/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ie=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","vs/base/common/errors","electron","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/base/common/cancellation","vs/base/common/arrays","vs/platform/environment/electron-main/environmentMainService","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/base/common/strings","os","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/base/common/map","vs/base/common/uuid","vs/base/common/extpath","vs/platform/state/node/state","vs/base/common/process","vs/platform/environment/common/environment","vs/base/common/objects","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/json","fs","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/base/common/errorMessage","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/base/common/hash","vs/base/common/ternarySearchTree","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/utilityProcess/electron-main/utilityProcess","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/theme/electron-main/themeMainService","vs/platform/window/common/window","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/codicons","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/functional","vs/base/common/normalization","crypto","net","vs/base/node/id","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindows","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/storage/common/storage","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/linkedList","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/dialogs/common/dialogs","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/base/node/unc","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/windows/electron-main/windowImpl","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindow","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindowsMainService","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","graceful-fs","@vscode/policy-watcher","string_decoder","vs/code/electron-main/main"],ne=function(J){for(var e=[],S=0,A=J.length;S<A;S++)e[S]=ie[J[S]];return e};define(ie[134],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function S(m,w,$){const d=A(m,w);if(d!==-1)return m[d]}e.$fb=S;function A(m,w,$=m.length-1){for(let d=$;d>=0;d--){const u=m[d];if(w(u))return d}return-1}e.$gb=A;function s(m,w){const $=R(m,w);return $===-1?void 0:m[$]}e.$hb=s;function R(m,w,$=0,d=m.length){let u=$,E=d;for(;u<E;){const l=Math.floor((u+E)/2);w(m[l])?u=l+1:E=l}return u-1}e.$ib=R;function C(m,w){const $=P(m,w);return $===m.length?void 0:m[$]}e.$jb=C;function P(m,w,$=0,d=m.length){let u=$,E=d;for(;u<E;){const l=Math.floor((u+E)/2);w(m[l])?E=l:u=l+1}return u}e.$kb=P;function h(m,w,$=0,d=m.length){const u=P(m,w,$,d);return u===m.length?-1:u}e.$lb=h;class c{static{this.assertInvariants=!1}constructor(w){this.e=w,this.c=0}findLastMonotonous(w){if(c.assertInvariants){if(this.d){for(const d of this.e)if(this.d(d)&&!w(d))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=w}const $=R(this.e,w,this.c);return this.c=$+1,$===-1?void 0:this.e[$]}}e.$mb=c;function g(m,w){if(m.length===0)return;let $=m[0];for(let d=1;d<m.length;d++){const u=m[d];w(u,$)>0&&($=u)}return $}e.$nb=g;function b(m,w){if(m.length===0)return;let $=m[0];for(let d=1;d<m.length;d++){const u=m[d];w(u,$)>=0&&($=u)}return $}e.$ob=b;function y(m,w){return g(m,($,d)=>-w($,d))}e.$pb=y;function f(m,w){if(m.length===0)return-1;let $=0;for(let d=1;d<m.length;d++){const u=m[d];w(u,m[$])>0&&($=d)}return $}e.$qb=f;function v(m,w){for(const $ of m){const d=w($);if(d!==void 0)return d}}e.$rb=v}),define(ie[135],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M=e.$L=e.$K=e.$J=void 0;function S(C,P){const h=Object.create(null);for(const c of C){const g=P(c);let b=h[g];b||(b=h[g]=[]),b.push(c)}return h}e.$J=S;function A(C,P){const h=[],c=[];for(const g of C)P.has(g)||h.push(g);for(const g of P)C.has(g)||c.push(g);return{removed:h,added:c}}e.$K=A;function s(C,P){const h=[],c=[];for(const[g,b]of C)P.has(g)||h.push(b);for(const[g,b]of P)C.has(g)||c.push(b);return{removed:h,added:c}}e.$L=s;function R(C,P){const h=new Set;for(const c of P)C.has(c)&&h.add(c);return h}e.$M=R}),define(ie[136],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2s=e.$1s=e.$Zs=e.$Ys=void 0;function S(P,h){const c=Math.pow(10,h);return Math.round(P*c)/c}class A{constructor(h,c,g,b=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,h))|0,this.g=Math.min(255,Math.max(0,c))|0,this.b=Math.min(255,Math.max(0,g))|0,this.a=S(Math.max(Math.min(1,b),0),3)}static equals(h,c){return h.r===c.r&&h.g===c.g&&h.b===c.b&&h.a===c.a}}e.$Ys=A;class s{constructor(h,c,g,b){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=S(Math.max(Math.min(1,c),0),3),this.l=S(Math.max(Math.min(1,g),0),3),this.a=S(Math.max(Math.min(1,b),0),3)}static equals(h,c){return h.h===c.h&&h.s===c.s&&h.l===c.l&&h.a===c.a}static fromRGBA(h){const c=h.r/255,g=h.g/255,b=h.b/255,y=h.a,f=Math.max(c,g,b),v=Math.min(c,g,b);let m=0,w=0;const $=(v+f)/2,d=f-v;if(d>0){switch(w=Math.min($<=.5?d/(2*$):d/(2-2*$),1),f){case c:m=(g-b)/d+(g<b?6:0);break;case g:m=(b-c)/d+2;break;case b:m=(c-g)/d+4;break}m*=60,m=Math.round(m)}return new s(m,w,$,y)}static i(h,c,g){return g<0&&(g+=1),g>1&&(g-=1),g<1/6?h+(c-h)*6*g:g<1/2?c:g<2/3?h+(c-h)*(2/3-g)*6:h}static toRGBA(h){const c=h.h/360,{s:g,l:b,a:y}=h;let f,v,m;if(g===0)f=v=m=b;else{const w=b<.5?b*(1+g):b+g-b*g,$=2*b-w;f=s.i($,w,c+1/3),v=s.i($,w,c),m=s.i($,w,c-1/3)}return new A(Math.round(f*255),Math.round(v*255),Math.round(m*255),y)}}e.$Zs=s;class R{constructor(h,c,g,b){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=S(Math.max(Math.min(1,c),0),3),this.v=S(Math.max(Math.min(1,g),0),3),this.a=S(Math.max(Math.min(1,b),0),3)}static equals(h,c){return h.h===c.h&&h.s===c.s&&h.v===c.v&&h.a===c.a}static fromRGBA(h){const c=h.r/255,g=h.g/255,b=h.b/255,y=Math.max(c,g,b),f=Math.min(c,g,b),v=y-f,m=y===0?0:v/y;let w;return v===0?w=0:y===c?w=((g-b)/v%6+6)%6:y===g?w=(b-c)/v+2:w=(c-g)/v+4,new R(Math.round(w*60),m,y,h.a)}static toRGBA(h){const{h:c,s:g,v:b,a:y}=h,f=b*g,v=f*(1-Math.abs(c/60%2-1)),m=b-f;let[w,$,d]=[0,0,0];return c<60?(w=f,$=v):c<120?(w=v,$=f):c<180?($=f,d=v):c<240?($=v,d=f):c<300?(w=v,d=f):c<=360&&(w=f,d=v),w=Math.round((w+m)*255),$=Math.round(($+m)*255),d=Math.round((d+m)*255),new A(w,$,d,y)}}e.$1s=R;class C{static fromHex(h){return C.Format.CSS.parseHex(h)||C.red}static equals(h,c){return!h&&!c?!0:!h||!c?!1:h.equals(c)}get hsla(){return this.i?this.i:s.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:R.fromRGBA(this.rgba)}constructor(h){if(h)if(h instanceof A)this.rgba=h;else if(h instanceof s)this.i=h,this.rgba=s.toRGBA(h);else if(h instanceof R)this.j=h,this.rgba=R.toRGBA(h);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(h){return!!h&&A.equals(this.rgba,h.rgba)&&s.equals(this.hsla,h.hsla)&&R.equals(this.hsva,h.hsva)}getRelativeLuminance(){const h=C.k(this.rgba.r),c=C.k(this.rgba.g),g=C.k(this.rgba.b),b=.2126*h+.7152*c+.0722*g;return S(b,4)}static k(h){const c=h/255;return c<=.03928?c/12.92:Math.pow((c+.055)/1.055,2.4)}getContrastRatio(h){const c=this.getRelativeLuminance(),g=h.getRelativeLuminance();return c>g?(c+.05)/(g+.05):(g+.05)/(c+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(h){const c=this.getRelativeLuminance(),g=h.getRelativeLuminance();return c>g}isDarkerThan(h){const c=this.getRelativeLuminance(),g=h.getRelativeLuminance();return c<g}lighten(h){return new C(new s(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*h,this.hsla.a))}darken(h){return new C(new s(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*h,this.hsla.a))}transparent(h){const{r:c,g,b,a:y}=this.rgba;return new C(new A(c,g,b,y*h))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new C(new A(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(h){const c=h.rgba,g=this.rgba.a,b=c.a,y=g+b*(1-g);if(y<1e-6)return C.transparent;const f=this.rgba.r*g/y+c.r*b*(1-g)/y,v=this.rgba.g*g/y+c.g*b*(1-g)/y,m=this.rgba.b*g/y+c.b*b*(1-g)/y;return new C(new A(f,v,m,y))}makeOpaque(h){if(this.isOpaque()||h.rgba.a!==1)return this;const{r:c,g,b,a:y}=this.rgba;return new C(new A(h.rgba.r-y*(h.rgba.r-c),h.rgba.g-y*(h.rgba.g-g),h.rgba.b-y*(h.rgba.b-b),1))}flatten(...h){const c=h.reduceRight((g,b)=>C.o(b,g));return C.o(this,c)}static o(h,c){const g=1-h.rgba.a;return new C(new A(g*c.rgba.r+h.rgba.a*h.rgba.r,g*c.rgba.g+h.rgba.a*h.rgba.g,g*c.rgba.b+h.rgba.a*h.rgba.b))}toString(){return this.u||(this.u=C.Format.CSS.format(this)),this.u}static getLighterColor(h,c,g){if(h.isLighterThan(c))return h;g=g||.5;const b=h.getRelativeLuminance(),y=c.getRelativeLuminance();return g=g*(y-b)/y,h.lighten(g)}static getDarkerColor(h,c,g){if(h.isDarkerThan(c))return h;g=g||.5;const b=h.getRelativeLuminance(),y=c.getRelativeLuminance();return g=g*(b-y)/b,h.darken(g)}static{this.white=new C(new A(255,255,255,1))}static{this.black=new C(new A(0,0,0,1))}static{this.red=new C(new A(255,0,0,1))}static{this.blue=new C(new A(0,0,255,1))}static{this.green=new C(new A(0,255,0,1))}static{this.cyan=new C(new A(0,255,255,1))}static{this.lightgrey=new C(new A(211,211,211,1))}static{this.transparent=new C(new A(0,0,0,0))}}e.$2s=C,function(P){let h;(function(c){let g;(function(b){function y(i){return i.rgba.a===1?`rgb(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b})`:P.Format.CSS.formatRGBA(i)}b.formatRGB=y;function f(i){return`rgba(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b}, ${+i.rgba.a.toFixed(2)})`}b.formatRGBA=f;function v(i){return i.hsla.a===1?`hsl(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%)`:P.Format.CSS.formatHSLA(i)}b.formatHSL=v;function m(i){return`hsla(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%, ${i.hsla.a.toFixed(2)})`}b.formatHSLA=m;function w(i){const a=i.toString(16);return a.length!==2?"0"+a:a}function $(i){return`#${w(i.rgba.r)}${w(i.rgba.g)}${w(i.rgba.b)}`}b.formatHex=$;function d(i,a=!1){return a&&i.rgba.a===1?P.Format.CSS.formatHex(i):`#${w(i.rgba.r)}${w(i.rgba.g)}${w(i.rgba.b)}${w(Math.round(i.rgba.a*255))}`}b.formatHexA=d;function u(i){return i.isOpaque()?P.Format.CSS.formatHex(i):P.Format.CSS.formatRGBA(i)}b.format=u;function E(i){const a=i.length;if(a===0||i.charCodeAt(0)!==35)return null;if(a===7){const r=16*l(i.charCodeAt(1))+l(i.charCodeAt(2)),t=16*l(i.charCodeAt(3))+l(i.charCodeAt(4)),n=16*l(i.charCodeAt(5))+l(i.charCodeAt(6));return new P(new A(r,t,n,1))}if(a===9){const r=16*l(i.charCodeAt(1))+l(i.charCodeAt(2)),t=16*l(i.charCodeAt(3))+l(i.charCodeAt(4)),n=16*l(i.charCodeAt(5))+l(i.charCodeAt(6)),o=16*l(i.charCodeAt(7))+l(i.charCodeAt(8));return new P(new A(r,t,n,o/255))}if(a===4){const r=l(i.charCodeAt(1)),t=l(i.charCodeAt(2)),n=l(i.charCodeAt(3));return new P(new A(16*r+r,16*t+t,16*n+n))}if(a===5){const r=l(i.charCodeAt(1)),t=l(i.charCodeAt(2)),n=l(i.charCodeAt(3)),o=l(i.charCodeAt(4));return new P(new A(16*r+r,16*t+t,16*n+n,(16*o+o)/255))}return null}b.parseHex=E;function l(i){switch(i){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(g=c.CSS||(c.CSS={}))})(h=P.Format||(P.Format={}))}(C||(e.$2s=C={}))}),define(ie[54],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kh=e.$jh=e.$ih=void 0;function S(C){return(P,h,c)=>{let g=null,b=null;if(typeof c.value=="function"?(g="value",b=c.value):typeof c.get=="function"&&(g="get",b=c.get),!b)throw new Error("not supported");c[g]=C(b,h)}}function A(C,P,h){let c=null,g=null;if(typeof h.value=="function"?(c="value",g=h.value,g.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(c="get",g=h.get),!g)throw new Error("not supported");const b=`$memoize$${P}`;h[c]=function(...y){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:g.apply(this,y)}),this[b]}}e.$ih=A;function s(C,P,h){return S((c,g)=>{const b=`$debounce$${g}`,y=`$debounce$result$${g}`;return function(...f){this[y]||(this[y]=h?h():void 0),clearTimeout(this[b]),P&&(this[y]=P(this[y],...f),f=[this[y]]),this[b]=setTimeout(()=>{c.apply(this,f),this[y]=h?h():void 0},C)}})}e.$jh=s;function R(C,P,h){return S((c,g)=>{const b=`$throttle$timer$${g}`,y=`$throttle$result$${g}`,f=`$throttle$lastRun$${g}`,v=`$throttle$pending$${g}`;return function(...m){if(this[y]||(this[y]=h?h():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),P&&(this[y]=P(this[y],...m)),this[v])return;const w=this[f]+C;w<=Date.now()?(this[f]=Date.now(),c.apply(this,[this[y]]),this[y]=h?h():void 0):(this[v]=!0,this[b]=setTimeout(()=>{this[v]=!1,this[f]=Date.now(),c.apply(this,[this[y]]),this[y]=h?h():void 0},w-Date.now()))}})}e.$kh=R}),define(ie[14],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class S{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?u.isErrorNoTelemetry(i)?new u(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(a=>{a(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.$W=S,e.$X=new S;function A(l){e.$X.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=A;function s(l){if(!l||typeof l!="object")return!1;const i=l;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}e.$Z=s;function R(l){c(l)||e.$X.onUnexpectedError(l)}e.$1=R;function C(l){c(l)||e.$X.onUnexpectedExternalError(l)}e.$2=C;function P(l){if(l instanceof Error){const{name:i,message:a}=l,r=l.stacktrace||l.stack;return{$isError:!0,name:i,message:a,stack:r,noTelemetry:u.isErrorNoTelemetry(l)}}return l}e.$3=P;const h="Canceled";function c(l){return l instanceof g?!0:l instanceof Error&&l.name===h&&l.message===h}e.$4=c;class g extends Error{constructor(){super(h),this.name=this.message}}e.$5=g;function b(){const l=new Error(h);return l.name=l.message,l}e.$6=b;function y(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.$7=y;function f(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.$8=f;class v extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=v;function m(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.$0=m;class w extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.$$=w;class $ extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.$_=$;class d extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=d;class u extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof u)return i;const a=new u;return a.message=i.message,a.stack=i.stack,a}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.$bb=u;class E extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,E.prototype)}}e.$cb=E}),define(ie[23],ne([0,1,14,134]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function s(F,B=0){return F[F.length-(1+B)]}e.$sb=s;function R(F){if(F.length===0)throw new Error("Invalid tail call");return[F.slice(0,F.length-1),F[F.length-1]]}e.$tb=R;function C(F,B,V=(oe,de)=>oe===de){if(F===B)return!0;if(!F||!B||F.length!==B.length)return!1;for(let oe=0,de=F.length;oe<de;oe++)if(!V(F[oe],B[oe]))return!1;return!0}e.$ub=C;function P(F,B){const V=F.length-1;B<V&&(F[B]=F[V]),F.pop()}e.$vb=P;function h(F,B,V){return c(F.length,oe=>V(F[oe],B))}e.$wb=h;function c(F,B){let V=0,oe=F-1;for(;V<=oe;){const de=(V+oe)/2|0,ue=B(de);if(ue<0)V=de+1;else if(ue>0)oe=de-1;else return de}return-(V+1)}e.$xb=c;function g(F,B,V){if(F=F|0,F>=B.length)throw new TypeError("invalid index");const oe=B[Math.floor(B.length*Math.random())],de=[],ue=[],he=[];for(const ve of B){const be=V(ve,oe);be<0?de.push(ve):be>0?ue.push(ve):he.push(ve)}return F<de.length?g(F,de,V):F<de.length+he.length?he[0]:g(F-(de.length+he.length),ue,V)}e.$yb=g;function b(F,B){const V=[];let oe;for(const de of F.slice(0).sort(B))!oe||B(oe[0],de)!==0?(oe=[de],V.push(oe)):oe.push(de);return V}e.$zb=b;function*y(F,B){let V,oe;for(const de of F)oe!==void 0&&B(oe,de)?V.push(de):(V&&(yield V),V=[de]),oe=de;V&&(yield V)}e.$Ab=y;function f(F,B){for(let V=0;V<=F.length;V++)B(V===0?void 0:F[V-1],V===F.length?void 0:F[V])}e.$Bb=f;function v(F,B){for(let V=0;V<F.length;V++)B(V===0?void 0:F[V-1],F[V],V+1===F.length?void 0:F[V+1])}e.$Cb=v;function m(F,B,V){const oe=[];function de(ve,be,ye){if(be===0&&ye.length===0)return;const Ie=oe[oe.length-1];Ie&&Ie.start+Ie.deleteCount===ve?(Ie.deleteCount+=be,Ie.toInsert.push(...ye)):oe.push({start:ve,deleteCount:be,toInsert:ye})}let ue=0,he=0;for(;;){if(ue===F.length){de(ue,0,B.slice(he));break}if(he===B.length){de(ue,F.length-ue,[]);break}const ve=F[ue],be=B[he],ye=V(ve,be);ye===0?(ue+=1,he+=1):ye<0?(de(ue,1,[]),ue+=1):ye>0&&(de(ue,0,[be]),he+=1)}return oe}e.$Db=m;function w(F,B,V){const oe=m(F,B,V),de=[],ue=[];for(const he of oe)de.push(...F.slice(he.start,he.start+he.deleteCount)),ue.push(...he.toInsert);return{removed:de,added:ue}}e.$Eb=w;function $(F,B,V){if(V===0)return[];const oe=F.slice(0,V).sort(B);return u(F,B,oe,V,F.length),oe}e.top=$;function d(F,B,V,oe,de){return V===0?Promise.resolve([]):new Promise((ue,he)=>{(async()=>{const ve=F.length,be=F.slice(0,V).sort(B);for(let ye=V,Ie=Math.min(V+oe,ve);ye<ve;ye=Ie,Ie=Math.min(Ie+oe,ve)){if(ye>V&&await new Promise(Te=>setTimeout(Te)),de&&de.isCancellationRequested)throw new S.$5;u(F,B,be,ye,Ie)}return be})().then(ue,he)})}e.$Gb=d;function u(F,B,V,oe,de){for(const ue=V.length;oe<de;oe++){const he=F[oe];if(B(he,V[ue-1])<0){V.pop();const ve=(0,A.$kb)(V,be=>B(he,be)<0);V.splice(ve,0,he)}}}function E(F){return F.filter(B=>!!B)}e.$Hb=E;function l(F){let B=0;for(let V=0;V<F.length;V++)F[V]&&(F[B]=F[V],B+=1);F.length=B}e.$Ib=l;function i(F,B,V){F.splice(V,0,F.splice(B,1)[0])}e.$Jb=i;function a(F){return!Array.isArray(F)||F.length===0}e.$Kb=a;function r(F){return Array.isArray(F)&&F.length>0}e.$Lb=r;function t(F,B=V=>V){const V=new Set;return F.filter(oe=>{const de=B(oe);return V.has(de)?!1:(V.add(de),!0)})}e.$Mb=t;function n(F){const B=new Set;return V=>{const oe=F(V);return B.has(oe)?!1:(B.add(oe),!0)}}e.$Nb=n;function o(F,B){return F.length>0?F[0]:B}e.$Ob=o;function p(F,B){return F.length>0?F[F.length-1]:B}e.$Pb=p;function O(F,B,V=(oe,de)=>oe===de){let oe=0;for(let de=0,ue=Math.min(F.length,B.length);de<ue&&V(F[de],B[de]);de++)oe++;return oe}e.$Qb=O;function D(F){return[].concat(...F)}e.$Rb=D;function k(F,B){let V=typeof B=="number"?F:0;typeof B=="number"?V=F:(V=0,B=F);const oe=[];if(V<=B)for(let de=V;de<B;de++)oe.push(de);else for(let de=V;de>B;de--)oe.push(de);return oe}e.$Sb=k;function I(F,B,V){return F.reduce((oe,de)=>(oe[B(de)]=V?V(de):de,oe),Object.create(null))}e.$Tb=I;function j(F,B){return F.push(B),()=>U(F,B)}e.$Ub=j;function U(F,B){const V=F.indexOf(B);if(V>-1)return F.splice(V,1),B}e.$Vb=U;function z(F,B,V){const oe=F.slice(0,B),de=F.slice(B);return oe.concat(V,de)}e.$Wb=z;function x(F,B){let V;if(typeof B=="number"){let oe=B;V=()=>{const de=Math.sin(oe++)*179426549;return de-Math.floor(de)}}else V=Math.random;for(let oe=F.length-1;oe>0;oe-=1){const de=Math.floor(V()*(oe+1)),ue=F[oe];F[oe]=F[de],F[de]=ue}}e.$Xb=x;function Z(F,B){const V=F.indexOf(B);V>-1&&(F.splice(V,1),F.unshift(B))}e.$Yb=Z;function ae(F,B){const V=F.indexOf(B);V>-1&&(F.splice(V,1),F.push(B))}e.$Zb=ae;function se(F,B){for(const V of B)F.push(V)}e.$1b=se;function ce(F,B){return Array.isArray(F)?F.map(B):B(F)}e.$2b=ce;function Y(F){return Array.isArray(F)?F:[F]}e.$3b=Y;function K(F){return F[Math.floor(Math.random()*F.length)]}e.$4b=K;function Q(F,B,V){const oe=W(F,B),de=F.length,ue=V.length;F.length=de+ue;for(let he=de-1;he>=oe;he--)F[he+ue]=F[he];for(let he=0;he<ue;he++)F[he+oe]=V[he]}e.$5b=Q;function q(F,B,V,oe){const de=W(F,B);let ue=F.splice(de,V);return ue===void 0&&(ue=[]),Q(F,de,oe),ue}e.$6b=q;function W(F,B){return B<0?Math.max(B+F.length,0):Math.min(B,F.length)}var G;(function(F){function B(ue){return ue<0}F.isLessThan=B;function V(ue){return ue<=0}F.isLessThanOrEqual=V;function oe(ue){return ue>0}F.isGreaterThan=oe;function de(ue){return ue===0}F.isNeitherLessOrGreaterThan=de,F.greaterThan=1,F.lessThan=-1,F.neitherLessOrGreaterThan=0})(G||(e.CompareResult=G={}));function H(F,B){return(V,oe)=>B(F(V),F(oe))}e.$7b=H;function X(...F){return(B,V)=>{for(const oe of F){const de=oe(B,V);if(!G.isNeitherLessOrGreaterThan(de))return de}return G.neitherLessOrGreaterThan}}e.$8b=X;const re=(F,B)=>F-B;e.$9b=re;const L=(F,B)=>(0,e.$9b)(F?1:0,B?1:0);e.$0b=L;function M(F){return(B,V)=>-F(B,V)}e.$$b=M;class N{constructor(B){this.g=B,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(B){let V=this.c;for(;V<this.g.length&&B(this.g[V]);)V++;const oe=V===this.c?null:this.g.slice(this.c,V);return this.c=V,oe}takeFromEndWhile(B){let V=this.d;for(;V>=0&&B(this.g[V]);)V--;const oe=V===this.d?null:this.g.slice(V+1,this.d+1);return this.d=V,oe}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const B=this.g[this.c];return this.c++,B}removeLast(){const B=this.g[this.d];return this.d--,B}takeCount(B){const V=this.g.slice(this.c,this.c+B);return this.c+=B,V}}e.$_b=N;class T{static{this.empty=new T(B=>{})}constructor(B){this.iterate=B}forEach(B){this.iterate(V=>(B(V),!0))}toArray(){const B=[];return this.iterate(V=>(B.push(V),!0)),B}filter(B){return new T(V=>this.iterate(oe=>B(oe)?V(oe):!0))}map(B){return new T(V=>this.iterate(oe=>V(B(oe))))}some(B){let V=!1;return this.iterate(oe=>(V=B(oe),!V)),V}findFirst(B){let V;return this.iterate(oe=>B(oe)?(V=oe,!1):!0),V}findLast(B){let V;return this.iterate(oe=>(B(oe)&&(V=oe),!0)),V}findLastMaxBy(B){let V,oe=!0;return this.iterate(de=>((oe||G.isGreaterThan(B(de,V)))&&(oe=!1,V=de),!0)),V}}e.$ac=T}),define(ie[137],ne([0,1,14]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=e.$6c=e.$5c=e.$4c=e.ok=void 0;function A(h,c){if(!h)throw new Error(c?`Assertion failed (${c})`:"Assertion Failed")}e.ok=A;function s(h,c="Unreachable"){throw new Error(c)}e.$4c=s;function R(h){if(!h)throw new S.$cb("Assertion Failed")}e.$5c=R;function C(h){if(!h()){debugger;h(),(0,S.$1)(new S.$cb("Assertion Failed"))}}e.$6c=C;function P(h,c){let g=0;for(;g<h.length-1;){const b=h[g],y=h[g+1];if(!c(b,y))return!1;g++}return!0}e.$7c=P}),define(ie[83],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function S(A){const s=this;let R=!1,C;return function(){return R||(R=!0,C=A.apply(s,arguments)),C}}e.$db=S}),define(ie[70],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var S;(function(A){function s(l){return l&&typeof l=="object"&&typeof l[Symbol.iterator]=="function"}A.is=s;const R=Object.freeze([]);function C(){return R}A.empty=C;function*P(l){yield l}A.single=P;function h(l){return s(l)?l:P(l)}A.wrap=h;function c(l){return l||R}A.from=c;function*g(l){for(let i=l.length-1;i>=0;i--)yield l[i]}A.reverse=g;function b(l){return!l||l[Symbol.iterator]().next().done===!0}A.isEmpty=b;function y(l){return l[Symbol.iterator]().next().value}A.first=y;function f(l,i){for(const a of l)if(i(a))return!0;return!1}A.some=f;function v(l,i){for(const a of l)if(i(a))return a}A.find=v;function*m(l,i){for(const a of l)i(a)&&(yield a)}A.filter=m;function*w(l,i){let a=0;for(const r of l)yield i(r,a++)}A.map=w;function*$(...l){for(const i of l)for(const a of i)yield a}A.concat=$;function d(l,i,a){let r=a;for(const t of l)r=i(r,t);return r}A.reduce=d;function*u(l,i,a=l.length){for(i<0&&(i+=l.length),a<0?a+=l.length:a>l.length&&(a=l.length);i<a;i++)yield l[i]}A.slice=u;function E(l,i=Number.POSITIVE_INFINITY){const a=[];if(i===0)return[a,l];const r=l[Symbol.iterator]();for(let t=0;t<i;t++){const n=r.next();if(n.done)return[a,A.empty()];a.push(n.value)}return[a,{[Symbol.iterator](){return r}}]}A.consume=E})(S||(e.Iterable=S={}))}),define(ie[44],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var S;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(S||(e.ScanError=S={}));var A;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(A||(e.SyntaxKind=A={}));var s;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(s||(e.ParseErrorCode=s={}));var R;(function(i){i.DEFAULT={allowTrailingComma:!0}})(R||(e.ParseOptions=R={}));function C(i,a=!1){let r=0;const t=i.length;let n="",o=0,p=16,O=0;function D(Z){let ae=0,se=0;for(;ae<Z;){const ce=i.charCodeAt(r);if(ce>=48&&ce<=57)se=se*16+ce-48;else if(ce>=65&&ce<=70)se=se*16+ce-65+10;else if(ce>=97&&ce<=102)se=se*16+ce-97+10;else break;r++,ae++}return ae<Z&&(se=-1),se}function k(Z){r=Z,n="",o=0,p=16,O=0}function I(){const Z=r;if(i.charCodeAt(r)===48)r++;else for(r++;r<i.length&&c(i.charCodeAt(r));)r++;if(r<i.length&&i.charCodeAt(r)===46)if(r++,r<i.length&&c(i.charCodeAt(r)))for(r++;r<i.length&&c(i.charCodeAt(r));)r++;else return O=3,i.substring(Z,r);let ae=r;if(r<i.length&&(i.charCodeAt(r)===69||i.charCodeAt(r)===101))if(r++,(r<i.length&&i.charCodeAt(r)===43||i.charCodeAt(r)===45)&&r++,r<i.length&&c(i.charCodeAt(r))){for(r++;r<i.length&&c(i.charCodeAt(r));)r++;ae=r}else O=3;return i.substring(Z,ae)}function j(){let Z="",ae=r;for(;;){if(r>=t){Z+=i.substring(ae,r),O=2;break}const se=i.charCodeAt(r);if(se===34){Z+=i.substring(ae,r),r++;break}if(se===92){if(Z+=i.substring(ae,r),r++,r>=t){O=2;break}switch(i.charCodeAt(r++)){case 34:Z+='"';break;case 92:Z+="\\";break;case 47:Z+="/";break;case 98:Z+="\b";break;case 102:Z+="\f";break;case 110:Z+=`
`;break;case 114:Z+="\r";break;case 116:Z+="	";break;case 117:{const Y=D(4);Y>=0?Z+=String.fromCharCode(Y):O=4;break}default:O=5}ae=r;continue}if(se>=0&&se<=31)if(h(se)){Z+=i.substring(ae,r),O=2;break}else O=6;r++}return Z}function U(){if(n="",O=0,o=r,r>=t)return o=t,p=17;let Z=i.charCodeAt(r);if(P(Z)){do r++,n+=String.fromCharCode(Z),Z=i.charCodeAt(r);while(P(Z));return p=15}if(h(Z))return r++,n+=String.fromCharCode(Z),Z===13&&i.charCodeAt(r)===10&&(r++,n+=`
`),p=14;switch(Z){case 123:return r++,p=1;case 125:return r++,p=2;case 91:return r++,p=3;case 93:return r++,p=4;case 58:return r++,p=6;case 44:return r++,p=5;case 34:return r++,n=j(),p=10;case 47:{const ae=r-1;if(i.charCodeAt(r+1)===47){for(r+=2;r<t&&!h(i.charCodeAt(r));)r++;return n=i.substring(ae,r),p=12}if(i.charCodeAt(r+1)===42){r+=2;const se=t-1;let ce=!1;for(;r<se;){if(i.charCodeAt(r)===42&&i.charCodeAt(r+1)===47){r+=2,ce=!0;break}r++}return ce||(r++,O=1),n=i.substring(ae,r),p=13}return n+=String.fromCharCode(Z),r++,p=16}case 45:if(n+=String.fromCharCode(Z),r++,r===t||!c(i.charCodeAt(r)))return p=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=I(),p=11;default:for(;r<t&&z(Z);)r++,Z=i.charCodeAt(r);if(o!==r){switch(n=i.substring(o,r),n){case"true":return p=8;case"false":return p=9;case"null":return p=7}return p=16}return n+=String.fromCharCode(Z),r++,p=16}}function z(Z){if(P(Z)||h(Z))return!1;switch(Z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function x(){let Z;do Z=U();while(Z>=12&&Z<=15);return Z}return{setPosition:k,getPosition:()=>r,scan:a?x:U,getToken:()=>p,getTokenValue:()=>n,getTokenOffset:()=>o,getTokenLength:()=>r-o,getTokenError:()=>O}}e.$Vm=C;function P(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function h(i){return i===10||i===13||i===8232||i===8233}function c(i){return i>=48&&i<=57}var g;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(g||(g={}));function b(i,a){const r=[],t=new Object;let n;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let p=!1;function O(D,k,I,j){o.value=D,o.offset=k,o.length=I,o.type=j,o.colonOffset=void 0,n=o}try{u(i,{onObjectBegin:(D,k)=>{if(a<=D)throw t;n=void 0,p=a>D,r.push("")},onObjectProperty:(D,k,I)=>{if(a<k||(O(D,k,I,"property"),r[r.length-1]=D,a<=k+I))throw t},onObjectEnd:(D,k)=>{if(a<=D)throw t;n=void 0,r.pop()},onArrayBegin:(D,k)=>{if(a<=D)throw t;n=void 0,r.push(0)},onArrayEnd:(D,k)=>{if(a<=D)throw t;n=void 0,r.pop()},onLiteralValue:(D,k,I)=>{if(a<k||(O(D,k,I,l(D)),a<=k+I))throw t},onSeparator:(D,k,I)=>{if(a<=k)throw t;if(D===":"&&n&&n.type==="property")n.colonOffset=k,p=!1,n=void 0;else if(D===","){const j=r[r.length-1];typeof j=="number"?r[r.length-1]=j+1:(p=!0,r[r.length-1]=""),n=void 0}}})}catch(D){if(D!==t)throw D}return{path:r,previousNode:n,isAtPropertyKey:p,matches:D=>{let k=0;for(let I=0;k<D.length&&I<r.length;I++)if(D[k]===r[I]||D[k]==="*")k++;else if(D[k]!=="**")return!1;return k===D.length}}}e.$Wm=b;function y(i,a=[],r=R.DEFAULT){let t=null,n=[];const o=[];function p(D){Array.isArray(n)?n.push(D):t!==null&&(n[t]=D)}return u(i,{onObjectBegin:()=>{const D={};p(D),o.push(n),n=D,t=null},onObjectProperty:D=>{t=D},onObjectEnd:()=>{n=o.pop()},onArrayBegin:()=>{const D=[];p(D),o.push(n),n=D,t=null},onArrayEnd:()=>{n=o.pop()},onLiteralValue:p,onError:(D,k,I)=>{a.push({error:D,offset:k,length:I})}},r),n[0]}e.$Xm=y;function f(i,a=[],r=R.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(D){t.type==="property"&&(t.length=D-t.offset,t=t.parent)}function o(D){return t.children.push(D),D}u(i,{onObjectBegin:D=>{t=o({type:"object",offset:D,length:-1,parent:t,children:[]})},onObjectProperty:(D,k,I)=>{t=o({type:"property",offset:k,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:D,offset:k,length:I,parent:t})},onObjectEnd:(D,k)=>{t.length=D+k-t.offset,t=t.parent,n(D+k)},onArrayBegin:(D,k)=>{t=o({type:"array",offset:D,length:-1,parent:t,children:[]})},onArrayEnd:(D,k)=>{t.length=D+k-t.offset,t=t.parent,n(D+k)},onLiteralValue:(D,k,I)=>{o({type:l(D),offset:k,length:I,parent:t,value:D}),n(k+I)},onSeparator:(D,k,I)=>{t.type==="property"&&(D===":"?t.colonOffset=k:D===","&&n(k))},onError:(D,k,I)=>{a.push({error:D,offset:k,length:I})}},r);const O=t.children[0];return O&&delete O.parent,O}e.$Ym=f;function v(i,a){if(!i)return;let r=i;for(const t of a)if(typeof t=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let n=!1;for(const o of r.children)if(Array.isArray(o.children)&&o.children[0].value===t){r=o.children[1],n=!0;break}if(!n)return}else{const n=t;if(r.type!=="array"||n<0||!Array.isArray(r.children)||n>=r.children.length)return;r=r.children[n]}return r}e.$Zm=v;function m(i){if(!i.parent||!i.parent.children)return[];const a=m(i.parent);if(i.parent.type==="property"){const r=i.parent.children[0].value;a.push(r)}else if(i.parent.type==="array"){const r=i.parent.children.indexOf(i);r!==-1&&a.push(r)}return a}e.$1m=m;function w(i){switch(i.type){case"array":return i.children.map(w);case"object":{const a=Object.create(null);for(const r of i.children){const t=r.children[1];t&&(a[r.children[0].value]=w(t))}return a}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.$2m=w;function $(i,a,r=!1){return a>=i.offset&&a<i.offset+i.length||r&&a===i.offset+i.length}e.$3m=$;function d(i,a,r=!1){if($(i,a,r)){const t=i.children;if(Array.isArray(t))for(let n=0;n<t.length&&t[n].offset<=a;n++){const o=d(t[n],a,r);if(o)return o}return i}}e.$4m=d;function u(i,a,r=R.DEFAULT){const t=C(i,!1);function n(H){return H?()=>H(t.getTokenOffset(),t.getTokenLength()):()=>!0}function o(H){return H?X=>H(X,t.getTokenOffset(),t.getTokenLength()):()=>!0}const p=n(a.onObjectBegin),O=o(a.onObjectProperty),D=n(a.onObjectEnd),k=n(a.onArrayBegin),I=n(a.onArrayEnd),j=o(a.onLiteralValue),U=o(a.onSeparator),z=n(a.onComment),x=o(a.onError),Z=r&&r.disallowComments,ae=r&&r.allowTrailingComma;function se(){for(;;){const H=t.scan();switch(t.getTokenError()){case 4:ce(14);break;case 5:ce(15);break;case 3:ce(13);break;case 1:Z||ce(11);break;case 2:ce(12);break;case 6:ce(16);break}switch(H){case 12:case 13:Z?ce(10):z();break;case 16:ce(1);break;case 15:case 14:break;default:return H}}}function ce(H,X=[],re=[]){if(x(H),X.length+re.length>0){let L=t.getToken();for(;L!==17;){if(X.indexOf(L)!==-1){se();break}else if(re.indexOf(L)!==-1)break;L=se()}}}function Y(H){const X=t.getTokenValue();return H?j(X):O(X),se(),!0}function K(){switch(t.getToken()){case 11:{let H=0;try{H=JSON.parse(t.getTokenValue()),typeof H!="number"&&(ce(2),H=0)}catch{ce(2)}j(H);break}case 7:j(null);break;case 8:j(!0);break;case 9:j(!1);break;default:return!1}return se(),!0}function Q(){return t.getToken()!==10?(ce(3,[],[2,5]),!1):(Y(!1),t.getToken()===6?(U(":"),se(),G()||ce(4,[],[2,5])):ce(5,[],[2,5]),!0)}function q(){p(),se();let H=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(H||ce(4,[],[]),U(","),se(),t.getToken()===2&&ae)break}else H&&ce(6,[],[]);Q()||ce(4,[],[2,5]),H=!0}return D(),t.getToken()!==2?ce(7,[2],[]):se(),!0}function W(){k(),se();let H=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(H||ce(4,[],[]),U(","),se(),t.getToken()===4&&ae)break}else H&&ce(6,[],[]);G()||ce(4,[],[4,5]),H=!0}return I(),t.getToken()!==4?ce(8,[4],[]):se(),!0}function G(){switch(t.getToken()){case 3:return W();case 1:return q();case 10:return Y(!0);default:return K()}}return se(),t.getToken()===17?r.allowEmptyContent?!0:(ce(4,[],[]),!1):G()?(t.getToken()!==17&&ce(9,[],[]),!0):(ce(4,[],[]),!1)}e.$5m=u;function E(i,a){const r=C(i),t=[];let n,o=0,p;do switch(p=r.getPosition(),n=r.scan(),n){case 12:case 13:case 17:o!==p&&t.push(i.substring(o,p)),a!==void 0&&t.push(r.getTokenValue().replace(/[^\r\n]/g,a)),o=r.getPosition();break}while(n!==17);return t.join("")}e.$6m=E;function l(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.$7m=l}),define(ie[138],ne([0,1,44]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aT=e.$_S=e.$$S=e.$0S=void 0;function A(c,g,b){let y,f,v,m,w;if(g){for(m=g.offset,w=m+g.length,v=m;v>0&&!h(c,v-1);)v--;let p=w;for(;p<c.length&&!h(c,p);)p++;f=c.substring(v,p),y=C(f,b)}else f=c,y=0,v=0,m=0,w=c.length;const $=P(b,c);let d=!1,u=0,E;b.insertSpaces?E=R(" ",b.tabSize||4):E="	";const l=(0,S.$Vm)(f,!1);let i=!1;function a(){return $+R(E,y+u)}function r(){let p=l.scan();for(d=!1;p===15||p===14;)d=d||p===14,p=l.scan();return i=p===16||l.getTokenError()!==0,p}const t=[];function n(p,O,D){!i&&O<w&&D>m&&c.substring(O,D)!==p&&t.push({offset:O,length:D-O,content:p})}let o=r();if(o!==17){const p=l.getTokenOffset()+v,O=R(E,y);n(O,v,p)}for(;o!==17;){let p=l.getTokenOffset()+l.getTokenLength()+v,O=r(),D="";for(;!d&&(O===12||O===13);){const I=l.getTokenOffset()+v;n(" ",p,I),p=l.getTokenOffset()+l.getTokenLength()+v,D=O===12?a():"",O=r()}if(O===2)o!==1&&(u--,D=a());else if(O===4)o!==3&&(u--,D=a());else{switch(o){case 3:case 1:u++,D=a();break;case 5:case 12:D=a();break;case 13:d?D=a():D=" ";break;case 6:D=" ";break;case 10:if(O===6){D="";break}case 7:case 8:case 9:case 11:case 2:case 4:O===12||O===13?D=" ":O!==5&&O!==17&&(i=!0);break;case 16:i=!0;break}d&&(O===12||O===13)&&(D=a())}const k=l.getTokenOffset()+v;n(D,p,k),o=O}return t}e.$0S=A;function s(c,g){const b=JSON.stringify(c,void 0,g.insertSpaces?g.tabSize||4:"	");return g.eol!==void 0?b.replace(/\r\n|\r|\n/g,g.eol):b}e.$$S=s;function R(c,g){let b="";for(let y=0;y<g;y++)b+=c;return b}function C(c,g){let b=0,y=0;const f=g.tabSize||4;for(;b<c.length;){const v=c.charAt(b);if(v===" ")y++;else if(v==="	")y+=f;else break;b++}return Math.floor(y/f)}function P(c,g){for(let b=0;b<g.length;b++){const y=g.charAt(b);if(y==="\r")return b+1<g.length&&g.charAt(b+1)===`
`?`\r
`:"\r";if(y===`
`)return`
`}return c&&c.eol||`
`}e.$_S=P;function h(c,g){return`\r
`.indexOf(c.charAt(g))!==-1}e.$aT=h}),define(ie[139],ne([0,1,44,138]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fT=e.$eT=e.$dT=e.$cT=e.$bT=void 0;function s(c,g,b){return R(c,g,void 0,b)}e.$bT=s;function R(c,g,b,y,f){const v=g.slice(),m=[],w=(0,S.$Ym)(c,m);let $,d;for(;v.length>0&&(d=v.pop(),$=(0,S.$Zm)(w,v),$===void 0&&b!==void 0);)typeof d=="string"?b={[d]:b}:b=[b];if($)if($.type==="object"&&typeof d=="string"&&Array.isArray($.children)){const u=(0,S.$Zm)($,[d]);if(u!==void 0)if(b===void 0){if(!u.parent)throw new Error("Malformed AST");const E=$.children.indexOf(u.parent);let l,i=u.parent.offset+u.parent.length;if(E>0){const a=$.children[E-1];l=a.offset+a.length}else l=$.offset+1,$.children.length>1&&(i=$.children[1].offset);return C(c,{offset:l,length:i-l,content:""},y)}else return C(c,{offset:u.offset,length:u.length,content:JSON.stringify(b)},y);else{if(b===void 0)return[];const E=`${JSON.stringify(d)}: ${JSON.stringify(b)}`,l=f?f($.children.map(a=>a.children[0].value)):$.children.length;let i;if(l>0){const a=$.children[l-1];i={offset:a.offset+a.length,length:0,content:","+E}}else $.children.length===0?i={offset:$.offset+1,length:0,content:E}:i={offset:$.offset+1,length:0,content:E+","};return C(c,i,y)}}else if($.type==="array"&&typeof d=="number"&&Array.isArray($.children))if(b!==void 0){const u=`${JSON.stringify(b)}`;let E;if($.children.length===0||d===0)E={offset:$.offset+1,length:0,content:$.children.length===0?u:u+","};else{const l=d===-1||d>$.children.length?$.children.length:d,i=$.children[l-1];E={offset:i.offset+i.length,length:0,content:","+u}}return C(c,E,y)}else{const u=d,E=$.children[u];let l;if($.children.length===1)l={offset:$.offset+1,length:$.length-2,content:""};else if($.children.length-1===u){const i=$.children[u-1],a=i.offset+i.length,r=$.offset+$.length;l={offset:a,length:r-2-a,content:""}}else l={offset:E.offset,length:$.children[u+1].offset-E.offset,content:""};return C(c,l,y)}else throw new Error(`Can not add ${typeof d!="number"?"index":"property"} to parent of type ${$.type}`);else{if(b===void 0)throw new Error("Can not delete in empty document");return C(c,{offset:w?w.offset:0,length:w?w.length:0,content:JSON.stringify(b)},y)}}e.$cT=R;function C(c,g,b){let y=P(c,g),f=g.offset,v=g.offset+g.content.length;if(g.length===0||g.content.length===0){for(;f>0&&!(0,A.$aT)(y,f-1);)f--;for(;v<y.length&&!(0,A.$aT)(y,v);)v++}const m=(0,A.$0S)(y,{offset:f,length:v-f},b);for(let $=m.length-1;$>=0;$--){const d=m[$];y=P(y,d),f=Math.min(f,d.offset),v=Math.max(v,d.offset+d.length),v+=d.content.length-d.length}const w=c.length-(y.length-v)-f;return[{offset:f,length:w,content:y.substring(f,v)}]}e.$dT=C;function P(c,g){return c.substring(0,g.offset)+g.content+c.substring(g.offset+g.length)}e.$eT=P;function h(c,g){const b=g.slice(0).sort((f,v)=>{const m=f.offset-v.offset;return m===0?f.length-v.length:m});let y=c.length;for(let f=b.length-1;f>=0;f--){const v=b[f];if(v.offset+v.length<=y)c=P(c,v);else throw new Error("Overlapping edit");y=v.offset}return c}e.$fT=h}),define(ie[71],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class S{constructor(s){this.d=s,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(s){this.c=s}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=S}),define(ie[101],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2c=void 0;class S{static{this.Undefined=new S(void 0)}constructor(R){this.element=R,this.next=S.Undefined,this.prev=S.Undefined}}class A{constructor(){this.a=S.Undefined,this.b=S.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===S.Undefined}clear(){let R=this.a;for(;R!==S.Undefined;){const C=R.next;R.prev=S.Undefined,R.next=S.Undefined,R=C}this.a=S.Undefined,this.b=S.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,C){const P=new S(R);if(this.a===S.Undefined)this.a=P,this.b=P;else if(C){const c=this.b;this.b=P,P.prev=c,c.next=P}else{const c=this.a;this.a=P,P.next=c,c.prev=P}this.c+=1;let h=!1;return()=>{h||(h=!0,this.e(P))}}shift(){if(this.a!==S.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==S.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==S.Undefined&&R.next!==S.Undefined){const C=R.prev;C.next=R.next,R.next.prev=C}else R.prev===S.Undefined&&R.next===S.Undefined?(this.a=S.Undefined,this.b=S.Undefined):R.next===S.Undefined?(this.b=this.b.prev,this.b.next=S.Undefined):R.prev===S.Undefined&&(this.a=this.a.next,this.a.prev=S.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==S.Undefined;)yield R.element,R=R.next}}e.$2c=A}),define(ie[31],ne([0,1]),function(J,e){"use strict";var S,A,s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function R(d,u,E){let l=d.get(u);return l===void 0&&(l=E,d.set(u,l)),l}e.$xc=R;function C(d){const u=[];return d.forEach((E,l)=>{u.push(`${l} => ${E}`)}),`Map(${d.size}) {${u.join(", ")}}`}e.$yc=C;function P(d){const u=[];return d.forEach(E=>{u.push(E)}),`Set(${d.size}) {${u.join(", ")}}`}e.$zc=P;class h{constructor(u,E){this.uri=u,this.value=E}}function c(d){return Array.isArray(d)}class g{static{this.a=u=>u.toString()}constructor(u,E){if(this[S]="ResourceMap",u instanceof g)this.b=new Map(u.b),this.c=E??g.a;else if(c(u)){this.b=new Map,this.c=E??g.a;for(const[l,i]of u)this.set(l,i)}else this.b=new Map,this.c=u??g.a}set(u,E){return this.b.set(this.c(u),new h(u,E)),this}get(u){return this.b.get(this.c(u))?.value}has(u){return this.b.has(this.c(u))}get size(){return this.b.size}clear(){this.b.clear()}delete(u){return this.b.delete(this.c(u))}forEach(u,E){typeof E<"u"&&(u=u.bind(E));for(const[l,i]of this.b)u(i.value,i.uri,this)}*values(){for(const u of this.b.values())yield u.value}*keys(){for(const u of this.b.values())yield u.uri}*entries(){for(const u of this.b.values())yield[u.uri,u.value]}*[(S=Symbol.toStringTag,Symbol.iterator)](){for(const[,u]of this.b)yield[u.uri,u.value]}}e.$Ac=g;class b{constructor(u,E){this[A]="ResourceSet",!u||typeof u=="function"?this.a=new g(u):(this.a=new g(E),u.forEach(this.add,this))}get size(){return this.a.size}add(u){return this.a.set(u,u),this}clear(){this.a.clear()}delete(u){return this.a.delete(u)}forEach(u,E){this.a.forEach((l,i)=>u.call(E,i,i,this))}has(u){return this.a.has(u)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=b;var y;(function(d){d[d.None=0]="None",d[d.AsOld=1]="AsOld",d[d.AsNew=2]="AsNew"})(y||(e.Touch=y={}));class f{constructor(){this[s]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(u){return this.a.has(u)}get(u,E=0){const l=this.a.get(u);if(l)return E!==0&&this.j(l,E),l.value}set(u,E,l=0){let i=this.a.get(u);if(i)i.value=E,l!==0&&this.j(i,l);else{switch(i={key:u,value:E,next:void 0,previous:void 0},l){case 0:this.h(i);break;case 1:this.g(i);break;case 2:this.h(i);break;default:this.h(i);break}this.a.set(u,i),this.d++}return this}delete(u){return!!this.remove(u)}remove(u){const E=this.a.get(u);if(E)return this.a.delete(u),this.i(E),this.d--,E.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const u=this.b;return this.a.delete(u.key),this.i(u),this.d--,u.value}forEach(u,E){const l=this.e;let i=this.b;for(;i;){if(E?u.bind(E)(i.value,i.key,this):u(i.value,i.key,this),this.e!==l)throw new Error("LinkedMap got modified during iteration.");i=i.next}}keys(){const u=this,E=this.e;let l=this.b;const i={[Symbol.iterator](){return i},next(){if(u.e!==E)throw new Error("LinkedMap got modified during iteration.");if(l){const a={value:l.key,done:!1};return l=l.next,a}else return{value:void 0,done:!0}}};return i}values(){const u=this,E=this.e;let l=this.b;const i={[Symbol.iterator](){return i},next(){if(u.e!==E)throw new Error("LinkedMap got modified during iteration.");if(l){const a={value:l.value,done:!1};return l=l.next,a}else return{value:void 0,done:!0}}};return i}entries(){const u=this,E=this.e;let l=this.b;const i={[Symbol.iterator](){return i},next(){if(u.e!==E)throw new Error("LinkedMap got modified during iteration.");if(l){const a={value:[l.key,l.value],done:!1};return l=l.next,a}else return{value:void 0,done:!0}}};return i}[(s=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(u){if(u>=this.size)return;if(u===0){this.clear();return}let E=this.b,l=this.size;for(;E&&l>u;)this.a.delete(E.key),E=E.next,l--;this.b=E,this.d=l,E&&(E.previous=void 0),this.e++}g(u){if(!this.b&&!this.c)this.c=u;else if(this.b)u.next=this.b,this.b.previous=u;else throw new Error("Invalid list");this.b=u,this.e++}h(u){if(!this.b&&!this.c)this.b=u;else if(this.c)u.previous=this.c,this.c.next=u;else throw new Error("Invalid list");this.c=u,this.e++}i(u){if(u===this.b&&u===this.c)this.b=void 0,this.c=void 0;else if(u===this.b){if(!u.next)throw new Error("Invalid list");u.next.previous=void 0,this.b=u.next}else if(u===this.c){if(!u.previous)throw new Error("Invalid list");u.previous.next=void 0,this.c=u.previous}else{const E=u.next,l=u.previous;if(!E||!l)throw new Error("Invalid list");E.previous=l,l.next=E}u.next=void 0,u.previous=void 0,this.e++}j(u,E){if(!this.b||!this.c)throw new Error("Invalid list");if(!(E!==1&&E!==2)){if(E===1){if(u===this.b)return;const l=u.next,i=u.previous;u===this.c?(i.next=void 0,this.c=i):(l.previous=i,i.next=l),u.previous=void 0,u.next=this.b,this.b.previous=u,this.b=u,this.e++}else if(E===2){if(u===this.c)return;const l=u.next,i=u.previous;u===this.b?(l.previous=void 0,this.b=l):(l.previous=i,i.next=l),u.next=void 0,u.previous=this.c,this.c.next=u,this.c=u,this.e++}}}toJSON(){const u=[];return this.forEach((E,l)=>{u.push([l,E])}),u}fromJSON(u){this.clear();for(const[E,l]of u)this.set(E,l)}}e.$Cc=f;class v extends f{constructor(u,E=1){super(),this.k=u,this.l=Math.min(Math.max(0,E),1)}get limit(){return this.k}set limit(u){this.k=u,this.m()}get ratio(){return this.l}set ratio(u){this.l=Math.min(Math.max(0,u),1),this.m()}get(u,E=2){return super.get(u,E)}peek(u){return super.get(u,0)}set(u,E){return super.set(u,E,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Dc=v;class m{constructor(){this.a=new Map}add(u){return this.a.set(u,(this.a.get(u)||0)+1),this}delete(u){let E=this.a.get(u)||0;return E===0?!1:(E--,E===0?this.a.delete(u):this.a.set(u,E),!0)}has(u){return this.a.has(u)}}e.$Ec=m;class w{constructor(u){if(this.a=new Map,this.b=new Map,u)for(const[E,l]of u)this.set(E,l)}clear(){this.a.clear(),this.b.clear()}set(u,E){this.a.set(u,E),this.b.set(E,u)}get(u){return this.a.get(u)}getKey(u){return this.b.get(u)}delete(u){const E=this.a.get(u);return E===void 0?!1:(this.a.delete(u),this.b.delete(E),!0)}forEach(u,E){this.a.forEach((l,i)=>{u.call(E,l,i,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Fc=w;class ${constructor(){this.a=new Map}add(u,E){let l=this.a.get(u);l||(l=new Set,this.a.set(u,l)),l.add(E)}delete(u,E){const l=this.a.get(u);l&&(l.delete(E),l.size===0&&this.a.delete(u))}forEach(u,E){const l=this.a.get(u);l&&l.forEach(E)}get(u){const E=this.a.get(u);return E||new Set}}e.$Gc=$}),define(ie[2],ne([0,1,23,135,31,83,70]),function(J,e,S,A,s,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=void 0;const P=!1;let h=null;class c{constructor(){this.b=new Map}static{this.a=0}c(I){let j=this.b.get(I);return j||(j={parent:null,source:null,isSingleton:!1,value:I,idx:c.a++},this.b.set(I,j)),j}trackDisposable(I){const j=this.c(I);j.source||(j.source=new Error().stack)}setParent(I,j){const U=this.c(I);U.parent=j}markAsDisposed(I){this.b.delete(I)}markAsSingleton(I){this.c(I).isSingleton=!0}f(I,j){const U=j.get(I);if(U)return U;const z=I.parent?this.f(this.c(I.parent),j):I;return j.set(I,z),z}getTrackedDisposables(){const I=new Map;return[...this.b.entries()].filter(([,U])=>U.source!==null&&!this.f(U,I).isSingleton).flatMap(([U])=>U)}computeLeakingDisposables(I=10,j){let U;if(j)U=j;else{const se=new Map,ce=[...this.b.values()].filter(K=>K.source!==null&&!this.f(K,se).isSingleton);if(ce.length===0)return;const Y=new Set(ce.map(K=>K.value));if(U=ce.filter(K=>!(K.parent&&Y.has(K.parent))),U.length===0)throw new Error("There are cyclic diposable chains!")}if(!U)return;function z(se){function ce(K,Q){for(;K.length>0&&Q.some(q=>typeof q=="string"?q===K[0]:K[0].match(q));)K.shift()}const Y=se.source.split(`
`).map(K=>K.trim().replace("at ","")).filter(K=>K!=="");return ce(Y,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Y.reverse()}const x=new s.$Gc;for(const se of U){const ce=z(se);for(let Y=0;Y<=ce.length;Y++)x.add(ce.slice(0,Y).join(`
`),se)}U.sort((0,S.$7b)(se=>se.idx,S.$9b));let Z="",ae=0;for(const se of U.slice(0,I)){ae++;const ce=z(se),Y=[];for(let K=0;K<ce.length;K++){let Q=ce[K];Q=`(shared with ${x.get(ce.slice(0,K+1).join(`
`)).size}/${U.length} leaks) at ${Q}`;const W=x.get(ce.slice(0,K).join(`
`)),G=(0,A.$J)([...W].map(H=>z(H)[K]),H=>H);delete G[ce[K]];for(const[H,X]of Object.entries(G))Y.unshift(`    - stacktraces of ${X.length} other leaks continue with ${H}`);Y.unshift(Q)}Z+=`


==================== Leaking disposable ${ae}/${U.length}: ${se.value.constructor.name} ====================
${Y.join(`
`)}
============================================================

`}return U.length>I&&(Z+=`


... and ${U.length-I} more leaking disposables

`),{leaks:U,details:Z}}}e.$Hc=c;function g(k){h=k}if(e.$Ic=g,P){const k="__is_disposable_tracked__";g(new class{trackDisposable(I){const j=new Error("Potentially leaked disposable").stack;setTimeout(()=>{I[k]||console.log(j)},3e3)}setParent(I,j){if(I&&I!==i.None)try{I[k]=!0}catch{}}markAsDisposed(I){if(I&&I!==i.None)try{I[k]=!0}catch{}}markAsSingleton(I){}})}function b(k){return h?.trackDisposable(k),k}e.$Jc=b;function y(k){h?.markAsDisposed(k)}e.$Kc=y;function f(k,I){h?.setParent(k,I)}function v(k,I){if(h)for(const j of k)h.setParent(j,I)}function m(k){return h?.markAsSingleton(k),k}e.$Lc=m;function w(k){return typeof k.dispose=="function"&&k.dispose.length===0}e.$Mc=w;function $(k){if(C.Iterable.is(k)){const I=[];for(const j of k)if(j)try{j.dispose()}catch(U){I.push(U)}if(I.length===1)throw I[0];if(I.length>1)throw new AggregateError(I,"Encountered errors while disposing of store");return Array.isArray(k)?[]:k}else if(k)return k.dispose(),k}e.$Nc=$;function d(k){for(const I of k)w(I)&&I.dispose();return[]}e.$Oc=d;function u(...k){const I=E(()=>$(k));return v(k,I),I}e.$Pc=u;function E(k){const I=b({dispose:(0,R.$db)(()=>{y(I),k()})});return I}e.$Qc=E;class l{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,b(this)}dispose(){this.g||(y(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{$(this.f)}finally{this.f.clear()}}add(I){if(!I)return I;if(I===this)throw new Error("Cannot register a disposable on itself!");return f(I,this),this.g?l.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(I),I}delete(I){if(I){if(I===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(I),I.dispose()}}deleteAndLeak(I){I&&this.f.has(I)&&(this.f.delete(I),f(I,null))}}e.$Rc=l;class i{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new l,b(this),f(this.q,this)}dispose(){y(this),this.q.dispose()}B(I){if(I===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(I)}}e.$Sc=i;class a{constructor(){this.b=!1,b(this)}get value(){return this.b?void 0:this.a}set value(I){this.b||I===this.a||(this.a?.dispose(),I&&f(I,this),this.a=I)}clear(){this.value=void 0}dispose(){this.b=!0,y(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const I=this.a;return this.a=void 0,I&&f(I,null),I}}e.$Tc=a;class r{constructor(I){this.b=I,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Uc=r;class t{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,b(this)}set(I){let j=I;return this.unset=()=>j=void 0,this.isset=()=>j!==void 0,this.dispose=()=>{j&&(j(),j=void 0,y(this))},this}}e.$Vc=t;class n{constructor(){this.a=new Map}acquire(I,...j){let U=this.a.get(I);U||(U={counter:0,object:this.b(I,...j)},this.a.set(I,U));const{object:z}=U,x=(0,R.$db)(()=>{--U.counter===0&&(this.c(I,U.object),this.a.delete(I))});return U.counter++,{object:z,dispose:x}}}e.$Wc=n;class o{constructor(I){this.a=I}async acquire(I,...j){const U=this.a.acquire(I,...j);try{return{object:await U.object,dispose:()=>U.dispose()}}catch(z){throw U.dispose(),z}}}e.$Xc=o;class p{constructor(I){this.object=I}dispose(){}}e.$Yc=p;function O(k){const I=new l;try{k(I)}finally{I.dispose()}}e.$Zc=O;class D{constructor(){this.a=new Map,this.b=!1,b(this)}dispose(){y(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{$(this.a.values())}finally{this.a.clear()}}has(I){return this.a.has(I)}get size(){return this.a.size}get(I){return this.a.get(I)}set(I,j,U=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),U||this.a.get(I)?.dispose(),this.a.set(I,j)}deleteAndDispose(I){this.a.get(I)?.dispose(),this.a.delete(I)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$1c=D}),define(ie[84],ne([0,1,31]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rl=e.$ql=e.$pl=void 0;const A=new S.$Dc(1e4);function s(c){return h(c,"NFC",A)}e.$pl=s;const R=new S.$Dc(1e4);function C(c){return h(c,"NFD",R)}e.$ql=C;const P=/[^\u0000-\u0080]/;function h(c,g,b){if(!c)return c;const y=b.get(c);if(y)return y;let f;return P.test(c)?f=c.normalize(g):f=c,b.set(c,f),f}e.$rl=function(){const c=/[\u0300-\u036f]/g;return function(g){return C(g).replace(c,"")}}()}),define(ie[140],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=e.$Sl=e.$Rl=e.rot=e.$Pl=void 0;function S(P,h,c){return Math.min(Math.max(P,h),c)}e.$Pl=S;function A(P,h){return(h+P%h)%h}e.rot=A;class s{constructor(){this.a=0}getNext(){return this.a++}}e.$Rl=s;class R{constructor(){this.a=1,this.b=0}update(h){return this.b=this.b+(h-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Sl=R;class C{constructor(h){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(h),this.c.fill(0,0,h)}update(h){const c=this.c[this.d];return this.c[this.d]=h,this.d=(this.d+1)%this.c.length,this.e-=c,this.e+=h,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Tl=C}),function(){function J(s){const R=[];typeof s=="number"&&R.push("code/timeOrigin",s);function C(h){R.push(h,Date.now())}function P(){const h=[];for(let c=0;c<R.length;c+=2)h.push({name:R[c],startTime:R[c+1]});return h}return{mark:C,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(s){performance.mark(s)},getMarks(){let s=performance.timeOrigin;typeof s!="number"&&(s=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(s)}];for(const C of performance.getEntriesByType("mark"))R.push({name:C.name,startTime:Math.round(s+C.startTime)});return R}};if(typeof process=="object"){const s=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(s)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function S(s){return s.MonacoPerformanceMarks||(s.MonacoPerformanceMarks=e()),s.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return S(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=S(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=S(A))}(),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var S=e();for(var A in S)(typeof exports=="object"?exports:J)[A]=S[A]}}(typeof self<"u"?self:this,function(){return function(J){var e={};function S(A){if(e[A])return e[A].exports;var s=e[A]={i:A,l:!1,exports:{}};return J[A].call(s.exports,s,s.exports,S),s.l=!0,s.exports}return S.m=J,S.c=e,S.d=function(A,s,R){S.o(A,s)||Object.defineProperty(A,s,{enumerable:!0,get:R})},S.r=function(A){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(A,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(A,"__esModule",{value:!0})},S.t=function(A,s){if(1&s&&(A=S(A)),8&s||4&s&&typeof A=="object"&&A&&A.__esModule)return A;var R=Object.create(null);if(S.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:A}),2&s&&typeof A!="string")for(var C in A)S.d(R,C,function(P){return A[P]}.bind(null,C));return R},S.n=function(A){var s=A&&A.__esModule?function(){return A.default}:function(){return A};return S.d(s,"a",s),s},S.o=function(A,s){return Object.prototype.hasOwnProperty.call(A,s)},S.p="",S(S.s=0)}([function(J,e,S){(function(A){var s;e=J.exports=re,s=typeof A=="object"&&A.env&&A.env.NODE_DEBUG&&/\bsemver\b/i.test(A.env.NODE_DEBUG)?function(){var _=Array.prototype.slice.call(arguments,0);_.unshift("SEMVER"),console.log.apply(console,_)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,C=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],h=e.src=[],c=0,g=c++;h[g]="0|[1-9]\\d*";var b=c++;h[b]="[0-9]+";var y=c++;h[y]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var f=c++;h[f]="("+h[g]+")\\.("+h[g]+")\\.("+h[g]+")";var v=c++;h[v]="("+h[b]+")\\.("+h[b]+")\\.("+h[b]+")";var m=c++;h[m]="(?:"+h[g]+"|"+h[y]+")";var w=c++;h[w]="(?:"+h[b]+"|"+h[y]+")";var $=c++;h[$]="(?:-("+h[m]+"(?:\\."+h[m]+")*))";var d=c++;h[d]="(?:-?("+h[w]+"(?:\\."+h[w]+")*))";var u=c++;h[u]="[0-9A-Za-z-]+";var E=c++;h[E]="(?:\\+("+h[u]+"(?:\\."+h[u]+")*))";var l=c++,i="v?"+h[f]+h[$]+"?"+h[E]+"?";h[l]="^"+i+"$";var a="[v=\\s]*"+h[v]+h[d]+"?"+h[E]+"?",r=c++;h[r]="^"+a+"$";var t=c++;h[t]="((?:<|>)?=?)";var n=c++;h[n]=h[b]+"|x|X|\\*";var o=c++;h[o]=h[g]+"|x|X|\\*";var p=c++;h[p]="[v=\\s]*("+h[o]+")(?:\\.("+h[o]+")(?:\\.("+h[o]+")(?:"+h[$]+")?"+h[E]+"?)?)?";var O=c++;h[O]="[v=\\s]*("+h[n]+")(?:\\.("+h[n]+")(?:\\.("+h[n]+")(?:"+h[d]+")?"+h[E]+"?)?)?";var D=c++;h[D]="^"+h[t]+"\\s*"+h[p]+"$";var k=c++;h[k]="^"+h[t]+"\\s*"+h[O]+"$";var I=c++;h[I]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var j=c++;h[j]="(?:~>?)";var U=c++;h[U]="(\\s*)"+h[j]+"\\s+",P[U]=new RegExp(h[U],"g");var z=c++;h[z]="^"+h[j]+h[p]+"$";var x=c++;h[x]="^"+h[j]+h[O]+"$";var Z=c++;h[Z]="(?:\\^)";var ae=c++;h[ae]="(\\s*)"+h[Z]+"\\s+",P[ae]=new RegExp(h[ae],"g");var se=c++;h[se]="^"+h[Z]+h[p]+"$";var ce=c++;h[ce]="^"+h[Z]+h[O]+"$";var Y=c++;h[Y]="^"+h[t]+"\\s*("+a+")$|^$";var K=c++;h[K]="^"+h[t]+"\\s*("+i+")$|^$";var Q=c++;h[Q]="(\\s*)"+h[t]+"\\s*("+a+"|"+h[p]+")",P[Q]=new RegExp(h[Q],"g");var q=c++;h[q]="^\\s*("+h[p]+")\\s+-\\s+("+h[p]+")\\s*$";var W=c++;h[W]="^\\s*("+h[O]+")\\s+-\\s+("+h[O]+")\\s*$";var G=c++;h[G]="(<|>)?=?\\s*\\*";for(var H=0;H<35;H++)s(H,h[H]),P[H]||(P[H]=new RegExp(h[H]));function X(_,le){if(_ instanceof re)return _;if(typeof _!="string"||_.length>R||!(le?P[r]:P[l]).test(_))return null;try{return new re(_,le)}catch{return null}}function re(_,le){if(_ instanceof re){if(_.loose===le)return _;_=_.version}else if(typeof _!="string")throw new TypeError("Invalid Version: "+_);if(_.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof re))return new re(_,le);s("SemVer",_,le),this.loose=le;var ge=_.trim().match(le?P[r]:P[l]);if(!ge)throw new TypeError("Invalid Version: "+_);if(this.raw=_,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>C||this.major<0)throw new TypeError("Invalid major version");if(this.minor>C||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>C||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(Oe){if(/^[0-9]+$/.test(Oe)){var Ce=+Oe;if(Ce>=0&&Ce<C)return Ce}return Oe}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=X,e.valid=function(_,le){var ge=X(_,le);return ge?ge.version:null},e.clean=function(_,le){var ge=X(_.trim().replace(/^[=v]+/,""),le);return ge?ge.version:null},e.SemVer=re,re.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},re.prototype.toString=function(){return this.version},re.prototype.compare=function(_){return s("SemVer.compare",this.version,this.loose,_),_ instanceof re||(_=new re(_,this.loose)),this.compareMain(_)||this.comparePre(_)},re.prototype.compareMain=function(_){return _ instanceof re||(_=new re(_,this.loose)),M(this.major,_.major)||M(this.minor,_.minor)||M(this.patch,_.patch)},re.prototype.comparePre=function(_){if(_ instanceof re||(_=new re(_,this.loose)),this.prerelease.length&&!_.prerelease.length)return-1;if(!this.prerelease.length&&_.prerelease.length)return 1;if(!this.prerelease.length&&!_.prerelease.length)return 0;var le=0;do{var ge=this.prerelease[le],Oe=_.prerelease[le];if(s("prerelease compare",le,ge,Oe),ge===void 0&&Oe===void 0)return 0;if(Oe===void 0)return 1;if(ge===void 0)return-1;if(ge!==Oe)return M(ge,Oe)}while(++le)},re.prototype.inc=function(_,le){switch(_){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",le);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",le);break;case"prepatch":this.prerelease.length=0,this.inc("patch",le),this.inc("pre",le);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",le),this.inc("pre",le);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}le&&(this.prerelease[0]===le?isNaN(this.prerelease[1])&&(this.prerelease=[le,0]):this.prerelease=[le,0]);break;default:throw new Error("invalid increment argument: "+_)}return this.format(),this.raw=this.version,this},e.inc=function(_,le,ge,Oe){typeof ge=="string"&&(Oe=ge,ge=void 0);try{return new re(_,ge).inc(le,Oe).version}catch{return null}},e.diff=function(_,le){if(B(_,le))return null;var ge=X(_),Oe=X(le);if(ge.prerelease.length||Oe.prerelease.length){for(var Ce in ge)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&ge[Ce]!==Oe[Ce])return"pre"+Ce;return"prerelease"}for(var Ce in ge)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&ge[Ce]!==Oe[Ce])return Ce},e.compareIdentifiers=M;var L=/^[0-9]+$/;function M(_,le){var ge=L.test(_),Oe=L.test(le);return ge&&Oe&&(_=+_,le=+le),ge&&!Oe?-1:Oe&&!ge?1:_<le?-1:_>le?1:0}function N(_,le,ge){return new re(_,ge).compare(new re(le,ge))}function T(_,le,ge){return N(_,le,ge)>0}function F(_,le,ge){return N(_,le,ge)<0}function B(_,le,ge){return N(_,le,ge)===0}function V(_,le,ge){return N(_,le,ge)!==0}function oe(_,le,ge){return N(_,le,ge)>=0}function de(_,le,ge){return N(_,le,ge)<=0}function ue(_,le,ge,Oe){var Ce;switch(le){case"===":typeof _=="object"&&(_=_.version),typeof ge=="object"&&(ge=ge.version),Ce=_===ge;break;case"!==":typeof _=="object"&&(_=_.version),typeof ge=="object"&&(ge=ge.version),Ce=_!==ge;break;case"":case"=":case"==":Ce=B(_,ge,Oe);break;case"!=":Ce=V(_,ge,Oe);break;case">":Ce=T(_,ge,Oe);break;case">=":Ce=oe(_,ge,Oe);break;case"<":Ce=F(_,ge,Oe);break;case"<=":Ce=de(_,ge,Oe);break;default:throw new TypeError("Invalid operator: "+le)}return Ce}function he(_,le){if(_ instanceof he){if(_.loose===le)return _;_=_.value}if(!(this instanceof he))return new he(_,le);s("comparator",_,le),this.loose=le,this.parse(_),this.semver===ve?this.value="":this.value=this.operator+this.semver.version,s("comp",this)}e.rcompareIdentifiers=function(_,le){return M(le,_)},e.major=function(_,le){return new re(_,le).major},e.minor=function(_,le){return new re(_,le).minor},e.patch=function(_,le){return new re(_,le).patch},e.compare=N,e.compareLoose=function(_,le){return N(_,le,!0)},e.rcompare=function(_,le,ge){return N(le,_,ge)},e.sort=function(_,le){return _.sort(function(ge,Oe){return e.compare(ge,Oe,le)})},e.rsort=function(_,le){return _.sort(function(ge,Oe){return e.rcompare(ge,Oe,le)})},e.gt=T,e.lt=F,e.eq=B,e.neq=V,e.gte=oe,e.lte=de,e.cmp=ue,e.Comparator=he;var ve={};function be(_,le){if(_ instanceof be)return _.loose===le?_:new be(_.raw,le);if(_ instanceof he)return new be(_.value,le);if(!(this instanceof be))return new be(_,le);if(this.loose=le,this.raw=_,this.set=_.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+_);this.format()}function ye(_){return!_||_.toLowerCase()==="x"||_==="*"}function Ie(_,le,ge,Oe,Ce,Le,Re,He,ze,ee,fe,$e,ke){return((le=ye(ge)?"":ye(Oe)?">="+ge+".0.0":ye(Ce)?">="+ge+"."+Oe+".0":">="+le)+" "+(He=ye(ze)?"":ye(ee)?"<"+(+ze+1)+".0.0":ye(fe)?"<"+ze+"."+(+ee+1)+".0":$e?"<="+ze+"."+ee+"."+fe+"-"+$e:"<="+He)).trim()}function Te(_,le){for(var ge=0;ge<_.length;ge++)if(!_[ge].test(le))return!1;if(le.prerelease.length){for(ge=0;ge<_.length;ge++)if(s(_[ge].semver),_[ge].semver!==ve&&_[ge].semver.prerelease.length>0){var Oe=_[ge].semver;if(Oe.major===le.major&&Oe.minor===le.minor&&Oe.patch===le.patch)return!0}return!1}return!0}function me(_,le,ge){try{le=new be(le,ge)}catch{return!1}return le.test(_)}function we(_,le,ge,Oe){var Ce,Le,Re,He,ze;switch(_=new re(_,Oe),le=new be(le,Oe),ge){case">":Ce=T,Le=de,Re=F,He=">",ze=">=";break;case"<":Ce=F,Le=oe,Re=T,He="<",ze="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(me(_,le,Oe))return!1;for(var ee=0;ee<le.set.length;++ee){var fe=le.set[ee],$e=null,ke=null;if(fe.forEach(function(De){De.semver===ve&&(De=new he(">=0.0.0")),$e=$e||De,ke=ke||De,Ce(De.semver,$e.semver,Oe)?$e=De:Re(De.semver,ke.semver,Oe)&&(ke=De)}),$e.operator===He||$e.operator===ze||(!ke.operator||ke.operator===He)&&Le(_,ke.semver)||ke.operator===ze&&Re(_,ke.semver))return!1}return!0}he.prototype.parse=function(_){var le=this.loose?P[Y]:P[K],ge=_.match(le);if(!ge)throw new TypeError("Invalid comparator: "+_);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new re(ge[2],this.loose):this.semver=ve},he.prototype.toString=function(){return this.value},he.prototype.test=function(_){return s("Comparator.test",_,this.loose),this.semver===ve||(typeof _=="string"&&(_=new re(_,this.loose)),ue(_,this.operator,this.semver,this.loose))},he.prototype.intersects=function(_,le){if(!(_ instanceof he))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new be(_.value,le),me(this.value,ge,le);if(_.operator==="")return ge=new be(this.value,le),me(_.semver,ge,le);var Oe=!(this.operator!==">="&&this.operator!==">"||_.operator!==">="&&_.operator!==">"),Ce=!(this.operator!=="<="&&this.operator!=="<"||_.operator!=="<="&&_.operator!=="<"),Le=this.semver.version===_.semver.version,Re=!(this.operator!==">="&&this.operator!=="<="||_.operator!==">="&&_.operator!=="<="),He=ue(this.semver,"<",_.semver,le)&&(this.operator===">="||this.operator===">")&&(_.operator==="<="||_.operator==="<"),ze=ue(this.semver,">",_.semver,le)&&(this.operator==="<="||this.operator==="<")&&(_.operator===">="||_.operator===">");return Oe||Ce||Le&&Re||He||ze},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(_){return _.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(_){var le=this.loose;_=_.trim(),s("range",_,le);var ge=le?P[W]:P[q];_=_.replace(ge,Ie),s("hyphen replace",_),_=_.replace(P[Q],"$1$2$3"),s("comparator trim",_,P[Q]),_=(_=(_=_.replace(P[U],"$1~")).replace(P[ae],"$1^")).split(/\s+/).join(" ");var Oe=le?P[Y]:P[K],Ce=_.split(" ").map(function(Le){return function(Re,He){return s("comp",Re),Re=function(ze,ee){return ze.trim().split(/\s+/).map(function(fe){return function($e,ke){s("caret",$e,ke);var De=ke?P[ce]:P[se];return $e.replace(De,function(Ne,je,Fe,Ve,Ge){var Qe;return s("caret",$e,Ne,je,Fe,Ve,Ge),ye(je)?Qe="":ye(Fe)?Qe=">="+je+".0.0 <"+(+je+1)+".0.0":ye(Ve)?Qe=je==="0"?">="+je+"."+Fe+".0 <"+je+"."+(+Fe+1)+".0":">="+je+"."+Fe+".0 <"+(+je+1)+".0.0":Ge?(s("replaceCaret pr",Ge),Ge.charAt(0)!=="-"&&(Ge="-"+Ge),Qe=je==="0"?Fe==="0"?">="+je+"."+Fe+"."+Ve+Ge+" <"+je+"."+Fe+"."+(+Ve+1):">="+je+"."+Fe+"."+Ve+Ge+" <"+je+"."+(+Fe+1)+".0":">="+je+"."+Fe+"."+Ve+Ge+" <"+(+je+1)+".0.0"):(s("no pr"),Qe=je==="0"?Fe==="0"?">="+je+"."+Fe+"."+Ve+" <"+je+"."+Fe+"."+(+Ve+1):">="+je+"."+Fe+"."+Ve+" <"+je+"."+(+Fe+1)+".0":">="+je+"."+Fe+"."+Ve+" <"+(+je+1)+".0.0"),s("caret return",Qe),Qe})}(fe,ee)}).join(" ")}(Re,He),s("caret",Re),Re=function(ze,ee){return ze.trim().split(/\s+/).map(function(fe){return function($e,ke){var De=ke?P[x]:P[z];return $e.replace(De,function(Ne,je,Fe,Ve,Ge){var Qe;return s("tilde",$e,Ne,je,Fe,Ve,Ge),ye(je)?Qe="":ye(Fe)?Qe=">="+je+".0.0 <"+(+je+1)+".0.0":ye(Ve)?Qe=">="+je+"."+Fe+".0 <"+je+"."+(+Fe+1)+".0":Ge?(s("replaceTilde pr",Ge),Ge.charAt(0)!=="-"&&(Ge="-"+Ge),Qe=">="+je+"."+Fe+"."+Ve+Ge+" <"+je+"."+(+Fe+1)+".0"):Qe=">="+je+"."+Fe+"."+Ve+" <"+je+"."+(+Fe+1)+".0",s("tilde return",Qe),Qe})}(fe,ee)}).join(" ")}(Re,He),s("tildes",Re),Re=function(ze,ee){return s("replaceXRanges",ze,ee),ze.split(/\s+/).map(function(fe){return function($e,ke){$e=$e.trim();var De=ke?P[k]:P[D];return $e.replace(De,function(Ne,je,Fe,Ve,Ge,Qe){s("xRange",$e,Ne,je,Fe,Ve,Ge,Qe);var Ze=ye(Fe),Xe=Ze||ye(Ve),it=Xe||ye(Ge);return je==="="&&it&&(je=""),Ze?Ne=je===">"||je==="<"?"<0.0.0":"*":je&&it?(Xe&&(Ve=0),it&&(Ge=0),je===">"?(je=">=",Xe?(Fe=+Fe+1,Ve=0,Ge=0):it&&(Ve=+Ve+1,Ge=0)):je==="<="&&(je="<",Xe?Fe=+Fe+1:Ve=+Ve+1),Ne=je+Fe+"."+Ve+"."+Ge):Xe?Ne=">="+Fe+".0.0 <"+(+Fe+1)+".0.0":it&&(Ne=">="+Fe+"."+Ve+".0 <"+Fe+"."+(+Ve+1)+".0"),s("xRange return",Ne),Ne})}(fe,ee)}).join(" ")}(Re,He),s("xrange",Re),Re=function(ze,ee){return s("replaceStars",ze,ee),ze.trim().replace(P[G],"")}(Re,He),s("stars",Re),Re}(Le,le)}).join(" ").split(/\s+/);return this.loose&&(Ce=Ce.filter(function(Le){return!!Le.match(Oe)})),Ce=Ce.map(function(Le){return new he(Le,le)})},be.prototype.intersects=function(_,le){if(!(_ instanceof be))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(Oe){return _.set.some(function(Ce){return Ce.every(function(Le){return Oe.intersects(Le,le)})})})})},e.toComparators=function(_,le){return new be(_,le).set.map(function(ge){return ge.map(function(Oe){return Oe.value}).join(" ").trim().split(" ")})},be.prototype.test=function(_){if(!_)return!1;typeof _=="string"&&(_=new re(_,this.loose));for(var le=0;le<this.set.length;le++)if(Te(this.set[le],_))return!0;return!1},e.satisfies=me,e.maxSatisfying=function(_,le,ge){var Oe=null,Ce=null;try{var Le=new be(le,ge)}catch{return null}return _.forEach(function(Re){Le.test(Re)&&(Oe&&Ce.compare(Re)!==-1||(Ce=new re(Oe=Re,ge)))}),Oe},e.minSatisfying=function(_,le,ge){var Oe=null,Ce=null;try{var Le=new be(le,ge)}catch{return null}return _.forEach(function(Re){Le.test(Re)&&(Oe&&Ce.compare(Re)!==1||(Ce=new re(Oe=Re,ge)))}),Oe},e.validRange=function(_,le){try{return new be(_,le).range||"*"}catch{return null}},e.ltr=function(_,le,ge){return we(_,le,"<",ge)},e.gtr=function(_,le,ge){return we(_,le,">",ge)},e.outside=we,e.prerelease=function(_,le){var ge=X(_,le);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(_,le,ge){return _=new be(_,ge),le=new be(le,ge),_.intersects(le)},e.coerce=function(_){if(_ instanceof re)return _;if(typeof _!="string")return null;var le=_.match(P[I]);return le==null?null:X((le[1]||"0")+"."+(le[2]||"0")+"."+(le[3]||"0"))}}).call(this,S(1))},function(J,e){var S,A,s=J.exports={};function R(){throw new Error("setTimeout has not been defined")}function C(){throw new Error("clearTimeout has not been defined")}function P(w){if(S===setTimeout)return setTimeout(w,0);if((S===R||!S)&&setTimeout)return S=setTimeout,setTimeout(w,0);try{return S(w,0)}catch{try{return S.call(null,w,0)}catch{return S.call(this,w,0)}}}(function(){try{S=typeof setTimeout=="function"?setTimeout:R}catch{S=R}try{A=typeof clearTimeout=="function"?clearTimeout:C}catch{A=C}})();var h,c=[],g=!1,b=-1;function y(){g&&h&&(g=!1,h.length?c=h.concat(c):b=-1,c.length&&f())}function f(){if(!g){var w=P(y);g=!0;for(var $=c.length;$;){for(h=c,c=[];++b<$;)h&&h[b].run();b=-1,$=c.length}h=null,g=!1,function(d){if(A===clearTimeout)return clearTimeout(d);if((A===C||!A)&&clearTimeout)return A=clearTimeout,clearTimeout(d);try{A(d)}catch{try{return A.call(null,d)}catch{return A.call(this,d)}}}(w)}}function v(w,$){this.fun=w,this.array=$}function m(){}s.nextTick=function(w){var $=new Array(arguments.length-1);if(arguments.length>1)for(var d=1;d<arguments.length;d++)$[d-1]=arguments[d];c.push(new v(w,$)),c.length!==1||g||P(f)},v.prototype.run=function(){this.fun.apply(null,this.array)},s.title="browser",s.browser=!0,s.env={},s.argv=[],s.version="",s.versions={},s.on=m,s.addListener=m,s.once=m,s.off=m,s.removeListener=m,s.removeAllListeners=m,s.emit=m,s.prependListener=m,s.prependOnceListener=m,s.listeners=function(w){return[]},s.binding=function(w){throw new Error("process.binding is not supported")},s.cwd=function(){return"/"},s.chdir=function(w){throw new Error("process.chdir is not supported")},s.umask=function(){return 0}}])}),define(ie[141],ne([0,1]),function(J,e){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$Cr=void 0;class A{constructor(P,h,c){this.level=P,this.key=h,this.value=c,this.forward=[]}}const s=void 0;class R{constructor(P,h=2**16){this.comparator=P,this[S]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(h)|0),this.e=new A(this.c,s,s)}get size(){return this.f}clear(){this.e=new A(this.c,s,s),this.f=0}has(P){return!!R.g(this,P,this.comparator)}get(P){return R.g(this,P,this.comparator)?.value}set(P,h){return R.h(this,P,h,this.comparator)&&(this.f+=1),this}delete(P){const h=R.k(this,P,this.comparator);return h&&(this.f-=1),h}forEach(P,h){let c=this.e.forward[0];for(;c;)P.call(h,c.value,c.key,this),c=c.forward[0]}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this.e.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this.e.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this.e.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",h=this.e.forward[0];for(;h;)P+=`node(${h.key}, ${h.value}, lvl:${h.level})`,h=h.forward[0];return P}static g(P,h,c){let g=P.e;for(let b=P.d-1;b>=0;b--)for(;g.forward[b]&&c(g.forward[b].key,h)<0;)g=g.forward[b];if(g=g.forward[0],g&&c(g.key,h)===0)return g}static h(P,h,c,g){const b=[];let y=P.e;for(let f=P.d-1;f>=0;f--){for(;y.forward[f]&&g(y.forward[f].key,h)<0;)y=y.forward[f];b[f]=y}if(y=y.forward[0],y&&g(y.key,h)===0)return y.value=c,!1;{const f=R.j(P);if(f>P.d){for(let v=P.d;v<f;v++)b[v]=P.e;P.d=f}y=new A(f,h,c);for(let v=0;v<f;v++)y.forward[v]=b[v].forward[v],b[v].forward[v]=y;return!0}}static j(P,h=.5){let c=1;for(;Math.random()<h&&c<P.c;)c+=1;return c}static k(P,h,c){const g=[];let b=P.e;for(let y=P.d-1;y>=0;y--){for(;b.forward[y]&&c(b.forward[y].key,h)<0;)b=b.forward[y];g[y]=b}if(b=b.forward[0],!b||c(b.key,h)!==0)return!1;for(let y=0;y<P.d&&g[y].forward[y]===b;y++)g[y].forward[y]=b.forward[y];for(;P.d>0&&P.e.forward[P.d-1]===s;)P.d-=1;return!0}}e.$Cr=R}),define(ie[72],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kd=void 0;const S=globalThis.performance&&typeof globalThis.performance.now=="function";class A{static create(R){return new A(R)}constructor(R){this.c=S&&R===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Kd=A}),define(ie[3],ne([0,1,14,83,2,101,72]),function(J,e,S,A,s,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.Event=void 0;const P=!1,h=!1;var c;(function(D){D.None=()=>s.$Sc.None;function k(ue){if(h){const{onDidAddListener:he}=ue,ve=v.create();let be=0;ue.onDidAddListener=()=>{++be===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ve.print()),he?.()}}}function I(ue,he){return K(ue,()=>{},0,void 0,!0,void 0,he)}D.defer=I;function j(ue){return(he,ve=null,be)=>{let ye=!1,Ie;return Ie=ue(Te=>{if(!ye)return Ie?Ie.dispose():ye=!0,he.call(ve,Te)},null,be),ye&&Ie.dispose(),Ie}}D.once=j;function U(ue,he,ve){return ce((be,ye=null,Ie)=>ue(Te=>be.call(ye,he(Te)),null,Ie),ve)}D.map=U;function z(ue,he,ve){return ce((be,ye=null,Ie)=>ue(Te=>{he(Te),be.call(ye,Te)},null,Ie),ve)}D.forEach=z;function x(ue,he,ve){return ce((be,ye=null,Ie)=>ue(Te=>he(Te)&&be.call(ye,Te),null,Ie),ve)}D.filter=x;function Z(ue){return ue}D.signal=Z;function ae(...ue){return(he,ve=null,be)=>{const ye=(0,s.$Pc)(...ue.map(Ie=>Ie(Te=>he.call(ve,Te))));return Y(ye,be)}}D.any=ae;function se(ue,he,ve,be){let ye=ve;return U(ue,Ie=>(ye=he(ye,Ie),ye),be)}D.reduce=se;function ce(ue,he){let ve;const be={onWillAddFirstListener(){ve=ue(ye.fire,ye)},onDidRemoveLastListener(){ve?.dispose()}};he||k(be);const ye=new u(be);return he?.add(ye),ye.event}function Y(ue,he){return he instanceof Array?he.push(ue):he&&he.add(ue),ue}function K(ue,he,ve=100,be=!1,ye=!1,Ie,Te){let me,we,_,le=0,ge;const Oe={leakWarningThreshold:Ie,onWillAddFirstListener(){me=ue(Le=>{le++,we=he(we,Le),be&&!_&&(Ce.fire(we),we=void 0),ge=()=>{const Re=we;we=void 0,_=void 0,(!be||le>1)&&Ce.fire(Re),le=0},typeof ve=="number"?(clearTimeout(_),_=setTimeout(ge,ve)):_===void 0&&(_=0,queueMicrotask(ge))})},onWillRemoveListener(){ye&&le>0&&ge?.()},onDidRemoveLastListener(){ge=void 0,me.dispose()}};Te||k(Oe);const Ce=new u(Oe);return Te?.add(Ce),Ce.event}D.debounce=K;function Q(ue,he=0,ve){return D.debounce(ue,(be,ye)=>be?(be.push(ye),be):[ye],he,void 0,!0,void 0,ve)}D.accumulate=Q;function q(ue,he=(be,ye)=>be===ye,ve){let be=!0,ye;return x(ue,Ie=>{const Te=be||!he(Ie,ye);return be=!1,ye=Ie,Te},ve)}D.latch=q;function W(ue,he,ve){return[D.filter(ue,he,ve),D.filter(ue,be=>!he(be),ve)]}D.split=W;function G(ue,he=!1,ve=[],be){let ye=ve.slice(),Ie=ue(we=>{ye?ye.push(we):me.fire(we)});be&&be.add(Ie);const Te=()=>{ye?.forEach(we=>me.fire(we)),ye=null},me=new u({onWillAddFirstListener(){Ie||(Ie=ue(we=>me.fire(we)),be&&be.add(Ie))},onDidAddFirstListener(){ye&&(he?setTimeout(Te):Te())},onDidRemoveLastListener(){Ie&&Ie.dispose(),Ie=null}});return be&&be.add(me),me.event}D.buffer=G;function H(ue,he){return(be,ye,Ie)=>{const Te=he(new re);return ue(function(me){const we=Te.evaluate(me);we!==X&&be.call(ye,we)},void 0,Ie)}}D.chain=H;const X=Symbol("HaltChainable");class re{constructor(){this.f=[]}map(he){return this.f.push(he),this}forEach(he){return this.f.push(ve=>(he(ve),ve)),this}filter(he){return this.f.push(ve=>he(ve)?ve:X),this}reduce(he,ve){let be=ve;return this.f.push(ye=>(be=he(be,ye),be)),this}latch(he=(ve,be)=>ve===be){let ve=!0,be;return this.f.push(ye=>{const Ie=ve||!he(ye,be);return ve=!1,be=ye,Ie?ye:X}),this}evaluate(he){for(const ve of this.f)if(he=ve(he),he===X)break;return he}}function L(ue,he,ve=be=>be){const be=(...me)=>Te.fire(ve(...me)),ye=()=>ue.on(he,be),Ie=()=>ue.removeListener(he,be),Te=new u({onWillAddFirstListener:ye,onDidRemoveLastListener:Ie});return Te.event}D.fromNodeEventEmitter=L;function M(ue,he,ve=be=>be){const be=(...me)=>Te.fire(ve(...me)),ye=()=>ue.addEventListener(he,be),Ie=()=>ue.removeEventListener(he,be),Te=new u({onWillAddFirstListener:ye,onDidRemoveLastListener:Ie});return Te.event}D.fromDOMEventEmitter=M;function N(ue){return new Promise(he=>j(ue)(he))}D.toPromise=N;function T(ue){const he=new u;return ue.then(ve=>{he.fire(ve)},()=>{he.fire(void 0)}).finally(()=>{he.dispose()}),he.event}D.fromPromise=T;function F(ue,he,ve){return he(ve),ue(be=>he(be))}D.runAndSubscribe=F;function B(ue,he){let ve=null;function be(Ie){ve?.dispose(),ve=new s.$Rc,he(Ie,ve)}be(void 0);const ye=ue(Ie=>be(Ie));return(0,s.$Qc)(()=>{ye.dispose(),ve?.dispose()})}D.runAndSubscribeWithStore=B;class V{constructor(he,ve){this._observable=he,this.f=0,this.g=!1;const be={onWillAddFirstListener:()=>{he.addObserver(this)},onDidRemoveLastListener:()=>{he.removeObserver(this)}};ve||k(be),this.emitter=new u(be),ve&&ve.add(this.emitter)}beginUpdate(he){this.f++}handlePossibleChange(he){}handleChange(he,ve){this.g=!0}endUpdate(he){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function oe(ue,he){return new V(ue,he).emitter.event}D.fromObservable=oe;function de(ue){return he=>{let ve=0,be=!1;const ye={beginUpdate(){ve++},endUpdate(){ve--,ve===0&&(ue.reportChanges(),be&&(be=!1,he()))},handlePossibleChange(){},handleChange(){be=!0}};return ue.addObserver(ye),ue.reportChanges(),{dispose(){ue.removeObserver(ye)}}}}D.fromObservableLight=de})(c||(e.Event=c={}));class g{static{this.all=new Set}static{this.f=0}constructor(k){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${k}_${g.f++}`,g.all.add(this)}start(k){this.g=new C.$Kd,this.listenerCount=k}stop(){if(this.g){const k=this.g.elapsed();this.durations.push(k),this.elapsedOverall+=k,this.invocationCount+=1,this.g=void 0}}}e.$Md=g;let b=-1;function y(D){const k=b;return b=D,{dispose(){b=k}}}e.$Nd=y;class f{constructor(k,I=Math.random().toString(18).slice(2,5)){this.threshold=k,this.name=I,this.g=0}dispose(){this.f?.clear()}check(k,I){const j=this.threshold;if(j<=0||I<j)return;this.f||(this.f=new Map);const U=this.f.get(k.value)||0;if(this.f.set(k.value,U+1),this.g-=1,this.g<=0){this.g=j*.5;let z,x=0;for(const[Z,ae]of this.f)(!z||x<ae)&&(z=Z,x=ae);console.warn(`[${this.name}] potential listener LEAK detected, having ${I} listeners already. MOST frequent listener (${x}):`),console.warn(z)}return()=>{const z=this.f.get(k.value)||0;this.f.set(k.value,z-1)}}}class v{static create(){return new v(new Error().stack??"")}constructor(k){this.value=k}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let m=0;class w{constructor(k){this.value=k,this.id=m++}}const $=2,d=(D,k)=>{if(D instanceof w)k(D);else for(let I=0;I<D.length;I++){const j=D[I];j&&k(j)}};class u{constructor(k){this.w=0,this.f=k,this.g=b>0||this.f?.leakWarningThreshold?new f(this.f?.leakWarningThreshold??b):void 0,this.j=this.f?._profName?new g(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(P){const k=this.t;queueMicrotask(()=>{d(k,I=>I.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(k,I,j)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),s.$Sc.None;if(this.m)return s.$Sc.None;I&&(k=k.bind(I));const U=new w(k);let z,x;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(U.stack=v.create(),z=this.g.check(U.stack,this.w+1)),P&&(U.stack=x??v.create()),this.t?this.t instanceof w?(this.u??=new l,this.t=[this.t,U]):this.t.push(U):(this.f?.onWillAddFirstListener?.(this),this.t=U,this.f?.onDidAddFirstListener?.(this)),this.w++;const Z=(0,s.$Qc)(()=>{z?.(),this.x(U)});return j instanceof s.$Rc?j.add(Z):Array.isArray(j)&&j.push(Z),Z},this.q}x(k){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const I=this.t,j=I.indexOf(k);if(j===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,I[j]=void 0;const U=this.u.current===this;if(this.w*$<=I.length){let z=0;for(let x=0;x<I.length;x++)I[x]?I[z++]=I[x]:U&&(this.u.end--,z<this.u.i&&this.u.i--);I.length=z}}y(k,I){if(!k)return;const j=this.f?.onListenerError||S.$1;if(!j){k.value(I);return}try{k.value(I)}catch(U){j(U)}}z(k){const I=k.current.t;for(;k.i<k.end;)this.y(I[k.i++],k.value);k.reset()}fire(k){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof w)this.y(this.t,k);else{const I=this.u;I.enqueue(this,k,this.t.length),this.z(I)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Od=u;const E=()=>new l;e.$Pd=E;class l{constructor(){this.i=-1,this.end=0}enqueue(k,I,j){this.i=0,this.end=j,this.current=k,this.value=I}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class i extends u{async fireAsync(k,I,j){if(this.t)for(this.h||(this.h=new R.$2c),d(this.t,U=>this.h.push([U.value,k]));this.h.size>0&&!I.isCancellationRequested;){const[U,z]=this.h.shift(),x=[],Z={...z,token:I,waitUntil:ae=>{if(Object.isFrozen(x))throw new Error("waitUntil can NOT be called asynchronous");j&&(ae=j(ae,U)),x.push(ae)}};try{U(Z)}catch(ae){(0,S.$1)(ae);continue}Object.freeze(x),await Promise.allSettled(x).then(ae=>{for(const se of ae)se.status==="rejected"&&(0,S.$1)(se.reason)})}}}e.$Qd=i;class a extends u{get isPaused(){return this.h!==0}constructor(k){super(k),this.h=0,this.s=new R.$2c,this.A=k?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const k=Array.from(this.s);this.s.clear(),super.fire(this.A(k))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(k){this.w&&(this.h!==0?this.s.push(k):super.fire(k))}}e.$Rd=a;class r extends a{constructor(k){super(k),this.k=k.delay??100}fire(k){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(k)}}e.$Sd=r;class t extends u{constructor(k){super(k),this.h=[],this.k=k?.merge}fire(k){this.hasListeners()&&(this.h.push(k),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(I=>super.fire(I)),this.h=[]}))}}e.$Td=t;class n{constructor(){this.g=!1,this.h=[],this.f=new u({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(k){const I={event:k,listener:null};this.h.push(I),this.g&&this.m(I);const j=()=>{this.g&&this.o(I);const U=this.h.indexOf(I);this.h.splice(U,1)};return(0,s.$Qc)((0,A.$db)(j))}j(){this.g=!0,this.h.forEach(k=>this.m(k))}k(){this.g=!1,this.h.forEach(k=>this.o(k))}m(k){k.listener=k.event(I=>this.f.fire(I))}o(k){k.listener&&k.listener.dispose(),k.listener=null}dispose(){this.f.dispose()}}e.$Ud=n;class o{constructor(k,I,j,U){this.f=new s.$Rc;const z=this.f.add(new n),x=this.f.add(new s.$1c);function Z(ae){x.set(ae,z.add(U(ae)))}for(const ae of k)Z(ae);this.f.add(I(ae=>{Z(ae)})),this.f.add(j(ae=>{x.deleteAndDispose(ae)})),this.event=z.event}dispose(){this.f.dispose()}}e.$Vd=o;class p{constructor(){this.f=[]}wrapEvent(k){return(I,j,U)=>k(z=>{const x=this.f[this.f.length-1];x?x.push(()=>I.call(j,z)):I.call(j,z)},void 0,U)}bufferEvents(k){const I=[];this.f.push(I);const j=k();return this.f.pop(),I.forEach(U=>U()),j}}e.$Wd=p;class O{constructor(){this.f=!1,this.g=c.None,this.h=s.$Sc.None,this.j=new u({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(k){this.g=k,this.f&&(this.h.dispose(),this.h=k(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$Xd=O}),define(ie[22],ne([0,1,3]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yd=e.CancellationToken=void 0;const A=Object.freeze(function(P,h){const c=setTimeout(P.bind(h),0);return{dispose(){clearTimeout(c)}}});var s;(function(P){function h(c){return c===P.None||c===P.Cancelled||c instanceof R?!0:!c||typeof c!="object"?!1:typeof c.isCancellationRequested=="boolean"&&typeof c.onCancellationRequested=="function"}P.isCancellationToken=h,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:S.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:A})})(s||(e.CancellationToken=s={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?A:(this.b||(this.b=new S.$Od),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class C{constructor(h){this.f=void 0,this.g=void 0,this.g=h&&h.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new R),this.f}cancel(){this.f?this.f instanceof R&&this.f.cancel():this.f=s.Cancelled}dispose(h=!1){h&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof R&&this.f.dispose():this.f=s.None}}e.$Yd=C}),define(ie[142],ne([0,1,22]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=e.$ye=e.$xe=void 0;class A{constructor(P){this.b=P,this.a=null}get(){if(this.a)return this.a;const P=new S.$Yd,h=this.b(P.token);return this.a={promise:h,dispose:()=>{this.a=null,P.cancel(),P.dispose()}},this.a}}e.$xe=A;class s{constructor(P){this.c=P,this.a=void 0,this.b=void 0}get(P){const h=JSON.stringify(P);return this.b!==h&&(this.b=h,this.a=this.c(P)),this.a}}e.$ye=s;class R{get cachedValues(){return this.a}constructor(P){this.b=P,this.a=new Map}get(P){if(this.a.has(P))return this.a.get(P);const h=this.b(P);return this.a.set(P,h),h}}e.$ze=R}),define(ie[61],ne([0,1,14,2]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=void 0;function s(E){const l=E;return l?typeof l.read=="function":!1}e.$Zd=s;function R(E){const l=E;return l?[l.on,l.pause,l.resume,l.destroy].every(i=>typeof i=="function"):!1}e.$1d=R;function C(E){const l=E;return l?R(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.$2d=C;function P(E,l){return new h(E,l)}e.$3d=P;class h{constructor(l,i){this.e=l,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(l){if(!this.a.destroyed){if(this.a.flowing)this.g(l);else if(this.b.data.push(l),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(l){this.a.destroyed||(this.a.flowing?this.h(l):this.b.error.push(l))}end(l){this.a.destroyed||(typeof l<"u"&&this.write(l),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(l){this.c.data.slice(0).forEach(i=>i(l))}h(l){this.c.error.length===0?(0,S.$1)(l):this.c.error.slice(0).forEach(i=>i(l))}i(){this.c.end.slice(0).forEach(l=>l())}on(l,i){if(!this.a.destroyed)switch(l){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(l,i){if(this.a.destroyed)return;let a;switch(l){case"data":a=this.c.data;break;case"end":a=this.c.end;break;case"error":a=this.c.error;break}if(a){const r=a.indexOf(i);r>=0&&a.splice(r,1)}}j(){if(this.b.data.length>0){const l=this.e(this.b.data);this.g(l),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(a=>a())}}k(){if(this.c.error.length>0){for(const l of this.b.error)this.h(l);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(E,l){const i=[];let a;for(;(a=E.read())!==null;)i.push(a);return l(i)}e.$4d=c;function g(E,l,i){const a=[];let r;for(;(r=E.read())!==null&&a.length<i;)a.push(r);return r===null&&a.length>0?l(a):{read:()=>{if(a.length>0)return a.shift();if(typeof r<"u"){const t=r;return r=void 0,t}return E.read()}}}e.$5d=g;function b(E,l){return new Promise((i,a)=>{const r=[];y(E,{onData:t=>{l&&r.push(t)},onError:t=>{l?a(t):i(void 0)},onEnd:()=>{i(l?l(r):void 0)}})})}e.$6d=b;function y(E,l,i){E.on("error",a=>{i?.isCancellationRequested||l.onError(a)}),E.on("end",()=>{i?.isCancellationRequested||l.onEnd()}),E.on("data",a=>{i?.isCancellationRequested||l.onData(a)})}e.$7d=y;function f(E,l){return new Promise((i,a)=>{const r=new A.$Rc,t=[],n=O=>{if(t.push(O),t.length>l)return r.dispose(),E.pause(),i({stream:E,buffer:t,ended:!1})},o=O=>(r.dispose(),a(O)),p=()=>(r.dispose(),i({stream:E,buffer:t,ended:!0}));r.add((0,A.$Qc)(()=>E.removeListener("error",o))),E.on("error",o),r.add((0,A.$Qc)(()=>E.removeListener("end",p))),E.on("end",p),r.add((0,A.$Qc)(()=>E.removeListener("data",n))),E.on("data",n)})}e.$8d=f;function v(E,l){const i=P(l);return i.end(E),i}e.$9d=v;function m(){const E=P(()=>{throw new Error("not supported")});return E.end(),E}e.$0d=m;function w(E){let l=!1;return{read:()=>l?null:(l=!0,E)}}e.$$d=w;function $(E,l,i){const a=P(i);return y(E,{onData:r=>a.write(l.data(r)),onError:r=>a.error(l.error?l.error(r):r),onEnd:()=>a.end()}),a}e.$_d=$;function d(E,l,i){let a=!1;return{read:()=>{const r=l.read();return a?r:(a=!0,r!==null?i([E,r]):E)}}}e.$ae=d;function u(E,l,i){let a=!1;const r=P(i);return y(l,{onData:t=>a?r.write(t):(a=!0,r.write(i([E,t]))),onError:t=>r.error(t),onEnd:()=>{a||(a=!0,r.write(E)),r.end()}}),r}e.$be=u}),define(ie[17],ne([0,1,71,61]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=void 0;const s=typeof Buffer<"u",R=new S.$V(()=>new Uint8Array(256));let C,P;class h{static alloc(I){return s?new h(Buffer.allocUnsafe(I)):new h(new Uint8Array(I))}static wrap(I){return s&&!Buffer.isBuffer(I)&&(I=Buffer.from(I.buffer,I.byteOffset,I.byteLength)),new h(I)}static fromString(I,j){return!(j?.dontUseNodeBuffer||!1)&&s?new h(Buffer.from(I)):(C||(C=new TextEncoder),new h(C.encode(I)))}static fromByteArray(I){const j=h.alloc(I.length);for(let U=0,z=I.length;U<z;U++)j.buffer[U]=I[U];return j}static concat(I,j){if(typeof j>"u"){j=0;for(let x=0,Z=I.length;x<Z;x++)j+=I[x].byteLength}const U=h.alloc(j);let z=0;for(let x=0,Z=I.length;x<Z;x++){const ae=I[x];U.set(ae,z),z+=ae.byteLength}return U}constructor(I){this.buffer=I,this.byteLength=this.buffer.byteLength}clone(){const I=h.alloc(this.byteLength);return I.set(this),I}toString(){return s?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(I,j){return new h(this.buffer.subarray(I,j))}set(I,j){if(I instanceof h)this.buffer.set(I.buffer,j);else if(I instanceof Uint8Array)this.buffer.set(I,j);else if(I instanceof ArrayBuffer)this.buffer.set(new Uint8Array(I),j);else if(ArrayBuffer.isView(I))this.buffer.set(new Uint8Array(I.buffer,I.byteOffset,I.byteLength),j);else throw new Error("Unknown argument 'array'")}readUInt32BE(I){return y(this.buffer,I)}writeUInt32BE(I,j){f(this.buffer,I,j)}readUInt32LE(I){return v(this.buffer,I)}writeUInt32LE(I,j){m(this.buffer,I,j)}readUInt8(I){return w(this.buffer,I)}writeUInt8(I,j){$(this.buffer,I,j)}indexOf(I,j=0){return c(this.buffer,I instanceof h?I.buffer:I,j)}}e.$ce=h;function c(k,I,j=0){const U=I.byteLength,z=k.byteLength;if(U===0)return 0;if(U===1)return k.indexOf(I[0]);if(U>z-j)return-1;const x=R.value;x.fill(I.length);for(let ce=0;ce<I.length;ce++)x[I[ce]]=I.length-ce-1;let Z=j+I.length-1,ae=Z,se=-1;for(;Z<z;)if(k[Z]===I[ae]){if(ae===0){se=Z;break}Z--,ae--}else Z+=Math.max(I.length-ae,x[k[Z]]),ae=I.length-1;return se}e.$de=c;function g(k,I){return k[I+0]<<0>>>0|k[I+1]<<8>>>0}e.$ee=g;function b(k,I,j){k[j+0]=I&255,I=I>>>8,k[j+1]=I&255}e.$fe=b;function y(k,I){return k[I]*2**24+k[I+1]*2**16+k[I+2]*2**8+k[I+3]}e.$ge=y;function f(k,I,j){k[j+3]=I,I=I>>>8,k[j+2]=I,I=I>>>8,k[j+1]=I,I=I>>>8,k[j]=I}e.$he=f;function v(k,I){return k[I+0]<<0>>>0|k[I+1]<<8>>>0|k[I+2]<<16>>>0|k[I+3]<<24>>>0}e.$ie=v;function m(k,I,j){k[j+0]=I&255,I=I>>>8,k[j+1]=I&255,I=I>>>8,k[j+2]=I&255,I=I>>>8,k[j+3]=I&255}e.$je=m;function w(k,I){return k[I]}e.$ke=w;function $(k,I,j){k[j]=I}e.$le=$;function d(k){return A.$4d(k,I=>h.concat(I))}e.$me=d;function u(k){return A.$$d(k)}e.$ne=u;function E(k){return A.$6d(k,I=>h.concat(I))}e.$oe=E;async function l(k){return k.ended?h.concat(k.buffer):h.concat([...k.buffer,await E(k.stream)])}e.$pe=l;function i(k){return A.$9d(k,I=>h.concat(I))}e.$qe=i;function a(k){return A.$_d(k,{data:I=>typeof I=="string"?h.fromString(I):h.wrap(I)},I=>h.concat(I))}e.$re=a;function r(k){return A.$3d(I=>h.concat(I),k)}e.$se=r;function t(k,I){return A.$ae(k,I,j=>h.concat(j))}e.$te=t;function n(k,I){return A.$be(k,I,j=>h.concat(j))}e.$ue=n;function o(k){let I=0,j=0,U=0;const z=new Uint8Array(Math.floor(k.length/4*3)),x=ae=>{switch(j){case 3:z[U++]=I|ae,j=0;break;case 2:z[U++]=I|ae>>>2,I=ae<<6,j=3;break;case 1:z[U++]=I|ae>>>4,I=ae<<4,j=2;break;default:I=ae<<2,j=1}};for(let ae=0;ae<k.length;ae++){const se=k.charCodeAt(ae);if(se>=65&&se<=90)x(se-65);else if(se>=97&&se<=122)x(se-97+26);else if(se>=48&&se<=57)x(se-48+52);else if(se===43||se===45)x(62);else if(se===47||se===95)x(63);else{if(se===61)break;throw new SyntaxError(`Unexpected base64 character ${k[ae]}`)}}const Z=U;for(;j>0;)x(0);return h.wrap(z).slice(0,Z)}e.$ve=o;const p="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",O="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function D({buffer:k},I=!0,j=!1){const U=j?O:p;let z="";const x=k.byteLength%3;let Z=0;for(;Z<k.byteLength-x;Z+=3){const ae=k[Z+0],se=k[Z+1],ce=k[Z+2];z+=U[ae>>>2],z+=U[(ae<<4|se>>>4)&63],z+=U[(se<<2|ce>>>6)&63],z+=U[ce&63]}if(x===1){const ae=k[Z+0];z+=U[ae>>>2],z+=U[ae<<4&63],I&&(z+="==")}else if(x===2){const ae=k[Z+0],se=k[Z+1];z+=U[ae>>>2],z+=U[(ae<<4|se>>>4)&63],z+=U[se<<2&63],I&&(z+="=")}return z}e.$we=D}),define(ie[27],ne([0,1,142,71]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yf=e.$xf=e.$wf=e.$vf=e.GraphemeBreakType=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=void 0;function s(ee){return!ee||typeof ee!="string"?!0:ee.trim().length===0}e.$Ce=s;const R=/{(\d+)}/g;function C(ee,...fe){return fe.length===0?ee:ee.replace(R,function($e,ke){const De=parseInt(ke,10);return isNaN(De)||De<0||De>=fe.length?$e:fe[De]})}e.$De=C;const P=/{([^}]+)}/g;function h(ee,fe){return Object.keys(fe).length===0?ee:ee.replace(P,($e,ke)=>fe[ke]??$e)}e.$Ee=h;function c(ee){return ee.replace(/[<>&]/g,function(fe){switch(fe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return fe}})}e.$Fe=c;function g(ee){return ee.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Ge=g;function b(ee,fe){let $e=0;const ke=fe.charCodeAt(0);for(let De=ee.length-1;De>=0;De--)ee.charCodeAt(De)===ke&&$e++;return $e}e.$He=b;function y(ee,fe,$e="\u2026"){return ee.length<=fe?ee:`${ee.substr(0,fe)}${$e}`}e.$Ie=y;function f(ee,fe=" "){const $e=v(ee,fe);return m($e,fe)}e.$Je=f;function v(ee,fe){if(!ee||!fe)return ee;const $e=fe.length;if($e===0||ee.length===0)return ee;let ke=0;for(;ee.indexOf(fe,ke)===ke;)ke=ke+$e;return ee.substring(ke)}e.$Ke=v;function m(ee,fe){if(!ee||!fe)return ee;const $e=fe.length,ke=ee.length;if($e===0||ke===0)return ee;let De=ke,Ne=-1;for(;Ne=ee.lastIndexOf(fe,De-1),!(Ne===-1||Ne+$e!==De);){if(Ne===0)return"";De=Ne}return ee.substring(0,De)}e.$Le=m;function w(ee){return ee.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Me=w;function $(ee){return ee.replace(/\*/g,"")}e.$Ne=$;function d(ee,fe,$e={}){if(!ee)throw new Error("Cannot create regex from empty string");fe||(ee=g(ee)),$e.wholeWord&&(/\B/.test(ee.charAt(0))||(ee="\\b"+ee),/\B/.test(ee.charAt(ee.length-1))||(ee=ee+"\\b"));let ke="";return $e.global&&(ke+="g"),$e.matchCase||(ke+="i"),$e.multiline&&(ke+="m"),$e.unicode&&(ke+="u"),new RegExp(ee,ke)}e.$Oe=d;function u(ee){return ee.source==="^"||ee.source==="^$"||ee.source==="$"||ee.source==="^\\s*$"?!1:!!(ee.exec("")&&ee.lastIndex===0)}e.$Pe=u;function E(ee){return ee.split(/\r\n|\r|\n/)}e.$Qe=E;function l(ee){for(let fe=0,$e=ee.length;fe<$e;fe++){const ke=ee.charCodeAt(fe);if(ke!==32&&ke!==9)return fe}return-1}e.$Re=l;function i(ee,fe=0,$e=ee.length){for(let ke=fe;ke<$e;ke++){const De=ee.charCodeAt(ke);if(De!==32&&De!==9)return ee.substring(fe,ke)}return ee.substring(fe,$e)}e.$Se=i;function a(ee,fe=ee.length-1){for(let $e=fe;$e>=0;$e--){const ke=ee.charCodeAt($e);if(ke!==32&&ke!==9)return $e}return-1}e.$Te=a;function r(ee,fe,$e){const ke=[];let De=0;for(const Ne of ee.matchAll(fe)){if(ke.push(ee.slice(De,Ne.index)),Ne.index===void 0)throw new Error("match.index should be defined");De=Ne.index+Ne[0].length,ke.push($e(Ne[0],...Ne.slice(1),Ne.index,ee,Ne.groups))}return ke.push(ee.slice(De)),Promise.all(ke).then(Ne=>Ne.join(""))}e.$Ue=r;function t(ee,fe){return ee<fe?-1:ee>fe?1:0}e.$Ve=t;function n(ee,fe,$e=0,ke=ee.length,De=0,Ne=fe.length){for(;$e<ke&&De<Ne;$e++,De++){const Ve=ee.charCodeAt($e),Ge=fe.charCodeAt(De);if(Ve<Ge)return-1;if(Ve>Ge)return 1}const je=ke-$e,Fe=Ne-De;return je<Fe?-1:je>Fe?1:0}e.$We=n;function o(ee,fe){return p(ee,fe,0,ee.length,0,fe.length)}e.$Xe=o;function p(ee,fe,$e=0,ke=ee.length,De=0,Ne=fe.length){for(;$e<ke&&De<Ne;$e++,De++){let Ve=ee.charCodeAt($e),Ge=fe.charCodeAt(De);if(Ve===Ge)continue;if(Ve>=128||Ge>=128)return n(ee.toLowerCase(),fe.toLowerCase(),$e,ke,De,Ne);D(Ve)&&(Ve-=32),D(Ge)&&(Ge-=32);const Qe=Ve-Ge;if(Qe!==0)return Qe}const je=ke-$e,Fe=Ne-De;return je<Fe?-1:je>Fe?1:0}e.$Ye=p;function O(ee){return ee>=48&&ee<=57}e.$Ze=O;function D(ee){return ee>=97&&ee<=122}e.$1e=D;function k(ee){return ee>=65&&ee<=90}e.$2e=k;function I(ee,fe){return ee.length===fe.length&&p(ee,fe)===0}e.$3e=I;function j(ee,fe){const $e=fe.length;return fe.length>ee.length?!1:p(ee,fe,0,$e)===0}e.$4e=j;function U(ee,fe){const $e=Math.min(ee.length,fe.length);let ke;for(ke=0;ke<$e;ke++)if(ee.charCodeAt(ke)!==fe.charCodeAt(ke))return ke;return $e}e.$5e=U;function z(ee,fe){const $e=Math.min(ee.length,fe.length);let ke;const De=ee.length-1,Ne=fe.length-1;for(ke=0;ke<$e;ke++)if(ee.charCodeAt(De-ke)!==fe.charCodeAt(Ne-ke))return ke;return $e}e.$6e=z;function x(ee){return 55296<=ee&&ee<=56319}e.$7e=x;function Z(ee){return 56320<=ee&&ee<=57343}e.$8e=Z;function ae(ee,fe){return(ee-55296<<10)+(fe-56320)+65536}e.$9e=ae;function se(ee,fe,$e){const ke=ee.charCodeAt($e);if(x(ke)&&$e+1<fe){const De=ee.charCodeAt($e+1);if(Z(De))return ae(ke,De)}return ke}e.$0e=se;function ce(ee,fe){const $e=ee.charCodeAt(fe-1);if(Z($e)&&fe>1){const ke=ee.charCodeAt(fe-2);if(x(ke))return ae(ke,$e)}return $e}class Y{get offset(){return this.e}constructor(fe,$e=0){this.c=fe,this.d=fe.length,this.e=$e}setOffset(fe){this.e=fe}prevCodePoint(){const fe=ce(this.c,this.e);return this.e-=fe>=65536?2:1,fe}nextCodePoint(){const fe=se(this.c,this.d,this.e);return this.e+=fe>=65536?2:1,fe}eol(){return this.e>=this.d}}e.$$e=Y;class K{get offset(){return this.c.offset}constructor(fe,$e=0){this.c=new Y(fe,$e)}nextGraphemeLength(){const fe=le.getInstance(),$e=this.c,ke=$e.offset;let De=fe.getGraphemeBreakType($e.nextCodePoint());for(;!$e.eol();){const Ne=$e.offset,je=fe.getGraphemeBreakType($e.nextCodePoint());if(we(De,je)){$e.setOffset(Ne);break}De=je}return $e.offset-ke}prevGraphemeLength(){const fe=le.getInstance(),$e=this.c,ke=$e.offset;let De=fe.getGraphemeBreakType($e.prevCodePoint());for(;$e.offset>0;){const Ne=$e.offset,je=fe.getGraphemeBreakType($e.prevCodePoint());if(we(je,De)){$e.setOffset(Ne);break}De=je}return ke-$e.offset}eol(){return this.c.eol()}}e.$_e=K;function Q(ee,fe){return new K(ee,fe).nextGraphemeLength()}e.$af=Q;function q(ee,fe){return new K(ee,fe).prevGraphemeLength()}e.$bf=q;function W(ee,fe){fe>0&&Z(ee.charCodeAt(fe))&&fe--;const $e=fe+Q(ee,fe);return[$e-q(ee,$e),$e]}e.$cf=W;function G(ee){const fe=new K(ee);let $e=0;for(;!fe.eol();)$e++,fe.nextGraphemeLength();return $e}e.$df=G;let H;function X(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function re(ee){return H||(H=X()),H.test(ee)}e.$ef=re;const L=/^[\t\n\r\x20-\x7E]*$/;function M(ee){return L.test(ee)}e.$ff=M,e.$gf=/[\u2028\u2029]/;function N(ee){return e.$gf.test(ee)}e.$hf=N;function T(ee){return ee>=11904&&ee<=55215||ee>=63744&&ee<=64255||ee>=65281&&ee<=65374}e.$if=T;function F(ee){return ee>=127462&&ee<=127487||ee===8986||ee===8987||ee===9200||ee===9203||ee>=9728&&ee<=10175||ee===11088||ee===11093||ee>=127744&&ee<=128591||ee>=128640&&ee<=128764||ee>=128992&&ee<=129008||ee>=129280&&ee<=129535||ee>=129648&&ee<=129782}e.$jf=F;function B(ee,fe){if(ee.length<fe)return ee;const $e=/\b/g;let ke=0;for(;$e.test(ee)&&!(ee.length-$e.lastIndex<fe);)ke=$e.lastIndex,$e.lastIndex+=1;return ee.substring(ke).replace(/^\s/,"")}e.$kf=B;const V=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,oe=/\x1b\].*?\x07/g;function de(ee){return ee&&(ee=ee.replace(V,"").replace(oe,"")),ee}e.$lf=de,e.$mf=String.fromCharCode(65279);function ue(ee){return!!(ee&&ee.length>0&&ee.charCodeAt(0)===65279)}e.$nf=ue;function he(ee){return ue(ee)?ee.substr(1):ee}e.$of=he;function ve(ee,fe){if(!ee||!fe||ee.length<fe.length)return!1;const $e=fe.length,ke=ee.toLowerCase();let De=0,Ne=-1;for(;De<$e;){const je=ke.indexOf(fe[De],Ne+1);if(je<0)return!1;Ne=je,De++}return!0}e.$pf=ve;function be(ee,fe=!1){return ee?(fe&&(ee=ee.replace(/\\./g,"")),ee.toLowerCase()!==ee):!1}e.$qf=be;function ye(ee){return ee.charAt(0).toUpperCase()+ee.slice(1)}e.$rf=ye;function Ie(ee,fe=1){if(fe===0)return"";let $e=-1;do $e=ee.indexOf(`
`,$e+1),fe--;while(fe>0&&$e>=0);return $e===-1?ee:(ee[$e-1]==="\r"&&$e--,ee.substr(0,$e))}e.$sf=Ie;function Te(ee){return ee=ee%(2*26),ee<26?String.fromCharCode(97+ee):String.fromCharCode(65+ee-26)}e.$tf=Te;function me(ee){return le.getInstance().getGraphemeBreakType(ee)}e.$uf=me;function we(ee,fe){return ee===0?fe!==5&&fe!==7:ee===2&&fe===3?!1:ee===4||ee===2||ee===3||fe===4||fe===2||fe===3?!0:!(ee===8&&(fe===8||fe===9||fe===11||fe===12)||(ee===11||ee===9)&&(fe===9||fe===10)||(ee===12||ee===10)&&fe===10||fe===5||fe===13||fe===7||ee===1||ee===13&&fe===14||ee===6&&fe===6)}var _;(function(ee){ee[ee.Other=0]="Other",ee[ee.Prepend=1]="Prepend",ee[ee.CR=2]="CR",ee[ee.LF=3]="LF",ee[ee.Control=4]="Control",ee[ee.Extend=5]="Extend",ee[ee.Regional_Indicator=6]="Regional_Indicator",ee[ee.SpacingMark=7]="SpacingMark",ee[ee.L=8]="L",ee[ee.V=9]="V",ee[ee.T=10]="T",ee[ee.LV=11]="LV",ee[ee.LVT=12]="LVT",ee[ee.ZWJ=13]="ZWJ",ee[ee.Extended_Pictographic=14]="Extended_Pictographic"})(_||(e.GraphemeBreakType=_={}));class le{static{this.c=null}static getInstance(){return le.c||(le.c=new le),le.c}constructor(){this.d=ge()}getGraphemeBreakType(fe){if(fe<32)return fe===10?3:fe===13?2:4;if(fe<127)return 0;const $e=this.d,ke=$e.length/3;let De=1;for(;De<=ke;)if(fe<$e[3*De])De=2*De;else if(fe>$e[3*De+1])De=2*De+1;else return $e[3*De+2];return 0}}function ge(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Oe(ee,fe){if(ee===0)return 0;const $e=Ce(ee,fe);if($e!==void 0)return $e;const ke=new Y(fe,ee);return ke.prevCodePoint(),ke.offset}e.$vf=Oe;function Ce(ee,fe){const $e=new Y(fe,ee);let ke=$e.prevCodePoint();for(;Le(ke)||ke===65039||ke===8419;){if($e.offset===0)return;ke=$e.prevCodePoint()}if(!F(ke))return;let De=$e.offset;return De>0&&$e.prevCodePoint()===8205&&(De=$e.offset),De}function Le(ee){return 127995<=ee&&ee<=127999}var Re;(function(ee){ee[ee.zwj=8205]="zwj",ee[ee.emojiVariantSelector=65039]="emojiVariantSelector",ee[ee.enclosingKeyCap=8419]="enclosingKeyCap"})(Re||(Re={})),e.$wf="\xA0";class He{static{this.c=new A.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new S.$ye(fe=>{function $e(Qe){const Ze=new Map;for(let Xe=0;Xe<Qe.length;Xe+=2)Ze.set(Qe[Xe],Qe[Xe+1]);return Ze}function ke(Qe,Ze){const Xe=new Map(Qe);for(const[it,nt]of Ze)Xe.set(it,nt);return Xe}function De(Qe,Ze){if(!Qe)return Ze;const Xe=new Map;for(const[it,nt]of Qe)Ze.has(it)&&Xe.set(it,nt);return Xe}const Ne=this.c.value;let je=fe.filter(Qe=>!Qe.startsWith("_")&&Qe in Ne);je.length===0&&(je=["_default"]);let Fe;for(const Qe of je){const Ze=$e(Ne[Qe]);Fe=De(Fe,Ze)}const Ve=$e(Ne._common),Ge=ke(Ve,Fe);return new He(Ge)})}static getInstance(fe){return He.d.get(Array.from(fe))}static{this.e=new A.$V(()=>Object.keys(He.c.value).filter(fe=>!fe.startsWith("_")))}static getLocales(){return He.e.value}constructor(fe){this.f=fe}isAmbiguous(fe){return this.f.has(fe)}getPrimaryConfusable(fe){return this.f.get(fe)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$xf=He;class ze{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(ze.c())),this.d}static isInvisibleCharacter(fe){return ze.e().has(fe)}static get codePoints(){return ze.e()}}e.$yf=ze}),define(ie[55],ne([0,1,27]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=void 0;function A($){return s($,0)}e.$Ei=A;function s($,d){switch(typeof $){case"object":return $===null?R(349,d):Array.isArray($)?h($,d):c($,d);case"string":return P($,d);case"boolean":return C($,d);case"number":return R($,d);case"undefined":return R(937,d);default:return R(617,d)}}e.$Fi=s;function R($,d){return(d<<5)-d+$|0}e.$Gi=R;function C($,d){return R($?433:863,d)}function P($,d){d=R(149417,d);for(let u=0,E=$.length;u<E;u++)d=R($.charCodeAt(u),d);return d}e.$Hi=P;function h($,d){return d=R(104579,d),$.reduce((u,E)=>s(E,u),d)}function c($,d){return d=R(181387,d),Object.keys($).sort().reduce((u,E)=>(u=P(E,u),s($[E],u)),d)}class g{constructor(){this.g=0}get value(){return this.g}hash(d){return this.g=s(d,this.g),this.g}}e.$Ii=g;var b;(function($){$[$.BLOCK_SIZE=64]="BLOCK_SIZE",$[$.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(b||(b={}));function y($,d,u=32){const E=u-d,l=~((1<<E)-1);return($<<d|(l&$)>>>E)>>>0}function f($,d=0,u=$.byteLength,E=0){for(let l=0;l<u;l++)$[d+l]=E}function v($,d,u="0"){for(;$.length<d;)$=u+$;return $}function m($,d=32){return $ instanceof ArrayBuffer?Array.from(new Uint8Array($)).map(u=>u.toString(16).padStart(2,"0")).join(""):v(($>>>0).toString(16),d/4)}e.$Ji=m;class w{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(d){const u=d.length;if(u===0)return;const E=this.p;let l=this.r,i=this.u,a,r;for(i!==0?(a=i,r=-1,i=0):(a=d.charCodeAt(0),r=0);;){let t=a;if(S.$7e(a))if(r+1<u){const n=d.charCodeAt(r+1);S.$8e(n)?(r++,t=S.$9e(a,n)):t=65533}else{i=a;break}else S.$8e(a)&&(t=65533);if(l=this.w(E,l,t),r++,r<u)a=d.charCodeAt(r);else break}this.r=l,this.u=i}w(d,u,E){return E<128?d[u++]=E:E<2048?(d[u++]=192|(E&1984)>>>6,d[u++]=128|(E&63)>>>0):E<65536?(d[u++]=224|(E&61440)>>>12,d[u++]=128|(E&4032)>>>6,d[u++]=128|(E&63)>>>0):(d[u++]=240|(E&1835008)>>>18,d[u++]=128|(E&258048)>>>12,d[u++]=128|(E&4032)>>>6,d[u++]=128|(E&63)>>>0),u>=64&&(this.y(),u-=64,this.t+=64,d[0]=d[64+0],d[1]=d[64+1],d[2]=d[64+2]),u}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),m(this.h)+m(this.l)+m(this.m)+m(this.n)+m(this.o)}x(){this.p[this.r++]=128,f(this.p,this.r),this.r>56&&(this.y(),f(this.p));const d=8*this.t;this.q.setUint32(56,Math.floor(d/4294967296),!1),this.q.setUint32(60,d%4294967296,!1),this.y()}y(){const d=w.g,u=this.q;for(let p=0;p<64;p+=4)d.setUint32(p,u.getUint32(p,!1),!1);for(let p=64;p<320;p+=4)d.setUint32(p,y(d.getUint32(p-12,!1)^d.getUint32(p-32,!1)^d.getUint32(p-56,!1)^d.getUint32(p-64,!1),1),!1);let E=this.h,l=this.l,i=this.m,a=this.n,r=this.o,t,n,o;for(let p=0;p<80;p++)p<20?(t=l&i|~l&a,n=1518500249):p<40?(t=l^i^a,n=1859775393):p<60?(t=l&i|l&a|i&a,n=2400959708):(t=l^i^a,n=3395469782),o=y(E,5)+t+r+n+d.getUint32(p*4,!1)&4294967295,r=a,a=i,i=y(l,30),l=E,E=o;this.h=this.h+E&4294967295,this.l=this.l+l&4294967295,this.m=this.m+i&4294967295,this.n=this.n+a&4294967295,this.o=this.o+r&4294967295}}e.$Ki=w}),define(ie[73],ne([0,1,27]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var A;(function(s){s[s.Ignore=0]="Ignore",s[s.Info=1]="Info",s[s.Warning=2]="Warning",s[s.Error=3]="Error"})(A||(A={})),function(s){const R="error",C="warning",P="warn",h="info",c="ignore";function g(y){return y?S.$3e(R,y)?s.Error:S.$3e(C,y)||S.$3e(P,y)?s.Warning:S.$3e(h,y)?s.Info:s.Ignore:s.Ignore}s.fromValue=g;function b(y){switch(y){case s.Error:return R;case s.Warning:return C;case s.Info:return h;default:return c}}s.toString=b}(A||(A={})),e.default=A}),define(ie[143],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ld=void 0,e.$Ld=Symbol("MicrotaskDelay")}),define(ie[56],ne([0,1,23,27]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=void 0;class s{constructor(){this.b="",this.c=0}reset(f){return this.b=f,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(f){const v=f.charCodeAt(0),m=this.b.charCodeAt(this.c);return v-m}value(){return this.b[this.c]}}e.$Sh=s;class R{constructor(f=!0){this.e=f}reset(f){return this.b=f,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let f=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(f)this.c++;else break;else f=!1;return this}cmp(f){return this.e?(0,A.$We)(f,this.b,0,f.length,this.c,this.d):(0,A.$Ye)(f,this.b,0,f.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Th=R;class C{constructor(f=!0,v=!0){this.f=f,this.g=v}reset(f){this.d=0,this.e=0,this.b=f,this.c=f.length;for(let v=f.length-1;v>=0;v--,this.c--){const m=this.b.charCodeAt(v);if(!(m===47||this.f&&m===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let f=!0;for(;this.e<this.c;this.e++){const v=this.b.charCodeAt(this.e);if(v===47||this.f&&v===92)if(f)this.d++;else break;else f=!1}return this}cmp(f){return this.g?(0,A.$We)(f,this.b,0,f.length,this.d,this.e):(0,A.$Ye)(f,this.b,0,f.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Uh=C;var P;(function(y){y[y.Scheme=1]="Scheme",y[y.Authority=2]="Authority",y[y.Path=3]="Path",y[y.Query=4]="Query",y[y.Fragment=5]="Fragment"})(P||(P={}));class h{constructor(f,v){this.f=f,this.g=v,this.d=[],this.e=0}reset(f){return this.c=f,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new C(!1,!this.f(f)),this.b.reset(f.path),this.b.value()&&this.d.push(3)),this.g(f)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(f){if(this.d[this.e]===1)return(0,A.$Xe)(f,this.c.scheme);if(this.d[this.e]===2)return(0,A.$Xe)(f,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(f);if(this.d[this.e]===4)return(0,A.$Ve)(f,this.c.query);if(this.d[this.e]===5)return(0,A.$Ve)(f,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Vh=h;class c{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const f=this.right;return this.right=f.left,f.left=this,this.updateHeight(),f.updateHeight(),f}rotateRight(){const f=this.left;return this.left=f.right,f.right=this,this.updateHeight(),f.updateHeight(),f}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var g;(function(y){y[y.Left=-1]="Left",y[y.Mid=0]="Mid",y[y.Right=1]="Right"})(g||(g={}));class b{static forUris(f=()=>!1,v=()=>!1){return new b(new h(f,v))}static forPaths(f=!1){return new b(new C(void 0,!f))}static forStrings(){return new b(new s)}static forConfigKeys(){return new b(new R)}constructor(f){this.b=f}clear(){this.c=void 0}fill(f,v){if(v){const m=v.slice(0);(0,S.$Xb)(m);for(const w of m)this.set(w,f)}else{const m=f.slice(0);(0,S.$Xb)(m);for(const w of m)this.set(w[0],w[1])}}set(f,v){const m=this.b.reset(f);let w;this.c||(this.c=new c,this.c.segment=m.value());const $=[];for(w=this.c;;){const u=m.cmp(w.segment);if(u>0)w.left||(w.left=new c,w.left.segment=m.value()),$.push([-1,w]),w=w.left;else if(u<0)w.right||(w.right=new c,w.right.segment=m.value()),$.push([1,w]),w=w.right;else if(m.hasNext())m.next(),w.mid||(w.mid=new c,w.mid.segment=m.value()),$.push([0,w]),w=w.mid;else break}const d=w.value;w.value=v,w.key=f;for(let u=$.length-1;u>=0;u--){const E=$[u][1];E.updateHeight();const l=E.balanceFactor();if(l<-1||l>1){const i=$[u][0],a=$[u+1][0];if(i===1&&a===1)$[u][1]=E.rotateLeft();else if(i===-1&&a===-1)$[u][1]=E.rotateRight();else if(i===1&&a===-1)E.right=$[u+1][1]=$[u+1][1].rotateRight(),$[u][1]=E.rotateLeft();else if(i===-1&&a===1)E.left=$[u+1][1]=$[u+1][1].rotateLeft(),$[u][1]=E.rotateRight();else throw new Error;if(u>0)switch($[u-1][0]){case-1:$[u-1][1].left=$[u][1];break;case 1:$[u-1][1].right=$[u][1];break;case 0:$[u-1][1].mid=$[u][1];break}else this.c=$[0][1]}}return d}get(f){return this.d(f)?.value}d(f){const v=this.b.reset(f);let m=this.c;for(;m;){const w=v.cmp(m.segment);if(w>0)m=m.left;else if(w<0)m=m.right;else if(v.hasNext())v.next(),m=m.mid;else break}return m}has(f){const v=this.d(f);return!(v?.value===void 0&&v?.mid===void 0)}delete(f){return this.e(f,!1)}deleteSuperstr(f){return this.e(f,!0)}e(f,v){const m=this.b.reset(f),w=[];let $=this.c;for(;$;){const d=m.cmp($.segment);if(d>0)w.push([-1,$]),$=$.left;else if(d<0)w.push([1,$]),$=$.right;else if(m.hasNext())m.next(),w.push([0,$]),$=$.mid;else break}if($){if(v?($.left=void 0,$.mid=void 0,$.right=void 0,$.height=1):($.key=void 0,$.value=void 0),!$.mid&&!$.value)if($.left&&$.right){const d=this.f($.right);if(d.key){const{key:u,value:E,segment:l}=d;this.e(d.key,!1),$.key=u,$.value=E,$.segment=l}}else{const d=$.left??$.right;if(w.length>0){const[u,E]=w[w.length-1];switch(u){case-1:E.left=d;break;case 0:E.mid=d;break;case 1:E.right=d;break}}else this.c=d}for(let d=w.length-1;d>=0;d--){const u=w[d][1];u.updateHeight();const E=u.balanceFactor();if(E>1?(u.right.balanceFactor()>=0||(u.right=u.right.rotateRight()),w[d][1]=u.rotateLeft()):E<-1&&(u.left.balanceFactor()<=0||(u.left=u.left.rotateLeft()),w[d][1]=u.rotateRight()),d>0)switch(w[d-1][0]){case-1:w[d-1][1].left=w[d][1];break;case 1:w[d-1][1].right=w[d][1];break;case 0:w[d-1][1].mid=w[d][1];break}else this.c=w[0][1]}}}f(f){for(;f.left;)f=f.left;return f}findSubstr(f){const v=this.b.reset(f);let m=this.c,w;for(;m;){const $=v.cmp(m.segment);if($>0)m=m.left;else if($<0)m=m.right;else if(v.hasNext())v.next(),w=m.value||w,m=m.mid;else break}return m&&m.value||w}findSuperstr(f){return this.g(f,!1)}g(f,v){const m=this.b.reset(f);let w=this.c;for(;w;){const $=m.cmp(w.segment);if($>0)w=w.left;else if($<0)w=w.right;else if(m.hasNext())m.next(),w=w.mid;else return w.mid?this.h(w.mid):v?w.value:void 0}}hasElementOrSubtree(f){return this.g(f,!0)!==void 0}forEach(f){for(const[v,m]of this)f(m,v)}*[Symbol.iterator](){yield*this.h(this.c)}h(f){const v=[];return this.j(f,v),v[Symbol.iterator]()}j(f,v){f&&(f.left&&this.j(f.left,v),f.value&&v.push([f.key,f.value]),f.mid&&this.j(f.mid,v),f.right&&this.j(f.right,v))}_isBalanced(){const f=v=>{if(!v)return!0;const m=v.balanceFactor();return m<-1||m>1?!1:f(v.left)&&f(v.right)};return f(this.c)}}e.$Wh=b}),define(ie[12],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=void 0;function S(l){return typeof l=="string"}e.$zf=S;function A(l){return Array.isArray(l)&&l.every(i=>S(i))}e.$Af=A;function s(l){return typeof l=="object"&&l!==null&&!Array.isArray(l)&&!(l instanceof RegExp)&&!(l instanceof Date)}e.$Bf=s;function R(l){const i=Object.getPrototypeOf(Uint8Array);return typeof l=="object"&&l instanceof i}e.$Cf=R;function C(l){return typeof l=="number"&&!isNaN(l)}e.$Df=C;function P(l){return!!l&&typeof l[Symbol.iterator]=="function"}e.$Ef=P;function h(l){return l===!0||l===!1}e.$Ff=h;function c(l){return typeof l>"u"}e.$Gf=c;function g(l){return!b(l)}e.$Hf=g;function b(l){return c(l)||l===null}e.$If=b;function y(l,i){if(!l)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.$Jf=y;function f(l){if(b(l))throw new Error("Assertion Failed: argument is undefined or null");return l}e.$Kf=f;function v(...l){const i=[];for(let a=0;a<l.length;a++){const r=l[a];if(b(r))throw new Error(`Assertion Failed: argument at index ${a} is undefined or null`);i.push(r)}return i}e.$Lf=v;const m=Object.prototype.hasOwnProperty;function w(l){if(!s(l))return!1;for(const i in l)if(m.call(l,i))return!1;return!0}e.$Mf=w;function $(l){return typeof l=="function"}e.$Nf=$;function d(...l){return l.length>0&&l.every($)}e.$Of=d;function u(l,i){const a=Math.min(l.length,i.length);for(let r=0;r<a;r++)E(l[r],i[r])}e.$Pf=u;function E(l,i){if(S(i)){if(typeof l!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if($(i)){try{if(l instanceof i)return}catch{}if(!b(l)&&l.constructor===i||i.length===1&&i.call(void 0,l)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Qf=E}),define(ie[74],ne([0,1,12]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vj=e.$Uj=e.$Tj=void 0;const A=Object.create(null);function s(P,h){if((0,S.$zf)(h)){const c=A[h];if(c===void 0)throw new Error(`${P} references an unknown codicon: ${h}`);h=c}return A[P]=h,{id:P}}function R(){return A}e.$Tj=R;function C(){return Object.values(e.$Vj)}e.$Uj=C,e.$Vj={add:s("add",6e4),plus:s("plus",6e4),gistNew:s("gist-new",6e4),repoCreate:s("repo-create",6e4),lightbulb:s("lightbulb",60001),lightBulb:s("light-bulb",60001),repo:s("repo",60002),repoDelete:s("repo-delete",60002),gistFork:s("gist-fork",60003),repoForked:s("repo-forked",60003),gitPullRequest:s("git-pull-request",60004),gitPullRequestAbandoned:s("git-pull-request-abandoned",60004),recordKeys:s("record-keys",60005),keyboard:s("keyboard",60005),tag:s("tag",60006),tagAdd:s("tag-add",60006),tagRemove:s("tag-remove",60006),gitPullRequestLabel:s("git-pull-request-label",60006),person:s("person",60007),personFollow:s("person-follow",60007),personOutline:s("person-outline",60007),personFilled:s("person-filled",60007),gitBranch:s("git-branch",60008),gitBranchCreate:s("git-branch-create",60008),gitBranchDelete:s("git-branch-delete",60008),sourceControl:s("source-control",60008),mirror:s("mirror",60009),mirrorPublic:s("mirror-public",60009),star:s("star",60010),starAdd:s("star-add",60010),starDelete:s("star-delete",60010),starEmpty:s("star-empty",60010),comment:s("comment",60011),commentAdd:s("comment-add",60011),alert:s("alert",60012),warning:s("warning",60012),search:s("search",60013),searchSave:s("search-save",60013),logOut:s("log-out",60014),signOut:s("sign-out",60014),logIn:s("log-in",60015),signIn:s("sign-in",60015),eye:s("eye",60016),eyeUnwatch:s("eye-unwatch",60016),eyeWatch:s("eye-watch",60016),circleFilled:s("circle-filled",60017),primitiveDot:s("primitive-dot",60017),closeDirty:s("close-dirty",60017),debugBreakpoint:s("debug-breakpoint",60017),debugBreakpointDisabled:s("debug-breakpoint-disabled",60017),debugHint:s("debug-hint",60017),primitiveSquare:s("primitive-square",60018),edit:s("edit",60019),pencil:s("pencil",60019),info:s("info",60020),issueOpened:s("issue-opened",60020),gistPrivate:s("gist-private",60021),gitForkPrivate:s("git-fork-private",60021),lock:s("lock",60021),mirrorPrivate:s("mirror-private",60021),close:s("close",60022),removeClose:s("remove-close",60022),x:s("x",60022),repoSync:s("repo-sync",60023),sync:s("sync",60023),clone:s("clone",60024),desktopDownload:s("desktop-download",60024),beaker:s("beaker",60025),microscope:s("microscope",60025),vm:s("vm",60026),deviceDesktop:s("device-desktop",60026),file:s("file",60027),fileText:s("file-text",60027),more:s("more",60028),ellipsis:s("ellipsis",60028),kebabHorizontal:s("kebab-horizontal",60028),mailReply:s("mail-reply",60029),reply:s("reply",60029),organization:s("organization",60030),organizationFilled:s("organization-filled",60030),organizationOutline:s("organization-outline",60030),newFile:s("new-file",60031),fileAdd:s("file-add",60031),newFolder:s("new-folder",60032),fileDirectoryCreate:s("file-directory-create",60032),trash:s("trash",60033),trashcan:s("trashcan",60033),history:s("history",60034),clock:s("clock",60034),folder:s("folder",60035),fileDirectory:s("file-directory",60035),symbolFolder:s("symbol-folder",60035),logoGithub:s("logo-github",60036),markGithub:s("mark-github",60036),github:s("github",60036),terminal:s("terminal",60037),console:s("console",60037),repl:s("repl",60037),zap:s("zap",60038),symbolEvent:s("symbol-event",60038),error:s("error",60039),stop:s("stop",60039),variable:s("variable",60040),symbolVariable:s("symbol-variable",60040),array:s("array",60042),symbolArray:s("symbol-array",60042),symbolModule:s("symbol-module",60043),symbolPackage:s("symbol-package",60043),symbolNamespace:s("symbol-namespace",60043),symbolObject:s("symbol-object",60043),symbolMethod:s("symbol-method",60044),symbolFunction:s("symbol-function",60044),symbolConstructor:s("symbol-constructor",60044),symbolBoolean:s("symbol-boolean",60047),symbolNull:s("symbol-null",60047),symbolNumeric:s("symbol-numeric",60048),symbolNumber:s("symbol-number",60048),symbolStructure:s("symbol-structure",60049),symbolStruct:s("symbol-struct",60049),symbolParameter:s("symbol-parameter",60050),symbolTypeParameter:s("symbol-type-parameter",60050),symbolKey:s("symbol-key",60051),symbolText:s("symbol-text",60051),symbolReference:s("symbol-reference",60052),goToFile:s("go-to-file",60052),symbolEnum:s("symbol-enum",60053),symbolValue:s("symbol-value",60053),symbolRuler:s("symbol-ruler",60054),symbolUnit:s("symbol-unit",60054),activateBreakpoints:s("activate-breakpoints",60055),archive:s("archive",60056),arrowBoth:s("arrow-both",60057),arrowDown:s("arrow-down",60058),arrowLeft:s("arrow-left",60059),arrowRight:s("arrow-right",60060),arrowSmallDown:s("arrow-small-down",60061),arrowSmallLeft:s("arrow-small-left",60062),arrowSmallRight:s("arrow-small-right",60063),arrowSmallUp:s("arrow-small-up",60064),arrowUp:s("arrow-up",60065),bell:s("bell",60066),bold:s("bold",60067),book:s("book",60068),bookmark:s("bookmark",60069),debugBreakpointConditionalUnverified:s("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:s("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:s("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:s("debug-breakpoint-data-unverified",60072),debugBreakpointData:s("debug-breakpoint-data",60073),debugBreakpointDataDisabled:s("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:s("debug-breakpoint-log-unverified",60074),debugBreakpointLog:s("debug-breakpoint-log",60075),debugBreakpointLogDisabled:s("debug-breakpoint-log-disabled",60075),briefcase:s("briefcase",60076),broadcast:s("broadcast",60077),browser:s("browser",60078),bug:s("bug",60079),calendar:s("calendar",60080),caseSensitive:s("case-sensitive",60081),check:s("check",60082),checklist:s("checklist",60083),chevronDown:s("chevron-down",60084),dropDownButton:s("drop-down-button",60084),chevronLeft:s("chevron-left",60085),chevronRight:s("chevron-right",60086),chevronUp:s("chevron-up",60087),chromeClose:s("chrome-close",60088),chromeMaximize:s("chrome-maximize",60089),chromeMinimize:s("chrome-minimize",60090),chromeRestore:s("chrome-restore",60091),circle:s("circle",60092),circleOutline:s("circle-outline",60092),debugBreakpointUnverified:s("debug-breakpoint-unverified",60092),circleSlash:s("circle-slash",60093),circuitBoard:s("circuit-board",60094),clearAll:s("clear-all",60095),clippy:s("clippy",60096),closeAll:s("close-all",60097),cloudDownload:s("cloud-download",60098),cloudUpload:s("cloud-upload",60099),code:s("code",60100),collapseAll:s("collapse-all",60101),colorMode:s("color-mode",60102),commentDiscussion:s("comment-discussion",60103),compareChanges:s("compare-changes",60157),creditCard:s("credit-card",60105),dash:s("dash",60108),dashboard:s("dashboard",60109),database:s("database",60110),debugContinue:s("debug-continue",60111),debugDisconnect:s("debug-disconnect",60112),debugPause:s("debug-pause",60113),debugRestart:s("debug-restart",60114),debugStart:s("debug-start",60115),debugStepInto:s("debug-step-into",60116),debugStepOut:s("debug-step-out",60117),debugStepOver:s("debug-step-over",60118),debugStop:s("debug-stop",60119),debug:s("debug",60120),deviceCameraVideo:s("device-camera-video",60121),deviceCamera:s("device-camera",60122),deviceMobile:s("device-mobile",60123),diffAdded:s("diff-added",60124),diffIgnored:s("diff-ignored",60125),diffModified:s("diff-modified",60126),diffRemoved:s("diff-removed",60127),diffRenamed:s("diff-renamed",60128),diff:s("diff",60129),discard:s("discard",60130),editorLayout:s("editor-layout",60131),emptyWindow:s("empty-window",60132),exclude:s("exclude",60133),extensions:s("extensions",60134),eyeClosed:s("eye-closed",60135),fileBinary:s("file-binary",60136),fileCode:s("file-code",60137),fileMedia:s("file-media",60138),filePdf:s("file-pdf",60139),fileSubmodule:s("file-submodule",60140),fileSymlinkDirectory:s("file-symlink-directory",60141),fileSymlinkFile:s("file-symlink-file",60142),fileZip:s("file-zip",60143),files:s("files",60144),filter:s("filter",60145),flame:s("flame",60146),foldDown:s("fold-down",60147),foldUp:s("fold-up",60148),fold:s("fold",60149),folderActive:s("folder-active",60150),folderOpened:s("folder-opened",60151),gear:s("gear",60152),gift:s("gift",60153),gistSecret:s("gist-secret",60154),gist:s("gist",60155),gitCommit:s("git-commit",60156),gitCompare:s("git-compare",60157),gitMerge:s("git-merge",60158),githubAction:s("github-action",60159),githubAlt:s("github-alt",60160),globe:s("globe",60161),grabber:s("grabber",60162),graph:s("graph",60163),gripper:s("gripper",60164),heart:s("heart",60165),home:s("home",60166),horizontalRule:s("horizontal-rule",60167),hubot:s("hubot",60168),inbox:s("inbox",60169),issueClosed:s("issue-closed",60324),issueReopened:s("issue-reopened",60171),issues:s("issues",60172),italic:s("italic",60173),jersey:s("jersey",60174),json:s("json",60175),bracket:s("bracket",60175),kebabVertical:s("kebab-vertical",60176),key:s("key",60177),law:s("law",60178),lightbulbAutofix:s("lightbulb-autofix",60179),linkExternal:s("link-external",60180),link:s("link",60181),listOrdered:s("list-ordered",60182),listUnordered:s("list-unordered",60183),liveShare:s("live-share",60184),loading:s("loading",60185),location:s("location",60186),mailRead:s("mail-read",60187),mail:s("mail",60188),markdown:s("markdown",60189),megaphone:s("megaphone",60190),mention:s("mention",60191),milestone:s("milestone",60192),gitPullRequestMilestone:s("git-pull-request-milestone",60192),mortarBoard:s("mortar-board",60193),move:s("move",60194),multipleWindows:s("multiple-windows",60195),mute:s("mute",60196),noNewline:s("no-newline",60197),note:s("note",60198),octoface:s("octoface",60199),openPreview:s("open-preview",60200),package:s("package",60201),paintcan:s("paintcan",60202),pin:s("pin",60203),play:s("play",60204),run:s("run",60204),plug:s("plug",60205),preserveCase:s("preserve-case",60206),preview:s("preview",60207),project:s("project",60208),pulse:s("pulse",60209),question:s("question",60210),quote:s("quote",60211),radioTower:s("radio-tower",60212),reactions:s("reactions",60213),references:s("references",60214),refresh:s("refresh",60215),regex:s("regex",60216),remoteExplorer:s("remote-explorer",60217),remote:s("remote",60218),remove:s("remove",60219),replaceAll:s("replace-all",60220),replace:s("replace",60221),repoClone:s("repo-clone",60222),repoForcePush:s("repo-force-push",60223),repoPull:s("repo-pull",60224),repoPush:s("repo-push",60225),report:s("report",60226),requestChanges:s("request-changes",60227),rocket:s("rocket",60228),rootFolderOpened:s("root-folder-opened",60229),rootFolder:s("root-folder",60230),rss:s("rss",60231),ruby:s("ruby",60232),saveAll:s("save-all",60233),saveAs:s("save-as",60234),save:s("save",60235),screenFull:s("screen-full",60236),screenNormal:s("screen-normal",60237),searchStop:s("search-stop",60238),server:s("server",60240),settingsGear:s("settings-gear",60241),settings:s("settings",60242),shield:s("shield",60243),smiley:s("smiley",60244),sortPrecedence:s("sort-precedence",60245),splitHorizontal:s("split-horizontal",60246),splitVertical:s("split-vertical",60247),squirrel:s("squirrel",60248),starFull:s("star-full",60249),starHalf:s("star-half",60250),symbolClass:s("symbol-class",60251),symbolColor:s("symbol-color",60252),symbolCustomColor:s("symbol-customcolor",60252),symbolConstant:s("symbol-constant",60253),symbolEnumMember:s("symbol-enum-member",60254),symbolField:s("symbol-field",60255),symbolFile:s("symbol-file",60256),symbolInterface:s("symbol-interface",60257),symbolKeyword:s("symbol-keyword",60258),symbolMisc:s("symbol-misc",60259),symbolOperator:s("symbol-operator",60260),symbolProperty:s("symbol-property",60261),wrench:s("wrench",60261),wrenchSubaction:s("wrench-subaction",60261),symbolSnippet:s("symbol-snippet",60262),tasklist:s("tasklist",60263),telescope:s("telescope",60264),textSize:s("text-size",60265),threeBars:s("three-bars",60266),thumbsdown:s("thumbsdown",60267),thumbsup:s("thumbsup",60268),tools:s("tools",60269),triangleDown:s("triangle-down",60270),triangleLeft:s("triangle-left",60271),triangleRight:s("triangle-right",60272),triangleUp:s("triangle-up",60273),twitter:s("twitter",60274),unfold:s("unfold",60275),unlock:s("unlock",60276),unmute:s("unmute",60277),unverified:s("unverified",60278),verified:s("verified",60279),versions:s("versions",60280),vmActive:s("vm-active",60281),vmOutline:s("vm-outline",60282),vmRunning:s("vm-running",60283),watch:s("watch",60284),whitespace:s("whitespace",60285),wholeWord:s("whole-word",60286),window:s("window",60287),wordWrap:s("word-wrap",60288),zoomIn:s("zoom-in",60289),zoomOut:s("zoom-out",60290),listFilter:s("list-filter",60291),listFlat:s("list-flat",60292),listSelection:s("list-selection",60293),selection:s("selection",60293),listTree:s("list-tree",60294),debugBreakpointFunctionUnverified:s("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:s("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:s("debug-breakpoint-function-disabled",60296),debugStackframeActive:s("debug-stackframe-active",60297),circleSmallFilled:s("circle-small-filled",60298),debugStackframeDot:s("debug-stackframe-dot",60298),debugStackframe:s("debug-stackframe",60299),debugStackframeFocused:s("debug-stackframe-focused",60299),debugBreakpointUnsupported:s("debug-breakpoint-unsupported",60300),symbolString:s("symbol-string",60301),debugReverseContinue:s("debug-reverse-continue",60302),debugStepBack:s("debug-step-back",60303),debugRestartFrame:s("debug-restart-frame",60304),callIncoming:s("call-incoming",60306),callOutgoing:s("call-outgoing",60307),menu:s("menu",60308),expandAll:s("expand-all",60309),feedback:s("feedback",60310),gitPullRequestReviewer:s("git-pull-request-reviewer",60310),groupByRefType:s("group-by-ref-type",60311),ungroupByRefType:s("ungroup-by-ref-type",60312),account:s("account",60313),gitPullRequestAssignee:s("git-pull-request-assignee",60313),bellDot:s("bell-dot",60314),debugConsole:s("debug-console",60315),library:s("library",60316),output:s("output",60317),runAll:s("run-all",60318),syncIgnored:s("sync-ignored",60319),pinned:s("pinned",60320),githubInverted:s("github-inverted",60321),debugAlt:s("debug-alt",60305),serverProcess:s("server-process",60322),serverEnvironment:s("server-environment",60323),pass:s("pass",60324),stopCircle:s("stop-circle",60325),playCircle:s("play-circle",60326),record:s("record",60327),debugAltSmall:s("debug-alt-small",60328),vmConnect:s("vm-connect",60329),cloud:s("cloud",60330),merge:s("merge",60331),exportIcon:s("export",60332),graphLeft:s("graph-left",60333),magnet:s("magnet",60334),notebook:s("notebook",60335),redo:s("redo",60336),checkAll:s("check-all",60337),pinnedDirty:s("pinned-dirty",60338),passFilled:s("pass-filled",60339),circleLargeFilled:s("circle-large-filled",60340),circleLarge:s("circle-large",60341),circleLargeOutline:s("circle-large-outline",60341),combine:s("combine",60342),gather:s("gather",60342),table:s("table",60343),variableGroup:s("variable-group",60344),typeHierarchy:s("type-hierarchy",60345),typeHierarchySub:s("type-hierarchy-sub",60346),typeHierarchySuper:s("type-hierarchy-super",60347),gitPullRequestCreate:s("git-pull-request-create",60348),runAbove:s("run-above",60349),runBelow:s("run-below",60350),notebookTemplate:s("notebook-template",60351),debugRerun:s("debug-rerun",60352),workspaceTrusted:s("workspace-trusted",60353),workspaceUntrusted:s("workspace-untrusted",60354),workspaceUnspecified:s("workspace-unspecified",60355),terminalCmd:s("terminal-cmd",60356),terminalDebian:s("terminal-debian",60357),terminalLinux:s("terminal-linux",60358),terminalPowershell:s("terminal-powershell",60359),terminalTmux:s("terminal-tmux",60360),terminalUbuntu:s("terminal-ubuntu",60361),terminalBash:s("terminal-bash",60362),arrowSwap:s("arrow-swap",60363),copy:s("copy",60364),personAdd:s("person-add",60365),filterFilled:s("filter-filled",60366),wand:s("wand",60367),debugLineByLine:s("debug-line-by-line",60368),inspect:s("inspect",60369),layers:s("layers",60370),layersDot:s("layers-dot",60371),layersActive:s("layers-active",60372),compass:s("compass",60373),compassDot:s("compass-dot",60374),compassActive:s("compass-active",60375),azure:s("azure",60376),issueDraft:s("issue-draft",60377),gitPullRequestClosed:s("git-pull-request-closed",60378),gitPullRequestDraft:s("git-pull-request-draft",60379),debugAll:s("debug-all",60380),debugCoverage:s("debug-coverage",60381),runErrors:s("run-errors",60382),folderLibrary:s("folder-library",60383),debugContinueSmall:s("debug-continue-small",60384),beakerStop:s("beaker-stop",60385),graphLine:s("graph-line",60386),graphScatter:s("graph-scatter",60387),pieChart:s("pie-chart",60388),bracketDot:s("bracket-dot",60389),bracketError:s("bracket-error",60390),lockSmall:s("lock-small",60391),azureDevops:s("azure-devops",60392),verifiedFilled:s("verified-filled",60393),newLine:s("newline",60394),layout:s("layout",60395),layoutActivitybarLeft:s("layout-activitybar-left",60396),layoutActivitybarRight:s("layout-activitybar-right",60397),layoutPanelLeft:s("layout-panel-left",60398),layoutPanelCenter:s("layout-panel-center",60399),layoutPanelJustify:s("layout-panel-justify",60400),layoutPanelRight:s("layout-panel-right",60401),layoutPanel:s("layout-panel",60402),layoutSidebarLeft:s("layout-sidebar-left",60403),layoutSidebarRight:s("layout-sidebar-right",60404),layoutStatusbar:s("layout-statusbar",60405),layoutMenubar:s("layout-menubar",60406),layoutCentered:s("layout-centered",60407),layoutSidebarRightOff:s("layout-sidebar-right-off",60416),layoutPanelOff:s("layout-panel-off",60417),layoutSidebarLeftOff:s("layout-sidebar-left-off",60418),target:s("target",60408),indent:s("indent",60409),recordSmall:s("record-small",60410),errorSmall:s("error-small",60411),arrowCircleDown:s("arrow-circle-down",60412),arrowCircleLeft:s("arrow-circle-left",60413),arrowCircleRight:s("arrow-circle-right",60414),arrowCircleUp:s("arrow-circle-up",60415),heartFilled:s("heart-filled",60420),map:s("map",60421),mapFilled:s("map-filled",60422),circleSmall:s("circle-small",60423),bellSlash:s("bell-slash",60424),bellSlashDot:s("bell-slash-dot",60425),commentUnresolved:s("comment-unresolved",60426),gitPullRequestGoToChanges:s("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:s("git-pull-request-new-changes",60428),searchFuzzy:s("search-fuzzy",60429),commentDraft:s("comment-draft",60430),send:s("send",60431),sparkle:s("sparkle",60432),insert:s("insert",60433),mic:s("mic",60434),dialogError:s("dialog-error","error"),dialogWarning:s("dialog-warning","warning"),dialogInfo:s("dialog-info","info"),dialogClose:s("dialog-close","close"),treeItemExpanded:s("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:s("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:s("tree-filter-on-type-off","list-selection"),treeFilterClear:s("tree-filter-clear","close"),treeItemLoading:s("tree-item-loading","loading"),menuSelection:s("menu-selection","check"),menuSubmenu:s("menu-submenu","chevron-right"),menuBarMore:s("menubar-more","more"),scrollbarButtonLeft:s("scrollbar-button-left","triangle-left"),scrollbarButtonRight:s("scrollbar-button-right","triangle-right"),scrollbarButtonUp:s("scrollbar-button-up","triangle-up"),scrollbarButtonDown:s("scrollbar-button-down","triangle-down"),toolBarMore:s("toolbar-more","more"),quickInputBack:s("quick-input-back","arrow-left")}}),define(ie[37],ne([0,1,12]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=void 0;function A(E){if(!E||typeof E!="object"||E instanceof RegExp)return E;const l=Array.isArray(E)?[]:{};return Object.entries(E).forEach(([i,a])=>{l[i]=a&&typeof a=="object"?A(a):a}),l}e.$8m=A;function s(E){if(!E||typeof E!="object")return E;const l=[E];for(;l.length>0;){const i=l.shift();Object.freeze(i);for(const a in i)if(R.call(i,a)){const r=i[a];typeof r=="object"&&!Object.isFrozen(r)&&!(0,S.$Cf)(r)&&l.push(r)}}return E}e.$9m=s;const R=Object.prototype.hasOwnProperty;function C(E,l){return P(E,l,new Set)}e.$0m=C;function P(E,l,i){if((0,S.$If)(E))return E;const a=l(E);if(typeof a<"u")return a;if(Array.isArray(E)){const r=[];for(const t of E)r.push(P(t,l,i));return r}if((0,S.$Bf)(E)){if(i.has(E))throw new Error("Cannot clone recursive data-structure");i.add(E);const r={};for(const t in E)R.call(E,t)&&(r[t]=P(E[t],l,i));return i.delete(E),r}return E}function h(E,l,i=!0){return(0,S.$Bf)(E)?((0,S.$Bf)(l)&&Object.keys(l).forEach(a=>{a in E?i&&((0,S.$Bf)(E[a])&&(0,S.$Bf)(l[a])?h(E[a],l[a],i):E[a]=l[a]):E[a]=l[a]}),E):l}e.$$m=h;function c(E,l){if(E===l)return!0;if(E==null||l===null||l===void 0||typeof E!=typeof l||typeof E!="object"||Array.isArray(E)!==Array.isArray(l))return!1;let i,a;if(Array.isArray(E)){if(E.length!==l.length)return!1;for(i=0;i<E.length;i++)if(!c(E[i],l[i]))return!1}else{const r=[];for(a in E)r.push(a);r.sort();const t=[];for(a in l)t.push(a);if(t.sort(),!c(r,t))return!1;for(i=0;i<r.length;i++)if(!c(E[r[i]],l[r[i]]))return!1}return!0}e.$_m=c;function g(E){const l=new Set;return JSON.stringify(E,(i,a)=>{if((0,S.$Bf)(a)||Array.isArray(a)){if(l.has(a))return"[Circular]";l.add(a)}return a})}e.$an=g;function b(E,l){const i=Object.create(null);return!E||!l||Object.keys(l).forEach(r=>{const t=E[r],n=l[r];c(t,n)||(i[r]=n)}),i}e.$bn=b;function y(E,l){const i=l.toLowerCase(),a=Object.keys(E).find(r=>r.toLowerCase()===i);return a?E[a]:E[l]}e.$cn=y;function f(E,l){const i=Object.create(null);for(const[a,r]of Object.entries(E))l(a,r)&&(i[a]=r);return i}e.$dn=f;function v(E){let l=[];for(;Object.prototype!==E;)l=l.concat(Object.getOwnPropertyNames(E)),E=Object.getPrototypeOf(E);return l}e.$en=v;function m(E){const l=[];for(const i of v(E))typeof E[i]=="function"&&l.push(i);return l}e.$fn=m;function w(E,l){const i=r=>function(){const t=Array.prototype.slice.call(arguments,0);return l(r,t)},a={};for(const r of E)a[r]=i(r);return a}e.$gn=w;function $(E,l,i){typeof l=="string"&&E[l]!==void 0&&typeof E[l]!="boolean"&&(E[l]=i)}e.$hn=$;function d(E,l,i){typeof l=="string"&&E[l]!==void 0&&typeof E[l]!="number"&&(E[l]=i)}e.$in=d;function u(E,l,i,a){if(typeof l!="string")return;const r=E[l];r!==void 0&&(typeof r!="string"||!i.includes(r))&&(E[l]=a)}e.$jn=u}),define(ie[102],ne([0,1,74]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Wj=e.ThemeColor=void 0;var A;(function(C){function P(h){return h&&typeof h=="object"&&typeof h.id=="string"}C.isThemeColor=P})(A||(e.ThemeColor=A={}));function s(C){return{id:C}}e.$Wj=s;var R;(function(C){C.iconNameSegment="[A-Za-z0-9]+",C.iconNameExpression="[A-Za-z0-9-]+",C.iconModifierExpression="~[A-Za-z]+",C.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${C.iconNameExpression})(${C.iconModifierExpression})?$`);function h(d){const u=P.exec(d.id);if(!u)return h(S.$Vj.error);const[,E,l]=u,i=["codicon","codicon-"+E];return l&&i.push("codicon-modifier-"+l.substring(1)),i}C.asClassNameArray=h;function c(d){return h(d).join(" ")}C.asClassName=c;function g(d){return"."+h(d).join(".")}C.asCSSSelector=g;function b(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(typeof d.color>"u"||A.isThemeColor(d.color))}C.isThemeIcon=b;const y=new RegExp(`^\\$\\((${C.iconNameExpression}(?:${C.iconModifierExpression})?)\\)$`);function f(d){const u=y.exec(d);if(!u)return;const[,E]=u;return{id:E}}C.fromString=f;function v(d){return{id:d}}C.fromId=v;function m(d,u){let E=d.id;const l=E.lastIndexOf("~");return l!==-1&&(E=E.substring(0,l)),u&&(E=`${E}~${u}`),{id:E}}C.modify=m;function w(d){const u=d.id.lastIndexOf("~");if(u!==-1)return d.id.substring(u+1)}C.getModifier=w;function $(d,u){return d.id===u.id&&d.color?.id===u.color?.id}C.isEqual=$})(R||(e.ThemeIcon=R={}))}),define(ie[32],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fg=e.$eg=void 0;const S=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function A(s){return S.test(s)}e.$eg=A,e.$fg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let s;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?s=crypto.getRandomValues.bind(crypto):s=function(P){for(let h=0;h<P.length;h++)P[h]=Math.floor(Math.random()*256);return P};const R=new Uint8Array(16),C=[];for(let P=0;P<256;P++)C.push(P.toString(16).padStart(2,"0"));return function(){s(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let h=0,c="";return c+=C[R[h++]],c+=C[R[h++]],c+=C[R[h++]],c+=C[R[h++]],c+="-",c+=C[R[h++]],c+=C[R[h++]],c+="-",c+=C[R[h++]],c+=C[R[h++]],c+="-",c+=C[R[h++]],c+=C[R[h++]],c+="-",c+=C[R[h++]],c+=C[R[h++]],c+=C[R[h++]],c+=C[R[h++]],c+=C[R[h++]],c+=C[R[h++]],c}}()}),define(ie[144],ne([0,1,85,45,83]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pT=void 0;async function R(C,P){if(await new Promise((g,b)=>{const y=A.createReadStream(C),f=S.createHash("sha1");y.pipe(f);const v=(0,s.$db)((m,w)=>{y.removeAllListeners(),f.removeAllListeners(),m?b(m):g(w)});y.once("error",v),y.once("end",v),f.once("error",v),f.once("data",m=>v(void 0,m.toString("hex")))})!==P)throw new Error("Hash mismatch")}e.$pT=R}),define(ie[145],ne([0,1,28]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rm=void 0;const A=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function s(C){const P=C.replace(/\-/g,":").toLowerCase();return!A.has(P)}function R(){const C=(0,S.networkInterfaces)();for(const P in C){const h=C[P];if(h){for(const{mac:c}of h)if(s(c))return c}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$Rm=R}),define(ie[103],ne([0,1,86]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jg=e.$ig=e.$hg=void 0;function A(P,h,c,g=1){let b=!1;return new Promise(y=>{const f=setTimeout(()=>{if(!b)return b=!0,y(0)},c);s(P,h,g,v=>{if(!b)return b=!0,clearTimeout(f),y(v)})})}e.$hg=A;function s(P,h,c,g){if(h===0)return g(0);const b=new S.Socket;b.once("connect",()=>(C(b),s(P+c,h-1,c,g))),b.once("data",()=>{}),b.once("error",y=>(C(b),y.code!=="ECONNREFUSED"?s(P+c,h-1,c,g):g(P))),b.connect(P,"127.0.0.1")}e.$ig={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(P,h,c,g="127.0.0.1"){let b=!1,y,f=1;const v=S.createServer({pauseOnConnect:!0});function m(w,$){b||(b=!0,v.removeAllListeners(),v.close(),y&&clearTimeout(y),$(w))}return new Promise(w=>{y=setTimeout(()=>{m(0,w)},c),v.on("listening",()=>{m(P,w)}),v.on("error",$=>{$&&($.code==="EADDRINUSE"||$.code==="EACCES")&&f<h?(P++,f++,v.listen(P,g)):m(0,w)}),v.on("close",()=>{m(0,w)}),v.listen(P,g)})}e.$jg=R;function C(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(h){console.error(h)}}}),function(){function J(){function e(){return process.uncHostAllowlist}function S(h){const c=new Set;if(Array.isArray(h))for(const g of h)typeof g=="string"&&c.add(g);return Array.from(c)}function A(){const h=e();return h?Array.from(h):[]}function s(h){if(process.platform!=="win32")return;const c=e();if(c)if(typeof h=="string")c.add(h.toLowerCase());else for(const g of S(h))s(g)}function R(h){if(typeof h!="string")return;const c=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let g;for(const b of c){if(h.indexOf(b)!==0)continue;const f=h.indexOf("\\",b.length);if(f===-1)continue;const v=h.substring(b.length,f);if(v){g=v;break}}return g}function C(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function P(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:A,addUNCHostToAllowlist:s,getUNCHost:R,disableUNCAccessRestrictions:C,isUNCAccessRestrictionsDisabled:P}}typeof define=="function"?define("vs/base/node/unc",[],function(){return J()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=J():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(ie[146],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tT=e.$sT=void 0,e.$sT="vscode:contextmenu",e.$tT="vscode:onCloseContextMenu"}),define(ie[147],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AT=void 0;class S{constructor(s,R){this.a=s,this.onMessage=R}send(s){try{this.a.send("vscode:message",s.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$AT=S}),define(ie[148],ne([11,10]),function(J,e){return J.create("vs/base/common/date",e)}),define(ie[149],ne([0,1,148]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fm=e.$em=void 0;const A=60,s=A*60,R=s*24,C=R*7,P=R*30,h=R*365;function c(b,y,f,v){typeof b!="number"&&(b=b.getTime());const m=Math.round((new Date().getTime()-b)/1e3);if(m<-30)return(0,S.localize)(0,null,c(new Date().getTime()+m*1e3,!1));if(!v&&m<30)return(0,S.localize)(1,null);let w;return m<A?(w=m,y?w===1?f?(0,S.localize)(2,null,w):(0,S.localize)(3,null,w):f?(0,S.localize)(4,null,w):(0,S.localize)(5,null,w):w===1?f?(0,S.localize)(6,null,w):(0,S.localize)(7,null,w):f?(0,S.localize)(8,null,w):(0,S.localize)(9,null,w)):m<s?(w=Math.floor(m/A),y?w===1?f?(0,S.localize)(10,null,w):(0,S.localize)(11,null,w):f?(0,S.localize)(12,null,w):(0,S.localize)(13,null,w):w===1?f?(0,S.localize)(14,null,w):(0,S.localize)(15,null,w):f?(0,S.localize)(16,null,w):(0,S.localize)(17,null,w)):m<R?(w=Math.floor(m/s),y?w===1?f?(0,S.localize)(18,null,w):(0,S.localize)(19,null,w):f?(0,S.localize)(20,null,w):(0,S.localize)(21,null,w):w===1?f?(0,S.localize)(22,null,w):(0,S.localize)(23,null,w):f?(0,S.localize)(24,null,w):(0,S.localize)(25,null,w)):m<C?(w=Math.floor(m/R),y?w===1?(0,S.localize)(26,null,w):(0,S.localize)(27,null,w):w===1?(0,S.localize)(28,null,w):(0,S.localize)(29,null,w)):m<P?(w=Math.floor(m/C),y?w===1?f?(0,S.localize)(30,null,w):(0,S.localize)(31,null,w):f?(0,S.localize)(32,null,w):(0,S.localize)(33,null,w):w===1?f?(0,S.localize)(34,null,w):(0,S.localize)(35,null,w):f?(0,S.localize)(36,null,w):(0,S.localize)(37,null,w)):m<h?(w=Math.floor(m/P),y?w===1?f?(0,S.localize)(38,null,w):(0,S.localize)(39,null,w):f?(0,S.localize)(40,null,w):(0,S.localize)(41,null,w):w===1?f?(0,S.localize)(42,null,w):(0,S.localize)(43,null,w):f?(0,S.localize)(44,null,w):(0,S.localize)(45,null,w)):(w=Math.floor(m/h),y?w===1?f?(0,S.localize)(46,null,w):(0,S.localize)(47,null,w):f?(0,S.localize)(48,null,w):(0,S.localize)(49,null,w):w===1?f?(0,S.localize)(50,null,w):(0,S.localize)(51,null,w):f?(0,S.localize)(52,null,w):(0,S.localize)(53,null,w))}e.$em=c;function g(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$fm=g}),define(ie[150],ne([11,10]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(ie[49],ne([0,1,23,12,150]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=e.$Ci=e.$Bi=void 0;function R(b,y){return y&&(b.stack||b.stacktrace)?s.localize(0,null,P(b),C(b.stack)||C(b.stacktrace)):P(b)}function C(b){return Array.isArray(b)?b.join(`
`):b}function P(b){return b.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${b.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?s.localize(1,null,b.message):b.message||s.localize(2,null)}function h(b=null,y=!1){if(!b)return s.localize(3,null);if(Array.isArray(b)){const f=S.$Hb(b),v=h(f[0],y);return f.length>1?s.localize(4,null,v,f.length):v}if(A.$zf(b))return b;if(b.detail){const f=b.detail;if(f.error)return R(f.error,y);if(f.exception)return R(f.exception,y)}return b.stack?R(b,y):b.message?b.message:s.localize(5,null)}e.$Bi=h;function c(b){const y=b;return y instanceof Error&&Array.isArray(y.actions)}e.$Ci=c;function g(b,y){let f;return typeof b=="string"?f=new Error(b):f=b,f.actions=y,f}e.$Di=g}),define(ie[151],ne([11,10]),function(J,e){return J.create("vs/base/common/jsonErrorMessages",e)}),define(ie[152],ne([0,1,151]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=void 0;function A(s){switch(s){case 1:return(0,S.localize)(0,null);case 2:return(0,S.localize)(1,null);case 3:return(0,S.localize)(2,null);case 4:return(0,S.localize)(3,null);case 5:return(0,S.localize)(4,null);case 6:return(0,S.localize)(5,null);case 7:return(0,S.localize)(6,null);case 8:return(0,S.localize)(7,null);case 9:return(0,S.localize)(8,null);default:return""}}e.$Ap=A}),define(ie[153],ne([11,10]),function(J,e){return J.create("vs/base/common/platform",e)}),define(ie[4],ne([0,1,153]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$h=e.$g=void 0,e.$g="en";let A=!1,s=!1,R=!1,C=!1,P=!1,h=!1,c=!1,g=!1,b=!1,y=!1,f,v=e.$g,m=e.$g,w,$;e.$h=typeof self=="object"?self:typeof global=="object"?global:{};let d;typeof e.$h.vscode<"u"&&typeof e.$h.vscode.process<"u"?d=e.$h.vscode.process:typeof process<"u"&&(d=process);const u=typeof d?.versions?.electron=="string",E=u&&d?.type==="renderer";if(typeof navigator=="object"&&!E)$=navigator.userAgent,A=$.indexOf("Windows")>=0,s=$.indexOf("Macintosh")>=0,g=($.indexOf("Macintosh")>=0||$.indexOf("iPad")>=0||$.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=$.indexOf("Linux")>=0,y=$?.indexOf("Mobi")>=0,h=!0,f=S.getConfiguredDefaultLocale(S.localize(0,null))||e.$g,v=f,m=navigator.language;else if(typeof d=="object"){A=d.platform==="win32",s=d.platform==="darwin",R=d.platform==="linux",C=R&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,c=u,b=!!d.env.CI||!!d.env.BUILD_ARTIFACTSTAGINGDIRECTORY,f=e.$g,v=e.$g;const O=d.env.VSCODE_NLS_CONFIG;if(O)try{const D=JSON.parse(O),k=D.availableLanguages["*"];f=D.locale,m=D.osLocale,v=k||e.$g,w=D._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var l;(function(O){O[O.Web=0]="Web",O[O.Mac=1]="Mac",O[O.Linux=2]="Linux",O[O.Windows=3]="Windows"})(l||(e.Platform=l={}));function i(O){switch(O){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$i=i;let a=0;s?a=1:A?a=3:R&&(a=2),e.$j=A,e.$k=s,e.$l=R,e.$m=C,e.$n=P,e.$o=c,e.$p=h,e.$q=h&&typeof e.$h.importScripts=="function",e.$r=g,e.$s=y,e.$t=b,e.$u=a,e.$v=$,e.$w=v;var r;(function(O){function D(){return e.$w}O.value=D;function k(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}O.isDefaultVariant=k;function I(){return e.$w==="en"}O.isDefault=I})(r||(e.Language=r={})),e.$x=f,e.$y=m,e.$z=w,e.$A=typeof e.$h.postMessage=="function"&&!e.$h.importScripts,e.$B=(()=>{if(e.$A){const O=[];e.$h.addEventListener("message",k=>{if(k.data&&k.data.vscodeScheduleAsyncWork)for(let I=0,j=O.length;I<j;I++){const U=O[I];if(U.id===k.data.vscodeScheduleAsyncWork){O.splice(I,1),U.callback();return}}});let D=0;return k=>{const I=++D;O.push({id:I,callback:k}),e.$h.postMessage({vscodeScheduleAsyncWork:I},"*")}}return O=>setTimeout(O)})();var t;(function(O){O[O.Windows=1]="Windows",O[O.Macintosh=2]="Macintosh",O[O.Linux=3]="Linux"})(t||(e.OperatingSystem=t={})),e.OS=s||g?2:A?1:3;let n=!0,o=!1;function p(){if(!o){o=!0;const O=new Uint8Array(2);O[0]=1,O[1]=2,n=new Uint16Array(O.buffer)[0]===(2<<8)+1}return n}e.$D=p,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0)}),define(ie[35],ne([0,1,4]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let A;if(typeof S.$h.vscode<"u"&&typeof S.$h.vscode.process<"u"){const s=S.$h.vscode.process;A={get platform(){return s.platform},get arch(){return s.arch},get env(){return s.env},cwd(){return s.cwd()}}}else typeof process<"u"?A={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:A={get platform(){return S.$j?"win32":S.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=A.cwd,e.env=A.env,e.$dc=A.platform,e.$ec=A.arch}),define(ie[9],ne([0,1,35]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const A=65,s=97,R=90,C=122,P=46,h=47,c=92,g=58,b=63;class y extends Error{constructor(a,r,t){let n;typeof r=="string"&&r.indexOf("not ")===0?(n="must not be",r=r.replace(/^not /,"")):n="must be";const o=a.indexOf(".")!==-1?"property":"argument";let p=`The "${a}" ${o} ${n} of type ${r}`;p+=`. Received type ${typeof t}`,super(p),this.code="ERR_INVALID_ARG_TYPE"}}function f(i,a){if(i===null||typeof i!="object")throw new y(a,"Object",i)}function v(i,a){if(typeof i!="string")throw new y(a,"string",i)}const m=S.$dc==="win32";function w(i){return i===h||i===c}function $(i){return i===h}function d(i){return i>=A&&i<=R||i>=s&&i<=C}function u(i,a,r,t){let n="",o=0,p=-1,O=0,D=0;for(let k=0;k<=i.length;++k){if(k<i.length)D=i.charCodeAt(k);else{if(t(D))break;D=h}if(t(D)){if(!(p===k-1||O===1))if(O===2){if(n.length<2||o!==2||n.charCodeAt(n.length-1)!==P||n.charCodeAt(n.length-2)!==P){if(n.length>2){const I=n.lastIndexOf(r);I===-1?(n="",o=0):(n=n.slice(0,I),o=n.length-1-n.lastIndexOf(r)),p=k,O=0;continue}else if(n.length!==0){n="",o=0,p=k,O=0;continue}}a&&(n+=n.length>0?`${r}..`:"..",o=2)}else n.length>0?n+=`${r}${i.slice(p+1,k)}`:n=i.slice(p+1,k),o=k-p-1;p=k,O=0}else D===P&&O!==-1?++O:O=-1}return n}function E(i,a){f(a,"pathObject");const r=a.dir||a.root,t=a.base||`${a.name||""}${a.ext||""}`;return r?r===a.root?`${r}${t}`:`${r}${i}${t}`:t}e.$fc={resolve(...i){let a="",r="",t=!1;for(let n=i.length-1;n>=-1;n--){let o;if(n>=0){if(o=i[n],v(o,"path"),o.length===0)continue}else a.length===0?o=S.cwd():(o=S.env[`=${a}`]||S.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==a.toLowerCase()&&o.charCodeAt(2)===c)&&(o=`${a}\\`));const p=o.length;let O=0,D="",k=!1;const I=o.charCodeAt(0);if(p===1)w(I)&&(O=1,k=!0);else if(w(I))if(k=!0,w(o.charCodeAt(1))){let j=2,U=j;for(;j<p&&!w(o.charCodeAt(j));)j++;if(j<p&&j!==U){const z=o.slice(U,j);for(U=j;j<p&&w(o.charCodeAt(j));)j++;if(j<p&&j!==U){for(U=j;j<p&&!w(o.charCodeAt(j));)j++;(j===p||j!==U)&&(D=`\\\\${z}\\${o.slice(U,j)}`,O=j)}}}else O=1;else d(I)&&o.charCodeAt(1)===g&&(D=o.slice(0,2),O=2,p>2&&w(o.charCodeAt(2))&&(k=!0,O=3));if(D.length>0)if(a.length>0){if(D.toLowerCase()!==a.toLowerCase())continue}else a=D;if(t){if(a.length>0)break}else if(r=`${o.slice(O)}\\${r}`,t=k,k&&a.length>0)break}return r=u(r,!t,"\\",w),t?`${a}\\${r}`:`${a}${r}`||"."},normalize(i){v(i,"path");const a=i.length;if(a===0)return".";let r=0,t,n=!1;const o=i.charCodeAt(0);if(a===1)return $(o)?"\\":i;if(w(o))if(n=!0,w(i.charCodeAt(1))){let O=2,D=O;for(;O<a&&!w(i.charCodeAt(O));)O++;if(O<a&&O!==D){const k=i.slice(D,O);for(D=O;O<a&&w(i.charCodeAt(O));)O++;if(O<a&&O!==D){for(D=O;O<a&&!w(i.charCodeAt(O));)O++;if(O===a)return`\\\\${k}\\${i.slice(D)}\\`;O!==D&&(t=`\\\\${k}\\${i.slice(D,O)}`,r=O)}}}else r=1;else d(o)&&i.charCodeAt(1)===g&&(t=i.slice(0,2),r=2,a>2&&w(i.charCodeAt(2))&&(n=!0,r=3));let p=r<a?u(i.slice(r),!n,"\\",w):"";return p.length===0&&!n&&(p="."),p.length>0&&w(i.charCodeAt(a-1))&&(p+="\\"),t===void 0?n?`\\${p}`:p:n?`${t}\\${p}`:`${t}${p}`},isAbsolute(i){v(i,"path");const a=i.length;if(a===0)return!1;const r=i.charCodeAt(0);return w(r)||a>2&&d(r)&&i.charCodeAt(1)===g&&w(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let a,r;for(let o=0;o<i.length;++o){const p=i[o];v(p,"path"),p.length>0&&(a===void 0?a=r=p:a+=`\\${p}`)}if(a===void 0)return".";let t=!0,n=0;if(typeof r=="string"&&w(r.charCodeAt(0))){++n;const o=r.length;o>1&&w(r.charCodeAt(1))&&(++n,o>2&&(w(r.charCodeAt(2))?++n:t=!1))}if(t){for(;n<a.length&&w(a.charCodeAt(n));)n++;n>=2&&(a=`\\${a.slice(n)}`)}return e.$fc.normalize(a)},relative(i,a){if(v(i,"from"),v(a,"to"),i===a)return"";const r=e.$fc.resolve(i),t=e.$fc.resolve(a);if(r===t||(i=r.toLowerCase(),a=t.toLowerCase(),i===a))return"";let n=0;for(;n<i.length&&i.charCodeAt(n)===c;)n++;let o=i.length;for(;o-1>n&&i.charCodeAt(o-1)===c;)o--;const p=o-n;let O=0;for(;O<a.length&&a.charCodeAt(O)===c;)O++;let D=a.length;for(;D-1>O&&a.charCodeAt(D-1)===c;)D--;const k=D-O,I=p<k?p:k;let j=-1,U=0;for(;U<I;U++){const x=i.charCodeAt(n+U);if(x!==a.charCodeAt(O+U))break;x===c&&(j=U)}if(U!==I){if(j===-1)return t}else{if(k>I){if(a.charCodeAt(O+U)===c)return t.slice(O+U+1);if(U===2)return t.slice(O+U)}p>I&&(i.charCodeAt(n+U)===c?j=U:U===2&&(j=3)),j===-1&&(j=0)}let z="";for(U=n+j+1;U<=o;++U)(U===o||i.charCodeAt(U)===c)&&(z+=z.length===0?"..":"\\..");return O+=j,z.length>0?`${z}${t.slice(O,D)}`:(t.charCodeAt(O)===c&&++O,t.slice(O,D))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const a=e.$fc.resolve(i);if(a.length<=2)return i;if(a.charCodeAt(0)===c){if(a.charCodeAt(1)===c){const r=a.charCodeAt(2);if(r!==b&&r!==P)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(d(a.charCodeAt(0))&&a.charCodeAt(1)===g&&a.charCodeAt(2)===c)return`\\\\?\\${a}`;return i},dirname(i){v(i,"path");const a=i.length;if(a===0)return".";let r=-1,t=0;const n=i.charCodeAt(0);if(a===1)return w(n)?i:".";if(w(n)){if(r=t=1,w(i.charCodeAt(1))){let O=2,D=O;for(;O<a&&!w(i.charCodeAt(O));)O++;if(O<a&&O!==D){for(D=O;O<a&&w(i.charCodeAt(O));)O++;if(O<a&&O!==D){for(D=O;O<a&&!w(i.charCodeAt(O));)O++;if(O===a)return i;O!==D&&(r=t=O+1)}}}}else d(n)&&i.charCodeAt(1)===g&&(r=a>2&&w(i.charCodeAt(2))?3:2,t=r);let o=-1,p=!0;for(let O=a-1;O>=t;--O)if(w(i.charCodeAt(O))){if(!p){o=O;break}}else p=!1;if(o===-1){if(r===-1)return".";o=r}return i.slice(0,o)},basename(i,a){a!==void 0&&v(a,"ext"),v(i,"path");let r=0,t=-1,n=!0,o;if(i.length>=2&&d(i.charCodeAt(0))&&i.charCodeAt(1)===g&&(r=2),a!==void 0&&a.length>0&&a.length<=i.length){if(a===i)return"";let p=a.length-1,O=-1;for(o=i.length-1;o>=r;--o){const D=i.charCodeAt(o);if(w(D)){if(!n){r=o+1;break}}else O===-1&&(n=!1,O=o+1),p>=0&&(D===a.charCodeAt(p)?--p===-1&&(t=o):(p=-1,t=O))}return r===t?t=O:t===-1&&(t=i.length),i.slice(r,t)}for(o=i.length-1;o>=r;--o)if(w(i.charCodeAt(o))){if(!n){r=o+1;break}}else t===-1&&(n=!1,t=o+1);return t===-1?"":i.slice(r,t)},extname(i){v(i,"path");let a=0,r=-1,t=0,n=-1,o=!0,p=0;i.length>=2&&i.charCodeAt(1)===g&&d(i.charCodeAt(0))&&(a=t=2);for(let O=i.length-1;O>=a;--O){const D=i.charCodeAt(O);if(w(D)){if(!o){t=O+1;break}continue}n===-1&&(o=!1,n=O+1),D===P?r===-1?r=O:p!==1&&(p=1):r!==-1&&(p=-1)}return r===-1||n===-1||p===0||p===1&&r===n-1&&r===t+1?"":i.slice(r,n)},format:E.bind(null,"\\"),parse(i){v(i,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return a;const r=i.length;let t=0,n=i.charCodeAt(0);if(r===1)return w(n)?(a.root=a.dir=i,a):(a.base=a.name=i,a);if(w(n)){if(t=1,w(i.charCodeAt(1))){let j=2,U=j;for(;j<r&&!w(i.charCodeAt(j));)j++;if(j<r&&j!==U){for(U=j;j<r&&w(i.charCodeAt(j));)j++;if(j<r&&j!==U){for(U=j;j<r&&!w(i.charCodeAt(j));)j++;j===r?t=j:j!==U&&(t=j+1)}}}}else if(d(n)&&i.charCodeAt(1)===g){if(r<=2)return a.root=a.dir=i,a;if(t=2,w(i.charCodeAt(2))){if(r===3)return a.root=a.dir=i,a;t=3}}t>0&&(a.root=i.slice(0,t));let o=-1,p=t,O=-1,D=!0,k=i.length-1,I=0;for(;k>=t;--k){if(n=i.charCodeAt(k),w(n)){if(!D){p=k+1;break}continue}O===-1&&(D=!1,O=k+1),n===P?o===-1?o=k:I!==1&&(I=1):o!==-1&&(I=-1)}return O!==-1&&(o===-1||I===0||I===1&&o===O-1&&o===p+1?a.base=a.name=i.slice(p,O):(a.name=i.slice(p,o),a.base=i.slice(p,O),a.ext=i.slice(o,O))),p>0&&p!==t?a.dir=i.slice(0,p-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null};const l=(()=>{if(m){const i=/\\/g;return()=>{const a=S.cwd().replace(i,"/");return a.slice(a.indexOf("/"))}}return()=>S.cwd()})();e.$gc={resolve(...i){let a="",r=!1;for(let t=i.length-1;t>=-1&&!r;t--){const n=t>=0?i[t]:l();v(n,"path"),n.length!==0&&(a=`${n}/${a}`,r=n.charCodeAt(0)===h)}return a=u(a,!r,"/",$),r?`/${a}`:a.length>0?a:"."},normalize(i){if(v(i,"path"),i.length===0)return".";const a=i.charCodeAt(0)===h,r=i.charCodeAt(i.length-1)===h;return i=u(i,!a,"/",$),i.length===0?a?"/":r?"./":".":(r&&(i+="/"),a?`/${i}`:i)},isAbsolute(i){return v(i,"path"),i.length>0&&i.charCodeAt(0)===h},join(...i){if(i.length===0)return".";let a;for(let r=0;r<i.length;++r){const t=i[r];v(t,"path"),t.length>0&&(a===void 0?a=t:a+=`/${t}`)}return a===void 0?".":e.$gc.normalize(a)},relative(i,a){if(v(i,"from"),v(a,"to"),i===a||(i=e.$gc.resolve(i),a=e.$gc.resolve(a),i===a))return"";const r=1,t=i.length,n=t-r,o=1,p=a.length-o,O=n<p?n:p;let D=-1,k=0;for(;k<O;k++){const j=i.charCodeAt(r+k);if(j!==a.charCodeAt(o+k))break;j===h&&(D=k)}if(k===O)if(p>O){if(a.charCodeAt(o+k)===h)return a.slice(o+k+1);if(k===0)return a.slice(o+k)}else n>O&&(i.charCodeAt(r+k)===h?D=k:k===0&&(D=0));let I="";for(k=r+D+1;k<=t;++k)(k===t||i.charCodeAt(k)===h)&&(I+=I.length===0?"..":"/..");return`${I}${a.slice(o+D)}`},toNamespacedPath(i){return i},dirname(i){if(v(i,"path"),i.length===0)return".";const a=i.charCodeAt(0)===h;let r=-1,t=!0;for(let n=i.length-1;n>=1;--n)if(i.charCodeAt(n)===h){if(!t){r=n;break}}else t=!1;return r===-1?a?"/":".":a&&r===1?"//":i.slice(0,r)},basename(i,a){a!==void 0&&v(a,"ext"),v(i,"path");let r=0,t=-1,n=!0,o;if(a!==void 0&&a.length>0&&a.length<=i.length){if(a===i)return"";let p=a.length-1,O=-1;for(o=i.length-1;o>=0;--o){const D=i.charCodeAt(o);if(D===h){if(!n){r=o+1;break}}else O===-1&&(n=!1,O=o+1),p>=0&&(D===a.charCodeAt(p)?--p===-1&&(t=o):(p=-1,t=O))}return r===t?t=O:t===-1&&(t=i.length),i.slice(r,t)}for(o=i.length-1;o>=0;--o)if(i.charCodeAt(o)===h){if(!n){r=o+1;break}}else t===-1&&(n=!1,t=o+1);return t===-1?"":i.slice(r,t)},extname(i){v(i,"path");let a=-1,r=0,t=-1,n=!0,o=0;for(let p=i.length-1;p>=0;--p){const O=i.charCodeAt(p);if(O===h){if(!n){r=p+1;break}continue}t===-1&&(n=!1,t=p+1),O===P?a===-1?a=p:o!==1&&(o=1):a!==-1&&(o=-1)}return a===-1||t===-1||o===0||o===1&&a===t-1&&a===r+1?"":i.slice(a,t)},format:E.bind(null,"/"),parse(i){v(i,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return a;const r=i.charCodeAt(0)===h;let t;r?(a.root="/",t=1):t=0;let n=-1,o=0,p=-1,O=!0,D=i.length-1,k=0;for(;D>=t;--D){const I=i.charCodeAt(D);if(I===h){if(!O){o=D+1;break}continue}p===-1&&(O=!1,p=D+1),I===P?n===-1?n=D:k!==1&&(k=1):n!==-1&&(k=-1)}if(p!==-1){const I=o===0&&r?1:o;n===-1||k===0||k===1&&n===p-1&&n===o+1?a.base=a.name=i.slice(I,p):(a.name=i.slice(I,n),a.base=i.slice(I,p),a.ext=i.slice(n,p))}return o>0?a.dir=i.slice(0,o-1):r&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=m?e.$fc.normalize:e.$gc.normalize,e.$ic=m?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=m?e.$fc.join:e.$gc.join,e.$kc=m?e.$fc.resolve:e.$gc.resolve,e.$lc=m?e.$fc.relative:e.$gc.relative,e.$mc=m?e.$fc.dirname:e.$gc.dirname,e.$nc=m?e.$fc.basename:e.$gc.basename,e.$oc=m?e.$fc.extname:e.$gc.extname,e.$pc=m?e.$fc.format:e.$gc.format,e.$qc=m?e.$fc.parse:e.$gc.parse,e.$rc=m?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=m?e.$fc.sep:e.$gc.sep,e.$tc=m?e.$fc.delimiter:e.$gc.delimiter}),define(ie[33],ne([0,1,9,4,27,12]),function(J,e,S,A,s,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=void 0;function C(o){return o===47||o===92}e.$Rf=C;function P(o){return o.replace(/[\\/]/g,S.$gc.sep)}e.$Sf=P;function h(o){return o.indexOf("/")===-1&&(o=P(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.$Tf=h;function c(o,p=S.$gc.sep){if(!o)return"";const O=o.length,D=o.charCodeAt(0);if(C(D)){if(C(o.charCodeAt(1))&&!C(o.charCodeAt(2))){let I=3;const j=I;for(;I<O&&!C(o.charCodeAt(I));I++);if(j!==I&&!C(o.charCodeAt(I+1))){for(I+=1;I<O;I++)if(C(o.charCodeAt(I)))return o.slice(0,I+1).replace(/[\\/]/g,p)}}return p}else if($(D)&&o.charCodeAt(1)===58)return C(o.charCodeAt(2))?o.slice(0,2)+p:o.slice(0,2);let k=o.indexOf("://");if(k!==-1){for(k+=3;k<O;k++)if(C(o.charCodeAt(k)))return o.slice(0,k+1)}return""}e.$Uf=c;function g(o){if(!A.$j||!o||o.length<5)return!1;let p=o.charCodeAt(0);if(p!==92||(p=o.charCodeAt(1),p!==92))return!1;let O=2;const D=O;for(;O<o.length&&(p=o.charCodeAt(O),p!==92);O++);return!(D===O||(p=o.charCodeAt(O+1),isNaN(p)||p===92))}e.$Vf=g;const b=/[\\/:\*\?"<>\|]/g,y=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function v(o,p=A.$j){const O=p?b:y;return!(!o||o.length===0||/^\s+$/.test(o)||(O.lastIndex=0,O.test(o))||p&&f.test(o)||o==="."||o===".."||p&&o[o.length-1]==="."||p&&o.length!==o.trim().length||o.length>255)}e.$Wf=v;function m(o,p,O){const D=o===p;return!O||D?D:!o||!p?!1:(0,s.$3e)(o,p)}e.$Xf=m;function w(o,p,O,D=S.sep){if(o===p)return!0;if(!o||!p||p.length>o.length)return!1;if(O){if(!(0,s.$4e)(o,p))return!1;if(p.length===o.length)return!0;let I=p.length;return p.charAt(p.length-1)===D&&I--,o.charAt(I)===D}return p.charAt(p.length-1)!==D&&(p+=D),o.indexOf(p)===0}e.$Yf=w;function $(o){return o>=65&&o<=90||o>=97&&o<=122}e.$Zf=$;function d(o,p){return A.$j&&o.endsWith(":")&&(o+=S.sep),(0,S.$ic)(o)||(o=(0,S.$jc)(p,o)),o=(0,S.$hc)(o),A.$j?(o=(0,s.$Le)(o,S.sep),o.endsWith(":")&&(o+=S.sep)):(o=(0,s.$Le)(o,S.sep),o||(o=S.sep)),o}e.$1f=d;function u(o){const p=(0,S.$hc)(o);return A.$j?o.length>3?!1:E(p)&&(o.length===2||p.charCodeAt(2)===92):p===S.$gc.sep}e.$2f=u;function E(o,p=A.$j){return p?$(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.$3f=E;function l(o,p=A.$j){return E(o,p)?o[0]:void 0}e.$4f=l;function i(o,p,O){return p.length>o.length?-1:o===p?0:(O&&(o=o.toLowerCase(),p=p.toLowerCase()),o.indexOf(p))}e.$5f=i;function a(o){const p=o.split(":");let O,D,k;for(const I of p){const j=Number(I);(0,R.$Df)(j)?D===void 0?D=j:k===void 0&&(k=j):O=O?[O,I].join(":"):I}if(!O)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:O,line:D!==void 0?D:void 0,column:k!==void 0?k:D!==void 0?1:void 0}}e.$6f=a;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",t="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function n(o,p,O=8){let D="";for(let I=0;I<O;I++){let j;I===0&&A.$j&&!p&&(O===3||O===4)?j=t:j=r,D+=j.charAt(Math.floor(Math.random()*j.length))}let k;return p?k=`${p}-${D}`:k=D,o?(0,S.$jc)(o,k):k}e.$7f=n}),define(ie[75],ne([0,1,4]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bl=e.$Al=e.TerminateResponseCode=e.Source=void 0;var A;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(A||(e.Source=A={}));var s;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(s||(e.TerminateResponseCode=s={}));function R(P,...h){const c=h.reduce((y,f)=>(y[f]=!0,y),{}),g=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(y=>!c[y]).forEach(y=>{for(let f=0;f<g.length;f++)if(y.search(g[f])!==-1){delete P[y];break}})}e.$Al=R;function C(P){P&&(delete P.DEBUG,S.$k&&delete P.DYLD_LIBRARY_PATH,S.$l&&delete P.LD_PRELOAD)}e.$Bl=C}),define(ie[7],ne([0,1,9,4]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const s=/^\w[\w\d+.-]*$/,R=/^\//,C=/^\/\//;function P(t,n){if(!t.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${t.authority}", path: "${t.path}", query: "${t.query}", fragment: "${t.fragment}"}`);if(t.scheme&&!s.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path){if(t.authority){if(!R.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(C.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function h(t,n){return!t&&!n?"file":t}function c(t,n){switch(t){case"https":case"http":case"file":n?n[0]!==b&&(n=b+n):n=b;break}return n}const g="",b="/",y=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{static isUri(n){return n instanceof f?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,o,p,O,D,k=!1){typeof n=="object"?(this.scheme=n.scheme||g,this.authority=n.authority||g,this.path=n.path||g,this.query=n.query||g,this.fragment=n.fragment||g):(this.scheme=h(n,k),this.authority=o||g,this.path=c(this.scheme,p||g),this.query=O||g,this.fragment=D||g,P(this,k))}get fsPath(){return E(this,!1)}with(n){if(!n)return this;let{scheme:o,authority:p,path:O,query:D,fragment:k}=n;return o===void 0?o=this.scheme:o===null&&(o=g),p===void 0?p=this.authority:p===null&&(p=g),O===void 0?O=this.path:O===null&&(O=g),D===void 0?D=this.query:D===null&&(D=g),k===void 0?k=this.fragment:k===null&&(k=g),o===this.scheme&&p===this.authority&&O===this.path&&D===this.query&&k===this.fragment?this:new w(o,p,O,D,k)}static parse(n,o=!1){const p=y.exec(n);return p?new w(p[2]||g,r(p[4]||g),r(p[5]||g),r(p[7]||g),r(p[9]||g),o):new w(g,g,g,g,g)}static file(n){let o=g;if(A.$j&&(n=n.replace(/\\/g,b)),n[0]===b&&n[1]===b){const p=n.indexOf(b,2);p===-1?(o=n.substring(2),n=b):(o=n.substring(2,p),n=n.substring(p)||b)}return new w("file",o,n,g,g)}static from(n,o){return new w(n.scheme,n.authority,n.path,n.query,n.fragment,o)}static joinPath(n,...o){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let p;return A.$j&&n.scheme==="file"?p=f.file(S.$fc.join(E(n,!0),...o)).path:p=S.$gc.join(n.path,...o),n.with({path:p})}toString(n=!1){return l(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof f)return n;{const o=new w(n);return o._formatted=n.external??null,o._fsPath=n._sep===m?n.fsPath??null:null,o}}else return n}}e.URI=f;function v(t){return!t||typeof t!="object"?!1:typeof t.scheme=="string"&&(typeof t.authority=="string"||typeof t.authority>"u")&&(typeof t.path=="string"||typeof t.path>"u")&&(typeof t.query=="string"||typeof t.query>"u")&&(typeof t.fragment=="string"||typeof t.fragment>"u")}e.$vc=v;const m=A.$j?1:void 0;class w extends f{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=E(this,!1)),this._fsPath}toString(n=!1){return n?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=m),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const $={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function d(t,n,o){let p,O=-1;for(let D=0;D<t.length;D++){const k=t.charCodeAt(D);if(k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57||k===45||k===46||k===95||k===126||n&&k===47||o&&k===91||o&&k===93||o&&k===58)O!==-1&&(p+=encodeURIComponent(t.substring(O,D)),O=-1),p!==void 0&&(p+=t.charAt(D));else{p===void 0&&(p=t.substr(0,D));const I=$[k];I!==void 0?(O!==-1&&(p+=encodeURIComponent(t.substring(O,D)),O=-1),p+=I):O===-1&&(O=D)}}return O!==-1&&(p+=encodeURIComponent(t.substring(O))),p!==void 0?p:t}function u(t){let n;for(let o=0;o<t.length;o++){const p=t.charCodeAt(o);p===35||p===63?(n===void 0&&(n=t.substr(0,o)),n+=$[p]):n!==void 0&&(n+=t[o])}return n!==void 0?n:t}function E(t,n){let o;return t.authority&&t.path.length>1&&t.scheme==="file"?o=`//${t.authority}${t.path}`:t.path.charCodeAt(0)===47&&(t.path.charCodeAt(1)>=65&&t.path.charCodeAt(1)<=90||t.path.charCodeAt(1)>=97&&t.path.charCodeAt(1)<=122)&&t.path.charCodeAt(2)===58?n?o=t.path.substr(1):o=t.path[1].toLowerCase()+t.path.substr(2):o=t.path,A.$j&&(o=o.replace(/\//g,"\\")),o}e.$wc=E;function l(t,n){const o=n?u:d;let p="",{scheme:O,authority:D,path:k,query:I,fragment:j}=t;if(O&&(p+=O,p+=":"),(D||O==="file")&&(p+=b,p+=b),D){let U=D.indexOf("@");if(U!==-1){const z=D.substr(0,U);D=D.substr(U+1),U=z.lastIndexOf(":"),U===-1?p+=o(z,!1,!1):(p+=o(z.substr(0,U),!1,!1),p+=":",p+=o(z.substr(U+1),!1,!0)),p+="@"}D=D.toLowerCase(),U=D.lastIndexOf(":"),U===-1?p+=o(D,!1,!0):(p+=o(D.substr(0,U),!1,!0),p+=D.substr(U))}if(k){if(k.length>=3&&k.charCodeAt(0)===47&&k.charCodeAt(2)===58){const U=k.charCodeAt(1);U>=65&&U<=90&&(k=`/${String.fromCharCode(U+32)}:${k.substr(3)}`)}else if(k.length>=2&&k.charCodeAt(1)===58){const U=k.charCodeAt(0);U>=65&&U<=90&&(k=`${String.fromCharCode(U+32)}:${k.substr(2)}`)}p+=o(k,!0,!1)}return I&&(p+="?",p+=o(I,!1,!1)),j&&(p+="#",p+=n?j:d(j,!1,!1)),p}function i(t){try{return decodeURIComponent(t)}catch{return t.length>3?t.substr(0,3)+i(t.substr(3)):t}}const a=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(t){return t.match(a)?t.replace(a,n=>i(n)):t}}),define(ie[154],ne([0,1,7]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$4p=e.$3p=e.$2p=void 0;function A(c){const g=c;return g&&typeof g.type=="string"&&typeof g.severity=="string"}e.$2p=A;function s(c){const g=[];let b;try{const y=JSON.parse(c.arguments),f=y[y.length-1];f&&f.__$stack&&(y.pop(),b=f.__$stack),g.push(...y)}catch{g.push("Unable to log remote console arguments",c.arguments)}return{args:g,stack:b}}e.$3p=s;function R(c){if(typeof c!="string")return R(s(c).stack);const g=c;if(g){const b=C(g),y=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(b||"");if(y&&y.length===4)return{uri:S.URI.file(y[1]),line:Number(y[2]),column:Number(y[3])}}}e.$4p=R;function C(c){if(!c)return c;const g=c.indexOf(`
`);return g===-1?c:c.substring(0,g)}function P(c,g){const{args:b,stack:y}=s(c),f=typeof b[0]=="string"&&b.length===1;let v=C(y);v&&(v=`(${v.trim()})`);let m=[];if(typeof b[0]=="string"?v&&f?m=[`%c[${g}] %c${b[0]} %c${v}`,h("blue"),h(""),h("grey")]:m=[`%c[${g}] %c${b[0]}`,h("blue"),h(""),...b.slice(1)]:m=[`%c[${g}]%`,h("blue"),...b],v&&!f&&m.push(v),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,m)}e.log=P;function h(c){return`color: ${c}`}}),define(ie[76],ne([0,1,17,7]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nh=e.$mh=e.$lh=void 0;function s(h){return JSON.stringify(h,C)}e.$lh=s;function R(h){let c=JSON.parse(h);return c=P(c),c}e.$mh=R;function C(h,c){return c instanceof RegExp?{$mid:2,source:c.source,flags:c.flags}:c}function P(h,c=0){if(!h||c>200)return h;if(typeof h=="object"){switch(h.$mid){case 1:return A.URI.revive(h);case 2:return new RegExp(h.source,h.flags);case 17:return new Date(h.source)}if(h instanceof S.$ce||h instanceof Uint8Array)return h;if(Array.isArray(h))for(let g=0;g<h.length;++g)h[g]=P(h[g],c+1);else for(const g in h)Object.hasOwnProperty.call(h,g)&&(h[g]=P(h[g],c+1))}return h}e.$nh=P}),define(ie[13],ne([0,1,14,4,7]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.Schemas=void 0;var R;(function(c){c.inMemory="inmemory",c.vscode="vscode",c.internal="private",c.walkThrough="walkThrough",c.walkThroughSnippet="walkThroughSnippet",c.http="http",c.https="https",c.file="file",c.mailto="mailto",c.untitled="untitled",c.data="data",c.command="command",c.vscodeRemote="vscode-remote",c.vscodeRemoteResource="vscode-remote-resource",c.vscodeManagedRemoteResource="vscode-managed-remote-resource",c.vscodeUserData="vscode-userdata",c.vscodeCustomEditor="vscode-custom-editor",c.vscodeNotebookCell="vscode-notebook-cell",c.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",c.vscodeNotebookCellOutput="vscode-notebook-cell-output",c.vscodeInteractiveInput="vscode-interactive-input",c.vscodeSettings="vscode-settings",c.vscodeWorkspaceTrust="vscode-workspace-trust",c.vscodeTerminal="vscode-terminal",c.vscodeChatSesssion="vscode-chat-editor",c.webviewPanel="webview-panel",c.vscodeWebview="vscode-webview",c.extension="extension",c.vscodeFileResource="vscode-file",c.tmp="tmp",c.vsls="vsls",c.vscodeSourceControl="vscode-scm"})(R||(e.Schemas=R={})),e.$8f="vscode-tkn",e.$9f="tkn";class C{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(g){this.d=g}setDelegate(g){this.e=g}setServerRootPath(g){this.f=`${g}/${R.vscodeRemoteResource}`}set(g,b,y){this.a[g]=b,this.b[g]=y}setConnectionToken(g,b){this.c[g]=b}getPreferredWebSchema(){return this.d}rewrite(g){if(this.e)try{return this.e(g)}catch(w){return S.$1(w),g}const b=g.authority;let y=this.a[b];y&&y.indexOf(":")!==-1&&y.indexOf("[")===-1&&(y=`[${y}]`);const f=this.b[b],v=this.c[b];let m=`path=${encodeURIComponent(g.path)}`;return typeof v=="string"&&(m+=`&${e.$9f}=${encodeURIComponent(v)}`),s.URI.from({scheme:A.$p?this.d:R.vscodeRemoteResource,authority:`${y}:${f}`,path:this.f,query:m})}}e.$0f=new C,e.$$f="vs/../../extensions",e.$_f="vs/../../node_modules",e.$ag="vs/../../node_modules.asar",e.$bg="vs/../../node_modules.asar.unpacked",e.$cg="vscode-app";class P{static{this.a=e.$cg}asBrowserUri(g){const b=this.b(g,J);return this.uriToBrowserUri(b)}uriToBrowserUri(g){return g.scheme===R.vscodeRemote?e.$0f.rewrite(g):g.scheme===R.file&&(A.$n||A.$q&&A.$h.origin===`${R.vscodeFileResource}://${P.a}`)?g.with({scheme:R.vscodeFileResource,authority:g.authority||P.a,query:null,fragment:null}):g}asFileUri(g){const b=this.b(g,J);return this.uriToFileUri(b)}uriToFileUri(g){return g.scheme===R.vscodeFileResource?g.with({scheme:R.file,authority:g.authority!==P.a?g.authority:null,query:null,fragment:null}):g}b(g,b){return s.URI.isUri(g)?g:s.URI.parse(b.toUrl(g))}}e.$dg=new P;var h;(function(c){const g=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);c.CoopAndCoep=Object.freeze(g.get("3"));const b="vscode-coi";function y(v){let m;typeof v=="string"?m=new URL(v).searchParams:v instanceof URL?m=v.searchParams:s.URI.isUri(v)&&(m=new URL(v.toString(!0)).searchParams);const w=m?.get(b);if(w)return g.get(w)}c.getHeadersFromQuery=y;function f(v,m,w){if(!globalThis.crossOriginIsolated)return;const $=m&&w?"3":w?"2":"1";v instanceof URLSearchParams?v.set(b,$):v[b]=$}c.addSearchParam=f})(h||(e.COI=h={}))}),define(ie[19],ne([0,1,33,13,9,4,27,7]),function(J,e,S,A,s,R,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gg=e.DataUri=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=void 0;function h(f){return(0,P.$wc)(f,!0)}e.$kg=h;class c{constructor(v){this.a=v}compare(v,m,w=!1){return v===m?0:(0,C.$Ve)(this.getComparisonKey(v,w),this.getComparisonKey(m,w))}isEqual(v,m,w=!1){return v===m?!0:!v||!m?!1:this.getComparisonKey(v,w)===this.getComparisonKey(m,w)}getComparisonKey(v,m=!1){return v.with({path:this.a(v)?v.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(v){return this.a(v)}isEqualOrParent(v,m,w=!1){if(v.scheme===m.scheme){if(v.scheme===A.Schemas.file)return S.$Yf(h(v),h(m),this.a(v))&&v.query===m.query&&(w||v.fragment===m.fragment);if((0,e.$Bg)(v.authority,m.authority))return S.$Yf(v.path,m.path,this.a(v),"/")&&v.query===m.query&&(w||v.fragment===m.fragment)}return!1}joinPath(v,...m){return P.URI.joinPath(v,...m)}basenameOrAuthority(v){return(0,e.$tg)(v)||v.authority}basename(v){return s.$gc.basename(v.path)}extname(v){return s.$gc.extname(v.path)}dirname(v){if(v.path.length===0)return v;let m;return v.scheme===A.Schemas.file?m=P.URI.file(s.$mc(h(v))).path:(m=s.$gc.dirname(v.path),v.authority&&m.length&&m.charCodeAt(0)!==47&&(console.error(`dirname("${v.toString})) resulted in a relative path`),m="/")),v.with({path:m})}normalizePath(v){if(!v.path.length)return v;let m;return v.scheme===A.Schemas.file?m=P.URI.file(s.$hc(h(v))).path:m=s.$gc.normalize(v.path),v.with({path:m})}relativePath(v,m){if(v.scheme!==m.scheme||!(0,e.$Bg)(v.authority,m.authority))return;if(v.scheme===A.Schemas.file){const d=s.$lc(h(v),h(m));return R.$j?S.$Sf(d):d}let w=v.path||"/";const $=m.path||"/";if(this.a(v)){let d=0;for(const u=Math.min(w.length,$.length);d<u&&!(w.charCodeAt(d)!==$.charCodeAt(d)&&w.charAt(d).toLowerCase()!==$.charAt(d).toLowerCase());d++);w=$.substr(0,d)+w.substr(d)}return s.$gc.relative(w,$)}resolvePath(v,m){if(v.scheme===A.Schemas.file){const w=P.URI.file(s.$kc(h(v),m));return v.with({authority:w.authority,path:w.path})}return m=S.$Tf(m),v.with({path:s.$gc.resolve(v.path,m)})}isAbsolutePath(v){return!!v.path&&v.path[0]==="/"}isEqualAuthority(v,m){return v===m||v!==void 0&&m!==void 0&&(0,C.$3e)(v,m)}hasTrailingPathSeparator(v,m=s.sep){if(v.scheme===A.Schemas.file){const w=h(v);return w.length>S.$Uf(w).length&&w[w.length-1]===m}else{const w=v.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(v.fsPath)}}removeTrailingPathSeparator(v,m=s.sep){return(0,e.$Cg)(v,m)?v.with({path:v.path.substr(0,v.path.length-1)}):v}addTrailingPathSeparator(v,m=s.sep){let w=!1;if(v.scheme===A.Schemas.file){const $=h(v);w=$!==void 0&&$.length===S.$Uf($).length&&$[$.length-1]===m}else{m="/";const $=v.path;w=$.length===1&&$.charCodeAt($.length-1)===47}return!w&&!(0,e.$Cg)(v,m)?v.with({path:v.path+"/"}):v}}e.$lg=c,e.$mg=new c(()=>!1),e.$ng=new c(f=>f.scheme===A.Schemas.file?!R.$l:!0),e.$og=new c(f=>!0),e.$pg=e.$mg.isEqual.bind(e.$mg),e.$qg=e.$mg.isEqualOrParent.bind(e.$mg),e.$rg=e.$mg.getComparisonKey.bind(e.$mg),e.$sg=e.$mg.basenameOrAuthority.bind(e.$mg),e.$tg=e.$mg.basename.bind(e.$mg),e.$ug=e.$mg.extname.bind(e.$mg),e.$vg=e.$mg.dirname.bind(e.$mg),e.$wg=e.$mg.joinPath.bind(e.$mg),e.$xg=e.$mg.normalizePath.bind(e.$mg),e.$yg=e.$mg.relativePath.bind(e.$mg),e.$zg=e.$mg.resolvePath.bind(e.$mg),e.$Ag=e.$mg.isAbsolutePath.bind(e.$mg),e.$Bg=e.$mg.isEqualAuthority.bind(e.$mg),e.$Cg=e.$mg.hasTrailingPathSeparator.bind(e.$mg),e.$Dg=e.$mg.removeTrailingPathSeparator.bind(e.$mg),e.$Eg=e.$mg.addTrailingPathSeparator.bind(e.$mg);function g(f,v){const m=[];for(let w=0;w<f.length;w++){const $=v(f[w]);f.some((d,u)=>u===w?!1:(0,e.$qg)($,v(d)))||m.push(f[w])}return m}e.$Fg=g;var b;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function v(m){const w=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(u=>{const[E,l]=u.split(":");E&&l&&w.set(E,l)});const d=m.path.substring(0,m.path.indexOf(";"));return d&&w.set(f.META_DATA_MIME,d),w}f.parseMetaData=v})(b||(e.DataUri=b={}));function y(f,v,m){if(v){let w=f.path;return w&&w[0]!==s.$gc.sep&&(w=s.$gc.sep+w),f.with({scheme:m,authority:v,path:w})}return f.with({scheme:m})}e.$Gg=y}),define(ie[8],ne([0,1,22,14,3,2,19,4,143]),function(J,e,S,A,s,R,C,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hh=e.$gh=e.$fh=e.$eh=e.Promises=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=void 0;function c(N){return!!N&&typeof N.then=="function"}e.$Hg=c;function g(N){const T=new S.$Yd,F=N(T.token),B=new Promise((V,oe)=>{const de=T.token.onCancellationRequested(()=>{de.dispose(),T.dispose(),oe(new A.$5)});Promise.resolve(F).then(ue=>{de.dispose(),T.dispose(),V(ue)},ue=>{de.dispose(),T.dispose(),oe(ue)})});return new class{cancel(){T.cancel()}then(V,oe){return B.then(V,oe)}catch(V){return this.then(void 0,V)}finally(V){return B.finally(V)}}}e.$Ig=g;function b(N,T,F){return new Promise((B,V)=>{const oe=T.onCancellationRequested(()=>{oe.dispose(),B(F)});N.then(B,V).finally(()=>oe.dispose())})}e.$Jg=b;function y(N,T){return new Promise((F,B)=>{const V=T.onCancellationRequested(()=>{V.dispose(),B(new A.$5)});N.then(F,B).finally(()=>V.dispose())})}e.$Kg=y;async function f(N){let T=-1;const F=N.map((B,V)=>B.then(oe=>(T=V,oe)));try{return await Promise.race(F)}finally{N.forEach((B,V)=>{V!==T&&B.cancel()})}}e.$Lg=f;function v(N,T,F){let B;const V=setTimeout(()=>{B?.(void 0),F?.()},T);return Promise.race([N.finally(()=>clearTimeout(V)),new Promise(oe=>B=oe)])}e.$Mg=v;function m(N){return new Promise((T,F)=>{const B=N();c(B)?B.then(T,F):T(B)})}e.$Ng=m;class w{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(T){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=T,!this.b){const F=()=>{if(this.b=null,this.f)return;const B=this.queue(this.d);return this.d=null,B};this.b=new Promise(B=>{this.a.then(F,F).then(B)})}return new Promise((F,B)=>{this.b.then(F,B)})}return this.a=T(),new Promise((F,B)=>{this.a.then(V=>{this.a=null,F(V)},V=>{this.a=null,B(V)})})}dispose(){this.f=!0}}e.$Og=w;class ${constructor(){this.a=Promise.resolve(null)}queue(T){return this.a=this.a.then(()=>T(),()=>T())}}e.$Pg=$;class d{constructor(){this.a=new Map}queue(T,F){const V=(this.a.get(T)??Promise.resolve()).catch(()=>{}).then(F).finally(()=>{this.a.get(T)===V&&this.a.delete(T)});return this.a.set(T,V),V}}e.$Qg=d;const u=(N,T)=>{let F=!0;const B=setTimeout(()=>{F=!1,T()},N);return{isTriggered:()=>F,dispose:()=>{clearTimeout(B),F=!1}}},E=N=>{let T=!0;return queueMicrotask(()=>{T&&(T=!1,N())}),{isTriggered:()=>T,dispose:()=>{T=!1}}};class l{constructor(T){this.defaultDelay=T,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(T,F=this.defaultDelay){this.g=T,this.h(),this.b||(this.b=new Promise((V,oe)=>{this.d=V,this.f=oe}).then(()=>{if(this.b=null,this.d=null,this.g){const V=this.g;return this.g=null,V()}}));const B=()=>{this.a=null,this.d?.(null)};return this.a=F===h.$Ld?E(B):u(F,B),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new A.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Rg=l;class i{constructor(T){this.a=new l(T),this.b=new w}trigger(T,F){return this.a.trigger(()=>this.b.queue(T),F)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Sg=i;class a{constructor(){this.a=!1,this.b=new Promise((T,F)=>{this.d=T})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Tg=a;class r extends a{constructor(T){super(),this.f=setTimeout(()=>this.open(),T)}open(){clearTimeout(this.f),super.open()}}e.$Ug=r;function t(N,T){return T?new Promise((F,B)=>{const V=setTimeout(()=>{oe.dispose(),F()},N),oe=T.onCancellationRequested(()=>{clearTimeout(V),oe.dispose(),B(new A.$5)})}):g(F=>t(N,F))}e.$Vg=t;function n(N,T=0,F){const B=setTimeout(()=>{N(),F&&V.dispose()},T),V=(0,R.$Qc)(()=>{clearTimeout(B),F?.deleteAndLeak(V)});return F?.add(V),V}e.$Wg=n;function o(N){const T=[];let F=0;const B=N.length;function V(){return F<B?N[F++]():null}function oe(de){de!=null&&T.push(de);const ue=V();return ue?ue.then(oe):Promise.resolve(T)}return Promise.resolve(null).then(oe)}e.$Xg=o;function p(N,T=B=>!!B,F=null){let B=0;const V=N.length,oe=()=>{if(B>=V)return Promise.resolve(F);const de=N[B++];return Promise.resolve(de()).then(he=>T(he)?Promise.resolve(he):oe())};return oe()}e.$Yg=p;function O(N,T=B=>!!B,F=null){if(N.length===0)return Promise.resolve(F);let B=N.length;const V=()=>{B=-1;for(const oe of N)oe.cancel?.()};return new Promise((oe,de)=>{for(const ue of N)ue.then(he=>{--B>=0&&T(he)?(V(),oe(he)):B===0&&oe(F)}).catch(he=>{--B>=0&&(V(),de(he))})})}e.$Zg=O;class D{constructor(T){this.a=0,this.d=T,this.f=[],this.b=0,this.g=new s.$Od}get onDrained(){return this.g.event}get size(){return this.a}queue(T){return this.a++,new Promise((F,B)=>{this.f.push({factory:T,c:F,e:B}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const T=this.f.shift();this.b++;const F=T.factory();F.then(T.c,T.e),F.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$1g=D;class k extends D{constructor(){super(1)}}e.$2g=k;class I{constructor(){this.a=new K,this.b=0}queue(T){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,T())):this.a.run(this.b++,T())}}e.$3g=I;class j{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const T=new W;return this.b.add(T),T.p}g(){for(const[,T]of this.a)if(T.size>0)return!1;return!0}queueFor(T,F=C.$mg){const B=F.getComparisonKey(T);let V=this.a.get(B);if(!V){V=new k;const oe=this.f++,de=s.Event.once(V.onDrained)(()=>{V?.dispose(),this.a.delete(B),this.h(),this.d?.deleteAndDispose(oe),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new R.$1c),this.d.set(oe,de),this.a.set(B,V)}return V}h(){this.g()&&this.j()}j(){for(const T of this.b)T.complete();this.b.clear()}dispose(){for(const[,T]of this.a)T.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$4g=j;class U{constructor(T,F){this.a=-1,typeof T=="function"&&typeof F=="number"&&this.setIfNotSet(T,F)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(T,F){this.cancel(),this.a=setTimeout(()=>{this.a=-1,T()},F)}setIfNotSet(T,F){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,T()},F))}}e.$5g=U;class z{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(T,F){this.cancel(),this.a=setInterval(()=>{T()},F)}}e.$6g=z;class x{constructor(T,F){this.b=-1,this.a=T,this.d=F,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(T=this.d){this.cancel(),this.b=setTimeout(this.f,T)}get delay(){return this.d}set delay(T){this.d=T}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$7g=x;class Z{constructor(T,F){F%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${F}ms is not a multiple of 1000ms.`),this.a=T,this.b=F,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(T=this.b){T%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${T}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(T/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$8g=Z;class ae extends x{constructor(T,F){super(T,F),this.j=[]}work(T){this.j.push(T),this.isScheduled()||this.schedule()}h(){const T=this.j;this.j=[],this.a?.(T)}dispose(){this.j=[],super.dispose()}}e.$9g=ae;class se extends R.$Sc{constructor(T,F){super(),this.g=T,this.h=F,this.a=[],this.b=this.B(new R.$Tc),this.f=!1}get pending(){return this.a.length}work(T){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+T.length>this.g.maxBufferedWork)return!1}else if(this.pending+T.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const F of T)this.a.push(F);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new x(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$0g=se,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$$g=N=>{(0,P.$B)(()=>{if(T)return;const F=Date.now()+15;N(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,F-Date.now())}}))});let T=!1;return{dispose(){T||(T=!0)}}}:e.$$g=(N,T)=>{const F=requestIdleCallback(N,typeof T=="number"?{timeout:T}:void 0);let B=!1;return{dispose(){B||(B=!0,cancelIdleCallback(F))}}}}();class ce{constructor(T){this.d=!1,this.a=()=>{try{this.f=T()}catch(F){this.g=F}finally{this.d=!0}},this.b=(0,e.$$g)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$_g=ce;async function Y(N,T,F){let B;for(let V=0;V<F;V++)try{return await N()}catch(oe){B=oe,await t(T)}throw B}e.$ah=Y;class K{isRunning(T){return typeof T=="number"?this.a?.taskId===T:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(T,F,B){return this.a={taskId:T,cancel:()=>B?.(),promise:F},F.then(()=>this.d(T),()=>this.d(T)),F}d(T){this.a&&T===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const T=this.b;this.b=void 0,T.run().then(T.promiseResolve,T.promiseReject)}}queue(T){if(this.b)this.b.run=T;else{let F,B;const V=new Promise((oe,de)=>{F=oe,B=de});this.b={run:T,promise:V,promiseResolve:F,promiseReject:B}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$bh=K;class Q{constructor(T,F=()=>Date.now()){this.d=T,this.f=F,this.a=0,this.b=0}increment(){const T=this.f();return T-this.a>this.d&&(this.a=T,this.b=0),this.b++,this.b}}e.$ch=Q;var q;(function(N){N[N.Resolved=0]="Resolved",N[N.Rejected=1]="Rejected"})(q||(q={}));class W{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((T,F)=>{this.a=T,this.b=F})}complete(T){return new Promise(F=>{this.a(T),this.d={outcome:0,value:T},F()})}error(T){return new Promise(F=>{this.b(T),this.d={outcome:1,value:T},F()})}cancel(){return this.error(new A.$5)}}e.$dh=W;var G;(function(N){async function T(B){let V;const oe=await Promise.all(B.map(de=>de.then(ue=>ue,ue=>{V||(V=ue)})));if(typeof V<"u")throw V;return oe}N.settled=T;function F(B){return new Promise(async(V,oe)=>{try{await B(V,oe)}catch(de){oe(de)}})}N.withAsyncBody=F})(G||(e.Promises=G={}));var H;(function(N){N[N.Initial=0]="Initial",N[N.DoneOK=1]="DoneOK",N[N.DoneError=2]="DoneError"})(H||(H={}));class X{static fromArray(T){return new X(F=>{F.emitMany(T)})}static fromPromise(T){return new X(async F=>{F.emitMany(await T)})}static fromPromises(T){return new X(async F=>{await Promise.all(T.map(async B=>F.emitOne(await B)))})}static merge(T){return new X(async F=>{await Promise.all(T.map(async B=>{for await(const V of B)F.emitOne(V)}))})}static{this.EMPTY=X.fromArray([])}constructor(T){this.a=0,this.b=[],this.d=null,this.f=new s.$Od,queueMicrotask(async()=>{const F={emitOne:B=>this.g(B),emitMany:B=>this.h(B),reject:B=>this.k(B)};try{await Promise.resolve(T(F)),this.j()}catch(B){this.k(B)}finally{F.emitOne=void 0,F.emitMany=void 0,F.reject=void 0}})}[Symbol.asyncIterator](){let T=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(T<this.b.length)return{done:!1,value:this.b[T++]};if(this.a===1)return{done:!0,value:void 0};await s.Event.toPromise(this.f.event)}while(!0)}}}static map(T,F){return new X(async B=>{for await(const V of T)B.emitOne(F(V))})}map(T){return X.map(this,T)}static filter(T,F){return new X(async B=>{for await(const V of T)F(V)&&B.emitOne(V)})}filter(T){return X.filter(this,T)}static coalesce(T){return X.filter(T,F=>!!F)}coalesce(){return X.coalesce(this)}static async toPromise(T){const F=[];for await(const B of T)F.push(B);return F}toPromise(){return X.toPromise(this)}g(T){this.a===0&&(this.b.push(T),this.f.fire())}h(T){this.a===0&&(this.b=this.b.concat(T),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(T){this.a===0&&(this.a=2,this.d=T,this.f.fire())}}e.$eh=X;class re extends X{constructor(T,F){super(F),this.l=T}cancel(){this.l.cancel()}}e.$fh=re;function L(N){const T=new S.$Yd,F=N(T.token);return new re(T,async B=>{const V=T.token.onCancellationRequested(()=>{V.dispose(),T.dispose(),B.reject(new A.$5)});try{for await(const oe of F){if(T.token.isCancellationRequested)return;B.emitOne(oe)}V.dispose(),T.dispose()}catch(oe){V.dispose(),T.dispose(),B.reject(oe)}})}e.$gh=L;class M{constructor(){this.a=new W,this.b=new X(B=>{if(T){B.reject(T);return}return F&&B.emitMany(F),this.d=V=>B.reject(V),this.f=V=>B.emitOne(V),this.a.p});let T,F;this.f=B=>{F||(F=[]),F.push(B)},this.d=B=>{T||(T=B)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(T){this.d(T),this.a.complete()}emitOne(T){this.f(T)}}e.$hh=M}),define(ie[104],ne([0,1,23,8,33,31,9,4,27]),function(J,e,S,A,s,R,C,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=void 0;function c(){return Object.create(null)}e.$sj=c,e.$tj="**",e.$uj="/";const g="[/\\\\]",b="[^/\\\\]",y=/\//g;function f(K,Q){switch(K){case 0:return"";case 1:return`${b}*?`;default:return`(?:${g}|${b}+${g}${Q?`|${g}${b}+`:""})*?`}}function v(K,Q){if(!K)return[];const q=[];let W=!1,G=!1,H="";for(const X of K){switch(X){case Q:if(!W&&!G){q.push(H),H="";continue}break;case"{":W=!0;break;case"}":W=!1;break;case"[":G=!0;break;case"]":G=!1;break}H+=X}return H&&q.push(H),q}e.$vj=v;function m(K){if(!K)return"";let Q="";const q=v(K,e.$uj);if(q.every(W=>W===e.$tj))Q=".*";else{let W=!1;q.forEach((G,H)=>{if(G===e.$tj){if(W)return;Q+=f(2,H===q.length-1)}else{let X=!1,re="",L=!1,M="";for(const N of G){if(N!=="}"&&X){re+=N;continue}if(L&&(N!=="]"||!M)){let T;N==="-"?T=N:(N==="^"||N==="!")&&!M?T="^":N===e.$uj?T="":T=(0,h.$Ge)(N),M+=T;continue}switch(N){case"{":X=!0;continue;case"[":L=!0;continue;case"}":{const F=`(?:${v(re,",").map(B=>m(B)).join("|")})`;Q+=F,X=!1,re="";break}case"]":{Q+="["+M+"]",L=!1,M="";break}case"?":Q+=b;continue;case"*":Q+=f(1);continue;default:Q+=(0,h.$Ge)(N)}}H<q.length-1&&(q[H+1]!==e.$tj||H+2<q.length)&&(Q+=g)}W=G===e.$tj})}return Q}const w=/^\*\*\/\*\.[\w\.-]+$/,$=/^\*\*\/([\w\.-]+)\/?$/,d=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,u=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,E=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new R.$Dc(1e4),a=function(){return!1},r=function(){return null};function t(K,Q){if(!K)return r;let q;typeof K!="string"?q=K.pattern:q=K,q=q.trim();const W=`${q}_${!!Q.trimForExclusions}`;let G=i.get(W);if(G)return n(G,K);let H;return w.test(q)?G=p(q.substr(4),q):(H=$.exec(o(q,Q)))?G=O(H[1],q):(Q.trimForExclusions?u:d).test(q)?G=D(q,Q):(H=E.exec(o(q,Q)))?G=k(H[1].substr(1),q,!0):(H=l.exec(o(q,Q)))?G=k(H[1],q,!1):G=I(q),i.set(W,G),n(G,K)}function n(K,Q){if(typeof Q=="string")return K;const q=function(W,G){return(0,s.$Yf)(W,Q.base,!P.$l)?K((0,h.$Ke)(W.substr(Q.base.length),C.sep),G):null};return q.allBasenames=K.allBasenames,q.allPaths=K.allPaths,q.basenames=K.basenames,q.patterns=K.patterns,q}function o(K,Q){return Q.trimForExclusions&&K.endsWith("/**")?K.substr(0,K.length-2):K}function p(K,Q){return function(q,W){return typeof q=="string"&&q.endsWith(K)?Q:null}}function O(K,Q){const q=`/${K}`,W=`\\${K}`,G=function(X,re){return typeof X!="string"?null:re?re===K?Q:null:X===K||X.endsWith(q)||X.endsWith(W)?Q:null},H=[K];return G.basenames=H,G.patterns=[Q],G.allBasenames=H,G}function D(K,Q){const q=ce(K.slice(1,-1).split(",").map(re=>t(re,Q)).filter(re=>re!==r),K),W=q.length;if(!W)return r;if(W===1)return q[0];const G=function(re,L){for(let M=0,N=q.length;M<N;M++)if(q[M](re,L))return K;return null},H=q.find(re=>!!re.allBasenames);H&&(G.allBasenames=H.allBasenames);const X=q.reduce((re,L)=>L.allPaths?re.concat(L.allPaths):re,[]);return X.length&&(G.allPaths=X),G}function k(K,Q,q){const W=C.sep===C.$gc.sep,G=W?K:K.replace(y,C.sep),H=C.sep+G,X=C.$gc.sep+K;let re;return q?re=function(L,M){return typeof L=="string"&&(L===G||L.endsWith(H)||!W&&(L===K||L.endsWith(X)))?Q:null}:re=function(L,M){return typeof L=="string"&&(L===G||!W&&L===K)?Q:null},re.allPaths=[(q?"*/":"./")+K],re}function I(K){try{const Q=new RegExp(`^${m(K)}$`);return function(q){return Q.lastIndex=0,typeof q=="string"&&Q.test(q)?K:null}}catch{return r}}function j(K,Q,q){return!K||typeof Q!="string"?!1:U(K)(Q,void 0,q)}e.$wj=j;function U(K,Q={}){if(!K)return a;if(typeof K=="string"||z(K)){const q=t(K,Q);if(q===r)return a;const W=function(G,H){return!!q(G,H)};return q.allBasenames&&(W.allBasenames=q.allBasenames),q.allPaths&&(W.allPaths=q.allPaths),W}return ae(K,Q)}e.$xj=U;function z(K){const Q=K;return Q?typeof Q.base=="string"&&typeof Q.pattern=="string":!1}e.$yj=z;function x(K){return K.allBasenames||[]}e.$zj=x;function Z(K){return K.allPaths||[]}e.$Aj=Z;function ae(K,Q){const q=ce(Object.getOwnPropertyNames(K).map(re=>se(re,K[re],Q)).filter(re=>re!==r)),W=q.length;if(!W)return r;if(!q.some(re=>!!re.requiresSiblings)){if(W===1)return q[0];const re=function(N,T){let F;for(let B=0,V=q.length;B<V;B++){const oe=q[B](N,T);if(typeof oe=="string")return oe;(0,A.$Hg)(oe)&&(F||(F=[]),F.push(oe))}return F?(async()=>{for(const B of F){const V=await B;if(typeof V=="string")return V}return null})():null},L=q.find(N=>!!N.allBasenames);L&&(re.allBasenames=L.allBasenames);const M=q.reduce((N,T)=>T.allPaths?N.concat(T.allPaths):N,[]);return M.length&&(re.allPaths=M),re}const G=function(re,L,M){let N,T;for(let F=0,B=q.length;F<B;F++){const V=q[F];V.requiresSiblings&&M&&(L||(L=(0,C.$nc)(re)),N||(N=L.substr(0,L.length-(0,C.$oc)(re).length)));const oe=V(re,L,N,M);if(typeof oe=="string")return oe;(0,A.$Hg)(oe)&&(T||(T=[]),T.push(oe))}return T?(async()=>{for(const F of T){const B=await F;if(typeof B=="string")return B}return null})():null},H=q.find(re=>!!re.allBasenames);H&&(G.allBasenames=H.allBasenames);const X=q.reduce((re,L)=>L.allPaths?re.concat(L.allPaths):re,[]);return X.length&&(G.allPaths=X),G}function se(K,Q,q){if(Q===!1)return r;const W=t(K,q);if(W===r)return r;if(typeof Q=="boolean")return W;if(Q){const G=Q.when;if(typeof G=="string"){const H=(X,re,L,M)=>{if(!M||!W(X,re))return null;const N=G.replace("$(basename)",()=>L),T=M(N);return(0,A.$Hg)(T)?T.then(F=>F?K:null):T?K:null};return H.requiresSiblings=!0,H}}return W}function ce(K,Q){const q=K.filter(re=>!!re.basenames);if(q.length<2)return K;const W=q.reduce((re,L)=>{const M=L.basenames;return M?re.concat(M):re},[]);let G;if(Q){G=[];for(let re=0,L=W.length;re<L;re++)G.push(Q)}else G=q.reduce((re,L)=>{const M=L.patterns;return M?re.concat(M):re},[]);const H=function(re,L){if(typeof re!="string")return null;if(!L){let N;for(N=re.length;N>0;N--){const T=re.charCodeAt(N-1);if(T===47||T===92)break}L=re.substr(N)}const M=W.indexOf(L);return M!==-1?G[M]:null};H.basenames=W,H.patterns=G,H.allBasenames=W;const X=K.filter(re=>!re.basenames);return X.push(H),X}function Y(K,Q){return(0,S.$ub)(K,Q,(q,W)=>typeof q=="string"&&typeof W=="string"?q===W:typeof q!="string"&&typeof W!="string"?q.base===W.base&&q.pattern===W.pattern:!1)}e.$Bj=Y}),define(ie[46],ne([0,1,23,33,9,4,19,27]),function(J,e,S,A,s,R,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ev=e.$Dv=e.$Cv=e.$Bv=e.$Av=e.$zv=e.$yv=e.$xv=e.$wv=e.$vv=void 0;function h(t,n){const{os:o,tildify:p,relative:O}=n;if(O){const I=c(t,O,o);if(typeof I=="string")return I}let D=t.fsPath;if(o===1&&!R.$j?D=D.replace(/\//g,"\\"):o!==1&&R.$j&&(D=D.replace(/\\/g,"/")),o!==1&&p?.userHome){const I=p.userHome.fsPath;let j;t.scheme!==p.userHome.scheme&&t.path.startsWith(s.$gc.sep)?j=p.userHome.with({path:t.path}).fsPath:j=t.fsPath,D=y(j,I,o)}return(o===1?s.$fc:s.$gc).normalize(g(D,o===1))}e.$vv=h;function c(t,n,o){const p=o===1?s.$fc:s.$gc,O=o===3?C.$mg:C.$og,D=n.getWorkspace(),k=(0,S.$Ob)(D.folders);if(!k)return;t.scheme!==k.uri.scheme&&t.path.startsWith(s.$gc.sep)&&(t=k.uri.with({path:t.path}));const I=n.getWorkspaceFolder(t);if(!I)return;let j;if(O.isEqual(I.uri,t)?j="":j=O.relativePath(I.uri,t)??"",j&&(j=p.normalize(j)),D.folders.length>1&&!n.noPrefix){const U=I.name?I.name:O.basenameOrAuthority(I.uri);j=j?`${U} \u2022 ${j}`:U}return j}function g(t,n=R.$j){return(0,A.$3f)(t,n)?t.charAt(0).toUpperCase()+t.slice(1):t}e.$wv=g;let b=Object.create(null);function y(t,n,o=R.OS){if(o===1||!t||!n)return t;let p=b.original===n?b.normalized:void 0;p||(p=n,R.$j&&(p=(0,A.$Sf)(p)),p=`${(0,P.$Le)(p,s.$gc.sep)}${s.$gc.sep}`,b={original:n,normalized:p});let O=t;return R.$j&&(O=(0,A.$Sf)(O)),(o===3?O.startsWith(p):(0,P.$4e)(O,p))?`~/${O.substr(p.length)}`:t}e.$xv=y;function f(t,n){return t.replace(/^~($|\/|\\)/,`${n}$1`)}e.$yv=f;const v="\u2026",m="\\\\",w="~";function $(t,n=s.sep){const o=new Array(t.length);let p=!1;for(let O=0;O<t.length;O++){const D=t[O];if(D===""){o[O]=`.${n}`;continue}if(!D){o[O]=D;continue}p=!0;let k="",I=D;I.indexOf(m)===0?(k=I.substr(0,I.indexOf(m)+m.length),I=I.substr(I.indexOf(m)+m.length)):I.indexOf(n)===0?(k=I.substr(0,I.indexOf(n)+n.length),I=I.substr(I.indexOf(n)+n.length)):I.indexOf(w)===0&&(k=I.substr(0,I.indexOf(w)+w.length),I=I.substr(I.indexOf(w)+w.length));const j=I.split(n);for(let U=1;p&&U<=j.length;U++)for(let z=j.length-U;p&&z>=0;z--){p=!1;let x=j.slice(z,z+U).join(n);for(let Z=0;!p&&Z<t.length;Z++)if(Z!==O&&t[Z]&&t[Z].indexOf(x)>-1){const ae=z+U===j.length,se=z>0&&t[Z].indexOf(n)>-1?n+x:x,ce=t[Z].endsWith(se);p=!ae||ce}if(!p){let Z="";(j[0].endsWith(":")||k!=="")&&(z===1&&(z=0,U++,x=j[0]+n+x),z>0&&(Z=j[0]+n),Z=k+Z),z>0&&(Z=Z+v+n),Z=Z+x,z+U<j.length&&(Z=Z+n+v),o[O]=Z}}p&&(o[O]=D)}return o}e.$zv=$;var d;(function(t){t[t.TEXT=0]="TEXT",t[t.VARIABLE=1]="VARIABLE",t[t.SEPARATOR=2]="SEPARATOR"})(d||(d={}));function u(t,n=Object.create(null)){const o=[];let p=!1,O="";for(const D of t)if(D==="$"||p&&D==="{")O&&o.push({value:O,type:d.TEXT}),O="",p=!0;else if(D==="}"&&p){const k=n[O];if(typeof k=="string")k.length&&o.push({value:k,type:d.VARIABLE});else if(k){const I=o[o.length-1];(!I||I.type!==d.SEPARATOR)&&o.push({value:k.label,type:d.SEPARATOR})}O="",p=!1}else O+=D;return O&&!p&&o.push({value:O,type:d.TEXT}),o.filter((D,k)=>{if(D.type===d.SEPARATOR){const I=o[k-1],j=o[k+1];return[I,j].every(U=>U&&(U.type===d.VARIABLE||U.type===d.TEXT)&&U.value.length>0)}return!0}).map(D=>D.value).join("")}e.$Av=u;function E(t,n){return R.$k||n?t.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.$k?"&":"&&"):t.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.$Bv=E;function l(t,n){return R.$k||n?t.replace(/\(&&\w\)|&&/g,""):R.$j?t.replace(/&&|&/g,o=>o==="&"?"&&":"&"):t.replace(/&&/g,"_")}e.$Cv=l;function i(t){return t.replace(/&/g,"&&")}e.$Dv=i;function a(t){if(t.endsWith("]")){const n=t.lastIndexOf(" [",t.length-2);if(n!==-1){const o=r(t.substring(0,n));return{name:o.name,parentPath:o.parentPath+t.substring(n)}}}return r(t)}e.$Ev=a;function r(t){const n=t.indexOf("/")!==-1?s.$gc:s.$fc,o=n.basename(t),p=n.dirname(t);return o.length?{name:o,parentPath:p}:{name:p,parentPath:""}}}),define(ie[155],ne([0,1,17,7]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qm=e.$Pm=e.$Om=e.$Nm=e.$Mm=void 0;function s(b){return b.toJSON()}class R{constructor(y){this.a=y}transformIncoming(y){const f=this.a.transformIncoming(y);return f===y?y:s(A.URI.from(f))}transformOutgoing(y){const f=this.a.transformOutgoing(y);return f===y?y:s(A.URI.from(f))}transformOutgoingURI(y){const f=this.a.transformOutgoing(y);return f===y?y:A.URI.from(f)}transformOutgoingScheme(y){return this.a.transformOutgoingScheme(y)}}e.$Mm=R,e.$Nm=new class{transformIncoming(b){return b}transformOutgoing(b){return b}transformOutgoingURI(b){return b}transformOutgoingScheme(b){return b}};function C(b,y,f){if(!b||f>200)return null;if(typeof b=="object"){if(b instanceof A.URI)return y.transformOutgoing(b);for(const v in b)if(Object.hasOwnProperty.call(b,v)){const m=C(b[v],y,f+1);m!==null&&(b[v]=m)}}return null}function P(b,y){const f=C(b,y,0);return f===null?b:f}e.$Om=P;function h(b,y,f,v){if(!b||v>200)return null;if(typeof b=="object"){if(b.$mid===1)return f?A.URI.revive(y.transformIncoming(b)):y.transformIncoming(b);if(b instanceof S.$ce)return null;for(const m in b)if(Object.hasOwnProperty.call(b,m)){const w=h(b[m],y,f,v+1);w!==null&&(b[m]=w)}}return null}function c(b,y){const f=h(b,y,!1,0);return f===null?b:f}e.$Pm=c;function g(b,y){const f=h(b,y,!0,0);return f===null?b:f}e.$Qm=g}),define(ie[87],ne([0,1,28,56,32,145,4]),function(J,e,S,A,s,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=e.$Tm=e.$Sm=void 0,e.$Sm=new class{c(y){return this.a||(this.a=A.$Wh.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(y)}value(){if(this.b===void 0){let y=0,f=0;const v=(0,S.networkInterfaces)();for(const m in v){const w=v[m];if(w)for(const{mac:$,internal:d}of w)d||(f+=1,this.c($.toUpperCase())&&(y+=1))}this.b=f>0?y/f:0}return this.b}};let P;async function h(y){return P||(P=(async()=>await c(y)||s.$fg())()),P}e.$Tm=h;async function c(y){try{const f=await new Promise((m,w)=>{J(["crypto"],m,w)}),v=(0,R.$Rm)();return f.createHash("sha256").update(v,"utf8").digest("hex")}catch(f){y(f);return}}const g="Software\\Microsoft\\SQMClient";async function b(y){if(C.$j){const f=await new Promise((v,m)=>{J(["@vscode/windows-registry"],v,m)});try{return f.GetStringRegKey("HKEY_LOCAL_MACHINE",g,"MachineId")||""}catch(v){return y(v),""}}return""}e.$Um=b}),define(ie[21],ne([0,1,45,28,156,8,33,84,9,4,19,7]),function(J,e,S,A,s,R,C,P,h,c,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var y;(function(se){se[se.UNLINK=0]="UNLINK",se[se.MOVE=1]="MOVE"})(y||(e.RimRafMode=y={}));async function f(se,ce=y.UNLINK,Y){if((0,C.$2f)(se))throw new Error("rimraf - will refuse to recursively delete root");return ce===y.UNLINK?m(se):v(se,Y)}async function v(se,ce=(0,C.$7f)((0,A.tmpdir)())){try{try{await S.promises.rename(se,ce)}catch(Y){return Y.code==="ENOENT"?void 0:m(se)}m(ce).catch(Y=>{})}catch(Y){if(Y.code!=="ENOENT")throw Y}}async function m(se){return(0,s.promisify)(S.rm)(se,{recursive:!0,force:!0,maxRetries:3})}function w(se){if((0,C.$2f)(se))throw new Error("rimraf - will refuse to recursively delete root");S.rmSync(se,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=w;async function $(se,ce){return E(await(ce?d(se):(0,s.promisify)(S.readdir)(se)))}async function d(se){try{return await(0,s.promisify)(S.readdir)(se,{withFileTypes:!0})}catch(K){console.warn("[node.js fs] readdir with filetypes failed with error: ",K)}const ce=[],Y=await $(se);for(const K of Y){let Q=!1,q=!1,W=!1;try{const G=await e.Promises.lstat((0,h.$jc)(se,K));Q=G.isFile(),q=G.isDirectory(),W=G.isSymbolicLink()}catch(G){console.warn("[node.js fs] unexpected error from lstat after readdir: ",G)}ce.push({name:K,isFile:()=>Q,isDirectory:()=>q,isSymbolicLink:()=>W})}return ce}function u(se){return E(S.readdirSync(se))}e.readdirSync=u;function E(se){return se.map(ce=>typeof ce=="string"?c.$k?(0,P.$pl)(ce):ce:(ce.name=c.$k?(0,P.$pl)(ce.name):ce.name,ce))}async function l(se){const ce=await $(se),Y=[];for(const K of ce)await a.existsDirectory((0,h.$jc)(se,K))&&Y.push(K);return Y}function i(se,ce=1e3){return new Promise(Y=>{let K=!1;const Q=setInterval(()=>{K||(K=!0,S.access(se,q=>{K=!1,q&&(clearInterval(Q),Y(void 0))}))},ce)})}e.whenDeleted=i;var a;(function(se){async function ce(Q){let q;try{if(q=await e.Promises.lstat(Q),!q.isSymbolicLink())return{stat:q}}catch{}try{return{stat:await e.Promises.stat(Q),symbolicLink:q?.isSymbolicLink()?{dangling:!1}:void 0}}catch(W){if(W.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};if(c.$j&&W.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(Q)),symbolicLink:{dangling:!1}}}catch(G){if(G.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};throw G}throw W}}se.stat=ce;async function Y(Q){try{const{stat:q,symbolicLink:W}=await se.stat(Q);return q.isFile()&&W?.dangling!==!0}catch{}return!1}se.existsFile=Y;async function K(Q){try{const{stat:q,symbolicLink:W}=await se.stat(Q);return q.isDirectory()&&W?.dangling!==!0}catch{}return!1}se.existsDirectory=K})(a||(e.SymlinkSupport=a={}));const r=new R.$4g;function t(se,ce,Y){return r.queueFor(b.URI.file(se),g.$ng).queue(()=>{const K=D(Y);return new Promise((Q,q)=>p(se,ce,K,W=>W?q(W):Q()))})}let n=!0;function o(se){n=se}e.configureFlushOnWrite=o;function p(se,ce,Y,K){if(!n)return S.writeFile(se,ce,{mode:Y.mode,flag:Y.flag},K);S.open(se,Y.flag,Y.mode,(Q,q)=>{if(Q)return K(Q);S.writeFile(q,ce,W=>{if(W)return S.close(q,()=>K(W));S.fdatasync(q,G=>(G&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",G),o(!1)),S.close(q,H=>K(H))))})})}function O(se,ce,Y){const K=D(Y);if(!n)return S.writeFileSync(se,ce,{mode:K.mode,flag:K.flag});const Q=S.openSync(se,K.flag,K.mode);try{S.writeFileSync(Q,ce);try{S.fdatasyncSync(Q)}catch(q){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",q),o(!1)}}finally{S.closeSync(Q)}}e.writeFileSync=O;function D(se){return se?{mode:typeof se.mode=="number"?se.mode:438,flag:typeof se.flag=="string"?se.flag:"w"}:{mode:438,flag:"w"}}async function k(se,ce,Y=6e4){if(se!==ce)try{c.$j&&typeof Y=="number"?await I(se,ce,Date.now(),Y):await(0,s.promisify)(S.rename)(se,ce)}catch(K){if(se.toLowerCase()!==ce.toLowerCase()&&K.code==="EXDEV"||se.endsWith("."))await j(se,ce,{preserveSymlinks:!1}),await f(se,y.MOVE);else throw K}}async function I(se,ce,Y,K,Q=0){try{return await(0,s.promisify)(S.rename)(se,ce)}catch(q){if(q.code!=="EACCES"&&q.code!=="EPERM"&&q.code!=="EBUSY")throw q;if(Date.now()-Y>=K)throw console.error(`[node.js fs] rename failed after ${Q} retries with error: ${q}`),q;if(Q===0){let W=!1;try{const{stat:G}=await a.stat(ce);G.isFile()||(W=!0)}catch{}if(W)throw q}return await(0,R.$Vg)(Math.min(100,Q*10)),I(se,ce,Y,K,Q+1)}}async function j(se,ce,Y){return z(se,ce,{root:{source:se,target:ce},options:Y,handledSourcePaths:new Set})}const U=511;async function z(se,ce,Y){if(Y.handledSourcePaths.has(se))return;Y.handledSourcePaths.add(se);const{stat:K,symbolicLink:Q}=await a.stat(se);if(Q){if(Y.options.preserveSymlinks)try{return await ae(se,ce,Y)}catch(q){console.warn("[node.js fs] copy of symlink failed: ",q)}if(Q.dangling)return}return K.isDirectory()?x(se,ce,K.mode&U,Y):Z(se,ce,K.mode&U)}async function x(se,ce,Y,K){await e.Promises.mkdir(ce,{recursive:!0,mode:Y});const Q=await $(se);for(const q of Q)await z((0,h.$jc)(se,q),(0,h.$jc)(ce,q),K)}async function Z(se,ce,Y){await e.Promises.copyFile(se,ce),await e.Promises.chmod(ce,Y)}async function ae(se,ce,Y){let K=await e.Promises.readlink(se);(0,C.$Yf)(K,Y.root.source,!c.$l)&&(K=(0,h.$jc)(Y.root.target,K.substr(Y.root.source.length+1))),await e.Promises.symlink(K,ce)}e.Promises=new class{get access(){return(0,s.promisify)(S.access)}get stat(){return(0,s.promisify)(S.stat)}get lstat(){return(0,s.promisify)(S.lstat)}get utimes(){return(0,s.promisify)(S.utimes)}get read(){return(se,ce,Y,K,Q)=>new Promise((q,W)=>{S.read(se,ce,Y,K,Q,(G,H,X)=>G?W(G):q({bytesRead:H,buffer:X}))})}get readFile(){return(0,s.promisify)(S.readFile)}get write(){return(se,ce,Y,K,Q)=>new Promise((q,W)=>{S.write(se,ce,Y,K,Q,(G,H,X)=>G?W(G):q({bytesWritten:H,buffer:X}))})}get appendFile(){return(0,s.promisify)(S.appendFile)}get fdatasync(){return(0,s.promisify)(S.fdatasync)}get truncate(){return(0,s.promisify)(S.truncate)}get copyFile(){return(0,s.promisify)(S.copyFile)}get open(){return(0,s.promisify)(S.open)}get close(){return(0,s.promisify)(S.close)}get symlink(){return(0,s.promisify)(S.symlink)}get readlink(){return(0,s.promisify)(S.readlink)}get chmod(){return(0,s.promisify)(S.chmod)}get mkdir(){return(0,s.promisify)(S.mkdir)}get unlink(){return(0,s.promisify)(S.unlink)}get rmdir(){return(0,s.promisify)(S.rmdir)}get realpath(){return(0,s.promisify)(S.realpath)}async exists(se){try{return await e.Promises.access(se),!0}catch{return!1}}get readdir(){return $}get readDirsInDir(){return l}get writeFile(){return t}get rm(){return f}get rename(){return k}get copy(){return j}}}),define(ie[105],ne([0,1,45,9,4,27,21]),function(J,e,S,A,s,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_p=e.$$p=e.$0p=e.$9p=void 0;function P(y){if(s.$l)return y;const f=(0,A.$mc)(y);if(y===f)return y;const v=((0,A.$nc)(y)||y).toLowerCase();try{const w=(0,C.readdirSync)(f).filter($=>$.toLowerCase()===v);if(w.length===1){const $=P(f);if($)return(0,A.$jc)($,w[0])}else if(w.length>1){const $=w.indexOf(v);if($>=0){const d=P(f);if(d)return(0,A.$jc)(d,w[$])}}}catch{}return null}e.$9p=P;async function h(y){if(s.$l)return y;const f=(0,A.$mc)(y);if(y===f)return y;const v=((0,A.$nc)(y)||y).toLowerCase();try{const w=(await C.Promises.readdir(f)).filter($=>$.toLowerCase()===v);if(w.length===1){const $=await h(f);if($)return(0,A.$jc)($,w[0])}else if(w.length>1){const $=w.indexOf(v);if($>=0){const d=await h(f);if(d)return(0,A.$jc)(d,w[$])}}}catch{}return null}e.$0p=h;async function c(y){try{return await C.Promises.realpath(y)}catch{const v=b(y);return await C.Promises.access(v,S.constants.R_OK),v}}e.$$p=c;function g(y){try{return S.realpathSync(y)}catch{const v=b(y);return S.accessSync(v,S.constants.R_OK),v}}e.$_p=g;function b(y){return(0,R.$Le)((0,A.$hc)(y),A.sep)}}),define(ie[106],ne([0,1,28,9,21]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zl=e.$yl=void 0;const R=/^\d+$/,C=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var h;(function(E){E[E.x64=0]="x64",E[E.x86=1]="x86",E[E.ARM=2]="ARM"})(h||(h={}));let c;switch(process.arch){case"ia32":c=1;break;case"arm":case"arm64":c=2;break;default:c=0;break}let g;process.env.PROCESSOR_ARCHITEW6432?g=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?g=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?g=1:g=0;class b{constructor(l,i,a){this.exePath=l,this.displayName=i,this.a=a}async exists(){return this.a===void 0&&(this.a=await s.SymlinkSupport.existsFile(this.exePath)),this.a}}function y({useAlternateBitness:E=!1}={}){return E?c===0?process.env["ProgramFiles(x86)"]||null:g===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function f({useAlternateBitness:E=!1,findPreview:l=!1}={}){const i=y({useAlternateBitness:E});if(!i)return null;const a=A.$jc(i,"PowerShell");if(!await s.SymlinkSupport.existsDirectory(a))return null;let r=-1,t=null;for(const p of await s.Promises.readdir(a)){let O=-1;if(l){const k=p.indexOf("-");if(k<0)continue;const I=p.substring(0,k);if(!R.test(I)||p.substring(k+1)!=="preview")continue;O=parseInt(I,10)}else{if(!R.test(p))continue;O=parseInt(p,10)}if(O<=r)continue;const D=A.$jc(a,p,"pwsh.exe");await s.SymlinkSupport.existsFile(D)&&(t=D,r=O)}if(!t)return null;const n=i.includes("x86")?" (x86)":"",o=l?" Preview":"";return new b(t,`PowerShell${o}${n}`,!0)}async function v({findPreview:E}={}){if(!process.env.LOCALAPPDATA)return null;const l=A.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await s.SymlinkSupport.existsDirectory(l))return null;const{pwshMsixDirRegex:i,pwshMsixName:a}=E?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:C,pwshMsixName:"PowerShell (Store)"};for(const r of await s.Promises.readdir(l))if(i.test(r)){const t=A.$jc(l,r,"pwsh.exe");return new b(t,a)}return null}function m(){const E=A.$jc(S.homedir(),".dotnet","tools","pwsh.exe");return new b(E,".NET Core PowerShell Global Tool")}function w(){const E=A.$jc(process.env.windir,c===1&&g!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new b(E,"Windows PowerShell",!0)}async function*$(){let E=await f();E&&(yield E),E=await f({useAlternateBitness:!0}),E&&(yield E),E=await v(),E&&(yield E),E=m(),E&&(yield E),E=await f({findPreview:!0}),E&&(yield E),E=await v({findPreview:!0}),E&&(yield E),E=await f({useAlternateBitness:!0,findPreview:!0}),E&&(yield E),E=w(),E&&(yield E)}async function*d(){for await(const E of $())await E.exists()&&(yield E)}e.$yl=d;async function u(){for await(const E of d())return E;return null}e.$zl=u}),define(ie[88],ne([0,1,9,4,35,75,12,21]),function(J,e,S,A,s,R,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Dl=e.$Cl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function h(b=s.env){return b.comspec||"cmd.exe"}e.$Cl=h;function c(b){let y=[],f=!1;const v=function(m){if(f){y.push(m);return}(!b.send(m,$=>{if($&&console.error($),f=!1,y.length>0){const d=y.slice(0);y=[],d.forEach(u=>v(u))}})||A.$j)&&(f=!0)};return{send:v}}e.$Dl=c;var g;(function(b){async function y(f,v,m){if(S.$ic(f))return f;if(v===void 0&&(v=s.cwd()),S.$mc(f)!=="."||(m===void 0&&C.$zf(s.env.PATH)&&(m=s.env.PATH.split(S.$tc)),m===void 0||m.length===0))return S.$jc(v,f);async function $(d){if(await P.Promises.exists(d)){let u;try{u=await P.Promises.stat(d)}catch(E){E.message.startsWith("EACCES")&&(u=await P.Promises.lstat(d))}return u?!u.isDirectory():!1}return!1}for(const d of m){let u;if(S.$ic(d)?u=S.$jc(d,f):u=S.$jc(v,d,f),await $(u))return u;let E=u+".com";if(await $(E)||(E=u+".exe",await $(E)))return E}return S.$jc(v,f)}b.findExecutable=y})(g||(e.win32=g={}))}),define(ie[107],ne([0,1,47,13]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gr=void 0;function s(C){return new Promise((P,h)=>{let c;const g=new Map;function b(f,v,m,w,$){const d=g.get(v);if(f===C||d){const u={name:y(m),cmd:m,pid:f,ppid:v,load:w,mem:$};g.set(f,u),f===C&&(c=u),d&&(d.children||(d.children=[]),d.children.push(u),d.children.length>1&&(d.children=d.children.sort((E,l)=>E.pid-l.pid)))}}function y(f){const v=/--utility-sub-type=network/i,m=/--ms-enable-electron-run-as-node/i,w=/--crashes-directory/i,$=/\\pipe\\winpty-control/i,d=/conhost\.exe.+--headless/i,u=/--type=([a-zA-Z-]+)/;if(w.exec(f))return"electron-crash-reporter";if($.exec(f))return"winpty-agent";if(d.exec(f))return"conpty-agent";let E=u.exec(f);if(E&&E.length===2)return E[1]==="renderer"?"window":E[1]==="utility"?v.exec(f)?"utility-network-service":"utility-process":E[1]==="extensionHost"?"extension-host":E[1];const l=/[a-zA-Z-]+\.js/g;let i="";do E=l.exec(f),E&&(i+=E+" ");while(E);return i&&f.indexOf("node ")<0&&f.indexOf("node.exe")<0?`electron-nodejs (${i})`:m.exec(f)?`electron-nodejs (${f})`:f}if(process.platform==="win32"){const f=v=>v.indexOf("\\\\?\\")===0||v.indexOf("\\??\\")===0?v.substring(4):v.indexOf('"\\\\?\\')===0||v.indexOf('"\\??\\')===0?'"'+v.substring(5):v;new Promise((v,m)=>{J(["@vscode/windows-process-tree"],v,m)}).then(v=>{v.getProcessList(C,m=>{if(!m){h(new Error(`Root process ${C} not found`));return}v.getProcessCpuUsage(m,w=>{const $=new Map;w.forEach(d=>{const u=f(d.commandLine||"");$.set(d.pid,{name:y(u),cmd:u,pid:d.pid,ppid:d.ppid,load:d.cpu||0,mem:d.memory||0})}),c=$.get(C),c?($.forEach(d=>{const u=$.get(d.ppid);u&&(u.children||(u.children=[]),u.children.push(d))}),$.forEach(d=>{d.children&&(d.children=d.children.sort((u,E)=>u.pid-E.pid))}),P(c)):h(new Error(`Root process ${C} not found`))})},v.ProcessDataFlag.CommandLine|v.ProcessDataFlag.Memory)})}else{let f=function(){let v=[c];const m=[];for(;v.length;){const $=v.shift();$&&(m.push($.pid),$.children&&(v=v.concat($.children)))}let w=JSON.stringify(A.$dg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);w+=" "+m.join(" "),(0,S.exec)(w,{},($,d,u)=>{if($||u)h($||new Error(u.toString()));else{const E=d.toString().split(`
`);for(let l=0;l<m.length;l++){const i=g.get(m[l]);i.load=parseFloat(E[l])}if(!c){h(new Error(`Root process ${C} not found`));return}P(c)}})};(0,S.exec)("which ps",{},(v,m,w)=>{if(v||w)if(process.platform!=="linux")h(v||new Error(w.toString()));else{const $=JSON.stringify(A.$dg.asFileUri("vs/base/node/ps.sh").fsPath);(0,S.exec)($,{},(d,u,E)=>{d||E?h(d||new Error(E.toString())):(R(u,b),f())})}else{const $=m.toString().trim(),d="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,S.exec)(`${$} ${d}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(u,E,l)=>{u||l&&!l.includes("screen size is bogus")?h(u||new Error(l.toString())):(R(E,b),process.platform==="linux"?f():c?P(c):h(new Error(`Root process ${C} not found`)))})}})}})}e.$Gr=s;function R(C,P){const h=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,c=C.toString().split(`
`);for(const g of c){const b=h.exec(g.trim());b&&b.length===6&&P(parseInt(b[1]),parseInt(b[2]),b[5],parseFloat(b[3]),parseFloat(b[4]))}}}),define(ie[108],ne([0,1,28,4,106,88]),function(J,e,S,A,s,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$El=void 0;async function C(b,y){return b===1?A.$j?g():R.$Cl(y):h(b,y)}e.$El=C;let P=null;function h(b,y){if(A.$l&&b===2||A.$k&&b===3)return"/bin/bash";if(!P){let f;if(A.$j)f="/bin/bash";else{if(f=y.SHELL,!f)try{f=(0,S.userInfo)().shell}catch{}f||(f="sh"),f==="/bin/false"&&(f="/bin/bash")}P=f}return P}let c=null;async function g(){return c||(c=(await(0,s.$zl)()).exePath),c}});var Ee=this&&this.__decorate||function(J,e,S,A){var s=arguments.length,R=s<3?e:A===null?A=Object.getOwnPropertyDescriptor(e,S):A,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(J,e,S,A);else for(var P=J.length-1;P>=0;P--)(C=J[P])&&(R=(s<3?C(R):s>3?C(e,S,R):C(e,S))||R);return s>3&&R&&Object.defineProperty(e,S,R),R};define(ie[42],ne([0,1,23,8,17,22,54,14,3,2,76,27,12]),function(J,e,S,A,s,R,C,P,h,c,g,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zh=e.ProxyChannel=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.RequestInitiator=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=void 0;var f;(function(Q){Q[Q.Promise=100]="Promise",Q[Q.PromiseCancel=101]="PromiseCancel",Q[Q.EventListen=102]="EventListen",Q[Q.EventDispose=103]="EventDispose"})(f||(f={}));function v(Q){switch(Q){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var m;(function(Q){Q[Q.Initialize=200]="Initialize",Q[Q.PromiseSuccess=201]="PromiseSuccess",Q[Q.PromiseError=202]="PromiseError",Q[Q.PromiseErrorObj=203]="PromiseErrorObj",Q[Q.EventFire=204]="EventFire"})(m||(m={}));function w(Q){switch(Q){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var $;(function(Q){Q[Q.Uninitialized=0]="Uninitialized",Q[Q.Idle=1]="Idle"})($||($={}));function d(Q){let q=0;for(let W=0;;W+=7){const G=Q.read(1);if(q|=(G.buffer[0]&127)<<W,!(G.buffer[0]&128))return q}}const u=r(0);function E(Q,q){if(q===0){Q.write(u);return}let W=0;for(let H=q;H!==0;H=H>>>7)W++;const G=s.$ce.alloc(W);for(let H=0;q!==0;H++)G.buffer[H]=q&127,q=q>>>7,q>0&&(G.buffer[H]|=128);Q.write(G)}class l{constructor(q){this.b=q,this.a=0}read(q){const W=this.b.slice(this.a,this.a+q);return this.a+=W.byteLength,W}}e.$oh=l;class i{constructor(){this.a=[]}get buffer(){return s.$ce.concat(this.a)}write(q){this.a.push(q)}}e.$ph=i;var a;(function(Q){Q[Q.Undefined=0]="Undefined",Q[Q.String=1]="String",Q[Q.Buffer=2]="Buffer",Q[Q.VSBuffer=3]="VSBuffer",Q[Q.Array=4]="Array",Q[Q.Object=5]="Object",Q[Q.Int=6]="Int"})(a||(a={}));function r(Q){const q=s.$ce.alloc(1);return q.writeUInt8(Q,0),q}const t={Undefined:r(a.Undefined),String:r(a.String),Buffer:r(a.Buffer),VSBuffer:r(a.VSBuffer),Array:r(a.Array),Object:r(a.Object),Uint:r(a.Int)},n=typeof Buffer<"u";function o(Q,q){if(typeof q>"u")Q.write(t.Undefined);else if(typeof q=="string"){const W=s.$ce.fromString(q);Q.write(t.String),E(Q,W.byteLength),Q.write(W)}else if(n&&Buffer.isBuffer(q)){const W=s.$ce.wrap(q);Q.write(t.Buffer),E(Q,W.byteLength),Q.write(W)}else if(q instanceof s.$ce)Q.write(t.VSBuffer),E(Q,q.byteLength),Q.write(q);else if(Array.isArray(q)){Q.write(t.Array),E(Q,q.length);for(const W of q)o(Q,W)}else if(typeof q=="number"&&(q|0)===q)Q.write(t.Uint),E(Q,q);else{const W=s.$ce.fromString(JSON.stringify(q));Q.write(t.Object),E(Q,W.byteLength),Q.write(W)}}e.$qh=o;function p(Q){switch(Q.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return Q.read(d(Q)).toString();case a.Buffer:return Q.read(d(Q)).buffer;case a.VSBuffer:return Q.read(d(Q));case a.Array:{const W=d(Q),G=[];for(let H=0;H<W;H++)G.push(p(Q));return G}case a.Object:return JSON.parse(Q.read(d(Q)).toString());case a.Int:return d(Q)}}e.$rh=p;class O{constructor(q,W,G=null,H=1e3){this.h=q,this.j=W,this.k=G,this.l=H,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(X=>this.q(X)),this.m({type:200})}registerChannel(q,W){this.b.set(q,W),setTimeout(()=>this.w(q),0)}m(q){switch(q.type){case 200:{const W=this.o([q.type]);this.k?.logOutgoing(W,0,1,w(q.type));return}case 201:case 202:case 204:case 203:{const W=this.o([q.type,q.id],q.data);this.k?.logOutgoing(W,q.id,1,w(q.type),q.data);return}}}o(q,W=void 0){const G=new i;return o(G,q),o(G,W),this.p(G.buffer)}p(q){try{return this.h.send(q),q.byteLength}catch{return 0}}q(q){const W=new l(q),G=p(W),H=p(W),X=G[0];switch(X){case 100:return this.k?.logIncoming(q.byteLength,G[1],1,`${v(X)}: ${G[2]}.${G[3]}`,H),this.s({type:X,id:G[1],channelName:G[2],name:G[3],arg:H});case 102:return this.k?.logIncoming(q.byteLength,G[1],1,`${v(X)}: ${G[2]}.${G[3]}`,H),this.t({type:X,id:G[1],channelName:G[2],name:G[3],arg:H});case 101:return this.k?.logIncoming(q.byteLength,G[1],1,`${v(X)}`),this.u({type:X,id:G[1]});case 103:return this.k?.logIncoming(q.byteLength,G[1],1,`${v(X)}`),this.u({type:X,id:G[1]})}}s(q){const W=this.b.get(q.channelName);if(!W){this.v(q);return}const G=new R.$Yd;let H;try{H=W.call(this.j,q.name,q.arg,G.token)}catch(L){H=Promise.reject(L)}const X=q.id;H.then(L=>{this.m({id:X,data:L,type:201})},L=>{L instanceof Error?this.m({id:X,data:{message:L.message,name:L.name,stack:L.stack?L.stack.split?L.stack.split(`
`):L.stack:void 0},type:202}):this.m({id:X,data:L,type:203})}).finally(()=>{re.dispose(),this.d.delete(q.id)});const re=(0,c.$Qc)(()=>G.cancel());this.d.set(q.id,re)}t(q){const W=this.b.get(q.channelName);if(!W){this.v(q);return}const G=q.id,X=W.listen(this.j,q.name,q.arg)(re=>this.m({id:G,data:re,type:204}));this.d.set(q.id,X)}u(q){const W=this.d.get(q.id);W&&(W.dispose(),this.d.delete(q.id))}v(q){let W=this.g.get(q.channelName);W||(W=[],this.g.set(q.channelName,W));const G=setTimeout(()=>{console.error(`Unknown channel: ${q.channelName}`),q.type===100&&this.m({id:q.id,data:{name:"Unknown channel",message:`Channel name '${q.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);W.push({request:q,timeoutTimer:G})}w(q){const W=this.g.get(q);if(W){for(const G of W)switch(clearTimeout(G.timeoutTimer),G.request.type){case 100:this.s(G.request);break;case 102:this.t(G.request);break}this.g.delete(q)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.$Nc)(this.d.values()),this.d.clear()}}e.$sh=O;var D;(function(Q){Q[Q.LocalSide=0]="LocalSide",Q[Q.OtherSide=1]="OtherSide"})(D||(e.RequestInitiator=D={}));class k{constructor(q,W=null){this.l=q,this.a=!1,this.b=$.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new h.$Od,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(G=>this.s(G)),this.j=W}getChannel(q){const W=this;return{call(G,H,X){return W.a?Promise.reject(new P.$5):W.m(q,G,H,X)},listen(G,H){return W.a?h.Event.None:W.o(q,G,H)}}}m(q,W,G,H=R.CancellationToken.None){const X=this.g++,L={id:X,type:100,channelName:q,name:W,arg:G};if(H.isCancellationRequested)return Promise.reject(new P.$5);let M;return new Promise((T,F)=>{if(H.isCancellationRequested)return F(new P.$5);const B=()=>{const ue=he=>{switch(he.type){case 201:this.f.delete(X),T(he.data);break;case 202:{this.f.delete(X);const ve=new Error(he.data.message);ve.stack=Array.isArray(he.data.stack)?he.data.stack.join(`
`):he.data.stack,ve.name=he.data.name,F(ve);break}case 203:this.f.delete(X),F(he.data);break}};this.f.set(X,ue),this.p(L)};let V=null;this.b===$.Idle?B():(V=(0,A.$Ig)(ue=>this.u()),V.then(()=>{V=null,B()}));const oe=()=>{V?(V.cancel(),V=null):this.p({id:X,type:101}),F(new P.$5)},de=H.onCancellationRequested(oe);M=(0,c.$Pc)((0,c.$Qc)(oe),de),this.d.add(M)}).finally(()=>{M.dispose(),this.d.delete(M)})}o(q,W,G){const H=this.g++,re={id:H,type:102,channelName:q,name:W,arg:G};let L=null;const M=new h.$Od({onWillAddFirstListener:()=>{L=(0,A.$Ig)(T=>this.u()),L.then(()=>{L=null,this.d.add(M),this.p(re)})},onDidRemoveLastListener:()=>{L?(L.cancel(),L=null):(this.d.delete(M),this.p({id:H,type:103}))}}),N=T=>M.fire(T.data);return this.f.set(H,N),M.event}p(q){switch(q.type){case 100:case 102:{const W=this.q([q.type,q.id,q.channelName,q.name],q.arg);this.j?.logOutgoing(W,q.id,0,`${v(q.type)}: ${q.channelName}.${q.name}`,q.arg);return}case 101:case 103:{const W=this.q([q.type,q.id]);this.j?.logOutgoing(W,q.id,0,v(q.type));return}}}q(q,W=void 0){const G=new i;return o(G,q),o(G,W),this.r(G.buffer)}r(q){try{return this.l.send(q),q.byteLength}catch{return 0}}s(q){const W=new l(q),G=p(W),H=p(W),X=G[0];switch(X){case 200:return this.j?.logIncoming(q.byteLength,0,0,w(X)),this.t({type:G[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(q.byteLength,G[1],0,w(X),H),this.t({type:G[0],id:G[1],data:H})}}t(q){if(q.type===200){this.b=$.Idle,this.k.fire();return}this.f.get(q.id)?.(q)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}u(){return this.b===$.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.$Nc)(this.d.values()),this.d.clear()}}e.$th=k,Ee([C.$ih],k.prototype,"onDidInitializePromise",null);class I{get connections(){const q=[];return this.f.forEach(W=>q.push(W)),q}constructor(q){this.a=new Map,this.f=new Set,this.g=new h.$Od,this.onDidAddConnection=this.g.event,this.h=new h.$Od,this.onDidRemoveConnection=this.h.event,this.j=new c.$Rc,this.j.add(q(({protocol:W,onDidClientDisconnect:G})=>{const H=h.Event.once(W.onMessage);this.j.add(H(X=>{const re=new l(X),L=p(re),M=new O(W,L),N=new k(W);this.a.forEach((F,B)=>M.registerChannel(B,F));const T={channelServer:M,channelClient:N,ctx:L};this.f.add(T),this.g.fire(T),this.j.add(G(()=>{M.dispose(),N.dispose(),this.f.delete(T),this.h.fire(T)}))}))}))}getChannel(q,W){const G=this;return{call(H,X,re){let L;if((0,y.$Nf)(W)){const N=(0,S.$4b)(G.connections.filter(W));L=N?Promise.resolve(N):h.Event.toPromise(h.Event.filter(G.onDidAddConnection,W))}else L=W.routeCall(G,H,X);const M=L.then(N=>N.channelClient.getChannel(q));return U(M).call(H,X,re)},listen(H,X){if((0,y.$Nf)(W))return G.k(q,W,H,X);const re=W.routeEvent(G,H,X).then(L=>L.channelClient.getChannel(q));return U(re).listen(H,X)}}}k(q,W,G,H){const X=this;let re;const L=new h.$Od({onWillAddFirstListener:()=>{re=new c.$Rc;const M=new h.$Ud,N=new Map,T=B=>{const oe=B.channelClient.getChannel(q).listen(G,H),de=M.add(oe);N.set(B,de)},F=B=>{const V=N.get(B);V&&(V.dispose(),N.delete(B))};X.connections.filter(W).forEach(T),h.Event.filter(X.onDidAddConnection,W)(T,void 0,re),X.onDidRemoveConnection(F,void 0,re),M.event(L.fire,L,re),re.add(M)},onDidRemoveLastListener:()=>{re?.dispose(),re=void 0}});return L.event}registerChannel(q,W){this.a.set(q,W);for(const G of this.f)G.channelServer.registerChannel(q,W)}dispose(){this.j.dispose();for(const q of this.f)q.channelClient.dispose(),q.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$uh=I;class j{constructor(q,W,G=null){const H=new i;o(H,W),q.send(H.buffer),this.a=new k(q,G),this.d=new O(q,W,G)}getChannel(q){return this.a.getChannel(q)}registerChannel(q,W){this.d.registerChannel(q,W)}dispose(){this.a.dispose(),this.d.dispose()}}e.$vh=j;function U(Q){return{call(q,W,G){return Q.then(H=>H.call(q,W,G))},listen(q,W){const G=new h.$Xd;return Q.then(H=>G.input=H.listen(q,W)),G.event}}}e.$wh=U;function z(Q){let q=!1;return{call(W,G,H){return q?Q.call(W,G,H):(0,A.$Vg)(0).then(()=>q=!0).then(()=>Q.call(W,G,H))},listen(W,G){if(q)return Q.listen(W,G);const H=new h.$Xd;return(0,A.$Vg)(0).then(()=>q=!0).then(()=>H.input=Q.listen(W,G)),H.event}}}e.$xh=z;class x{constructor(q){this.a=q}routeCall(q){return this.b(q)}routeEvent(q){return this.b(q)}async b(q){for(const W of q.connections)if(await Promise.resolve(this.a(W.ctx)))return Promise.resolve(W);return await h.Event.toPromise(q.onDidAddConnection),await this.b(q)}}e.$yh=x;var Z;(function(Q){function q(X,re,L){const M=X,N=L&&L.disableMarshalling,T=new Map;for(const F in M)G(F)&&T.set(F,h.Event.buffer(M[F],!0,void 0,re));return new class{listen(F,B,V){const oe=T.get(B);if(oe)return oe;if(H(B)){const de=M[B];if(typeof de=="function")return de.call(M,V)}throw new P.$bb(`Event not found: ${B}`)}call(F,B,V){const oe=M[B];if(typeof oe=="function"){if(!N&&Array.isArray(V))for(let ue=0;ue<V.length;ue++)V[ue]=(0,g.$nh)(V[ue]);let de=oe.apply(M,V);return de instanceof Promise||(de=Promise.resolve(de)),de}throw new P.$bb(`Method not found: ${B}`)}}}Q.fromService=q;function W(X,re){const L=re&&re.disableMarshalling;return new Proxy({},{get(M,N){if(typeof N=="string")return re?.properties?.has(N)?re.properties.get(N):H(N)?function(T){return X.listen(N,T)}:G(N)?X.listen(N):async function(...T){let F;re&&!(0,y.$If)(re.context)?F=[re.context,...T]:F=T;const B=await X.call(N,F);return L?B:(0,g.$nh)(B)};throw new P.$bb(`Property not found: ${String(N)}`)}})}Q.toService=W;function G(X){return X[0]==="o"&&X[1]==="n"&&b.$2e(X.charCodeAt(2))}function H(X){return/^onDynamic/.test(X)&&b.$2e(X.charCodeAt(9))}})(Z||(e.ProxyChannel=Z={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function se(Q){if(Array.isArray(Q))return Q;if(Q&&typeof Q=="object"&&typeof Q.toString=="function"){const q=Q.toString();if(q!=="[object Object]")return q}return Q}function ce(Q){return Array.isArray(Q)?Q.map(se):se(Q)}function Y(Q,q,W,G,H,X,re){re=ce(re);const L=ae[H],M=L[G%L.length];let N=[`%c[${Q}]%c[${String(q).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(G).padStart(5," ")} - ${X}`,"color: darkgreen","color: grey","color: grey",`color: ${M}`];/\($/.test(X)?(N=N.concat(re),N.push(")")):N.push(re),console.log.apply(console,N)}class K{constructor(q,W){this.d=q,this.f=W,this.a=0,this.b=0}logOutgoing(q,W,G,H,X){this.b+=q,Y(this.d,this.b,q,W,G,H,X)}logIncoming(q,W,G,H,X){this.a+=q,Y(this.f,this.a,q,W,G,H,X)}}e.$zh=K}),define(ie[157],ne([0,1,17,3,42]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yT=e.$xT=void 0;class R{constructor(h){this.a=h,this.onMessage=A.Event.fromDOMEventEmitter(this.a,"message",c=>S.$ce.wrap(c.data)),h.start()}send(h){this.a.postMessage(h.buffer)}disconnect(){this.a.close()}}e.$xT=R;class C extends s.$vh{constructor(h,c){const g=new R(h);super(g,c),this.b=g}dispose(){this.b.disconnect(),super.dispose()}}e.$yT=C}),define(ie[109],ne([0,1,17,3,2,42]),function(J,e,S,A,s,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.ProtocolConstants=e.$Ah=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var C;(function(t){t.Created="created",t.Read="read",t.Write="write",t.Open="open",t.Error="error",t.Close="close",t.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",t.NodeEndReceived="nodeEndReceived",t.NodeEndSent="nodeEndSent",t.NodeDrainBegin="nodeDrainBegin",t.NodeDrainEnd="nodeDrainEnd",t.zlibInflateError="zlibInflateError",t.zlibInflateData="zlibInflateData",t.zlibInflateInitialWrite="zlibInflateInitialWrite",t.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",t.zlibInflateWrite="zlibInflateWrite",t.zlibInflateFlushFired="zlibInflateFlushFired",t.zlibDeflateError="zlibDeflateError",t.zlibDeflateData="zlibDeflateData",t.zlibDeflateWrite="zlibDeflateWrite",t.zlibDeflateFlushFired="zlibDeflateFlushFired",t.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",t.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",t.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",t.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",t.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",t.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",t.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",t.ProtocolHeaderRead="protocolHeaderRead",t.ProtocolMessageRead="protocolMessageRead",t.ProtocolHeaderWrite="protocolHeaderWrite",t.ProtocolMessageWrite="protocolMessageWrite",t.ProtocolWrite="protocolWrite"})(C||(e.SocketDiagnosticsEventType=C={}));var P;(function(t){t.enableDiagnostics=!1,t.records=[];const n=new WeakMap;let o=0;function p(D,k){if(!n.has(D)){const I=String(++o);n.set(D,I)}return n.get(D)}function O(D,k,I,j){if(!t.enableDiagnostics)return;const U=p(D,k);if(j instanceof S.$ce||j instanceof Uint8Array||j instanceof ArrayBuffer||ArrayBuffer.isView(j)){const z=S.$ce.alloc(j.byteLength);z.set(j),t.records.push({timestamp:Date.now(),id:U,label:k,type:I,buff:z})}else t.records.push({timestamp:Date.now(),id:U,label:k,type:I,data:j})}t.traceSocketEvent=O})(P||(e.SocketDiagnostics=P={}));var h;(function(t){t[t.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",t[t.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(h||(e.SocketCloseEventType=h={}));let c=null;function g(){return c||(c=S.$ce.alloc(0)),c}class b{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(n){this.a.push(n),this.b+=n.byteLength}read(n){return this.c(n,!0)}peek(n){return this.c(n,!1)}c(n,o){if(n===0)return g();if(n>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===n){const k=this.a[0];return o&&(this.a.shift(),this.b-=n),k}if(this.a[0].byteLength>n){const k=this.a[0].slice(0,n);return o&&(this.a[0]=this.a[0].slice(n),this.b-=n),k}const p=S.$ce.alloc(n);let O=0,D=0;for(;n>0;){const k=this.a[D];if(k.byteLength>n){const I=k.slice(0,n);p.set(I,O),O+=n,o&&(this.a[D]=k.slice(n),this.b-=n),n-=n}else p.set(k,O),O+=k.byteLength,o?(this.a.shift(),this.b-=k.byteLength):D++,n-=k.byteLength}return p}}e.$Ah=b;var y;(function(t){t[t.None=0]="None",t[t.Regular=1]="Regular",t[t.Control=2]="Control",t[t.Ack=3]="Ack",t[t.Disconnect=5]="Disconnect",t[t.ReplayRequest=6]="ReplayRequest",t[t.Pause=7]="Pause",t[t.Resume=8]="Resume",t[t.KeepAlive=9]="KeepAlive"})(y||(y={}));function f(t){switch(t){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var v;(function(t){t[t.HeaderLength=13]="HeaderLength",t[t.AcknowledgeTime=2e3]="AcknowledgeTime",t[t.TimeoutTime=2e4]="TimeoutTime",t[t.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",t[t.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",t[t.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(v||(e.ProtocolConstants=v={}));class m{constructor(n,o,p,O){this.type=n,this.id=o,this.ack=p,this.data=O,this.writtenTime=0}get size(){return this.data.byteLength}}class w extends s.$Sc{constructor(n){super(),this.f=this.B(new A.$Od),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=n,this.b=!1,this.c=new b,this.B(this.a.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(n);this.c.byteLength>=this.g.readLen;){const o=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=o.readUInt32BE(9),this.g.messageType=o.readUInt8(0),this.g.id=o.readUInt32BE(1),this.g.ack=o.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:f(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const p=this.g.messageType,O=this.g.id,D=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",o),this.f.fire(new m(p,O,D,o)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class ${constructor(n){this.k=null,this.a=!1,this.b=!1,this.c=n,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(n){if(this.a)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=S.$ce.alloc(13);o.writeUInt8(n.type,0),o.writeUInt32BE(n.id,1),o.writeUInt32BE(n.ack,5),o.writeUInt32BE(n.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:f(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",n.data),this.j(o,n.data)}g(n,o){const p=this.f===0;return this.d.push(n,o),this.f+=n.byteLength+o.byteLength,p}h(){const n=S.$ce.concat(this.d,this.f);return this.d.length=0,this.f=0,n}j(n,o){this.g(n,o)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const n=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:n.byteLength}),this.c.write(n)}}class d extends s.$Sc{constructor(n){super(),this.f=new A.$Od,this.onMessage=this.f.event,this.g=new A.$Od,this.onDidDispose=this.g.event,this.a=n,this.b=this.B(new $(this.a)),this.c=this.B(new w(this.a)),this.B(this.c.onMessage(o=>{o.type===1&&this.f.fire(o.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(n){this.b.write(new m(1,0,0,n))}}e.$Bh=d;class u extends R.$vh{static fromSocket(n,o){return new u(new d(n),o)}get onDidDispose(){return this.b.onDidDispose}constructor(n,o,p=null){super(n,o,p),this.b=n}dispose(){super.dispose();const n=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),n.end()}}e.$Ch=u;class E{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new A.$Od({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(n){this.b?this.d.length>0?this.d.push(n):this.a.fire(n):this.d.push(n)}flushBuffer(){this.d=[]}}e.$Dh=E;class l{constructor(n){this.data=n,this.next=null}}class i{constructor(){this.a=null,this.b=null}length(){let n=0,o=this.a;for(;o;)o=o.next,n++;return n}peek(){return this.a?this.a.data:null}toArray(){const n=[];let o=0,p=this.a;for(;p;)n[o++]=p.data,p=p.next;return n}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(n){const o=new l(n);if(!this.a){this.a=o,this.b=o;return}this.b.next=o,this.b=o}}class a{static{this.a=10}static{this.b=null}static getInstance(){return a.b||(a.b=new a),a.b}constructor(){this.c=[];const n=Date.now();for(let o=0;o<a.a;o++)this.c[o]=n-1e3*o;setInterval(()=>{for(let o=a.a;o>=1;o--)this.c[o]=this.c[o-1];this.c[0]=Date.now()},1e3)}d(){const n=Date.now(),o=(1+a.a)*1e3;let p=0;for(let O=0;O<a.a;O++)n-this.c[O]<=o&&p++;return 1-p/a.a}hasHighLoad(){return this.d()>=.5}}class r{get unacknowledgedCount(){return this.c-this.d}constructor(n){this.u=new E,this.onControlMessage=this.u.event,this.v=new E,this.onMessage=this.v.event,this.w=new E,this.onDidDispose=this.w.event,this.x=new E,this.onSocketClose=this.x.event,this.y=new E,this.onSocketTimeout=this.y.event,this.s=n.loadEstimator??a.getInstance(),this.t=n.sendKeepAlive??!0,this.a=!1,this.b=new i,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new s.$Rc,this.o=n.socket,this.p=this.r.add(new $(this.o)),this.q=this.r.add(new w(this.o)),this.r.add(this.q.onMessage(o=>this.z(o))),this.r.add(this.o.onClose(o=>this.x.fire(o))),n.initialChunk&&this.q.acceptChunk(n.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const n=new m(5,0,0,g());this.p.write(n),this.p.flush()}sendPause(){const n=new m(7,0,0,g());this.p.write(n)}sendResume(){const n=new m(8,0,0,g());this.p.write(n)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(n,o){this.a=!0,this.r.dispose(),this.r=new s.$Rc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=n,this.p=this.r.add(new $(this.o)),this.q=this.r.add(new w(this.o)),this.r.add(this.q.onMessage(p=>this.z(p))),this.r.add(this.o.onClose(p=>this.x.fire(p))),this.q.acceptChunk(o)}endAcceptReconnection(){this.a=!1,this.h=this.g;const n=new m(3,0,this.h,g());this.p.write(n);const o=this.b.toArray();for(let p=0,O=o.length;p<O;p++)this.p.write(o[p]);this.B()}acceptDisconnect(){this.w.fire()}z(n){if(n.ack>this.d){this.d=n.ack;do{const o=this.b.peek();if(o&&o.id<=n.ack)this.b.pop();else break}while(!0)}switch(n.type){case 0:break;case 1:{if(n.id>this.g)if(n.id!==this.g+1){const o=Date.now();o-this.m>1e4&&(this.m=o,this.p.write(new m(6,0,0,g())))}else this.g=n.id,this.j=Date.now(),this.A(),this.v.fire(n.data);break}case 2:{this.u.fire(n.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const o=this.b.toArray();for(let p=0,O=o.length;p<O;p++)this.p.write(o[p]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(n){const o=++this.c;this.h=this.g;const p=new m(1,o,this.h,n);this.b.push(p),this.a||(this.p.write(p),this.B())}sendControl(n){const o=new m(2,0,0,n);this.p.write(o)}A(){if(this.g<=this.h||this.k)return;const n=Date.now()-this.j;if(n>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-n+5)}B(){if(this.c<=this.d||this.f||this.a)return;const n=this.b.peek(),o=Date.now()-n.writtenTime,p=Date.now()-this.q.lastReadTime,O=Date.now()-this.n;if(o>=2e4&&p>=2e4&&O>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:o,timeSinceLastReceivedSomeData:p});return}const D=Math.max(2e4-o,2e4-p,2e4-O,500);this.f=setTimeout(()=>{this.f=null,this.B()},D)}C(){if(this.g<=this.h)return;this.h=this.g;const n=new m(3,0,this.h,g());this.p.write(n)}D(){this.h=this.g;const n=new m(9,0,this.h,g());this.p.write(n)}}e.$Eh=r}),define(ie[38],ne([0,1,15,14,13]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uT=void 0;class R{constructor(){this.a=new WeakMap}on(P,h){const c=(g,...b)=>{this.b(P,g)&&h(g,...b)};return this.a.set(h,c),S.ipcMain.on(P,c),this}once(P,h){return S.ipcMain.once(P,(c,...g)=>{this.b(P,c)&&h(c,...g)}),this}handle(P,h){return S.ipcMain.handle(P,(c,...g)=>this.b(P,c)?h(c,...g):Promise.reject(`Invalid channel '${P}' or sender for ipcMain.handle() usage.`)),this}removeHandler(P){return S.ipcMain.removeHandler(P),this}removeListener(P,h){const c=this.a.get(h);return c&&(S.ipcMain.removeListener(P,c),this.a.delete(h)),this}b(P,h){if(!P||!P.startsWith("vscode:"))return(0,A.$1)(`Refused to handle ipcMain event for channel '${P}' because the channel is unknown.`),!1;const c=h.senderFrame,g=c.url;if(!g||g==="about:blank")return!0;let b="unknown";try{b=new URL(g).host}catch{return(0,A.$1)(`Refused to handle ipcMain event for channel '${P}' because of a malformed URL '${g}'.`),!1}return b!==s.$cg?((0,A.$1)(`Refused to handle ipcMain event for channel '${P}' because of a bad origin of '${b}'.`),!1):c.parent!==null?((0,A.$1)(`Refused to handle ipcMain event for channel '${P}' because sender of origin '${b}' is not a main frame.`),!1):!0}}e.$uT=new R}),define(ie[158],ne([0,1,15,38,146]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vT=void 0;function R(){A.$uT.on(s.$sT,(P,h,c,g,b)=>{const y=C(P,g,c);y.popup({x:b?b.x:void 0,y:b?b.y:void 0,positioningItem:b?b.positioningItem:void 0,callback:()=>{y&&P.sender.send(s.$tT,h)}})})}e.$vT=R;function C(P,h,c){const g=new S.Menu;return c.forEach(b=>{let y;b.type==="separator"?y=new S.MenuItem({type:b.type}):Array.isArray(b.submenu)?y=new S.MenuItem({submenu:C(P,h,b.submenu),label:b.label}):y=new S.MenuItem({label:b.label,type:b.type,accelerator:b.accelerator,checked:b.checked,enabled:b.enabled,visible:b.visible,click:(f,v,m)=>P.sender.send(h,b.id,m)}),g.append(y)}),g}}),define(ie[159],ne([0,1,38,17,3,2,42,147]),function(J,e,S,A,s,R,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BT=void 0;function h(g,b){const y=s.Event.fromNodeEventEmitter(S.$uT,b,(v,m)=>({event:v,message:m})),f=s.Event.filter(y,({event:v})=>v.sender.id===g);return s.Event.map(f,({message:v})=>v&&A.$ce.wrap(v))}class c extends C.$uh{static{this.b=new Map}static d(){const b=s.Event.fromNodeEventEmitter(S.$uT,"vscode:hello",({sender:y})=>y);return s.Event.map(b,y=>{const f=y.id;c.b.get(f)?.dispose();const m=new s.$Od;c.b.set(f,(0,R.$Qc)(()=>m.fire()));const w=h(f,"vscode:message"),$=s.Event.any(s.Event.signal(h(f,"vscode:disconnect")),m.event);return{protocol:new P.$AT(y,w),onDidClientDisconnect:$}})}constructor(){super(c.d())}}e.$BT=c}),define(ie[110],ne([0,1,38,3,32,157]),function(J,e,S,A,s,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DT=e.$CT=void 0;class C extends R.$yT{constructor(c,g){super({addEventListener:(b,y)=>c.addListener(b,y),removeEventListener:(b,y)=>c.removeListener(b,y),postMessage:b=>c.postMessage(b),start:()=>c.start(),close:()=>c.close()},g)}}e.$CT=C;async function P(h){if(h.isDestroyed()||h.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const c=(0,s.$fg)();h.webContents.send("vscode:createMessageChannel",c);const g=A.Event.fromNodeEventEmitter(S.$uT,"vscode:createMessageChannelResult",(y,f)=>({nonce:f,port:y.ports[0]})),{port:b}=await A.Event.toPromise(A.Event.once(A.Event.filter(g,y=>y.nonce===c)));return b}e.$DT=P}),define(ie[160],ne([0,1,47,8,17,22,154,14,3,2,37,88,75,42]),function(J,e,S,A,s,R,C,P,h,c,g,b,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=e.$6p=void 0;class v extends f.$sh{constructor($){super({send:d=>{try{process.send?.(d.buffer.toString("base64"))}catch{}},onMessage:h.Event.fromNodeEventEmitter(process,"message",d=>s.$ce.wrap(Buffer.from(d,"base64")))},$),process.once("disconnect",()=>this.dispose())}}e.$6p=v;class m{constructor($,d){this.i=$,this.j=d,this.c=new Set,this.g=new Map,this.h=new h.$Od,this.onDidProcessExit=this.h.event;const u=d&&d.timeout?d.timeout:6e4;this.b=new A.$Rg(u),this.d=null,this.f=null}getChannel($){const d=this;return{call(u,E,l){return d.k($,u,E,l)},listen(u,E){return d.l($,u,E)}}}k($,d,u,E=R.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(E.isCancellationRequested)return Promise.reject(P.$6());this.b.cancel();const l=this.n($),i=(0,A.$Ig)(t=>l.call(d,u,t)),a=E.onCancellationRequested(()=>i.cancel()),r=(0,c.$Qc)(()=>i.cancel());return this.c.add(r),i.finally(()=>{a.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l($,d,u){if(!this.b)return h.Event.None;this.b.cancel();let E;const l=new h.$Od({onWillAddFirstListener:()=>{E=this.n($).listen(d,u)(l.fire,l),this.c.add(E)},onDidRemoveLastListener:()=>{this.c.delete(E),E.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return l.event}get m(){if(!this.f){const $=this.j&&this.j.args?this.j.args:[],d=Object.create(null);d.env={...(0,g.$8m)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(d.env={...d.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(d.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(d.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(d.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),d.execArgv===void 0&&(d.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,y.$Bl)(d.env),this.d=(0,S.fork)(this.i,$,d);const u=new h.$Od;h.Event.fromNodeEventEmitter(this.d,"message",n=>n)(n=>{if((0,C.$2p)(n)){(0,C.log)(n,`IPC Library: ${this.j.serverName}`);return}u.fire(s.$ce.wrap(Buffer.from(n,"base64")))});const l=this.j.useQueue?(0,b.$Dl)(this.d):this.d,i=n=>this.d&&this.d.connected&&l.send(n.buffer.toString("base64")),a=u.event,r={send:i,onMessage:a};this.f=new f.$th(r);const t=()=>this.o();process.once("exit",t),this.d.on("error",n=>console.warn('IPC "'+this.j.serverName+'" errored with '+n)),this.d.on("exit",(n,o)=>{process.removeListener("exit",t),this.c.forEach(p=>(0,c.$Nc)(p)),this.c.clear(),n!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+n+" and signal "+o),this.b?.cancel(),this.o(),this.h.fire({code:n,signal:o})})}return this.f}n($){let d=this.g.get($);return d||(d=this.m.getChannel($),this.g.set($,d)),d}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$7p=m}),define(ie[111],ne([0,1,8,3,2,76,12]),function(J,e,S,A,s,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7o=e.$6o=e.StorageState=e.$5o=e.StorageHint=void 0;var P;(function(y){y[y.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",y[y.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(P||(e.StorageHint=P={}));function h(y){const f=y;return f?.changed instanceof Map||f?.deleted instanceof Set}e.$5o=h;var c;(function(y){y[y.None=0]="None",y[y.Initialized=1]="Initialized",y[y.Closed=2]="Closed"})(c||(e.StorageState=c={}));class g extends s.$Sc{static{this.a=100}constructor(f,v=Object.create(null)){super(),this.r=f,this.s=v,this.b=this.B(new A.$Rd),this.onDidChangeStorage=this.b.event,this.c=c.None,this.f=new Map,this.g=this.B(new S.$Sg(g.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(f=>this.u(f)))}u(f){this.b.pause();try{f.changed?.forEach((v,m)=>this.w(m,v)),f.deleted?.forEach(v=>this.w(v,void 0))}finally{this.b.resume()}}w(f,v){if(this.c===c.Closed)return;let m=!1;(0,C.$If)(v)?m=this.f.delete(f):this.f.get(f)!==v&&(this.f.set(f,v),m=!0),m&&this.b.fire({key:f,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===c.None&&(this.c=c.Initialized,this.s.hint!==P.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(f,v){const m=this.f.get(f);return(0,C.$If)(m)?v:m}getBoolean(f,v){const m=this.get(f);return(0,C.$If)(m)?v:m==="true"}getNumber(f,v){const m=this.get(f);return(0,C.$If)(m)?v:parseInt(m,10)}getObject(f,v){const m=this.get(f);return(0,C.$If)(m)?v:(0,R.$mh)(m)}async set(f,v,m=!1){if(this.c===c.Closed)return;if((0,C.$If)(v))return this.delete(f,m);const w=(0,C.$Bf)(v)||Array.isArray(v)?(0,R.$lh)(v):String(v);if(this.f.get(f)!==w)return this.f.set(f,w),this.j.set(f,w),this.h.delete(f),this.b.fire({key:f,external:m}),this.D()}async delete(f,v=!1){if(!(this.c===c.Closed||!this.f.delete(f)))return this.h.has(f)||this.h.add(f),this.j.delete(f),this.b.fire({key:f,external:v}),this.D()}async optimize(){if(this.c!==c.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=c.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const f={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(f).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(f){if(this.z)return this.D(f)}async D(f){return this.s.hint===P.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),f)}async whenFlushed(){if(this.z)return new Promise(f=>this.n.push(f))}isInMemory(){return this.s.hint===P.STORAGE_IN_MEMORY}}e.$6o=g;class b{constructor(){this.onDidChangeItemsExternal=A.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(f){f.insert?.forEach((v,m)=>this.a.set(m,v)),f.delete?.forEach(v=>this.a.delete(v))}async optimize(){}async close(){}}e.$7o=b}),define(ie[161],ne([0,1,8,3,31,9,21]),function(J,e,S,A,s,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZT=void 0;class P{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return A.Event.None}static{this.a=2e3}static{this.b=256}constructor(g,b=Object.create(null)){this.g=g,this.h=b,this.c=(0,R.$nc)(this.g),this.d=new h(this.h.logging),this.f=this.n(this.g)}async getItems(){const g=await this.f,b=new Map;return(await this.s(g,"SELECT * FROM ItemTable")).forEach(f=>b.set(f.key,f.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${b.size} rows`),b}async updateItems(g){const b=await this.f;return this.j(b,g)}j(g,b){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${b.insert?(0,s.$yc)(b.insert):"0"}), delete(${b.delete?(0,s.$zc)(b.delete):"0"})`),this.t(g,()=>{const y=b.insert,f=b.delete;if(y&&y.size>0){const v=[];v.push([]);let m=0;y.forEach((w,$)=>{let d=v[m];d.length>P.b&&(m++,d=[],v.push(d)),d.push($,w)}),v.forEach(w=>{this.u(g,`INSERT INTO ItemTable VALUES ${new Array(w.length/2).fill("(?,?)").join(",")}`,$=>$.run(w),()=>{const $=[];let d=0;return y.forEach((u,E)=>{$.push(E),d+=u.length}),`Keys: ${$.join(", ")} Length: ${d}`})})}if(f&&f.size){const v=[];v.push([]);let m=0;f.forEach(w=>{let $=v[m];$.length>P.b&&(m++,$=[],v.push($)),$.push(w)}),v.forEach(w=>{this.u(g,`DELETE FROM ItemTable WHERE key IN (${new Array(w.length).fill("?").join(",")})`,$=>$.run(w),()=>{const $=[];return f.forEach(d=>{$.push(d)}),`Keys: ${$.join(", ")}`})})}})}async optimize(){this.d.trace(`[storage ${this.c}] vacuum()`);const g=await this.f;return this.q(g,"VACUUM")}async close(g){this.d.trace(`[storage ${this.c}] close()`);const b=await this.f;return this.k(b,g)}k(g,b){return new Promise((y,f)=>{g.db.close(v=>(v&&this.o(g,`[storage ${this.c}] close(): ${v}`),this.g===P.IN_MEMORY_PATH?y():!g.isErroneous&&!g.isInMemory?this.l().then(y,m=>(this.d.error(`[storage ${this.c}] backup(): ${m}`),y())):typeof b=="function"?C.Promises.unlink(this.g).then(()=>this.p(this.g).then(m=>{const w=()=>this.k(m,void 0);return this.j(m,{insert:b()}).then(()=>w(),$=>(w(),Promise.reject($)))})).then(y,f):f(v||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const g=this.m(this.g);return C.Promises.copy(this.g,g,{preserveSymlinks:!1})}m(g){return`${g}.backup`}async checkIntegrity(g){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${g})`);const b=await this.f,y=await this.r(b,g?"PRAGMA integrity_check":"PRAGMA quick_check"),f=g?y.integrity_check:y.quick_check;return b.isErroneous?`${f} (last error: ${b.lastError})`:b.isInMemory?`${f} (in-memory!)`:f}async n(g,b=!0){this.d.trace(`[storage ${this.c}] open(${g}, retryOnBusy: ${b})`);try{return await this.p(g)}catch(y){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${y}`),y.code==="SQLITE_BUSY"&&b)return await(0,S.$Vg)(P.a),this.n(g,!1);try{await C.Promises.unlink(g);try{await C.Promises.rename(this.m(g),g,!1)}catch{}return await this.p(g)}catch(f){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${f}`),this.p(P.IN_MEMORY_PATH)}}}o(g,b){g.isErroneous=!0,g.lastError=b,this.d.error(b)}p(g){return new Promise((b,y)=>{new Promise((f,v)=>{J(["@vscode/sqlite3"],f,v)}).then(f=>{const v={db:new(this.d.isTracing?f.verbose().Database:f.Database)(g,m=>m?v.db&&m.code!=="SQLITE_CANTOPEN"?v.db.close(()=>y(m)):y(m):this.q(v,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>b(v),w=>v.db.close(()=>y(w)))),isInMemory:g===P.IN_MEMORY_PATH};v.db.on("error",m=>this.o(v,`[storage ${this.c}] Error (event): ${m}`)),this.d.isTracing&&v.db.on("trace",m=>this.d.trace(`[storage ${this.c}] Trace (event): ${m}`))},y)})}q(g,b){return new Promise((y,f)=>{g.db.exec(b,v=>v?(this.o(g,`[storage ${this.c}] exec(): ${v}`),f(v)):y())})}r(g,b){return new Promise((y,f)=>{g.db.get(b,(v,m)=>v?(this.o(g,`[storage ${this.c}] get(): ${v}`),f(v)):y(m))})}s(g,b){return new Promise((y,f)=>{g.db.all(b,(v,m)=>v?(this.o(g,`[storage ${this.c}] all(): ${v}`),f(v)):y(m))})}t(g,b){return new Promise((y,f)=>{g.db.serialize(()=>{g.db.run("BEGIN TRANSACTION"),b(),g.db.run("END TRANSACTION",v=>v?(this.o(g,`[storage ${this.c}] transaction(): ${v}`),f(v)):y())})})}u(g,b,y,f){const v=g.db.prepare(b),m=w=>{this.o(g,`[storage ${this.c}] prepare(): ${w} (${b}). Details: ${f()}`)};v.on("error",m),y(v),v.finalize(w=>{w&&m(w),v.removeListener("error",m)})}}e.$ZT=P;class h{static{this.a="VSCODE_TRACE_STORAGE"}constructor(g){g&&typeof g.logTrace=="function"&&process.env[h.a]&&(this.b=g.logTrace),g&&typeof g.logError=="function"&&(this.c=g.logError)}get isTracing(){return!!this.b}trace(g){this.b?.(g)}error(g){this.c?.(g)}}}),define(ie[162],ne([11,10]),function(J,e){return J.create("vs/code/electron-main/app",e)}),define(ie[163],ne([11,10]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ie[164],ne([11,10]),function(J,e){return J.create("vs/platform/contextkey/common/contextkey",e)}),define(ie[165],ne([11,10]),function(J,e){return J.create("vs/platform/contextkey/common/scanner",e)}),define(ie[166],ne([11,10]),function(J,e){return J.create("vs/platform/dialogs/common/dialogs",e)}),define(ie[167],ne([11,10]),function(J,e){return J.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(ie[168],ne([11,10]),function(J,e){return J.create("vs/platform/environment/node/argv",e)}),define(ie[169],ne([11,10]),function(J,e){return J.create("vs/platform/environment/node/argvHelper",e)}),define(ie[170],ne([11,10]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ie[171],ne([11,10]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ie[172],ne([11,10]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ie[173],ne([11,10]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(ie[174],ne([11,10]),function(J,e){return J.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ie[175],ne([11,10]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(ie[176],ne([11,10]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(ie[177],ne([11,10]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(ie[178],ne([11,10]),function(J,e){return J.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(ie[179],ne([11,10]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ie[180],ne([11,10]),function(J,e){return J.create("vs/platform/issue/electron-main/issueMainService",e)}),define(ie[181],ne([11,10]),function(J,e){return J.create("vs/platform/menubar/electron-main/menubar",e)}),define(ie[182],ne([11,10]),function(J,e){return J.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(ie[183],ne([11,10]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(ie[184],ne([11,10]),function(J,e){return J.create("vs/platform/shell/node/shellEnv",e)}),define(ie[185],ne([11,10]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(ie[186],ne([11,10]),function(J,e){return J.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ie[187],ne([11,10]),function(J,e){return J.create("vs/platform/terminal/common/terminalProfiles",e)}),define(ie[188],ne([11,10]),function(J,e){return J.create("vs/platform/update/common/update.config.contribution",e)}),define(ie[189],ne([11,10]),function(J,e){return J.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ie[190],ne([11,10]),function(J,e){return J.create("vs/platform/windows/electron-main/windowImpl",e)}),define(ie[191],ne([11,10]),function(J,e){return J.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(ie[192],ne([11,10]),function(J,e){return J.create("vs/platform/workspace/common/workspace",e)}),define(ie[193],ne([11,10]),function(J,e){return J.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(ie[194],ne([11,10]),function(J,e){return J.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(ie[195],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QU=e.$PU=void 0;function S(s){return s&&s.hasOwnProperty("folderUri")}e.$PU=S;function A(s){return s&&s.hasOwnProperty("workspace")}e.$QU=A}),define(ie[196],ne([0,1,7]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P6b=e.$O6b=e.$N6b=void 0;function A(C){return typeof C?.backupFolder=="string"}e.$N6b=A;function s(C){let P=[];try{Array.isArray(C.workspaces)&&(P=C.workspaces.map(h=>({workspace:{id:h.id,configPath:S.URI.parse(h.configURIPath)},remoteAuthority:h.remoteAuthority})))}catch{}return P}e.$O6b=s;function R(C){let P=[];try{Array.isArray(C.folders)&&(P=C.folders.map(h=>({folderUri:S.URI.parse(h.folderUri),remoteAuthority:h.remoteAuthority})))}catch{}return P}e.$P6b=R}),define(ie[197],ne([0,1,14,165]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Li=e.TokenType=void 0;var s;(function(c){c[c.LParen=0]="LParen",c[c.RParen=1]="RParen",c[c.Neg=2]="Neg",c[c.Eq=3]="Eq",c[c.NotEq=4]="NotEq",c[c.Lt=5]="Lt",c[c.LtEq=6]="LtEq",c[c.Gt=7]="Gt",c[c.GtEq=8]="GtEq",c[c.RegexOp=9]="RegexOp",c[c.RegexStr=10]="RegexStr",c[c.True=11]="True",c[c.False=12]="False",c[c.In=13]="In",c[c.Not=14]="Not",c[c.And=15]="And",c[c.Or=16]="Or",c[c.Str=17]="Str",c[c.QuotedStr=18]="QuotedStr",c[c.Error=19]="Error",c[c.EOF=20]="EOF"})(s||(e.TokenType=s={}));function R(...c){switch(c.length){case 1:return(0,A.localize)(0,null,c[0]);case 2:return(0,A.localize)(1,null,c[0],c[1]);case 3:return(0,A.localize)(2,null,c[0],c[1],c[2]);default:return}}const C=(0,A.localize)(3,null),P=(0,A.localize)(4,null);class h{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(g){switch(g.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return g.isTripleEq?"===":"==";case 4:return g.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return g.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return g.lexeme;case 18:return g.lexeme;case 19:return g.lexeme;case 20:return"EOF";default:throw(0,S.$8)(`unhandled token type: ${JSON.stringify(g)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(g=>g.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(g){return this.c=g,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const b=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:b})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const b=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:b})}else this.h(126)?this.k(9):this.l(R("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(R("&&"));break;case 124:this.h(124)?this.k(16):this.l(R("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(g){return this.r()||this.c.charCodeAt(this.e)!==g?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(g){this.f.push({type:g,offset:this.d})}l(g){const b=this.d,y=this.c.substring(this.d,this.e),f={type:19,offset:this.d,lexeme:y};this.g.push({offset:b,lexeme:y,additionalInfo:g}),this.f.push(f)}n(){this.m.lastIndex=this.d;const g=this.m.exec(this.c);if(g){this.e=this.d+g[0].length;const b=this.c.substring(this.d,this.e),y=h.b.get(b);y?this.k(y):this.f.push({type:17,lexeme:b,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(C);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let g=this.e,b=!1,y=!1;for(;;){if(g>=this.c.length){this.e=g,this.l(P);return}const v=this.c.charCodeAt(g);if(b)b=!1;else if(v===47&&!y){g++;break}else v===91?y=!0:v===92?b=!0:v===93&&(y=!1);g++}for(;g<this.c.length&&h.a.has(this.c.charCodeAt(g));)g++;this.e=g;const f=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:f,offset:this.d})}r(){return this.e>=this.c.length}}e.$Li=h}),define(ie[198],ne([0,1,3,2]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rn=e.$Qn=void 0;class s{constructor(){this.a=new S.$Od,this.b=new S.$Od,this.c=new S.$Od,this.d=new S.$Od}static{this.ChannelName="extensionhostdebugservice"}call(P,h,c){switch(h){case"close":return Promise.resolve(this.a.fire({sessionId:c[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:c[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:c[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:c[0],port:c[1],subId:c[2]}))}throw new Error("Method not implemented.")}listen(P,h,c){switch(h){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$Qn=s;class R extends A.$Sc{constructor(P){super(),this.b=P}reload(P){this.b.call("reload",[P])}get onReload(){return this.b.listen("reload")}close(P){this.b.call("close",[P])}get onClose(){return this.b.listen("close")}attachSession(P,h,c){this.b.call("attach",[P,h,c])}get onAttachSession(){return this.b.listen("attach")}terminateSession(P,h){this.b.call("terminate",[P,h])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(P,h){return this.b.call("openExtensionDevelopmentHostWindow",[P,h])}}e.$Rn=R}),define(ie[199],ne([0,1,149,54,13,9,35,19,7]),function(J,e,S,A,s,R,C,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jm=e.$im=e.$hm=e.$gm=void 0,e.$gm=/^([^.]+\..+):(.+)$/;class c{get appRoot(){return(0,R.$mc)(s.$dg.asFileUri("").fsPath)}get userHome(){return h.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return h.URI.file((0,R.$jc)(this.userDataPath,"User"))}get tmpDir(){return h.URI.file(this.b.tmpDir)}get cacheHome(){return h.URI.file(this.userDataPath)}get stateResource(){return(0,P.$wg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:s.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,P.$wg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const f=(0,S.$fm)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.$jc)(this.userDataPath,"logs",f)}return h.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.$wg)(h.URI.file((0,R.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.$wg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.$wg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.$wg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=C.env.VSCODE_PORTABLE;return f?h.URI.file((0,R.$jc)(f,"argv.json")):(0,P.$wg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return h.URI.file((0,R.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?(0,R.$kc)(f):(0,R.$hc)((0,R.$jc)(s.$dg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const f=this.args["extensions-download-dir"];return f?h.URI.file((0,R.$kc)(f)):h.URI.file((0,R.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return(0,R.$kc)(f);const v=C.env.VSCODE_EXTENSIONS;if(v)return v;const m=C.env.VSCODE_PORTABLE;return m?(0,R.$jc)(m,"extensions"):(0,P.$wg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(v=>/^[^:/?#]+?:\/\//.test(v)?h.URI.parse(v):h.URI.file((0,R.$hc)(v)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(f=>f==="ui"||f==="workspace"||f==="web"?f:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?h.URI.parse(f):h.URI.file((0,R.$hc)(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return g(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!C.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(f=>!e.$gm.test(f))}get extensionLogLevel(){const f=[];for(const v of this.args.log||[]){const m=e.$gm.exec(v);m&&m[1]&&m[2]&&f.push([m[1],m[2]])}return f.length?f:void 0}get serviceMachineIdResource(){return(0,P.$wg)(h.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const f=C.env.VSCODE_PORTABLE;return f?h.URI.file((0,R.$jc)(f,"policy.json")):(0,P.$wg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(f){this.args.continueOn=f}get args(){return this.a}constructor(f,v,m){this.a=f,this.b=v,this.c=m,this.editSessionId=this.args.editSessionId}}e.$hm=c,Ee([A.$ih],c.prototype,"appRoot",null),Ee([A.$ih],c.prototype,"userHome",null),Ee([A.$ih],c.prototype,"userDataPath",null),Ee([A.$ih],c.prototype,"appSettingsHome",null),Ee([A.$ih],c.prototype,"tmpDir",null),Ee([A.$ih],c.prototype,"cacheHome",null),Ee([A.$ih],c.prototype,"stateResource",null),Ee([A.$ih],c.prototype,"userRoamingDataHome",null),Ee([A.$ih],c.prototype,"userDataSyncHome",null),Ee([A.$ih],c.prototype,"sync",null),Ee([A.$ih],c.prototype,"machineSettingsResource",null),Ee([A.$ih],c.prototype,"workspaceStorageHome",null),Ee([A.$ih],c.prototype,"localHistoryHome",null),Ee([A.$ih],c.prototype,"keyboardLayoutResource",null),Ee([A.$ih],c.prototype,"argvResource",null),Ee([A.$ih],c.prototype,"isExtensionDevelopment",null),Ee([A.$ih],c.prototype,"untitledWorkspacesHome",null),Ee([A.$ih],c.prototype,"builtinExtensionsPath",null),Ee([A.$ih],c.prototype,"extensionsPath",null),Ee([A.$ih],c.prototype,"extensionDevelopmentLocationURI",null),Ee([A.$ih],c.prototype,"extensionDevelopmentKind",null),Ee([A.$ih],c.prototype,"extensionTestsLocationURI",null),Ee([A.$ih],c.prototype,"debugExtensionHost",null),Ee([A.$ih],c.prototype,"logLevel",null),Ee([A.$ih],c.prototype,"extensionLogLevel",null),Ee([A.$ih],c.prototype,"serviceMachineIdResource",null),Ee([A.$ih],c.prototype,"disableTelemetry",null),Ee([A.$ih],c.prototype,"disableWorkspaceTrust",null),Ee([A.$ih],c.prototype,"useInMemorySecretStorage",null),Ee([A.$ih],c.prototype,"policyFile",null);function g(y,f){return b(y["inspect-extensions"],y["inspect-brk-extensions"],5870,f,y.debugId,y.extensionEnvironment)}e.$im=g;function b(y,f,v,m,w,$){const u=Number(f||y)||(m?null:v),E=u?!!f:!1;let l;if($)try{l=JSON.parse($)}catch{}return{port:u,break:E,debugId:w,env:l}}e.$jm=b}),define(ie[112],ne([0,1,309,4,168]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=void 0;const R={o:(0,s.localize)(0,null),e:(0,s.localize)(1,null),t:(0,s.localize)(2,null)};e.$Fl=["tunnel","serve-web"],e.$Gl={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,s.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,s.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,s.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,s.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,s.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,s.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,s.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,s.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,s.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,s.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,s.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,s.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,s.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,s.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,s.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,s.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,s.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,s.localize)(22,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,s.localize)(23,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,s.localize)(24,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,s.localize)(25,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,s.localize)(26,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,s.localize)(27,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,s.localize)(28,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,s.localize)(29,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,s.localize)(30,null)},sync:{type:"string",cat:"t",description:(0,s.localize)(31,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,s.localize)(32,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,s.localize)(33,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,s.localize)(34,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,s.localize)(35,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},telemetry:{type:"boolean",cat:"t",description:(0,s.localize)(36,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const C={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(m,w,$=C){const d=m.find(o=>o.length>0&&o[0]!=="-"),u={},E=["_"],l=[],i={};let a;for(const o in w){const p=w[o];p.type==="subcommand"?o===d&&(a=p):(p.alias&&(u[o]=p.alias),p.type==="string"||p.type==="string[]"?(E.push(o),p.deprecates&&E.push(...p.deprecates)):p.type==="boolean"&&(l.push(o),p.deprecates&&l.push(...p.deprecates)),p.global&&(i[o]=p))}if(a&&d){const o=i;for(const k in a.options)o[k]=a.options[k];const p=m.filter(k=>k!==d),O=$.getSubcommandReporter?$.getSubcommandReporter(d):void 0,D=P(p,o,O);return{[d]:D,_:[]}}const r=S(m,{string:E,boolean:l,alias:u}),t={},n=r;t._=r._.map(o=>String(o)).filter(o=>o.length>0),delete n._;for(const o in w){const p=w[o];if(p.type==="subcommand")continue;p.alias&&delete n[p.alias];let O=n[o];if(p.deprecates)for(const D of p.deprecates)n.hasOwnProperty(D)&&(O||(O=n[D],O&&$.onDeprecatedOption(D,p.deprecationMessage||(0,s.localize)(37,null,o))),delete n[D]);if(typeof O<"u"){if(p.type==="string[]"){if(Array.isArray(O)||(O=[O]),!p.allowEmptyValue){const D=O.filter(k=>k.length>0);D.length!==O.length&&($.onEmptyValue(o),O=D.length>0?D:void 0)}}else p.type==="string"&&(Array.isArray(O)?(O=O.pop(),$.onMultipleValues(o,O)):!O&&!p.allowEmptyValue&&($.onEmptyValue(o),O=void 0));t[o]=O,p.deprecationMessage&&$.onDeprecatedOption(o,p.deprecationMessage)}delete n[o]}for(const o in n)$.onUnknownOption(o);return t}e.$Hl=P;function h(m,w){let $="";return w.args&&(Array.isArray(w.args)?$=` <${w.args.join("> <")}>`:$=` <${w.args}>`),w.alias?`-${w.alias} --${m}${$}`:`--${m}${$}`}function c(m,w){const $=[];for(const d in m){const u=m[d],E=h(d,u);$.push([E,u.description])}return g($,w)}e.$Il=c;function g(m,w){const d=m.reduce((l,i)=>Math.max(l,i[0].length),12)+2+1;if(w-d<25)return m.reduce((l,i)=>l.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);const u=w-d-1,E=[];for(const l of m){const i=l[0],a=y(l[1],u),r=b(d-i.length-2);E.push("  "+i+r+a[0]);for(let t=1;t<a.length;t++)E.push(b(d)+a[t])}return E}function b(m){return" ".repeat(m)}function y(m,w){const $=[];for(;m.length;){const d=m.length<w?m.length:m.lastIndexOf(" ",w),u=m.slice(0,d).trim();m=m.slice(d),$.push(u)}return $}function f(m,w,$,d,u){const E=process.stdout.isTTY&&process.stdout.columns||80,l=u?.noInputFiles!==!0?`[${(0,s.localize)(38,null)}...]`:"",i=[`${m} ${$}`];i.push(""),i.push(`${(0,s.localize)(39,null)}: ${w} [${(0,s.localize)(40,null)}]${l}`),i.push(""),u?.noPipe!==!0&&(A.$j?i.push((0,s.localize)(41,null,w)):i.push((0,s.localize)(42,null,w)),i.push(""));const a={},r=[];for(const t in d){const n=d[t];if(n.type==="subcommand")n.description&&r.push({command:t,description:n.description});else if(n.description&&n.cat){let o=a[n.cat];o||(a[n.cat]=o={}),o[t]=n}}for(const t in a){const n=t,o=a[n];o&&(i.push(R[n]),i.push(...c(o,E)),i.push(""))}return r.length&&(i.push((0,s.localize)(43,null)),i.push(...g(r.map(t=>[t.command,t.description]),E)),i.push("")),i.join(`
`)}e.$Jl=f;function v(m,w){return`${m||(0,s.localize)(44,null)}
${w||(0,s.localize)(45,null)}
${process.arch}`}e.$Kl=v}),define(ie[200],ne([0,1,86,198,112]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d7b=void 0;class R extends A.$Qn{constructor(P){super(),this.f=P}call(P,h,c){return h==="openExtensionDevelopmentHostWindow"?this.g(c[0],c[1]):super.call(P,h,c)}async g(P,h){const c=(0,s.$Hl)(P,s.$Gl);c.debugRenderer=h;const g=c.extensionDevelopmentPath;if(!g)return{success:!1};const[b]=await this.f.openExtensionDevelopmentHostWindow(g,{context:5,cli:c,forceProfile:c.profile,forceTempProfile:c["profile-temp"]});if(!h)return{success:!0};const y=b.win;if(!y)return{success:!0};const f=y.webContents.debugger;let v=f.isAttached()?1/0:0;const m=(0,S.createServer)(w=>{v++===0&&f.attach();let $=!1;const d=l=>{$||w.write(JSON.stringify(l)+"\0")},u=(l,i,a,r)=>d({method:i,params:a,sessionId:r});y.on("close",()=>{f.removeListener("message",u),w.end(),$=!0}),f.addListener("message",u);let E=Buffer.alloc(0);w.on("data",l=>{E=Buffer.concat([E,l]);for(let i=E.indexOf(0);i!==-1;i=E.indexOf(0)){let a;try{const r=E.slice(0,i).toString("utf8");E=E.slice(i+1),a=JSON.parse(r)}catch(r){console.error("error reading cdp line",r)}f.sendCommand(a.method,a.params,a.sessionId).then(r=>d({id:a.id,sessionId:a.sessionId,result:r})).catch(r=>d({id:a.id,sessionId:a.sessionId,error:{code:0,message:r.message}}))}}),w.on("error",l=>{console.error("error on cdp pipe:",l)}),w.on("close",()=>{$=!0,--v===0&&f.detach()})});return await new Promise(w=>m.listen(0,w)),y.on("close",()=>m.close()),{rendererDebugPort:m.address().port,success:!0}}}e.$d7b=R}),define(ie[62],ne([0,1,310,169,112]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ol=e.$Nl=e.$Ml=e.$Ll=void 0;function R(b,y){const f=(u,E)=>{console.warn((0,A.localize)(0,null,u,E))},v=u=>{console.warn((0,A.localize)(1,null,u))},m=(u,E)=>{console.warn((0,A.localize)(2,null,u,E))},w=u=>({onUnknownOption:E=>{s.$Fl.includes(u)||console.warn((0,A.localize)(3,null,E,u))},onMultipleValues:f,onEmptyValue:v,onDeprecatedOption:m,getSubcommandReporter:s.$Fl.includes(u)?w:void 0}),$={onUnknownOption:u=>{console.warn((0,A.localize)(4,null,u))},onMultipleValues:f,onEmptyValue:v,onDeprecatedOption:m,getSubcommandReporter:w},d=(0,s.$Hl)(b,s.$Gl,y?$:void 0);return d.goto&&d._.forEach(u=>S(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(u),(0,A.localize)(5,null))),d}function C(b){const y=b.findIndex(f=>!/^-/.test(f));if(y>-1)return[...b.slice(0,y),...b.slice(y+1)]}function P(b){let[,...y]=b;process.env.VSCODE_DEV&&(y=C(y)||[]);const f=!g(process.env);return R(y,f)}e.$Ll=P;function h(b){let[,,...y]=b;return process.env.VSCODE_DEV&&(y=C(y)||[]),R(y,!0)}e.$Ml=h;function c(b,...y){const f=b.indexOf("--");return f===-1?b.push(...y):b.splice(f,0,...y),b}e.$Nl=c;function g(b){return b.VSCODE_CLI==="1"}e.$Ol=g}),function(){"use strict";function J(e,S,A){function s(C,P){const h=R(C,P),c=[h];return e.isAbsolute(h)||c.unshift(A),e.resolve(...c)}function R(C,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const h=process.env.VSCODE_PORTABLE;if(h)return e.join(h,"user-data");let c=process.env.VSCODE_APPDATA;if(c)return e.join(c,P);const g=C["user-data-dir"];if(g)return g;switch(process.platform){case"win32":if(c=process.env.APPDATA,!c){const b=process.env.USERPROFILE;if(typeof b!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");c=e.join(b,"AppData","Roaming")}break;case"darwin":c=e.join(S.homedir(),"Library","Application Support");break;case"linux":c=process.env.XDG_CONFIG_HOME||e.join(S.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(c,P)}return{getUserDataPath:s}}if(typeof define=="function")define(ie[201],ne([113,28,35]),function(e,S,A){return J(e,S,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),S=require("os");module.exports=J(e,S,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ie[89],ne([0,1,28,199,201]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mm=e.$lm=e.$km=void 0;class R extends A.$hm{constructor(c,g){super(c,{homeDir:(0,S.homedir)(),tmpDir:(0,S.tmpdir)(),userDataDir:(0,s.getUserDataPath)(c,g.nameShort)},g)}}e.$km=R;function C(h,c){return(0,A.$jm)(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,c,h.extensionEnvironment)}e.$lm=C;function P(h,c){return(0,A.$jm)(h["inspect-sharedprocess"],h["inspect-brk-sharedprocess"],5879,c,h.extensionEnvironment)}e.$mm=P}),define(ie[202],ne([0,1,45,28,33]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v8b=void 0;function R(C){const P=(0,s.$7f)((0,A.tmpdir)());try{return(0,S.writeFileSync)(P,""),C&&console.log(`Marker file for --wait created: ${P}`),P}catch(h){C&&console.error(`Failed to create marker file for --wait: ${h}`);return}}e.$v8b=R}),define(ie[203],ne([0,1,12,171]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=void 0;function s(C,P,h,c){try{R(C,P,h,c)}catch(g){C.error(g?.message??g)}return P}e.$Bp=s;function R(C,P,h,c){const g=(b,y,f)=>{const v=b[y];if((0,S.$zf)(v)){const m=v,w=m.length;if(w>1&&m[0]==="%"&&m[w-1]==="%"){const $=m.substr(1,w-2);let d=h[$];d===void 0&&c&&(d=c[$]);const u=typeof d=="string"?d:d?.message,E=c?.[$],l=typeof E=="string"?E:E?.message;if(!u){l||C.warn(`[${P.name}]: ${(0,A.localize)(0,null,$)}`);return}if(f&&(y==="title"||y==="category")&&l&&l!==u){const i={value:u,original:l};b[y]=i}else b[y]=u}}else if((0,S.$Bf)(v))for(const m in v)v.hasOwnProperty(m)&&(m==="commands"?g(v,m,!0):g(v,m,f));else if(Array.isArray(v))for(let m=0;m<v.length;m++)g(v,m,f)};for(const b in P)P.hasOwnProperty(b)&&g(P,b)}}),define(ie[204],ne([0,1,19,73,173,205]),function(J,e,S,A,s,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=void 0;const C=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function h($){return $=$.trim(),$==="*"||C.test($)}e.$Po=h;function c($){if(!h($))return null;if($=$.trim(),$==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const d=$.match(C);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}e.$Qo=c;function g($){if(!$)return null;const d=$.majorBase,u=$.majorMustEqual,E=$.minorBase;let l=$.minorMustEqual;const i=$.patchBase;let a=$.patchMustEqual;$.hasCaret&&(d===0||(l=!1),a=!1);let r=0;if($.preRelease){const t=P.exec($.preRelease);if(t){const[,n,o,p]=t;r=Date.UTC(Number(n),Number(o)-1,Number(p))}}return{majorBase:d,majorMustEqual:u,minorBase:E,minorMustEqual:l,patchBase:i,patchMustEqual:a,isMinimum:$.hasGreaterEquals,notBefore:r}}e.$Ro=g;function b($,d,u){let E;typeof $=="string"?E=g(c($)):E=$;let l;d instanceof Date?l=d.getTime():typeof d=="string"&&(l=new Date(d).getTime());let i;if(typeof u=="string"?i=g(c(u)):i=u,!E||!i)return!1;const a=E.majorBase,r=E.minorBase,t=E.patchBase;let n=i.majorBase,o=i.minorBase,p=i.patchBase;const O=i.notBefore;let D=i.majorMustEqual,k=i.minorMustEqual,I=i.patchMustEqual;return i.isMinimum?a>n?!0:a<n?!1:r>o?!0:r<o||l&&l<O?!1:t>=p:(a===1&&n===0&&(!D||!k||!I)&&(n=1,o=0,p=0,D=!0,k=!1,I=!1),a<n?!1:a>n?!D:r<o?!1:r>o?!k:t<p?!1:t>p?!I:!(l&&l<O))}e.$So=b;function y($,d,u,E,l){const i=[];if(typeof E.publisher<"u"&&typeof E.publisher!="string")return i.push([A.default.Error,s.localize(0,null)]),i;if(typeof E.name!="string")return i.push([A.default.Error,s.localize(1,null,"name")]),i;if(typeof E.version!="string")return i.push([A.default.Error,s.localize(2,null,"version")]),i;if(!E.engines)return i.push([A.default.Error,s.localize(3,null,"engines")]),i;if(typeof E.engines.vscode!="string")return i.push([A.default.Error,s.localize(4,null,"engines.vscode")]),i;if(typeof E.extensionDependencies<"u"&&!w(E.extensionDependencies))return i.push([A.default.Error,s.localize(5,null,"extensionDependencies")]),i;if(typeof E.activationEvents<"u"){if(!w(E.activationEvents))return i.push([A.default.Error,s.localize(6,null,"activationEvents")]),i;if(typeof E.main>"u"&&typeof E.browser>"u")return i.push([A.default.Error,s.localize(7,null,"activationEvents","main","browser")]),i}if(typeof E.extensionKind<"u"&&typeof E.main>"u"&&i.push([A.default.Warning,s.localize(8,null,"extensionKind")]),typeof E.main<"u"){if(typeof E.main!="string")return i.push([A.default.Error,s.localize(9,null,"main")]),i;{const t=(0,S.$wg)(u,E.main);(0,S.$qg)(t,u)||i.push([A.default.Warning,s.localize(10,null,t.path,u.path)])}}if(typeof E.browser<"u"){if(typeof E.browser!="string")return i.push([A.default.Error,s.localize(11,null,"browser")]),i;{const t=(0,S.$wg)(u,E.browser);(0,S.$qg)(t,u)||i.push([A.default.Warning,s.localize(12,null,t.path,u.path)])}}if(!R.valid(E.version))return i.push([A.default.Error,s.localize(13,null)]),i;const a=[];if(!f($,d,E,l,a))for(const t of a)i.push([A.default.Error,t]);return i}e.$To=y;function f($,d,u,E,l){return E||typeof u.main>"u"&&typeof u.browser>"u"?!0:m($,d,u.engines.vscode,l)}e.$Uo=f;function v($,d,u){return $==="*"||m(d,u,$)}e.$Vo=v;function m($,d,u,E=[]){const l=g(c(u));if(!l)return E.push(s.localize(14,null,u)),!1;if(l.majorBase===0){if(!l.majorMustEqual||!l.minorMustEqual)return E.push(s.localize(15,null,u)),!1}else if(!l.majorMustEqual)return E.push(s.localize(16,null,u)),!1;return b($,d,l)?!0:(E.push(s.localize(17,null,$,u)),!1)}function w($){if(!Array.isArray($))return!1;for(let d=0,u=$.length;d<u;d++)if(typeof $[d]!="string")return!1;return!0}}),define(ie[206],ne([0,1,17,32]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dp=void 0;async function s(R,C,P){let h=P&&P.get("storage.serviceMachineId",-1)||null;if(h)return h;try{const g=(await C.readFile(R.serviceMachineIdResource)).value.toString();h=(0,A.$eg)(g)?g:null}catch{h=null}if(!h){h=(0,A.$fg)();try{await C.writeFile(R.serviceMachineIdResource,S.$ce.fromString(h))}catch{}}return P?.store("storage.serviceMachineId",h,-1,1),h}e.$dp=s}),define(ie[77],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nh=void 0;class S{constructor(s,R=[],C=!1){this.ctor=s,this.staticArguments=R,this.supportsDelayedInstantiation=C}}e.$Nh=S}),define(ie[207],ne([0,1,77]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Br=e.$Ar=e.InstantiationType=void 0;const A=[];var s;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(s||(e.InstantiationType=s={}));function R(P,h,c){h instanceof S.$Nh||(h=new S.$Nh(h,[],!!c)),A.push([P,h])}e.$Ar=R;function C(){return A}e.$Br=C}),define(ie[208],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gq=e.$fq=void 0;class S{constructor(R,C){this.key=R,this.data=C,this.incoming=new Map,this.outgoing=new Map}}e.$fq=S;class A{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const C of this.a.values())C.outgoing.size===0&&R.push(C);return R}insertEdge(R,C){const P=this.lookupOrInsertNode(R),h=this.lookupOrInsertNode(C);P.outgoing.set(h.key,h),h.incoming.set(P.key,P)}removeNode(R){const C=this.b(R);this.a.delete(C);for(const P of this.a.values())P.outgoing.delete(C),P.incoming.delete(C)}lookupOrInsertNode(R){const C=this.b(R);let P=this.a.get(C);return P||(P=new S(C,R),this.a.set(C,P)),P}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[C,P]of this.a)R.push(`${C}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,C]of this.a){const P=new Set([R]),h=this.c(C,P);if(h)return h}}c(R,C){for(const[P,h]of R.outgoing){if(C.has(P))return[...C,P].join(" -> ");C.add(P);const c=this.c(h,C);if(c)return c;C.delete(P)}}}e.$gq=A}),define(ie[5],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rh=e.$Qh=e.$Ph=e._util=void 0;var S;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function P(h){return h[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=P})(S||(e._util=S={})),e.$Ph=s("instantiationService");function A(C,P,h){P[S.DI_TARGET]===P?P[S.DI_DEPENDENCIES].push({id:C,index:h}):(P[S.DI_DEPENDENCIES]=[{id:C,index:h}],P[S.DI_TARGET]=P)}function s(C){if(S.serviceIds.has(C))return S.serviceIds.get(C);const P=function(h,c,g){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");A(P,h,g)};return P.toString=()=>C,S.serviceIds.set(C,P),P}e.$Qh=s;function R(C){return C}e.$Rh=R}),define(ie[90],ne([0,1,5]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$96b=void 0,e.$96b=(0,S.$Qh)("auxiliaryWindowsMainService")}),define(ie[63],ne([0,1,5]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q6b=void 0,e.$Q6b=(0,S.$Qh)("backupMainService")}),define(ie[18],ne([0,1,12,7,5]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.ConfigurationTarget=e.$mi=e.$li=e.$ki=void 0,e.$ki=(0,s.$Qh)("configurationService");function R($){return $&&typeof $=="object"&&(!$.overrideIdentifier||typeof $.overrideIdentifier=="string")&&(!$.resource||$.resource instanceof A.URI)}e.$li=R;function C($){return $&&typeof $=="object"&&(!$.overrideIdentifiers||Array.isArray($.overrideIdentifiers))&&!$.overrideIdentifier&&(!$.resource||$.resource instanceof A.URI)}e.$mi=C;var P;(function($){$[$.APPLICATION=1]="APPLICATION",$[$.USER=2]="USER",$[$.USER_LOCAL=3]="USER_LOCAL",$[$.USER_REMOTE=4]="USER_REMOTE",$[$.WORKSPACE=5]="WORKSPACE",$[$.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",$[$.DEFAULT=7]="DEFAULT",$[$.MEMORY=8]="MEMORY"})(P||(e.ConfigurationTarget=P={}));function h($){switch($){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$ni=h;function c($){return $.applicationValue!==void 0||$.userValue!==void 0||$.userLocalValue!==void 0||$.userRemoteValue!==void 0||$.workspaceValue!==void 0||$.workspaceFolderValue!==void 0}e.$oi=c;function g($,d){const u=Object.create(null);for(const E in $)b(u,E,$[E],d);return u}e.$pi=g;function b($,d,u,E){const l=d.split("."),i=l.pop();let a=$;for(let r=0;r<l.length;r++){const t=l[r];let n=a[t];switch(typeof n){case"undefined":n=a[t]=Object.create(null);break;case"object":break;default:E(`Ignoring ${d} as ${l.slice(0,r+1).join(".")} is ${JSON.stringify(n)}`);return}a=n}if(typeof a=="object"&&a!==null)try{a[i]=u}catch{E(`Ignoring ${d} as ${l.join(".")} is ${JSON.stringify(a)}`)}else E(`Ignoring ${d} as ${l.join(".")} is ${JSON.stringify(a)}`)}e.$qi=b;function y($,d){const u=d.split(".");f($,u)}e.$ri=y;function f($,d){const u=d.shift();if(d.length===0){delete $[u];return}if(Object.keys($).indexOf(u)!==-1){const E=$[u];typeof E=="object"&&!Array.isArray(E)&&(f(E,d),Object.keys(E).length===0&&delete $[u])}}function v($,d,u){function E(a,r){let t=a;for(const n of r){if(typeof t!="object"||t===null)return;t=t[n]}return t}const l=d.split("."),i=E($,l);return typeof i>"u"?u:i}e.$si=v;function m($,d,u){Object.keys(d).forEach(E=>{E!=="__proto__"&&(E in $?S.$Bf($[E])&&S.$Bf(d[E])?m($[E],d[E],u):u&&($[E]=d[E]):$[E]=d[E])})}e.$ti=m;function w($){return $.replace(/[\[\]]/g,"")}e.$ui=w}),define(ie[114],ne([0,1,4,27,197,5,164,14]),function(J,e,S,A,s,R,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.ContextKeyExprType=e.$Mi=void 0;const h=new Map;h.set("false",!1),h.set("true",!0),h.set("isMac",S.$k),h.set("isLinux",S.$l),h.set("isWindows",S.$j),h.set("isWeb",S.$p),h.set("isMacNative",S.$k&&!S.$p),h.set("isEdge",S.$H),h.set("isFirefox",S.$F),h.set("isChrome",S.$E),h.set("isSafari",S.$G);function c(L,M){if(h.get(L)!==void 0)throw(0,P.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");h.set(L,M)}e.$Mi=c;const g=Object.prototype.hasOwnProperty;var b;(function(L){L[L.False=0]="False",L[L.True=1]="True",L[L.Defined=2]="Defined",L[L.Not=3]="Not",L[L.Equals=4]="Equals",L[L.NotEquals=5]="NotEquals",L[L.And=6]="And",L[L.Regex=7]="Regex",L[L.NotRegex=8]="NotRegex",L[L.Or=9]="Or",L[L.In=10]="In",L[L.NotIn=11]="NotIn",L[L.Greater=12]="Greater",L[L.GreaterEquals=13]="GreaterEquals",L[L.Smaller=14]="Smaller",L[L.SmallerEquals=15]="SmallerEquals"})(b||(e.ContextKeyExprType=b={}));const y={regexParsingWithErrorRecovery:!0},f=(0,C.localize)(0,null),v=(0,C.localize)(1,null),m=(0,C.localize)(2,null),w=(0,C.localize)(3,null),$=(0,C.localize)(4,null),d=(0,C.localize)(5,null),u=(0,C.localize)(6,null),E=(0,C.localize)(7,null);class l{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(M=y){this.k=M,this.d=new s.$Li,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(M){if(M===""){this.h.push({message:f,offset:0,lexeme:"",additionalInfo:v});return}this.f=this.d.reset(M).scan(),this.g=0,this.h=[];try{const N=this.l();if(!this.E()){const T=this.D(),F=T.type===17?d:void 0;throw this.h.push({message:$,offset:T.offset,lexeme:s.$Li.getLexeme(T),additionalInfo:F}),l.c}return N}catch(N){if(N!==l.c)throw N;return}}l(){return this.m()}m(){const M=[this.o()];for(;this.y(16);){const N=this.o();M.push(N)}return M.length===1?M[0]:i.or(...M)}o(){const M=[this.s()];for(;this.y(15);){const N=this.s();M.push(N)}return M.length===1?M[0]:i.and(...M)}s(){if(this.y(2)){const M=this.D();switch(M.type){case 11:return this.z(),n.INSTANCE;case 12:return this.z(),o.INSTANCE;case 0:{this.z();const N=this.l();return this.A(1,w),N?.negate()}case 17:return this.z(),j.create(M.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",M)}}return this.t()}t(){const M=this.D();switch(M.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const N=this.l();return this.A(1,w),N}case 17:{const N=M.lexeme;if(this.z(),this.y(9)){const F=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),F.type!==10)throw this.B("REGEX",F);const B=F.lexeme,V=B.lastIndexOf("/"),oe=V===B.length-1?void 0:this.w(B.substring(V+1));let de;try{de=new RegExp(B.substring(1,V),oe)}catch{throw this.B("REGEX",F)}return se.create(N,de)}switch(F.type){case 10:case 19:{const B=[F.lexeme];this.z();let V=this.D(),oe=0;for(let be=0;be<F.lexeme.length;be++)F.lexeme.charCodeAt(be)===40?oe++:F.lexeme.charCodeAt(be)===41&&oe--;for(;!this.E()&&V.type!==15&&V.type!==16;){switch(V.type){case 0:oe++;break;case 1:oe--;break;case 10:case 18:for(let be=0;be<V.lexeme.length;be++)V.lexeme.charCodeAt(be)===40?oe++:F.lexeme.charCodeAt(be)===41&&oe--}if(oe<0)break;B.push(s.$Li.getLexeme(V)),this.z(),V=this.D()}const de=B.join(""),ue=de.lastIndexOf("/"),he=ue===de.length-1?void 0:this.w(de.substring(ue+1));let ve;try{ve=new RegExp(de.substring(1,ue),he)}catch{throw this.B("REGEX",F)}return i.regex(N,ve)}case 18:{const B=F.lexeme;this.z();let V=null;if(!(0,A.$Ce)(B)){const oe=B.indexOf("/"),de=B.lastIndexOf("/");if(oe!==de&&oe>=0){const ue=B.slice(oe+1,de),he=B[de+1]==="i"?"i":"";try{V=new RegExp(ue,he)}catch{throw this.B("REGEX",F)}}}if(V===null)throw this.B("REGEX",F);return se.create(N,V)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,m);const F=this.u();return i.notIn(N,F)}switch(this.D().type){case 3:{this.z();const F=this.u();if(this.x().type===18)return i.equals(N,F);switch(F){case"true":return i.has(N);case"false":return i.not(N);default:return i.equals(N,F)}}case 4:{this.z();const F=this.u();if(this.x().type===18)return i.notEquals(N,F);switch(F){case"true":return i.not(N);case"false":return i.has(N);default:return i.notEquals(N,F)}}case 5:return this.z(),Z.create(N,this.u());case 6:return this.z(),ae.create(N,this.u());case 7:return this.z(),z.create(N,this.u());case 8:return this.z(),x.create(N,this.u());case 13:return this.z(),i.in(N,this.u());default:return i.has(N)}}case 20:throw this.h.push({message:u,offset:M.offset,lexeme:"",additionalInfo:E}),l.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const M=this.D();switch(M.type){case 17:case 18:return this.z(),M.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(M){return M.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(M){return this.C(M)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(M,N){if(this.C(M))return this.z();throw this.B(N,this.D())}B(M,N,T){const F=(0,C.localize)(8,null,M,s.$Li.getLexeme(N)),B=N.offset,V=s.$Li.getLexeme(N);return this.h.push({message:F,offset:B,lexeme:V,additionalInfo:T}),l.c}C(M){return this.D().type===M}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Ni=l;class i{static false(){return n.INSTANCE}static true(){return o.INSTANCE}static has(M){return p.create(M)}static equals(M,N){return O.create(M,N)}static notEquals(M,N){return I.create(M,N)}static regex(M,N){return se.create(M,N)}static in(M,N){return D.create(M,N)}static notIn(M,N){return k.create(M,N)}static not(M){return j.create(M)}static and(...M){return K.create(M,null,!0)}static or(...M){return Q.create(M,null,!0)}static greater(M,N){return z.create(M,N)}static greaterEquals(M,N){return x.create(M,N)}static smaller(M,N){return Z.create(M,N)}static smallerEquals(M,N){return ae.create(M,N)}static{this.c=new l({regexParsingWithErrorRecovery:!1})}static deserialize(M){return M==null?void 0:this.c.parse(M)}}e.$Oi=i;function a(L){const M=new l({regexParsingWithErrorRecovery:!1});return L.map(N=>(M.parse(N),M.lexingErrors.length>0?M.lexingErrors.map(T=>({errorMessage:T.additionalInfo?(0,C.localize)(9,null,T.additionalInfo):(0,C.localize)(10,null),offset:T.offset,length:T.lexeme.length})):M.parsingErrors.length>0?M.parsingErrors.map(T=>({errorMessage:T.additionalInfo?`${T.message}. ${T.additionalInfo}`:T.message,offset:T.offset,length:T.lexeme.length})):[]))}e.$Pi=a;function r(L,M){const N=L?L.substituteConstants():void 0,T=M?M.substituteConstants():void 0;return!N&&!T?!0:!N||!T?!1:N.equals(T)}e.$Qi=r;function t(L,M){return L.cmp(M)}class n{static{this.INSTANCE=new n}constructor(){this.type=0}cmp(M){return this.type-M.type}equals(M){return M.type===this.type}substituteConstants(){return this}evaluate(M){return!1}serialize(){return"false"}keys(){return[]}map(M){return this}negate(){return o.INSTANCE}}e.$Ri=n;class o{static{this.INSTANCE=new o}constructor(){this.type=1}cmp(M){return this.type-M.type}equals(M){return M.type===this.type}substituteConstants(){return this}evaluate(M){return!0}serialize(){return"true"}keys(){return[]}map(M){return this}negate(){return n.INSTANCE}}e.$Si=o;class p{static create(M,N=null){const T=h.get(M);return typeof T=="boolean"?T?o.INSTANCE:n.INSTANCE:new p(M,N)}constructor(M,N){this.key=M,this.c=N,this.type=2}cmp(M){return M.type!==this.type?this.type-M.type:W(this.key,M.key)}equals(M){return M.type===this.type?this.key===M.key:!1}substituteConstants(){const M=h.get(this.key);return typeof M=="boolean"?M?o.INSTANCE:n.INSTANCE:this}evaluate(M){return!!M.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(M){return M.mapDefined(this.key)}negate(){return this.c||(this.c=j.create(this.key,this)),this.c}}e.$Ti=p;class O{static create(M,N,T=null){if(typeof N=="boolean")return N?p.create(M,T):j.create(M,T);const F=h.get(M);return typeof F=="boolean"?N===(F?"true":"false")?o.INSTANCE:n.INSTANCE:new O(M,N,T)}constructor(M,N,T){this.c=M,this.d=N,this.f=T,this.type=4}cmp(M){return M.type!==this.type?this.type-M.type:G(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){const M=h.get(this.c);if(typeof M=="boolean"){const N=M?"true":"false";return this.d===N?o.INSTANCE:n.INSTANCE}return this}evaluate(M){return M.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(M){return M.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$Ui=O;class D{static create(M,N){return new D(M,N)}constructor(M,N){this.d=M,this.f=N,this.type=10,this.c=null}cmp(M){return M.type!==this.type?this.type-M.type:G(this.d,this.f,M.d,M.f)}equals(M){return M.type===this.type?this.d===M.d&&this.f===M.f:!1}substituteConstants(){return this}evaluate(M){const N=M.getValue(this.f),T=M.getValue(this.d);return Array.isArray(N)?N.includes(T):typeof T=="string"&&typeof N=="object"&&N!==null?g.call(N,T):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(M){return M.mapIn(this.d,this.f)}negate(){return this.c||(this.c=k.create(this.d,this.f)),this.c}}e.$Vi=D;class k{static create(M,N){return new k(M,N)}constructor(M,N){this.d=M,this.f=N,this.type=11,this.c=D.create(M,N)}cmp(M){return M.type!==this.type?this.type-M.type:this.c.cmp(M.c)}equals(M){return M.type===this.type?this.c.equals(M.c):!1}substituteConstants(){return this}evaluate(M){return!this.c.evaluate(M)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(M){return M.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Wi=k;class I{static create(M,N,T=null){if(typeof N=="boolean")return N?j.create(M,T):p.create(M,T);const F=h.get(M);return typeof F=="boolean"?N===(F?"true":"false")?n.INSTANCE:o.INSTANCE:new I(M,N,T)}constructor(M,N,T){this.c=M,this.d=N,this.f=T,this.type=5}cmp(M){return M.type!==this.type?this.type-M.type:G(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){const M=h.get(this.c);if(typeof M=="boolean"){const N=M?"true":"false";return this.d===N?n.INSTANCE:o.INSTANCE}return this}evaluate(M){return M.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(M){return M.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$Xi=I;class j{static create(M,N=null){const T=h.get(M);return typeof T=="boolean"?T?n.INSTANCE:o.INSTANCE:new j(M,N)}constructor(M,N){this.c=M,this.d=N,this.type=3}cmp(M){return M.type!==this.type?this.type-M.type:W(this.c,M.c)}equals(M){return M.type===this.type?this.c===M.c:!1}substituteConstants(){const M=h.get(this.c);return typeof M=="boolean"?M?n.INSTANCE:o.INSTANCE:this}evaluate(M){return!M.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(M){return M.mapNot(this.c)}negate(){return this.d||(this.d=p.create(this.c,this)),this.d}}e.$Yi=j;function U(L,M){if(typeof L=="string"){const N=parseFloat(L);isNaN(N)||(L=N)}return typeof L=="string"||typeof L=="number"?M(L):n.INSTANCE}class z{static create(M,N,T=null){return U(N,F=>new z(M,F,T))}constructor(M,N,T){this.c=M,this.d=N,this.f=T,this.type=12}cmp(M){return M.type!==this.type?this.type-M.type:G(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(M){return M.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ae.create(this.c,this.d,this)),this.f}}e.$Zi=z;class x{static create(M,N,T=null){return U(N,F=>new x(M,F,T))}constructor(M,N,T){this.c=M,this.d=N,this.f=T,this.type=13}cmp(M){return M.type!==this.type?this.type-M.type:G(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(M){return M.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=Z.create(this.c,this.d,this)),this.f}}e.$1i=x;class Z{static create(M,N,T=null){return U(N,F=>new Z(M,F,T))}constructor(M,N,T){this.c=M,this.d=N,this.f=T,this.type=14}cmp(M){return M.type!==this.type?this.type-M.type:G(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(M){return M.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=x.create(this.c,this.d,this)),this.f}}e.$2i=Z;class ae{static create(M,N,T=null){return U(N,F=>new ae(M,F,T))}constructor(M,N,T){this.c=M,this.d=N,this.f=T,this.type=15}cmp(M){return M.type!==this.type?this.type-M.type:G(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(M){return M.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$3i=ae;class se{static create(M,N){return new se(M,N)}constructor(M,N){this.d=M,this.f=N,this.type=7,this.c=null}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.d<M.d)return-1;if(this.d>M.d)return 1;const N=this.f?this.f.source:"",T=M.f?M.f.source:"";return N<T?-1:N>T?1:0}equals(M){if(M.type===this.type){const N=this.f?this.f.source:"",T=M.f?M.f.source:"";return this.d===M.d&&N===T}return!1}substituteConstants(){return this}evaluate(M){const N=M.getValue(this.d);return this.f?this.f.test(N):!1}serialize(){const M=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${M}`}keys(){return[this.d]}map(M){return M.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ce.create(this)),this.c}}e.$4i=se;class ce{static create(M){return new ce(M)}constructor(M){this.c=M,this.type=8}cmp(M){return M.type!==this.type?this.type-M.type:this.c.cmp(M.c)}equals(M){return M.type===this.type?this.c.equals(M.c):!1}substituteConstants(){return this}evaluate(M){return!this.c.evaluate(M)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(M){return new ce(this.c.map(M))}negate(){return this.c}}e.$5i=ce;function Y(L){let M=null;for(let N=0,T=L.length;N<T;N++){const F=L[N].substituteConstants();if(L[N]!==F&&M===null){M=[];for(let B=0;B<N;B++)M[B]=L[B]}M!==null&&(M[N]=F)}return M===null?L:M}class K{static create(M,N,T){return K.d(M,N,T)}constructor(M,N){this.expr=M,this.c=N,this.type=6}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.expr.length<M.expr.length)return-1;if(this.expr.length>M.expr.length)return 1;for(let N=0,T=this.expr.length;N<T;N++){const F=t(this.expr[N],M.expr[N]);if(F!==0)return F}return 0}equals(M){if(M.type===this.type){if(this.expr.length!==M.expr.length)return!1;for(let N=0,T=this.expr.length;N<T;N++)if(!this.expr[N].equals(M.expr[N]))return!1;return!0}return!1}substituteConstants(){const M=Y(this.expr);return M===this.expr?this:K.create(M,this.c,!1)}evaluate(M){for(let N=0,T=this.expr.length;N<T;N++)if(!this.expr[N].evaluate(M))return!1;return!0}static d(M,N,T){const F=[];let B=!1;for(const V of M)if(V){if(V.type===1){B=!0;continue}if(V.type===0)return n.INSTANCE;if(V.type===6){F.push(...V.expr);continue}F.push(V)}if(F.length===0&&B)return o.INSTANCE;if(F.length!==0){if(F.length===1)return F[0];F.sort(t);for(let V=1;V<F.length;V++)F[V-1].equals(F[V])&&(F.splice(V,1),V--);if(F.length===1)return F[0];for(;F.length>1;){const V=F[F.length-1];if(V.type!==9)break;F.pop();const oe=F.pop(),de=F.length===0,ue=Q.create(V.expr.map(he=>K.create([he,oe],null,T)),null,de);ue&&(F.push(ue),F.sort(t))}if(F.length===1)return F[0];if(T){for(let V=0;V<F.length;V++)for(let oe=V+1;oe<F.length;oe++)if(F[V].negate().equals(F[oe]))return n.INSTANCE;if(F.length===1)return F[0]}return new K(F,N)}}serialize(){return this.expr.map(M=>M.serialize()).join(" && ")}keys(){const M=[];for(const N of this.expr)M.push(...N.keys());return M}map(M){return new K(this.expr.map(N=>N.map(M)),null)}negate(){if(!this.c){const M=[];for(const N of this.expr)M.push(N.negate());this.c=Q.create(M,this,!0)}return this.c}}e.$6i=K;class Q{static create(M,N,T){return Q.d(M,N,T)}constructor(M,N){this.expr=M,this.c=N,this.type=9}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.expr.length<M.expr.length)return-1;if(this.expr.length>M.expr.length)return 1;for(let N=0,T=this.expr.length;N<T;N++){const F=t(this.expr[N],M.expr[N]);if(F!==0)return F}return 0}equals(M){if(M.type===this.type){if(this.expr.length!==M.expr.length)return!1;for(let N=0,T=this.expr.length;N<T;N++)if(!this.expr[N].equals(M.expr[N]))return!1;return!0}return!1}substituteConstants(){const M=Y(this.expr);return M===this.expr?this:Q.create(M,this.c,!1)}evaluate(M){for(let N=0,T=this.expr.length;N<T;N++)if(this.expr[N].evaluate(M))return!0;return!1}static d(M,N,T){let F=[],B=!1;if(M){for(let V=0,oe=M.length;V<oe;V++){const de=M[V];if(de){if(de.type===0){B=!0;continue}if(de.type===1)return o.INSTANCE;if(de.type===9){F=F.concat(de.expr);continue}F.push(de)}}if(F.length===0&&B)return n.INSTANCE;F.sort(t)}if(F.length!==0){if(F.length===1)return F[0];for(let V=1;V<F.length;V++)F[V-1].equals(F[V])&&(F.splice(V,1),V--);if(F.length===1)return F[0];if(T){for(let V=0;V<F.length;V++)for(let oe=V+1;oe<F.length;oe++)if(F[V].negate().equals(F[oe]))return o.INSTANCE;if(F.length===1)return F[0]}return new Q(F,N)}}serialize(){return this.expr.map(M=>M.serialize()).join(" || ")}keys(){const M=[];for(const N of this.expr)M.push(...N.keys());return M}map(M){return new Q(this.expr.map(N=>N.map(M)),null)}negate(){if(!this.c){const M=[];for(const N of this.expr)M.push(N.negate());for(;M.length>1;){const N=M.shift(),T=M.shift(),F=[];for(const B of re(N))for(const V of re(T))F.push(K.create([B,V],null,!1));M.unshift(Q.create(F,null,!1))}this.c=Q.create(M,this,!0)}return this.c}}e.$7i=Q;class q extends p{static{this.d=[]}static all(){return q.d.values()}constructor(M,N,T){super(M,null),this.f=N,typeof T=="object"?q.d.push({...T,key:M}):T!==!0&&q.d.push({key:M,description:T,type:N!=null?typeof N:void 0})}bindTo(M){return M.createKey(this.key,this.f)}getValue(M){return M.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(M){return O.create(this.key,M)}notEqualsTo(M){return I.create(this.key,M)}}e.$8i=q,e.$9i=(0,R.$Qh)("contextKeyService");function W(L,M){return L<M?-1:L>M?1:0}function G(L,M,N,T){return L<N?-1:L>N?1:M<T?-1:M>T?1:0}function H(L,M){if(L.type===0||M.type===1)return!0;if(L.type===9)return M.type===9?X(L.expr,M.expr):!1;if(M.type===9){for(const N of M.expr)if(H(L,N))return!0;return!1}if(L.type===6){if(M.type===6)return X(M.expr,L.expr);for(const N of L.expr)if(H(N,M))return!0;return!1}return L.equals(M)}e.$0i=H;function X(L,M){let N=0,T=0;for(;N<L.length&&T<M.length;){const F=L[N].cmp(M[T]);if(F<0)return!1;F===0&&N++,T++}return N===L.length}function re(L){return L.type===9?L.expr:[L]}}),define(ie[91],ne([0,1,5]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tm=e.$sm=e.$rm=e.ID=void 0,e.ID="diagnosticsService",e.$rm=(0,S.$Qh)(e.ID);function A(R){return!!R.hostName&&!!R.errorMessage}e.$sm=A;class s{async getPerformanceInfo(C,P){return{}}async getSystemInfo(C,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(C,P){return""}async getWorkspaceFileExtensions(C){return{extensions:[]}}async reportWorkspaceStats(C){}}e.$tm=s}),define(ie[115],ne([0,1,19,73,166,5,46,4,37]),function(J,e,S,A,s,R,C,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jv=e.$Iv=e.ConfirmResult=e.$Hv=e.$Gv=e.$Fv=void 0,e.$Fv=(0,R.$Qh)("dialogService");var c;(function(m){m[m.Confirmation=1]="Confirmation",m[m.Prompt=2]="Prompt",m[m.Input=3]="Input"})(c||(c={}));class g{a(w){return this.d(w,c.Confirmation)}b(w){return this.d(w,c.Prompt)}c(w){return this.d(w,c.Input)}d(w,$){const d=[];switch($){case c.Confirmation:{const u=w;u.primaryButton?d.push(u.primaryButton):d.push((0,s.localize)(0,null)),u.cancelButton?d.push(u.cancelButton):d.push((0,s.localize)(1,null));break}case c.Prompt:{const u=w;Array.isArray(u.buttons)&&u.buttons.length>0&&d.push(...u.buttons.map(E=>E.label)),u.cancelButton&&(u.cancelButton===!0?d.push((0,s.localize)(2,null)):typeof u.cancelButton=="string"?d.push(u.cancelButton):u.cancelButton.label?d.push(u.cancelButton.label):d.push((0,s.localize)(3,null))),d.length===0&&d.push((0,s.localize)(4,null));break}case c.Input:{const u=w;u.primaryButton?d.push(u.primaryButton):d.push((0,s.localize)(5,null)),u.cancelButton?d.push(u.cancelButton):d.push((0,s.localize)(6,null));break}}return d}e(w){if(typeof w=="string")return w;if(typeof w=="number")return w===A.default.Info?"info":w===A.default.Error?"error":w===A.default.Warning?"warning":"none"}f(w,$,d){const u=[...w.buttons??[]];w.cancelButton&&typeof w.cancelButton!="string"&&typeof w.cancelButton!="boolean"&&u.push(w.cancelButton);let E=u[$]?.run({checkboxChecked:d});return E instanceof Promise||(E=Promise.resolve(E)),{result:E,checkboxChecked:d}}}e.$Gv=g,e.$Hv=(0,R.$Qh)("fileDialogService");var b;(function(m){m[m.SAVE=0]="SAVE",m[m.DONT_SAVE=1]="DONT_SAVE",m[m.CANCEL=2]="CANCEL"})(b||(e.ConfirmResult=b={}));const y=10;function f(m){const w=[];return w.push(...m.slice(0,y).map($=>typeof $=="string"?$:(0,S.$tg)($))),m.length>y&&(m.length-y===1?w.push((0,s.localize)(7,null)):w.push((0,s.localize)(8,null,m.length-y))),w.push(""),w.join(`
`)}e.$Iv=f;function v(m,w){const $=(0,h.$8m)(m);let d=($.buttons??[]).map(i=>(0,C.$Cv)(i)),u=(m.buttons||[]).map((i,a)=>a),E=0,l=$.cancelId??d.length-1;if(d.length>1){const i=typeof l=="number"?d[l]:void 0;if(P.$l||P.$k){if(typeof i=="string"&&d.length>1&&l!==1){d.splice(l,1),d.splice(1,0,i);const a=u[l];u.splice(l,1),u.splice(1,0,a),l=1}P.$l&&d.length>1&&(d=d.reverse(),u=u.reverse(),E=d.length-1,typeof i=="string"&&(l=E-1))}else if(P.$j&&typeof i=="string"&&d.length>1&&l!==d.length-1){d.splice(l,1),d.push(i);const a=u[l];u.splice(l,1),u.push(a),l=d.length-1}}return $.buttons=d,$.defaultId=E,$.cancelId=l,$.noLink=!0,$.title=$.title||w.nameLong,{options:$,buttonIndeces:u}}e.$Jv=v}),define(ie[116],ne([0,1,5]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eU=e.$dU=e.KnownStorageProvider=e.PasswordStoreCLIOption=e.$cU=e.$bU=void 0,e.$bU=(0,S.$Qh)("encryptionService"),e.$cU=(0,S.$Qh)("encryptionMainService");var A;(function(P){P.kwallet="kwallet",P.kwallet5="kwallet5",P.gnome="gnome",P.gnomeKeyring="gnome-keyring",P.gnomeLibsecret="gnome-libsecret",P.basic="basic"})(A||(e.PasswordStoreCLIOption=A={}));var s;(function(P){P.unknown="unknown",P.basicText="basic_text",P.gnomeAny="gnome_any",P.gnomeLibsecret="gnome_libsecret",P.gnomeKeyring="gnome_keyring",P.kwallet="kwallet",P.kwallet5="kwallet5",P.kwallet6="kwallet6",P.dplib="dpapi",P.keychainAccess="keychain_access"})(s||(e.KnownStorageProvider=s={}));function R(P){return P==="kwallet"||P==="kwallet5"||P==="kwallet6"}e.$dU=R;function C(P){return P==="gnome_any"||P==="gnome_libsecret"||P==="gnome_keyring"}e.$eU=C}),define(ie[36],ne([0,1,5]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yh=e.$Xh=void 0,e.$Xh=(0,S.$Qh)("environmentService"),e.$Yh=(0,S.$Rh)(e.$Xh)}),define(ie[117],ne([0,1,170,5]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$bo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=void 0,e.$2n="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$3n=new RegExp(e.$2n),e.$4n="__web_extension",e.$5n="skipWalkthrough",e.$6n="extensionsSync",e.$7n="dependecyOrPackExtensionInstall";function s($){switch($){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$8n=s;function R($){switch($){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$9n=R;function C($,d){switch($){case 3:return d==="x64"?"win32-x64":d==="arm64"?"win32-arm64":"unknown";case 2:return d==="x64"?"linux-x64":d==="arm64"?"linux-arm64":d==="arm"?"linux-armhf":"unknown";case"alpine":return d==="x64"?"alpine-x64":d==="arm64"?"alpine-arm64":"unknown";case 1:return d==="x64"?"darwin-x64":d==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$0n=C;function P($,d){return d==="web"&&!$.includes("web")}e.$$n=P;function h($,d,u){return P(d,u)?!1:$==="undefined"||$==="universal"?!0:$==="unknown"?!1:$===u}e.$_n=h;function c($){return $&&typeof $=="object"&&typeof $.id=="string"&&(!$.uuid||typeof $.uuid=="string")}e.$ao=c;var g;(function($){$[$.NoneOrRelevance=0]="NoneOrRelevance",$[$.LastUpdatedDate=1]="LastUpdatedDate",$[$.Title=2]="Title",$[$.PublisherName=3]="PublisherName",$[$.InstallCount=4]="InstallCount",$[$.PublishedDate=10]="PublishedDate",$[$.AverageRating=6]="AverageRating",$[$.WeightedRating=12]="WeightedRating"})(g||(e.SortBy=g={}));var b;(function($){$[$.Default=0]="Default",$[$.Ascending=1]="Ascending",$[$.Descending=2]="Descending"})(b||(e.SortOrder=b={}));var y;(function($){$.Install="install",$.Uninstall="uninstall"})(y||(e.StatisticType=y={}));var f;(function($){$[$.None=1]="None",$[$.Install=2]="Install",$[$.Update=3]="Update",$[$.Migrate=4]="Migrate"})(f||(e.InstallOperation=f={})),e.$bo=(0,A.$Qh)("extensionGalleryService");var v;(function($){$.Unsupported="Unsupported",$.Deprecated="Deprecated",$.Malicious="Malicious",$.Incompatible="Incompatible",$.IncompatibleTargetPlatform="IncompatibleTargetPlatform",$.ReleaseVersionNotFound="ReleaseVersionNotFound",$.Invalid="Invalid",$.Download="Download",$.Extract="Extract",$.Delete="Delete",$.Rename="Rename",$.CorruptZip="CorruptZip",$.IncompleteZip="IncompleteZip",$.Signature="Signature",$.Internal="Internal"})(v||(e.ExtensionManagementErrorCode=v={}));var m;(function($){$.UnknownError="UnknownError",$.PackageIsInvalidZip="PackageIsInvalidZip",$.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(m||(e.ExtensionSignaturetErrorCode=m={}));class w extends Error{constructor(d,u){super(d),this.code=u,this.name=u}}e.$co=w,e.$do=(0,A.$Qh)("extensionManagementService"),e.$eo="extensionsIdentifiers/disabled",e.$fo="extensionsIdentifiers/enabled",e.$go=(0,A.$Qh)("IGlobalExtensionEnablementService"),e.$ho=(0,A.$Qh)("IExtensionTipsService"),e.$io=(0,S.localize)(0,null),e.$jo={value:e.$io,original:"Extensions"},e.$ko={value:(0,S.localize)(1,null),original:"Preferences"}}),define(ie[209],ne([0,1,5]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l7b=e.$k7b=void 0,e.$k7b=(0,S.$Qh)("extensionHostStarter"),e.$l7b="extensionHostStarter"}),define(ie[210],ne([0,1,5]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uYb=e.$tYb=void 0,e.$tYb=(0,S.$Qh)("externalTerminal"),e.$uYb="Terminal.app"}),define(ie[211],ne([0,1,5]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$n7b=void 0,e.$n7b=(0,S.$Qh)("externalTerminal")}),define(ie[212],ne([0,1,47,13,9,4,75,21,88,174,210]),function(J,e,S,A,s,R,C,P,h,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q7b=e.$p7b=e.$o7b=void 0;const b=c.localize(0,null);class y{async getDefaultTerminalForPlatforms(){return{windows:f.getDefaultTerminalWindows(),linux:await m.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class f extends y{static{this.b="cmd.exe"}openTerminal(E,l){return this.spawnTerminal(S,E,h.$Cl(),l)}spawnTerminal(E,l,i,a){const r=l.windowsExec||f.getDefaultTerminalWindows();a&&a[1]===":"&&(a=a[0].toUpperCase()+a.substr(1));const t=s.$nc(r,".exe").toLowerCase();if(t==="cmder")return E.spawn(r,a?[a]:void 0),Promise.resolve(void 0);const n=["/c","start","/wait"];return r.indexOf(" ")>=0&&n.push('""'),n.push(r),t==="wt"&&n.push("-d ."),new Promise((o,p)=>{const O=w(process),D=E.spawn(i,n,{cwd:a,env:O});D.on("error",p),D.on("exit",()=>o())})}runInTerminal(E,l,i,a,r){const t="windowsExec"in r&&r.windowsExec?r.windowsExec:f.getDefaultTerminalWindows();return new Promise((n,o)=>{const p=`"${l} - ${b}"`,O=`""${i.join('" "')}" & pause"`,D=Object.assign({},w(process),a);Object.keys(D).filter(z=>D[z]===null).forEach(z=>delete D[z]);const k={cwd:l,env:D,windowsVerbatimArguments:!0};let I,j;s.$nc(t,".exe")==="wt"?(I=t,j=["-d",".",f.b,"/c",O]):(I=f.b,j=["/c","start",p,"/wait",t,"/c",O]),S.spawn(I,j,k).on("error",z=>{o($(z))}),n(void 0)})}static getDefaultTerminalWindows(){if(!f.d){const E=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");f.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${E?"Sysnative":"System32"}\\cmd.exe`}return f.d}}e.$o7b=f;class v extends y{static{this.b="/usr/bin/osascript"}openTerminal(E,l){return this.spawnTerminal(S,E,l)}runInTerminal(E,l,i,a,r){const t=r.osxExec||g.$uYb;return new Promise((n,o)=>{if(t===g.$uYb||t==="iTerm.app"){const p=t===g.$uYb?"TerminalHelper":"iTermHelper",D=[A.$dg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${p}.scpt`).fsPath,"-t",E||b,"-w",l];for(const j of i)D.push("-a"),D.push(j);if(a){const j=Object.assign({},w(process),a);for(const U in j){const z=j[U];z===null?(D.push("-u"),D.push(U)):(D.push("-e"),D.push(`${U}=${z}`))}}let k="";const I=S.spawn(v.b,D);I.on("error",j=>{o($(j))}),I.stderr.on("data",j=>{k+=j.toString()}),I.on("exit",j=>{if(j===0)n(void 0);else if(k){const U=k.split(`
`,1);o(new Error(U[0]))}else o(new Error(c.localize(1,null,p,j)))})}else o(new Error(c.localize(2,null,t)))})}spawnTerminal(E,l,i){const a=l.osxExec||g.$uYb;return new Promise((r,t)=>{const n=["-a",a];i&&n.push(i);const o=w(process),p=E.spawn("/usr/bin/open",n,{cwd:i,env:o});p.on("error",t),p.on("exit",()=>r())})}}e.$p7b=v;class m extends y{static{this.b=c.localize(3,null)}openTerminal(E,l){return this.spawnTerminal(S,E,l)}runInTerminal(E,l,i,a,r){const t=r.linuxExec?Promise.resolve(r.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((n,o)=>{const p=[];t.then(O=>{O.indexOf("gnome-terminal")>=0?p.push("-x"):p.push("-e"),p.push("bash"),p.push("-c");const D=`${d(i)}; echo; read -p "${m.b}" -n1;`;p.push(`''${D}''`);const k=Object.assign({},w(process),a);Object.keys(k).filter(z=>k[z]===null).forEach(z=>delete k[z]);const I={cwd:l,env:k};let j="";const U=S.spawn(O,p,I);U.on("error",z=>{o($(z))}),U.stderr.on("data",z=>{j+=z.toString()}),U.on("exit",z=>{if(z===0)n(void 0);else if(j){const x=j.split(`
`,1);o(new Error(x[0]))}else o(new Error(c.localize(4,null,O,z)))})})})}static async getDefaultTerminalLinuxReady(){if(!m.d)if(!R.$l)m.d=Promise.resolve("xterm");else{const E=await P.Promises.exists("/etc/debian_version");m.d=new Promise(l=>{E?l("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?l("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?l("konsole"):process.env.COLORTERM?l(process.env.COLORTERM):process.env.TERM?l(process.env.TERM):l("xterm")})}return m.d}spawnTerminal(E,l,i){const a=l.linuxExec?Promise.resolve(l.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((r,t)=>{a.then(n=>{const o=w(process),p=E.spawn(n,[],{cwd:i,env:o});p.on("error",t),p.on("exit",()=>r())})})}}e.$q7b=m;function w(u){const E={...u.env};return(0,C.$Al)(E),E}function $(u){return"errno"in u&&u.errno==="ENOENT"&&"path"in u&&typeof u.path=="string"?new Error(c.localize(5,null,u.path)):u}function d(u){let E="";for(const l of u)l.indexOf(" ")>=0?E+='"'+l+'"':E+=l,E+=" ";return E}}),define(ie[16],ne([0,1,56,9,27,12,7,176,5,4,13,71]),function(J,e,S,A,s,R,C,P,h,c,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.FileKind=e.$Dk=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.FileOperationResult=e.$wk=e.$vk=e.$uk=e.$tk=e.$sk=e.FileChangeType=e.$rk=e.FileOperation=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.FileSystemProviderErrorCode=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.FileSystemProviderCapabilities=e.$bk=e.FilePermission=e.FileType=e.$ak=e.$_j=void 0,e.$_j=(0,h.$Qh)("fileService");function y(H){return H.create===!0}e.$ak=y;var f;(function(H){H[H.Unknown=0]="Unknown",H[H.File=1]="File",H[H.Directory=2]="Directory",H[H.SymbolicLink=64]="SymbolicLink"})(f||(e.FileType=f={}));var v;(function(H){H[H.Readonly=1]="Readonly",H[H.Locked=2]="Locked"})(v||(e.FilePermission=v={}));function m(H){const X=H;return!!X&&typeof X.onDidChange=="function"}e.$bk=m;var w;(function(H){H[H.None=0]="None",H[H.FileReadWrite=2]="FileReadWrite",H[H.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",H[H.FileReadStream=16]="FileReadStream",H[H.FileFolderCopy=8]="FileFolderCopy",H[H.PathCaseSensitive=1024]="PathCaseSensitive",H[H.Readonly=2048]="Readonly",H[H.Trash=4096]="Trash",H[H.FileWriteUnlock=8192]="FileWriteUnlock",H[H.FileAtomicRead=16384]="FileAtomicRead",H[H.FileAtomicWrite=32768]="FileAtomicWrite",H[H.FileAtomicDelete=65536]="FileAtomicDelete",H[H.FileClone=131072]="FileClone"})(w||(e.FileSystemProviderCapabilities=w={}));function $(H){return!!(H.capabilities&2)}e.$ck=$;function d(H){return!!(H.capabilities&8)}e.$dk=d;function u(H){return!!(H.capabilities&131072)}e.$ek=u;function E(H){return!!(H.capabilities&4)}e.$fk=E;function l(H){return!!(H.capabilities&16)}e.$gk=l;function i(H){return $(H)?!!(H.capabilities&16384):!1}e.$hk=i;function a(H){return $(H)?!!(H.capabilities&32768):!1}e.$ik=a;function r(H){return!!(H.capabilities&65536)}e.$jk=r;function t(H){return!!(H.capabilities&2048)}e.$kk=t;var n;(function(H){H.FileExists="EntryExists",H.FileNotFound="EntryNotFound",H.FileNotADirectory="EntryNotADirectory",H.FileIsADirectory="EntryIsADirectory",H.FileExceedsStorageQuota="EntryExceedsStorageQuota",H.FileTooLarge="EntryTooLarge",H.FileWriteLocked="EntryWriteLocked",H.NoPermissions="NoPermissions",H.Unavailable="Unavailable",H.Unknown="Unknown"})(n||(e.FileSystemProviderErrorCode=n={}));class o extends Error{static create(X,re){const L=new o(X.toString(),re);return D(L,re),L}constructor(X,re){super(X),this.code=re}}e.$lk=o;function p(H,X){return o.create(H,X)}e.$mk=p;function O(H){return H||p((0,P.localize)(0,null),n.Unknown)}e.$nk=O;function D(H,X){return H.name=X?`${X} (FileSystemError)`:"FileSystemError",H}e.$ok=D;function k(H){if(!H)return n.Unknown;if(H instanceof o)return H.code;const X=/^(.+) \(FileSystemError\)$/.exec(H.name);if(!X)return n.Unknown;switch(X[1]){case n.FileExists:return n.FileExists;case n.FileIsADirectory:return n.FileIsADirectory;case n.FileNotADirectory:return n.FileNotADirectory;case n.FileNotFound:return n.FileNotFound;case n.FileTooLarge:return n.FileTooLarge;case n.FileWriteLocked:return n.FileWriteLocked;case n.NoPermissions:return n.NoPermissions;case n.Unavailable:return n.Unavailable}return n.Unknown}e.$pk=k;function I(H){if(H instanceof ae)return H.fileOperationResult;switch(k(H)){case n.FileNotFound:return 1;case n.FileIsADirectory:return 0;case n.FileNotADirectory:return 9;case n.FileWriteLocked:return 5;case n.NoPermissions:return 6;case n.FileExists:return 4;case n.FileTooLarge:return 7;default:return 10}}e.$qk=I;var j;(function(H){H[H.CREATE=0]="CREATE",H[H.DELETE=1]="DELETE",H[H.MOVE=2]="MOVE",H[H.COPY=3]="COPY",H[H.WRITE=4]="WRITE"})(j||(e.FileOperation=j={}));class U{constructor(X,re,L){this.resource=X,this.operation=re,this.target=L}isOperation(X){return this.operation===X}}e.$rk=U;var z;(function(H){H[H.UPDATED=0]="UPDATED",H[H.ADDED=1]="ADDED",H[H.DELETED=2]="DELETED"})(z||(e.FileChangeType=z={}));class x{static{this.a=null}constructor(X,re){this.c=re,this.b=void 0,this.d=new b.$V(()=>{const L=S.$Wh.forUris(()=>this.c);return L.fill(this.rawAdded.map(M=>[M,!0])),L}),this.f=new b.$V(()=>{const L=S.$Wh.forUris(()=>this.c);return L.fill(this.rawUpdated.map(M=>[M,!0])),L}),this.g=new b.$V(()=>{const L=S.$Wh.forUris(()=>this.c);return L.fill(this.rawDeleted.map(M=>[M,!0])),L}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const L of X){switch(L.type){case 1:this.rawAdded.push(L.resource);break;case 0:this.rawUpdated.push(L.resource);break;case 2:this.rawDeleted.push(L.resource);break}this.b!==x.a&&(typeof L.cId=="number"?this.b===void 0?this.b=L.cId:this.b!==L.cId&&(this.b=x.a):this.b!==void 0&&(this.b=x.a))}}contains(X,...re){return this.h(X,{includeChildren:!1},...re)}affects(X,...re){return this.h(X,{includeChildren:!0},...re)}h(X,re,...L){if(!X)return!1;const M=L.length>0;return!!((!M||L.includes(1))&&(this.d.value.get(X)||re.includeChildren&&this.d.value.findSuperstr(X))||(!M||L.includes(0))&&(this.f.value.get(X)||re.includeChildren&&this.f.value.findSuperstr(X))||(!M||L.includes(2))&&(this.g.value.findSubstr(X)||re.includeChildren&&this.g.value.findSuperstr(X)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(X){return this.b===X}hasCorrelation(){return typeof this.b=="number"}}e.$sk=x;function Z(H,X,re){return!H||!X||H===X||X.length>H.length?!1:(X.charAt(X.length-1)!==A.sep&&(X+=A.sep),re?(0,s.$4e)(H,X):H.indexOf(X)===0)}e.$tk=Z;class ae extends Error{constructor(X,re,L){super(X),this.fileOperationResult=re,this.options=L}}e.$uk=ae;class se extends ae{constructor(X,re,L,M){super(X,re,M),this.fileOperationResult=re,this.size=L}}e.$vk=se;class ce extends ae{constructor(X,re,L){super(X,2,L),this.stat=re}}e.$wk=ce;var Y;(function(H){H[H.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",H[H.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",H[H.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",H[H.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",H[H.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",H[H.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",H[H.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",H[H.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",H[H.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",H[H.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",H[H.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Y||(e.FileOperationResult=Y={})),e.$xk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$yk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$zk="files.associations",e.$Ak="files.exclude",e.$Bk="files.readonlyInclude",e.$Ck="files.readonlyExclude",e.$Dk="files.readonlyFromPermissions";var K;(function(H){H[H.FILE=0]="FILE",H[H.FOLDER=1]="FOLDER",H[H.ROOT_FOLDER=2]="ROOT_FOLDER"})(K||(e.FileKind=K={})),e.$Ek="";function Q(H){if(!(typeof H.size!="number"||typeof H.mtime!="number"))return H.mtime.toString(29)+H.size.toString(31)}e.$Fk=Q;async function q(H,X){if(!X.hasProvider(C.URI.from({scheme:H.scheme})))return new Promise(re=>{const L=X.onDidChangeFileSystemProviderRegistrations(M=>{M.scheme===H.scheme&&M.added&&(L.dispose(),re())})})}e.$Gk=q;class W{static{this.KB=1024}static{this.MB=W.KB*W.KB}static{this.GB=W.MB*W.KB}static{this.TB=W.GB*W.KB}static formatSize(X){return(0,R.$Df)(X)||(X=0),X<W.KB?(0,P.localize)(1,null,X.toFixed(0)):X<W.MB?(0,P.localize)(2,null,(X/W.KB).toFixed(2)):X<W.GB?(0,P.localize)(3,null,(X/W.MB).toFixed(2)):X<W.TB?(0,P.localize)(4,null,(X/W.GB).toFixed(2)):(0,P.localize)(5,null,(X/W.TB).toFixed(2))}}e.$Hk=W;function G(H){const X=typeof H=="string"||H?.scheme===g.Schemas.vscodeRemote;return typeof H!="string"&&H?.scheme===g.Schemas.file?1024*W.MB:X?10*W.MB:c.$p?50*W.MB:1024*W.MB}e.$Ik=G}),define(ie[118],ne([0,1,17,14,177,16]),function(J,e,S,A,s,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qp=void 0;async function C(g,b,y,f,v,m){let w;try{await P(g,b,y,f,v,m)}catch($){w=$}finally{w&&v.errorTransformer&&(w=v.errorTransformer(w)),typeof w<"u"&&y.error(w),y.end()}}e.$Qp=C;async function P(g,b,y,f,v,m){h(m);const w=await g.open(b,{create:!1});try{h(m);let $=0,d=0,u=v&&typeof v.length=="number"?v.length:void 0,E=S.$ce.alloc(Math.min(v.bufferSize,typeof u=="number"?u:v.bufferSize)),l=v&&typeof v.position=="number"?v.position:0,i=0;do d=await g.read(w,l,E.buffer,i,E.byteLength-i),l+=d,i+=d,$+=d,typeof u=="number"&&(u-=d),i===E.byteLength&&(await y.write(f(E)),E=S.$ce.alloc(Math.min(v.bufferSize,typeof u=="number"?u:v.bufferSize)),i=0);while(d>0&&(typeof u!="number"||u>0)&&h(m)&&c($,v));if(i>0){let a=i;typeof u=="number"&&(a=Math.min(i,u)),y.write(f(E.slice(0,a)))}}catch($){throw(0,R.$nk)($)}finally{await g.close(w)}}function h(g){if(g.isCancellationRequested)throw(0,A.$6)();return!0}function c(g,b){if(typeof b?.limits?.size=="number"&&g>b.limits.size)throw(0,R.$mk)((0,s.localize)(0,null),R.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ie[64],ne([0,1,104,2,9,4,7,16]),function(J,e,S,A,s,R,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=e.$Yp=e.$Xp=e.$Wp=e.$Vp=e.$Up=e.$Tp=e.$Sp=void 0;function h($){return $.recursive===!0}e.$Sp=h;class c extends A.$Sc{static{this.a=5}constructor(d,u,E,l){super(),this.h=d,this.j=u,this.m=E,this.n=l,this.c=this.B(new A.$Tc),this.f=void 0,this.g=0}s(){const d=new A.$Rc;this.c.value=d,this.b=this.r(d),this.b.setVerboseLogging(this.m),d.add(this.b.onDidChangeFile(u=>this.h(u))),d.add(this.b.onDidLogMessage(u=>this.j(u))),d.add(this.b.onDidError(u=>this.t(u)))}t(d){this.n.restartOnError?this.g<c.a&&this.f?(this.w(`restarting watcher after error: ${d}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${d}`):this.w(d)}u(d){this.g++,this.s(),this.watch(d)}async watch(d){this.f=d,await this.b?.watch(d)}async setVerboseLogging(d){this.m=d,await this.b?.setVerboseLogging(d)}w(d){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${d}`})}y(d){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${d}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Tp=c;class g extends c{constructor(d,u,E){super(d,u,E,{type:"node.js",restartOnError:!1})}}e.$Up=g;class b extends c{constructor(d,u,E){super(d,u,E,{type:"universal",restartOnError:!0})}}e.$Vp=b;function y($){return $.map(d=>({type:d.type,resource:C.URI.revive(d.resource),cId:d.cId}))}e.$Wp=y;function f($){const d=new w;for(const u of $)d.processEvent(u);return d.coalesce()}e.$Xp=f;function v($,d){return typeof d=="string"&&!d.startsWith(S.$tj)&&!(0,s.$ic)(d)?{base:$,pattern:d}:d}e.$Yp=v;function m($,d){const u=[];for(const E of d)u.push((0,S.$xj)(v($,E)));return u}e.$Zp=m;class w{constructor(){this.a=new Set,this.b=new Map}c(d){return R.$l?d.resource.fsPath:d.resource.fsPath.toLowerCase()}processEvent(d){const u=this.b.get(this.c(d));let E=!1;if(u){const l=u.type,i=d.type;u.resource.fsPath!==d.resource.fsPath&&(d.type===2||d.type===1)?E=!0:l===1&&i===2?(this.b.delete(this.c(d)),this.a.delete(u)):l===2&&i===1?u.type=0:l===1&&i===0||(u.type=i)}else E=!0;E&&(this.a.add(d),this.b.set(this.c(d),d))}coalesce(){const d=[],u=[];return Array.from(this.a).filter(E=>E.type!==2?(d.push(E),!1):!0).sort((E,l)=>E.resource.fsPath.length-l.resource.fsPath.length).filter(E=>u.some(l=>(0,P.$tk)(E.resource.fsPath,l,!R.$l))?!1:(u.push(E.resource.fsPath),!0)).concat(d)}}}),define(ie[213],ne([0,1,17,49,14,3,2,61,32,16,64]),function(J,e,S,A,s,R,C,P,h,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wN=e.$vN=void 0,e.$vN="localFilesystem";class b extends C.$Sc{constructor(f,v){super(),this.a=f,this.b=v,this.onDidChangeCapabilities=R.Event.None,this.f=this.B(new R.$Od),this.onDidChangeFile=this.f.event,this.g=this.B(new R.$Od),this.onDidWatchError=this.g.event,this.h=(0,h.$fg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(f){return this.a.call("stat",[f])}readdir(f){return this.a.call("readdir",[f])}async readFile(f,v){const{buffer:m}=await this.a.call("readFile",[f,v]);return m}readFileStream(f,v,m){const w=(0,P.$3d)(d=>S.$ce.concat(d.map(u=>S.$ce.wrap(u))).buffer),$=new C.$Rc;return $.add(this.a.listen("readFileStream",[f,v])(d=>{if(d instanceof S.$ce)w.write(d.buffer);else{if(d==="end")w.end();else{let u;if(d instanceof Error)u=d;else{const E=d;u=(0,c.$mk)(E.message??(0,A.$Bi)(E),E.code??c.FileSystemProviderErrorCode.Unknown)}w.error(u),w.end()}$.dispose()}})),$.add(m.onCancellationRequested(()=>{w.error((0,s.$6)()),w.end(),$.dispose()})),w}writeFile(f,v,m){return this.a.call("writeFile",[f,S.$ce.wrap(v),m])}open(f,v){return this.a.call("open",[f,v])}close(f){return this.a.call("close",[f])}async read(f,v,m,w,$){const[d,u]=await this.a.call("read",[f,v,$]);return m.set(d.buffer.slice(0,u),w),u}write(f,v,m,w,$){return this.a.call("write",[f,v,S.$ce.wrap(m),w,$])}mkdir(f){return this.a.call("mkdir",[f])}delete(f,v){return this.a.call("delete",[f,v])}rename(f,v,m){return this.a.call("rename",[f,v,m])}copy(f,v,m){return this.a.call("copy",[f,v,m])}cloneFile(f,v){return this.a.call("cloneFile",[f,v])}j(){this.B(this.a.listen("fileChange",[this.h])(f=>{if(Array.isArray(f)){const v=f;this.f.fire((0,g.$Wp)(v))}else{const v=f;this.g.fire(v)}}))}watch(f,v){const m=(0,h.$fg)();return this.a.call("watch",[this.h,m,f,v]),(0,C.$Qc)(()=>this.a.call("unwatch",[this.h,m]))}}e.$wN=b}),define(ie[214],ne([0,1,45,8,22,33,2,84,9,4,19,7,105,21,64]),function(J,e,S,A,s,R,C,P,h,c,g,b,y,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=e.$aq=void 0;class m extends C.$Sc{static{this.a=100}static{this.b=75}constructor(d,u,E,l){super(),this.m=d,this.n=u,this.r=E,this.s=l,this.c=this.B(new A.$0g({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},i=>this.n(i))),this.f=this.B(new A.$9g(i=>this.z(i),m.b)),this.g=(0,v.$Zp)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,v.$Zp)(this.m.path,this.m.includes):void 0,this.j=new s.$Yd,this.ready=this.t()}async t(){try{const d=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const u=await f.Promises.stat(d);this.B(await this.w(d,u.isDirectory()))}catch(d){d.code!=="ENOENT"?this.D(d):this.G(d)}}async u(d){let u=d.path;try{u=await f.Promises.realpath(d.path),d.path===u&&(u=await(0,y.$0p)(d.path)??d.path),d.path!==u&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${d.path}, real: ${u})`)}catch{}return u}async w(d,u){if(c.$k&&(0,R.$Yf)(d,"/Volumes/",!0))return this.D(`Refusing to watch ${d} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),C.$Sc.None;const E=new s.$Yd(this.j.token),l=new C.$Rc;try{const i=b.URI.file(this.m.path),a=(0,h.$nc)(d),r=(0,S.watch)(d);l.add((0,C.$Qc)(()=>{r.removeAllListeners(),r.close()})),this.G(`Started watching: '${d}'`);const t=new Set;if(u)try{for(const o of await f.Promises.readdir(d))t.add(o)}catch(o){this.D(o)}const n=new Map;l.add((0,C.$Qc)(()=>{for(const[,o]of n)o.dispose();n.clear()})),r.on("error",(o,p)=>{this.D(`Failed to watch ${d} for changes using fs.watch() (${o}, ${p})`),this.dispose()}),r.on("change",(o,p)=>{if(E.token.isCancellationRequested)return;this.G(`[raw] ["${o}"] ${p}`);let O="";if(p&&(O=p.toString(),c.$k&&(O=(0,P.$pl)(O))),!(!O||o!=="change"&&o!=="rename"))if(u)if(o==="rename"){n.get(O)?.dispose();const D=setTimeout(async()=>{if(n.delete(O),O===a&&!await f.Promises.exists(d)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const k=await this.C((0,h.$jc)(d,O));if(E.token.isCancellationRequested)return;let I;k?t.has(O)?I=0:(I=1,t.add(O)):(t.delete(O),I=2),this.y({resource:(0,g.$wg)(i,O),type:I,cId:this.m.correlationId})},m.a);n.set(O,(0,C.$Qc)(()=>clearTimeout(D)))}else{let D;t.has(O)?D=0:(D=1,t.add(O)),this.y({resource:(0,g.$wg)(i,O),type:D,cId:this.m.correlationId})}else if(o==="rename"||O!==a){const D=setTimeout(async()=>{const k=await f.Promises.exists(d);E.token.isCancellationRequested||(k?(this.y({resource:i,type:0,cId:this.m.correlationId},!0),l.add(await this.w(d,!1))):(this.y({resource:i,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},m.a);l.clear(),l.add((0,C.$Qc)(()=>clearTimeout(D)))}else this.y({resource:i,type:0,cId:this.m.correlationId},!0)})}catch(i){await f.Promises.exists(d)&&!E.token.isCancellationRequested&&this.D(`Failed to watch ${d} for changes using fs.watch() (${i.toString()})`)}return(0,C.$Qc)(()=>{E.dispose(!0),l.dispose()})}y(d,u=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.resource.fsPath}`),!u&&this.g.some(E=>E(d.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${d.resource.fsPath}`):!u&&this.h&&this.h.length>0&&!this.h.some(E=>E(d.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${d.resource.fsPath}`):this.f.work(d))}z(d){const u=(0,v.$Xp)(d);if(u.length>0){if(this.s)for(const l of u)this.G(` >> normalized ${l.type===1?"[ADDED]":l.type===2?"[DELETED]":"[CHANGED]"} ${l.resource.fsPath}`);this.c.work(u)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${u[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${u.length}, most recent change: ${u[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(d){if(c.$l)return f.Promises.exists(d);try{const u=(0,h.$nc)(d);return(await f.Promises.readdir((0,h.$mc)(d))).some(l=>l===u)}catch(u){return this.G(u),!1}}setVerboseLogging(d){this.s=d}D(d){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${d}`})}F(d){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${d}`})}G(d){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${d}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$aq=m;async function w($,d,u,E,l=512){const i=await f.Promises.open($,"r"),a=Buffer.allocUnsafe(l),r=new s.$Yd(E);let t,n=!1;const o={path:$,excludes:[],recursive:!1},p=new m(o,O=>{(async()=>{for(const{type:D}of O)if(D===0){if(n)return;n=!0;try{for(;!r.token.isCancellationRequested;){const{bytesRead:k}=await f.Promises.read(i,a,0,l,null);if(!k||r.token.isCancellationRequested)break;d(a.slice(0,k))}}catch(k){t=new Error(k),r.dispose(!0)}finally{n=!1}}})()});return await p.ready,u(),new Promise((O,D)=>{r.token.onCancellationRequested(async()=>{p.dispose();try{await f.Promises.close(i)}catch(k){t=new Error(k)}t?D(t):O()})})}e.$bq=w}),define(ie[215],ne([0,1,3,104,2,4,214]),function(J,e,S,A,s,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=void 0;class P extends s.$Sc{constructor(){super(...arguments),this.a=this.B(new S.$Od),this.onDidChangeFile=this.a.event,this.b=this.B(new S.$Od),this.onDidLogMessage=this.b.event,this.onDidError=S.Event.None,this.c=new Map,this.f=!1}async watch(c){const g=this.j(c),b=g.filter(f=>{const v=this.c.get(f.path);return v?!(0,A.$Bj)(v.request.excludes,f.excludes)||!(0,A.$Bj)(v.request.includes,f.includes):!0}),y=Array.from(this.c.values()).filter(({request:f})=>!g.find(v=>v.path===f.path&&(0,A.$Bj)(v.excludes,f.excludes)&&(0,A.$Bj)(v.includes,f.includes))).map(({request:f})=>f.path);b.length&&this.m(`Request to start watching: ${b.map(f=>`${f.path} (excludes: ${f.excludes.length>0?f.excludes:"<none>"}, includes: ${f.includes&&f.includes.length>0?JSON.stringify(f.includes):"<all>"}, correlationId: ${typeof f.correlationId=="number"?f.correlationId:"<none>"})`).join(",")}`),y.length&&this.m(`Request to stop watching: ${y.join(",")}`);for(const f of y)this.h(f);for(const f of b)this.g(f)}g(c){const g=new C.$aq(c,y=>this.a.fire(y),y=>this.b.fire(y),this.f),b={request:c,instance:g};this.c.set(c.path,b)}async stop(){for(const[c]of this.c)this.h(c);this.c.clear()}h(c){const g=this.c.get(c);g&&(this.c.delete(c),g.instance.dispose())}j(c){const g=new Map;for(const b of c){const y=R.$l?b.path:b.path.toLowerCase();let f=g.get(b.correlationId);f||(f=new Map,g.set(b.correlationId,f)),f.set(y,b)}return Array.from(g.values()).map(b=>Array.from(b.values())).flat()}async setVerboseLogging(c){this.f=c;for(const[,g]of this.c)g.instance.setVerboseLogging(c)}m(c){this.f&&this.b.fire({type:"trace",message:this.n(c)})}n(c,g){return g?`[File Watcher (node.js)] ${c} (path: ${g.request.path})`:`[File Watcher (node.js)] ${c}`}}e.$cq=P}),define(ie[216],ne([0,1,64,215]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=void 0;class s extends S.$Up{constructor(C,P,h){super(C,P,h),this.s()}r(C){return C.add(new A.$cq)}}e.$dq=s}),define(ie[217],ne([0,1,13,42,160,64]),function(J,e,S,A,s,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=void 0;class C extends R.$Vp{constructor(h,c,g){super(h,c,g),this.s()}r(h){const c=h.add(new s.$7p(S.$dg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return h.add(c.onDidProcessExit(({code:g,signal:b})=>this.t(`terminated by itself with code ${g}, signal: ${b}`))),A.ProxyChannel.toService((0,A.$xh)(c.getChannel("watcher")))}}e.$8p=C}),define(ie[92],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oh=void 0;class S{constructor(...s){this.a=new Map;for(const[R,C]of s)this.set(R,C)}set(s,R){const C=this.a.get(s);return this.a.set(s,R),C}has(s){return this.a.has(s)}get(s){return this.a.get(s)}}e.$Oh=S}),define(ie[218],ne([0,1,8,14,2,77,208,5,92,101]),function(J,e,S,A,s,R,C,P,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iq=e.$hq=void 0;const g=!1;class b extends Error{constructor(w){super("cyclic dependency between services"),this.message=w.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${w.toString()}`}}class y{constructor(w=new h.$Oh,$=!1,d,u=g){this.f=w,this.g=$,this.h=d,this.i=u,this.o=new Set,this.f.set(P.$Ph,this),this._globalGraph=u?d?._globalGraph??new C.$gq(E=>E):void 0}createChild(w){return new y(w,this.g,this,this.i)}invokeFunction(w,...$){const d=v.traceInvocation(this.i,w);let u=!1;try{return w({get:l=>{if(u)throw(0,A.$8)("service accessor is only valid during the invocation of its target method");const i=this.m(l,d);if(!i)throw new Error(`[invokeFunction] unknown service '${l}'`);return i}},...$)}finally{u=!0,d.stop()}}createInstance(w,...$){let d,u;return w instanceof R.$Nh?(d=v.traceCreation(this.i,w.ctor),u=this.j(w.ctor,w.staticArguments.concat($),d)):(d=v.traceCreation(this.i,w),u=this.j(w,$,d)),d.stop(),u}j(w,$=[],d){const u=P._util.getServiceDependencies(w).sort((i,a)=>i.index-a.index),E=[];for(const i of u){const a=this.m(i.id,d);a||this.u(`[createInstance] ${w.name} depends on UNKNOWN service ${i.id}.`,!1),E.push(a)}const l=u.length>0?u[0].index:$.length;if($.length!==l){console.trace(`[createInstance] First service dependency of ${w.name} at position ${l+1} conflicts with ${$.length} static arguments`);const i=l-$.length;i>0?$=$.concat(new Array(i)):$=$.slice(0,l)}return Reflect.construct(w,$.concat(E))}k(w,$){if(this.f.get(w)instanceof R.$Nh)this.f.set(w,$);else if(this.h)this.h.k(w,$);else throw new Error("illegalState - setting UNKNOWN service instance")}l(w){const $=this.f.get(w);return!$&&this.h?this.h.l(w):$}m(w,$){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(w));const d=this.l(w);return d instanceof R.$Nh?this.q(w,d,$.branch(w,!0)):($.branch(w,!1),d)}q(w,$,d){if(this.o.has(w))throw new Error(`illegal state - RECURSIVELY instantiating service '${w}'`);this.o.add(w);try{return this.r(w,$,d)}finally{this.o.delete(w)}}r(w,$,d){const u=new C.$gq(i=>i.id.toString());let E=0;const l=[{id:w,desc:$,_trace:d}];for(;l.length;){const i=l.pop();if(u.lookupOrInsertNode(i),E++>1e3)throw new b(u);for(const a of P._util.getServiceDependencies(i.desc.ctor)){const r=this.l(a.id);if(r||this.u(`[createInstance] ${w} depends on ${a.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(a.id)),r instanceof R.$Nh){const t={id:a.id,desc:r,_trace:i._trace.branch(a.id,!0)};u.insertEdge(i,t),l.push(t)}}}for(;;){const i=u.roots();if(i.length===0){if(!u.isEmpty())throw new b(u);break}for(const{data:a}of i){if(this.l(a.id)instanceof R.$Nh){const t=this.s(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this.k(a.id,t)}u.removeNode(a)}}return this.l(w)}s(w,$,d=[],u,E){if(this.f.get(w)instanceof R.$Nh)return this.t(w,$,d,u,E);if(this.h)return this.h.s(w,$,d,u,E);throw new Error(`illegalState - creating UNKNOWN service instance ${$.name}`)}t(w,$,d=[],u,E){if(u){const l=new y(void 0,this.g,this,this.i);l.c=String(w);const i=new Map,a=new S.$_g(()=>{const r=l.j($,d,E);for(const[t,n]of i){const o=r[t];if(typeof o=="function")for(const p of n)o.apply(r,p)}return i.clear(),r});return new Proxy(Object.create(null),{get(r,t){if(!a.isInitialized&&typeof t=="string"&&(t.startsWith("onDid")||t.startsWith("onWill"))){let p=i.get(t);return p||(p=new c.$2c,i.set(t,p)),(D,k,I)=>{const j=p.push([D,k,I]);return(0,s.$Qc)(j)}}if(t in r)return r[t];const n=a.value;let o=n[t];return typeof o!="function"||(o=o.bind(n),r[t]=o),o},set(r,t,n){return a.value[t]=n,!0},getPrototypeOf(r){return $.prototype}})}else return this.j($,d,E)}u(w,$){if($&&console.warn(w),this.g)throw new Error(w)}}e.$hq=y;var f;(function(m){m[m.None=0]="None",m[m.Creation=1]="Creation",m[m.Invocation=2]="Invocation",m[m.Branch=3]="Branch"})(f||(f={}));class v{static{this.all=new Set}static{this.c=new class extends v{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(w,$){return w?new v(2,$.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):v.c}static traceCreation(w,$){return w?new v(1,$.name):v.c}static{this.f=0}constructor(w,$){this.type=w,this.name=$,this.g=Date.now(),this.h=[]}branch(w,$){const d=new v(3,w.toString());return this.h.push([w,$,d]),d}stop(){const w=Date.now()-this.g;v.f+=w;let $=!1;function d(E,l){const i=[],a=new Array(E+1).join("	");for(const[r,t,n]of l.h)if(t&&n){$=!0,i.push(`${a}CREATES -> ${r}`);const o=d(E+1,n);o&&i.push(o)}else i.push(`${a}uses -> ${r}`);return i.join(`
`)}const u=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${w.toFixed(2)}ms (grand total ${v.f.toFixed(2)}ms)`];(w>2||$)&&v.all.add(u.join(`
`))}}e.$iq=v}),define(ie[219],ne([0,1,5]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kxb=e.IssueType=void 0;var A;(function(s){s[s.Bug=0]="Bug",s[s.PerformanceIssue=1]="PerformanceIssue",s[s.FeatureRequest=2]="FeatureRequest"})(A||(e.IssueType=A={})),e.$kxb=(0,S.$Qh)("issueService")}),define(ie[6],ne([0,1,49,3,55,2,31,4,19,12,7,114,5]),function(J,e,S,A,s,R,C,P,h,c,g,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.log=e.$bj=e.LogLevel=e.$aj=e.$_i=e.$$i=void 0,e.$$i=(0,y.$Qh)("logService"),e.$_i=(0,y.$Qh)("loggerService");function f(){return new Date().toISOString()}function v(D){return(0,c.$Df)(D)}e.$aj=v;var m;(function(D){D[D.Off=0]="Off",D[D.Trace=1]="Trace",D[D.Debug=2]="Debug",D[D.Info=3]="Info",D[D.Warning=4]="Warning",D[D.Error=5]="Error"})(m||(e.LogLevel=m={})),e.$bj=m.Info;function w(D,k,I){switch(k){case m.Trace:D.trace(I);break;case m.Debug:D.debug(I);break;case m.Info:D.info(I);break;case m.Warning:D.warn(I);break;case m.Error:D.error(I);break;case m.Off:break;default:throw new Error(`Invalid log level ${k}`)}}e.log=w;function $(D,k=!1){let I="";for(let j=0;j<D.length;j++){let U=D[j];if(U instanceof Error&&(U=(0,S.$Bi)(U,k)),typeof U=="object")try{U=JSON.stringify(U)}catch{}I+=(j>0?" ":"")+U}return I}class d extends R.$Sc{constructor(){super(...arguments),this.b=e.$bj,this.c=this.B(new A.$Od),this.onDidChangeLogLevel=this.c.event}setLevel(k){this.b!==k&&(this.b=k,this.c.fire(this.b))}getLevel(){return this.b}f(k){return this.b!==m.Off&&this.b<=k}}e.$dj=d;class u extends d{constructor(k){super(),this.h=k}f(k){return this.h||super.f(k)}trace(k,...I){this.f(m.Trace)&&this.g(m.Trace,$([k,...I],!0))}debug(k,...I){this.f(m.Debug)&&this.g(m.Debug,$([k,...I]))}info(k,...I){this.f(m.Info)&&this.g(m.Info,$([k,...I]))}warn(k,...I){this.f(m.Warning)&&this.g(m.Warning,$([k,...I]))}error(k,...I){if(this.f(m.Error))if(k instanceof Error){const j=Array.prototype.slice.call(arguments);j[0]=k.stack,this.g(m.Error,$(j))}else this.g(m.Error,$([k,...I]))}flush(){}}e.$ej=u;class E extends d{constructor(k=e.$bj){super(),this.setLevel(k),this.g=!P.$j}trace(k,...I){this.f(m.Trace)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,k,...I):console.log(`[main ${f()}]`,k,...I))}debug(k,...I){this.f(m.Debug)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,k,...I):console.log(`[main ${f()}]`,k,...I))}info(k,...I){this.f(m.Info)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,k,...I):console.log(`[main ${f()}]`,k,...I))}warn(k,...I){this.f(m.Warning)&&(this.g?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,k,...I):console.warn(`[main ${f()}]`,k,...I))}error(k,...I){this.f(m.Error)&&(this.g?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,k,...I):console.error(`[main ${f()}]`,k,...I))}dispose(){}flush(){}}e.$fj=E;class l extends d{constructor(k=e.$bj,I=!0){super(),this.g=I,this.setLevel(k)}trace(k,...I){this.f(m.Trace)&&(this.g?console.log("%cTRACE","color: #888",k,...I):console.log(k,...I))}debug(k,...I){this.f(m.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",k,...I):console.log(k,...I))}info(k,...I){this.f(m.Info)&&(this.g?console.log("%c INFO","color: #33f",k,...I):console.log(k,...I))}warn(k,...I){this.f(m.Warning)&&(this.g?console.log("%c WARN","color: #993",k,...I):console.log(k,...I))}error(k,...I){this.f(m.Error)&&(this.g?console.log("%c  ERR","color: #f33",k,...I):console.error(k,...I))}dispose(){}flush(){}}e.$gj=l;class i extends d{constructor(k,I=e.$bj){super(),this.g=k,this.setLevel(I)}trace(k,...I){this.f(m.Trace)&&this.g.log(m.Trace,[this.h(k),...I])}debug(k,...I){this.f(m.Debug)&&this.g.log(m.Debug,[this.h(k),...I])}info(k,...I){this.f(m.Info)&&this.g.log(m.Info,[this.h(k),...I])}warn(k,...I){this.f(m.Warning)&&this.g.log(m.Warning,[this.h(k),...I])}error(k,...I){this.f(m.Error)&&this.g.log(m.Error,[this.h(k),...I])}h(k){return typeof k=="string"?k:(0,S.$Bi)(k,this.f(m.Trace))}dispose(){}flush(){}}e.$hj=i;class a extends d{constructor(k){super(),this.g=k,k.length&&this.setLevel(k[0].getLevel())}setLevel(k){for(const I of this.g)I.setLevel(k);super.setLevel(k)}trace(k,...I){for(const j of this.g)j.trace(k,...I)}debug(k,...I){for(const j of this.g)j.debug(k,...I)}info(k,...I){for(const j of this.g)j.info(k,...I)}warn(k,...I){for(const j of this.g)j.warn(k,...I)}error(k,...I){for(const j of this.g)j.error(k,...I)}flush(){for(const k of this.g)k.flush()}dispose(){for(const k of this.g)k.dispose()}}e.$ij=a;class r extends R.$Sc{constructor(k,I,j){if(super(),this.h=k,this.j=I,this.b=new C.$Ac,this.c=this.B(new A.$Od),this.onDidChangeLoggers=this.c.event,this.f=this.B(new A.$Od),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new A.$Od),this.onDidChangeVisibility=this.g.event,j)for(const U of j)this.b.set(U.resource,{logger:void 0,info:U})}m(k){return(0,c.$zf)(k)?[...this.b.values()].find(I=>I.info.id===k):this.b.get(k)}getLogger(k){return this.m(k)?.logger}createLogger(k,I){const j=this.n(k),U=(0,c.$zf)(k)?k:I?.id??(0,s.$Ei)(j.toString()).toString(16);let z=this.b.get(j)?.logger;const x=I?.logLevel==="always"?m.Trace:I?.logLevel;z||(z=this.s(j,x??this.getLogLevel(j)??this.h,{...I,id:U}));const Z={logger:z,info:{resource:j,id:U,logLevel:x,name:I?.name,hidden:I?.hidden,extensionId:I?.extensionId,when:I?.when}};return this.registerLogger(Z.info),this.b.set(j,Z),z}n(k){return(0,c.$zf)(k)?(0,h.$wg)(this.j,`${k}.log`):k}setLogLevel(k,I){if(g.URI.isUri(k)){const j=k,U=I,z=this.b.get(j);z&&U!==z.info.logLevel&&(z.info.logLevel=U===this.h?void 0:U,z.logger?.setLevel(U),this.b.set(z.info.resource,z),this.f.fire([j,U]))}else{this.h=k;for(const[j,U]of this.b.entries())this.b.get(j)?.info.logLevel===void 0&&U.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(k,I){const j=this.m(k);j&&I!==!j.info.hidden&&(j.info.hidden=!I,this.b.set(j.info.resource,j),this.g.fire([j.info.resource,I]))}getLogLevel(k){let I;return k&&(I=this.b.get(k)?.info.logLevel),I??this.h}registerLogger(k){const I=this.b.get(k.resource);I?I.info.hidden!==k.hidden&&this.setVisibility(k.resource,!k.hidden):(this.b.set(k.resource,{info:k,logger:void 0}),this.c.fire({added:[k],removed:[]}))}deregisterLogger(k){const I=this.b.get(k);I&&(I.logger&&I.logger.dispose(),this.b.delete(k),this.c.fire({added:[],removed:[I.info]}))}*getRegisteredLoggers(){for(const k of this.b.values())yield k.info}getRegisteredLogger(k){return this.b.get(k)?.info}dispose(){this.b.forEach(k=>k.logger?.dispose()),this.b.clear(),super.dispose()}}e.$jj=r;class t{constructor(){this.onDidChangeLogLevel=new A.$Od().event}setLevel(k){}getLevel(){return m.Info}trace(k,...I){}debug(k,...I){}info(k,...I){}warn(k,...I){}error(k,...I){}critical(k,...I){}dispose(){}flush(){}}e.$kj=t;class n extends t{}e.$lj=n;function o(D){if(D.verbose)return m.Trace;if(typeof D.logLevel=="string"){const k=O(D.logLevel.toLowerCase());if(k!==void 0)return k}return e.$bj}e.$mj=o;function p(D){switch(D){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Off:return"off"}}e.$nj=p;function O(D){switch(D){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Error;case"off":return m.Off}}e.$oj=O,e.$pj=new b.$8i("logLevel",p(m.Info))});var te=this&&this.__param||function(J,e){return function(S,A){e(S,A,J)}};define(ie[220],ne([0,1,15,4,6]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j7b=void 0;const R=S.safeStorage;let C=class{constructor(h){this.a=h,S.app.commandLine.getSwitchValue("password-store")==="basic"&&R.setUsePlainTextEncryption?.(!0)}async encrypt(h){this.a.trace("[EncryptionMainService] Encrypting value.");try{const c=JSON.stringify(R.encryptString(h));return this.a.trace("[EncryptionMainService] Encrypted value."),c}catch(c){throw this.a.error(c),c}}async decrypt(h){let c;try{if(c=JSON.parse(h),!c.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${h}`);const g=Buffer.from(c.data);this.a.trace("[EncryptionMainService] Decrypting value.");const b=R.decryptString(g);return this.a.trace("[EncryptionMainService] Decrypted value."),b}catch(g){throw this.a.error(g),g}}isEncryptionAvailable(){return Promise.resolve(R.isEncryptionAvailable())}getKeyStorageProvider(){if(A.$j)return Promise.resolve("dpapi");if(A.$k)return Promise.resolve("keychain_access");if(R.getSelectedStorageBackend)try{const h=R.getSelectedStorageBackend();return Promise.resolve(h)}catch(h){this.a.error(h)}return Promise.resolve("unknown")}async setUsePlainTextEncryption(){if(A.$j)throw new Error("Setting plain text encryption is not supported on Windows.");if(A.$k)throw new Error("Setting plain text encryption is not supported on macOS.");if(!R.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");R.setUsePlainTextEncryption(!0)}};e.$j7b=C,e.$j7b=C=Ee([te(0,s.$$i)],C)}),define(ie[221],ne([0,1,23,8,14,3,2,9,64,6]),function(J,e,S,A,s,R,C,P,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=void 0;class g extends C.$Sc{constructor(y,f){super(),this.a=y,this.b=f,this.c=this.B(new R.$Od),this.onDidChangeFile=this.c.event,this.g=this.B(new R.$Od),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new A.$Sg(0)),this.w=[],this.y=this.B(new A.$Sg(0))}watch(y,f){return f.recursive||this.b?.watcher?.forceUniversal?this.n(y,f):this.z(y,f)}n(y,f){const v={path:this.H(y),excludes:f.excludes,includes:f.includes,recursive:f.recursive,correlationId:f.correlationId},m=(0,S.$Ub)(this.j,v);return this.r(),(0,C.$Qc)(()=>{m(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(y=>(0,s.$1)(y))}s(){this.h||(this.h=this.B(this.t(f=>this.c.fire((0,h.$Wp)(f)),f=>this.G(f),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)})));const y=this.b?.watcher?.recursive?.usePolling;if(y===!0)for(const f of this.j)(0,h.$Sp)(f)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(y))for(const f of this.j)(0,h.$Sp)(f)&&y.includes(f.path)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(y,f){const v={path:this.H(y),excludes:f.excludes,includes:f.includes,recursive:!1,correlationId:f.correlationId},m=(0,S.$Ub)(this.w,v);return this.C(),(0,C.$Qc)(()=>{m(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(y=>(0,s.$1)(y))}D(){return this.u||(this.u=this.B(this.F(y=>this.c.fire((0,h.$Wp)(y)),y=>this.G(y),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)}))),this.u.watch(this.w)}G(y){y.type==="error"&&this.g.fire(y.message),this.a[y.type](y.message)}H(y){return(0,P.$hc)(y.fsPath)}}e.$1p=g}),define(ie[222],ne([0,1,23,8,17,22,3,55,70,2,56,13,65,19,61,175,16,118,6,14]),function(J,e,S,A,s,R,C,P,h,c,g,b,y,f,v,m,w,$,d,u){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=void 0;let l=class extends c.$Sc{static{E=this}constructor(a){super(),this.b=a,this.a=256*1024,this.c=this.B(new C.$Od),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new C.$Od),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new C.$Od),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new C.$Od),this.onDidRunOperation=this.r.event,this.X=this.B(new C.$Od),this.Y=this.B(new C.$Od),this.onDidFilesChange=this.Y.event,this.Z=this.B(new C.$Od),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new A.$4g)}registerProvider(a,r){if(this.h.has(a))throw new Error(`A filesystem provider for the scheme '${a}' is already registered.`);(0,y.mark)(`code/registerFilesystem/${a}`);const t=new c.$Rc;return this.h.set(a,r),this.c.fire({added:!0,scheme:a,provider:r}),t.add(r.onDidChangeFile(n=>{const o=new w.$sk(n,!this.S(r));this.X.fire(o),o.hasCorrelation()||this.Y.fire(o)})),typeof r.onDidWatchError=="function"&&t.add(r.onDidWatchError(n=>this.Z.fire(new Error(n)))),t.add(r.onDidChangeCapabilities(()=>this.g.fire({provider:r,scheme:a}))),(0,c.$Qc)(()=>{this.c.fire({added:!1,scheme:a,provider:r}),this.h.delete(a),(0,c.$Nc)(t)})}getProvider(a){return this.h.get(a)}async activateProvider(a){const r=[];this.f.fire({scheme:a,join(t){r.push(t)}}),!this.h.has(a)&&await A.Promises.settled(r)}async canHandleResource(a){return await this.activateProvider(a.scheme),this.hasProvider(a)}hasProvider(a){return this.h.has(a.scheme)}hasCapability(a,r){const t=this.h.get(a.scheme);return!!(t&&t.capabilities&r)}listCapabilities(){return h.Iterable.map(this.h,([a,r])=>({scheme:a,capabilities:r.capabilities}))}async j(a){if(!(0,f.$Ag)(a))throw new w.$uk((0,m.localize)(0,null,this.sb(a)),8);await this.activateProvider(a.scheme);const r=this.h.get(a.scheme);if(!r){const t=new u.$bb;throw t.message=(0,m.localize)(1,null,a.toString()),t}return r}async m(a){const r=await this.j(a);if((0,w.$fk)(r)||(0,w.$ck)(r)||(0,w.$gk)(r))return r;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(a){const r=await this.j(a);if((0,w.$fk)(r)||(0,w.$ck)(r))return r;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(a,r){try{return await this.s(a,r)}catch(t){throw(0,w.$pk)(t)===w.FileSystemProviderErrorCode.FileNotFound?new w.$uk((0,m.localize)(2,null,this.sb(a)),1):(0,w.$nk)(t)}}async s(a,r){const t=await this.j(a),n=this.S(t),o=r?.resolveTo,p=r?.resolveSingleChildDescendants,O=r?.resolveMetadata,D=await t.stat(a);let k;return this.t(t,a,D,void 0,!!O,(I,j)=>(k||(k=g.$Wh.forUris(()=>!n),k.set(a,!0),o&&k.fill(!0,o)),k.get(I.resource)||k.findSuperstr(I.resource.with({query:null,fragment:null}))?!0:I.isDirectory&&p?j===1:!1))}async t(a,r,t,n,o,p){const{providerExtUri:O}=this.R(a),D={resource:r,name:O.basename(r),isFile:(t.type&w.FileType.File)!==0,isDirectory:(t.type&w.FileType.Directory)!==0,isSymbolicLink:(t.type&w.FileType.SymbolicLink)!==0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:!!((t.permissions??0)&w.FilePermission.Readonly)||!!(a.capabilities&2048),locked:!!((t.permissions??0)&w.FilePermission.Locked),etag:(0,w.$Fk)({mtime:t.mtime,size:t.size}),children:void 0};if(D.isDirectory&&p(D,n)){try{const k=await a.readdir(r),I=await A.Promises.settled(k.map(async([j,U])=>{try{const z=O.joinPath(r,j),x=o?await a.stat(z):{type:U};return await this.t(a,z,x,k.length,o,p)}catch(z){return this.b.trace(z),null}}));D.children=(0,S.$Hb)(I)}catch(k){this.b.trace(k),D.children=[]}return D}return D}async resolveAll(a){return A.Promises.settled(a.map(async r=>{try{return{stat:await this.s(r.resource,r.options),success:!0}}catch(t){return this.b.trace(t),{stat:void 0,success:!1}}}))}async stat(a){const r=await this.j(a),t=await r.stat(a);return this.t(r,a,t,void 0,!0,()=>!1)}async exists(a){const r=await this.j(a);try{return!!await r.stat(a)}catch{return!1}}async canCreateFile(a,r){try{await this.u(a,r)}catch(t){return t}return!0}async u(a,r){if(!r?.overwrite&&await this.exists(a))throw new w.$uk((0,m.localize)(3,null,this.sb(a)),3,r)}async createFile(a,r=s.$ce.fromString(""),t){await this.u(a,t);const n=await this.writeFile(a,r);return this.r.fire(new w.$rk(a,0,n)),n}async writeFile(a,r,t){const n=this.qb(await this.n(a),a),{providerExtUri:o}=this.R(n);let p=t;if((0,w.$ik)(n)&&!p?.atomic){const O=n.enforceAtomicWriteFile?.(a);O&&(p={...t,atomic:O})}try{await this.w(n,a,p)||await this.U(n,o.dirname(a));let D;if((0,w.$ck)(n)&&!(r instanceof s.$ce))if((0,v.$1d)(r)){const k=await(0,v.$8d)(r,3);k.ended?D=s.$ce.concat(k.buffer):D=k}else D=(0,v.$5d)(r,k=>s.$ce.concat(k),3);else D=r;!(0,w.$fk)(n)||(0,w.$ck)(n)&&D instanceof s.$ce||(0,w.$ck)(n)&&(0,w.$ik)(n)&&p?.atomic?await this.hb(n,a,p,D):await this.db(n,a,p,D instanceof s.$ce?(0,s.$ne)(D):D),this.r.fire(new w.$rk(a,4))}catch(O){throw new w.$uk((0,m.localize)(4,null,this.sb(a),(0,w.$nk)(O).toString()),(0,w.$qk)(O),p)}return this.resolve(a,{resolveMetadata:!0})}async w(a,r,t){const n=!!t?.unlock;if(n&&!(a.capabilities&8192))throw new Error((0,m.localize)(5,null,this.sb(r)));if(!!t?.atomic){if(!(a.capabilities&32768))throw new Error((0,m.localize)(6,null,this.sb(r)));if(!(a.capabilities&2))throw new Error((0,m.localize)(7,null,this.sb(r)));if(n)throw new Error((0,m.localize)(8,null,this.sb(r)))}let p;try{p=await a.stat(r)}catch{return}if(p.type&w.FileType.Directory)throw new w.$uk((0,m.localize)(9,null,this.sb(r)),0,t);if(this.rb(r,p),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==w.$Ek&&typeof p.mtime=="number"&&typeof p.size=="number"&&t.mtime<p.mtime&&t.etag!==(0,w.$Fk)({mtime:t.mtime,size:p.size}))throw new w.$uk((0,m.localize)(10,null),3,t);return p}async readFile(a,r,t){const n=await this.m(a);return r?.atomic?this.z(n,a,r,t):this.C(n,a,r,t)}async z(a,r,t,n){return new Promise((o,p)=>{this.cb.queueFor(r,this.R(a).providerExtUri).queue(async()=>{try{const O=await this.C(a,r,t,n);o(O)}catch(O){p(O)}})})}async C(a,r,t,n){const o=await this.D(a,r,{...t,preferUnbuffered:!0},n);return{...o,value:await(0,s.$oe)(o.value)}}async readFileStream(a,r,t){const n=await this.m(a);return this.D(n,a,r,t)}async D(a,r,t,n){const o=new R.$Yd(n);let p=t;(0,w.$hk)(a)&&a.enforceAtomicReadFile?.(r)&&(p={...t,atomic:!0});const O=this.J(r,p).then(k=>k,k=>{throw o.dispose(!0),k});let D;try{return typeof p?.etag=="string"&&p.etag!==w.$Ek&&await O,p?.atomic&&(0,w.$hk)(a)||!((0,w.$fk)(a)||(0,w.$gk)(a))||(0,w.$ck)(a)&&p?.preferUnbuffered?D=this.I(a,r,p):(0,w.$gk)(a)?D=this.G(a,r,o.token,p):D=this.H(a,r,o.token,p),D.on("end",()=>o.dispose()),D.on("error",()=>o.dispose()),{...await O,value:D}}catch(k){throw D&&await(0,v.$6d)(D),this.F(k,r,p)}}F(a,r,t){const n=(0,m.localize)(11,null,this.sb(r),(0,w.$nk)(a).toString());return a instanceof w.$wk?new w.$wk(n,a.stat,t):a instanceof w.$vk?new w.$vk(n,a.fileOperationResult,a.size,a.options):new w.$uk(n,(0,w.$qk)(a),t)}G(a,r,t,n=Object.create(null)){const o=a.readFileStream(r,n,t);return(0,v.$_d)(o,{data:p=>p instanceof s.$ce?p:s.$ce.wrap(p),error:p=>this.F(p,r,n)},p=>s.$ce.concat(p))}H(a,r,t,n=Object.create(null)){const o=(0,s.$se)();return(0,$.$Qp)(a,r,o,p=>p,{...n,bufferSize:this.a,errorTransformer:p=>this.F(p,r,n)},t),o}I(a,r,t){const n=(0,v.$3d)(o=>s.$ce.concat(o));return(async()=>{try{let o;t?.atomic&&(0,w.$hk)(a)?o=await a.readFile(r,{atomic:!0}):o=await a.readFile(r),typeof t?.position=="number"&&(o=o.slice(t.position)),typeof t?.length=="number"&&(o=o.slice(0,t.length)),this.L(r,o.byteLength,t),n.end(s.$ce.wrap(o))}catch(o){n.error(o),n.end()}})(),n}async J(a,r){const t=await this.resolve(a,{resolveMetadata:!0});if(t.isDirectory)throw new w.$uk((0,m.localize)(12,null,this.sb(a)),0,r);if(typeof r?.etag=="string"&&r.etag!==w.$Ek&&r.etag===t.etag)throw new w.$wk((0,m.localize)(13,null),t,r);return this.L(a,t.size,r),t}L(a,r,t){if(typeof t?.limits?.size=="number"&&r>t.limits.size)throw new w.$vk((0,m.localize)(14,null,this.sb(a)),7,r,t)}async canMove(a,r,t){return this.M(a,r,"move",t)}async canCopy(a,r,t){return this.M(a,r,"copy",t)}async M(a,r,t,n){if(a.toString()!==r.toString())try{const o=t==="move"?this.qb(await this.n(a),a):await this.m(a),p=this.qb(await this.n(r),r);await this.Q(o,a,p,r,t,n)}catch(o){return o}return!0}async move(a,r,t){const n=this.qb(await this.n(a),a),o=this.qb(await this.n(r),r),p=await this.N(n,a,o,r,"move",!!t),O=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new w.$rk(a,p==="move"?2:3,O)),O}async copy(a,r,t){const n=await this.m(a),o=this.qb(await this.n(r),r),p=await this.N(n,a,o,r,"copy",!!t),O=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new w.$rk(a,p==="copy"?3:2,O)),O}async N(a,r,t,n,o,p){if(r.toString()===n.toString())return o;const{exists:O,isSameResourceWithDifferentPathCase:D}=await this.Q(a,r,t,n,o,p);if(O&&!D&&p&&await this.del(n,{recursive:!0}),await this.U(t,this.R(t).providerExtUri.dirname(n)),o==="copy"){if(a===t&&(0,w.$dk)(a))await a.copy(r,n,{overwrite:p});else{const k=await this.resolve(r);k.isDirectory?await this.P(a,k,t,n):await this.O(a,r,t,n)}return o}else return a===t?(await a.rename(r,n,{overwrite:p}),o):(await this.N(a,r,t,n,"copy",p),await this.del(r,{recursive:!0}),"copy")}async O(a,r,t,n){if((0,w.$fk)(a)&&(0,w.$fk)(t))return this.jb(a,r,t,n);if((0,w.$fk)(a)&&(0,w.$ck)(t))return this.pb(a,r,t,n);if((0,w.$ck)(a)&&(0,w.$fk)(t))return this.nb(a,r,t,n);if((0,w.$ck)(a)&&(0,w.$ck)(t))return this.lb(a,r,t,n)}async P(a,r,t,n){await t.mkdir(n),Array.isArray(r.children)&&await A.Promises.settled(r.children.map(async o=>{const p=this.R(t).providerExtUri.joinPath(n,o.name);return o.isDirectory?this.P(a,await this.resolve(o.resource),t,p):this.O(a,o.resource,t,p)}))}async Q(a,r,t,n,o,p){let O=!1;if(a===t){const{providerExtUri:k,isPathCaseSensitive:I}=this.R(a);if(I||(O=k.isEqual(r,n)),O&&o==="copy")throw new Error((0,m.localize)(15,null,this.sb(r),this.sb(n)));if(!O&&k.isEqualOrParent(n,r))throw new Error((0,m.localize)(16,null,this.sb(r),this.sb(n)))}const D=await this.exists(n);if(D&&!O){if(!p)throw new w.$uk((0,m.localize)(17,null,this.sb(r),this.sb(n)),4);if(a===t){const{providerExtUri:k}=this.R(a);if(k.isEqualOrParent(r,n))throw new Error((0,m.localize)(18,null,this.sb(r),this.sb(n)))}}return{exists:D,isSameResourceWithDifferentPathCase:O}}R(a){const r=this.S(a);return{providerExtUri:r?f.$mg:f.$og,isPathCaseSensitive:r}}S(a){return!!(a.capabilities&1024)}async createFolder(a){const r=this.qb(await this.j(a),a);await this.U(r,a);const t=await this.resolve(a,{resolveMetadata:!0});return this.r.fire(new w.$rk(a,0,t)),t}async U(a,r){const t=[],{providerExtUri:n}=this.R(a);for(;!n.isEqual(r,n.dirname(r));)try{if(!((await a.stat(r)).type&w.FileType.Directory))throw new Error((0,m.localize)(19,null,this.sb(r)));break}catch(o){if((0,w.$pk)(o)!==w.FileSystemProviderErrorCode.FileNotFound)throw o;t.push(n.basename(r)),r=n.dirname(r)}for(let o=t.length-1;o>=0;o--){r=n.joinPath(r,t[o]);try{await a.mkdir(r)}catch(p){if((0,w.$pk)(p)!==w.FileSystemProviderErrorCode.FileExists)throw p}}}async canDelete(a,r){try{await this.W(a,r)}catch(t){return t}return!0}async W(a,r){const t=this.qb(await this.j(a),a),n=!!r?.useTrash;if(n&&!(t.capabilities&4096))throw new Error((0,m.localize)(20,null,this.sb(a)));const o=r?.atomic;if(o&&!(t.capabilities&65536))throw new Error((0,m.localize)(21,null,this.sb(a)));if(n&&o)throw new Error((0,m.localize)(22,null,this.sb(a)));let p;try{p=await t.stat(a)}catch{}if(p)this.rb(a,p);else throw new w.$uk((0,m.localize)(23,null,this.sb(a)),1);if(!!!r?.recursive){const D=await this.resolve(a);if(D.isDirectory&&Array.isArray(D.children)&&D.children.length>0)throw new Error((0,m.localize)(24,null,this.sb(a)))}return t}async del(a,r){const t=await this.W(a,r);let n=r;if((0,w.$jk)(t)&&!n?.atomic){const D=t.enforceAtomicDelete?.(a);D&&(n={...r,atomic:D})}const o=!!n?.useTrash,p=!!n?.recursive,O=n?.atomic??!1;await t.delete(a,{recursive:p,useTrash:o,atomic:O}),this.r.fire(new w.$rk(a,1))}async cloneFile(a,r){const t=await this.j(a),n=this.qb(await this.n(r),r);if(t===n&&this.R(t).providerExtUri.isEqual(a,r))return;if(t===n&&(0,w.$ek)(t))return t.cloneFile(a,r);await this.U(n,this.R(n).providerExtUri.dirname(r));const o=this.cb.queueFor(a,this.R(t).providerExtUri);return t===n&&(0,w.$dk)(t)?o.queue(()=>t.copy(a,r,{overwrite:!0})):o.queue(()=>this.O(t,a,n,r))}static{this.ab=0}createWatcher(a,r){return this.watch(a,{...r,correlationId:E.ab++})}watch(a,r={recursive:!1,excludes:[]}){const t=new c.$Rc;let n=!1,o=()=>{n=!0};t.add((0,c.$Qc)(()=>o())),(async()=>{try{const O=await this.bb(a,r);n?(0,c.$Nc)(O):o=()=>(0,c.$Nc)(O)}catch(O){this.b.error(O)}})();const p=r.correlationId;if(typeof p=="number"){const O=t.add(new C.$Od);return t.add(this.X.event(k=>{k.correlates(p)&&O.fire(k)})),{onDidChange:O.event,dispose:()=>t.dispose()}}return t}async bb(a,r){const t=await this.j(a),n=(0,P.$Ei)([this.R(t).providerExtUri.getComparisonKey(a),r]);let o=this.$.get(n);return o||(o={count:0,disposable:t.watch(a,r)},this.$.set(n,o)),o.count+=1,(0,c.$Qc)(()=>{o&&(o.count--,o.count===0&&((0,c.$Nc)(o.disposable),this.$.delete(n)))})}dispose(){super.dispose();for(const[,a]of this.$)(0,c.$Nc)(a.disposable);this.$.clear()}async db(a,r,t,n){return this.cb.queueFor(r,this.R(a).providerExtUri).queue(async()=>{const o=await a.open(r,{create:!0,unlock:t?.unlock??!1});try{(0,v.$1d)(n)||(0,v.$2d)(n)?await this.eb(a,o,n):await this.fb(a,o,n)}catch(p){throw(0,w.$nk)(p)}finally{await a.close(o)}})}async eb(a,r,t){let n=0,o;if((0,v.$2d)(t)){if(t.buffer.length>0){const p=s.$ce.concat(t.buffer);await this.gb(a,r,p,p.byteLength,n,0),n+=p.byteLength}if(t.ended)return;o=t.stream}else o=t;return new Promise((p,O)=>{(0,v.$7d)(o,{onData:async D=>{o.pause();try{await this.gb(a,r,D,D.byteLength,n,0)}catch(k){return O(k)}n+=D.byteLength,setTimeout(()=>o.resume())},onError:D=>O(D),onEnd:()=>p()})})}async fb(a,r,t){let n=0,o;for(;(o=t.read())!==null;)await this.gb(a,r,o,o.byteLength,n,0),n+=o.byteLength}async gb(a,r,t,n,o,p){let O=0;for(;O<n;){const D=await a.write(r,o+O,t.buffer,p+O,n-O);O+=D}}async hb(a,r,t,n){return this.cb.queueFor(r,this.R(a).providerExtUri).queue(()=>this.ib(a,r,t,n))}async ib(a,r,t,n){let o;n instanceof s.$ce?o=n:(0,v.$1d)(n)?o=await(0,s.$oe)(n):(0,v.$2d)(n)?o=await(0,s.$pe)(n):o=(0,s.$me)(n),await a.writeFile(r,o.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1,atomic:t?.atomic??!1})}async jb(a,r,t,n){return this.cb.queueFor(n,this.R(t).providerExtUri).queue(()=>this.kb(a,r,t,n))}async kb(a,r,t,n){let o,p;try{o=await a.open(r,{create:!1}),p=await t.open(n,{create:!0,unlock:!1});const O=s.$ce.alloc(this.a);let D=0,k=0,I=0;do I=await a.read(o,D,O.buffer,k,O.byteLength-k),await this.gb(t,p,O,I,D,k),D+=I,k+=I,k===O.byteLength&&(k=0);while(I>0)}catch(O){throw(0,w.$nk)(O)}finally{await A.Promises.settled([typeof o=="number"?a.close(o):Promise.resolve(),typeof p=="number"?t.close(p):Promise.resolve()])}}async lb(a,r,t,n){return this.cb.queueFor(n,this.R(t).providerExtUri).queue(()=>this.mb(a,r,t,n))}async mb(a,r,t,n){return t.writeFile(n,await a.readFile(r),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(a,r,t,n){return this.cb.queueFor(n,this.R(t).providerExtUri).queue(()=>this.ob(a,r,t,n))}async ob(a,r,t,n){const o=await t.open(n,{create:!0,unlock:!1});try{const p=await a.readFile(r);await this.gb(t,o,s.$ce.wrap(p),p.byteLength,0,0)}catch(p){throw(0,w.$nk)(p)}finally{await t.close(o)}}async pb(a,r,t,n){const o=await(0,s.$oe)(this.H(a,r,R.CancellationToken.None));await this.hb(t,n,void 0,o)}qb(a,r){if(a.capabilities&2048)throw new w.$uk((0,m.localize)(25,null,this.sb(r)),6);return a}rb(a,r){if((r.permissions??0)&w.FilePermission.Readonly)throw new w.$uk((0,m.localize)(26,null,this.sb(a)),6)}sb(a){return a.scheme===b.Schemas.file?a.fsPath:a.toString(!0)}};e.$Rp=l,e.$Rp=l=E=Ee([te(0,d.$$i)],l)}),define(ie[93],ne([0,1,45,311,8,31,17,3,33,2,9,4,19,61,21,179,16,118,221,49,217,216]),function(J,e,S,A,s,R,C,P,h,c,g,b,y,f,v,m,w,$,d,u,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=void 0,(()=>{try{(0,A.gracefulify)(S)}catch(a){console.error(`Error enabling graceful-fs: ${(0,u.$Bi)(a)}`)}})();class i extends d.$1p{static{this.I=!1}constructor(r,t){super(r,t),this.onDidChangeCapabilities=P.Event.None,this.N=new R.$Ac(n=>y.$ng.getComparisonKey(n)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,b.$l&&(this.J|=1024)),this.J}async stat(r){try{const{stat:t,symbolicLink:n}=await v.SymlinkSupport.stat(this.H(r));return{type:this.M(t,n),ctime:t.birthtime.getTime(),mtime:t.mtime.getTime(),size:t.size,permissions:t.mode&128?void 0:w.FilePermission.Locked}}catch(t){throw this.fb(t)}}async L(r){try{return await this.stat(r)}catch{return}}async readdir(r){try{const t=await v.Promises.readdir(this.H(r),{withFileTypes:!0}),n=[];return await Promise.all(t.map(async o=>{try{let p;o.isSymbolicLink()?p=(await this.stat((0,y.$wg)(r,o.name))).type:p=this.M(o),n.push([o.name,p])}catch(p){this.a.trace(p)}})),n}catch(t){throw this.fb(t)}}M(r,t){let n;return t?.dangling?n=w.FileType.Unknown:r.isFile()?n=w.FileType.File:r.isDirectory()?n=w.FileType.Directory:n=w.FileType.Unknown,t&&(n|=w.FileType.SymbolicLink),n}async O(r){const t=this.H(r);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${t})`);let n;for(;n=this.N.get(r);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${t})`),await n.wait();const o=new s.$Tg;return this.N.set(r,o),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${t})`),(0,c.$Qc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${t})`),this.N.get(r)===o&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${t})`),this.N.delete(r)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${t})`),o.open()})}async readFile(r,t){let n;try{t?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(r)})`),n=await this.O(r));const o=this.H(r);return await v.Promises.readFile(o)}catch(o){throw this.fb(o)}finally{n?.dispose()}}P(r){i.I&&this.a.trace(r)}readFileStream(r,t,n){const o=(0,f.$3d)(p=>C.$ce.concat(p.map(O=>C.$ce.wrap(O))).buffer);return(0,$.$Qp)(this,r,o,p=>p.buffer,{...t,bufferSize:256*1024},n),o}async writeFile(r,t,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.Q(r)?this.R(r,(0,y.$wg)((0,y.$vg)(r),`${(0,y.$tg)(r)}${n.atomic.postfix}`),t,n):this.S(r,t,n)}async Q(r){try{const t=this.H(r),{symbolicLink:n}=await v.SymlinkSupport.stat(t);if(n)return!1}catch{}return!0}async R(r,t,n,o){const p=new c.$Rc;try{p.add(await this.O(r)),p.add(await this.O(t)),await this.S(t,n,o,!0);try{await this.rename(t,r,{overwrite:!0})}catch(O){try{await this.delete(t,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw O}}finally{p.dispose()}}async S(r,t,n,o){let p;try{const O=this.H(r);if(!n.create||!n.overwrite){if(await v.Promises.exists(O)){if(!n.overwrite)throw(0,w.$mk)((0,m.localize)(0,null),w.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,w.$mk)((0,m.localize)(1,null),w.FileSystemProviderErrorCode.FileNotFound)}p=await this.open(r,{create:!0,unlock:n.unlock},o),await this.write(p,0,t,0,t.byteLength)}catch(O){throw await this.gb(r,O)}finally{typeof p=="number"&&await this.close(p)}}static{this.Y=!0}static configureFlushOnWrite(r){i.Y=r}async open(r,t,n){const o=this.H(r);let p;(0,w.$ak)(t)&&!n&&(p=await this.O(r));let O;try{if((0,w.$ak)(t)&&t.unlock)try{const{stat:k}=await v.SymlinkSupport.stat(o);k.mode&128||await v.Promises.chmod(o,k.mode|128)}catch(k){k.code!=="ENOENT"&&this.a.trace(k)}let D;if((0,w.$ak)(t)){if(b.$j)try{await v.Promises.truncate(o,0),D="r+"}catch(k){k.code!=="ENOENT"&&this.a.trace(k)}D||(D="w")}else D="r";O=await v.Promises.open(o,D)}catch(D){throw p?.dispose(),(0,w.$ak)(t)?await this.gb(r,D):this.fb(D)}if(this.U.set(O,0),(0,w.$ak)(t)&&this.X.set(O,r),p){const D=this.W.get(O);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${O} (${o})`),this.W.set(O,p),D&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${O} (${o})`),D.dispose())}return O}async close(r){const t=this.W.get(r);try{if(this.U.delete(r),this.X.delete(r)&&i.Y)try{await v.Promises.fdatasync(r)}catch(n){i.configureFlushOnWrite(!1),this.a.error(n)}return await v.Promises.close(r)}catch(n){throw this.fb(n)}finally{t&&(this.W.get(r)===t&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.W.delete(r)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),t.dispose())}}async read(r,t,n,o,p){const O=this.Z(r,t);let D=null;try{D=(await v.Promises.read(r,n,o,p,O)).bytesRead}catch(k){throw this.fb(k)}finally{this.$(r,O,D)}return D}Z(r,t){return t===this.U.get(r)?null:t}$(r,t,n){const o=this.U.get(r);typeof o=="number"&&(typeof t=="number"||(typeof n=="number"?this.U.set(r,o+n):this.U.delete(r)))}async write(r,t,n,o,p){return(0,s.$ah)(()=>this.ab(r,t,n,o,p),100,3)}async ab(r,t,n,o,p){const O=this.Z(r,t);let D=null;try{D=(await v.Promises.write(r,n,o,p,O)).bytesWritten}catch(k){throw await this.gb(this.X.get(r),k)}finally{this.$(r,O,D)}return D}async mkdir(r){try{await v.Promises.mkdir(this.H(r))}catch(t){throw this.fb(t)}}async delete(r,t){try{const n=this.H(r);if(t.recursive){let o;t?.atomic!==!1&&t.atomic.postfix&&(o=(0,g.$jc)((0,g.$mc)(n),`${(0,g.$nc)(n)}${t.atomic.postfix}`)),await v.Promises.rm(n,v.RimRafMode.MOVE,o)}else try{await v.Promises.unlink(n)}catch(o){if(o.code==="EPERM"||o.code==="EISDIR"){let p=!1;try{const{stat:O,symbolicLink:D}=await v.SymlinkSupport.stat(n);p=O.isDirectory()&&!D}catch{}if(p)await v.Promises.rmdir(n);else throw o}else throw o}}catch(n){throw this.fb(n)}}async rename(r,t,n){const o=this.H(r),p=this.H(t);if(o!==p)try{await this.bb(r,t,"move",n.overwrite),await v.Promises.rename(o,p)}catch(O){throw(O.code==="EINVAL"||O.code==="EBUSY"||O.code==="ENAMETOOLONG")&&(O=new Error((0,m.localize)(2,null,(0,g.$nc)(o),(0,g.$nc)((0,g.$mc)(p)),O.toString()))),this.fb(O)}}async copy(r,t,n){const o=this.H(r),p=this.H(t);if(o!==p)try{await this.bb(r,t,"copy",n.overwrite),await v.Promises.copy(o,p,{preserveSymlinks:!0})}catch(O){throw(O.code==="EINVAL"||O.code==="EBUSY"||O.code==="ENAMETOOLONG")&&(O=new Error((0,m.localize)(3,null,(0,g.$nc)(o),(0,g.$nc)((0,g.$mc)(p)),O.toString()))),this.fb(O)}}async bb(r,t,n,o){const p=this.H(r),O=this.H(t);let D=!1;if(!!(this.capabilities&1024)||(D=(0,h.$Xf)(p,O,!0)),D){if(n==="copy")throw(0,w.$mk)((0,m.localize)(4,null),w.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const I=await this.L(r);if(!I)throw(0,w.$mk)((0,m.localize)(5,null),w.FileSystemProviderErrorCode.FileNotFound);const j=await this.L(t);if(j){if(!o)throw(0,w.$mk)((0,m.localize)(6,null),w.FileSystemProviderErrorCode.FileExists);I.type&w.FileType.File&&j.type&w.FileType.File||await this.delete(t,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(r,t){return this.cb(r,t,!1)}async cb(r,t,n){const o=this.H(r),p=this.H(t),O=!!(this.capabilities&1024);if((0,h.$Xf)(o,p,!O))return;const D=new c.$Rc;try{D.add(await this.O(r)),D.add(await this.O(t)),n&&await v.Promises.mkdir((0,g.$mc)(p),{recursive:!0}),await v.Promises.copyFile(o,p)}catch(k){if(k.code==="ENOENT"&&!n)return this.cb(r,t,!0);throw this.fb(k)}finally{D.dispose()}}t(r,t,n){return new E.$8p(o=>r(o),o=>t(o),n)}F(r,t,n){return new l.$dq(o=>r(o),o=>t(o),n)}fb(r){if(r instanceof w.$lk)return r;let t=r,n;switch(r.code){case"ENOENT":n=w.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=w.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=w.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=w.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=w.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":t=`${r.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=w.FileSystemProviderErrorCode.Unknown;break;default:n=w.FileSystemProviderErrorCode.Unknown}return(0,w.$mk)(t,n)}async gb(r,t){let n=this.fb(t);if(r&&n.code===w.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await v.SymlinkSupport.stat(this.H(r));o.mode&128||(n=(0,w.$mk)(t,w.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.a.trace(o)}return n}}e.$eq=i}),define(ie[223],ne([0,1,3,93,2,17,61,22]),function(J,e,S,A,s,R,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nr=e.$Mr=void 0;class h extends s.$Sc{constructor(b,y){super(),this.a=b,this.b=y,this.F=new Map,this.G=new Map}call(b,y,f){const v=this.c(b);switch(y){case"stat":return this.g(v,f[0]);case"readdir":return this.h(v,f[0]);case"open":return this.r(v,f[0],f[1]);case"close":return this.s(f[0]);case"read":return this.t(f[0],f[1],f[2]);case"readFile":return this.j(v,f[0],f[1]);case"write":return this.u(f[0],f[1],f[2],f[3],f[4]);case"writeFile":return this.n(v,f[0],f[1],f[2]);case"rename":return this.z(v,f[0],f[1],f[2]);case"copy":return this.C(v,f[0],f[1],f[2]);case"cloneFile":return this.D(v,f[0],f[1]);case"mkdir":return this.w(v,f[0]);case"delete":return this.y(v,f[0],f[1]);case"watch":return this.I(v,f[0],f[1],f[2],f[3]);case"unwatch":return this.J(f[0],f[1])}throw new Error(`IPC Command ${y} not found`)}listen(b,y,f){const v=this.c(b);switch(y){case"fileChange":return this.H(v,f[0]);case"readFileStream":return this.m(v,f[0],f[1])}throw new Error(`Unknown event ${y}`)}g(b,y){const f=this.f(b,y,!0);return this.a.stat(f)}h(b,y){const f=this.f(b,y);return this.a.readdir(f)}async j(b,y,f){const v=this.f(b,y,!0),m=await this.a.readFile(v,f);return R.$ce.wrap(m)}m(b,y,f){const v=this.f(b,y,!0),m=new P.$Yd,w=new S.$Od({onDidRemoveLastListener:()=>{m.cancel()}}),$=this.a.readFileStream(v,f,m.token);return(0,C.$7d)($,{onData:d=>w.fire(R.$ce.wrap(d)),onError:d=>w.fire(d),onEnd:()=>{w.fire("end"),w.dispose(),m.dispose()}}),w.event}n(b,y,f,v){const m=this.f(b,y);return this.a.writeFile(m,f.buffer,v)}r(b,y,f){const v=this.f(b,y,!0);return this.a.open(v,f)}s(b){return this.a.close(b)}async t(b,y,f){const v=R.$ce.alloc(f),m=0,w=await this.a.read(b,y,v.buffer,m,f);return[v,w]}u(b,y,f,v,m){return this.a.write(b,y,f.buffer,v,m)}w(b,y){const f=this.f(b,y);return this.a.mkdir(f)}y(b,y,f){const v=this.f(b,y);return this.a.delete(v,f)}z(b,y,f,v){const m=this.f(b,y),w=this.f(b,f);return this.a.rename(m,w,v)}C(b,y,f,v){const m=this.f(b,y),w=this.f(b,f);return this.a.copy(m,w,v)}D(b,y,f){const v=this.f(b,y),m=this.f(b,f);return this.a.cloneFile(v,m)}H(b,y){const f=new S.$Od({onWillAddFirstListener:()=>{this.F.set(y,this.L(b,f))},onDidRemoveLastListener:()=>{(0,s.$Nc)(this.F.get(y)),this.F.delete(y)}});return f.event}async I(b,y,f,v,m){const w=this.F.get(y);if(w){const $=this.f(b,v),d=w.watch(f,$,m);this.G.set(y+f,d)}}async J(b,y){const f=b+y,v=this.G.get(f);v&&((0,s.$Nc)(v),this.G.delete(f))}dispose(){super.dispose();for(const[,b]of this.G)b.dispose();this.G.clear();for(const[,b]of this.F)b.dispose();this.F.clear()}}e.$Mr=h;class c extends s.$Sc{constructor(b,y,f,v){super(),this.c=b,this.f=f,this.g=v,this.a=new Map,this.b=this.B(new A.$eq(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(y)}h(b){const y=this.B(new S.$Od);this.B(y.event(f=>{b.fire(f.map(v=>({resource:this.c.transformOutgoingURI(v.resource),type:v.type,cId:v.cId})))})),this.B(this.b.onDidChangeFile(f=>y.fire(f))),this.B(this.b.onDidWatchError(f=>b.fire(f)))}j(b){}m(b){}watch(b,y,f){const v=this.m(this.g);return Array.isArray(v)&&(f.excludes=[...f.excludes,...v]),this.a.set(b,this.b.watch(y,f)),(0,s.$Qc)(()=>{(0,s.$Nc)(this.a.get(b)),this.a.delete(b)})}dispose(){for(const[,b]of this.a)b.dispose();this.a.clear(),super.dispose()}}e.$Nr=c}),define(ie[224],ne([0,1,15,178,4,7,16,9,223,155]),function(J,e,S,A,s,R,C,P,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r7b=void 0;class g extends h.$Mr{constructor(f,v,m){super(f,v),this.M=m}c(f){return c.$Nm}f(f,v){return R.URI.revive(v)}async y(f,v,m){if(!m.useTrash)return super.y(f,v,m);const w=this.f(f,v),$=(0,P.$hc)(w.fsPath);try{await S.shell.trashItem($)}catch{throw(0,C.$mk)(s.$j?(0,A.localize)(0,null,(0,P.$nc)($)):(0,A.localize)(1,null,(0,P.$nc)($)),C.FileSystemProviderErrorCode.Unknown)}}L(f,v){return new b(f,v,this.b,this.M)}}e.$r7b=g;class b extends h.$Nr{watch(f,v,m){if(m.recursive)throw(0,C.$mk)("Recursive file watching is not supported from main process for performance reasons.",C.FileSystemProviderErrorCode.Unavailable);return super.watch(f,v,m)}}}),define(ie[225],ne([0,1,6]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h4b=void 0;class A extends S.$ej{constructor(R=S.$bj){super(),this.m=[],this.n=void 0,this.setLevel(R),this.B(this.onDidChangeLogLevel(C=>{this.n?.setLevel(C)}))}set logger(R){this.n=R;for(const{level:C,message:P}of this.m)(0,S.log)(R,C,P);this.m=[]}g(R,C){this.n?(0,S.log)(this.n,R,C):this.getLevel()<=R&&this.m.push({level:R,message:C})}dispose(){this.n?.dispose()}flush(){this.n?.flush()}}e.$h4b=A}),define(ie[226],ne([0,1,7,3,6,2]),function(J,e,S,A,s,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$er=e.$dr=e.$cr=void 0;class C extends s.$jj{constructor(b,y,f,v,m){super(y,f,v),this.r=b,this.t=m,this.B(m.listen("onDidChangeLogLevel",b)(w=>{(0,s.$aj)(w)?super.setLogLevel(w):super.setLogLevel(S.URI.revive(w[0]),w[1])})),this.B(m.listen("onDidChangeVisibility",b)(([w,$])=>super.setVisibility(S.URI.revive(w),$))),this.B(m.listen("onDidChangeLoggers",b)(({added:w,removed:$})=>{for(const d of w)super.registerLogger({...d,resource:S.URI.revive(d.resource)});for(const d of $)super.deregisterLogger(d.resource)}))}createConsoleMainLogger(){return new s.$hj({log:(b,y)=>{this.t.call("consoleLog",[b,y])}})}registerLogger(b){super.registerLogger(b),this.t.call("registerLogger",[b,this.r])}deregisterLogger(b){super.deregisterLogger(b),this.t.call("deregisterLogger",[b,this.r])}setLogLevel(b,y){super.setLogLevel(b,y),this.t.call("setLogLevel",[b,y])}setVisibility(b,y){super.setVisibility(b,y),this.t.call("setVisibility",[this.n(b),y])}s(b,y,f){return new P(this.t,b,y,f,this.r)}static setLogLevel(b,y,f){return b.call("setLogLevel",[y,f])}}e.$cr=C;class P extends s.$ej{constructor(b,y,f,v,m){super(v?.logLevel==="always"),this.r=b,this.s=y,this.m=!1,this.n=[],this.setLevel(f),this.r.call("createLogger",[y,v,m]).then(()=>{this.u(this.n),this.m=!0})}g(b,y){const f=[[b,y]];this.m?this.u(f):this.n.push(...f)}u(b){this.r.call("log",[this.s,b])}}class h{constructor(b,y){this.a=b,this.b=y}listen(b,y){const f=this.b(b);switch(y){case"onDidChangeLoggers":return A.Event.map(this.a.onDidChangeLoggers,v=>({added:[...v.added].map(m=>this.c(m,f)),removed:[...v.removed].map(m=>this.c(m,f))}));case"onDidChangeVisibility":return A.Event.map(this.a.onDidChangeVisibility,v=>[f.transformOutgoingURI(v[0]),v[1]]);case"onDidChangeLogLevel":return A.Event.map(this.a.onDidChangeLogLevel,v=>(0,s.$aj)(v)?v:[f.transformOutgoingURI(v[0]),v[1]])}throw new Error(`Event not found: ${y}`)}async call(b,y,f){const v=this.b(b);switch(y){case"setLogLevel":return(0,s.$aj)(f[0])?this.a.setLogLevel(f[0]):this.a.setLogLevel(S.URI.revive(v.transformIncoming(f[0][0])),f[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(m=>this.c(m,v)))}throw new Error(`Call not found: ${y}`)}c(b,y){return{...b,resource:y.transformOutgoingURI(b.resource)}}}e.$dr=h;class c extends R.$Sc{constructor(b,y){super(),y.call("setLogLevel",[b.getLogLevel()]),this.B(b.onDidChangeLogLevel(f=>y.call("setLogLevel",[f]))),y.call("getRegisteredLoggers").then(f=>{for(const v of f)b.registerLogger({...v,resource:S.URI.revive(v.resource)})}),this.B(y.listen("onDidChangeVisibility")(([f,v])=>b.setVisibility(S.URI.revive(f),v))),this.B(y.listen("onDidChangeLoggers")(({added:f,removed:v})=>{for(const m of f)b.registerLogger({...m,resource:S.URI.revive(m.resource)});for(const m of v)b.deregisterLogger(m.resource)}))}}e.$er=c}),define(ie[227],ne([0,1,2,6]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NN=void 0;class s extends S.$Sc{constructor(C,P=[]){super(),this.a=new A.$ij([C,...P]),this.B(C.onDidChangeLogLevel(h=>this.setLevel(h)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(C){this.a.setLevel(C)}getLevel(){return this.a.getLevel()}trace(C,...P){this.a.trace(C,...P)}debug(C,...P){this.a.debug(C,...P)}info(C,...P){this.a.info(C,...P)}warn(C,...P){this.a.warn(C,...P)}error(C,...P){this.a.error(C,...P)}flush(){this.a.flush()}}e.$NN=s}),define(ie[228],ne([0,1,31,7,6]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l8b=void 0;class R{constructor(P){this.b=P,this.a=new S.$Ac}listen(P,h,c){switch(h){case"onDidChangeLoggers":return c?this.b.getOnDidChangeLoggersEvent(c):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return c?this.b.getOnDidChangeLogLevelEvent(c):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return c?this.b.getOnDidChangeVisibilityEvent(c):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${h}`)}async call(P,h,c){switch(h){case"createLogger":this.c(A.URI.revive(c[0]),c[1],c[2]);return;case"log":return this.e(A.URI.revive(c[0]),c[1]);case"consoleLog":return this.d(c[0],c[1]);case"setLogLevel":return(0,s.$aj)(c[0])?this.b.setLogLevel(c[0]):this.b.setLogLevel(A.URI.revive(c[0]),c[1]);case"setVisibility":return this.b.setVisibility(A.URI.revive(c[0]),c[1]);case"registerLogger":return this.b.registerLogger({...c[0],resource:A.URI.revive(c[0].resource)},c[1]);case"deregisterLogger":return this.b.deregisterLogger(A.URI.revive(c[0]))}throw new Error(`Call not found: ${h}`)}c(P,h,c){this.a.set(P,this.b.createLogger(P,h,c))}d(P,h){let c=console.log;switch(P){case s.LogLevel.Error:c=console.error;break;case s.LogLevel.Warning:c=console.warn;break;case s.LogLevel.Info:c=console.info;break}c.call(console,...h)}e(P,h){const c=this.a.get(P);if(!c)throw new Error("Create the logger before logging");for(const[g,b]of h)(0,s.log)(c,g,b)}}e.$l8b=R}),define(ie[229],ne([0,1,16,6]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CN=void 0;var s;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(s||(s={}));async function R(c,g,b,y,f){try{const v=await new Promise((w,$)=>{J(["@vscode/spdlog"],w,$)});v.setFlushOn(s.Trace);const m=await v.createAsyncRotatingLogger(c,g,b,y);return f?m.clearFormatters():m.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),m}catch(v){console.error(v)}return null}function C(c,g,b){switch(g){case A.LogLevel.Trace:c.trace(b);break;case A.LogLevel.Debug:c.debug(b);break;case A.LogLevel.Info:c.info(b);break;case A.LogLevel.Warning:c.warn(b);break;case A.LogLevel.Error:c.error(b);break;case A.LogLevel.Off:break;default:throw new Error(`Invalid log level ${g}`)}}function P(c,g){switch(g){case A.LogLevel.Trace:c.setLevel(s.Trace);break;case A.LogLevel.Debug:c.setLevel(s.Debug);break;case A.LogLevel.Info:c.setLevel(s.Info);break;case A.LogLevel.Warning:c.setLevel(s.Warning);break;case A.LogLevel.Error:c.setLevel(s.Error);break;case A.LogLevel.Off:c.setLevel(s.Off);break;default:throw new Error(`Invalid log level ${g}`)}}class h extends A.$ej{constructor(g,b,y,f,v){super(),this.m=[],this.setLevel(v),this.n=this.s(g,b,y,f),this.B(this.onDidChangeLogLevel(m=>{this.r&&P(this.r,m)}))}async s(g,b,y,f){const v=y?6:1,m=30/v*S.$Hk.MB,w=await R(g,b,m,v,f);if(w){this.r=w,P(this.r,this.getLevel());for(const{level:$,message:d}of this.m)C(this.r,$,d);this.m=[]}}g(g,b){this.r?C(this.r,g,b):this.getLevel()<=g&&this.m.push({level:g,message:b})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$CN=h}),define(ie[230],ne([0,1,32,6,229]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DN=void 0;class R extends A.$jj{s(P,h,c){return new s.$CN((0,S.$fg)(),P.fsPath,!c?.donotRotate,!!c?.donotUseFormatters,h)}}e.$DN=R}),define(ie[66],ne([0,1,31,3,5,6,230]),function(J,e,S,A,s,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$56b=e.$46b=void 0,e.$46b=(0,s.$Rh)(R.$_i);class P extends C.$DN{constructor(){super(...arguments),this.u=new S.$Ac}createLogger(c,g,b){b!==void 0&&this.u.set(this.n(c),b);try{return super.createLogger(c,g)}catch(y){throw this.u.delete(this.n(c)),y}}registerLogger(c,g){g!==void 0&&this.u.set(c.resource,g),super.registerLogger(c)}deregisterLogger(c){this.u.delete(c),super.deregisterLogger(c)}getRegisteredLoggers(c){const g=[];for(const b of super.getRegisteredLoggers())c===this.u.get(b.resource)&&g.push(b);return g}getOnDidChangeLogLevelEvent(c){return A.Event.filter(this.onDidChangeLogLevel,g=>(0,R.$aj)(g)||this.w(g[0],c))}getOnDidChangeVisibilityEvent(c){return A.Event.filter(this.onDidChangeVisibility,([g])=>this.w(g,c))}getOnDidChangeLoggersEvent(c){return A.Event.filter(A.Event.map(this.onDidChangeLoggers,g=>({added:[...g.added].filter(y=>this.w(y.resource,c)),removed:[...g.removed].filter(y=>this.w(y.resource,c))})),g=>g.added.length>0||g.removed.length>0)}deregisterLoggers(c){for(const[g,b]of this.u)b===c&&this.deregisterLogger(g)}w(c,g){const b=this.u.get(c);return b===void 0||b===g}dispose(){super.dispose(),this.u.clear()}}e.$56b=P}),define(ie[231],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G7b=e.$F7b=e.$E7b=e.$D7b=void 0;function S(C){return C.submenu!==void 0}e.$D7b=S;function A(C){return C.id==="vscode.menubar.separator"}e.$E7b=A;function s(C){return C.uri!==void 0}e.$F7b=s;function R(C){return!S(C)&&!A(C)&&!s(C)}e.$G7b=R}),define(ie[39],ne([0,1,3,70,2,5]),function(J,e,S,A,s,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$on=e.$nn=e.$mn=void 0,e.$mn=(0,R.$Qh)("policy");class C extends s.$Sc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new S.$Od),this.onDidChange=this.h.event}async updatePolicyDefinitions(c){const g=Object.keys(this.f).length;return this.f={...c,...this.f},g!==Object.keys(this.f).length&&await this.j(c),A.Iterable.reduce(this.g.entries(),(b,[y,f])=>({...b,[y]:f}),{})}getPolicyValue(c){return this.g.get(c)}serialize(){return A.Iterable.reduce(Object.entries(this.f),(c,[g,b])=>({...c,[g]:{definition:b,value:this.g.get(g)}}),{})}}e.$nn=C;class P{constructor(){this.onDidChange=S.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$on=P}),define(ie[232],ne([0,1,8,3,70,12,16,6,39]),function(J,e,S,A,s,R,C,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E8b=void 0;function c(b,y){const f=[];for(const v of new Set(s.Iterable.concat(b.keys(),y.keys())))b.get(v)!==y.get(v)&&f.push(v);return f}let g=class extends h.$nn{constructor(y,f,v){super(),this.m=y,this.n=f,this.s=v,this.c=this.B(new S.$Sg(500));const m=A.Event.filter(f.onDidFilesChange,w=>w.affects(y));this.B(f.watch(y)),this.B(m(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const y=new Map;try{const f=await this.n.readFile(this.m),v=JSON.parse(f.value.toString());if(!(0,R.$Bf)(v))throw new Error("Policy file isn't a JSON object");for(const m of Object.keys(v))this.f[m]&&y.set(m,v[m])}catch(f){f.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",f)}return y}async w(){const y=await this.u(),f=c(this.g,y);this.g=y,f.length>0&&this.h.fire(f)}};e.$E8b=g,e.$E8b=g=Ee([te(1,C.$_j),te(2,P.$$i)],g)}),define(ie[233],ne([0,1,3,2,39]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d8b=e.$c8b=void 0;class R{constructor(h){this.b=h,this.a=new A.$Rc}listen(h,c){switch(c){case"onDidChange":return S.Event.map(this.b.onDidChange,g=>g.reduce((b,y)=>({...b,[y]:this.b.getPolicyValue(y)??null}),{}),this.a)}throw new Error(`Event not found: ${c}`)}call(h,c,g){switch(c){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(g)}throw new Error(`Call not found: ${c}`)}dispose(){this.a.dispose()}}e.$c8b=R;class C extends s.$nn{constructor(h,c){super(),this.a=c;for(const g in h){const{definition:b,value:y}=h[g];this.f[g]=b,y!==void 0&&this.g.set(g,y)}this.a.listen("onDidChange")(g=>{for(const b in g){const y=g[b];y===null?this.g.delete(b):this.g.set(b,y)}this.h.fire(Object.keys(g))})}async j(h){const c=await this.a.call("updatePolicyDefinitions",h);for(const g in c)this.g.set(g,c[g])}}e.$d8b=C}),define(ie[234],ne([0,1,39,8,312,2,6]),function(J,e,S,A,s,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D8b=void 0;let P=class extends S.$nn{constructor(c,g){super(),this.m=c,this.n=g,this.a=new A.$Og,this.b=this.B(new R.$Tc)}async j(c){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(c).length} policy definitions`),await this.a.queue(()=>new Promise((g,b)=>{try{this.b.value=(0,s.createWatcher)(this.n,c,y=>{this.t(y),g()})}catch(y){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",y),b(y)}}))}t(c){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(c)}`);for(const g in c){const b=c[g];b===void 0?this.g.delete(g):this.g.set(g,b)}this.h.fire(Object.keys(c))}};e.$D8b=P,e.$D8b=P=Ee([te(0,C.$$i)],P)}),define(ie[78],ne([0,1,4,35]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let s;if(typeof S.$h.vscode<"u"&&typeof S.$h.vscode.context<"u"){const R=S.$h.vscode.context.configuration();if(R)s=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(s=globalThis._VSCODE_PRODUCT_JSON,A.env.VSCODE_DEV&&Object.assign(s,{nameShort:`${s.nameShort} Dev`,nameLong:`${s.nameLong} Dev`,dataFolderName:`${s.dataFolderName}-dev`,serverDataFolderName:s.serverDataFolderName?`${s.serverDataFolderName}-dev`:void 0}),!s.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(s,{version:R.version})}}else s={},Object.keys(s).length===0&&Object.assign(s,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=s}),define(ie[25],ne([0,1,5]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rj=e.$qj=void 0,e.$qj=(0,S.$Qh)("productService"),e.$rj="vscode://schemas/vscode-product"}),define(ie[235],ne([0,1,8,6]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u7b=void 0;let s=class{constructor(C,P,h){this.a=C,this.b=P,this.c=h}async inspect(C){await this.d();const P=this.a.webContents.debugger;await P.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,S.$Vg)(C);const h=await P.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),h.profile}async d(){const C=this.a.webContents.debugger;C.attach(),await C.sendCommand("Profiler.enable")}async e(){const C=this.a.webContents.debugger;await C.sendCommand("Profiler.disable"),C.detach()}};e.$u7b=s,e.$u7b=s=Ee([te(2,A.$$i)],s)}),define(ie[79],ne([0,1,5]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T6b=void 0,e.$T6b=(0,S.$Qh)("protocolMainService")}),define(ie[43],ne([0,1,137,12]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kn=void 0;class s{constructor(){this.a=new Map}add(C,P){S.ok(A.$zf(C)),S.ok(A.$Bf(P)),S.ok(!this.a.has(C),"There is already an extension with this id"),this.a.set(C,P)}knows(C){return this.a.has(C)}as(C){return this.a.get(C)||null}}e.$kn=new s}),define(ie[236],ne([0,1,3,43]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=void 0,e.$ln={JSONContribution:"base.contributions.json"};function s(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class R{constructor(){this.b=new S.$Od,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(h,c){this.a[s(h)]=c,this.b.fire(h)}notifySchemaChanged(h){this.b.fire(h)}getSchemaContributions(){return{schemas:this.a}}}const C=new R;A.$kn.add(e.$ln.JSONContribution,C)}),define(ie[57],ne([0,1,23,3,12,163,18,236,43]),function(J,e,S,A,s,R,C,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.ConfigurationScope=e.$pn=e.EditPresentationTypes=void 0;var c;(function(l){l.Multiline="multilineText",l.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.$pn={Configuration:"base.contributions.configuration"};var g;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.MACHINE=2]="MACHINE",l[l.WINDOW=3]="WINDOW",l[l.RESOURCE=4]="RESOURCE",l[l.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",l[l.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(g||(e.ConfigurationScope=g={})),e.$qn={properties:{},patternProperties:{}},e.$rn={properties:{},patternProperties:{}},e.$sn={properties:{},patternProperties:{}},e.$tn={properties:{},patternProperties:{}},e.$un={properties:{},patternProperties:{}},e.$vn={properties:{},patternProperties:{}},e.$wn="vscode://schemas/settings/resourceLanguage",e.$xn="vscode://schemas/settings/configurationDefaults";const b=h.$kn.as(P.$ln.JSONContribution);class y{constructor(){this.h=new Set,this.i=new A.$Od,this.onDidSchemaChange=this.i.event,this.j=new A.$Od,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},b.registerSchema(e.$wn,this.g),this.v()}registerConfiguration(i,a=!0){this.registerConfigurations([i],a)}registerConfigurations(i,a=!0){const r=new Set;this.n(i,a,r),b.registerSchema(e.$wn,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(i){const a=new Set;this.o(i,a),b.registerSchema(e.$wn,this.g),this.i.fire(),this.j.fire({properties:a})}updateConfigurations({add:i,remove:a}){const r=new Set;this.o(a,r),this.n(i,!1,r),b.registerSchema(e.$wn,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(i){const a=new Set;this.k(i,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}k(i,a){const r=[];for(const{overrides:t,source:n}of i)for(const o in t)if(a.add(o),e.$zn.test(o)){const p=this.a.get(o),O=p?.valuesSources??new Map;if(n)for(const j of Object.keys(t[o]))O.set(j,n);const D={...p?.value||{},...t[o]};this.a.set(o,{source:n,value:D,valuesSources:O});const k=(0,C.$ui)(o),I={type:"object",default:D,description:R.localize(1,null,k),$ref:e.$wn,defaultDefaultValue:D,source:s.$zf(n)?void 0:n,defaultValueSource:n};r.push(...m(o)),this.d[o]=I,this.b.properties[o]=I}else{this.a.set(o,{value:t[o],source:n});const p=this.d[o];p&&(this.w(o,p),this.r(o,p))}this.m(r)}deregisterDefaultConfigurations(i){const a=new Set;this.l(i,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}l(i,a){for(const{overrides:r,source:t}of i)for(const n in r){const o=this.a.get(n),p=s.$zf(t)?t:t?.id,O=s.$zf(o?.source)?o?.source:o?.source?.id;if(p===O)if(a.add(n),this.a.delete(n),e.$zn.test(n))delete this.d[n],delete this.b.properties[n];else{const D=this.d[n];D&&(this.w(n,D),this.r(n,D))}}this.u()}deltaConfiguration(i){let a=!1;const r=new Set;i.removedDefaults&&(this.l(i.removedDefaults,r),a=!0),i.addedDefaults&&(this.k(i.addedDefaults,r),a=!0),i.removedConfigurations&&this.o(i.removedConfigurations,r),i.addedConfigurations&&this.n(i.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:a})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const a of i)this.h.add(a);this.u()}n(i,a,r){i.forEach(t=>{this.p(t,a,t.extensionInfo,t.restrictedProperties,void 0,r),this.c.push(t),this.q(t)})}o(i,a){const r=t=>{if(t.properties)for(const n in t.properties){a.add(n);const o=this.d[n];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[n],this.s(n,t.properties[n])}t.allOf?.forEach(n=>r(n))};for(const t of i){r(t);const n=this.c.indexOf(t);n!==-1&&this.c.splice(n,1)}}p(i,a=!0,r,t,n=3,o){n=s.$If(i.scope)?n:i.scope;const p=i.properties;if(p)for(const D in p){const k=p[D];if(a&&u(D,k)){delete p[D];continue}if(k.source=r,k.defaultDefaultValue=p[D].default,this.w(D,k),e.$zn.test(D)?k.scope=void 0:(k.scope=s.$If(k.scope)?n:k.scope,k.restricted=s.$If(k.restricted)?!!t?.includes(D):k.restricted),p[D].hasOwnProperty("included")&&!p[D].included){this.f[D]=p[D],delete p[D];continue}else this.d[D]=p[D],p[D].policy?.name&&this.e.set(p[D].policy.name,D);!p[D].deprecationMessage&&p[D].markdownDeprecationMessage&&(p[D].deprecationMessage=p[D].markdownDeprecationMessage),o.add(D)}const O=i.allOf;if(O)for(const D of O)this.p(D,a,r,t,n,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const a=r=>{const t=r.properties;if(t)for(const o in t)this.r(o,t[o]);r.allOf?.forEach(a)};a(i)}r(i,a){switch(e.$qn.properties[i]=a,a.scope){case 1:e.$rn.properties[i]=a;break;case 2:e.$sn.properties[i]=a;break;case 6:e.$tn.properties[i]=a;break;case 3:e.$un.properties[i]=a;break;case 4:e.$vn.properties[i]=a;break;case 5:e.$vn.properties[i]=a,this.g.properties[i]=a;break}}s(i,a){switch(delete e.$qn.properties[i],a.scope){case 1:delete e.$rn.properties[i];break;case 2:delete e.$sn.properties[i];break;case 6:delete e.$tn.properties[i];break;case 3:delete e.$un.properties[i];break;case 4:case 5:delete e.$vn.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const a=`[${i}]`,r={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.$wn};this.w(a,r),e.$qn.properties[a]=r,e.$rn.properties[a]=r,e.$sn.properties[a]=r,e.$tn.properties[a]=r,e.$un.properties[a]=r,e.$vn.properties[a]=r}}v(){const i={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.$wn};e.$qn.patternProperties[e.$yn]=i,e.$rn.patternProperties[e.$yn]=i,e.$sn.patternProperties[e.$yn]=i,e.$tn.patternProperties[e.$yn]=i,e.$un.patternProperties[e.$yn]=i,e.$vn.patternProperties[e.$yn]=i,this.i.fire()}w(i,a){const r=this.a.get(i);let t=r?.value,n=r?.source;s.$Gf(t)&&(t=a.defaultDefaultValue,n=void 0),s.$Gf(t)&&(t=$(a.type)),a.default=t,a.defaultValueSource=n}}const f="\\[([^\\]]+)\\]",v=new RegExp(f,"g");e.$yn=`^(${f})+$`,e.$zn=new RegExp(e.$yn);function m(l){const i=[];if(e.$zn.test(l)){let a=v.exec(l);for(;a?.length;){const r=a[1].trim();r&&i.push(r),a=v.exec(l)}}return(0,S.$Mb)(i)}e.$An=m;function w(l){return l.reduce((i,a)=>`${i}[${a}]`,"")}e.$Bn=w;function $(l){switch(Array.isArray(l)?l[0]:l){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$Cn=$;const d=new y;h.$kn.add(e.$pn.Configuration,d);function u(l,i){return l.trim()?e.$zn.test(l)?R.localize(7,null,l):d.getConfigurationProperties()[l]!==void 0?R.localize(8,null,l):i.policy?.name&&d.getPolicyConfigurations().get(i.policy?.name)!==void 0?R.localize(9,null,l,i.policy?.name,d.getPolicyConfigurations().get(i.policy?.name)):null:R.localize(6,null)}e.$Dn=u;function E(){const l=[],i=d.getConfigurationProperties();for(const a of Object.keys(i))l.push([a,i[a].scope]);return l.push(["launch",4]),l.push(["task",4]),l}e.$En=E}),define(ie[119],ne([0,1,23,3,44,2,31,37,12,7,18,57,43]),function(J,e,S,A,s,R,C,P,h,c,g,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=void 0;function f(a){return Object.isFrozen(a)?a:P.$9m(a)}class v{constructor(r={},t=[],n=[],o){this.b=r,this.c=t,this.d=n,this.raw=o,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const r=this.raw.map(t=>{if(t instanceof v)return t;const n=new m("");return n.parseRaw(t),n.configurationModel});this.f=r.reduce((t,n)=>n===t?n:t.merge(n),r[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,g.$si)(this.contents,r):this.contents}inspect(r,t){const n=this.rawConfiguration.getValue(r),o=t?this.rawConfiguration.getOverrideValue(r,t):void 0,p=t?this.rawConfiguration.override(t).getValue(r):n;return{value:n,override:o,merged:p}}getOverrideValue(r,t){const n=this.i(t);return n?r?(0,g.$si)(n,r):n:void 0}getKeysForOverrideIdentifier(r){const t=[];for(const n of this.overrides)n.identifiers.includes(r)&&t.push(...n.keys);return S.$Mb(t)}getAllOverrideIdentifiers(){const r=[];for(const t of this.overrides)r.push(...t.identifiers);return S.$Mb(r)}override(r){let t=this.a.get(r);return t||(t=this.g(r),this.a.set(r,t)),t}merge(...r){const t=P.$8m(this.contents),n=P.$8m(this.overrides),o=[...this.keys],p=this.raw?.length?[...this.raw]:[this];for(const O of r)if(p.push(...O.raw?.length?O.raw:[O]),!O.isEmpty()){this.h(t,O.contents);for(const D of O.overrides){const[k]=n.filter(I=>S.$ub(I.identifiers,D.identifiers));k?(this.h(k.contents,D.contents),k.keys.push(...D.keys),k.keys=S.$Mb(k.keys)):n.push(P.$8m(D))}for(const D of O.keys)o.indexOf(D)===-1&&o.push(D)}return new v(t,o,n,p.every(O=>O instanceof v)?void 0:p)}g(r){const t=this.i(r);if(!t||typeof t!="object"||!Object.keys(t).length)return this;const n={};for(const o of S.$Mb([...Object.keys(this.contents),...Object.keys(t)])){let p=this.contents[o];const O=t[o];O&&(typeof p=="object"&&typeof O=="object"?(p=P.$8m(p),this.h(p,O)):p=O),n[o]=p}return new v(n,this.keys,this.overrides)}h(r,t){for(const n of Object.keys(t)){if(n in r&&h.$Bf(r[n])&&h.$Bf(t[n])){this.h(r[n],t[n]);continue}r[n]=P.$8m(t[n])}}i(r){let t=null,n=null;const o=p=>{p&&(n?this.h(n,p):n=P.$8m(p))};for(const p of this.overrides)p.identifiers.length===1&&p.identifiers[0]===r?t=p.contents:p.identifiers.includes(r)&&o(p.contents);return o(t),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,t){this.j(r,t,!0)}setValue(r,t){this.j(r,t,!1)}removeValue(r){const t=this.keys.indexOf(r);t!==-1&&(this.keys.splice(t,1),(0,g.$ri)(this.contents,r),b.$zn.test(r)&&this.overrides.splice(this.overrides.findIndex(n=>S.$ub(n.identifiers,(0,b.$An)(r))),1))}j(r,t,n){(0,g.$qi)(this.contents,r,t,o=>console.error(o)),n=n||this.keys.indexOf(r)===-1,n&&this.keys.push(r),b.$zn.test(r)&&this.overrides.push({identifiers:(0,b.$An)(r),keys:Object.keys(this.contents[r]),contents:(0,g.$pi)(this.contents[r],o=>console.error(o))})}}e.$Fn=v;class m{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new v}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,t){if(!h.$If(r)){const n=this.g(r);this.parseRaw(n,t)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,t){this.a=r;const{contents:n,keys:o,overrides:p,restricted:O,hasExcludedProperties:D}=this.h(r,t);this.b=new v(n,o,p,D?[r]:void 0),this.c=O||[]}g(r){let t={},n=null,o=[];const p=[],O=[];function D(I){Array.isArray(o)?o.push(I):n!==null&&(o[n]=I)}const k={onObjectBegin:()=>{const I={};D(I),p.push(o),o=I,n=null},onObjectProperty:I=>{n=I},onObjectEnd:()=>{o=p.pop()},onArrayBegin:()=>{const I=[];D(I),p.push(o),o=I,n=null},onArrayEnd:()=>{o=p.pop()},onLiteralValue:D,onError:(I,j,U)=>{O.push({error:I,offset:j,length:U})}};if(r)try{s.$5m(r,k),t=o[0]||{}}catch(I){console.error(`Error while parsing settings file ${this.f}: ${I}`),this.d=[I]}return t}h(r,t){const n=y.$kn.as(b.$pn.Configuration).getConfigurationProperties(),o=this.i(r,n,!0,t);r=o.raw;const p=(0,g.$pi)(r,k=>console.error(`Conflict in settings file ${this.f}: ${k}`)),O=Object.keys(r),D=this.j(r,k=>console.error(`Conflict in settings file ${this.f}: ${k}`));return{contents:p,keys:O,overrides:D,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}i(r,t,n,o){let p=!1;if(!o?.scopes&&!o?.skipRestricted&&!o?.exclude?.length)return{raw:r,restricted:[],hasExcludedProperties:p};const O={},D=[];for(const k in r)if(b.$zn.test(k)&&n){const I=this.i(r[k],t,!1,o);O[k]=I.raw,p=p||I.hasExcludedProperties,D.push(...I.restricted)}else{const I=t[k],j=I?typeof I.scope<"u"?I.scope:3:void 0;I?.restricted&&D.push(k),!o.exclude?.includes(k)&&(o.include?.includes(k)||(j===void 0||o.scopes===void 0||o.scopes.includes(j))&&!(o.skipRestricted&&I?.restricted))?O[k]=r[k]:p=!0}return{raw:O,restricted:D,hasExcludedProperties:p}}j(r,t){const n=[];for(const o of Object.keys(r))if(b.$zn.test(o)){const p={};for(const O in r[o])p[O]=r[o][O];n.push({identifiers:(0,b.$An)(o),keys:Object.keys(p),contents:(0,g.$pi)(p,t)})}return n}}e.$Gn=m;class w extends R.$Sc{constructor(r,t,n,o){super(),this.c=r,this.f=t,this.g=o,this.b=this.B(new A.$Od),this.onDidChange=this.b.event,this.a=new m(this.c.toString()),this.B(this.g.watch(n.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(A.Event.any(A.Event.filter(this.g.onDidFilesChange,p=>p.contains(this.c)),A.Event.filter(this.g.onDidRunOperation,p=>(p.isOperation(0)||p.isOperation(3)||p.isOperation(1)||p.isOperation(4))&&n.isEqual(p.resource,r)))(()=>this.b.fire()))}async loadConfiguration(){try{const r=await this.g.readFile(this.c);return this.a.parse(r.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new v}}reparse(r){return r&&(this.f=r),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Hn=w;class ${constructor(r,t,n,o,p,O,D,k,I,j,U,z,x){this.a=r,this.b=t,this.c=n,this.overrideIdentifiers=o,this.d=p,this.f=O,this.g=D,this.h=k,this.i=I,this.j=j,this.k=U,this.l=z,this.m=x}get value(){return f(this.c)}n(r,t,n){const o=r.inspect(t,n);return{get value(){return f(o.value)},get override(){return f(o.override)},get merged(){return f(o.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class d{constructor(r,t,n,o,p=new v,O=new v,D=new C.$Ac,k=new v,I=new C.$Ac){this.c=r,this.d=t,this.f=n,this.g=o,this.h=p,this.i=O,this.j=D,this.l=k,this.m=I,this.a=null,this.b=new C.$Ac,this.n=null}getValue(r,t,n){return this.q(r,t,n).getValue(r)}updateValue(r,t,n={}){let o;n.resource?(o=this.m.get(n.resource),o||(o=new v,this.m.set(n.resource,o))):o=this.l,t===void 0?o.removeValue(r):o.setValue(r,t),n.resource||(this.a=null)}inspect(r,t,n){const o=this.q(r,t,n),p=this.u(t.resource,n),O=t.resource?this.m.get(t.resource)||this.l:this.l,D=new Set;for(const k of o.overrides)for(const I of k.identifiers)o.getOverrideValue(r,I)!==void 0&&D.add(I);return new $(r,t,o.getValue(r),D.size?[...D]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this.i:void 0,p||void 0,O)}keys(r){const t=this.u(void 0,r);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:t?t.keys.slice(0):[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.i=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,t){this.j.set(r,t),this.b.delete(r)}deleteFolderConfiguration(r){this.p.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,t){const n=[];if(!t){const{added:o,updated:p,removed:O}=l(this.c,r);t=[...o,...p,...O]}for(const o of t)for(const p of(0,b.$An)(o)){const O=this.c.getKeysForOverrideIdentifier(p),D=r.getKeysForOverrideIdentifier(p),k=[...D.filter(I=>O.indexOf(I)===-1),...O.filter(I=>D.indexOf(I)===-1),...O.filter(I=>!P.$_m(this.c.override(p).getValue(I),r.override(p).getValue(I)))];n.push([p,k])}return this.updateDefaultConfiguration(r),{keys:t,overrides:n}}compareAndUpdatePolicyConfiguration(r){const{added:t,updated:n,removed:o}=l(this.d,r),p=[...t,...n,...o];return p.length&&this.updatePolicyConfiguration(r),{keys:p,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:t,updated:n,removed:o,overrides:p}=l(this.applicationConfiguration,r),O=[...t,...n,...o];return O.length&&this.updateApplicationConfiguration(r),{keys:O,overrides:p}}compareAndUpdateLocalUserConfiguration(r){const{added:t,updated:n,removed:o,overrides:p}=l(this.localUserConfiguration,r),O=[...t,...n,...o];return O.length&&this.updateLocalUserConfiguration(r),{keys:O,overrides:p}}compareAndUpdateRemoteUserConfiguration(r){const{added:t,updated:n,removed:o,overrides:p}=l(this.remoteUserConfiguration,r),O=[...t,...n,...o];return O.length&&this.updateRemoteUserConfiguration(r),{keys:O,overrides:p}}compareAndUpdateWorkspaceConfiguration(r){const{added:t,updated:n,removed:o,overrides:p}=l(this.workspaceConfiguration,r),O=[...t,...n,...o];return O.length&&this.updateWorkspaceConfiguration(r),{keys:O,overrides:p}}compareAndUpdateFolderConfiguration(r,t){const n=this.p.get(r),{added:o,updated:p,removed:O,overrides:D}=l(n,t),k=[...o,...p,...O];return(k.length||!n)&&this.updateFolderConfiguration(r,t),{keys:k,overrides:D}}compareAndDeleteFolderConfiguration(r){const t=this.p.get(r);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:n,updated:o,removed:p,overrides:O}=l(t,void 0);return{keys:[...n,...o,...p],overrides:O}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(r,t,n){let o=this.r(t,n);return t.overrideIdentifier&&(o=o.override(t.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(o=o.merge(this.d)),o}r({resource:r},t){let n=this.s();if(t&&r){const o=t.getFolder(r);o&&(n=this.t(o.uri)||n);const p=this.m.get(r);p&&(n=n.merge(p))}return n}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(r){let t=this.b.get(r);if(!t){const n=this.s(),o=this.j.get(r);o?(t=n.merge(o),this.b.set(r,t)):t=n}return t}u(r,t){if(t&&r){const n=t.getFolder(r);if(n)return this.j.get(n.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((r,t)=>{const{contents:n,overrides:o,keys:p}=this.j.get(t);return r.push([t,{contents:n,overrides:o,keys:p}]),r},[])}}allKeys(){const r=new Set;return this.c.keys.forEach(t=>r.add(t)),this.userConfiguration.keys.forEach(t=>r.add(t)),this.i.keys.forEach(t=>r.add(t)),this.j.forEach(t=>t.keys.forEach(n=>r.add(n))),[...r.values()]}v(){const r=new Set;return this.c.getAllOverrideIdentifiers().forEach(t=>r.add(t)),this.userConfiguration.getAllOverrideIdentifiers().forEach(t=>r.add(t)),this.i.getAllOverrideIdentifiers().forEach(t=>r.add(t)),this.j.forEach(t=>t.getAllOverrideIdentifiers().forEach(n=>r.add(n))),[...r.values()]}w(r){const t=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(n=>t.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>t.add(n)),this.i.getKeysForOverrideIdentifier(r).forEach(n=>t.add(n)),this.j.forEach(n=>n.getKeysForOverrideIdentifier(r).forEach(o=>t.add(o))),[...t.values()]}static parse(r){const t=this.x(r.defaults),n=this.x(r.policy),o=this.x(r.application),p=this.x(r.user),O=this.x(r.workspace),D=r.folders.reduce((k,I)=>(k.set(c.URI.revive(I[0]),this.x(I[1])),k),new C.$Ac);return new d(t,n,o,p,new v,O,D,new v,new C.$Ac)}static x(r){return new v(r.contents,r.keys,r.overrides)}}e.$In=d;function u(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const r=new Set,t=new Map;for(const o of a)o.keys.forEach(p=>r.add(p)),o.overrides.forEach(([p,O])=>{const D=(0,C.$xc)(t,p,new Set);O.forEach(k=>D.add(k))});const n=[];return t.forEach((o,p)=>n.push([p,[...o.values()]])),{keys:[...r.values()],overrides:n}}e.$Jn=u;class E{constructor(r,t,n,o){this.change=r,this.f=t,this.g=n,this.h=o,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const p of r.keys)this.affectedKeys.add(p);for(const[,p]of r.overrides)for(const O of p)this.affectedKeys.add(O);this.d=this.a;for(const p of this.affectedKeys)this.d+=p+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=d.parse(this.f.data)),this.i}affectsConfiguration(r,t){const n=this.a+r,o=this.d.indexOf(n);if(o<0)return!1;const p=o+n.length;if(p>=this.d.length)return!1;const O=this.d.charCodeAt(p);if(O!==this.b&&O!==this.c)return!1;if(t){const D=this.previousConfiguration?this.previousConfiguration.getValue(r,t,this.f?.workspace):void 0,k=this.g.getValue(r,t,this.h);return!P.$_m(D,k)}return!0}}e.$Kn=E;function l(a,r){const{added:t,removed:n,updated:o}=i(r?.rawConfiguration,a?.rawConfiguration),p=[],O=a?.getAllOverrideIdentifiers()||[],D=r?.getAllOverrideIdentifiers()||[];if(r){const k=D.filter(I=>!O.includes(I));for(const I of k)p.push([I,r.getKeysForOverrideIdentifier(I)])}if(a){const k=O.filter(I=>!D.includes(I));for(const I of k)p.push([I,a.getKeysForOverrideIdentifier(I)])}if(r&&a){for(const k of O)if(D.includes(k)){const I=i({contents:a.getOverrideValue(void 0,k)||{},keys:a.getKeysForOverrideIdentifier(k)},{contents:r.getOverrideValue(void 0,k)||{},keys:r.getKeysForOverrideIdentifier(k)});p.push([k,[...I.added,...I.removed,...I.updated]])}}return{added:t,removed:n,updated:o,overrides:p}}function i(a,r){const t=a?r?a.keys.filter(p=>r.keys.indexOf(p)===-1):[...a.keys]:[],n=r?a?r.keys.filter(p=>a.keys.indexOf(p)===-1):[...r.keys]:[],o=[];if(a&&r){for(const p of r.keys)if(a.keys.indexOf(p)!==-1){const O=(0,g.$si)(r.contents,p),D=(0,g.$si)(a.contents,p);P.$_m(O,D)||o.push(p)}}return{added:t,removed:n,updated:o}}}),define(ie[237],ne([0,1,23,3,2,37,12,119,57,6,39,43]),function(J,e,S,A,s,R,C,P,h,c,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nn=e.$Mn=e.$Ln=void 0;class y extends s.$Sc{constructor(){super(...arguments),this.a=this.B(new A.$Od),this.onDidChangeConfiguration=this.a.event,this.b=new P.$Fn}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(b.$kn.as(h.$pn.Configuration).onDidUpdateConfiguration(({properties:w,defaultsOverrides:$})=>this.c(Array.from(w),$))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(w,$){this.h(w,b.$kn.as(h.$pn.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:w})}f(){return{}}g(){this.b=new P.$Fn;const w=b.$kn.as(h.$pn.Configuration).getConfigurationProperties();this.h(Object.keys(w),w)}h(w,$){const d=this.f();for(const u of w){const E=d[u],l=$[u];E!==void 0?this.b.addValue(u,E):l?this.b.addValue(u,l.default):this.b.removeValue(u)}}}e.$Ln=y;class f{constructor(){this.onDidChangeConfiguration=A.Event.None,this.configurationModel=new P.$Fn}async initialize(){return this.configurationModel}}e.$Mn=f;let v=class extends s.$Sc{get configurationModel(){return this.b}constructor(w,$,d){super(),this.c=w,this.f=$,this.g=d,this.a=this.B(new A.$Od),this.onDidChangeConfiguration=this.a.event,this.b=new P.$Fn}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(w=>this.j(w))),this.B(this.c.onDidChangeConfiguration(async({properties:w})=>this.m(await this.h(w),!0))),this.b}async h(w){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",w);const $={},d=[],u=b.$kn.as(h.$pn.Configuration).getConfigurationProperties();for(const E of w){const l=u[E];if(!l){d.push(E);continue}if(l.policy){if(l.type!=="string"&&l.type!=="number"){this.g.warn(`Policy ${l.policy.name} has unsupported type ${l.type}`);continue}d.push(E),$[l.policy.name]={type:l.type}}}return(0,C.$Mf)($)||await this.f.updatePolicyDefinitions($),d}j(w){this.g.trace("PolicyConfiguration#onDidChangePolicies",w);const $=b.$kn.as(h.$pn.Configuration).getPolicyConfigurations(),d=(0,S.$Hb)(w.map(u=>$.get(u)));this.m(d,!0)}m(w,$){this.g.trace("PolicyConfiguration#update",w);const d=b.$kn.as(h.$pn.Configuration).getConfigurationProperties(),u=[],E=this.b.isEmpty();for(const l of w){const i=d[l]?.policy?.name;if(i){const a=this.f.getPolicyValue(i);(E?a!==void 0:!(0,R.$_m)(this.b.getValue(l),a))&&u.push([l,a])}else this.b.getValue(l)!==void 0&&u.push([l,void 0])}if(u.length){this.g.trace("PolicyConfiguration#changed",u);const l=this.b;this.b=new P.$Fn;for(const i of l.keys)this.b.setValue(i,l.getValue(i));for(const[i,a]of u)a===void 0?this.b.removeValue(i):this.b.setValue(i,a);$&&this.a.fire(this.b)}}};e.$Nn=v,e.$Nn=v=Ee([te(1,g.$mn),te(2,c.$$i)],v)}),define(ie[238],ne([0,1,8,3,2,19,18,119,237,39]),function(J,e,S,A,s,R,C,P,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$On=void 0;class g extends s.$Sc{constructor(y,f,v,m){super(),this.j=y,this.h=this.B(new A.$Od),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new h.$Ln),this.c=v instanceof c.$on?new h.$Mn:this.B(new h.$Nn(this.b,v,m)),this.f=this.B(new P.$Hn(this.j,{},R.$ng,f)),this.a=new P.$In(this.b.configurationModel,this.c.configurationModel,new P.$Fn,new P.$Fn),this.g=this.B(new S.$7g(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:w,properties:$})=>this.n(w,$))),this.B(this.c.onDidChangeConfiguration(w=>this.r(w))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[y,f,v]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new P.$In(y,f,new P.$Fn,v)}getConfigurationData(){return this.a.toData()}getValue(y,f){const v=typeof y=="string"?y:void 0,m=(0,C.$li)(y)?y:(0,C.$li)(f)?f:{};return this.a.getValue(v,m,void 0)}updateValue(y,f,v,m){return Promise.reject(new Error("not supported"))}inspect(y){return this.a.inspect(y,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const y=await this.f.loadConfiguration();this.m(y)}m(y){const f=this.a.toData(),v=this.a.compareAndUpdateLocalUserConfiguration(y);this.s(v,f,2)}n(y,f){const v=this.a.toData(),m=this.a.compareAndUpdateDefaultConfiguration(y,f);this.s(m,v,7)}r(y){const f=this.a.toData(),v=this.a.compareAndUpdatePolicyConfiguration(y);this.s(v,f,7)}s(y,f,v){const m=new P.$Kn(y,{data:f},this.a);m.source=v,m.sourceConfig=this.t(v),this.h.fire(m)}t(y){switch(y){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$On=g}),define(ie[239],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s8b=e.$r8b=e.$q8b=void 0,e.$q8b="request",e.$r8b="remoteResourceHandler";class S{async routeCall(s,R,C){if(R!==e.$q8b)throw new Error(`Call not found: ${R}`);const P=C[0];if(P?.authority){const h=s.connections.find(c=>c.ctx===P.authority);if(h)return h}throw new Error("Caller not found")}routeEvent(s,R){throw new Error(`Event not found: ${R}`)}}e.$s8b=S}),define(ie[240],ne([0,1,14,5]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uk=e.$Tk=e.RemoteAuthorityResolverErrorCode=e.$Sk=e.$Rk=e.RemoteConnectionType=e.$Qk=void 0,e.$Qk=(0,A.$Qh)("remoteAuthorityResolverService");var s;(function(g){g[g.WebSocket=0]="WebSocket",g[g.Managed=1]="Managed"})(s||(e.RemoteConnectionType=s={}));class R{constructor(b){this.id=b,this.type=1}toString(){return`Managed(${this.id})`}}e.$Rk=R;class C{constructor(b,y){this.host=b,this.port=y,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Sk=C;var P;(function(g){g.Unknown="Unknown",g.NotAvailable="NotAvailable",g.TemporarilyNotAvailable="TemporarilyNotAvailable",g.NoResolverFound="NoResolverFound",g.InvalidAuthority="InvalidAuthority"})(P||(e.RemoteAuthorityResolverErrorCode=P={}));class h extends S.$bb{static isNotAvailable(b){return b instanceof h&&b._code===P.NotAvailable}static isTemporarilyNotAvailable(b){return b instanceof h&&b._code===P.TemporarilyNotAvailable}static isNoResolverFound(b){return b instanceof h&&b._code===P.NoResolverFound}static isInvalidAuthority(b){return b instanceof h&&b._code===P.InvalidAuthority}static isHandled(b){return b instanceof h&&b.isHandled}constructor(b,y=P.Unknown,f){super(b),this._message=b,this._code=y,this._detail=f,this.isHandled=y===P.NotAvailable&&f===!0,Object.setPrototypeOf(this,h.prototype)}}e.$Tk=h;function c(g){const b=g.indexOf("+");return b===-1?g:g.substring(0,b)}e.$Uk=c}),define(ie[58],ne([0,1,13]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zk=e.$Yk=e.$Xk=e.$Wk=e.$Vk=void 0;function A(c){return c.scheme===S.Schemas.vscodeRemote?c.authority:void 0}e.$Vk=A;function s(c){if(!c)return;const g=c.indexOf("+");return g<0?c:c.substr(0,g)}e.$Wk=s;function R(c){return`/${c.quality??"oss"}-${c.commit??"dev"}`}e.$Xk=R;function C(c){const{host:g,port:b}=h(c);if(typeof b>"u")throw new Error("Remote authority doesn't contain a port!");return{host:g,port:b}}e.$Yk=C;function P(c,g){let{host:b,port:y}=h(c);return typeof y>"u"&&(y=g),{host:b,port:y}}e.$Zk=P;function h(c){const g=c.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(g)return{host:g[1],port:parseInt(g[2],10)};const b=c.match(/^(\[[0-9a-z:]+\])$/);if(b)return{host:b[1],port:void 0};const y=c.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:c,port:void 0}}}),define(ie[120],ne([0,1,27,5,58]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.TargetPlatform=e.ExtensionType=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=void 0,e.$1l="extensions.user.cache",e.$2l="extensions.builtin.cache",e.$3l="undefined_publisher",e.$4l=["ui","workspace","web"];function R(m){if(typeof m=="object"&&m!==null&&m.supported!==!0)return m.description}e.$5l=R,e.$6l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var C;(function(m){m[m.System=0]="System",m[m.User=1]="User"})(C||(e.ExtensionType=C={}));var P;(function(m){m.WIN32_X64="win32-x64",m.WIN32_ARM64="win32-arm64",m.LINUX_X64="linux-x64",m.LINUX_ARM64="linux-arm64",m.LINUX_ARMHF="linux-armhf",m.ALPINE_X64="alpine-x64",m.ALPINE_ARM64="alpine-arm64",m.DARWIN_X64="darwin-x64",m.DARWIN_ARM64="darwin-arm64",m.WEB="web",m.UNIVERSAL="universal",m.UNKNOWN="unknown",m.UNDEFINED="undefined"})(P||(e.TargetPlatform=P={}));class h{constructor(w){this.value=w,this._lower=w.toLowerCase()}static equals(w,$){if(typeof w>"u"||w===null)return typeof $>"u"||$===null;if(typeof $>"u"||$===null)return!1;if(typeof w=="string"||typeof $=="string"){const d=typeof w=="string"?w:w.value,u=typeof $=="string"?$:$.value;return S.$3e(d,u)}return w._lower===$._lower}static toKey(w){return typeof w=="string"?w.toLowerCase():w._lower}}e.$7l=h;class c{get size(){return this.c.size}constructor(w){if(this.c=new Set,w)for(const $ of w)this.add($)}add(w){this.c.add(h.toKey(w))}delete(w){return this.c.delete(h.toKey(w))}has(w){return this.c.has(h.toKey(w))}}e.$8l=c;class g{constructor(){this.c=new Map}clear(){this.c.clear()}delete(w){this.c.delete(h.toKey(w))}get(w){return this.c.get(h.toKey(w))}has(w){return this.c.has(h.toKey(w))}set(w,$){this.c.set(h.toKey(w),$)}values(){return this.c.values()}forEach(w){this.c.forEach(w)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$9l=g;function b(m){return y(m)}e.$0l=b;function y(m){return m.contributes&&m.contributes.localizations?m.contributes.localizations.length>0:!1}e.$$l=y;function f(m){return m.contributes&&m.contributes.authentication?m.contributes.authentication.length>0:!1}e.$_l=f;function v(m,w){if(w){const $=`onResolveRemoteAuthority:${(0,s.$Wk)(w)}`;return!!m.activationEvents?.includes($)}return!1}e.$am=v,e.$bm=(0,A.$Qh)("IBuiltinExtensionsScannerService")}),define(ie[241],ne([0,1,8,17,22,14,3,2,65,72,32,109,240,58]),function(J,e,S,A,s,R,C,P,h,c,g,b,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cl=e.$bl=e.$al=e.$_k=e.$$k=e.$0k=e.$9k=e.$8k=e.PersistentConnectionEventType=e.$7k=e.$6k=e.$5k=e.ConnectionType=void 0;const v=30*1e3;var m;(function(L){L[L.Management=1]="Management",L[L.ExtensionHost=2]="ExtensionHost",L[L.Tunnel=3]="Tunnel"})(m||(e.ConnectionType=m={}));function w(L){switch(L){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function $(L){const M=new s.$Yd;return setTimeout(()=>M.cancel(),L),M.token}function d(L,M){if(L.isCancellationRequested||M.isCancellationRequested)return s.CancellationToken.Cancelled;const N=new s.$Yd;return L.onCancellationRequested(()=>N.cancel()),M.onCancellationRequested(()=>N.cancel()),N.token}class u{get didTimeout(){return this.c==="timedout"}constructor(M){this.c="pending",this.d=new P.$Rc,this.promise=new Promise((N,T)=>{this.f=N,this.g=T}),M.isCancellationRequested?this.h():this.d.add(M.onCancellationRequested(()=>this.h()))}registerDisposable(M){this.c==="pending"?this.d.add(M):M.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const M=new Error("Time limit reached");return M.code="ETIMEDOUT",M.syscall="connect",M}resolve(M){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(M))}reject(M){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(M))}}function E(L,M){const N=new u(M);return N.registerDisposable(L.onControlMessage(T=>{const F=JSON.parse(T.toString()),B=q(F);B?N.reject(B):N.resolve(F)})),N.promise}function l(L,M,N,T,F,B,V,oe){const de=new u(oe),ue=c.$Kd.create(!1);return L.info(`Creating a socket (${V})...`),h.mark(`code/willCreateSocket/${B}`),M.connect(N,T,F,V).then(he=>{de.didTimeout?(h.mark(`code/didCreateSocketError/${B}`),L.info(`Creating a socket (${V}) finished after ${ue.elapsed()} ms, but this is too late and has timed out already.`),he?.dispose()):(h.mark(`code/didCreateSocketOK/${B}`),L.info(`Creating a socket (${V}) was successful after ${ue.elapsed()} ms.`),de.resolve(he))},he=>{h.mark(`code/didCreateSocketError/${B}`),L.info(`Creating a socket (${V}) returned an error after ${ue.elapsed()} ms.`),L.error(he),de.reject(he)}),de.promise}function i(L,M){const N=new u(M);return L.then(T=>{N.didTimeout||N.resolve(T)},T=>{N.didTimeout||N.reject(T)}),N.promise}async function a(L,M,N,T){const F=X(L,M);L.logService.trace(`${F} 1/6. invoking socketFactory.connect().`);let B;try{B=await l(L.logService,L.remoteSocketFactoryService,L.connectTo,(0,f.$Xk)(L),`reconnectionToken=${L.reconnectionToken}&reconnection=${L.reconnectionProtocol?"true":"false"}`,w(M),`renderer-${w(M)}-${L.reconnectionToken}`,T)}catch(he){throw L.logService.error(`${F} socketFactory.connect() failed or timed out. Error:`),L.logService.error(he),he}L.logService.trace(`${F} 2/6. socketFactory.connect() was successful.`);let V,oe;L.reconnectionProtocol?(L.reconnectionProtocol.beginAcceptReconnection(B,null),V=L.reconnectionProtocol,oe=!1):(V=new b.$Eh({socket:B}),oe=!0),L.logService.trace(`${F} 3/6. sending AuthRequest control message.`);const de=await i(L.signService.createNewMessage((0,g.$fg)()),T),ue={type:"auth",auth:L.connectionToken||"00000000000000000000",data:de.data};V.sendControl(A.$ce.fromString(JSON.stringify(ue)));try{const he=await E(V,d(T,$(1e4)));if(he.type!=="sign"||typeof he.data!="string"){const Ie=new Error("Unexpected handshake message");throw Ie.code="VSCODE_CONNECTION_ERROR",Ie}if(L.logService.trace(`${F} 4/6. received SignRequest control message.`),!await i(L.signService.validate(de,he.signedData),T)){const Ie=new Error("Refused to connect to unsupported server");throw Ie.code="VSCODE_CONNECTION_ERROR",Ie}const be=await i(L.signService.sign(he.data),T),ye={type:"connectionType",commit:L.commit,signedData:be,desiredConnectionType:M};return N&&(ye.args=N),L.logService.trace(`${F} 5/6. sending ConnectionTypeRequest control message.`),V.sendControl(A.$ce.fromString(JSON.stringify(ye))),{protocol:V,ownsProtocol:oe}}catch(he){throw he&&he.code==="ETIMEDOUT"&&(L.logService.error(`${F} the handshake timed out. Error:`),L.logService.error(he)),he&&he.code==="VSCODE_CONNECTION_ERROR"&&(L.logService.error(`${F} received error control message when negotiating connection. Error:`),L.logService.error(he)),oe&&Q(V),he}}async function r(L,M,N,T){const F=Date.now(),B=X(L,M),{protocol:V,ownsProtocol:oe}=await a(L,M,N,T),de=new u(T);return de.registerDisposable(V.onControlMessage(ue=>{const he=JSON.parse(ue.toString()),ve=q(he);ve?(L.logService.error(`${B} received error control message when negotiating connection. Error:`),L.logService.error(ve),oe&&Q(V),de.reject(ve)):(L.reconnectionProtocol?.endAcceptReconnection(),L.logService.trace(`${B} 6/6. handshake finished, connection is up and running after ${re(F)}!`),de.resolve({protocol:V,firstMessage:he}))})),de.promise}async function t(L,M){const{protocol:N}=await r(L,1,void 0,M);return{protocol:N}}async function n(L,M,N){const{protocol:T,firstMessage:F}=await r(L,2,M,N),B=F&&F.debugPort;return{protocol:T,debugPort:B}}async function o(L,M,N){const T=Date.now(),F=X(L,3),{protocol:B}=await a(L,3,M,N);return L.logService.trace(`${F} 6/6. handshake finished, connection is up and running after ${re(T)}!`),B}async function p(L,M,N){const{connectTo:T,connectionToken:F}=await L.addressProvider.getAddress();return{commit:L.commit,quality:L.quality,connectTo:T,connectionToken:F,reconnectionToken:M,reconnectionProtocol:N,remoteSocketFactoryService:L.remoteSocketFactoryService,signService:L.signService,logService:L.logService}}async function O(L,M,N){return k(L,async T=>{const{protocol:F}=await t(T,s.CancellationToken.None);return new Y(L,M,N,T.reconnectionToken,F)})}e.$5k=O;async function D(L,M){return k(L,async N=>{const{protocol:T,debugPort:F}=await n(N,M,s.CancellationToken.None);return new K(L,M,N.reconnectionToken,T,F)})}e.$6k=D;async function k(L,M){for(let T=1;;T++)try{const F=(0,g.$fg)(),B=await p(L,F,null);return await M(B)}catch(F){if(T<5)L.logService.error(`[remote-connection][attempt ${T}] An error occurred in initial connection! Will retry... Error:`),L.logService.error(F);else throw L.logService.error(`[remote-connection][attempt ${T}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),L.logService.error(F),ce.triggerPermanentFailure(0,0,y.$Tk.isHandled(F)),F}}async function I(L,M,N){const T=await p(L,(0,g.$fg)(),null);return await o(T,{host:M,port:N},s.CancellationToken.None)}e.$7k=I;function j(L){return(0,S.$Ig)(M=>new Promise((N,T)=>{const F=setTimeout(N,L*1e3);M.onCancellationRequested(()=>{clearTimeout(F),N()})}))}var U;(function(L){L[L.ConnectionLost=0]="ConnectionLost",L[L.ReconnectionWait=1]="ReconnectionWait",L[L.ReconnectionRunning=2]="ReconnectionRunning",L[L.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",L[L.ConnectionGain=4]="ConnectionGain"})(U||(e.PersistentConnectionEventType=U={}));class z{constructor(M,N){this.reconnectionToken=M,this.millisSinceLastIncomingData=N,this.type=0}}e.$8k=z;class x{constructor(M,N,T,F){this.reconnectionToken=M,this.millisSinceLastIncomingData=N,this.durationSeconds=T,this.c=F,this.type=1}skipWait(){this.c.cancel()}}e.$9k=x;class Z{constructor(M,N,T){this.reconnectionToken=M,this.millisSinceLastIncomingData=N,this.attempt=T,this.type=2}}e.$0k=Z;class ae{constructor(M,N,T){this.reconnectionToken=M,this.millisSinceLastIncomingData=N,this.attempt=T,this.type=4}}e.$$k=ae;class se{constructor(M,N,T,F){this.reconnectionToken=M,this.millisSinceLastIncomingData=N,this.attempt=T,this.handled=F,this.type=3}}e.$_k=se;class ce extends P.$Sc{static triggerPermanentFailure(M,N,T){this._permanentFailure=!0,this.f=M,this.g=N,this.h=T,this.j.forEach(F=>F.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(M=>M.y())}static debugPauseSocketWriting(){this.j.forEach(M=>M.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||ce._permanentFailure}constructor(M,N,T,F,B){super(),this.t=M,this.u=N,this.reconnectionToken=T,this.protocol=F,this.w=B,this.m=this.B(new C.$Od),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new ae(this.reconnectionToken,0,0)),this.B(F.onSocketClose(V=>{const oe=H(this.t,this.reconnectionToken,!0);V?V.type===0?(this.u.logService.info(`${oe} received socket close event (hadError: ${V.hadError}).`),V.error&&this.u.logService.error(V.error)):(this.u.logService.info(`${oe} received socket close event (wasClean: ${V.wasClean}, code: ${V.code}, reason: ${V.reason}).`),V.event&&this.u.logService.error(V.event)):this.u.logService.info(`${oe} received socket close event.`),this.y()})),this.B(F.onSocketTimeout(V=>{const oe=H(this.t,this.reconnectionToken,!0);this.u.logService.info(`${oe} received socket timeout event (unacknowledgedMsgCount: ${V.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${V.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${V.timeSinceLastReceivedSomeData}).`),this.y()})),ce.j.push(this),this.B((0,P.$Qc)(()=>{const V=ce.j.indexOf(this);V>=0&&ce.j.splice(V,1)})),this.n&&this.D(ce.f,ce.g,ce.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const M=H(this.t,this.reconnectionToken,!0);this.u.logService.info(`${M} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const N=[0,5,5,10,10,10,10,10,30];let T=-1;do{T++;const F=T<N.length?N[T]:N[N.length-1];try{if(F>0){const V=j(F);this.m.fire(new x(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F,V)),this.u.logService.info(`${M} waiting for ${F} seconds before reconnecting...`);try{await V}catch{}}if(this.n){this.u.logService.error(`${M} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new Z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),T+1)),this.u.logService.info(`${M} resolving connection...`);const B=await p(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${M} connecting to ${B.connectTo}...`),await this.G(B,$(v)),this.u.logService.info(`${M} reconnected!`),this.m.fire(new ae(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),T+1));break}catch(B){if(B.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${M} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(B),this.C(this.protocol.getMillisSinceLastIncomingData(),T+1,!1);break}if(T>360){this.u.logService.error(`${M} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(B),this.C(this.protocol.getMillisSinceLastIncomingData(),T+1,!1);break}if(y.$Tk.isTemporarilyNotAvailable(B)){this.u.logService.info(`${M} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(B);continue}if((B.code==="ETIMEDOUT"||B.code==="ENETUNREACH"||B.code==="ECONNREFUSED"||B.code==="ECONNRESET")&&B.syscall==="connect"){this.u.logService.info(`${M} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(B);continue}if((0,R.$4)(B)){this.u.logService.info(`${M} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(B);continue}if(B instanceof y.$Tk){this.u.logService.error(`${M} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(B),this.C(this.protocol.getMillisSinceLastIncomingData(),T+1,y.$Tk.isHandled(B));break}this.u.logService.error(`${M} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(B),this.C(this.protocol.getMillisSinceLastIncomingData(),T+1,!1);break}}while(!this.n&&!this.s)}C(M,N,T){this.w?ce.triggerPermanentFailure(M,N,T):this.D(M,N,T)}D(M,N,T){this.m.fire(new se(this.reconnectionToken,M,N,T)),Q(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$al=ce;class Y extends ce{constructor(M,N,T,F,B){super(1,M,F,B,!0),this.client=this.B(new b.$Ch(B,{remoteAuthority:N,clientId:T},M.ipcLogger))}async G(M,N){await t(M,N)}}e.$bl=Y;class K extends ce{constructor(M,N,T,F,B){super(2,M,T,F,!1),this.H=N,this.debugPort=B}async G(M,N){await n(M,this.H,N)}}e.$cl=K;function Q(L){try{L.acceptDisconnect();const M=L.getSocket();L.dispose(),M.dispose()}catch(M){(0,R.$1)(M)}}function q(L){if(L&&L.type==="error"){const M=new Error(`Connection error: ${L.reason}`);return M.code="VSCODE_CONNECTION_ERROR",M}return null}function W(L,M){for(;L.length<M;)L+=" ";return L}function G(L,M){return`[remote-connection][${W(w(L),13)}][${M.substr(0,5)}\u2026]`}function H(L,M,N){return`${G(L,M)}[${N?"reconnect":"initial"}]`}function X(L,M){return`${H(M,L.reconnectionToken,!!L.reconnectionProtocol)}[${L.connectTo}]`}function re(L){return`${Date.now()-L} ms`}}),define(ie[242],ne([0,1,2,5]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2k=e.$1k=void 0,e.$1k=(0,A.$Qh)("remoteSocketFactoryService");class s{constructor(){this.a={}}register(C,P){return this.a[C]??=[],this.a[C].push(P),(0,S.$Qc)(()=>{const h=this.a[C]?.indexOf(P);typeof h=="number"&&h>=0&&this.a[C]?.splice(h,1)})}b(C){return(this.a[C.type]||[]).find(h=>h.supports(C))}connect(C,P,h,c){const g=this.b(C);if(!g)throw new Error(`No socket factory found for ${C}`);return g.connect(C,P,h,c)}}e.$2k=s}),define(ie[243],ne([0,1,28,47,21,113]),function(J,e,S,A,s,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t7b=void 0;let C;async function P(f=!1){return(C===void 0||f)&&(C=h()),C}e.$t7b=P;async function h(){const f=c();if(f===void 0)return!1;if(f>=22e3){const v=b();if(v)return new Promise(m=>{A.execFile(v,["--status"],w=>m(!w))})}else{const v=y();if(v)try{if((await s.Promises.stat(v)).isFile())return!0}catch{}}return!1}function c(){const f=/(\d+)\.(\d+)\.(\d+)/g.exec(S.release());if(f)return parseInt(f[3])}function g(f){const v=process.env.SystemRoot;if(v){const m=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return R.join(v,m?"Sysnative":"System32",f)}}function b(){return g("wsl.exe")}function y(){return g("lxss\\LxssManager.dll")}}),define(ie[50],ne([0,1,17,14,2,183,57,5,6,43]),function(J,e,S,A,s,R,C,P,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4o=e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=void 0,e.$Wo=(0,P.$Qh)("requestService");class g{constructor(l){this.b=l}toJSON(){if(!this.a){const l=Object.create(null);for(const i in this.b)i.toLowerCase()==="authorization"||i.toLowerCase()==="proxy-authorization"?l[i]="*****":l[i]=this.b[i];this.a=l}return this.a}}class b extends s.$Sc{constructor(l){super(),this.b=0,this.a=l.createLogger("network",{name:(0,R.localize)(0,null),when:h.$pj.isEqualTo((0,h.$nj)(h.LogLevel.Trace)).serialize()})}async c(l,i,a){const r=`${l} #${++this.b}: ${i.url}`;this.a.trace(`${r} - begin`,i.type,new g(i.headers??{}));try{const t=await a();return this.a.trace(`${r} - end`,i.type,t.res.statusCode,t.res.headers),t}catch(t){throw this.a.error(`${r} - error`,i.type,(0,A.$0)(t)),t}}}e.$Xo=b;function y(E){return E.res.statusCode&&E.res.statusCode>=200&&E.res.statusCode<300||E.res.statusCode===1223}e.$Yo=y;function f(E){return E.res.statusCode===204}e.$Zo=f;async function v(E){return f(E)?null:(await(0,S.$oe)(E.stream)).toString()}e.$1o=v;async function m(E){if(!y(E))throw new Error("Server returned "+E.res.statusCode);return v(E)}e.$2o=m;async function w(E){if(!y(E))throw new Error("Server returned "+E.res.statusCode);if(f(E))return null;const i=(await(0,S.$oe)(E.stream)).toString();try{return JSON.parse(i)}catch(a){throw a.message+=`:
`+i,a}}e.$3o=w;function $(E){u(E)}e.$4o=$;let d;function u(E){const l=c.$kn.as(C.$pn.Configuration),i=d;d={id:"http",order:15,title:(0,R.localize)(1,null),type:"object",scope:E,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,R.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,R.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,R.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,R.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,R.localize)(6,null),(0,R.localize)(7,null),(0,R.localize)(8,null),(0,R.localize)(9,null)],default:"override",description:(0,R.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,R.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,R.localize)(12,null),restricted:!0}}},l.updateConfigurations({add:[d],remove:i?[i]:[]})}u(1)}),define(ie[244],ne([0,1,17,22]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=e.$Zq=void 0;class s{constructor(P){this.a=P}listen(P,h){throw new Error("Invalid listen")}call(P,h,c,g=A.CancellationToken.None){switch(h){case"request":return this.a.request(c[0],g).then(async({res:b,stream:y})=>{const f=await(0,S.$oe)(y);return[{statusCode:b.statusCode,headers:b.headers},f]});case"resolveProxy":return this.a.resolveProxy(c[0])}throw new Error("Invalid call")}}e.$Zq=s;class R{constructor(P){this.a=P}async request(P,h){const[c,g]=await this.a.call("request",[P],h);return{res:c,stream:(0,S.$qe)(g)}}async resolveProxy(P){return this.a.call("resolveProxy",[P])}}e.$1q=R}),define(ie[245],ne([0,1,246,12]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=void 0;function s(C,P){return C.protocol==="http:"?P.HTTP_PROXY||P.http_proxy||null:C.protocol==="https:"&&(P.HTTPS_PROXY||P.https_proxy||P.HTTP_PROXY||P.http_proxy)||null}async function R(C,P,h={}){const c=(0,S.parse)(C),g=h.proxyUrl||s(c,P);if(!g)return null;const b=(0,S.parse)(g);if(!/^https?:$/.test(b.protocol||""))return null;const y={host:b.hostname||"",port:(b.port?+b.port:0)||(b.protocol==="https"?443:80),auth:b.auth,rejectUnauthorized:(0,A.$Ff)(h.strictSSL)?h.strictSSL:!0};return c.protocol==="http:"?new(await new Promise((f,v)=>{J(["http-proxy-agent"],f,v)})).HttpProxyAgent(g,y):new(await new Promise((f,v)=>{J(["https-proxy-agent"],f,v)})).HttpsProxyAgent(g,y)}e.$2q=R}),define(ie[247],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O7b=e.$N7b=e.$M7b=void 0,e.$M7b={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$N7b={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$O7b={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(ie[94],ne([0,1,47,9,184,22,49,14,4,32,108,62,8,140]),function(J,e,S,A,s,R,C,P,h,c,g,b,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ul=void 0;let v;async function m($,d,u,E){return u["force-disable-user-env"]?(d.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):h.$j?(d.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,b.$Ol)(E)&&!u["force-user-env"]?(d.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,b.$Ol)(E)?d.trace("resolveShellEnv(): running (--force-user-env)"):d.trace("resolveShellEnv(): running (macOS/Linux)"),v||(v=y.Promises.withAsyncBody(async(l,i)=>{const a=new R.$Yd;let r=1e4;const t=$.getValue("application.shellEnvironmentResolutionTimeout");typeof t=="number"&&(r=(0,f.$Pl)(t,1,120)*1e3);const n=setTimeout(()=>{a.dispose(!0),i(new Error((0,s.localize)(0,null)))},r);try{l(await w(d,a.token))}catch(o){!(0,P.$4)(o)&&!a.token.isCancellationRequested?i(new Error((0,s.localize)(1,null,(0,C.$Bi)(o)))):l({})}finally{clearTimeout(n),a.dispose()}})),v)}e.$Ul=m;async function w($,d){const u=process.env.ELECTRON_RUN_AS_NODE;$.trace("getUnixShellEnvironment#runAsNode",u);const E=process.env.ELECTRON_NO_ATTACH_CONSOLE;$.trace("getUnixShellEnvironment#noAttach",E);const l=(0,c.$fg)().replace(/-/g,"").substr(0,12),i=new RegExp(l+"({.*})"+l),a={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};$.trace("getUnixShellEnvironment#env",a);const r=await(0,g.$El)(h.OS,a);return $.trace("getUnixShellEnvironment#shell",r),new Promise((t,n)=>{if(d.isCancellationRequested)return n(new P.$5);const o=(0,A.$nc)(r);let p,O;const D=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(o)?(p=`& '${process.execPath}' ${D} -p '''${l}'' + JSON.stringify(process.env) + ''${l}'''`,O=["-Login","-Command"]):o==="nu"?(p=`^'${process.execPath}' ${D} -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,O=["-i","-l","-c"]):(p=`'${process.execPath}' ${D} -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,o==="tcsh"||o==="csh"?O=["-ic"]:O=["-i","-l","-c"]),$.trace("getUnixShellEnvironment#spawn",JSON.stringify(O),p);const k=(0,S.spawn)(r,[...O,p],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});d.onCancellationRequested(()=>(k.kill(),n(new P.$5))),k.on("error",U=>{$.error("getUnixShellEnvironment#errorChildProcess",(0,C.$Bi)(U)),n(U)});const I=[];k.stdout.on("data",U=>I.push(U));const j=[];k.stderr.on("data",U=>j.push(U)),k.on("close",(U,z)=>{const x=Buffer.concat(I).toString("utf8");$.trace("getUnixShellEnvironment#raw",x);const Z=Buffer.concat(j).toString("utf8");if(Z.trim()&&$.trace("getUnixShellEnvironment#stderr",Z),U||z)return n(new Error((0,s.localize)(2,null,U,z)));const ae=i.exec(x),se=ae?ae[1]:"{}";try{const ce=JSON.parse(se);u?ce.ELECTRON_RUN_AS_NODE=u:delete ce.ELECTRON_RUN_AS_NODE,E?ce.ELECTRON_NO_ATTACH_CONSOLE=E:delete ce.ELECTRON_NO_ATTACH_CONSOLE,delete ce.VSCODE_RESOLVING_ENVIRONMENT,delete ce.XDG_RUNTIME_DIR,$.trace("getUnixShellEnvironment#result",ce),t(ce)}catch(ce){$.error("getUnixShellEnvironment#errorCaught",(0,C.$Bi)(ce)),n(ce)}})})}}),define(ie[248],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I3b=void 0;class S{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(s){try{const R=await this.c();if(R){const C=String(S.a++);return this.b.set(C,R),{id:C,data:R.createNewMessage(s)}}}catch{}return{id:"",data:s}}async validate(s,R){if(!s.id)return!0;const C=this.b.get(s.id);if(!C)return!1;this.b.delete(s.id);try{return C.validate(R)==="ok"}catch{return!1}finally{C.dispose?.()}}async sign(s){try{return await this.d(s)}catch{}return s}}e.$I3b=S}),define(ie[95],ne([0,1,5]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4k=e.$3k=void 0,e.$3k="signService",e.$4k=(0,S.$Qh)(e.$3k)}),define(ie[249],ne([0,1,248]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C8b=void 0;class A extends S.$I3b{c(){return this.h().then(R=>new R.validator)}d(R){return this.h().then(C=>new C.signer().sign(R))}h(){return new Promise((R,C)=>J(["vsda"],R,C))}}e.$C8b=A}),define(ie[34],ne([0,1,5]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FN=e.$EN=void 0,e.$EN=(0,S.$Qh)("stateReadService"),e.$FN=(0,S.$Qh)("stateService")}),define(ie[121],ne([0,1,8,17,2,12,36,16,6]),function(J,e,S,A,s,R,C,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IN=e.$HN=e.$GN=e.SaveStrategy=void 0;var c;(function(f){f[f.IMMEDIATE=0]="IMMEDIATE",f[f.DELAYED=1]="DELAYED"})(c||(e.SaveStrategy=c={}));class g extends s.$Sc{constructor(v,m,w,$){super(),this.h=v,this.j=w,this.m=$,this.a=Object.create(null),this.b="",this.f=void 0,this.g=void 0,this.c=m===0?void 0:this.B(new S.$Sg(100))}init(){return this.f||(this.f=this.n()),this.f}async n(){try{this.b=(await this.m.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(v){v.fileOperationResult!==1&&this.j.error(v)}}getItem(v,m){const w=this.a[v];return(0,R.$If)(w)?m:w}setItem(v,m){this.setItems([{key:v,data:m}])}setItems(v){let m=!1;for(const{key:w,data:$}of v)this.a[w]!==$&&((0,R.$If)($)?(0,R.$Gf)(this.a[w])||(this.a[w]=void 0,m=!0):(this.a[w]=$,m=!0));m&&this.r()}removeItem(v){(0,R.$Gf)(this.a[v])||(this.a[v]=void 0,this.r())}async r(){if(!this.g)return this.c?this.c.trigger(()=>this.s()):this.s()}async s(){if(!this.f)return;await this.f;const v=JSON.stringify(this.a,null,4);if(v!==this.b)try{await this.m.writeFile(this.h,A.$ce.fromString(v),{atomic:{postfix:".vsctmp"}}),this.b=v}catch(m){this.j.error(m)}}async close(){return this.g||(this.g=this.c?this.c.trigger(()=>this.s(),0):this.s()),this.g}}e.$GN=g;let b=class extends s.$Sc{constructor(v,m,w,$){super(),this.a=this.B(new g(m.stateResource,v,w,$))}async init(){await this.a.init()}getItem(v,m){return this.a.getItem(v,m)}};e.$HN=b,e.$HN=b=Ee([te(1,C.$Xh),te(2,h.$$i),te(3,P.$_j)],b);class y extends b{setItem(v,m){this.a.setItem(v,m)}setItems(v){this.a.setItems(v)}removeItem(v){this.a.removeItem(v)}close(){return this.a.close()}}e.$IN=y}),define(ie[122],ne([0,1,4,35,32]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mo=e.$lo=void 0;function R(h){if(S.$u===2&&/^penguin(\.|$)/i.test(h))return"chromebook"}function C(h,c,g,b,y,f,v,m,w){const $=Object.create(null);$["common.machineId"]=f,$["common.sqmId"]=v,$.sessionID=(0,s.$fg)()+Date.now(),$.commitHash=b,$.version=y,$["common.platformVersion"]=(h||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),$["common.platform"]=(0,S.$i)(S.$u),$["common.nodePlatform"]=A.$dc,$["common.nodeArch"]=g,$["common.product"]=w||"desktop",m&&($["common.msftInternal"]=m);let d=0;const u=Date.now();Object.defineProperties($,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-u,enumerable:!0},"common.sequence":{get:()=>d++,enumerable:!0}}),S.$m&&($["common.snap"]="true");const E=R(c);return E&&($["common.platformDetail"]=E),$}e.$lo=C;function P(h){const c=A.env.USERDNSDOMAIN;if(!c)return!1;const g=c.toLowerCase();return h.some(b=>g===b)}e.$mo=P}),define(ie[26],ne([0,1,5]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$nl=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=e.$hl=e.$gl=e.$fl=e.$el=e.$dl=void 0,e.$dl=(0,S.$Qh)("telemetryService"),e.$el=(0,S.$Qh)("customEndpointTelemetryService"),e.$fl="telemetry.currentSessionDate",e.$gl="telemetry.firstSessionDate",e.$hl="telemetry.lastSessionDate",e.$il="telemetry.machineId",e.$jl="telemetry.sqmId",e.$kl="telemetry",e.$ll="telemetry.telemetryLevel",e.$ml="telemetry.enableCrashReporter",e.$nl="telemetry.enableTelemetry";var A;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(A||(e.TelemetryLevel=A={}));var s;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(s||(e.TelemetryConfiguration=s={}))}),define(ie[250],ne([0,1,28,8,44,13,9,4,7,87,21,107,91,16,25,26]),function(J,e,S,A,s,R,C,P,h,c,g,b,y,f,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kr=e.$Jr=e.$Ir=e.$Hr=void 0;const w=new Map;async function $(i,a){const r=`${i}::${a.join(":")}`,t=w.get(r);if(t)return t;const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],o=new Map,p=new Map,O=2e4;function D(I,j,U,z){const x=j.substring(I.length+1);return A.Promises.withAsyncBody(async Z=>{let ae;try{ae=await g.Promises.readdir(j,{withFileTypes:!0})}catch{Z();return}if(z.count>=O){z.count+=ae.length,z.maxReached=!0,Z();return}let se=ae.length;if(se===0){Z();return}let ce=ae;z.count+ae.length>O&&(z.maxReached=!0,se=O-z.count,ce=ae.slice(0,se)),z.count+=ae.length;for(const Y of ce)if(Y.isDirectory()){if(U.includes(Y.name)||await D(I,(0,C.$jc)(j,Y.name),U,z),--se===0){Z();return}}else{const K=Y.name.lastIndexOf(".");if(K>=0){const Q=Y.name.substring(K+1);Q&&o.set(Q,(o.get(Q)??0)+1)}for(const Q of n)Q.relativePathPattern?.test(x)!==!1&&Q.filePattern.test(Y.name)&&p.set(Q.tag,(p.get(Q.tag)??0)+1);if(--se===0){Z();return}}})}const k=A.Promises.withAsyncBody(async I=>{const j={count:0,maxReached:!1};await D(i,i,a,j);const U=await E(i);I({configFiles:d(p),fileTypes:d(o),fileCount:j.count,maxFilesReached:j.maxReached,launchConfigFiles:U})});return w.set(r,k),k}e.$Hr=$;function d(i){return Array.from(i.entries(),([a,r])=>({name:a,count:r})).sort((a,r)=>r.count-a.count)}function u(){const i={os:`${S.type()} ${S.arch()} ${S.release()}`,memory:`${(S.totalmem()/f.$Hk.GB).toFixed(2)}GB (${(S.freemem()/f.$Hk.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(c.$Sm.value()*100)}%`},a=S.cpus();return a&&a.length>0&&(i.cpus=`${a[0].model} (${a.length} x ${a[0].speed})`),i}e.$Ir=u;async function E(i){try{const a=new Map,r=(0,C.$jc)(i,".vscode","launch.json"),t=await g.Promises.readFile(r),n=[],o=(0,s.$Xm)(t.toString(),n);if(n.length)return console.log(`Unable to parse ${r}`),[];if((0,s.$7m)(o)==="object"&&o.configurations)for(const p of o.configurations){const O=p.type;O&&(a.has(O)?a.set(O,a.get(O)+1):a.set(O,1))}return d(a)}catch{return[]}}e.$Jr=E;let l=class{constructor(a,r){this.c=a,this.d=r}f(a){const r=[];return r.push(`OS Version:       ${a.os}`),r.push(`CPUs:             ${a.cpus}`),r.push(`Memory (System):  ${a.memory}`),r.push(`VM:               ${a.vmHint}`),r.join(`
`)}g(a){const r=[];r.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),r.push(`OS Version:       ${S.type()} ${S.arch()} ${S.release()}`);const t=S.cpus();return t&&t.length>0&&r.push(`CPUs:             ${t[0].model} (${t.length} x ${t[0].speed})`),r.push(`Memory (System):  ${(S.totalmem()/f.$Hk.GB).toFixed(2)}GB (${(S.freemem()/f.$Hk.GB).toFixed(2)}GB free)`),P.$j||r.push(`Load (avg):       ${S.loadavg().map(n=>Math.round(n)).join(", ")}`),r.push(`VM:               ${Math.round(c.$Sm.value()*100)}%`),r.push(`Screen Reader:    ${a.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${a.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.j(a.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(a,r){return Promise.all([(0,b.$Gr)(a.mainPID),this.k(a)]).then(async t=>{let[n,o]=t,p=this.m(a,n);return r.forEach(O=>{if((0,y.$sm)(O))p+=`
${O.errorMessage}`,o+=`
${O.errorMessage}`;else if(p+=`

Remote: ${O.hostName}`,O.processes&&(p+=`
${this.m(a,O.processes)}`),O.workspaceMetadata){o+=`
|  Remote: ${O.hostName}`;for(const D of Object.keys(O.workspaceMetadata)){const k=O.workspaceMetadata[D];let I=`${k.fileCount} files`;k.maxFilesReached&&(I=`more than ${I}`),o+=`|    Folder (${D}): ${I}`,o+=this.h(k)}}}),{processInfo:p,workspaceInfo:o}})}async getSystemInfo(a,r){const{memory:t,vmHint:n,os:o,cpus:p}=u(),O={os:o,memory:t,cpus:p,vmHint:n,processArgs:`${a.mainArguments.join(" ")}`,gpuStatus:a.gpuFeatureStatus,screenReader:`${a.screenReader?"yes":"no"}`,remoteData:r};return P.$j||(O.load=`${S.loadavg().map(D=>Math.round(D)).join(", ")}`),P.$l&&(O.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(O)}async getDiagnostics(a,r){const t=[];return(0,b.$Gr)(a.mainPID).then(async n=>(t.push(""),t.push(this.g(a)),t.push(""),t.push(this.m(a,n)),a.windows.some(o=>o.folderURIs&&o.folderURIs.length>0&&!o.remoteAuthority)&&(t.push(""),t.push("Workspace Stats: "),t.push(await this.k(a))),r.forEach(o=>{if((0,y.$sm)(o))t.push(`
${o.errorMessage}`);else if(t.push(`

`),t.push(`Remote:           ${o.hostName}`),t.push(this.f(o.machineInfo)),o.processes&&t.push(this.m(a,o.processes)),o.workspaceMetadata)for(const p of Object.keys(o.workspaceMetadata)){const O=o.workspaceMetadata[p];let D=`${O.fileCount} files`;O.maxFilesReached&&(D=`more than ${D}`),t.push(`Folder (${p}): ${D}`),t.push(this.h(O))}}),t.push(""),t.push(""),t.join(`
`)))}h(a){const r=[];let n=0;const o=(k,I)=>{const j=` ${k}(${I})`;n+j.length>60?(r.push(p),p="|                 ",n=p.length):n+=j.length,p+=j};let p="|      File types:";const O=10,D=a.fileTypes.length>O?O:a.fileTypes.length;for(let k=0;k<D;k++){const I=a.fileTypes[k];o(I.name,I.count)}if(r.push(p),a.configFiles.length>=0&&(p="|      Conf files:",n=0,a.configFiles.forEach(k=>{o(k.name,k.count)}),r.push(p)),a.launchConfigFiles.length>0){let k="|      Launch Configs:";a.launchConfigFiles.forEach(I=>{const j=I.count>1?` ${I.name}(${I.count})`:` ${I.name}`;k+=j}),r.push(k)}return r.join(`
`)}j(a){const r=Math.max(...Object.keys(a).map(t=>t.length));return Object.keys(a).map(t=>`${t}:  ${" ".repeat(r-t.length)}  ${a[t]}`).join(`
                  `)}k(a){const r=[],t=[];return a.windows.forEach(n=>{n.folderURIs.length===0||n.remoteAuthority||(r.push(`|  Window (${n.title})`),n.folderURIs.forEach(o=>{const p=h.URI.revive(o);if(p.scheme===R.Schemas.file){const O=p.fsPath;t.push($(O,["node_modules",".git"]).then(D=>{let k=`${D.fileCount} files`;D.maxFilesReached&&(k=`more than ${k}`),r.push(`|    Folder (${(0,C.$nc)(O)}): ${k}`),r.push(this.h(D))}).catch(D=>{r.push(`|      Error: Unable to collect workspace stats for folder ${O} (${D.toString()})`)}))}else r.push(`|    Folder (${p.toString()}): Workspace stats not available.`)}))}),Promise.all(t).then(n=>r.join(`
`)).catch(n=>`Unable to collect workspace stats: ${n}`)}m(a,r){const t=new Map;a.windows.forEach(o=>t.set(o.pid,`window [${o.id}] (${o.title})`)),a.pidToNames.forEach(({pid:o,name:p})=>t.set(o,p));const n=[];return n.push("CPU %	Mem MB	   PID	Process"),r&&this.n(a.mainPID,t,n,r,0),n.join(`
`)}n(a,r,t,n,o){const p=o===0;let O;p?O=n.pid===a?`${this.d.applicationName} main`:"remote agent":r.has(n.pid)?O=r.get(n.pid):O=`${"  ".repeat(o)} ${n.name}`;const D=process.platform==="win32"?n.mem:S.totalmem()*(n.mem/100);t.push(`${n.load.toFixed(0).padStart(5," ")}	${(D/f.$Hk.MB).toFixed(0).padStart(6," ")}	${n.pid.toFixed(0).padStart(6," ")}	${O}`),Array.isArray(n.children)&&n.children.forEach(k=>this.n(a,r,t,k,o+1))}async getWorkspaceFileExtensions(a){const r=new Set;for(const{uri:t}of a.folders){const n=h.URI.revive(t);if(n.scheme!==R.Schemas.file)continue;const o=n.fsPath;try{(await $(o,["node_modules",".git"])).fileTypes.forEach(O=>r.add(O.name))}catch{}}return{extensions:[...r]}}async reportWorkspaceStats(a){for(const{uri:r}of a.folders){const t=h.URI.revive(r);if(t.scheme!==R.Schemas.file)continue;const n=t.fsPath;try{const o=await $(n,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":a.telemetryId,rendererSessionId:a.rendererSessionId}),o.fileTypes.forEach(p=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:a.rendererSessionId,type:p.name,count:p.count})}),o.launchConfigFiles.forEach(p=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:a.rendererSessionId,type:p.name,count:p.count})}),o.configFiles.forEach(p=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:a.rendererSessionId,type:p.name,count:p.count})})}catch{}}}};e.$Kr=l,e.$Kr=l=Ee([te(0,m.$dl),te(1,v.$qj)],l)}),define(ie[251],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S7b=e.$R7b=void 0;class S{constructor(R){this.b=R}listen(R,C){throw new Error(`Event not found: ${C}`)}call(R,C,{eventName:P,data:h}){return this.b.forEach(c=>c.log(P,h)),Promise.resolve(null)}}e.$R7b=S;class A{constructor(R){this.b=R}log(R,C){return this.b.call("log",{eventName:R,data:C}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$S7b=A}),define(ie[51],ne([0,1,37,12,3,18,58,122,26]),function(J,e,S,A,s,R,C,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=void 0;class c{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$no=c;class g{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$oo=g,e.$po=new g;class b{async publicLog(n,o,p){}async publicLogError(n,o,p){}}e.$qo=b,e.$ro="telemetry",e.$so="extensionTelemetryLog",e.$to={log:()=>null,flush:()=>Promise.resolve(null)};function y(t,n){return s.Event.debounce(n.onDidChangeConfiguration,(p,O)=>{const D=p?new Set([...p.affectedKeys,...O.affectedKeys]):O.affectedKeys;return{...O,affectedKeys:D}},1e3,!0)(p=>{p.source!==7&&t.publicLog2("updateConfiguration",{configurationSource:(0,R.$ni)(p.source),configurationKeys:Array.from(p.affectedKeys)})})}e.$uo=y;function f(t,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!t.enableTelemetry)}e.$vo=f;function v(t,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}e.$wo=v;function m(t){const n=t.getValue(h.$ll),o=t.getValue(h.$ml);if(t.getValue(h.$nl)===!1||o===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$xo=m;function w(t){const n={},o={},p={};u(t,p);for(let O in p){O=O.length>150?O.substr(O.length-149):O;const D=p[O];typeof D=="number"?o[O]=D:typeof D=="boolean"?o[O]=D?1:0:typeof D=="string"?(D.length>8192&&console.warn(`Telemetry property: ${O} has been trimmed to 8192, the original length is ${D.length}`),n[O]=D.substring(0,8191)):typeof D<"u"&&D!==null&&(n[O]=D)}return{properties:n,measurements:o}}e.$yo=w;const $=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function d(t){if(!t)return"none";const n=(0,C.$Wk)(t);return $.has(n)?n:"other"}e.$zo=d;function u(t,n,o=0,p){if(t)for(const O of Object.getOwnPropertyNames(t)){const D=t[O],k=p?p+O:O;Array.isArray(D)?n[k]=(0,S.$an)(D):D instanceof Date?n[k]=D.toISOString():(0,A.$Bf)(D)?o<2?u(D,n,o+1,k+"."):n[k]=(0,S.$an)(D):n[k]=D}}function E(t,n){const o=t.msftInternalDomains||[],p=n.getValue("telemetry.internalTesting");return(0,P.$mo)(o)||p}e.$Ao=E;function l(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.$Bo=l;function i(t,n){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let o=t;const p=[];for(const I of n)for(;;){const j=I.exec(t);if(!j)break;p.push([j.index,I.lastIndex])}const O=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,D=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let k=0;for(o="";;){const I=D.exec(t);if(!I)break;const j=p.some(([U,z])=>I.index<z&&U<D.lastIndex);!O.test(I[0])&&!j&&(o+=t.substring(k,I.index)+"<REDACTED: user-file-path>",k=D.lastIndex)}return k<t.length&&(o+=t.substr(k)),o}function a(t){if(!t)return t;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const o of n)if(o.regex.test(t))return`<REDACTED: ${o.label}>`;return t}function r(t,n){return(0,S.$0m)(t,o=>{if(o instanceof c||Object.hasOwnProperty.call(o,"isTrustedTelemetryValue"))return o.value;if(typeof o=="string"){let p=o.replaceAll("%20"," ");p=i(p,n);for(const O of n)p=p.replace(O,"");return p=a(p),p}})}e.$Co=r}),define(ie[123],ne([0,1,27,117,120,4,7,14,35,51]),function(J,e,S,A,s,R,C,P,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=void 0;function g(r,t){return r.uuid&&t.uuid?r.uuid===t.uuid:r.id===t.id?!0:(0,S.$Xe)(r.id,t.id)===0}e.$Do=g;const b=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class y{static create(t){const n=t.manifest?t.manifest.version:t.version,o=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new y(t.identifier,n,o)}static parse(t){const n=b.exec(t);return n&&n[1]&&n[2]?new y({id:n[1]},n[2],n[4]||void 0):null}constructor(t,n,o="undefined"){this.version=n,this.targetPlatform=o,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof y?g(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.$Eo=y;const f=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(r){const t=f.exec(r);return t&&t[1]?[w(t[1]),t[2]]:[w(r),void 0]}e.$Fo=v;function m(r,t){return`${r}.${t}`}e.$Go=m;function w(r){return r.toLowerCase()}e.$Ho=w;function $(r,t){return w(m(r??s.$3l,t))}e.$Io=$;function d(r,t){const n=[],o=p=>{for(const O of n)if(O.some(D=>g(t(D),t(p))))return O;return null};for(const p of r){const O=o(p);O?O.push(p):n.push([p])}return n}e.$Jo=d;function u(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.$Ko=u;function E(r){return{id:new c.$no(r.identifier.id),name:new c.$no(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.$Lo=E,e.$Mo=new s.$7l("pprice.better-merge");function l(r,t){const n=[],o=t.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const p=o.shift();if(p&&n.every(O=>!g(O.identifier,{id:p}))){const O=r.filter(D=>g(D.identifier,{id:p}));O.length===1&&(n.push(O[0]),o.push(...O[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.$No=l;async function i(r,t){if(!R.$l)return!1;let n;try{n=(await r.readFile(C.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await r.readFile(C.URI.file("/usr/lib/os-release"))).value.toString()}catch(p){t.debug("Error while getting the os-release file.",(0,P.$0)(p))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function a(r,t){const n=await i(r,t),o=(0,A.$0n)(n?"alpine":R.$u,h.$ec);return t.debug("ComputeTargetPlatform:",o),o}e.$Oo=a}),define(ie[252],ne([0,1,206,51]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ep=void 0;async function s(R,C,P,h,c,g,b){const y={"X-Market-Client-Id":`VSCode ${R}`,"User-Agent":`VSCode ${R} (${C.nameShort})`};if((0,A.$vo)(C,P)&&(0,A.$xo)(h)===3){const f=await(0,S.$dp)(P,c,g);y["X-Market-User-Id"]=f,y["VSCode-SessionId"]=b.machineId||f}return y}e.$ep=s}),define(ie[253],ne([0,1,2,37,4,27,185,18,57,78,25,43,26,51]),function(J,e,S,A,s,R,C,P,h,c,g,b,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5q=void 0;let v=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor($,d,u){this.k=d,this.l=u,this.d={},this.i=new S.$Rc,this.j=[],this.b=$.appenders,this.c=$.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=$.piiPaths||[],this.g=3,this.h=!!$.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const E of this.f)this.j.push(new RegExp((0,R.$Ge)(E),"gi")),E.indexOf("\\")>=0&&this.j.push(new RegExp((0,R.$Ge)(E.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(E=>{(E.affectsConfiguration(y.$ll)||E.affectsConfiguration(y.$nl)||E.affectsConfiguration(y.$ml))&&this.m()}))}setExperimentProperty($,d){this.d[$]=d}m(){let $=(0,f.$xo)(this.k);const d=this.l.enabledTelemetryLevels;if(d){this.h=this.sendErrorTelemetry?d.error:!1;const u=d.usage?3:d.error?2:0;$=Math.min($,u)}this.g=$}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n($,d,u){this.g<d||(u=(0,A.$$m)(u,this.d),u=(0,f.$Co)(u,this.j),u=(0,A.$$m)(u,this.c),this.b.forEach(E=>E.log($,u)))}publicLog($,d){this.n($,3,d)}publicLog2($,d){this.publicLog($,d)}publicLogError($,d){this.h&&this.n($,2,d)}publicLogError2($,d){this.publicLogError($,d)}};e.$5q=v,e.$5q=v=Ee([te(1,P.$ki),te(2,g.$qj)],v);function m(){const w=(0,C.localize)(0,null,c.default.nameLong),$=c.default.privacyStatementUrl?(0,C.localize)(2,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,C.localize)(1,null,"https://aka.ms/vscode-telemetry"),d=s.$p?"":(0,C.localize)(3,null),u=(0,C.localize)(4,null),E=(0,C.localize)(5,null),l=(0,C.localize)(6,null),i=(0,C.localize)(7,null),a=`
|       | ${u} | ${E} | ${l} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,C.localize)(8,null);return`
${w} ${$} ${d}

&nbsp;

${i}
${a}

&nbsp;

${r}
`}b.$kn.as(h.$pn.Configuration).registerConfiguration({id:y.$kl,order:1,type:"object",title:(0,C.localize)(9,null),properties:{[y.$ll]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,C.localize)(10,null),(0,C.localize)(11,null),(0,C.localize)(12,null),(0,C.localize)(13,null)],markdownDescription:m(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),b.$kn.as(h.$pn.Configuration).registerConfiguration({id:y.$kl,order:110,type:"object",title:(0,C.localize)(14,null),properties:{[y.$nl]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,C.localize)(16,null,c.default.nameLong,c.default.privacyStatementUrl):(0,C.localize)(15,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,C.localize)(17,null,`\`#${y.$ll}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ie[254],ne([0,1,4,87,26]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i8b=e.$h8b=void 0;async function R(P,h){let c=P.getItem(s.$il);return(typeof c!="string"||S.$k&&c==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(c=await(0,A.$Tm)(h.error.bind(h))),c}e.$h8b=R;async function C(P,h){let c=P.getItem(s.$jl);return typeof c!="string"&&(c=await(0,A.$Um)(h.error.bind(h))),c}e.$i8b=C}),define(ie[255],ne([0,1,26,254]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k8b=e.$j8b=void 0;async function s(C,P){const h=await(0,A.$h8b)(C,P);return C.setItem(S.$il,h),h}e.$j8b=s;async function R(C,P){const h=await(0,A.$i8b)(C,P);return C.setItem(S.$jl,h),h}e.$k8b=R}),define(ie[124],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var S;(function(A){A[A.Replace=1]="Replace",A[A.Append=2]="Append",A[A.Prepend=3]="Prepend"})(S||(e.EnvironmentVariableMutatorType=S={}))}),define(ie[256],ne([0,1,4,124]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ur=void 0;const s=new Map([[A.EnvironmentVariableMutatorType.Append,"APPEND"],[A.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[A.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class R{constructor(g){this.collections=g,this.a=new Map,this.b=new Map,g.forEach((b,y)=>{this.d(b,y);const f=b.map.entries();let v=f.next();for(;!v.done;){const m=v.value[1],w=v.value[0];let $=this.a.get(w);if($||($=[],this.a.set(w,$)),$.length>0&&$[0].type===A.EnvironmentVariableMutatorType.Replace){v=f.next();continue}const d={extensionIdentifier:y,value:m.value,type:m.type,scope:m.scope,variable:m.variable,options:m.options};d.scope||delete d.scope,$.unshift(d),v=f.next()}})}async applyToProcessEnvironment(g,b,y){let f;S.$j&&(f={},Object.keys(g).forEach(v=>f[v.toLowerCase()]=v));for(const[v,m]of this.getVariableMap(b)){const w=S.$j&&f[v.toLowerCase()]||v;for(const $ of m){const d=y?await y($.value):$.value;if($.options?.applyAtProcessCreation??!0)switch($.type){case A.EnvironmentVariableMutatorType.Append:g[w]=(g[w]||"")+d;break;case A.EnvironmentVariableMutatorType.Prepend:g[w]=d+(g[w]||"");break;case A.EnvironmentVariableMutatorType.Replace:g[w]=d;break}if($.options?.applyAtShellIntegration??!1){const u=`VSCODE_ENV_${s.get($.type)}`;g[u]=(g[u]?g[u]+":":"")+v+"="+this.c(d)}}}}c(g){return g.replaceAll(":","\\x3a")}diff(g,b){const y=new Map,f=new Map,v=new Map;if(g.getVariableMap(b).forEach((m,w)=>{const $=this.getVariableMap(b).get(w),d=P(m,$);d&&y.set(w,d)}),this.getVariableMap(b).forEach((m,w)=>{const $=g.getVariableMap(b).get(w),d=P(m,$);d&&v.set(w,d)}),this.getVariableMap(b).forEach((m,w)=>{const $=g.getVariableMap(b).get(w),d=h(m,$);d&&f.set(w,d)}),!(y.size===0&&f.size===0&&v.size===0))return{added:y,changed:f,removed:v}}getVariableMap(g){const b=new Map;for(const y of this.a.values()){const f=y.filter(v=>C(v,g));f.length>0&&b.set(f[0].variable,f)}return b}getDescriptionMap(g){const b=new Map;for(const y of this.b.values()){const f=y.filter(v=>C(v,g,!0));for(const v of f)b.set(v.extensionIdentifier,v.description)}return b}d(g,b){if(!g.descriptionMap)return;const y=g.descriptionMap.entries();let f=y.next();for(;!f.done;){const v=f.value[1],m=f.value[0];let w=this.b.get(m);w||(w=[],this.b.set(m,w));const $={extensionIdentifier:b,scope:v.scope,description:v.description};$.scope||delete $.scope,w.push($),f=y.next()}}}e.$ur=R;function C(c,g,b=!1){return c.scope?!!(c.scope.workspaceFolder&&g?.workspaceFolder&&c.scope.workspaceFolder.index===g.workspaceFolder.index):b?g===c.scope:!0}function P(c,g){if(!g)return c;const b=new Set;g.forEach(f=>b.add(f.extensionIdentifier));const y=[];return c.forEach(f=>{b.has(f.extensionIdentifier)||y.push(f)}),y.length===0?void 0:y}function h(c,g){if(!g)return;const b=new Map;g.forEach(f=>b.set(f.extensionIdentifier,f));const y=[];return c.forEach(f=>{const v=b.get(f.extensionIdentifier);v&&(f.type!==v.type||f.value!==v.value||f.scope?.workspaceFolder?.index!==v.scope?.workspaceFolder?.index)&&y.push(v)}),y.length===0?void 0:y}}),define(ie[257],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tr=e.$sr=e.$rr=e.$qr=e.$pr=e.$or=void 0;function S(h){return[...h.entries()]}e.$or=S;function A(h){return h?[...h.entries()]:[]}e.$pr=A;function s(h){return new Map(h)}e.$qr=s;function R(h){return new Map(h??[])}e.$rr=R;function C(h){return Array.from(h.entries()).map(c=>[c[0],S(c[1].map),A(c[1].descriptionMap)])}e.$sr=C;function P(h){return new Map(h.map(c=>[c[0],{map:s(c[1]),descriptionMap:R(c[2])}]))}e.$tr=P}),define(ie[258],ne([0,1,8,22,3,2,6]),function(J,e,S,A,s,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=void 0;let P=class extends R.$Sc{constructor(c,g){super(),this.h=g,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new s.$Od),this.onCreateRequest=this.g.event,this.b=c===void 0?15e3:c,this.B((0,R.$Qc)(()=>{for(const b of this.f.values())(0,R.$Nc)(b)}))}createRequest(c){return new Promise((g,b)=>{const y=++this.a;this.c.set(y,g),this.g.fire({requestId:y,...c});const f=new A.$Yd;(0,S.$Vg)(this.b,f.token).then(()=>b(`Request ${y} timed out (${this.b}ms)`)),this.f.set(y,[(0,R.$Qc)(()=>f.cancel())])})}acceptReply(c,g){const b=this.c.get(c);b?(this.c.delete(c),(0,R.$Nc)(this.f.get(c)||[]),this.f.delete(c),b(g)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${c}`)}};e.$fr=P,e.$fr=P=Ee([te(1,C.$$i)],P)}),define(ie[125],ne([0,1,5,114,43]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=e.$ar=e.$_q=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$$q=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$0q=void 0,e.$0q=new A.$8i("terminalTabFocusMode",!1,!0);var R;(function(l){l.AutomationProfile="terminal.integrated.automationProfile.",l.DefaultProfile="terminal.integrated.defaultProfile.",l.Profiles="terminal.integrated.profiles."})(R||(e.TerminalSettingPrefix=R={}));var C;(function(l){l.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",l.AutomationProfileLinux="terminal.integrated.automationProfile.linux",l.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",l.AutomationProfileWindows="terminal.integrated.automationProfile.windows",l.ProfilesWindows="terminal.integrated.profiles.windows",l.ProfilesMacOs="terminal.integrated.profiles.osx",l.ProfilesLinux="terminal.integrated.profiles.linux",l.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",l.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",l.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",l.UseWslProfiles="terminal.integrated.useWslProfiles",l.TabsDefaultColor="terminal.integrated.tabs.defaultColor",l.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",l.TabsEnabled="terminal.integrated.tabs.enabled",l.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",l.TabsHideCondition="terminal.integrated.tabs.hideCondition",l.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",l.TabsShowActions="terminal.integrated.tabs.showActions",l.TabsLocation="terminal.integrated.tabs.location",l.TabsFocusMode="terminal.integrated.tabs.focusMode",l.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",l.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",l.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",l.CopyOnSelection="terminal.integrated.copyOnSelection",l.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",l.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",l.FontFamily="terminal.integrated.fontFamily",l.FontSize="terminal.integrated.fontSize",l.LetterSpacing="terminal.integrated.letterSpacing",l.LineHeight="terminal.integrated.lineHeight",l.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",l.TabStopWidth="terminal.integrated.tabStopWidth",l.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",l.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",l.BellDuration="terminal.integrated.bellDuration",l.FontWeight="terminal.integrated.fontWeight",l.FontWeightBold="terminal.integrated.fontWeightBold",l.CursorBlinking="terminal.integrated.cursorBlinking",l.CursorStyle="terminal.integrated.cursorStyle",l.CursorStyleInactive="terminal.integrated.cursorStyleInactive",l.CursorWidth="terminal.integrated.cursorWidth",l.Scrollback="terminal.integrated.scrollback",l.DetectLocale="terminal.integrated.detectLocale",l.DefaultLocation="terminal.integrated.defaultLocation",l.GpuAcceleration="terminal.integrated.gpuAcceleration",l.TerminalTitleSeparator="terminal.integrated.tabs.separator",l.TerminalTitle="terminal.integrated.tabs.title",l.TerminalDescription="terminal.integrated.tabs.description",l.RightClickBehavior="terminal.integrated.rightClickBehavior",l.Cwd="terminal.integrated.cwd",l.ConfirmOnExit="terminal.integrated.confirmOnExit",l.ConfirmOnKill="terminal.integrated.confirmOnKill",l.EnableBell="terminal.integrated.enableBell",l.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",l.AllowChords="terminal.integrated.allowChords",l.AllowMnemonics="terminal.integrated.allowMnemonics",l.TabFocusMode="terminal.integrated.tabFocusMode",l.EnvMacOs="terminal.integrated.env.osx",l.EnvLinux="terminal.integrated.env.linux",l.EnvWindows="terminal.integrated.env.windows",l.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",l.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",l.ShowExitAlert="terminal.integrated.showExitAlert",l.SplitCwd="terminal.integrated.splitCwd",l.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",l.WordSeparators="terminal.integrated.wordSeparators",l.EnableFileLinks="terminal.integrated.enableFileLinks",l.UnicodeVersion="terminal.integrated.unicodeVersion",l.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",l.LocalEchoEnabled="terminal.integrated.localEchoEnabled",l.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",l.LocalEchoStyle="terminal.integrated.localEchoStyle",l.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",l.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",l.HideOnStartup="terminal.integrated.hideOnStartup",l.CustomGlyphs="terminal.integrated.customGlyphs",l.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",l.InheritEnv="terminal.integrated.inheritEnv",l.ShowLinkHover="terminal.integrated.showLinkHover",l.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",l.AutoReplies="terminal.integrated.autoReplies",l.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",l.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",l.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",l.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",l.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",l.EnableImages="terminal.integrated.enableImages",l.SmoothScrolling="terminal.integrated.smoothScrolling",l.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",l.FocusAfterRun="terminal.integrated.focusAfterRun",l.AccessibleViewPreserveCursorPosition="terminal.integrated.accessibleViewPreserveCursorPosition",l.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",l.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",l.DevMode="terminal.integrated.developer.devMode"})(C||(e.TerminalSettingId=C={}));var P;(function(l){l.PowerShell="pwsh",l.Bash="bash",l.Fish="fish",l.Sh="sh",l.Csh="csh",l.Ksh="ksh",l.Zsh="zsh"})(P||(e.PosixShellType=P={}));var h;(function(l){l.CommandPrompt="cmd",l.PowerShell="pwsh",l.Wsl="wsl",l.GitBash="gitbash"})(h||(e.WindowsShellType=h={}));var c;(function(l){l[l.Api=0]="Api",l[l.Process=1]="Process",l[l.Sequence=2]="Sequence",l[l.Config=3]="Config"})(c||(e.TitleEventSource=c={}));var g;(function(l){l.LocalPty="localPty",l.PtyHost="ptyHost",l.PtyHostWindow="ptyHostWindow",l.Logger="logger",l.Heartbeat="heartbeat"})(g||(e.TerminalIpcChannels=g={}));var b;(function(l){l.Cwd="cwd",l.InitialCwd="initialCwd",l.FixedDimensions="fixedDimensions",l.Title="title",l.ShellType="shellType",l.HasChildProcesses="hasChildProcesses",l.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",l.OverrideDimensions="overrideDimensions",l.FailedShellIntegrationActivation="failedShellIntegrationActivation",l.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(b||(e.ProcessPropertyType=b={})),e.$$q=(0,S.$Qh)("ptyService");var y;(function(l){l[l.BeatInterval=5e3]="BeatInterval",l[l.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",l[l.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",l[l.SecondWaitMultiplier=1]="SecondWaitMultiplier",l[l.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(y||(e.HeartbeatConstants=y={}));var f;(function(l){l[l.Panel=1]="Panel",l[l.Editor=2]="Editor"})(f||(e.TerminalLocation=f={}));var v;(function(l){l.TerminalView="view",l.Editor="editor"})(v||(e.TerminalLocationString=v={}));var m;(function(l){l[l.GraceTime=6e4]="GraceTime",l[l.ShortGraceTime=6e3]="ShortGraceTime"})(m||(e.LocalReconnectConstants=m={}));var w;(function(l){l[l.HighWatermarkChars=1e5]="HighWatermarkChars",l[l.LowWatermarkChars=5e3]="LowWatermarkChars",l[l.CharCountAckSize=5e3]="CharCountAckSize"})(w||(e.FlowControlConstants=w={}));var $;(function(l){l.GitBash="Git Bash",l.Pwsh="PowerShell"})($||(e.ProfileSource=$={}));var d;(function(l){l[l.Off=0]="Off",l[l.FinalTerm=1]="FinalTerm",l[l.VSCode=2]="VSCode"})(d||(e.ShellIntegrationStatus=d={}));var u;(function(l){l[l.Unknown=0]="Unknown",l[l.Shutdown=1]="Shutdown",l[l.Process=2]="Process",l[l.User=3]="User",l[l.Extension=4]="Extension"})(u||(e.TerminalExitReason=u={})),e.$_q={Backend:"workbench.contributions.terminal.processBackend"};class E{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(i){const a=this.b(i.remoteAuthority);if(this.a.has(a))throw new Error(`A terminal backend with remote authority '${a}' was already registered.`);this.a.set(a,i)}getTerminalBackend(i){return this.a.get(this.b(i))}b(i){return i?.toLowerCase()??""}}s.$kn.add(e.$_q.Backend,new E),e.$ar=(0,S.$Qh)("localPtyService"),e.$br=(0,S.$Qh)("terminalLogService")}),define(ie[259],ne([0,1,74,7,187,102]),function(J,e,S,A,s,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=e.$ir=e.$hr=e.$gr=void 0;function C(y,f){const v=[{name:null,description:(0,s.localize)(0,null)}];return v.push(...y.map(m=>({name:m.profileName,description:P(m)}))),f&&v.push(...f.map(m=>({name:m.title,description:h(m)}))),{values:v.map(m=>m.name),markdownDescriptions:v.map(m=>m.description)}}e.$gr=C;function P(y){let f=`$(${R.ThemeIcon.isThemeIcon(y.icon)?y.icon.id:y.icon?y.icon:S.$Vj.terminal.id}) ${y.profileName}
- path: ${y.path}`;return y.args&&(typeof y.args=="string"?f+=`
- args: "${y.args}"`:f+=`
- args: [${y.args.length===0?"":`'${y.args.join("','")}'`}]`),y.overrideName!==void 0&&(f+=`
- overrideName: ${y.overrideName}`),y.color&&(f+=`
- color: ${y.color}`),y.env&&(f+=`
- env: ${JSON.stringify(y.env)}`),f}function h(y){return`$(${R.ThemeIcon.isThemeIcon(y.icon)?y.icon.id:y.icon?y.icon:S.$Vj.terminal.id}) ${y.title}
- extensionIdentifier: ${y.extensionIdentifier}`}function c(y,f){if(!y&&!f)return!0;if(typeof y=="string"&&typeof f=="string")return y===f;if(Array.isArray(y)&&Array.isArray(f)){if(y.length!==f.length)return!1;for(let v=0;v<y.length;v++)if(y[v]!==f[v])return!1;return!0}return!1}e.$hr=c;function g(y,f){if(!y&&!f)return!0;if(!y||!f)return!1;if(R.ThemeIcon.isThemeIcon(y)&&R.ThemeIcon.isThemeIcon(f))return y.id===f.id&&y.color===f.color;if(typeof y=="object"&&"light"in y&&"dark"in y&&typeof f=="object"&&"light"in f&&"dark"in f){const v=y,m=f;if((A.URI.isUri(v.light)||b(v.light))&&(A.URI.isUri(v.dark)||b(v.dark))&&(A.URI.isUri(m.light)||b(m.light))&&(A.URI.isUri(m.dark)||b(m.dark)))return v.light.path===m.light.path&&v.dark.path===m.dark.path}if(A.URI.isUri(y)&&A.URI.isUri(f)||b(y)||b(f)){const v=y,m=f;return v.path===m.path&&v.scheme===m.scheme}return!1}e.$ir=g;function b(y){return y?typeof y.path=="string"&&typeof y.scheme=="string":!1}e.$jr=b}),define(ie[260],ne([0,1,74,4,186,57,43,259]),function(J,e,S,A,s,R,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=e.$mr=e.$lr=e.$kr=void 0,e.$kr={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$lr={type:"string",enum:Array.from((0,S.$Uj)(),w=>w.id),markdownEnumDescriptions:Array.from((0,S.$Uj)(),w=>`$(${w.id})`)};const h={args:{description:(0,s.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,s.localize)(1,null),type:"boolean"},icon:{description:(0,s.localize)(2,null),...e.$lr},color:{description:(0,s.localize)(3,null),...e.$kr},env:{markdownDescription:(0,s.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},c={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(5,null),type:["string","array"],items:{type:"string"}},...h}},g={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(6,null),type:["string"],items:{type:"string"}},...h}};function b(w){const $=w===2?"linux":w===1?"osx":"windows";return(0,s.localize)(7,null,(0,A.$i)(w),'```json\n"terminal.integrated.profile.'+$+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const y={id:"terminal",order:100,title:(0,s.localize)(8,null),type:"object",properties:{["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,s.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},g],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,s.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},g],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,s.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},g],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:b(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,s.localize)(12,null),enum:["PowerShell","Git Bash"]},...h}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(13,null),type:"string"},id:{description:(0,s.localize)(14,null),type:"string"},title:{description:(0,s.localize)(15,null),type:"string"},...h}},{type:"null"},c]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:b(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(16,null),type:"string"},id:{description:(0,s.localize)(17,null),type:"string"},title:{description:(0,s.localize)(18,null),type:"string"},...h}},{type:"null"},c]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:b(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(19,null),type:"string"},id:{description:(0,s.localize)(20,null),type:"string"},title:{description:(0,s.localize)(21,null),type:"string"},...h}},{type:"null"},c]}},["terminal.integrated.useWslProfiles"]:{description:(0,s.localize)(22,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,s.localize)(23,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,s.localize)(24,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,s.localize)(25,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{markdownDescription:(0,s.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function f(){C.$kn.as(R.$pn.Configuration).registerConfiguration(y),m()}e.$mr=f;let v;function m(w,$){const d=C.$kn.as(R.$pn.Configuration);let u;w&&(u=(0,P.$gr)(w?.profiles,$));const E=v;v={id:"terminal",order:100,title:(0,s.localize)(27,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,s.localize)(28,null),type:["string","null"],default:null,enum:w?.os===3?u?.values:void 0,markdownEnumDescriptions:w?.os===3?u?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,s.localize)(29,null),type:["string","null"],default:null,enum:w?.os===2?u?.values:void 0,markdownEnumDescriptions:w?.os===2?u?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,s.localize)(30,null),type:["string","null"],default:null,enum:w?.os===1?u?.values:void 0,markdownEnumDescriptions:w?.os===1?u?.markdownDescriptions:void 0}}},d.updateConfigurations({add:[v],remove:E?[E]:[]})}e.$nr=m}),define(ie[261],ne([0,1,28,13,37,9,4,35,27,12,21,124,257,256]),function(J,e,S,A,s,R,C,P,h,c,g,b,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xr=e.$wr=e.$vr=void 0;function v(){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(S.release());let n=0;return t&&t.length===4&&(n=parseInt(t[3])),n}e.$vr=v;async function m(t,n,o,p=P.env,O=g.Promises.exists){if(R.$ic(t))return await O(t)?t:void 0;if(n===void 0&&(n=P.cwd()),R.$mc(t)!=="."){const j=R.$jc(n,t);return await O(j)?j:void 0}const k=(0,s.$cn)(p,"PATH");if(o===void 0&&(0,c.$zf)(k)&&(o=k.split(R.$tc)),o===void 0||o.length===0){const j=R.$jc(n,t);return await O(j)?j:void 0}for(const j of o){let U;if(R.$ic(j)?U=R.$jc(j,t):U=R.$jc(n,j,t),await O(U))return U;if(C.$j){let z=U+".com";if(await O(z)||(z=U+".exe",await O(z)))return z}}const I=R.$jc(n,t);return await O(I)?I:void 0}e.$wr=m;function w(t,n,o,p,O){const D=C.$j&&(!n.windowsEnableConpty||v()<18309);if(!n.shellIntegration.enabled||!t.executable||t.isFeatureTerminal||t.hideFromUser||t.ignoreShellIntegration||D)return;const k=t.args,I=P.$dc==="win32"?R.$nc(t.executable).toLowerCase():R.$nc(t.executable),j=R.$mc(A.$dg.asFileUri("").fsPath);let U;const z={VSCODE_INJECTION:"1"};if(n.shellIntegration.nonce&&(z.VSCODE_NONCE=n.shellIntegration.nonce),C.$j){if(I==="pwsh.exe"||I==="powershell.exe")return!k||a(k)?U=u.get(d.WindowsPwsh):i(k)&&(U=u.get(d.WindowsPwshLogin)),U?(U=[...U],U[U.length-1]=(0,h.$De)(U[U.length-1],j,""),{newArgs:U,envMixin:z}):void 0;p.warn(`Shell integration cannot be enabled for executable "${t.executable}" and args`,t.args);return}switch(I){case"bash":return!k||k.length===0?U=u.get(d.Bash):r(k)&&(z.VSCODE_SHELL_LOGIN="1",$(n,z),U=u.get(d.Bash)),U?(U=[...U],U[U.length-1]=(0,h.$De)(U[U.length-1],j),{newArgs:U,envMixin:z}):void 0;case"fish":{const x=o?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",Z=R.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return z.XDG_DATA_DIRS=`${x}:${Z}`,$(n,z),{newArgs:void 0,envMixin:z}}case"pwsh":return!k||a(k)?U=u.get(d.Pwsh):i(k)&&(U=u.get(d.PwshLogin)),U?(U=[...U],U[U.length-1]=(0,h.$De)(U[U.length-1],j,""),{newArgs:U,envMixin:z}):void 0;case"zsh":{if(!k||k.length===0?U=u.get(d.Zsh):r(k)?(U=u.get(d.ZshLogin),$(n,z)):(k===u.get(d.Zsh)||k===u.get(d.ZshLogin))&&(U=k),!U)return;U=[...U],U[U.length-1]=(0,h.$De)(U[U.length-1],j);let x;try{x=S.userInfo().username}catch{x="unknown"}const Z=R.$jc(S.tmpdir(),`${x}-${O.applicationName}-zsh`);z.ZDOTDIR=Z;const ae=o?.ZDOTDIR??S.homedir()??"~";z.USER_ZDOTDIR=ae;const se=[];return se.push({source:R.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:R.$jc(Z,".zshrc")}),se.push({source:R.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:R.$jc(Z,".zprofile")}),se.push({source:R.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:R.$jc(Z,".zshenv")}),se.push({source:R.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:R.$jc(Z,".zlogin")}),{newArgs:U,envMixin:z,filesToCopy:se}}}p.warn(`Shell integration cannot be enabled for executable "${t.executable}" and args`,t.args)}e.$xr=w;function $(t,n){if(C.$k&&t.environmentVariableCollections){const o=(0,y.$tr)(t.environmentVariableCollections),O=new f.$ur(o).getVariableMap({workspaceFolder:t.workspaceFolder}).get("PATH"),D=[];if(O)for(const k of O)k.type===b.EnvironmentVariableMutatorType.Prepend&&D.push(k.value);D.length>0&&(n.VSCODE_PATH_PREFIX=D.join(""))}}var d;(function(t){t.WindowsPwsh="windows-pwsh",t.WindowsPwshLogin="windows-pwsh-login",t.Pwsh="pwsh",t.PwshLogin="pwsh-login",t.Zsh="zsh",t.ZshLogin="zsh-login",t.Bash="bash"})(d||(d={}));const u=new Map;u.set(d.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),u.set(d.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),u.set(d.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),u.set(d.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),u.set(d.Zsh,["-i"]),u.set(d.ZshLogin,["-il"]),u.set(d.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const E=["-login","-l"],l=["-nol","-nologo"];function i(t){return typeof t=="string"?E.includes(t.toLowerCase()):t.length===1&&E.includes(t[0].toLowerCase())||t.length===2&&(E.includes(t[0].toLowerCase())||E.includes(t[1].toLowerCase()))&&(l.includes(t[0].toLowerCase())||l.includes(t[1].toLowerCase()))}function a(t){return typeof t=="string"?l.includes(t.toLowerCase()):t.length===0||t?.length===1&&l.includes(t[0].toLowerCase())}function r(t){return t==="string"&&E.includes(t.toLowerCase())||typeof t!="string"&&t.length===1&&E.includes(t[0].toLowerCase())}}),define(ie[262],ne([0,1,47,74,9,4,12,21,106,261,113]),function(J,e,S,A,s,R,C,P,h,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yr=void 0;let b,y=!0;function f(n,o,p,O,D=process.env,k,I,j,U){return k=k||{existsFile:P.SymlinkSupport.existsFile,readFile:P.Promises.readFile},R.$j?v(p,k,D,I,O.getValue("terminal.integrated.useWslProfiles")!==!1,n&&typeof n=="object"?{...n}:O.getValue("terminal.integrated.profiles.windows"),typeof o=="string"?o:O.getValue("terminal.integrated.defaultProfile.windows"),U,j):a(k,I,p,n&&typeof n=="object"?{...n}:O.getValue(R.$l?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof o=="string"?o:O.getValue(R.$l?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),U,j,D)}e.$yr=f;async function v(n,o,p,O,D,k,I,j,U){const z=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),x=`${process.env.windir}\\${z?"Sysnative":"System32"}`;let Z=!1;(0,c.$vr)()>=16299&&(Z=!0),await d(j);const ae=new Map;if(n){ae.set("PowerShell",{source:"PowerShell",icon:A.$Vj.terminalPowershell,isAutoDetected:!0}),ae.set("Windows PowerShell",{path:`${x}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:A.$Vj.terminalPowershell,isAutoDetected:!0}),ae.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),ae.set("Command Prompt",{path:`${x}\\cmd.exe`,icon:A.$Vj.terminalCmd,isAutoDetected:!0}),ae.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),ae.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:A.$Vj.terminalBash,isAutoDetected:!0});const ce=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;ae.set("Cmder",{path:`${x}\\cmd.exe`,args:["/K",ce],requiresPath:process.env.CMDER_ROOT?ce:{path:ce,isUnsafe:!0},isAutoDetected:!0})}r(k,ae);const se=await m(ae.entries(),I,o,p,O,U);if(n&&D)try{const ce=await l(`${x}\\${Z?"wsl":"bash"}.exe`,I);for(const Y of ce)(!k||!(Y.profileName in k))&&se.push(Y)}catch{y&&(O?.info("WSL is not installed, so could not detect WSL profiles"),y=!1)}return se}async function m(n,o,p,O=process.env,D,k){const I=[];for(const[j,U]of n)I.push(w(j,U,o,p,O,D,k));return(await Promise.all(I)).filter(j=>!!j)}async function w(n,o,p,O,D=process.env,k,I){if(o===null)return;let j,U,z;if("source"in o&&!("path"in o)){const se=b?.get(o.source);if(!se)return;j=se.paths,U=o.args||se.args,o.icon?z=$(o.icon):se.icon&&(z=se.icon)}else j=Array.isArray(o.path)?o.path:[o.path],U=R.$j||Array.isArray(o.args)?o.args:void 0,z=$(o.icon);let x;if(I){const se=j.map(Y=>typeof Y=="string"?Y:Y.path),ce=await I(se);x=new Array(j.length);for(let Y=0;Y<j.length;Y++)typeof j[Y]=="string"?x[Y]=ce[Y]:x[Y]={path:ce[Y],isUnsafe:!0}}else x=j.slice();let Z;if(o.requiresPath){let se;if((0,C.$zf)(o.requiresPath)?se=o.requiresPath:(se=o.requiresPath.path,o.requiresPath.isUnsafe&&(Z=se)),!await O.existsFile(se))return}const ae=await t(n,p,x,O,D,U,o.env,o.overrideName,o.isAutoDetected,Z);if(!ae){k?.debug("Terminal profile not validated",n,j);return}return ae.isAutoDetected=o.isAutoDetected,ae.icon=z,ae.color=o.color,ae}function $(n){return typeof n=="string"?{id:n}:n}async function d(n){if(b&&!n)return;const[o,p]=await Promise.all([u(),n||E()]);b=new Map,b.set("Git Bash",{profileName:"Git Bash",paths:o,args:["--login","-i"]}),b.set("PowerShell",{profileName:"PowerShell",paths:p,icon:A.$Vj.terminalPowershell})}async function u(){const n=new Set,o=await(0,c.$wr)("git.exe");if(o){const D=(0,g.dirname)(o);n.add((0,g.resolve)(D,"../.."))}function p(D,k){k&&D.add(k)}p(n,process.env.ProgramW6432),p(n,process.env.ProgramFiles),p(n,process.env["ProgramFiles(X86)"]),p(n,`${process.env.LocalAppData}\\Program`);const O=[];for(const D of n)O.push(`${D}\\Git\\bin\\bash.exe`,`${D}\\Git\\usr\\bin\\bash.exe`,`${D}\\usr\\bin\\bash.exe`);return O.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),O.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),O}async function E(){const n=[];for await(const o of(0,h.$yl)())n.push(o.exePath);return n}async function l(n,o){const p=[],O=await new Promise((I,j)=>{S.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(U,z)=>{if(U)return j("Problem occurred when getting wsl distros");I(z)})});if(!O)return[];const D=new RegExp(/[\r?\n]/),k=O.split(D).filter(I=>I.trim().length>0&&I!=="");for(const I of k){if(I===""||I.startsWith("docker-desktop"))continue;const j=`${I} (WSL)`,U={profileName:j,path:n,args:["-d",`${I}`],isDefault:j===o,icon:i(I),isAutoDetected:!1};p.push(U)}return p}function i(n){return n.includes("Ubuntu")?A.$Vj.terminalUbuntu:n.includes("Debian")?A.$Vj.terminalDebian:A.$Vj.terminalLinux}async function a(n,o,p,O,D,k,I,j){const U=new Map;if(p){const z=(await n.readFile("/etc/shells")).toString(),x=(k||z.split(`
`)).map(ae=>{const se=ae.indexOf("#");return se===-1?ae:ae.substring(0,se)}).filter(ae=>ae.trim().length>0),Z=new Map;for(const ae of x){let se=(0,s.$nc)(ae),ce=Z.get(se)||0;ce++,ce>1&&(se=`${se} (${ce})`),Z.set(se,ce),U.set(se,{path:ae,isAutoDetected:!0})}}return r(O,U),await m(U.entries(),D,n,j,o,I)}function r(n,o){if(n)for(const[p,O]of Object.entries(n))O===null||typeof O!="object"||!("path"in O)&&!("source"in O)?o.delete(p):(O.icon=O.icon||o.get(p)?.icon,o.set(p,O))}async function t(n,o,p,O,D,k,I,j,U,z){if(p.length===0)return Promise.resolve(void 0);const x=p.shift();if(x==="")return t(n,o,p,O,D,k,I,j,U);const Z=typeof x!="string"&&x.isUnsafe,ae=typeof x=="string"?x:x.path,se={profileName:n,path:ae,args:k,env:I,overrideName:j,isAutoDetected:U,isDefault:n===o,isUnsafePath:Z,requiresUnsafePath:z};if((0,s.$nc)(ae)===ae){const Y=D.PATH?D.PATH.split(s.$tc):void 0,K=await(0,c.$wr)(ae,void 0,Y,void 0,O.existsFile);return K?(se.path=K,se.isFromPath=!0,se):t(n,o,p,O,D,k)}return await O.existsFile((0,s.$hc)(ae))?se:t(n,o,p,O,D,k,I,j,U)}}),define(ie[263],ne([0,1,3,2,4,42,18,6,226,94,258,125,260,262,108,72]),function(J,e,S,A,s,R,C,P,h,c,g,b,y,f,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zr=void 0;var w;(function(d){d[d.MaxRestarts=5]="MaxRestarts"})(w||(w={}));let $=class extends A.$Sc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(u,E,l,i){super(),this.M=u,this.N=E,this.O=l,this.P=i,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new S.$Od),this.onPtyHostExit=this.u.event,this.w=this.B(new S.$Od),this.onPtyHostStart=this.w.event,this.y=this.B(new S.$Od),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new S.$Od),this.onPtyHostResponsive=this.z.event,this.C=this.B(new S.$Od),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new S.$Od),this.onProcessData=this.D.event,this.F=this.B(new S.$Od),this.onProcessReady=this.F.event,this.G=this.B(new S.$Od),this.onProcessReplay=this.G.event,this.H=this.B(new S.$Od),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new S.$Od),this.onDidRequestDetach=this.I.event,this.J=this.B(new S.$Od),this.onDidChangeProperty=this.J.event,this.L=this.B(new S.$Od),this.onProcessExit=this.L.event,(0,y.$mr)(),this.B(this.M),this.B((0,A.$Qc)(()=>this.W())),this.j=this.B(new g.$fr(void 0,this.O)),this.j.onCreateRequest(this.C.fire,this.C),this.M.onRequestConnection&&S.Event.once(this.M.onRequestConnection)(()=>this.h()),this.M.onWillShutdown?.(()=>this.m=!0)}get Q(){return this.N.getValue("terminal.integrated.ignoreProcessNames")}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(s.$j)return process.env;try{return await(0,c.$Ul)(this.N,this.O,{_:[]},process.env)}catch(u){return this.O.error("ptyHost was unable to resolve shell environment",u),{}}}U(){const u=this.M.start(),E=u.client;this.O.getLevel()===P.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),R.ProxyChannel.toService(E.getChannel(b.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(u.onDidProcessExit(a=>{this.u.fire(a.code),!this.m&&!this.q.isDisposed&&(this.n<=w.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${a.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${a.code}, giving up`))}));const i=R.ProxyChannel.toService(E.getChannel(b.TerminalIpcChannels.PtyHost));return this.B(i.onProcessData(a=>this.D.fire(a))),this.B(i.onProcessReady(a=>this.F.fire(a))),this.B(i.onProcessExit(a=>this.L.fire(a))),this.B(i.onDidChangeProperty(a=>this.J.fire(a))),this.B(i.onProcessReplay(a=>this.G.fire(a))),this.B(i.onProcessOrphanQuestion(a=>this.H.fire(a))),this.B(i.onDidRequestDetach(a=>this.I.fire(a))),this.B(new h.$er(this.P,E.getChannel(b.TerminalIpcChannels.Logger))),this.a=u,this.b=i,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async a=>{a.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.R()})),this.R(),[u,i]}async createProcess(u,E,l,i,a,r,t,n,o,p,O){const D=setTimeout(()=>this.$(),b.HeartbeatConstants.CreateProcessTimeout),k=await this.f.createProcess(u,E,l,i,a,r,t,n,o,p,O);return clearTimeout(D),k}updateTitle(u,E,l){return this.f.updateTitle(u,E,l)}updateIcon(u,E,l,i){return this.f.updateIcon(u,E,l,i)}attachToProcess(u){return this.f.attachToProcess(u)}detachFromProcess(u,E){return this.f.detachFromProcess(u,E)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(u){return this.f.start(u)}shutdown(u,E){return this.f.shutdown(u,E)}input(u,E){return this.f.input(u,E)}processBinary(u,E){return this.f.processBinary(u,E)}resize(u,E,l){return this.f.resize(u,E,l)}clearBuffer(u){return this.f.clearBuffer(u)}acknowledgeDataEvent(u,E){return this.f.acknowledgeDataEvent(u,E)}setUnicodeVersion(u,E){return this.f.setUnicodeVersion(u,E)}getInitialCwd(u){return this.f.getInitialCwd(u)}getCwd(u){return this.f.getCwd(u)}async getLatency(){const u=new m.$Kd,E=await this.f.getLatency();return u.stop(),[{label:"ptyhostservice<->ptyhost",latency:u.elapsed()},...E]}orphanQuestionReply(u){return this.f.orphanQuestionReply(u)}installAutoReply(u,E){return this.f.installAutoReply(u,E)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(u){return this.f.uninstallAutoReply(u)}getDefaultSystemShell(u){return this.g?.getDefaultSystemShell(u)??(0,v.$El)(u??s.OS,process.env)}async getProfiles(u,E,l,i=!1){const a=await this.S();return(0,f.$yr)(E,l,i,this.N,a,void 0,this.O,this.bb.bind(this,u))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(u,E){return this.f.getWslPath(u,E)}getRevivedPtyNewId(u,E){return this.f.getRevivedPtyNewId(u,E)}setTerminalLayoutInfo(u){return this.f.setTerminalLayoutInfo(u)}async getTerminalLayoutInfo(u){return this.g?.getTerminalLayoutInfo(u)}async requestDetachInstance(u,E){return this.f.requestDetachInstance(u,E)}async acceptDetachInstanceReply(u,E){return this.f.acceptDetachInstanceReply(u,E)}async freePortKillProcess(u){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(u)}async serializeTerminalState(u){return this.f.serializeTerminalState(u)}async reviveTerminalProcesses(u,E,l){return this.f.reviveTerminalProcesses(u,E,l)}async refreshProperty(u,E){return this.f.refreshProperty(u,E)}async updateProperty(u,E,l){return this.f.updateProperty(u,E,l)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(u){this.ab(),this.s=setTimeout(()=>this.Y(),u?b.HeartbeatConstants.ConnectingBeatInterval:b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.FirstWaitMultiplier+b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${b.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(u,E){return this.j.createRequest({workspaceId:u,originalText:E})}async acceptPtyHostResolvedVariables(u,E){this.j.acceptReply(u,E)}};e.$zr=$,e.$zr=$=Ee([te(1,C.$ki),te(2,P.$$i),te(3,P.$_i)],$)}),define(ie[67],ne([0,1,15,3,2,4,18,5,34]),function(J,e,S,A,s,R,C,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M6b=e.$L6b=void 0;const c="#FFFFFF",g="#1E1E1E",b="#000000",y="#FFFFFF",f="theme",v="themeBackground",m="windowSplash";e.$L6b=(0,P.$Qh)("themeMainService");let w=class extends s.$Sc{constructor(d,u){super(),this.b=d,this.c=u,this.a=this.B(new A.$Od),this.onDidChangeColorScheme=this.a.event,S.nativeTheme.on("updated",()=>{this.a.fire(this.getColorScheme())})}getColorScheme(){if(R.$j){if(S.nativeTheme.shouldUseHighContrastColors)return{dark:S.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(R.$k){if(S.nativeTheme.shouldUseInvertedColorScheme||S.nativeTheme.shouldUseHighContrastColors)return{dark:S.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(R.$l&&S.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:S.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const d=this.getColorScheme();if(d.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return d.dark?b:y;let u=this.b.getItem(v,null);if(!u)switch(this.b.getItem(f,"vs-dark").split(" ")[0]){case"vs":u=c;break;case"hc-black":u=b;break;case"hc-light":u=y;break;default:u=g}return R.$k&&u.toUpperCase()===g&&(u="#171717"),u}saveWindowSplash(d,u){this.b.setItems([{key:f,data:u.baseTheme},{key:v,data:u.colorInfo.background},{key:m,data:u}]),typeof d=="number"&&this.f(d,u)}f(d,u){for(const E of S.BrowserWindow.getAllWindows())if(E.id===d){E.setBackgroundColor(u.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(m)}};e.$M6b=w,e.$M6b=w=Ee([te(0,h.$FN),te(1,C.$ki)],w)}),define(ie[126],ne([0,1,3,18,5,6]),function(J,e,S,A,s,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lv=e.$kv=e.$jv=e.$iv=e.$hv=e.$gv=e.$fv=e.$ev=e.ProvidedOnAutoForward=e.$dv=e.TunnelPrivacyId=e.TunnelProtocol=e.$cv=e.$bv=void 0,e.$bv=(0,s.$Qh)("tunnelService"),e.$cv=(0,s.$Qh)("sharedTunnelsService");var C;(function(w){w.Http="http",w.Https="https"})(C||(e.TunnelProtocol=C={}));var P;(function(w){w.ConstantPrivate="constantPrivate",w.Private="private",w.Public="public"})(P||(e.TunnelPrivacyId=P={}));function h(w){return!!w.forwardPort}e.$dv=h;var c;(function(w){w[w.Notify=1]="Notify",w[w.OpenBrowser=2]="OpenBrowser",w[w.OpenPreview=3]="OpenPreview",w[w.Silent=4]="Silent",w[w.Ignore=5]="Ignore",w[w.OpenBrowserOnce=6]="OpenBrowserOnce"})(c||(e.ProvidedOnAutoForward=c={}));function g(w){if(w.scheme!=="http"&&w.scheme!=="https")return;const $=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(w.authority);if($)return{address:$[1],port:+$[2]}}e.$ev=g,e.$fv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function b(w){return e.$fv.indexOf(w)>=0}e.$gv=b,e.$hv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function y(w){return e.$hv.indexOf(w)>=0}e.$iv=y;function f(w,$,d,u){if(d===1)return!1;if(d===2&&y($)){const E=/(\d+)\.(\d+)\.(\d+)/g.exec(u);if(E?.length===4&&parseInt(E[1])>=18)return!1}return w<1024}e.$jv=f;class v{constructor($,d,u){this.remoteAddress=$,this.localAddress=d,this.b=u,this.a=new S.$Od,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$kv=v;let m=class{constructor($,d){this.j=$,this.k=d,this.a=new S.$Od,this.onTunnelOpened=this.a.event,this.b=new S.$Od,this.onTunnelClosed=this.b.event,this.c=new S.$Od,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const $=this.k.getValue("remote.localPortHost");return!$||$==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider($){return this.f=$,$?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures($){this.g=$.elevation,this.h=$.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const $=[],d=Array.from(this.e.values());for(const u of d){const E=Array.from(u.values());for(const l of E){const i=await l.value;i&&typeof i!="string"&&$.push(i)}}return $}async dispose(){for(const $ of this.e.values()){for(const{value:d}of $.values())await d.then(u=>typeof u!="string"?u?.dispose():void 0);$.clear()}this.e.clear()}setEnvironmentTunnel($,d,u,E,l){this.p($,d,Promise.resolve({tunnelRemoteHost:$,tunnelRemotePort:d,localAddress:u,privacy:E,protocol:l,dispose:()=>Promise.resolve()}))}async getExistingTunnel($,d){(y($)||b($))&&($=e.$fv[0]);const u=this.r($,d);if(u)return++u.refcount,u.value}openTunnel($,d,u,E,l,i=!1,a,r){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${u} on local port ${l}.`);const t=this.f??$;if(!t)return;if(d||(d="localhost"),E||(E=this.l),this.f&&this.i.has(u)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const n=this.s(t,d,u,E,l,i,a,r);return n?n.then(o=>{if(o){if(typeof o=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(d,u),o}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(d,u);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const p=this.n(o);return(o.tunnelRemoteHost!==d||o.tunnelRemotePort!==u)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),a&&o.privacy!==a&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(p),p}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),n)}n($){return{tunnelRemotePort:$.tunnelRemotePort,tunnelRemoteHost:$.tunnelRemoteHost,tunnelLocalPort:$.tunnelLocalPort,localAddress:$.localAddress,privacy:$.privacy,protocol:$.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${$.tunnelRemoteHost}:${$.tunnelRemotePort} `);const d=this.e.get($.tunnelRemoteHost);if(d){const u=d.get($.tunnelRemotePort);u&&(u.refcount--,await this.o($.tunnelRemoteHost,$.tunnelRemotePort,u))}}}}async o($,d,u){if(u.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${$}:${d}.`);const E=u.value.then(async l=>{l&&typeof l!="string"&&(await l.dispose(!0),this.b.fire({host:l.tunnelRemoteHost,port:l.tunnelRemotePort}))});return this.e.has($)&&this.e.get($).delete(d),E}}async closeTunnel($,d){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${$}:${d} `);const u=this.e.get($);if(u&&u.has(d)){const E=u.get(d);E.refcount=0,await this.o($,d,E)}}p($,d,u){this.e.has($)||this.e.set($,new Map),this.e.get($).set(d,{refcount:1,value:u})}async q($,d){const u=this.e.get($);if(u){const E=u.get(d),l=E?await E.value:void 0;(!l||typeof l=="string")&&u.delete(d),u.size===0&&this.e.delete($)}}r($,d){const u=[$];b($)?(u.push(...e.$fv),u.push(...e.$hv)):y($)&&u.push(...e.$hv);const E=u.map(l=>this.e.get(l));for(const l of E){const i=l?.get(d);if(i)return i}}canTunnel($){return!!g($)}t($,d,u,E,l,i,a){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${u} on local port ${E}.`);const r=u;this.i.add(r);const t=E===void 0?u:E,n={elevationRequired:l?this.isPortPrivileged(t):!1},o={remoteAddress:{host:d,port:u},localAddressPort:E,privacy:i,public:i?i!==P.Private:void 0,protocol:a},p=$.forwardPort(o,n);return p?(this.p(d,u,p),p.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(r)})):this.i.delete(r),p}};e.$lv=m,e.$lv=m=Ee([te(0,R.$$i),te(1,A.$ki)],m)}),define(ie[48],ne([0,1,5]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uU=e.$tU=e.DisablementReason=e.UpdateType=e.StateType=void 0;var A;(function(C){C.Uninitialized="uninitialized",C.Idle="idle",C.Disabled="disabled",C.CheckingForUpdates="checking for updates",C.AvailableForDownload="available for download",C.Downloading="downloading",C.Downloaded="downloaded",C.Updating="updating",C.Ready="ready"})(A||(e.StateType=A={}));var s;(function(C){C[C.Setup=0]="Setup",C[C.Archive=1]="Archive",C[C.Snap=2]="Snap"})(s||(e.UpdateType=s={}));var R;(function(C){C[C.NotBuilt=0]="NotBuilt",C[C.DisabledByEnvironment=1]="DisabledByEnvironment",C[C.ManuallyDisabled=2]="ManuallyDisabled",C[C.MissingConfiguration=3]="MissingConfiguration",C[C.InvalidConfiguration=4]="InvalidConfiguration",C[C.RunningAsAdmin=5]="RunningAsAdmin"})(R||(e.DisablementReason=R={})),e.$tU={Uninitialized:{type:"uninitialized"},Disabled:C=>({type:"disabled",reason:C}),Idle:(C,P)=>({type:"idle",updateType:C,error:P}),CheckingForUpdates:C=>({type:"checking for updates",explicit:C}),AvailableForDownload:C=>({type:"available for download",update:C}),Downloading:C=>({type:"downloading",update:C}),Downloaded:C=>({type:"downloaded",update:C}),Updating:C=>({type:"updating",update:C}),Ready:C=>({type:"ready",update:C})},e.$uU=(0,S.$Qh)("updateService")}),define(ie[264],ne([0,1,4,188,57,43]),function(J,e,S,A,s,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),R.$kn.as(s.$pn.Configuration).registerConfiguration({id:"update",order:15,title:(0,A.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,A.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,A.localize)(2,null),(0,A.localize)(3,null),(0,A.localize)(4,null),(0,A.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,A.localize)(6,null),deprecationMessage:(0,A.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,A.localize)(8,null),description:(0,A.localize)(9,null),included:S.$j&&!S.$p},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,A.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(ie[265],ne([0,1,3,48]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U7b=e.$T7b=void 0;class s{constructor(P){this.a=P}listen(P,h){switch(h){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${h}`)}call(P,h,c){switch(h){case"checkForUpdates":return this.a.checkForUpdates(c);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(c)}throw new Error(`Call not found: ${h}`)}}e.$T7b=s;class R{get state(){return this.b}set state(P){this.b=P,this.a.fire(P)}constructor(P){this.c=P,this.a=new S.$Od,this.onStateChange=this.a.event,this.b=A.$tU.Uninitialized,this.c.listen("onStateChange")(h=>this.state=h),this.c.call("_getInitialState").then(h=>this.state=h)}checkForUpdates(P){return this.c.call("checkForUpdates",P)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(P){return this.c.call("_applySpecificUpdate",P)}}e.$U7b=R}),define(ie[40],ne([0,1,5]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jk=void 0,e.$Jk=(0,S.$Qh)("IUriIdentityService")}),define(ie[266],ne([0,1,40,207,16,19,141,3,2]),function(J,e,S,A,s,R,C,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=void 0;class c{static{this._clock=0}constructor(y){this.uri=y,this.time=c._clock++}touch(){return this.time=c._clock++,this}}let g=class{constructor(y){this.g=y,this.c=new h.$Rc,this.f=2**16;const f=new Map,v=m=>{let w=f.get(m.scheme);return w===void 0&&(w=y.hasProvider(m)&&!this.g.hasCapability(m,1024),f.set(m.scheme,w)),w};this.c.add(P.Event.any(y.onDidChangeFileSystemProviderRegistrations,y.onDidChangeFileSystemProviderCapabilities)(m=>{f.delete(m.scheme)})),this.extUri=new R.$lg(v),this.d=new C.$Cr((m,w)=>this.extUri.compare(m,w,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(y){this.g.hasProvider(y)&&(y=(0,R.$xg)(y));const f=this.d.get(y);return f?f.touch().uri.with({fragment:y.fragment}):(this.d.set(y,new c(y)),this.h(),y)}h(){if(this.d.size<this.f)return;const y=[...this.d.entries()].sort((v,m)=>v[1].time<m[1].time?1:v[1].time>m[1].time?-1:0);c._clock=0,this.d.clear();const f=this.f*.5;for(let v=0;v<f;v++)this.d.set(y[v][0],y[v][1].touch())}};e.$Dr=g,e.$Dr=g=Ee([te(0,s.$_j)],g),(0,A.$Ar)(S.$Jk,g,1)}),define(ie[127],ne([0,1,5]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iU=void 0,e.$iU=(0,S.$Qh)("urlService")}),define(ie[267],ne([0,1,7]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$47b=e.$37b=e.$27b=void 0;class A{constructor(P){this.a=P}listen(P,h){throw new Error(`Event not found: ${h}`)}call(P,h,c){switch(h){case"handleURL":return this.a.handleURL(S.URI.revive(c[0]),c[1])}throw new Error(`Call not found: ${h}`)}}e.$27b=A;class s{constructor(P){this.a=P}handleURL(P,h){return this.a.call("handleURL",[P.toJSON(),h])}}e.$37b=s;class R{constructor(P,h){this.a=P,this.b=h}async routeCall(P,h,c,g){if(h!=="handleURL")throw new Error(`Call not found: ${h}`);if(Array.isArray(c)&&c.length>0){const b=S.URI.revive(c[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",b.toString(!0)),b.query){const y=/\bwindowId=(\d+)/.exec(b.query);if(y){const f=y[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${f}"`,b.toString(!0));const v=new RegExp(`window:${f}`),m=P.connections.find(w=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",w.ctx),v.test(w.ctx)));if(m)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",b.toString(!0)),m;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",b.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",b.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(P,h,c,g)}routeEvent(P,h){throw new Error(`Event not found: ${h}`)}}e.$47b=R}),define(ie[268],ne([0,1,8,2,7,25]),function(J,e,S,A,s,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kU=e.$jU=void 0;class C extends A.$Sc{constructor(){super(...arguments),this.a=new Set}open(c,g){const b=[...this.a.values()];return(0,S.$Yg)(b.map(y=>()=>y.handleURL(c,g)),void 0,!1).then(y=>y||!1)}registerHandler(c){return this.a.add(c),(0,A.$Qc)(()=>this.a.delete(c))}}e.$jU=C;let P=class extends C{constructor(c){super(),this.b=c}create(c){let{authority:g,path:b,query:y,fragment:f}=c||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return g&&b&&b.indexOf("/")!==0&&(b=`/${b}`),s.URI.from({scheme:this.b.urlProtocol,authority:g,path:b,query:y,fragment:f})}};e.$kU=P,e.$kU=P=Ee([te(0,R.$qj)],P)}),define(ie[269],ne([0,1,15,8,3,2,4,7]),function(J,e,S,A,s,R,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$57b=void 0;class h extends R.$Sc{constructor(g,b,y,f,v,m){if(super(),this.c=b,this.f=m,this.a=[],this.b=0,g&&(m.trace("ElectronURLListener initialUrisToHandle:",g.map(d=>d.originalUrl)),this.a=g),C.$j){const d=f.isBuilt?[]:[`"${f.appRoot}"`];d.push("--open-url","--"),S.app.setAsDefaultProtocolClient(v.urlProtocol,process.execPath,d)}const w=s.Event.map(s.Event.fromNodeEventEmitter(S.app,"open-url",(d,u)=>({event:d,url:u})),({event:d,url:u})=>(d.preventDefault(),u));this.B(w(d=>{const u=this.g(d);u&&this.c.open(u,{originalUrl:d})})),y.getWindows().filter(d=>d.isReady).length>0?(m.trace("ElectronURLListener: window is ready to handle URLs"),this.h()):(m.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),this.B(s.Event.once(y.onDidSignalReadyWindow)(()=>this.h())))}g(g){try{return P.URI.parse(g)}catch{return}}async h(){if(this.b++>10){this.f.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.f.trace("ElectronURLListener#flush(): flushing URLs");const g=[];for(const b of this.a)await this.c.open(b.uri,{originalUrl:b.originalUrl})?this.f.trace("ElectronURLListener#flush(): URL was handled",b.originalUrl):(this.f.trace("ElectronURLListener#flush(): URL was not yet handled",b.originalUrl),g.push(b));g.length!==0&&(this.a=g,(0,A.$Wg)(()=>this.h(),500,this.q))}}e.$57b=h}),define(ie[270],ne([0,1,3,2,16,56,31]),function(J,e,S,A,s,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F8b=void 0;class P extends A.$Sc{constructor(c,g,b,y,f,v){super(),this.f=c,this.g=g,this.h=b,this.j=y,this.m=f,this.n=v,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new S.$Od),this.onDidChangeFile=this.a.event,this.b=R.$Wh.forUris(()=>!(this.capabilities&1024)),this.c=new C.$Bc(m=>this.m.extUri.getComparisonKey(this.t(m))),this.r(),this.B(y.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(m=>this.s(m)))}r(){this.c.clear();for(const c of this.j.profiles)this.c.add(c.settingsResource),this.c.add(c.keybindingsResource),this.c.add(c.tasksResource),this.c.add(c.extensionsResource)}open(c,g){return this.g.open(this.t(c),g)}close(c){return this.g.close(c)}read(c,g,b,y,f){return this.g.read(c,g,b,y,f)}write(c,g,b,y,f){return this.g.write(c,g,b,y,f)}watch(c,g){this.b.set(c,c);const b=this.g.watch(this.t(c),g);return(0,A.$Qc)(()=>{this.b.delete(c),b.dispose()})}stat(c){return this.g.stat(this.t(c))}mkdir(c){return this.g.mkdir(this.t(c))}rename(c,g,b){return this.g.rename(this.t(c),this.t(g),b)}readFile(c,g){return this.g.readFile(this.t(c),g)}readFileStream(c,g,b){return this.g.readFileStream(this.t(c),g,b)}readdir(c){return this.g.readdir(this.t(c))}enforceAtomicReadFile(c){return this.c.has(c)}writeFile(c,g,b){return this.g.writeFile(this.t(c),g,b)}enforceAtomicWriteFile(c){return this.c.has(c)?{postfix:".vsctmp"}:!1}delete(c,g){return this.g.delete(this.t(c),g)}copy(c,g,b){if((0,s.$dk)(this.g))return this.g.copy(this.t(c),this.t(g),b);throw new Error("copy not supported")}cloneFile(c,g){if((0,s.$ek)(this.g))return this.g.cloneFile(this.t(c),this.t(g));throw new Error("clone not supported")}s(c){const g=[];for(const b of c){if(b.resource.scheme!==this.f)continue;const y=this.u(b.resource);this.b.findSubstr(y)&&g.push({resource:y,type:b.type,cId:b.cId})}g.length&&(this.n.debug("User data changed"),this.a.fire(g))}t(c){return c.with({scheme:this.f})}u(c){return c.with({scheme:this.h})}}e.$F8b=P}),define(ie[271],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m8b=void 0,e.$m8b="utilityProcessWorker"}),define(ie[272],ne([0,1,5]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$67b=void 0,e.$67b=(0,S.$Qh)("webviewManagerService")}),define(ie[273],ne([0,1,15,2,13,7]),function(J,e,S,A,s,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$77b=void 0;class C extends A.$Sc{static{this.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const h=this.b.bind(this);S.protocol.registerFileProtocol(s.Schemas.vscodeWebview,h)}b(h,c){try{const g=R.URI.parse(h.url),b=C.a.get(g.path);if(typeof b=="string"){const y=`vs/workbench/contrib/webview/browser/pre/${b}`,f=s.$dg.asFileUri(y);return c({path:f.fsPath,headers:{...s.COI.getHeadersFromQuery(h.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return c({error:-10})}catch{}return c({error:-2})}}e.$77b=C}),define(ie[68],ne([0,1,4]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qC=e.$pC=e.$oC=e.$nC=e.$mC=e.$lC=e.$kC=e.$jC=void 0,e.$jC={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function A(g){return!!g.workspaceUri}e.$kC=A;function s(g){return!!g.folderUri}e.$lC=s;function R(g){return!!g.fileUri}e.$mC=R;function C(g){const b=P(g),y=g.getValue("window.menuBarVisibility");return y==="default"||b==="native"&&y==="compact"||S.$k&&S.$n?"classic":y}e.$nC=C;function P(g){if(S.$p)return"custom";const b=g.getValue("window");if(b){if(S.$k&&b.nativeTabs===!0||S.$k&&b.nativeFullScreen===!1)return"native";const v=b.titleBarStyle;if(v==="native"||v==="custom")return v}return S.$l?"native":"custom"}e.$oC=P;function h(g){return!(!S.$j||S.$p||P(g)==="native")}e.$pC=h;function c(g=0){return Math.pow(1.2,g)}e.$qC=c}),define(ie[128],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.$w6b=e.UnloadReason=e.LoadReason=void 0;var S;(function(P){P[P.INITIAL=1]="INITIAL",P[P.LOAD=2]="LOAD",P[P.RELOAD=3]="RELOAD"})(S||(e.LoadReason=S={}));var A;(function(P){P[P.CLOSE=1]="CLOSE",P[P.QUIT=2]="QUIT",P[P.RELOAD=3]="RELOAD",P[P.LOAD=4]="LOAD"})(A||(e.UnloadReason=A={}));const s=function(P=1){return{width:1024,height:768,mode:P}};e.$w6b=s;var R;(function(P){P[P.Maximized=0]="Maximized",P[P.Normal=1]="Normal",P[P.Minimized=2]="Minimized",P[P.Fullscreen=3]="Fullscreen"})(R||(e.WindowMode=R={}));var C;(function(P){P[P.UNRESPONSIVE=1]="UNRESPONSIVE",P[P.PROCESS_GONE=2]="PROCESS_GONE",P[P.LOAD=3]="LOAD"})(C||(e.WindowError=C={}))}),define(ie[274],ne([0,1,8,3,2]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a8b=void 0;class R extends s.$Sc{constructor({onDidOpenWindow:P,onDidFocusWindow:h,getActiveWindowId:c}){super(),this.a=this.B(new s.$Rc),A.Event.latch(A.Event.any(P,h))(this.f,this,this.a),this.b=(0,S.$Ig)(()=>c()),(async()=>{try{const b=await this.b;this.c=typeof this.c=="number"?this.c:b}catch{}finally{this.b=void 0}})()}f(P){this.b&&(this.b.cancel(),this.b=void 0),this.c=P}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$a8b=R}),define(ie[30],ne([0,1,192,9,56,19,7,5,13]),function(J,e,S,A,s,R,C,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.WorkbenchState=e.$7h=e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=void 0,e.$Zh=(0,P.$Qh)("contextService");function c(t){const n=t;return typeof n?.id=="string"&&C.URI.isUri(n.uri)}e.$1h=c;function g(t){return typeof t?.id=="string"&&!c(t)&&!y(t)}e.$2h=g,e.$3h={id:"ext-dev"},e.$4h={id:"empty-window"};function b(t,n){if(typeof t=="string"||typeof t>"u")return typeof t=="string"?{id:(0,A.$nc)(t)}:n?e.$3h:e.$4h;const o=t;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}e.$5h=b;function y(t){const n=t;return typeof n?.id=="string"&&C.URI.isUri(n.configPath)}e.$6h=y;function f(t){const n=t;if(n?.uri)return{id:n.id,uri:C.URI.revive(n.uri)};const o=t;if(o?.configPath)return{id:o.id,configPath:C.URI.revive(o.configPath)};if(t?.id)return{id:t.id}}e.$7h=f;var v;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})(v||(e.WorkbenchState=v={}));function m(t){const n=t;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.$8h=m;function w(t){const n=t;return!!(n&&typeof n=="object"&&C.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.$9h=w;class ${constructor(n,o,p,O,D){this.h=n,this.j=p,this.k=O,this.l=D,this.c=s.$Wh.forUris(this.l,()=>!0),this.folders=o}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=s.$Wh.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$0h=$;class d{constructor(n,o){this.raw=o,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,R.$wg)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$$h=d;function u(t){return new d({uri:t,index:0,name:(0,R.$sg)(t)},{uri:t.toString()})}e.$_h=u,e.$ai="code-workspace",e.$bi=`.${e.$ai}`,e.$ci=[{name:(0,S.localize)(0,null),extensions:[e.$ai]}],e.$di="workspace.json";function E(t,n){return R.$ng.isEqualOrParent(t,n.untitledWorkspacesHome)}e.$ei=E;function l(t){let n;return C.URI.isUri(t)?n=t:n=t.configuration,n?.scheme===h.Schemas.tmp}e.$fi=l,e.$gi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(t){return t.id===e.$gi}e.$hi=i;function a(t,n){return!E(t,n)&&!l(t)}e.$ii=a;function r(t){return(typeof t=="string"?(0,A.$oc)(t):(0,R.$ug)(t))===e.$bi}e.$ji=r}),define(ie[59],ne([0,1,15,8,55,46,2,84,4,21,167,115,5,6,25,30]),function(J,e,S,A,s,R,C,P,h,c,g,b,y,f,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S6b=e.$R6b=void 0,e.$R6b=(0,y.$Qh)("dialogMainService");let w=class{constructor(d,u){this.d=d,this.e=u,this.a=new Map,this.b=new Map,this.c=new A.$2g}pickFileFolder(d,u){return this.f({...d,pickFolders:!0,pickFiles:!0,title:(0,g.localize)(0,null)},u)}pickFolder(d,u){return this.f({...d,pickFolders:!0,title:(0,g.localize)(1,null)},u)}pickFile(d,u){return this.f({...d,pickFiles:!0,title:(0,g.localize)(2,null)},u)}pickWorkspace(d,u){const E=(0,g.localize)(3,null),l=(0,R.$Cv)((0,g.localize)(4,null)),i=m.$ci;return this.f({...d,pickFiles:!0,title:E,filters:i,buttonLabel:l},u)}async f(d,u){const E={title:d.title,buttonLabel:d.buttonLabel,filters:d.filters,defaultPath:d.defaultPath};(typeof d.pickFiles=="boolean"||typeof d.pickFolders=="boolean")&&(E.properties=void 0,d.pickFiles&&d.pickFolders&&(E.properties=["multiSelections","openDirectory","openFile","createDirectory"])),E.properties||(E.properties=["multiSelections",d.pickFolders?"openDirectory":"openFile","createDirectory"]),h.$k&&E.properties.push("treatPackageAsDirectory");const l=await this.showOpenDialog(E,(u||S.BrowserWindow.getFocusedWindow())??void 0);if(l&&l.filePaths&&l.filePaths.length>0)return l.filePaths}g(d){if(d){let u=this.b.get(d.id);return u||(u=new A.$2g,this.b.set(d.id,u)),u}else return this.c}showMessageBox(d,u){return this.g(u).queue(async()=>{const{options:E,buttonIndeces:l}=(0,b.$Jv)(d,this.e);let i;return u?i=await S.dialog.showMessageBox(u,E):i=await S.dialog.showMessageBox(E),{response:l[i.response],checkboxChecked:i.checkboxChecked}})}async showSaveDialog(d,u){const E=this.j(d,u);if(!E)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.g(u).queue(async()=>{let l;return u?l=await S.dialog.showSaveDialog(u,d):l=await S.dialog.showSaveDialog(d),l.filePath=this.h(l.filePath),l})}finally{(0,C.$Nc)(E)}}h(d){return d&&h.$k&&(d=(0,P.$pl)(d)),d}i(d){return d.map(u=>this.h(u))}async showOpenDialog(d,u){d.defaultPath&&(await c.Promises.exists(d.defaultPath)||(d.defaultPath=void 0));const E=this.j(d,u);if(!E)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(u).queue(async()=>{let l;return u?l=await S.dialog.showOpenDialog(u,d):l=await S.dialog.showOpenDialog(d),l.filePaths=this.i(l.filePaths),l})}finally{(0,C.$Nc)(E)}}j(d,u){if(!u)return C.$Sc.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",d);let E=this.a.get(u.id);E||(E=new Set,this.a.set(u.id,E));const l=(0,s.$Ei)(d);if(!E.has(l))return this.d.trace("[DialogMainService]: new file dialog lock created",d),E.add(l),(0,C.$Qc)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",d),E?.delete(l),E?.size===0&&this.a.delete(u.id)})}};e.$S6b=w,e.$S6b=w=Ee([te(0,f.$$i),te(1,v.$qj)],w)}),define(ie[275],ne([0,1,3,2,76,30]),function(J,e,S,A,s,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q7b=void 0;class C extends A.$Sc{static{this.a=100}constructor(h,c){super(),this.f=h,this.g=c,this.b=this.B(new S.$Od),this.c=new Map,this.h(c.applicationStorage,this.b)}h(h,c){this.B(S.Event.debounce(h.onDidChangeStorage,(g,b)=>(g?g.push(b):g=[b],g),C.a)(g=>{g.length&&c.fire(this.j(g,h))}))}j(h,c){const g=new Map,b=new Set;return h.forEach(y=>{const f=c.get(y.key);typeof f=="string"?g.set(y.key,f):b.add(y.key)}),{changed:Array.from(g.entries()),deleted:Array.from(b.values())}}listen(h,c,g){switch(c){case"onDidChangeStorage":{const b=g.profile?(0,s.$nh)(g.profile):void 0;if(!b)return this.b.event;let y=this.c.get(b.id);return y||(y=this.B(new S.$Od),this.h(this.g.profileStorage(b),y),this.c.set(b.id,y)),y.event}}throw new Error(`Event not found: ${c}`)}async call(h,c,g){const b=g.profile?(0,s.$nh)(g.profile):void 0,y=(0,R.$7h)(g.workspace),f=await this.m(b,y);switch(c){case"getItems":return Array.from(f.items.entries());case"updateItems":{const v=g;if(v.insert)for(const[m,w]of v.insert)f.set(m,w);v.delete?.forEach(m=>f.delete(m));break}case"optimize":return f.optimize();case"isUsed":{const v=g.payload;if(typeof v=="string")return this.g.isUsed(v)}default:throw new Error(`Call not found: ${c}`)}}async m(h,c){let g;c?g=this.g.workspaceStorage(c):h?g=this.g.profileStorage(h):g=this.g.applicationStorage;try{await g.init()}catch(b){this.f.error(`StorageIPC#init: Unable to init ${c?"workspace":h?"profile":"application"} storage due to ${b}`)}return g}}e.$Q7b=C}),define(ie[41],ne([0,1,55,3,2,19,7,189,36,16,5,6,30,31,40,8,32,27,12]),function(J,e,S,A,s,R,C,P,h,c,g,b,y,f,v,m,w,$,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pk=e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.ProfileResourceType=void 0;var u;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState"})(u||(e.ProfileResourceType=u={}));function E(t){const n=t;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&C.URI.isUri(n.location)&&C.URI.isUri(n.globalStorageHome)&&C.URI.isUri(n.settingsResource)&&C.URI.isUri(n.keybindingsResource)&&C.URI.isUri(n.tasksResource)&&C.URI.isUri(n.snippetsHome)&&C.URI.isUri(n.extensionsResource))}e.$Kk=E,e.$Lk=(0,g.$Qh)("IUserDataProfilesService");function l(t,n){return{id:t.id,isDefault:t.isDefault,name:t.name,shortName:t.shortName,icon:t.icon,location:C.URI.revive(t.location).with({scheme:n}),globalStorageHome:C.URI.revive(t.globalStorageHome).with({scheme:n}),settingsResource:C.URI.revive(t.settingsResource).with({scheme:n}),keybindingsResource:C.URI.revive(t.keybindingsResource).with({scheme:n}),tasksResource:C.URI.revive(t.tasksResource).with({scheme:n}),snippetsHome:C.URI.revive(t.snippetsHome).with({scheme:n}),extensionsResource:C.URI.revive(t.extensionsResource).with({scheme:n}),cacheHome:C.URI.revive(t.cacheHome).with({scheme:n}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}e.$Mk=l;function i(t,n,o,p,O,D){return{id:t,name:n,location:o,isDefault:!1,shortName:O?.shortName,icon:O?.icon,globalStorageHome:D&&O?.useDefaultFlags?.globalState?D.globalStorageHome:(0,R.$wg)(o,"globalStorage"),settingsResource:D&&O?.useDefaultFlags?.settings?D.settingsResource:(0,R.$wg)(o,"settings.json"),keybindingsResource:D&&O?.useDefaultFlags?.keybindings?D.keybindingsResource:(0,R.$wg)(o,"keybindings.json"),tasksResource:D&&O?.useDefaultFlags?.tasks?D.tasksResource:(0,R.$wg)(o,"tasks.json"),snippetsHome:D&&O?.useDefaultFlags?.snippets?D.snippetsHome:(0,R.$wg)(o,"snippets"),extensionsResource:D&&O?.useDefaultFlags?.extensions?D.extensionsResource:(0,R.$wg)(o,"extensions.json"),cacheHome:(0,R.$wg)(p,t),useDefaultFlags:O?.useDefaultFlags,isTransient:O?.transient}}e.$Nk=i;let a=class extends s.$Sc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(n,o,p,O){super(),this.t=n,this.u=o,this.w=p,this.y=O,this.f=!0,this.h=this.B(new A.$Od),this.onDidChangeProfiles=this.h.event,this.j=this.B(new A.$Od),this.onWillCreateProfile=this.j.event,this.m=this.B(new A.$Od),this.onWillRemoveProfile=this.m.event,this.n=this.B(new A.$Od),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new f.$Ac,emptyWindows:new Map},this.profilesHome=(0,R.$wg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,R.$wg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(n){this.f!==n&&(this.z=void 0,this.f=n)}isEnabled(){return this.f}get C(){if(!this.z){const n=this.D(),o=[n];if(this.f)try{for(const D of this.O()){if(!D.name||!(0,d.$zf)(D.name)||!D.location){this.y.warn("Skipping the invalid stored profile",D.location||D.name);continue}o.push(i((0,R.$tg)(D.location),D.name,D.location,this.g,{shortName:D.shortName,icon:D.icon,useDefaultFlags:D.useDefaultFlags},n))}}catch(D){this.y.error(D)}const p=new f.$Ac,O=new Map;if(o.length)try{const D=this.Q();if(D.workspaces)for(const[k,I]of Object.entries(D.workspaces)){const j=C.URI.parse(k),U=o.find(z=>z.id===I);U&&p.set(j,U)}if(D.emptyWindows)for(const[k,I]of Object.entries(D.emptyWindows)){const j=o.find(U=>U.id===I);j&&O.set(k,j)}}catch(D){this.y.error(D)}this.z={profiles:o,workspaces:p,emptyWindows:O}}return this.z}D(){const n=i("__default__profile__",(0,P.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...n,extensionsResource:this.S()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const o="Temp",p=new RegExp(`${(0,$.$Ge)(o)}\\s(\\d+)`);let O=0;for(const k of this.profiles){const I=p.exec(k.name),j=I?parseInt(I[1]):0;O=j>O?j:O}const D=`${o} ${O+1}`;return this.createProfile((0,S.$Ei)((0,w.$fg)()).toString(16),D,{transient:!0},n)}async createNamedProfile(n,o,p){return this.createProfile((0,S.$Ei)((0,w.$fg)()).toString(16),n,o,p)}async createProfile(n,o,p,O){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const D=await this.F(n,o,p);return O&&await this.setProfileForWorkspace(O,D),D}async F(n,o,p){if(!(0,d.$zf)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let O=this.r.get(o);return O||(O=(async()=>{try{const D=this.profiles.find(j=>j.name===o||j.id===n);if(D)return D;const k=i(n,o,(0,R.$wg)(this.profilesHome,n),this.g,p,this.defaultProfile);await this.u.createFolder(k.location);const I=[];return this.j.fire({profile:k,join(j){I.push(j)}}),await m.Promises.settled(I),this.I([k],[],[]),k}finally{this.r.delete(o)}})(),this.r.set(o,O)),O}async updateProfile(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let p=this.profiles.find(O=>O.id===n.id);if(!p)throw new Error(`Profile '${n.name}' does not exist`);return p=i(p.id,o.name??p.name,p.location,this.g,{shortName:o.shortName??p.shortName,icon:o.icon===null?void 0:o.icon??p.icon,transient:o.transient??p.isTransient,useDefaultFlags:o.useDefaultFlags??p.useDefaultFlags},this.defaultProfile),this.I([],[],[p]),p}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(O=>O.id===n.id);if(!o)throw new Error(`Profile '${n.name}' does not exist`);const p=[];this.m.fire({profile:o,join(O){p.push(O)}});try{await Promise.allSettled(p)}catch(O){this.y.error(O)}for(const O of[...this.C.emptyWindows.keys()])o.id===this.C.emptyWindows.get(O)?.id&&this.C.emptyWindows.delete(O);for(const O of[...this.C.workspaces.keys()])o.id===this.C.workspaces.get(O)?.id&&this.C.workspaces.delete(O);this.M(),this.I([],[o],[]);try{await this.u.del(o.cacheHome,{recursive:!0})}catch(O){(0,c.$qk)(O)!==1&&this.y.error(O)}}async setProfileForWorkspace(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const p=this.profiles.find(O=>O.id===o.id);if(!p)throw new Error(`Profile '${o.name}' does not exist`);this.L(n,p)}unsetWorkspace(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(n,void 0,o)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const n=await this.u.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(o=>o.isDirectory&&this.profiles.every(p=>!this.w.extUri.isEqual(p.location,o.resource))).map(o=>this.u.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.s.profiles.filter(o=>!this.H(o));await Promise.allSettled(n.map(o=>this.removeProfile(o)))}getProfileForWorkspace(n){const o=this.G(n);return C.URI.isUri(o)?this.s.workspaces.get(o)??this.C.workspaces.get(o):this.s.emptyWindows.get(o)??this.C.emptyWindows.get(o)}G(n){return(0,y.$1h)(n)?n.uri:(0,y.$6h)(n)?n.configPath:n.id}H(n){return!!([...this.s.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,n.location))||[...this.s.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,n.location))||[...this.C.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,n.location))||[...this.C.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,n.location)))}I(n,o,p){const O=[...this.profiles,...n],D=[];this.s.profiles=[];for(let k of O)k.isDefault||o.some(I=>k.id===I.id)||(k=p.find(I=>k.id===I.id)??k,k.isTransient?this.s.profiles.push(k):D.push({location:k.location,name:k.name,shortName:k.shortName,icon:k.icon,useDefaultFlags:k.useDefaultFlags}));this.P(D),this.z=void 0,this.J(n,o,p)}J(n,o,p){this.h.fire({added:n,removed:o,updated:p,all:this.profiles})}L(n,o,p){p=o?.isTransient?!0:p,p||this.L(n,void 0,!0);const O=this.G(n),D=p?this.s:this.C;C.URI.isUri(O)?(D.workspaces.delete(O),o&&D.workspaces.set(O,o)):(D.emptyWindows.delete(O),o&&D.emptyWindows.set(O,o)),p||this.M()}M(){const n={};for(const[p,O]of this.C.workspaces.entries())n[p.toString()]=O.id;const o={};for(const[p,O]of this.C.emptyWindows.entries())o[p.toString()]=O.id;this.R({workspaces:n,emptyWindows:o}),this.z=void 0}N(n){const o={},p=this.D();if(n.workspaces)for(const[D,k]of Object.entries(n.workspaces)){const I=C.URI.parse(k);o[D]=this.w.extUri.isEqual(I,p.location)?p.id:this.w.extUri.basename(I)}const O={};if(n.emptyWindows)for(const[D,k]of Object.entries(n.emptyWindows)){const I=C.URI.parse(k);O[D]=this.w.extUri.isEqual(I,p.location)?p.id:this.w.extUri.basename(I)}return{workspaces:o,emptyWindows:O}}O(){return[]}P(n){throw new Error("not implemented")}Q(){return{}}R(n){throw new Error("not implemented")}S(){}};e.$Ok=a,e.$Ok=a=Ee([te(0,h.$Xh),te(1,c.$_j),te(2,v.$Jk),te(3,b.$$i)],a);class r extends a{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(n){this.a=n}Q(){return this.X}R(n){this.X=n}}e.$Pk=r}),define(ie[80],ne([0,1,8,17,2,3,31,7,117,123,16,5,6,41,40,12,14,26]),function(J,e,S,A,s,R,C,P,h,c,g,b,y,f,v,m,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zp=e.$yp=e.$xp=e.ExtensionsProfileScanningErrorCode=void 0;var d;(function(a){a.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",a.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(d||(e.ExtensionsProfileScanningErrorCode=d={}));class u extends Error{constructor(r,t){super(r),this.code=t}}e.$xp=u,e.$yp=(0,b.$Qh)("IExtensionsProfileScannerService");let E=class extends s.$Sc{constructor(r,t,n,o,p,O){super(),this.j=r,this.m=t,this.n=n,this.r=o,this.s=p,this.t=O,this.b=this.B(new R.$Od),this.onAddExtensions=this.b.event,this.c=this.B(new R.$Od),this.onDidAddExtensions=this.c.event,this.f=this.B(new R.$Od),this.onRemoveExtensions=this.f.event,this.g=this.B(new R.$Od),this.onDidRemoveExtensions=this.g.event,this.h=new C.$Ac}scanProfileExtensions(r,t){return this.u(r,void 0,t)}async addExtensionsToProfile(r,t){const n=[],o=[];try{return await this.u(t,p=>{const O=[];for(const D of p)r.some(([k])=>(0,c.$Do)(k.identifier,D.identifier)&&k.manifest.version!==D.version)?n.push(D):O.push(D);for(const[D,k]of r){const I=O.findIndex(U=>(0,c.$Do)(U.identifier,D.identifier)&&U.version===D.manifest.version),j={identifier:D.identifier,version:D.manifest.version,location:D.location,metadata:k};I===-1?(o.push(j),O.push(j)):O.splice(I,1,j)}return o.length&&this.b.fire({extensions:o,profileLocation:t}),n.length&&this.f.fire({extensions:n,profileLocation:t}),O}),o.length&&this.c.fire({extensions:o,profileLocation:t}),n.length&&this.g.fire({extensions:n,profileLocation:t}),o}catch(p){throw o.length&&this.c.fire({extensions:o,error:p,profileLocation:t}),n.length&&this.g.fire({extensions:n,error:p,profileLocation:t}),p}}async updateMetadata(r,t){const n=[];return await this.u(t,o=>{const p=[];for(const O of o){const D=r.find(([k])=>(0,c.$Do)(k.identifier,O.identifier)&&k.manifest.version===O.version);D&&(O.metadata={...O.metadata,...D[1]},n.push(O)),p.push(O)}return p}),n}async removeExtensionFromProfile(r,t){const n=[];try{await this.u(t,o=>{const p=[];for(const O of o)(0,c.$Do)(O.identifier,r.identifier)?n.push(O):p.push(O);return n.length&&this.f.fire({extensions:n,profileLocation:t}),p}),n.length&&this.g.fire({extensions:n,profileLocation:t})}catch(o){throw n.length&&this.g.fire({extensions:n,error:o,profileLocation:t}),o}}async u(r,t,n){return this.F(r).queue(async()=>{let o=[],p;try{const O=await this.m.readFile(r);p=JSON.parse(O.value.toString().trim()||"[]")}catch(O){if((0,g.$qk)(O)!==1)throw O;if(this.r.extUri.isEqual(r,this.n.defaultProfile.extensionsResource)&&(p=await this.D()),!p&&n?.bailOutWhenFileNotFound)throw new u((0,w.$0)(O),"ERROR_PROFILE_NOT_FOUND")}if(p){Array.isArray(p)||this.w(r);let O=!1;for(const D of p){l(D)||this.w(r);let k;if((0,m.$zf)(D.relativeLocation)&&D.relativeLocation)k=this.z(D.relativeLocation);else if((0,m.$zf)(D.location))k=this.z(D.location),O=!0,D.relativeLocation=D.location,D.location=k.toJSON();else{k=P.URI.revive(D.location);const I=this.y(k);I&&(O=!0,D.relativeLocation=I)}o.push({identifier:D.identifier,location:k,version:D.version,metadata:D.metadata})}O&&await this.m.writeFile(r,A.$ce.fromString(JSON.stringify(p)))}if(t){o=t(o);const O=o.map(D=>({identifier:D.identifier,version:D.version,location:D.location.toJSON(),relativeLocation:this.y(D.location),metadata:D.metadata}));await this.m.writeFile(r,A.$ce.fromString(JSON.stringify(O)))}return o})}w(r){const t=new u(`Invalid extensions content in ${r.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:t.code}),t}y(r){return this.r.extUri.isEqual(this.r.extUri.dirname(r),this.j)?this.r.extUri.basename(r):void 0}z(r){return this.r.extUri.joinPath(this.j,r)}async D(){return this.C||(this.C=(async()=>{const r=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),t=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let n;try{n=(await this.m.readFile(r)).value.toString()}catch(p){if((0,g.$qk)(p)===1)return;throw p}this.t.info("Migrating extensions from old default profile location",r.toString());let o;try{const p=JSON.parse(n);Array.isArray(p)&&p.every(O=>l(O))?o=p:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",p)}catch(p){this.t.error(p)}if(o)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,A.$ce.fromString(JSON.stringify(o)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",r.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(p){if((0,g.$qk)(p)===3)this.t.info("Migration from old default profile location to new location is done by another window",r.toString(),this.n.defaultProfile.extensionsResource.toString());else throw p}try{await this.m.del(r)}catch(p){(0,g.$qk)(p)!==1&&this.t.error(p)}try{await this.m.del(t)}catch(p){(0,g.$qk)(p)!==1&&this.t.error(p)}return o})()),this.C}F(r){let t=this.h.get(r);return t||(t=new S.$2g,this.h.set(r,t)),t}};e.$zp=E,e.$zp=E=Ee([te(1,g.$_j),te(2,f.$Lk),te(3,v.$Jk),te(4,$.$dl),te(5,y.$$i)],E);function l(a){return(0,m.$Bf)(a)&&(0,h.$ao)(a.identifier)&&(i(a.location)||(0,m.$zf)(a.location)&&a.location)&&((0,m.$Gf)(a.relativeLocation)||(0,m.$zf)(a.relativeLocation))&&a.version&&(0,m.$zf)(a.version)}function i(a){return a?(0,m.$zf)(a.path)&&(0,m.$zf)(a.scheme):!1}}),define(ie[129],ne([0,1,23,8,37,17,14,44,152,2,13,9,4,19,205,73,12,7,172,36,123,120,204,16,5,6,25,3,76,80,41,40,203]),function(J,e,S,A,s,R,C,P,h,c,g,b,y,f,v,m,w,$,d,u,E,l,i,a,r,t,n,o,p,O,D,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gp=e.$Fp=e.$Ep=e.$Dp=e.$Cp=e.Translations=void 0;var j;(function(ce){function Y(K,Q){if(K===Q)return!0;const q=Object.keys(K),W=new Set;for(const G of Object.keys(Q))W.add(G);if(q.length!==W.size)return!1;for(const G of q){if(K[G]!==Q[G])return!1;W.delete(G)}return W.size===0}ce.equals=Y})(j||(e.Translations=j={})),e.$Cp=(0,r.$Qh)("IExtensionsScannerService");let U=class extends c.$Sc{constructor(Y,K,Q,q,W,G,H,X,re,L,M,N){super(),this.systemExtensionsLocation=Y,this.userExtensionsLocation=K,this.r=Q,this.s=q,this.t=W,this.u=G,this.w=H,this.y=X,this.z=re,this.C=L,this.D=M,this.F=N,this.g=this.B(new o.$Od),this.onDidChangeCache=this.g.event,this.h=(0,f.$wg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(Z,this.s,this.h)),this.m=this.B(this.F.createInstance(Z,this.s,this.h)),this.n=this.B(this.F.createInstance(x,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,E.$Oo)(this.w,this.y)),this.G}async scanAllExtensions(Y,K,Q){const[q,W]=await Promise.all([this.scanSystemExtensions(Y),this.scanUserExtensions(K)]),G=Q?await this.scanExtensionsUnderDevelopment(Y,[...q,...W]):[];return this.L(q,W,G,await this.getTargetPlatform(),!0)}async scanSystemExtensions(Y){const K=[];K.push(this.M(!!Y.useCache,Y.language)),K.push(this.N(Y.language,!!Y.checkControlFile));const[Q,q]=await Promise.all(K);return this.J([...Q,...q],0,Y,!1)}async scanUserExtensions(Y){const K=Y.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",K);const Q=this.D.extUri.isEqual(Y.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,q=await this.P(K,!!Y.profileLocation,1,!Y.includeUninstalled,Y.language,!0,Q),W=Y.useCache&&!q.devMode&&q.excludeObsolete?this.m:this.n;let G;try{G=await W.scanExtensions(q)}catch(H){if(H instanceof O.$xp&&H.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),G=await W.scanExtensions(q);else throw H}return G=await this.J(G,1,Y,!0),this.y.trace("Scanned user extensions:",G.length),G}async scanExtensionsUnderDevelopment(Y,K){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const Q=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(q=>q.scheme===g.Schemas.file).map(async q=>{const W=await this.P(q,!1,1,!0,Y.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(W)).map(H=>(H.type=K.find(X=>(0,E.$Do)(X.identifier,H.identifier))?.type??H.type,this.n.validate(H,W)))}))).flat();return this.J(Q,"development",Y,!0)}return[]}async scanExistingExtension(Y,K,Q){const q=await this.P(Y,!1,K,!0,Q.language,!0,void 0),W=await this.n.scanExtension(q);return!W||!Q.includeInvalid&&!W.isValid?null:W}async scanOneOrMultipleExtensions(Y,K,Q){const q=await this.P(Y,!1,K,!0,Q.language,!0,void 0),W=await this.n.scanOneOrMultipleExtensions(q);return this.J(W,K,Q,!0)}async scanMetadata(Y){const K=(0,f.$wg)(Y,"package.json"),Q=(await this.w.readFile(K)).value.toString();return JSON.parse(Q).__metadata}async updateMetadata(Y,K){const Q=(0,f.$wg)(Y,"package.json"),q=(await this.w.readFile(Q)).value.toString(),W=JSON.parse(q);K.isMachineScoped===!1&&delete K.isMachineScoped,K.isBuiltin===!1&&delete K.isBuiltin,W.__metadata={...W.__metadata,...K},await this.w.writeFile((0,f.$wg)(Y,"package.json"),R.$ce.fromString(JSON.stringify(W,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(Y){if(Y instanceof O.$xp&&Y.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw Y}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const Y=await this.scanUserExtensions({includeInvalid:!0});if(Y.length)await this.u.addExtensionsToProfile(Y.map(K=>[K,K.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,R.$ce.fromString(JSON.stringify([])))}catch(K){(0,a.$qk)(K)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,C.$0)(K))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(Y){this.y.error(Y)}finally{this.H=void 0}})()),this.H}async J(Y,K,Q,q){return Q.includeAllVersions||(Y=this.L(K===0?Y:void 0,K===1?Y:void 0,K==="development"?Y:void 0,await this.getTargetPlatform(),q)),Q.includeInvalid||(Y=Y.filter(W=>W.isValid)),Y.sort((W,G)=>{const H=b.$nc(W.location.fsPath),X=b.$nc(G.location.fsPath);return H<X?-1:H>X?1:0})}L(Y,K,Q,q,W){const G=(X,re,L)=>{if(X.isValid&&!re.isValid)return!1;if(X.isValid===re.isValid){if(W&&v.gt(X.manifest.version,re.manifest.version))return this.y.debug(`Skipping extension ${re.location.path} with lower version ${re.manifest.version} in favour of ${X.location.path} with version ${X.manifest.version}`),!1;if(v.eq(X.manifest.version,re.manifest.version)){if(X.type===0)return this.y.debug(`Skipping extension ${re.location.path} in favour of system extension ${X.location.path} with same version`),!1;if(X.targetPlatform===q)return this.y.debug(`Skipping extension ${re.location.path} from different target platform ${re.targetPlatform}`),!1}}return L?this.y.warn(`Overwriting user extension ${X.location.path} with ${re.location.path}.`):this.y.debug(`Overwriting user extension ${X.location.path} with ${re.location.path}.`),!0},H=new l.$9l;return Y?.forEach(X=>{const re=H.get(X.identifier.id);(!re||G(re,X,!1))&&H.set(X.identifier.id,X)}),K?.forEach(X=>{const re=H.get(X.identifier.id);if(!re&&Y&&X.type===0){this.y.debug(`Skipping obsolete system extension ${X.location.path}.`);return}(!re||G(re,X,!1))&&H.set(X.identifier.id,X)}),Q?.forEach(X=>{const re=H.get(X.identifier.id);(!re||G(re,X,!0))&&H.set(X.identifier.id,X),H.set(X.identifier.id,X)}),[...H.values()]}async M(Y,K){this.y.trace("Started scanning system extensions");const Q=await this.P(this.systemExtensionsLocation,!1,0,!0,K,!0,void 0),W=await(Y&&!Q.devMode?this.j:this.n).scanExtensions(Q);return this.y.trace("Scanned system extensions:",W.length),W}async N(Y,K){const Q=this.z.isBuilt?[]:this.C.builtInExtensions;if(!Q?.length)return[];this.y.trace("Started scanning dev system extensions");const q=K?await this.O():{},W=[],G=$.URI.file(b.$hc(b.$jc(g.$dg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const X of Q){const re=q[X.name]||"marketplace";switch(re){case"disabled":break;case"marketplace":W.push((0,f.$wg)(G,X.name));break;default:W.push($.URI.file(re));break}}const H=await Promise.all(W.map(async X=>this.n.scanExtension(await this.P(X,!1,0,!0,Y,!0,void 0))));return this.y.trace("Scanned dev system extensions:",H.length),(0,S.$Hb)(H)}async O(){try{const Y=await this.w.readFile(this.r);return JSON.parse(Y.value.toString())}catch{return{}}}async P(Y,K,Q,q,W,G,H){const X=await this.f(W??y.$w),re=await this.Q(Y),L=K&&!this.D.extUri.isEqual(Y,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,M=L?await this.Q(L):void 0;return new z(Y,re,L,M,K,H,Q,q,G,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,W,X)}async Q(Y){try{const K=await this.w.stat(Y);if(typeof K.mtime=="number")return K.mtime}catch{}}};e.$Dp=U,e.$Dp=U=Ee([te(4,D.$Lk),te(5,O.$yp),te(6,a.$_j),te(7,t.$$i),te(8,u.$Xh),te(9,n.$qj),te(10,k.$Jk),te(11,r.$Ph)],U);class z{constructor(Y,K,Q,q,W,G,H,X,re,L,M,N,T,F,B){this.location=Y,this.mtime=K,this.applicationExtensionslocation=Q,this.applicationExtensionslocationMtime=q,this.profile=W,this.profileScanOptions=G,this.type=H,this.excludeObsolete=X,this.validate=re,this.productVersion=L,this.productDate=M,this.productCommit=N,this.devMode=T,this.language=F,this.translations=B}static createNlsConfiguration(Y){return{language:Y.language,pseudo:Y.language==="pseudo",devMode:Y.devMode,translations:Y.translations}}static equals(Y,K){return(0,f.$pg)(Y.location,K.location)&&Y.mtime===K.mtime&&(0,f.$pg)(Y.applicationExtensionslocation,K.applicationExtensionslocation)&&Y.applicationExtensionslocationMtime===K.applicationExtensionslocationMtime&&Y.profile===K.profile&&s.$_m(Y.profileScanOptions,K.profileScanOptions)&&Y.type===K.type&&Y.excludeObsolete===K.excludeObsolete&&Y.validate===K.validate&&Y.productVersion===K.productVersion&&Y.productDate===K.productDate&&Y.productCommit===K.productCommit&&Y.devMode===K.devMode&&Y.language===K.language&&j.equals(Y.translations,K.translations)}}e.$Ep=z;let x=class extends c.$Sc{constructor(Y,K,Q,q,W){super(),this.f=Y,this.g=K,this.h=Q,this.j=q,this.m=W}async scanExtensions(Y){const K=Y.profile?await this.r(Y):await this.n(Y);let Q={};if(Y.excludeObsolete&&Y.type===1)try{const q=(await this.j.readFile(this.f)).value.toString();Q=JSON.parse(q)}catch{}return(0,w.$Mf)(Q)?K:K.filter(q=>!Q[E.$Eo.create(q).toString()])}async n(Y){const K=await this.j.resolve(Y.location);if(!K.children?.length)return[];const Q=await Promise.all(K.children.map(async q=>{if(!q.isDirectory||Y.type===1&&(0,f.$tg)(q.resource).indexOf(".")===0)return null;const W=new z(q.resource,Y.mtime,Y.applicationExtensionslocation,Y.applicationExtensionslocationMtime,Y.profile,Y.profileScanOptions,Y.type,Y.excludeObsolete,Y.validate,Y.productVersion,Y.productDate,Y.productCommit,Y.devMode,Y.language,Y.translations);return this.scanExtension(W)}));return(0,S.$Hb)(Q).sort((q,W)=>q.location.path<W.location.path?-1:1)}async r(Y){let K=await this.s(Y.location,()=>!0,Y);if(Y.applicationExtensionslocation&&!this.h.extUri.isEqual(Y.location,Y.applicationExtensionslocation)){K=K.filter(q=>!q.metadata?.isApplicationScoped);const Q=await this.s(Y.applicationExtensionslocation,q=>!!q.metadata?.isBuiltin||!!q.metadata?.isApplicationScoped,Y);K.push(...Q)}return K}async s(Y,K,Q){const q=await this.g.scanProfileExtensions(Y,Q.profileScanOptions);if(!q.length)return[];const W=await Promise.all(q.map(async G=>{if(K(G)){const H=new z(G.location,Q.mtime,Q.applicationExtensionslocation,Q.applicationExtensionslocationMtime,Q.profile,Q.profileScanOptions,Q.type,Q.excludeObsolete,Q.validate,Q.productVersion,Q.productDate,Q.productCommit,Q.devMode,Q.language,Q.translations);return this.scanExtension(H,G.metadata)}return null}));return(0,S.$Hb)(W)}async scanOneOrMultipleExtensions(Y){try{if(await this.j.exists((0,f.$wg)(Y.location,"package.json"))){const K=await this.scanExtension(Y);return K?[K]:[]}else return await this.scanExtensions(Y)}catch(K){return this.m.error(`Error scanning extensions at ${Y.location.path}:`,(0,C.$0)(K)),[]}}async scanExtension(Y,K){try{let Q=await this.scanExtensionManifest(Y.location);if(Q){Q.publisher||(Q.publisher=l.$3l),K=K??Q.__metadata,delete Q.__metadata;const q=(0,E.$Io)(Q.publisher,Q.name),W=K?.id?{id:q,uuid:K.id}:{id:q},G=K?.isSystem?0:Y.type,H=G===0||!!K?.isBuiltin;Q=await this.t(Y.location,Q,z.createNlsConfiguration(Y));const X={type:G,identifier:W,manifest:Q,location:Y.location,isBuiltin:H,targetPlatform:K?.targetPlatform??"undefined",metadata:K,isValid:!0,validations:[]};return Y.validate?this.validate(X,Y):X}}catch(Q){Y.type!==0&&this.m.error(Q)}return null}validate(Y,K){let Q=!0;const q=(0,i.$To)(K.productVersion,K.productDate,K.location,Y.manifest,Y.isBuiltin);for(const[W,G]of q)W===m.default.Error&&(Q=!1,this.m.error(this.z(K.location,G)));return Y.isValid=Q,Y.validations=q,Y}async scanExtensionManifest(Y){const K=(0,f.$wg)(Y,"package.json");let Q;try{Q=(await this.j.readFile(K)).value.toString()}catch(W){return(0,a.$qk)(W)!==1&&this.m.error(this.z(Y,(0,d.localize)(0,null,K.path,W.message))),null}let q;try{q=JSON.parse(Q)}catch{const G=[];(0,P.$Xm)(Q,G);for(const H of G)this.m.error(this.z(Y,(0,d.localize)(1,null,K.path,H.offset,H.length,(0,h.$Ap)(H.error))));return null}return(0,P.$7m)(q)!=="object"?(this.m.error(this.z(Y,(0,d.localize)(2,null,K.path))),null):q}async t(Y,K,Q){const q=await this.u(Y,K,Q);if(q)try{const W=[],G=await this.w(q.default,W);if(W.length>0)return W.forEach(X=>{this.m.error(this.z(Y,(0,d.localize)(3,null,q.default?.path,(0,h.$Ap)(X.error))))}),K;if((0,P.$7m)(q)!=="object")return this.m.error(this.z(Y,(0,d.localize)(4,null,q.default?.path))),K;const H=q.values||Object.create(null);return(0,I.$Bp)(this.m,K,H,G)}catch{}return K}async u(Y,K,Q){const q=(0,f.$wg)(Y,"package.nls.json"),W=(re,L)=>{L.forEach(M=>{this.m.error(this.z(Y,(0,d.localize)(5,null,re?.path,(0,h.$Ap)(M.error))))})},G=re=>{this.m.error(this.z(Y,(0,d.localize)(6,null,re?.path)))},H=`${K.publisher}.${K.name}`,X=Q.translations[H];if(X)try{const re=$.URI.file(X),L=(await this.j.readFile(re)).value.toString(),M=[],N=(0,P.$Xm)(L,M);return M.length>0?(W(re,M),{values:void 0,default:q}):(0,P.$7m)(N)!=="object"?(G(re),{values:void 0,default:q}):{values:N.contents?N.contents.package:void 0,default:q}}catch{return{values:void 0,default:q}}else{if(!await this.j.exists(q))return;let L;try{L=await this.y(Y,Q)}catch{return}if(!L.localized)return{values:void 0,default:L.original};try{const M=(await this.j.readFile(L.localized)).value.toString(),N=[],T=(0,P.$Xm)(M,N);return N.length>0?(W(L.localized,N),{values:void 0,default:L.original}):(0,P.$7m)(T)!=="object"?(G(L.localized),{values:void 0,default:L.original}):{values:T,default:L.original}}catch{return{values:void 0,default:L.original}}}}async w(Y,K){if(Y)try{const Q=(await this.j.readFile(Y)).value.toString();return(0,P.$Xm)(Q,K)}catch{}}y(Y,K){return new Promise((Q,q)=>{const W=G=>{const H=(0,f.$wg)(Y,`package.nls.${G}.json`);this.j.exists(H).then(X=>{X&&Q({localized:H,original:(0,f.$wg)(Y,"package.nls.json")});const re=G.lastIndexOf("-");re===-1?Q({localized:(0,f.$wg)(Y,"package.nls.json"),original:null}):(G=G.substring(0,re),W(G))})};if(K.devMode||K.pseudo||!K.language)return Q({localized:(0,f.$wg)(Y,"package.nls.json"),original:null});W(K.language)})}z(Y,K){return`[${Y.path}]: ${K}`}};x=Ee([te(1,O.$yp),te(2,k.$Jk),te(3,a.$_j),te(4,t.$$i)],x);let Z=class extends x{constructor(Y,K,Q,q,W,G,H){super(K,q,W,G,H),this.G=Y,this.H=Q,this.D=this.B(new A.$Sg(3e3)),this.F=this.B(new o.$Od),this.onDidChangeCache=this.F.event}async scanExtensions(Y){const K=this.M(Y),Q=await this.I(K);if(this.C=Y,Q&&Q.input&&z.equals(Q.input,this.C))return this.m.debug("Using cached extensions scan result",Y.location.toString()),this.D.trigger(()=>this.L()),Q.result.map(W=>(W.location=$.URI.revive(W.location),W));const q=await super.scanExtensions(Y);return await this.J(K,{input:Y,result:q}),q}async I(Y){try{const K=await this.j.readFile(Y),Q=JSON.parse(K.value.toString());return{result:Q.result,input:(0,p.$nh)(Q.input)}}catch(K){this.m.debug("Error while reading the extension cache file:",Y.path,(0,C.$0)(K))}return null}async J(Y,K){try{await this.j.writeFile(Y,R.$ce.fromString(JSON.stringify(K)))}catch(Q){this.m.debug("Error while writing the extension cache file:",Y.path,(0,C.$0)(Q))}}async L(){if(!this.C)return;const Y=this.M(this.C),K=await this.I(Y);if(!K)return;const Q=K.result,q=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!s.$_m(q,Q))try{this.m.info("Invalidating Cache",Q,q),await this.j.del(Y),this.F.fire()}catch(W){this.m.error(W)}}M(Y){const K=this.N(Y);return this.h.extUri.joinPath(K.cacheHome,Y.type===0?l.$2l:l.$1l)}N(Y){return Y.type===0?this.H.defaultProfile:Y.profile?this.h.extUri.isEqual(Y.location,this.G.extensionsResource)?this.G:this.H.profiles.find(K=>this.h.extUri.isEqual(Y.location,K.extensionsResource))??this.G:this.H.defaultProfile}};Z=Ee([te(2,D.$Lk),te(3,O.$yp),te(4,k.$Jk),te(5,a.$_j),te(6,t.$$i)],Z);function ae(ce,Y){const K=(0,E.$Go)(ce.manifest.publisher,ce.manifest.name);return{id:K,identifier:new l.$7l(K),isBuiltin:ce.type===0,isUserBuiltin:ce.type===1&&ce.isBuiltin,isUnderDevelopment:Y,extensionLocation:ce.location,uuid:ce.identifier.uuid,targetPlatform:ce.targetPlatform,...ce.manifest}}e.$Fp=ae;class se extends U{constructor(Y,K,Q,q,W,G,H,X,re,L,M,N){super(Y,K,(0,f.$wg)(Q,".vscode-oss-dev","extensions","control.json"),q,W,G,H,X,re,L,M,N),this.R=(async()=>{if(y.$z)try{const T=await this.w.readFile($.URI.file(y.$z));return JSON.parse(T.value.toString())}catch{}return Object.create(null)})()}f(Y){return this.R}}e.$Gp=se}),define(ie[276],ne([0,1,6,41,40,26,80,16,36,7]),function(J,e,S,A,s,R,C,P,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MN=void 0;let g=class extends C.$zp{constructor(y,f,v,m,w,$){super(c.URI.file(y.extensionsPath),f,v,m,w,$)}};e.$MN=g,e.$MN=g=Ee([te(0,h.$Yh),te(1,P.$_j),te(2,A.$Lk),te(3,s.$Jk),te(4,R.$dl),te(5,S.$$i)],g)}),define(ie[277],ne([0,1,7,36,80,129,16,5,6,25,40,41]),function(J,e,S,A,s,R,C,P,h,c,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e8b=void 0;let y=class extends R.$Gp{constructor(v,m,w,$,d,u,E,l){super(S.URI.file(d.builtinExtensionsPath),S.URI.file(d.extensionsPath),d.userHome,v.defaultProfile,v,m,w,$,d,u,E,l)}};e.$e8b=y,e.$e8b=y=Ee([te(0,b.$Lk),te(1,s.$yp),te(2,C.$_j),te(3,h.$$i),te(4,A.$Yh),te(5,c.$qj),te(6,g.$Jk),te(7,P.$Ph)],y)}),define(ie[278],ne([0,1,15,2,13,9,4,56,7,32,38,36,6,41]),function(J,e,S,A,s,R,C,P,h,c,g,b,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w8b=void 0;let v=class extends A.$Sc{constructor(w,$,d){super(),this.c=w,this.f=d,this.a=P.$Wh.forPaths(!C.$l),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(w.appRoot),this.addValidFileRoot(w.extensionsPath),this.addValidFileRoot($.defaultProfile.globalStorageHome.with({scheme:s.Schemas.file}).fsPath),this.addValidFileRoot(w.workspaceStorageHome.with({scheme:s.Schemas.file}).fsPath),this.g()}g(){const{defaultSession:w}=S.session;w.protocol.registerFileProtocol(s.Schemas.vscodeFileResource,($,d)=>this.j($,d)),w.protocol.interceptFileProtocol(s.Schemas.file,($,d)=>this.h($,d)),this.B((0,A.$Qc)(()=>{w.protocol.unregisterProtocol(s.Schemas.vscodeFileResource),w.protocol.uninterceptProtocol(s.Schemas.file)}))}addValidFileRoot(w){const $=(0,R.$hc)(w);return this.a.get($)?A.$Sc.None:(this.a.set($,!0),(0,A.$Qc)(()=>this.a.delete($)))}h(w,$){const d=h.URI.parse(w.url);return this.f.error(`Refused to load resource ${d.fsPath} from ${s.Schemas.file}: protocol (original URL: ${w.url})`),$({error:-3})}j(w,$){const d=this.m(w);let u;return this.c.crossOriginIsolated&&((0,R.$nc)(d)==="workbench.html"||(0,R.$nc)(d)==="workbench-dev.html"?u=s.COI.CoopAndCoep:u=s.COI.getHeadersFromQuery(w.url)),this.a.findSubstr(d)?$({path:d,headers:u}):this.b.has((0,R.$oc)(d).toLowerCase())?$({path:d}):(this.f.error(`${s.Schemas.vscodeFileResource}: Refused to load resource ${d} from ${s.Schemas.vscodeFileResource}: protocol (original URL: ${w.url})`),$({error:-3}))}m(w){const $=h.URI.parse(w.url),d=s.$dg.uriToFileUri($);return(0,R.$hc)(d.fsPath)}createIPCObjectUrl(){let w;const $=h.URI.from({scheme:"vscode",path:(0,c.$fg)()}),d=$.toString(),u=async()=>w;return g.$uT.handle(d,u),this.f.trace(`IPC Object URL: Registered new channel ${d}.`),{resource:$,update:E=>w=E,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${d}.`),g.$uT.removeHandler(d)}}}};e.$w8b=v,e.$w8b=v=Ee([te(0,b.$Yh),te(1,f.$Lk),te(2,y.$$i)],v)}),define(ie[96],ne([0,1,8,3,2,65,12,111,5,41]),function(J,e,S,A,s,R,C,P,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$0o=e.$9o=e.$8o=void 0,e.$8o="__$__isNewStorageMarker",e.$9o="__$__targetStorageMarker",e.$0o=(0,h.$Qh)("storageService");var g;(function(d){d[d.NONE=0]="NONE",d[d.SHUTDOWN=1]="SHUTDOWN"})(g||(e.WillSaveStateReason=g={}));var b;(function(d){d[d.APPLICATION=-1]="APPLICATION",d[d.PROFILE=0]="PROFILE",d[d.WORKSPACE=1]="WORKSPACE"})(b||(e.StorageScope=b={}));var y;(function(d){d[d.USER=0]="USER",d[d.MACHINE=1]="MACHINE"})(y||(e.StorageTarget=y={}));function f(d){const u=d.get(e.$9o);if(u)try{return JSON.parse(u)}catch{}return Object.create(null)}e.$$o=f;class v extends s.$Sc{static{this.a=60*1e3}constructor(u={flushInterval:v.a}){super(),this.m=u,this.b=this.B(new A.$Rd),this.c=this.B(new A.$Rd),this.onDidChangeTarget=this.c.event,this.f=this.B(new A.$Od),this.onWillSaveState=this.f.event,this.h=this.B(new S.$7g(()=>this.n(),this.m.flushInterval)),this.j=this.B(new s.$Tc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(u,E,l){return A.Event.filter(this.b.event,i=>i.scope===u&&(E===void 0||i.key===E),l)}n(){this.j.value=(0,S.$$g)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,s.$Nc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.O()}finally{(0,R.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(u,E){const{key:l,external:i}=E;if(l===e.$9o){switch(u){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:u})}else this.b.fire({scope:u,key:l,target:this.J(u)[l],external:i})}w(u){this.f.fire({reason:u})}get(u,E,l){return this.P(E)?.get(u,l)}getBoolean(u,E,l){return this.P(E)?.getBoolean(u,l)}getNumber(u,E,l){return this.P(E)?.getNumber(u,l)}getObject(u,E,l){return this.P(E)?.getObject(u,l)}storeAll(u,E){this.y(()=>{for(const l of u)this.store(l.key,l.value,l.scope,l.target,E)})}store(u,E,l,i,a=!1){if((0,C.$If)(E)){this.remove(u,l,a);return}this.y(()=>{this.z(u,l,i),this.P(l)?.set(u,E,a)})}remove(u,E,l=!1){this.y(()=>{this.z(u,E,void 0),this.P(E)?.delete(u,l)})}y(u){this.b.pause(),this.c.pause();try{u()}finally{this.b.resume(),this.c.resume()}}keys(u,E){const l=[],i=this.J(u);for(const a of Object.keys(i))i[a]===E&&l.push(a);return l}z(u,E,l,i=!1){const a=this.J(E);typeof l=="number"?a[u]!==l&&(a[u]=l,this.P(E)?.set(e.$9o,JSON.stringify(a),i)):typeof a[u]=="number"&&(delete a[u],this.P(E)?.set(e.$9o,JSON.stringify(a),i))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(u){switch(u){case-1:return this.I;case 0:return this.G;default:return this.D}}L(u){const E=this.P(u);return E?f(E):Object.create(null)}isNew(u){return this.getBoolean(e.$8o,u)===!0}async flush(u=g.NONE){this.f.fire({reason:u});const E=this.P(-1),l=this.P(0),i=this.P(1);switch(u){case g.NONE:await S.Promises.settled([E?.whenFlushed()??Promise.resolve(),l?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case g.SHUTDOWN:await S.Promises.settled([E?.flush(0)??Promise.resolve(),l?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const u=this.P(-1)?.items??new Map,E=this.P(0)?.items??new Map,l=this.P(1)?.items??new Map;return $(u,E,l,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(u){return await this.flush(),this.P(u)?.optimize()}async switch(u,E){return this.w(g.NONE),(0,c.$Kk)(u)?this.R(u,E):this.S(u,E)}M(u,E){return!(u.id===E.id||m(E)&&m(u))}N(u,E,l){this.y(()=>{const i=new Set;for(const[a,r]of u)i.add(a),E.get(a)!==r&&this.u(l,{key:a,external:!0});for(const[a]of E.items)i.has(a)||this.u(l,{key:a,external:!0})})}}e.$_o=v;function m(d){return d.isDefault||!!d.useDefaultFlags?.globalState}e.$ap=m;class w extends v{constructor(){super(),this.U=this.B(new P.$6o(new P.$7o,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new P.$6o(new P.$7o,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new P.$6o(new P.$7o,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(u=>this.u(1,u))),this.B(this.W.onDidChangeStorage(u=>this.u(0,u))),this.B(this.U.onDidChangeStorage(u=>this.u(-1,u)))}P(u){switch(u){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(u){switch(u){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(u){return!1}}e.$bp=w;async function $(d,u,E,l,i,a){const r=j=>{try{return JSON.parse(j)}catch{return j}},t=new Map,n=new Map;d.forEach((j,U)=>{t.set(U,j),n.set(U,r(j))});const o=new Map,p=new Map;u.forEach((j,U)=>{o.set(U,j),p.set(U,r(j))});const O=new Map,D=new Map;E.forEach((j,U)=>{O.set(U,j),D.set(U,r(j))}),console.group(l!==i?`Storage: Application (path: ${l})`:`Storage: Application & Profile (path: ${l}, default profile)`);const k=[];if(t.forEach((j,U)=>{k.push({key:U,value:j})}),console.table(k),console.groupEnd(),console.log(n),l!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const j=[];o.forEach((U,z)=>{j.push({key:z,value:U})}),console.table(j),console.groupEnd(),console.log(p)}console.group(`Storage: Workspace (path: ${a})`);const I=[];O.forEach((j,U)=>{I.push({key:U,value:j})}),console.table(I),console.groupEnd(),console.log(D)}e.$cp=$}),define(ie[279],ne([0,1,23,8,3,2,9,72,7,21,111,161,6,96,26,30,13]),function(J,e,S,A,s,R,C,P,h,c,g,b,y,f,v,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E6b=e.$D6b=e.$C6b=e.$B6b=void 0;class $ extends R.$Sc{static{this.a=2e3}get storage(){return this.f}constructor(r,t){super(),this.m=r,this.n=t,this.b=this.B(new s.$Od),this.onDidChangeStorage=this.b.event,this.c=this.B(new s.$Od),this.onDidCloseStorage=this.c.event,this.f=this.B(new g.$6o(new g.$7o,{hint:g.StorageHint.STORAGE_IN_MEMORY})),this.g=void 0,this.h=new A.$dh,this.whenInit=this.h.p,this.j=g.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.j===g.StorageState.None)try{const r=this.B(await this.t());this.f.dispose(),this.f=r,this.B(r.onDidChangeStorage(n=>this.b.fire(n))),await this.s(r);const t=r.getBoolean(f.$8o);t===void 0?r.set(f.$8o,!0):t&&r.set(f.$8o,!1)}catch(r){this.m.error(`[storage main] initialize(): Unable to init storage due to ${r}`)}finally{this.j=g.StorageState.Initialized,this.h.complete()}})()),this.g}r(){return{logTrace:this.m.getLevel()===y.LogLevel.Trace?r=>this.m.trace(r):void 0,logError:r=>this.m.error(r)}}s(r){return r.init()}get items(){return this.f.items}get(r,t){return this.f.get(r,t)}set(r,t){return this.f.set(r,t)}delete(r){return this.f.delete(r)}optimize(){return this.f.optimize()}async close(){const r=new P.$Kd(!1);await this.w(),r.stop(),r.elapsed()>$.a&&await this.u(r),this.c.fire()}async u(r){if(this.path)try{const t=(0,S.top)(Array.from(this.f.items.entries()).map(([o,p])=>({key:o,length:p.length})),(o,p)=>p.length-o.length,5).map(o=>`${o.key}:${o.length}`).join(", "),n=(await this.n.stat(h.URI.file(this.path))).size;this.m.warn(`[storage main] detected slow close() operation: Time: ${r.elapsed()}ms, DB size: ${n}b, Large Keys: ${t}`)}catch(t){this.m.error("[storage main] figuring out stats for slow DB on close() resulted in an error",t)}}async w(){this.g&&await this.g,this.j=g.StorageState.Closed,await this.f.close()}}class d extends ${static{this.y="state.vscdb"}get path(){if(!this.C.useInMemoryStorage)return(0,C.$jc)(this.z.globalStorageHome.with({scheme:w.Schemas.file}).fsPath,d.y)}constructor(r,t,n,o){super(n,o),this.z=r,this.C=t}async t(){return new g.$6o(new b.$ZT(this.path??b.$ZT.IN_MEMORY_PATH,{logging:this.r()}),this.path?void 0:{hint:g.StorageHint.STORAGE_IN_MEMORY})}}class u extends d{constructor(r,t,n,o){super(r,t,n,o)}}e.$B6b=u;class E extends d{constructor(r,t,n,o){super(t.defaultProfile,r,n,o)}async s(r){await super.s(r),this.G(r)}G(r){r.get(v.$gl,void 0)===void 0&&r.set(v.$gl,new Date().toUTCString());const n=r.get(v.$fl,void 0),o=new Date().toUTCString();r.set(v.$hl,typeof n>"u"?null:n),r.set(v.$fl,o)}}e.$C6b=E;class l extends ${static{this.y="state.vscdb"}static{this.z="workspace.json"}get path(){if(!this.D.useInMemoryStorage)return(0,C.$jc)(this.F.workspaceStorageHome.with({scheme:w.Schemas.file}).fsPath,this.C.id,l.y)}constructor(r,t,n,o,p){super(n,p),this.C=r,this.D=t,this.F=o}async t(){const{storageFilePath:r,wasCreated:t}=await this.H();return new g.$6o(new b.$ZT(r,{logging:this.r()}),{hint:this.D.useInMemoryStorage?g.StorageHint.STORAGE_IN_MEMORY:t?g.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async H(){if(this.D.useInMemoryStorage)return{storageFilePath:b.$ZT.IN_MEMORY_PATH,wasCreated:!0};const r=(0,C.$jc)(this.F.workspaceStorageHome.with({scheme:w.Schemas.file}).fsPath,this.C.id),t=(0,C.$jc)(r,l.y);return await c.Promises.exists(r)?{storageFilePath:t,wasCreated:!1}:(await c.Promises.mkdir(r,{recursive:!0}),this.I(r),{storageFilePath:t,wasCreated:!0})}async I(r){let t;if((0,m.$1h)(this.C)?t={folder:this.C.uri.toString()}:(0,m.$6h)(this.C)&&(t={workspace:this.C.configPath.toString()}),t)try{const n=(0,C.$jc)(r,l.z);await c.Promises.exists(n)||await c.Promises.writeFile(n,JSON.stringify(t,void 0,2))}catch(n){this.m.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${n}`)}}}e.$D6b=l;class i extends ${get path(){}async t(){return new g.$6o(new g.$7o,{hint:g.StorageHint.STORAGE_IN_MEMORY})}}e.$E6b=i}),define(ie[280],ne([0,1,3,2,96]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g8b=void 0;class R extends A.$Sc{constructor(P,h,c){super(),this.b=P,this.c=h,this.f=c;const g=this.B(new A.$Tc);this.a=this.B(new S.$Od({onWillAddFirstListener:()=>g.value=this.g(),onDidRemoveLastListener:()=>g.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const P=new A.$Rc;return P.add(S.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(h,c)=>(h?h.push(c.key):h=[c.key],h),100)(h=>this.h(h))),P.add(S.Event.debounce(this.b.onDidChangeProfileStorage,(h,c)=>{h||(h=new Map);let g=h.get(c.profile.id);return g||h.set(c.profile.id,g={profile:c.profile,keys:[],storage:c.storage}),g.keys.push(c.key),h},100)(h=>this.j(h))),P}h(P){const h=P.includes(s.$9o)?[this.c.defaultProfile]:[],c=[];if(P=P.filter(g=>g!==s.$9o),P.length){const g=(0,s.$$o)(this.b.applicationStorage.storage);c.push({profile:this.c.defaultProfile,changes:P.map(b=>({key:b,scope:0,target:g[b]}))})}this.m(h,c)}j(P){const h=[],c=new Map;for(const[g,b]of P.entries()){b.keys.includes(s.$9o)&&h.push(b.profile);const y=b.keys.filter(f=>f!==s.$9o);if(y.length){const f=(0,s.$$o)(b.storage.storage);c.set(g,{profile:b.profile,changes:y.map(v=>({key:v,scope:0,target:f[v]}))})}}this.m(h,[...c.values()])}m(P,h){(P.length||h.length)&&this.a.fire({valueChanges:h,targetChanges:P})}listen(P,h,c){switch(h){case"onDidChange":return this.a.event}throw new Error(`Event not found: ${h}`)}async call(P,h){throw new Error(`Call not found: ${h}`)}}e.$g8b=R}),define(ie[281],ne([0,1,7,36,16,6,34,40,41,12,121]),function(J,e,S,A,s,R,C,P,h,c,g){"use strict";var b,y;Object.defineProperty(e,"__esModule",{value:!0}),e.$LN=e.$KN=e.$JN=void 0;let f=class extends h.$Ok{static{b=this}static{this.a="profileAssociationsMigration"}constructor($,d,u,E,l){super(u,E,d,l),this.U=$,this.W=u}O(){return this.U.getItem(b.b,[]).map(d=>({...d,location:(0,c.$zf)(d.location)?this.w.extUri.joinPath(this.profilesHome,d.location):S.URI.revive(d.location)}))}Q(){const $=this.U.getItem(b.c,{});return this.U.getItem(b.a,!1)?$:this.N($)}S(){return this.w.extUri.joinPath(S.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$JN=f,e.$JN=f=b=Ee([te(0,C.$EN),te(1,P.$Jk),te(2,A.$Yh),te(3,s.$_j),te(4,R.$$i)],f);let v=y=class extends f{constructor($,d,u,E,l){super($,d,u,E,l),this.$=$}P($){$.length?this.$.setItem(y.b,$.map(d=>({...d,location:this.w.extUri.basename(d.location)}))):this.$.removeItem(y.b)}O(){const $=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P($),this.$.setItem("userDataProfilesMigration",!0)),$}R($){$.emptyWindows||$.workspaces?this.$.setItem(y.c,$):this.$.removeItem(y.c)}Q(){const $="workspaceAndProfileInfo",d=this.$.getItem($,void 0);if(d){this.$.removeItem($);const E=d.reduce((l,{workspace:i,profile:a})=>(l[S.URI.revive(i).toString()]=S.URI.revive(a).toString(),l),{});this.$.setItem(y.c,{workspaces:E})}const u=super.Q();return this.$.getItem(y.a,!1)||(this.R(u),this.$.setItem(y.a,!0)),u}};e.$KN=v,e.$KN=v=y=Ee([te(0,C.$FN),te(1,P.$Jk),te(2,A.$Yh),te(3,s.$_j),te(4,R.$$i)],v);let m=class extends v{constructor($,d,u,E){super(new g.$IN(0,d,E,u),$,d,u,E)}async init(){return await this.$.init(),super.init()}};e.$LN=m,e.$LN=m=Ee([te(0,P.$Jk),te(1,A.$Yh),te(2,s.$_j),te(3,R.$$i)],m)}),define(ie[52],ne([0,1,36,16,5,6,40,41,281,34]),function(J,e,S,A,s,R,C,P,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G6b=e.$F6b=void 0,e.$F6b=(0,s.$Rh)(P.$Lk);let g=class extends h.$KN{constructor(y,f,v,m,w){super(y,f,v,m,w)}getAssociatedEmptyWindows(){const y=[];for(const f of this.C.emptyWindows.keys())y.push({id:f});return y}};e.$G6b=g,e.$G6b=g=Ee([te(0,c.$FN),te(1,C.$Jk),te(2,S.$Yh),te(3,A.$_j),te(4,R.$$i)],g)}),define(ie[130],ne([0,1,19,7,30]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W6b=e.$V6b=e.$U6b=void 0;async function R(h,c,g){for(const y of h){const f=y.openedWorkspace;if((0,s.$6h)(f)){const v=await g(f);if(v){if(v.folders.some(m=>S.$ng.isEqualOrParent(c,m.uri)))return y}else if(S.$ng.isEqualOrParent(c,f.configPath))return y}}const b=h.filter(y=>(0,s.$1h)(y.openedWorkspace)&&S.$ng.isEqualOrParent(c,y.openedWorkspace.uri));if(b.length)return b.sort((y,f)=>-(y.openedWorkspace.uri.path.length-f.openedWorkspace.uri.path.length))[0]}e.$U6b=R;function C(h,c){for(const g of h)if((0,s.$6h)(g.openedWorkspace)&&S.$ng.isEqual(g.openedWorkspace.configPath,c)||(0,s.$1h)(g.openedWorkspace)&&S.$ng.isEqual(g.openedWorkspace.uri,c))return g}e.$V6b=C;function P(h,c){const g=b=>c.some(y=>S.$ng.isEqual(A.URI.file(y),A.URI.file(b)));for(const b of h)if(b.config?.extensionDevelopmentPath?.some(y=>g(y)))return b}e.$W6b=P}),define(ie[97],ne([0,1,33,44,139,46,13,9,4,19,7,5,58,30]),function(J,e,S,A,s,R,C,P,h,c,g,b,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1U=e.$ZU=e.$YU=e.$XU=e.$WU=e.$VU=e.$UU=e.$TU=e.$SU=e.$RU=void 0,e.$RU=(0,b.$Qh)("workspacesService");function v(D){return D.hasOwnProperty("workspace")}e.$SU=v;function m(D){return D.hasOwnProperty("folderUri")}e.$TU=m;function w(D){return D.hasOwnProperty("fileUri")}e.$UU=w;function $(D){return d(D)||u(D)}e.$VU=$;function d(D){const k=D;return typeof k?.path=="string"&&(!k.name||typeof k.name=="string")}function u(D){const k=D;return typeof k?.uri=="string"&&(!k.name||typeof k.name=="string")}function E(D,k,I,j,U){if(D.scheme!==j.scheme)return{name:I,uri:D.toString(!0)};let z=k?void 0:U.relativePath(j,D);if(z!==void 0)z.length===0?z=".":h.$j&&(z=l(z));else if(D.scheme===C.Schemas.file)z=D.fsPath,h.$j&&(z=l(z));else if(U.isEqualAuthority(D.authority,j.authority))z=D.path;else return{name:I,uri:D.toString(!0)};return{name:I,path:z}}e.$WU=E;function l(D){return D=(0,R.$wv)(D),(0,S.$Vf)(D)||(D=(0,S.$Sf)(D)),D}function i(D,k,I){const j=[],U=new Set,z=I.dirname(k);for(const x of D){let Z;if(d(x))x.path&&(Z=I.resolvePath(z,x.path));else if(u(x))try{Z=g.URI.parse(x.uri),Z.path[0]!==P.$gc.sep&&(Z=Z.with({path:P.$gc.sep+Z.path}))}catch(ae){console.warn(ae)}if(Z){const ae=I.getComparisonKey(Z);if(!U.has(ae)){U.add(ae);const se=x.name||I.basenameOrAuthority(Z);j.push(new f.$$h({uri:Z,name:se,index:j.length},x))}}}return j}e.$XU=i;function a(D,k,I,j,U){const z=r(k,D),x=U.dirname(k),Z=U.dirname(j),ae=[];for(const K of z.folders){const Q=d(K)?U.resolvePath(x,K.path):g.URI.parse(K.uri);let q;I?q=!1:q=!d(K)||(0,P.$ic)(K.path),ae.push(E(Q,q,K.name,Z,U))}const se={insertSpaces:!1,tabSize:4,eol:h.$l||h.$k?`
`:`\r
`},ce=s.$cT(D,["folders"],ae,se);let Y=s.$fT(D,ce);return(0,c.$Bg)(z.remoteAuthority,(0,y.$Vk)(j))&&(Y=s.$fT(Y,s.$bT(Y,["remoteAuthority"],se))),Y}e.$YU=a;function r(D,k){const I=A.$Xm(k);if(I&&Array.isArray(I.folders))I.folders=I.folders.filter(j=>$(j));else throw new Error(`${D} looks like an invalid workspace file.`);return I}function t(D){return D.workspace&&typeof D.workspace=="object"&&typeof D.workspace.id=="string"&&typeof D.workspace.configPath=="string"}function n(D){return typeof D.folderUri=="string"}function o(D){return typeof D.fileUri=="string"}function p(D,k){const I={workspaces:[],files:[]};if(D){const j=function(z,x){for(let Z=0;Z<z.length;Z++)try{x(z[Z],Z)}catch(ae){k.warn(`Error restoring recent entry ${JSON.stringify(z[Z])}: ${ae.toString()}. Skip entry.`)}},U=D;Array.isArray(U.entries)&&j(U.entries,z=>{const x=z.label,Z=z.remoteAuthority;t(z)?I.workspaces.push({label:x,remoteAuthority:Z,workspace:{id:z.workspace.id,configPath:g.URI.parse(z.workspace.configPath)}}):n(z)?I.workspaces.push({label:x,remoteAuthority:Z,folderUri:g.URI.parse(z.folderUri)}):o(z)&&I.files.push({label:x,remoteAuthority:Z,fileUri:g.URI.parse(z.fileUri)})})}return I}e.$ZU=p;function O(D){const k={entries:[]};for(const I of D.workspaces)m(I)?k.entries.push({folderUri:I.folderUri.toString(),label:I.label,remoteAuthority:I.remoteAuthority}):k.entries.push({workspace:{id:I.workspace.id,configPath:I.workspace.configPath.toString()},label:I.label,remoteAuthority:I.remoteAuthority});for(const I of D.files)k.entries.push({fileUri:I.fileUri.toString(),label:I.label,remoteAuthority:I.remoteAuthority});return k}e.$1U=O}),define(ie[98],ne([0,1,85,13,4,19]),function(J,e,S,A,s,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$16b=e.$Z6b=e.$Y6b=e.$X6b=void 0,e.$X6b=128/4;function C(c){function g(){let b=c.scheme===A.Schemas.file?(0,R.$kg)(c):c.toString();return s.$l||(b=b.toLowerCase()),(0,S.createHash)("md5").update(b).digest("hex")}return{id:g(),configPath:c}}e.$Y6b=C;function P(c,g){function b(){if(c.scheme!==A.Schemas.file)return(0,S.createHash)("md5").update(c.toString()).digest("hex");if(!g)return;let f;return s.$l?f=g.ino:s.$k?f=g.birthtime.getTime():s.$j&&(typeof g.birthtimeMs=="number"?f=Math.floor(g.birthtimeMs):f=g.birthtime.getTime()),(0,S.createHash)("md5").update(c.fsPath).update(f?String(f):"").digest("hex")}const y=b();if(typeof y=="string")return{id:y,uri:c}}e.$Z6b=P;function h(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.$16b=h}),define(ie[99],ne([0,1,85,86,28,282,17,14,3,2,9,4,32,42,109]),function(J,e,S,A,s,R,C,P,h,c,g,b,y,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=void 0;class m{traceSocketEvent(k,I){v.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,k,I)}constructor(k,I=""){this.f=!0,this.debugLabel=I,this.socket=k,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=j=>{if(this.traceSocketEvent("error",{code:j?.code,message:j?.message}),j){if(j.code==="EPIPE")return;(0,P.$1)(j)}},this.socket.on("error",this.a),this.b=j=>{this.traceSocketEvent("close",{hadError:j}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(k){const I=j=>{this.traceSocketEvent("read",j),k(C.$ce.wrap(j))};return this.socket.on("data",I),{dispose:()=>this.socket.off("data",I)}}onClose(k){const I=j=>{k({type:0,hadError:j,error:void 0})};return this.socket.on("close",I),{dispose:()=>this.socket.off("close",I)}}onEnd(k){const I=()=>{k()};return this.socket.on("end",I),{dispose:()=>this.socket.off("end",I)}}write(k){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",k),this.socket.write(k.buffer,I=>{if(I){if(I.code==="EPIPE")return;(0,P.$1)(I)}})}catch(I){if(I.code==="EPIPE")return;(0,P.$1)(I)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((k,I)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),k();return}const j=()=>{this.socket.off("close",j),this.socket.off("end",j),this.socket.off("error",j),this.socket.off("timeout",j),this.socket.off("drain",j),this.traceSocketEvent("nodeDrainEnd"),k()};this.socket.on("close",j),this.socket.on("end",j),this.socket.on("error",j),this.socket.on("timeout",j),this.socket.on("drain",j)})}}e.$Fh=m;var w;(function(D){D[D.MinHeaderByteSize=2]="MinHeaderByteSize",D[D.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(w||(w={}));var $;(function(D){D[D.PeekHeader=1]="PeekHeader",D[D.ReadHeader=2]="ReadHeader",D[D.ReadBody=3]="ReadBody",D[D.Fin=4]="Fin"})($||($={}));class d extends c.$Sc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(k,I){this.socket.traceSocketEvent(k,I)}constructor(k,I,j,U){super(),this.f=this.B(new h.$Od),this.g=this.B(new h.$Od),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=k,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:I,inflateBytesLength:j?.byteLength||0,recordInflateBytes:U}),this.a=this.B(new u(this,I,j,U,this.f,(z,x)=>this.m(z,x))),this.B(this.a.onError(z=>{console.error(z),(0,P.$1)(z),this.g.fire({type:0,hadError:!0,error:z})})),this.b=new v.$Ah,this.B(this.socket.onData(z=>this.n(z))),this.B(this.socket.onClose(async z=>{this.a.isProcessingReadQueue()&&await h.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(z)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(k){return this.f.event(k)}onClose(k){return this.g.event(k)}onEnd(k){return this.socket.onEnd(k)}write(k){let I=0;for(;I<k.byteLength;)this.a.writeMessage(k.slice(I,Math.min(I+262144,k.byteLength)),{compressed:!0,opcode:2}),I+=262144}m(k,{compressed:I,opcode:j}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",k);let U=2;k.byteLength<126?U+=0:k.byteLength<2**16?U+=2:U+=8;const z=C.$ce.alloc(U),x=I?64:0,Z=j&15;if(z.writeUInt8(128|x|Z,0),k.byteLength<126)z.writeUInt8(k.byteLength,1);else if(k.byteLength<2**16){z.writeUInt8(126,1);let ae=1;z.writeUInt8(k.byteLength>>>8&255,++ae),z.writeUInt8(k.byteLength>>>0&255,++ae)}else{z.writeUInt8(127,1);let ae=1;z.writeUInt8(0,++ae),z.writeUInt8(0,++ae),z.writeUInt8(0,++ae),z.writeUInt8(0,++ae),z.writeUInt8(k.byteLength>>>24&255,++ae),z.writeUInt8(k.byteLength>>>16&255,++ae),z.writeUInt8(k.byteLength>>>8&255,++ae),z.writeUInt8(k.byteLength>>>0&255,++ae)}this.socket.write(C.$ce.concat([z,k]))}end(){this.h=!0,this.socket.end()}n(k){if(k.byteLength!==0){for(this.b.acceptChunk(k);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const I=this.b.peek(this.j.readLen),j=I.readUInt8(0),U=(j&128)>>>7,z=(j&64)>>>6,x=j&15,Z=I.readUInt8(1),ae=(Z&128)>>>7,se=Z&127;this.j.state=2,this.j.readLen=2+(ae?4:0)+(se===126?2:0)+(se===127?8:0),this.j.fin=U,this.j.firstFrameOfMessage&&(this.j.compressed=!!z),this.j.firstFrameOfMessage=!!U,this.j.mask=0,this.j.opcode=x,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const I=this.b.read(this.j.readLen),j=I.readUInt8(1),U=(j&128)>>>7;let z=j&127,x=1;z===126?z=I.readUInt8(++x)*2**8+I.readUInt8(++x):z===127&&(z=I.readUInt8(++x)*0+I.readUInt8(++x)*0+I.readUInt8(++x)*0+I.readUInt8(++x)*0+I.readUInt8(++x)*2**24+I.readUInt8(++x)*2**16+I.readUInt8(++x)*2**8+I.readUInt8(++x));let Z=0;U&&(Z=I.readUInt8(++x)*2**24+I.readUInt8(++x)*2**16+I.readUInt8(++x)*2**8+I.readUInt8(++x)),this.j.state=3,this.j.readLen=z,this.j.mask=Z,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const I=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",I),i(I,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",I),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(I,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(I,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await h.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Gh=d;class u extends c.$Sc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:C.$ce.alloc(0)}constructor(k,I,j,U,z,x){super(),this.n=k,this.r=z,this.s=x,this.a=this.B(new h.$Od),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new h.$Od),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new h.$Od),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,I?(this.b=this.B(new E(this.n,U,j,{windowBits:15})),this.f=this.B(new l(this.n,{windowBits:15})),this.B(this.b.onError(Z=>this.a.fire(Z))),this.B(this.f.onError(Z=>this.a.fire(Z)))):(this.b=null,this.f=null)}writeMessage(k,I){this.g.push({data:k,options:I}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:k,options:I}=this.g.shift();if(this.f&&I.compressed){const j=await this.w(this.f,k);this.s(j,I)}else this.s(k,{...I,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(k,I){return new Promise((j,U)=>{k.write(I),k.flush(z=>j(z))})}acceptFrame(k,I,j){this.h.push({data:k,isCompressed:I,isLastFrameOfMessage:j}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const k=this.h.shift();if(this.b&&k.isCompressed){const I=await this.C(this.b,k.data,k.isLastFrameOfMessage);this.r.fire(I)}else this.r.fire(k.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(k,I,j){return new Promise((U,z)=>{k.write(I),j&&k.write(C.$ce.fromByteArray([0,0,255,255])),k.flush(x=>U(x))})}}class E extends c.$Sc{get recordedInflateBytes(){return this.j?C.$ce.concat(this.f):C.$ce.alloc(0)}constructor(k,I,j,U){super(),this.h=k,this.j=I,this.a=this.B(new h.$Od),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,R.createInflateRaw)(U),this.b.on("error",z=>{this.h.traceSocketEvent("zlibInflateError",{message:z?.message,code:z?.code}),this.a.fire(z)}),this.b.on("data",z=>{this.h.traceSocketEvent("zlibInflateData",z),this.g.push(C.$ce.wrap(z))}),j&&(this.h.traceSocketEvent("zlibInflateInitialWrite",j.buffer),this.b.write(j.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(k){this.j&&this.f.push(k.clone()),this.h.traceSocketEvent("zlibInflateWrite",k),this.b.write(k.buffer)}flush(k){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const I=C.$ce.concat(this.g);this.g.length=0,k(I)})}}class l extends c.$Sc{constructor(k,I){super(),this.g=k,this.a=this.B(new h.$Od),this.onError=this.a.event,this.f=[],this.b=(0,R.createDeflateRaw)({windowBits:15}),this.b.on("error",j=>{this.g.traceSocketEvent("zlibDeflateError",{message:j?.message,code:j?.code}),this.a.fire(j)}),this.b.on("data",j=>{this.g.traceSocketEvent("zlibDeflateData",j),this.f.push(C.$ce.wrap(j))})}write(k){this.g.traceSocketEvent("zlibDeflateWrite",k.buffer),this.b.write(k.buffer)}flush(k){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let I=C.$ce.concat(this.f);this.f.length=0,I=I.slice(0,I.byteLength-4),k(I)})}}function i(D,k){if(k===0)return;const I=D.byteLength>>>2;for(let ae=0;ae<I;ae++){const se=D.readUInt32BE(ae*4);D.writeUInt32BE(se^k,ae*4)}const j=I*4,U=D.byteLength-j,z=k>>>24&255,x=k>>>16&255,Z=k>>>8&255;U>=1&&D.writeUInt8(D.readUInt8(j)^z,j),U>=2&&D.writeUInt8(D.readUInt8(j+1)^x,j+1),U>=3&&D.writeUInt8(D.readUInt8(j+2)^Z,j+2)}e.$Hh=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function r(){const D=(0,y.$fg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${D}-sock`;const k=process.platform!=="darwin"&&e.$Hh?e.$Hh:(0,s.tmpdir)(),I=(0,g.$jc)(k,`vscode-ipc-${D}.sock`);return n(I),I}e.$Ih=r;function t(D,k,I){const j=(0,S.createHash)("md5").update(D).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${j}-${I}-${k}-sock`;const U=I.substr(0,4),z=k.substr(0,6),x=j.substr(0,8);let Z;return process.platform!=="darwin"&&e.$Hh&&!process.env.VSCODE_PORTABLE?Z=(0,g.$jc)(e.$Hh,`vscode-${x}-${U}-${z}.sock`):Z=(0,g.$jc)(D,`${U}-${z}.sock`),n(Z),Z}e.$Jh=t;function n(D){const k=a[b.$u];typeof k=="number"&&D.length>=k&&console.warn(`WARNING: IPC handle "${D}" is longer than ${k} chars, try a shorter --user-data-dir`)}class o extends f.$uh{static b(k){const I=h.Event.fromNodeEventEmitter(k,"connection");return h.Event.map(I,j=>({protocol:new v.$Bh(new m(j,"ipc-server-connection")),onDidClientDisconnect:h.Event.once(h.Event.fromNodeEventEmitter(j,"close"))}))}constructor(k){super(o.b(k)),this.d=k}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Kh=o;function p(D){return new Promise((k,I)=>{const j=(0,A.createServer)();j.on("error",I),j.listen(D,()=>{j.removeListener("error",I),k(new o(j))})})}e.$Lh=p;function O(D,k){return new Promise((I,j)=>{const U=(0,A.createConnection)(D,()=>{U.removeListener("error",j),I(v.$Ch.fromSocket(new m(U,`ipc-client${k}`),k))});U.once("error",j)})}e.$Mh=O}),define(ie[24],ne([0,1,54,9,4,99,36,89,5]),function(J,e,S,A,s,R,C,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y6b=e.$x6b=void 0,e.$x6b=(0,h.$Rh)(C.$Xh);class c extends P.$km{constructor(){super(...arguments),this.d={}}get cachedLanguagesPath(){return(0,A.$jc)(this.userDataPath,"clp")}get backupHome(){return(0,A.$jc)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,R.$Jh)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,A.$jc)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(s.$l){for(const b in process.env)if(b.endsWith("_VSCODE_SNAP_ORIG")){const y=b.slice(0,-17);if(this.d[y])continue;process.env[y]&&(this.d[y]=process.env[y]),process.env[b]?process.env[y]=process.env[b]:delete process.env[y]}}}restoreSnapExportedVariables(){if(s.$l)for(const b in this.d)process.env[b]=this.d[b],delete this.d[b]}}e.$y6b=c,Ee([S.$ih],c.prototype,"cachedLanguagesPath",null),Ee([S.$ih],c.prototype,"backupHome",null),Ee([S.$ih],c.prototype,"mainIPCHandle",null),Ee([S.$ih],c.prototype,"mainLockfile",null),Ee([S.$ih],c.prototype,"disableUpdates",null),Ee([S.$ih],c.prototype,"crossOriginIsolated",null),Ee([S.$ih],c.prototype,"codeCachePath",null),Ee([S.$ih],c.prototype,"useCodeCache",null)}),define(ie[283],ne([0,1,85,33,13,9,4,19,21,196,18,24,34,16,6,195,30,98]),function(J,e,S,A,s,R,C,P,h,c,g,b,y,f,v,m,w,$){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$c7b=void 0;let u=class{static{d=this}static{this.a="backupWorkspaces"}constructor(l,i,a,r){this.j=l,this.k=i,this.l=a,this.m=r,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=P.$ng,this.i={isEqual:(t,n)=>(0,A.$Xf)(t,n,!C.$l)}}async initialize(){const l=this.m.getItem(d.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(l.emptyWindows),this.d=await this.u((0,c.$O6b)(l)),this.e=await this.v((0,c.$P6b)(l)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==f.$yk.OFF}q(){return this.s()===f.$yk.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||f.$yk.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(l,i){this.d.some(r=>l.workspace.id===r.workspace.id)||(this.d.push(l),this.C());const a=(0,R.$jc)(this.c,l.workspace.id);return i?this.t(a,i).then(()=>a):a}async t(l,i){if(await h.Promises.exists(l)&&await this.z(l),await h.Promises.exists(i))try{await h.Promises.rename(i,l,!1)}catch(a){this.l.error(`Backup: Could not move backup folder to new location: ${a.toString()}`)}}registerFolderBackup(l){return this.e.some(i=>this.h.isEqual(l.folderUri,i.folderUri))||(this.e.push(l),this.C()),(0,R.$jc)(this.c,this.D(l))}registerEmptyWindowBackup(l){return this.g.some(i=>!!i.backupFolder&&this.i.isEqual(i.backupFolder,l.backupFolder))||(this.g.push(l),this.C()),(0,R.$jc)(this.c,l.backupFolder)}async u(l){if(!Array.isArray(l))return[];const i=new Set,a=[];for(const r of l){const t=r.workspace;if(!(0,w.$6h)(t))return[];if(!i.has(t.id)){i.add(t.id);const n=(0,R.$jc)(this.c,t.id);await this.B(n)?t.configPath.scheme!==s.Schemas.file||await h.Promises.exists(t.configPath.fsPath)?a.push(r):await this.z(n):await this.x(n)}}return a}async v(l){if(!Array.isArray(l))return[];const i=[],a=new Set;for(const r of l){const t=r.folderUri,n=this.h.getComparisonKey(t);if(!a.has(n)){a.add(n);const o=(0,R.$jc)(this.c,this.D(r));await this.B(o)?t.scheme!==s.Schemas.file||await h.Promises.exists(t.fsPath)?i.push(r):await this.z(o):await this.x(o)}}return i}async w(l){if(!Array.isArray(l))return[];const i=[],a=new Set;for(const r of l){const t=r.backupFolder;if(typeof t!="string")return[];if(!a.has(t)){a.add(t);const n=(0,R.$jc)(this.c,t);await this.B(n)?i.push(r):await this.x(n)}}return i}async x(l){try{await h.Promises.rm(l,h.RimRafMode.MOVE)}catch(i){this.l.error(`Backup: Could not delete stale backup: ${i.toString()}`)}}y(){let l=(0,$.$16b)();for(;this.g.some(i=>!!i.backupFolder&&this.i.isEqual(i.backupFolder,l.id));)l=(0,$.$16b)();return{backupFolder:l.id}}async z(l){const i=this.y(),a=(0,R.$jc)(this.c,i.backupFolder);try{await h.Promises.rename(l,a,!1)}catch(r){return this.l.error(`Backup: Could not rename backup folder: ${r.toString()}`),!1}return this.g.push(i),!0}async getDirtyWorkspaces(){const l=[];for(const i of this.d)await this.A(i)&&l.push(i);for(const i of this.e)await this.A(i)&&l.push(i);return l}A(l){let i;return(0,c.$N6b)(l)?i=(0,R.$jc)(this.c,l.backupFolder):(0,m.$PU)(l)?i=(0,R.$jc)(this.c,this.D(l)):i=(0,R.$jc)(this.c,l.workspace.id),this.B(i)}async B(l){try{const i=await h.Promises.readdir(l);for(const a of i)try{if((await h.Promises.readdir((0,R.$jc)(l,a))).length>0)return!0}catch{}}catch{}return!1}C(){const l={workspaces:this.d.map(({workspace:i,remoteAuthority:a})=>{const r={id:i.id,configURIPath:i.configPath.toString()};return a&&(r.remoteAuthority=a),r}),folders:this.e.map(({folderUri:i,remoteAuthority:a})=>{const r={folderUri:i.toString()};return a&&(r.remoteAuthority=a),r}),emptyWindows:this.g.map(({backupFolder:i,remoteAuthority:a})=>{const r={backupFolder:i};return a&&(r.remoteAuthority=a),r})};this.m.setItem(d.a,l)}D(l){const i=l.folderUri;let a;return i.scheme===s.Schemas.file?a=C.$l?i.fsPath:i.fsPath.toLowerCase():a=i.toString().toLowerCase(),(0,S.createHash)("md5").update(a).digest("hex")}};e.$c7b=u,e.$c7b=u=d=Ee([te(0,b.$x6b),te(1,g.$ki),te(2,v.$$i),te(3,y.$FN)],u)}),define(ie[20],ne([0,1,15,38,8,3,2,4,35,12,5,6,34,24]),function(J,e,S,A,s,R,C,P,h,c,g,b,y,f){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$A6b=e.LifecycleMainPhase=e.ShutdownReason=e.$z6b=void 0,e.$z6b=(0,g.$Qh)("lifecycleMainService");var m;(function(d){d[d.QUIT=1]="QUIT",d[d.KILL=2]="KILL"})(m||(e.ShutdownReason=m={}));var w;(function(d){d[d.Starting=1]="Starting",d[d.Ready=2]="Ready",d[d.AfterWindowOpen=3]="AfterWindowOpen",d[d.Eventually=4]="Eventually"})(w||(e.LifecycleMainPhase=w={}));let $=class extends C.$Sc{static{v=this}static{this.b="lifecycle.quitAndRestart"}get quitRequested(){return this.j}get wasRestarted(){return this.m}get phase(){return this.n}constructor(u,E,l){super(),this.F=u,this.G=E,this.H=l,this.c=this.B(new R.$Od),this.onBeforeShutdown=this.c.event,this.f=this.B(new R.$Od),this.onWillShutdown=this.f.event,this.g=this.B(new R.$Od),this.onWillLoadWindow=this.g.event,this.h=this.B(new R.$Od),this.onBeforeCloseWindow=this.h.event,this.j=!1,this.m=!1,this.n=1,this.r=new Set,this.s=0,this.t=0,this.u=void 0,this.w=void 0,this.y=void 0,this.z=new Map,this.C=new Map,this.D=void 0,this.I(),this.when(2).then(()=>this.J())}I(){this.m=!!this.G.getItem(v.b),this.m&&this.G.removeItem(v.b)}J(){const u=()=>{this.j||(this.S("Lifecycle#app.on(before-quit)"),this.j=!0,this.S("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),P.$k&&this.t===0&&this.L(1))};S.app.addListener("before-quit",u);const E=()=>{this.S("Lifecycle#app.on(window-all-closed)"),(this.j||!P.$k)&&S.app.quit()};S.app.addListener("window-all-closed",E),S.app.once("will-quit",l=>{this.S("Lifecycle#app.on(will-quit) - begin"),l.preventDefault(),this.L(1).finally(()=>{this.S("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.O(!1),S.app.removeListener("before-quit",u),S.app.removeListener("window-all-closed",E),this.S("Lifecycle#app.on(will-quit) - calling app.quit()"),S.app.quit()})})}L(u){if(this.y)return this.y;const E=this.F;this.S("Lifecycle#onWillShutdown.fire()");const l=[];return this.f.fire({reason:u,join(i,a){E.trace(`Lifecycle#onWillShutdown - begin '${i}'`),l.push(a.finally(()=>{E.trace(`Lifecycle#onWillShutdown - end '${i}'`)}))}}),this.y=(async()=>{try{await s.Promises.settled(l)}catch(i){this.F.error(i)}try{await this.G.close()}catch(i){this.F.error(i)}})(),this.y}set phase(u){if(u<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.n===u)return;this.S(`lifecycle (main): phase changed (value: ${u})`),this.n=u;const E=this.C.get(this.n);E&&(E.open(),this.C.delete(this.n))}async when(u){if(u<=this.n)return;let E=this.C.get(u);E||(E=new s.$Tg,this.C.set(u,E)),await E.wait()}registerWindow(u){const E=new C.$Rc;this.t++,E.add(u.onWillLoad(i=>this.g.fire({window:u,workspace:i.workspace,reason:i.reason})));const l=(0,c.$Kf)(u.win);l.on("close",i=>{const a=u.id;if(this.r.has(a)){this.r.delete(a);return}this.S(`Lifecycle#window.on('close') - window ID ${u.id}`),i.preventDefault(),this.unload(u,1).then(r=>{if(r){this.r.delete(a);return}this.r.add(a),this.S(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${a}`),this.h.fire(u),u.close()})}),l.on("closed",()=>{this.S(`Lifecycle#window.on('closed') - window ID ${u.id}`),this.t--,E.dispose(),this.t===0&&(!P.$k||this.j)&&this.L(1)})}async reload(u,E){await this.unload(u,3)||u.reload(E)}unload(u,E){const l=this.z.get(u.id);if(l)return l;const i=this.M(u,E).finally(()=>{this.z.delete(u.id)});return this.z.set(u.id,i),i}async M(u,E){if(!u.isReady)return!1;this.S(`Lifecycle#unload() - window ID ${u.id}`);const l=this.j?2:E,i=await this.P(u,l);return i?(this.S(`Lifecycle#unload() - veto in renderer (window ID ${u.id})`),this.N(i)):(await this.Q(u,l),!1)}N(u){return u?(this.O(!0),this.j=!1,!0):!1}O(u){this.w&&(this.w(u),this.w=void 0,this.u=void 0)}P(u,E){return new Promise(l=>{const i=this.s++,a=`vscode:ok${i}`,r=`vscode:cancel${i}`;A.$uT.once(a,()=>{l(!1)}),A.$uT.once(r,()=>{l(!0)}),u.send("vscode:onBeforeUnload",{okChannel:a,cancelChannel:r,reason:E})})}Q(u,E){return new Promise(l=>{const a=`vscode:reply${this.s++}`;A.$uT.once(a,()=>l()),u.send("vscode:onWillUnload",{replyChannel:a,reason:E})})}quit(u){return this.R(u).then(E=>{if(!E&&u)try{if(P.$j){const l=(0,h.cwd)();l!==process.cwd()&&process.chdir(l)}}catch(l){this.F.error(l)}return E})}R(u){return this.S(`Lifecycle#quit() - begin (willRestart: ${u})`),this.u?(this.S("Lifecycle#quit() - returning pending quit promise"),this.u):(u&&this.G.setItem(v.b,!0),this.u=new Promise(E=>{this.w=E,this.S("Lifecycle#quit() - calling app.quit()"),S.app.quit()}),this.u)}S(u){this.H.args["enable-smoke-test-driver"]?this.F.info(u):this.F.trace(u)}setRelaunchHandler(u){this.D=u}async relaunch(u){this.S("Lifecycle#relaunch()");const E=process.argv.slice(1);if(u?.addArgs&&E.push(...u.addArgs),u?.removeArgs)for(const a of u.removeArgs){const r=E.indexOf(a);r>=0&&E.splice(r,1)}const l=()=>{this.D?.handleRelaunch(u)||(this.S("Lifecycle#relaunch() - calling app.relaunch()"),S.app.relaunch({args:E}))};S.app.once("quit",l),await this.quit(!0)&&S.app.removeListener("quit",l)}async kill(u){this.S("Lifecycle#kill()"),await this.L(2),await Promise.race([(0,s.$Vg)(1e3),(async()=>{for(const E of S.BrowserWindow.getAllWindows())if(E&&!E.isDestroyed()){let l;E.webContents&&!E.webContents.isDestroyed()?l=new Promise(i=>E.once("closed",i)):l=Promise.resolve(),E.destroy(),await l}})()]),S.app.exit(u)}};e.$A6b=$,e.$A6b=$=v=Ee([te(0,b.$$i),te(1,y.$FN),te(2,f.$x6b)],$)}),define(ie[284],ne([0,1,4,3,2,5,20]),function(J,e,S,A,s,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z7b=e.$y7b=void 0,e.$y7b=(0,R.$Qh)("keyboardLayoutMainService");let P=class extends s.$Sc{constructor(g){super(),this.a=this.B(new A.$Od),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,g.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const g=await new Promise((b,y)=>{J(["native-keymap"],b,y)});this.c=h(g),S.$t||g.onDidChangeKeyboardLayout(()=>{this.c=h(g),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};e.$z7b=P,e.$z7b=P=Ee([te(0,C.$z6b)],P);function h(c){const g=c.getKeyMap(),b=c.getCurrentKeyboardLayout();return{keyboardMapping:g,keyboardLayoutInfo:b}}}),define(ie[285],ne([0,1,246,8,17,14,12,18,36,94,6,50,245,282]),function(J,e,S,A,s,R,C,P,h,c,g,b,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4q=e.$3q=void 0;let v=class extends b.$Xo{constructor(d,u,E,l){super(l),this.m=d,this.n=u,this.r=E,this.s(),this.B(d.onDidChangeConfiguration(i=>{i.affectsConfiguration("http")&&this.s()}))}s(){const d=this.m.getValue("http");this.f=d?.proxy,this.g=!!d?.proxyStrictSSL,this.h=d?.proxyAuthorization}async request(d,u){const{f:E,g:l}=this;let i;try{i=await(0,c.$Ul)(this.m,this.r,this.n.args,process.env)}catch(t){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,R.$0)(t)))}const a={...process.env,...i},r=d.agent?d.agent:await(0,y.$2q)(d.url||"",a,{proxyUrl:E,strictSSL:l});return d.agent=r,d.strictSSL=l,this.h&&(d.headers={...d.headers||{},"Proxy-Authorization":this.h}),this.c(d.isChromiumNetwork?"electron":"node",d,()=>w(d,u))}async resolveProxy(d){}};e.$3q=v,e.$3q=v=Ee([te(0,P.$ki),te(1,h.$Yh),te(2,g.$$i),te(3,g.$_i)],v);async function m($){return((0,S.parse)($.url).protocol==="https:"?await new Promise((E,l)=>{J(["https"],E,l)}):await new Promise((E,l)=>{J(["http"],E,l)})).request}async function w($,d){return A.Promises.withAsyncBody(async(u,E)=>{const l=(0,S.parse)($.url),i=$.getRawRequest?$.getRawRequest($):await m($),a={hostname:l.hostname,port:l.port?parseInt(l.port):l.protocol==="https:"?443:80,protocol:l.protocol,path:l.path,method:$.type||"GET",headers:$.headers,agent:$.agent,rejectUnauthorized:(0,C.$Ff)($.strictSSL)?$.strictSSL:!0};$.user&&$.password&&(a.auth=$.user+":"+$.password);const r=i(a,t=>{const n=(0,C.$Df)($.followRedirects)?$.followRedirects:3;if(t.statusCode&&t.statusCode>=300&&t.statusCode<400&&n>0&&t.headers.location)w({...$,url:t.headers.location,followRedirects:n-1},d).then(u,E);else{let o=t;!$.isChromiumNetwork&&t.headers["content-encoding"]==="gzip"&&(o=t.pipe((0,f.createGunzip)())),u({res:t,stream:(0,s.$re)(o)})}});r.on("error",E),$.timeout&&r.setTimeout($.timeout),$.isChromiumNetwork&&r.removeHeader("Content-Length"),$.data&&typeof $.data=="string"&&r.write($.data),r.end(),d.onCancellationRequested(()=>{r.abort(),E(new R.$5)})})}e.$4q=w}),define(ie[286],ne([0,1,15,285]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B8b=void 0;function s(C){return S.net.request}class R extends A.$3q{request(P,h){return super.request({...P||{},getRawRequest:s,isChromiumNetwork:!0},h)}}e.$B8b=R}),define(ie[81],ne([0,1,7,3,2,36,16,5,20,6,96,279,41,52,40,13]),function(J,e,S,A,s,R,C,P,h,c,g,b,y,f,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K6b=e.$J6b=e.$I6b=e.$H6b=void 0,e.$H6b=(0,P.$Qh)("storageMainService");let w=class extends s.$Sc{constructor(u,E,l,i,a,r){super(),this.c=u,this.f=E,this.g=l,this.h=i,this.j=a,this.m=r,this.a=void 0,this.b=this.B(new A.$Od),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.B(this.s()),this.t=new Map,this.w=new Map,this.r()}n(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}r(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(u=>{u.window.profile&&this.profileStorage(u.window.profile).init(),u.workspace&&this.workspaceStorage(u.workspace).init()})),this.B(this.h.onWillShutdown(u=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=u.reason,u.join("applicationStorage",this.applicationStorage.close());for(const[,E]of this.t)u.join("profileStorage",E.close());for(const[,E]of this.w)u.join("workspaceStorage",E.close())})),this.B(this.g.onWillCreateProfile(u=>{u.join((async()=>{await this.j.exists(u.profile.globalStorageHome)||await this.j.createFolder(u.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(u=>{const E=this.t.get(u.profile.id);E&&u.join(E.close())}))}s(){this.c.trace("StorageMainService: creating application storage");const u=new b.$C6b(this.n(),this.g,this.c,this.j);return this.B(A.Event.once(u.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")})),u}profileStorage(u){if((0,g.$ap)(u))return this.applicationStorage;let E=this.t.get(u.id);if(!E){this.c.trace(`StorageMainService: creating profile storage (${u.name})`),E=this.B(this.u(u)),this.t.set(u.id,E);const l=this.B(E.onDidChangeStorage(i=>this.b.fire({...i,storage:E,profile:u})));this.B(A.Event.once(E.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${u.name})`),this.t.delete(u.id),l.dispose()}))}return E}u(u){return this.a===2?new b.$E6b(this.c,this.j):new b.$B6b(u,this.n(),this.c,this.j)}workspaceStorage(u){let E=this.w.get(u.id);return E||(this.c.trace(`StorageMainService: creating workspace storage (${u.id})`),E=this.B(this.y(u)),this.w.set(u.id,E),this.B(A.Event.once(E.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${u.id})`),this.w.delete(u.id)}))),E}y(u){return this.a===2?new b.$E6b(this.c,this.j):new b.$D6b(u,this.n(),this.c,this.f,this.j)}isUsed(u){const E=S.URI.file(u);for(const l of[this.applicationStorage,...this.t.values(),...this.w.values()])if(l.path&&this.m.extUri.isEqualOrParent(S.URI.file(l.path),E))return!0;return!1}};e.$I6b=w,e.$I6b=w=Ee([te(0,c.$$i),te(1,R.$Xh),te(2,f.$F6b),te(3,h.$z6b),te(4,C.$_j),te(5,v.$Jk)],w),e.$J6b=(0,P.$Qh)("applicationStorageMainService");let $=class extends g.$_o{constructor(u,E){super(),this.s=u,this.U=E,this.whenReady=this.U.applicationStorage.whenInit}O(){return this.U.applicationStorage.whenInit}P(u){if(u===-1)return this.U.applicationStorage.storage}Q(u){if(u===-1)return this.s.defaultProfile.globalStorageHome.with({scheme:m.Schemas.file}).fsPath}r(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}R(){throw new Error("Switching storage profile is unsupported from main process")}S(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.$K6b=$,e.$K6b=$=Ee([te(0,y.$Lk),te(1,e.$H6b)],$)}),define(ie[287],ne([0,1,86,28,103,99,8,2,4,18,6,25,241,242,95,126,17]),function(J,e,S,A,s,R,C,P,h,c,g,b,y,f,v,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A8b=e.$z8b=e.$y8b=e.$x8b=void 0;async function $(i,a,r,t,n){let o;for(let p=3;p&&(o?.dispose(),o=await new d(i,a,r,t,n).waitForReady(),!(n&&s.$ig[n]||!s.$ig[o.tunnelLocalPort]));p--);return o}class d extends P.$Sc{constructor(a,r,t,n,o){super(),this.m=r,this.n=o,this.privacy=m.TunnelPrivacyId.Private,this.j=new Map,this.a=a,this.b=S.createServer(),this.c=new C.$Tg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=p=>this.r(p),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=n,this.tunnelRemoteHost=t}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(r=>{r()})}async waitForReady(){const a=this.n??this.tunnelRemotePort,r=(0,m.$iv)(this.m)?"0.0.0.0":"127.0.0.1";let t=await(0,s.$jg)(a,2,1e3,r),n=null;return this.b.listen(t,this.m),await this.c.wait(),n=this.b.address(),n||(t=0,this.b.listen(t,this.m),await this.c.wait(),n=this.b.address()),this.tunnelLocalPort=n.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${n.port}`,this}async r(a){a.pause();const r=(0,m.$gv)(this.tunnelRemoteHost)||(0,m.$iv)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,t=await(0,y.$7k)(this.a,r,this.tunnelRemotePort),n=t.getSocket(),o=t.readEntireBuffer();t.dispose(),o.byteLength>0&&a.write(o.buffer),a.on("end",()=>{a.localAddress&&this.j.delete(a.localAddress),n.end()}),a.on("close",()=>n.end()),a.on("error",()=>{a.localAddress&&this.j.delete(a.localAddress),n instanceof R.$Fh?n.socket.destroy():n.end()}),n instanceof R.$Fh?this.t(a,n):this.s(a,n),a.localAddress&&this.j.set(a.localAddress,()=>{a.end(),n.end()})}s(a,r){r.onClose(()=>a.destroy()),r.onEnd(()=>a.end()),r.onData(t=>a.write(t.buffer)),a.on("data",t=>r.write(w.$ce.wrap(t))),a.resume()}t(a,r){const t=r.socket;t.on("end",()=>a.end()),t.on("close",()=>a.end()),t.on("error",()=>{a.destroy()}),t.pipe(a),a.pipe(t)}}e.$x8b=d;let u=class extends m.$lv{constructor(a,r,t,n,o){super(r,o),this.u=a,this.v=t,this.w=n}isPortPrivileged(a){return(0,m.$jv)(a,this.l,h.OS,A.release())}s(a,r,t,n,o,p,O,D){const k=this.r(r,t);if(k)return++k.refcount,k.value;if((0,m.$dv)(a))return this.t(a,r,t,o,p,O,D);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${r}:${t} on local port ${o}.`);const I={commit:this.w.commit,quality:this.w.quality,addressProvider:a,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},j=$(I,n,r,t,o);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(r,t,j),j}}};e.$y8b=u,e.$y8b=u=Ee([te(0,f.$1k),te(1,g.$$i),te(2,v.$4k),te(3,b.$qj),te(4,c.$ki)],u);let E=class extends u{constructor(a,r,t,n,o){super(a,r,t,n,o)}};e.$z8b=E,e.$z8b=E=Ee([te(0,f.$1k),te(1,g.$$i),te(2,v.$4k),te(3,b.$qj),te(4,c.$ki)],E);let l=class extends P.$Sc{constructor(a,r,t,n,o){super(),this.b=a,this.c=r,this.f=t,this.g=n,this.h=o,this.a=new Map}async openTunnel(a,r,t,n,o,p,O,D,k){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${t}:${n} on local port ${p}.`),!this.a.has(a)){const I=new E(this.b,this.c,this.g,this.f,this.h);this.B(I),this.a.set(a,I),I.onTunnelClosed(async()=>{(await I.tunnels).length===0&&(I.dispose(),this.a.delete(a))})}return this.a.get(a).openTunnel(r,t,n,o,p,O,D,k)}};e.$A8b=l,e.$A8b=l=Ee([te(0,f.$1k),te(1,g.$$i),te(2,b.$qj),te(3,v.$4k),te(4,c.$ki)],l)}),define(ie[100],ne([0,1,8,22,3,18,24,20,6,25,50,48]),function(J,e,S,A,s,R,C,P,h,c,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W7b=e.$V7b=void 0;function y(v,m,w){return`${w.updateUrl}/api/update/${v}/${m}/${w.commit}`}e.$V7b=y;let f=class{get state(){return this.b}d(m){this.j.info("update#setState",m.type),this.b=m,this.c.fire(m)}constructor(m,w,$,d,u,E){this.f=m,this.g=w,this.h=$,this.i=d,this.j=u,this.k=E,this.b=b.$tU.Uninitialized,this.c=new s.$Od,this.onStateChange=this.c.event,m.when(3).finally(()=>this.l())}async l(){if(!this.h.isBuilt){this.d(b.$tU.Disabled(0));return}if(this.h.disableUpdates){this.d(b.$tU.Disabled(1)),this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.d(b.$tU.Disabled(3)),this.j.info("update#ctor - updates are disabled as there is no update URL");return}const m=this.g.getValue("update.mode"),w=this.m(m);if(!w){this.d(b.$tU.Disabled(2)),this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(w),!this.a){this.d(b.$tU.Disabled(4)),this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.d(b.$tU.Idle(this.q())),m==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}m==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,$=>this.j.error($))}m(m){return m==="none"?void 0:this.k.quality}n(m=60*60*1e3){return(0,S.$Vg)(m).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(m){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.t(m)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.o(this.state)}async o(m){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(m=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${m}`),!m&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},A.CancellationToken.None)).res.statusCode===204}catch(w){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(w);return}}async _applySpecificUpdate(m){}q(){return 1}r(){}};e.$W7b=f,e.$W7b=f=Ee([te(0,P.$z6b),te(1,R.$ki),te(2,C.$x6b),te(3,g.$Wo),te(4,h.$$i),te(5,c.$qj)],f)}),define(ie[288],ne([0,1,15,54,3,2,18,24,20,6,25,50,26,48,100]),function(J,e,S,A,s,R,C,P,h,c,g,b,y,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X7b=void 0;let m=class extends v.$W7b{get v(){return s.Event.fromNodeEventEmitter(S.autoUpdater,"error",($,d)=>d)}get w(){return s.Event.fromNodeEventEmitter(S.autoUpdater,"update-not-available")}get x(){return s.Event.fromNodeEventEmitter(S.autoUpdater,"update-available",($,d,u)=>({url:d,version:u,productVersion:u}))}get y(){return s.Event.fromNodeEventEmitter(S.autoUpdater,"update-downloaded",($,d,u,E)=>({releaseNotes:d,version:u,productVersion:u,date:E}))}constructor($,d,u,E,l,i,a){super($,d,E,l,i,a),this.z=u,this.u=new R.$Rc,$.setRelaunchHandler(this)}handleRelaunch($){return $?.addArgs||$?.removeArgs||this.state.type!=="ready"?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B($){this.j.error("UpdateService error:",$);const d=this.state.type==="checking for updates"&&this.state.explicit?$:void 0;this.d(f.$tU.Idle(1,d))}s($){let d;this.k.darwinUniversalAssetId?d=this.k.darwinUniversalAssetId:d=process.arch==="x64"?"darwin":"darwin-arm64";const u=(0,v.$V7b)(d,$,this.k);try{S.autoUpdater.setFeedURL({url:u})}catch(E){this.j.error("Failed to set update feed URL",E);return}return u}t($){this.d(f.$tU.CheckingForUpdates($)),S.autoUpdater.checkForUpdates()}E($){this.state.type==="checking for updates"&&this.d(f.$tU.Downloading($))}F($){this.state.type==="downloading"&&(this.z.publicLog2("update:downloaded",{version:$.version}),this.d(f.$tU.Ready($)))}G(){this.state.type==="checking for updates"&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(f.$tU.Idle(1)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),S.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};e.$X7b=m,Ee([A.$ih],m.prototype,"v",null),Ee([A.$ih],m.prototype,"w",null),Ee([A.$ih],m.prototype,"x",null),Ee([A.$ih],m.prototype,"y",null),e.$X7b=m=Ee([te(0,h.$z6b),te(1,C.$ki),te(2,y.$dl),te(3,P.$x6b),te(4,b.$Wo),te(5,c.$$i),te(6,g.$qj)],m)}),define(ie[289],ne([0,1,47,45,8,3,9,24,20,6,26,48]),function(J,e,S,A,s,R,C,P,h,c,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z7b=void 0;let y=class{get state(){return this.a}d(m){this.g.info("update#setState",m.type),this.a=m,this.b.fire(m)}constructor(m,w,$){if(this.f=m,this.g=$,this.a=b.$tU.Uninitialized,this.b=new R.$Od,this.onStateChange=this.b.event,w.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(b.$tU.Idle(this.k())),this.h(30*1e3).then(void 0,d=>this.g.error(d))}h(m=60*60*1e3){return(0,s.$Vg)(m).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(m){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(m)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(m){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(m=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${m}`),!m&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(m){}};y=Ee([te(0,h.$z6b),te(1,P.$x6b),te(2,c.$$i)],y);let f=class extends y{constructor(m,w,$,d,u,E){super($,d,u),this.o=m,this.p=w,this.q=E;const l=(0,A.watch)(C.$mc(this.o)),i=R.Event.fromNodeEventEmitter(l,"change",(n,o)=>o),a=R.Event.filter(i,n=>n==="current"),t=R.Event.debounce(a,(n,o)=>o,2e3)(()=>this.checkForUpdates(!1));$.onWillShutdown(()=>{t.dispose(),l.close()})}m(){this.d(b.$tU.CheckingForUpdates(!1)),this.u().then(m=>{m?this.d(b.$tU.Ready({version:"something",productVersion:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(b.$tU.Idle(2)))},m=>{this.g.error(m),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(b.$tU.Idle(2,m.message||m))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,S.spawn)("sleep 3 && "+C.$nc(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const m=await new Promise(($,d)=>(0,A.realpath)(`${C.$mc(this.o)}/current`,(u,E)=>u?d(u):$(E))),w=C.$nc(m);return this.p!==w}isLatestVersion(){return this.u().then(void 0,m=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.$Z7b=f,e.$Z7b=f=Ee([te(2,h.$z6b),te(3,P.$x6b),te(4,c.$$i),te(5,g.$dl)],f)}),define(ie[29],ne([0,1,4,5,68,67,25,18,24,9,90]),function(J,e,S,A,s,R,C,P,h,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a7b=e.$_6b=e.$$6b=e.OpenContext=e.$06b=void 0,e.$06b=(0,A.$Qh)("windowsMainService");var b;(function(m){m[m.CLI=0]="CLI",m[m.DOCK=1]="DOCK",m[m.MENU=2]="MENU",m[m.DIALOG=3]="DIALOG",m[m.DESKTOP=4]="DESKTOP",m[m.API=5]="API"})(b||(e.OpenContext=b={}));function y(m,w,$){const d=m.get(R.$L6b),u=m.get(C.$qj),E=m.get(P.$ki),l=m.get(h.$x6b),i=E.getValue("window"),a={backgroundColor:d.getBackgroundColor(),minWidth:s.$jC.WIDTH,minHeight:s.$jC.HEIGHT,title:u.nameLong,...$,webPreferences:{enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,s.$qC)(i?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",...$?.webPreferences,sandbox:!0},experimentalDarkMode:!0};return w&&(a.x=w.x,a.y=w.y,a.width=w.width,a.height=w.height),S.$l?a.icon=(0,c.$jc)(l.appRoot,"resources/linux/code.png"):S.$j&&!l.isBuilt&&(a.icon=(0,c.$jc)(l.appRoot,"resources/win32/code_150x150.png")),S.$k&&(a.acceptFirstMouse=!0,i?.clickThroughInactive===!1&&(a.acceptFirstMouse=!1)),a}e.$$6b=y;function f(m){const w=m.get(e.$06b),$=m.get(g.$96b),d=w.getFocusedWindow()??$.getFocusedWindow();if(d)return d;const u=w.getLastActiveWindow(),E=$.getLastActiveWindow();return u&&E?u.lastFocusTime<E.lastFocusTime?E:u:u??E}e.$_6b=f;function v(m){let w,$=Number.MIN_VALUE;for(const d of m)d.lastFocusTime>$&&($=d.lastFocusTime,w=d);return w}e.$a7b=v}),define(ie[290],ne([0,1,15,22,3,55,2,32,116,6,81,29]),function(J,e,S,A,s,R,C,P,h,c,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b7b=void 0;var y;(function(v){v[v.Initial=1]="Initial",v[v.StoredCredentialsUsed=2]="StoredCredentialsUsed",v[v.LoginDialogShown=3]="LoginDialogShown"})(y||(y={}));let f=class extends C.$Sc{constructor(m,w,$,d){super(),this.g=m,this.h=w,this.j=$,this.m=d,this.a="proxy-credentials://",this.b=void 0,this.c=y.Initial,this.f=void 0,this.n()}n(){const m=s.Event.fromNodeEventEmitter(S.app,"login",(w,$,d,u,E)=>({event:w,webContents:$,req:d,authInfo:u,callback:E}));this.B(m(this.r,this))}async r({event:m,authInfo:w,req:$,callback:d}){if(!w.isProxy)return;if(!this.b&&this.c===y.LoginDialogShown&&$.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}m.preventDefault();let u;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),u=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.s(w);try{u=await this.b}finally{this.b=void 0}}d(u?.username,u?.password)}async s(m){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const w=await this.t(m);if(w)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),w;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async t(m){this.g.trace("auth#doResolveProxyCredentials - enter",m);const w=String((0,R.$Ei)({scheme:m.scheme,host:m.host,port:m.port}));let $,d;try{const i=this.m.get(this.a+w,-1);if(i){const a=JSON.parse(await this.j.decrypt(i));$=a.username,d=a.password}}catch(i){this.g.error(i)}if(this.c!==y.StoredCredentialsUsed&&typeof $=="string"&&typeof d=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=y.StoredCredentialsUsed,{username:$,password:d};const u=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!u){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${u.id} to handle proxy login`);const E={authInfo:m,username:this.f?.username??$,password:this.f?.password??d,replyChannel:`vscode:proxyAuthResponse:${(0,P.$fg)()}`};u.sendWhenReady("vscode:openProxyAuthenticationDialog",A.CancellationToken.None,E),this.c=y.LoginDialogShown;const l=await new Promise(i=>{const a=async(r,t,n)=>{if(t===E.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${u.id}`),u.win?.webContents.off("ipc-message",a),n){const o={username:n.username,password:n.password};try{if(n.remember){const p=await this.j.encrypt(JSON.stringify(o));this.m.store(this.a+w,p,-1,1)}else this.m.remove(this.a+w,-1)}catch(p){this.g.error(p)}i({username:o.username,password:o.password})}else i(void 0)};u.win?.webContents.on("ipc-message",a)});return this.f=l,l}};e.$b7b=f,e.$b7b=f=Ee([te(0,c.$$i),te(1,b.$06b),te(2,h.$cU),te(3,g.$J6b)],f)}),define(ie[291],ne([0,1,15,23,4,7,21,18,62,5,6,127,29]),function(J,e,S,A,s,R,C,P,h,c,g,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C7b=e.$B7b=e.ID=void 0,e.ID="launchMainService",e.$B7b=(0,c.$Qh)(e.ID);let f=class{constructor(m,w,$,d){this.a=m,this.b=w,this.c=$,this.d=d}async start(m,w){this.a.trace("Received data from other instance: ",m,w),s.$k&&S.app.focus({steal:!0});const $=this.e(m);if($.length){let d=Promise.resolve();if(this.b.getWindowCount()===0){const u=(0,A.$Ob)(await this.b.openEmptyWindow({context:4}));u&&(d=u.ready())}d.then(()=>{for(const{uri:u,originalUrl:E}of $)this.c.open(u,{originalUrl:E})})}else return this.f(m,w)}e(m){return m["open-url"]&&m._urls&&m._urls.length>0?(0,A.$Hb)(m._urls.map(w=>{try{return{uri:R.URI.parse(w),originalUrl:w}}catch{return null}})):[]}async f(m,w){const $=(0,h.$Ol)(w)?0:4;let d=[];const u=m.wait&&m.waitMarkerFilePath?R.URI.file(m.waitMarkerFilePath):void 0,E=m.remote||void 0,l={context:$,cli:m,userEnv:w,waitMarkerFileURI:u,remoteAuthority:E,forceProfile:m.profile,forceTempProfile:m["profile-temp"]};if(m.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(m.extensionDevelopmentPath,l);else if(!m._.length&&!m["folder-uri"]&&!m["file-uri"]){let i=!1;if(m["new-window"]||m["unity-launch"]||l.forceProfile||l.forceTempProfile)i=!0;else if(m["reuse-window"])i=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":i=!0;break;case"off":i=!1;break;default:i=!s.$k}if(i)d=await this.b.open({...l,forceNewWindow:!0,forceEmpty:!0});else{const a=this.b.getLastActiveWindow();a?(this.b.openExistingWindow(a,l),d=[a]):d=await this.b.open({...l,forceEmpty:!0})}}else d=await this.b.open({...l,forceNewWindow:m["new-window"],preferNewWindow:!m["reuse-window"]&&!m.wait,forceReuseWindow:m["reuse-window"],diffMode:m.diff,mergeMode:m.merge,addMode:m.add,noRecentEntry:!!m["skip-add-to-recently-opened"],gotoLineMode:m.goto});if(u&&d.length===1&&d[0])return Promise.race([d[0].whenClosedOrLoaded,(0,C.whenDeleted)(u.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};e.$C7b=f,e.$C7b=f=Ee([te(0,g.$$i),te(1,y.$06b),te(2,b.$iU),te(3,P.$ki)],f)}),define(ie[292],ne([0,1,2,20,52,30,8,29]),function(J,e,S,A,s,R,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f8b=void 0;let h=class extends S.$Sc{constructor(g,b,y){super(),this.a=b,this.b=y,this.B(g.onWillLoadWindow(f=>{f.reason===2&&this.c(f.window)})),this.B(g.onBeforeCloseWindow(f=>this.c(f))),this.B(new C.$7g(()=>this.g(),30*1e3)).schedule()}async c(g){const b=this.f(g),y=this.a.getProfileForWorkspace(b);y?.isTransient&&(this.a.unsetWorkspace(b,y.isTransient),y.isTransient&&await this.a.cleanUpTransientProfiles())}f(g){return g.openedWorkspace??(0,R.$5h)(g.backupPath,g.isExtensionDevelopmentHost)}g(){const g=this.a.getAssociatedEmptyWindows();if(g.length===0)return;const b=this.b.getWindows().map(y=>this.f(y));for(const y of g)b.some(f=>f.id===y.id)||this.a.unsetWorkspace(y,!1)}};e.$f8b=h,e.$f8b=h=Ee([te(0,A.$z6b),te(1,s.$F6b),te(2,P.$06b)],h)}),define(ie[60],ne([0,1,15,2,3,6,313,8,13,29,73,26,20,75,37,4,131]),function(J,e,S,A,s,R,C,P,h,c,g,b,y,f,v,m,w){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$f7b=e.$e7b=void 0;function d(l){return typeof l.responseWindowId=="number"}let u=class extends A.$Sc{static{$=this}static{this.a=0}static{this.b=new Map}static getAll(){return Array.from($.b.values())}constructor(i,a,r){super(),this.t=i,this.u=a,this.w=r,this.c=String(++$.a),this.f=this.B(new s.$Od),this.onStdout=this.f.event,this.g=this.B(new s.$Od),this.onStderr=this.g.event,this.h=this.B(new s.$Od),this.onMessage=this.h.event,this.j=this.B(new s.$Od),this.onExit=this.j.event,this.m=this.B(new s.$Od),this.onCrash=this.m.event,this.n=void 0,this.r=void 0,this.s=void 0}y(i,a){let r;switch(this.s?.correlationId?r=`[UtilityProcess id: ${this.s?.correlationId}, type: ${this.s?.type}, pid: ${this.r??"<none>"}]: ${i}`:r=`[UtilityProcess type: ${this.s?.type}, pid: ${this.r??"<none>"}]: ${i}`,a){case g.default.Error:this.t.error(r);break;case g.default.Warning:this.t.warn(r);break;case g.default.Info:this.t.trace(r);break}}z(){return this.n?(this.y("Cannot start utility process because it is already running...",g.default.Error),!1):!0}start(i){const a=this.C(i);return a&&i.payload&&this.postMessage(i.payload),a}C(i){if(!this.z())return!1;this.s=i;const a=`${this.s.type}-${this.c}`,r=h.$dg.asFileUri("bootstrap-fork.js").fsPath,t=this.s.args??[],n=this.s.execArgv??[],o=this.s.allowLoadingUnsignedLibraries,p=this.s.forceAllocationsToV8Sandbox,O="pipe",D=this.D(i);return this.y("creating new...",g.default.Info),this.n=S.utilityProcess.fork(r,t,{serviceName:a,env:D,execArgv:n,allowLoadingUnsignedLibraries:o,forceAllocationsToV8Sandbox:p,stdio:O}),this.F(this.n,this.s,a),!0}D(i){const a=i.env?{...i.env}:{...(0,v.$8m)(process.env)};a.VSCODE_AMD_ENTRYPOINT=i.entryPoint,typeof i.parentLifecycleBound=="number"&&(a.VSCODE_PARENT_PID=String(i.parentLifecycleBound)),a.VSCODE_CRASH_REPORTER_PROCESS_TYPE=i.type,m.$j&&((0,w.isUNCAccessRestrictionsDisabled)()?a.NODE_DISABLE_UNC_ACCESS_CHECKS="1":a.NODE_UNC_HOST_ALLOWLIST=(0,w.getUNCHostAllowlist)().join("\\")),(0,f.$Bl)(a);for(const r of Object.keys(a))a[r]=String(a[r]);return a}F(i,a,r){if(i.stdout){const t=new C.StringDecoder("utf-8");this.B(s.Event.fromNodeEventEmitter(i.stdout,"data")(n=>this.f.fire(typeof n=="string"?n:t.write(n))))}if(i.stderr){const t=new C.StringDecoder("utf-8");this.B(s.Event.fromNodeEventEmitter(i.stderr,"data")(n=>this.g.fire(typeof n=="string"?n:t.write(n))))}this.B(s.Event.fromNodeEventEmitter(i,"message")(t=>this.h.fire(t))),this.B(s.Event.fromNodeEventEmitter(i,"spawn")(()=>{this.r=i.pid,typeof i.pid=="number"&&$.b.set(i.pid,{pid:i.pid,name:d(a)?`${a.type} [${a.responseWindowId}]`:a.type}),this.y("successfully created",g.default.Info)})),this.B(s.Event.fromNodeEventEmitter(i,"exit")(t=>{this.y(`received exit event with code ${t}`,g.default.Info),this.j.fire({pid:this.r,code:t,signal:"unknown"}),this.G()})),this.B(s.Event.fromNodeEventEmitter(S.app,"child-process-gone",(t,n)=>({event:t,details:n}))(({details:t})=>{t.type==="Utility"&&t.name===r&&(this.y(`crashed with code ${t.exitCode} and reason '${t.reason}'`,g.default.Error),this.u.publicLog2("utilityprocesscrash",{type:a.type,reason:t.reason,code:t.exitCode}),this.m.fire({pid:this.r,code:t.exitCode,reason:t.reason}),this.G())}))}once(i,a){const r=this.B(this.h.event(t=>{t===i&&(r.dispose(),a())}))}postMessage(i,a){this.n&&this.n.postMessage(i,a)}connect(i){const{port1:a,port2:r}=new S.MessageChannelMain;return this.postMessage(i,[r]),a}enableInspectPort(){if(!this.n||typeof this.r!="number")return!1;this.y("enabling inspect port",g.default.Info);const i=process;return typeof i._debugProcess=="function"?(i._debugProcess(this.r),!0):!1}kill(){if(!this.n)return;this.y("attempting to kill the process...",g.default.Info),this.n.kill()?(this.y("successfully killed the process",g.default.Info),this.G()):this.y("unable to kill the process",g.default.Warning)}G(){typeof this.r=="number"&&$.b.delete(this.r),this.n=void 0}async waitForExit(i){this.n&&(this.y("waiting to exit...",g.default.Info),await Promise.race([s.Event.toPromise(this.onExit),(0,P.$Vg)(i)]),this.n&&(this.y(`did not exit within ${i}ms, will kill it now...`,g.default.Info),this.kill()))}};e.$e7b=u,e.$e7b=u=$=Ee([te(0,R.$$i),te(1,b.$dl),te(2,y.$z6b)],u);let E=class extends u{constructor(i,a,r,t){super(i,r,t),this.H=a}start(i){const a=this.H.getWindowById(i.responseWindowId);if(!a?.win||a.win.isDestroyed()||a.win.webContents.isDestroyed())return this.y("Refusing to start utility process because requesting window cannot be found or is destroyed...",g.default.Error),!0;if(!super.C(i))return!1;this.I(a.win,i);const t=this.connect(i.payload);return a.win.webContents.postMessage(i.responseChannel,i.responseNonce,[t]),!0}I(i,a){a.windowLifecycleBound&&(this.B(s.Event.filter(this.w.onWillLoadWindow,r=>r.window.win===i)(()=>this.kill())),this.B(s.Event.fromNodeEventEmitter(i,"closed")(()=>this.kill())))}};e.$f7b=E,e.$f7b=E=Ee([te(0,R.$$i),te(1,c.$06b),te(2,b.$dl),te(3,y.$z6b)],E)}),define(ie[293],ne([0,1,14,6,20,8,60,29,26]),function(J,e,S,A,s,R,C,P,h){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$m7b=void 0;let g=class{static{c=this}static{this.a=0}constructor(y,f,v,m){this.d=y,this.f=f,this.g=v,this.h=m,this.b=new Map,this.c=!1,this.f.onWillShutdown(w=>{this.c=!0,w.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}i(y){const f=this.b.get(y);if(!f)throw new Error("Unknown extension host!");return f}onDynamicStdout(y){return this.i(y).onStdout}onDynamicStderr(y){return this.i(y).onStderr}onDynamicMessage(y){return this.i(y).onMessage}onDynamicExit(y){return this.i(y).onExit}async createExtensionHost(){if(this.c)throw(0,S.$6)();const y=String(++c.a),f=new C.$f7b(this.d,this.g,this.h,this.f);return this.b.set(y,f),f.onExit(({pid:v,code:m,signal:w})=>{this.d.info(`Extension host with pid ${v} exited with code: ${m}, signal: ${w}.`),setTimeout(()=>{f.dispose(),this.b.delete(y)})}),{id:y}}async start(y,f){if(this.c)throw(0,S.$6)();this.i(y).start({...f,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:f.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:y})}async enableInspectPort(y){if(this.c)throw(0,S.$6)();const f=this.b.get(y);return f?f.enableInspectPort():!1}async kill(y){if(this.c)throw(0,S.$6)();const f=this.b.get(y);f&&f.kill()}async _killAllNow(){for(const[,y]of this.b)y.kill()}async _waitForAllExit(y){const f=[];for(const[,v]of this.b)f.push(v.waitForExit(y));return R.Promises.settled(f).then(()=>{})}};e.$m7b=g,e.$m7b=g=c=Ee([te(0,A.$$i),te(1,s.$z6b),te(2,P.$06b),te(3,h.$dl)],g)}),define(ie[294],ne([0,1,38,8,2,24,20,6,41,39,66,60,51,89,12,247]),function(J,e,S,A,s,R,C,P,h,c,g,b,y,f,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P7b=void 0;let w=class extends s.$Sc{constructor(d,u,E,l,i,a,r,t){super(),this.c=d,this.f=u,this.g=E,this.h=l,this.j=i,this.m=a,this.n=r,this.r=t,this.a=new A.$Tg,this.b=void 0,this.w=void 0,this.y=void 0,this.s()}s(){S.$uT.on(m.$N7b.request,(d,u)=>this.t(d,u,m.$N7b.response)),S.$uT.on(m.$O7b.request,(d,u)=>this.t(d,u,m.$O7b.response)),this.B(this.j.onWillShutdown(()=>this.u()))}async t(d,u,E){this.m.trace(`[SharedProcess] onWindowConnection for: ${E}`),this.a.isOpen()||this.a.open(),await this.whenReady();const l=await this.connect(E);if(d.sender.isDestroyed())return l.close();d.sender.postMessage(E,u,[l])}u(){this.m.trace("[SharedProcess] onWillShutdown"),this.b?.postMessage(m.$M7b.exit),this.b=void 0}whenReady(){return this.w||(this.w=(async()=>{await this.z;const d=new A.$dh;this.b?this.b.once(m.$M7b.initDone,()=>d.complete()):S.$uT.once(m.$M7b.initDone,()=>d.complete()),await d.p,this.m.trace("[SharedProcess] Overall ready")})()),this.w}get z(){return this.y||(this.y=(async()=>{await this.a.wait(),this.C();const d=new A.$dh;this.b?this.b.once(m.$M7b.ipcReady,()=>d.complete()):S.$uT.once(m.$M7b.ipcReady,()=>d.complete()),await d.p,this.m.trace("[SharedProcess] IPC ready")})()),this.y}C(){this.b=this.B(new b.$e7b(this.m,y.$po,this.j));const d=(0,f.$mm)(this.g.args,this.g.isBuilt);let u;d.port&&(u=["--nolazy"],d.break?u.push(`--inspect-brk=${d.port}`):u.push(`--inspect=${d.port}`)),this.b.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.D(),execArgv:u})}D(){return{machineId:this.c,sqmId:this.f,codeCachePath:this.g.codeCachePath,profiles:{home:this.h.profilesHome,all:this.h.profiles},args:this.g.args,logLevel:this.n.getLogLevel(),loggers:this.n.getRegisteredLoggers(),policiesData:this.r.serialize()}}async connect(d){return await this.z,(0,v.$Kf)(this.b).connect(d)}};e.$P7b=w,e.$P7b=w=Ee([te(2,R.$x6b),te(3,h.$Lk),te(4,C.$z6b),te(5,P.$$i),te(6,g.$46b),te(7,c.$mn)],w)}),define(ie[295],ne([0,1,24,89,20,6,51,60,110,38,2,3,37,18,13]),function(J,e,S,A,s,R,C,P,h,c,g,b,y,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p8b=void 0;let m=class extends g.$Sc{constructor($,d,u,E,l){super(),this.f=$,this.g=d,this.h=u,this.j=E,this.m=l,this.a=void 0,this.b=new b.$Od,this.onRequestConnection=this.b.event,this.c=new b.$Od,this.onWillShutdown=this.c.event,this.j.onWillShutdown(()=>this.c.fire()),c.$uT.on("vscode:createPtyHostMessageChannel",(i,a)=>this.r(i,a)),this.B((0,g.$Qc)(()=>{c.$uT.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.a=new P.$e7b(this.m,C.$po,this.j);const $=(0,A.$lm)(this.h.args,this.h.isBuilt),d=$.port?["--nolazy",`--inspect${$.break?"-brk":""}=${$.port}`]:void 0;this.a.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:d,args:["--logsPath",this.h.logsHome.with({scheme:v.Schemas.file}).fsPath],env:this.n()});const u=this.a.connect(),E=new h.$CT(u,"ptyHost"),l=new g.$Rc;return l.add(E),l.add((0,g.$Qc)(()=>{this.a?.kill(),this.a?.dispose(),this.a=void 0})),{client:E,store:l,onDidProcessExit:this.a.onExit}}n(){this.h.unsetSnapExportedVariables();const $={...(0,y.$8m)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this.f.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this.f.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this.f.scrollback)},d=this.g.getValue("terminal.integrated.developer.ptyHost.latency");d&&typeof d=="number"&&($.VSCODE_LATENCY=String(d));const u=this.g.getValue("terminal.integrated.developer.ptyHost.startupDelay");return u&&typeof u=="number"&&($.VSCODE_STARTUP_DELAY=String(u)),this.h.restoreSnapExportedVariables(),$}r($,d){this.b.fire();const u=this.a.connect();if($.sender.isDestroyed()){u.close();return}$.sender.postMessage("vscode:createPtyHostMessageChannelResult",d,[u])}};e.$p8b=m,e.$p8b=m=Ee([te(1,f.$ki),te(2,S.$x6b),te(3,s.$z6b),te(4,R.$$i)],m)}),define(ie[296],ne([0,1,2,5,6,29,60,26,55,3,8,20]),function(J,e,S,A,s,R,C,P,h,c,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o8b=e.$n8b=void 0,e.$n8b=(0,A.$Qh)("utilityProcessWorker");let y=class extends S.$Sc{constructor(m,w,$,d){super(),this.b=m,this.c=w,this.f=$,this.g=d,this.a=new Map}async createWorker(m){const w=`window: ${m.reply.windowId}, moduleId: ${m.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${w})`);const $=this.h(m);this.a.has($)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${w})`),this.disposeWorker(m));const d=new f(this.b,this.c,this.f,this.g,m);if(!d.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set($,d);const u=new g.$dh;return c.Event.once(d.onDidTerminate)(E=>{E.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${E.code}, signal: ${E.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${E.code}, signal: ${E.signal}`),this.a.delete($),u.complete({reason:E})}),u.p}h(m){return(0,h.$Ei)({moduleId:m.process.moduleId,windowId:m.reply.windowId})}async disposeWorker(m){const w=this.h(m),$=this.a.get(w);$&&(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${m.reply.windowId}, moduleId: ${m.process.moduleId})`),$.kill(),this.a.delete(w))}};e.$o8b=y,e.$o8b=y=Ee([te(0,s.$$i),te(1,R.$06b),te(2,P.$dl),te(3,b.$z6b)],y);let f=class extends S.$Sc{constructor(m,w,$,d,u){super(),this.c=m,this.f=w,this.g=$,this.h=d,this.j=u,this.a=this.B(new c.$Od),this.onDidTerminate=this.a.event,this.b=new C.$f7b(this.c,this.f,this.g,this.h),this.m()}m(){this.B(this.b.onExit(m=>this.a.fire({code:m.code,signal:m.signal}))),this.B(this.b.onCrash(m=>this.a.fire({code:m.code,signal:"ECRASH"})))}spawn(){const w=this.f.getWindowById(this.j.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.j.process.type,entryPoint:this.j.process.moduleId,parentLifecycleBound:w,windowLifecycleBound:!0,correlationId:`${this.j.reply.windowId}`,responseWindowId:this.j.reply.windowId,responseChannel:this.j.reply.channel,responseNonce:this.j.reply.nonce})}kill(){this.b.kill()}};f=Ee([te(0,s.$$i),te(1,R.$06b),te(2,P.$dl),te(3,b.$z6b)],f)}),define(ie[297],ne([0,1,15,3,2,273,29]),function(J,e,S,A,s,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$87b=void 0;let P=class extends s.$Sc{constructor(c){super(),this.b=c,this.a=this.B(new A.$Od),this.onFoundInFrame=this.a.event,this.B(new R.$77b)}async setIgnoreMenuShortcuts(c,g){let b;if(typeof c.windowId=="number"){const{windowId:y}=c,f=this.b.getWindowById(y);if(!f?.win)throw new Error(`Invalid windowId: ${y}`);b=f.win.webContents}else{const{webContentsId:y}=c;if(b=S.webContents.fromId(y),!b)throw new Error(`Invalid webContentsId: ${y}`)}b.isDestroyed()||b.setIgnoreMenuShortcuts(g)}async findInFrame(c,g,b,y){const v=this.c(c,g);if(typeof v.findInFrame=="function"){v.findInFrame(b,{findNext:y.findNext,forward:y.forward});const m=(w,$)=>{$.finalUpdate&&(this.a.fire($),v.removeListener("found-in-frame",m))};v.on("found-in-frame",m)}}async stopFindInFrame(c,g,b){const f=this.c(c,g);typeof f.stopFindInFrame=="function"&&f.stopFindInFrame(b.keepSelection?"keepSelection":"clearSelection")}c(c,g){const b=this.b.getWindowById(c.windowId);if(!b?.win)throw new Error(`Invalid windowId: ${c}`);const y=b.win.webContents.mainFrame.framesInSubtree.find(f=>f.name===g);if(!y)throw new Error(`Unknown frame: ${g}`);return y}};e.$87b=P,e.$87b=P=Ee([te(0,C.$06b)],P)}),define(ie[298],ne([0,1,15,2,4,19,7,18,20,6,34,29,128,30]),function(J,e,S,A,s,R,C,P,h,c,g,b,y,f){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$$7b=e.$07b=e.$97b=void 0;let m=class extends A.$Sc{static{v=this}static{this.a="windowsState"}get state(){return this.b}constructor(l,i,a,r,t){super(),this.g=l,this.h=i,this.j=a,this.m=r,this.n=t,this.b=w(this.h.getItem(v.a)),this.c=void 0,this.f=!1,this.r()}r(){S.app.on("browser-window-blur",()=>{this.f||this.t()}),this.j.onBeforeCloseWindow(l=>this.u(l)),this.j.onBeforeShutdown(()=>this.s()),this.g.onDidChangeWindowsCount(l=>{l.newCount-l.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(l=>this.u(l))}s(){this.f=!0,this.t()}t(){const l=new Set,i={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!i.lastActiveWindow){let t=this.g.getLastActiveWindow();(!t||t.isExtensionDevelopmentHost)&&(t=this.g.getWindows().find(n=>!n.isExtensionDevelopmentHost)),t&&(i.lastActiveWindow=this.w(t),i.lastActiveWindow.uiState.mode===3&&l.add(i.lastActiveWindow.uiState.display))}const a=this.g.getWindows().find(t=>t.isExtensionDevelopmentHost&&!t.isExtensionTestHost);a&&(i.lastPluginDevelopmentHostWindow=this.w(a),i.lastPluginDevelopmentHostWindow.uiState.mode===3&&(l.has(i.lastPluginDevelopmentHostWindow.uiState.display)?s.$k&&!a.win?.isSimpleFullScreen()&&(i.lastPluginDevelopmentHostWindow.uiState.mode=1):l.add(i.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(i.openedWindows=this.g.getWindows().filter(t=>!t.isExtensionDevelopmentHost).map(t=>{const n=this.w(t);return n.uiState.mode===3&&(l.has(n.uiState.display)?s.$k&&n.windowId!==i.lastActiveWindow?.windowId&&!t.win?.isSimpleFullScreen()&&(n.uiState.mode=1):l.add(n.uiState.display)),n}));const r=d(i);this.h.setItem(v.a,r),this.f&&this.m.trace("[WindowsStateHandler] onBeforeShutdown",r)}u(l){if(this.j.quitRequested)return;const i=this.w(l);l.isExtensionDevelopmentHost&&!l.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=i:!l.isExtensionDevelopmentHost&&l.openedWorkspace&&this.b.openedWindows.forEach(a=>{const r=(0,f.$6h)(l.openedWorkspace)&&a.workspace?.id===l.openedWorkspace.id,t=(0,f.$1h)(l.openedWorkspace)&&a.folderUri&&R.$ng.isEqual(a.folderUri,l.openedWorkspace.uri);(r||t)&&(a.uiState=i.uiState)}),this.g.getWindowCount()===1&&(this.c=i)}w(l){return{windowId:l.id,workspace:(0,f.$6h)(l.openedWorkspace)?l.openedWorkspace:void 0,folderUri:(0,f.$1h)(l.openedWorkspace)?l.openedWorkspace.uri:void 0,backupPath:l.backupPath,remoteAuthority:l.remoteAuthority,uiState:l.serializeWindowState()}}getNewWindowState(l){const i=this.z(l),a=this.n.getValue("window");if(i.mode===3){let r;i.hasDefaultState?r=!!(a?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(a.newWindowDimensions)>=0):r=!!(this.j.wasRestarted||a?.restoreFullscreen),r||(i.mode=1)}return i}z(l){const i=this.g.getLastActiveWindow();if(!l.extensionTestsPath){if(l.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const p=l.workspace;if((0,f.$6h)(p)){const D=this.state.openedWindows.filter(k=>k.workspace&&k.workspace.id===p.id).map(k=>k.uiState);if(D.length)return D[0]}if((0,f.$1h)(p)){const D=this.state.openedWindows.filter(k=>k.folderUri&&R.$ng.isEqual(k.folderUri,p.uri)).map(k=>k.uiState);if(D.length)return D[0]}else if(l.backupPath){const D=this.state.openedWindows.filter(k=>k.backupPath===l.backupPath).map(k=>k.uiState);if(D.length)return D[0]}const O=this.c||this.state.lastActiveWindow;if(!i&&O)return O.uiState}let a;const r=S.screen.getAllDisplays();if(r.length===1)a=r[0];else{if(s.$k){const p=S.screen.getCursorScreenPoint();a=S.screen.getDisplayNearestPoint(p)}!a&&i&&(a=S.screen.getDisplayMatching(i.getBounds())),a||(a=S.screen.getPrimaryDisplay()||r[0])}let t=(0,y.$w6b)();t.x=Math.round(a.bounds.x+a.bounds.width/2-t.width/2),t.y=Math.round(a.bounds.y+a.bounds.height/2-t.height/2);const n=this.n.getValue("window");let o=!0;if(n?.newWindowDimensions){if(n.newWindowDimensions==="maximized")t.mode=0,o=!1;else if(n.newWindowDimensions==="fullscreen")t.mode=3,o=!1;else if((n.newWindowDimensions==="inherit"||n.newWindowDimensions==="offset")&&i){const p=i.serializeWindowState();p.mode===3?t.mode=3:t=p,o=t.mode!==3&&n.newWindowDimensions==="offset"}}return o&&(t=this.C(t)),t.hasDefaultState=!0,t}C(l){if(this.g.getWindows().length===0)return l;l.x=typeof l.x=="number"?l.x:0,l.y=typeof l.y=="number"?l.y:0;const i=this.g.getWindows().map(a=>a.getBounds());for(;i.some(a=>a.x===l.x||a.y===l.y);)l.x+=30,l.y+=30;return l}};e.$97b=m,e.$97b=m=v=Ee([te(0,b.$06b),te(1,g.$FN),te(2,h.$z6b),te(3,c.$$i),te(4,P.$ki)],m);function w(E){const l={openedWindows:[]},i=E||{openedWindows:[]};return i.lastActiveWindow&&(l.lastActiveWindow=$(i.lastActiveWindow)),i.lastPluginDevelopmentHostWindow&&(l.lastPluginDevelopmentHostWindow=$(i.lastPluginDevelopmentHostWindow)),Array.isArray(i.openedWindows)&&(l.openedWindows=i.openedWindows.map(a=>$(a))),l}e.$07b=w;function $(E){const l={uiState:E.uiState};return E.backupPath&&(l.backupPath=E.backupPath),E.remoteAuthority&&(l.remoteAuthority=E.remoteAuthority),E.folder&&(l.folderUri=C.URI.parse(E.folder)),E.workspaceIdentifier&&(l.workspace={id:E.workspaceIdentifier.id,configPath:C.URI.parse(E.workspaceIdentifier.configURIPath)}),l}function d(E){return{lastActiveWindow:E.lastActiveWindow&&u(E.lastActiveWindow),lastPluginDevelopmentHostWindow:E.lastPluginDevelopmentHostWindow&&u(E.lastPluginDevelopmentHostWindow),openedWindows:E.openedWindows.map(l=>u(l))}}e.$$7b=d;function u(E){return{workspaceIdentifier:E.workspace&&{id:E.workspace.id,configURIPath:E.workspace.configPath.toString()},folder:E.folderUri&&E.folderUri.toString(),backupPath:E.backupPath,remoteAuthority:E.remoteAuthority,uiState:E.uiState}}}),define(ie[53],ne([0,1,15,3,44,2,13,9,19,21,194,63,59,24,5,6,52,130,30,97,98]),function(J,e,S,A,s,R,C,P,h,c,g,b,y,f,v,m,w,$,d,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$36b=e.$26b=void 0,e.$26b=(0,v.$Qh)("workspacesManagementMainService");let l=class extends R.$Sc{constructor(a,r,t,n,o){super(),this.g=a,this.h=r,this.j=t,this.m=n,this.n=o,this.a=this.B(new A.$Od),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new A.$Od),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const a=(await c.Promises.readdir(this.c.with({scheme:C.Schemas.file}).fsPath)).map(r=>(0,h.$wg)(this.c,r,d.$di));for(const r of a){const t=(0,E.$Y6b)(r),n=await this.resolveLocalWorkspace(r);n?this.f.push({workspace:t,remoteAuthority:n.remoteAuthority}):await this.deleteUntitledWorkspace(t)}}catch(a){a.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${a}).`)}}resolveLocalWorkspace(a){return this.r(a,r=>c.Promises.readFile(r,"utf8"))}r(a,r){if(this.s(a)&&a.scheme===C.Schemas.file)try{const t=r(a.fsPath);return t instanceof Promise?t.then(n=>this.t(a,n),n=>{}):this.t(a,t)}catch{return}}s(a){return(0,d.$ei)(a,this.g)||(0,d.$ji)(a)}t(a,r){try{const t=this.u(a,r),n=(0,E.$Y6b)(a);return{id:n.id,configPath:n.configPath,folders:(0,u.$XU)(t.folders,n.configPath,h.$ng),remoteAuthority:t.remoteAuthority,transient:t.transient}}catch(t){this.h.warn(t.toString())}}u(a,r){const t=(0,s.$Xm)(r);if(t&&Array.isArray(t.folders))t.folders=t.folders.filter(n=>(0,u.$VU)(n));else throw new Error(`${a.toString(!0)} looks like an invalid workspace file.`);return t}async createUntitledWorkspace(a,r){const{workspace:t,storedWorkspace:n}=this.w(a,r),o=t.configPath.fsPath;return await c.Promises.mkdir((0,P.$mc)(o),{recursive:!0}),await c.Promises.writeFile(o,JSON.stringify(n,null,"	")),this.f.push({workspace:t,remoteAuthority:r}),t}w(a=[],r){const t=(Date.now()+Math.round(Math.random()*1e3)).toString(),n=(0,h.$wg)(this.c,t),o=(0,h.$wg)(n,d.$di),p=[];for(const O of a)p.push((0,u.$WU)(O.uri,!0,O.name,n,h.$ng));return{workspace:(0,E.$Y6b)(o),storedWorkspace:{folders:p,remoteAuthority:r}}}async getWorkspaceIdentifier(a){return(0,E.$Y6b)(a)}isUntitledWorkspace(a){return(0,d.$ei)(a.configPath,this.g)}async deleteUntitledWorkspace(a){this.isUntitledWorkspace(a)&&(await this.y(a),this.j.isEnabled()&&this.j.unsetWorkspace(a),this.a.fire(a))}async y(a){const r=(0,h.$kg)(a.configPath);try{await c.Promises.rm((0,P.$mc)(r));const t=(0,P.$jc)(this.g.workspaceStorageHome.with({scheme:C.Schemas.file}).fsPath,a.id);await c.Promises.exists(t)&&await c.Promises.writeFile((0,P.$jc)(t,"obsolete"),""),this.f=this.f.filter(n=>n.workspace.id!==a.id)}catch(t){this.h.warn(`Unable to delete untitled workspace ${r} (${t}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(a,r,t){if(!a||!a.win||!a.isReady||!await this.z(a,r,t))return;const o=await this.C(a,(0,E.$Y6b)(t));if(o)return this.b.fire({window:a,workspace:o.workspace}),o}async z(a,r,t){return t?(0,d.$6h)(a.openedWorkspace)&&h.$ng.isEqual(a.openedWorkspace.configPath,t)?!1:(0,$.$V6b)(r,t)?(await this.n.showMessageBox({type:"info",buttons:[(0,g.localize)(0,null)],message:(0,g.localize)(1,null,(0,h.$tg)(t)),detail:(0,g.localize)(2,null)},S.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async C(a,r){if(!a.config)return;a.focus();let t;return a.config.extensionDevelopmentPath||(a.config.backupPath?t=await this.m.registerWorkspaceBackup({workspace:r,remoteAuthority:a.remoteAuthority},a.config.backupPath):t=this.m.registerWorkspaceBackup({workspace:r,remoteAuthority:a.remoteAuthority})),(0,d.$6h)(a.openedWorkspace)&&this.isUntitledWorkspace(a.openedWorkspace)&&await this.deleteUntitledWorkspace(a.openedWorkspace),a.config.workspace=r,a.config.backupPath=t,{workspace:r,backupPath:t}}};e.$36b=l,e.$36b=l=Ee([te(0,f.$x6b),te(1,m.$$i),te(2,w.$F6b),te(3,b.$Q6b),te(4,y.$R6b)],l)}),define(ie[132],ne([0,1,15,38,22,5,29,30,53,12,6,60]),function(J,e,S,A,s,R,C,P,h,c,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i7b=e.$h7b=e.ID=void 0,e.ID="diagnosticsMainService",e.$h7b=(0,R.$Qh)(e.ID);let y=class{constructor(v,m,w){this.a=v,this.b=m,this.c=w}async getRemoteDiagnostics(v){const m=this.a.getWindows();return(await Promise.all(m.map(async $=>{const d=$.remoteAuthority;if(!d)return;const u=`vscode:getDiagnosticInfoResponse${$.id}`,E={includeProcesses:v.includeProcesses,folders:v.includeWorkspaceMetadata?await this.f($):void 0};return new Promise(l=>{$.sendWhenReady("vscode:getDiagnosticInfo",s.CancellationToken.None,{replyChannel:u,args:E}),A.$uT.once(u,(i,a)=>{a||l({hostName:d,errorMessage:`Unable to resolve connection to '${d}'.`}),l(a)}),setTimeout(()=>{l({hostName:d,errorMessage:`Connection to '${d}' could not be established`})},5e3)})}))).filter($=>!!$)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const v=[];for(const w of S.BrowserWindow.getAllWindows()){const $=this.a.getWindowById(w.id);$?v.push(await this.d($)):v.push(this.e(w))}const m=[];for(const{pid:w,name:$}of b.$e7b.getAll())m.push({pid:w,name:$});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:v,pidToNames:m,screenReader:!!S.app.accessibilitySupportEnabled,gpuFeatureStatus:S.app.getGPUFeatureStatus()}}async d(v){const m=await this.f(v),w=(0,c.$Kf)(v.win);return this.e(w,m,v.remoteAuthority)}e(v,m=[],w){return{id:v.id,pid:v.webContents.getOSProcessId(),title:v.getTitle(),folderURIs:m,remoteAuthority:w}}async f(v){const m=[],w=v.openedWorkspace;if((0,P.$1h)(w))m.push(w.uri);else if((0,P.$6h)(w)){const $=await this.b.resolveLocalWorkspace(w.configPath);$&&$.folders.forEach(u=>{m.push(u.uri)})}return m}};e.$i7b=y,e.$i7b=y=Ee([te(0,C.$06b),te(1,h.$26b),te(2,g.$$i)],y)}),define(ie[69],ne([0,1,47,15,28,156,54,3,2,13,9,4,7,105,87,21,103,182,59,24,5,20,6,25,67,29,30,53,17,243,235,90]),function(J,e,S,A,s,R,C,P,h,c,g,b,y,f,v,m,w,$,d,u,E,l,i,a,r,t,n,o,p,O,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w7b=e.$v7b=void 0,e.$v7b=(0,E.$Qh)("nativeHostMainService");let I=class extends h.$Sc{constructor(U,z,x,Z,ae,se,ce,Y,K,Q){super(),this.a=U,this.b=z,this.c=x,this.f=Z,this.g=ae,this.h=se,this.j=ce,this.m=Y,this.n=K,this.r=Q,this.onDidOpenWindow=P.Event.map(this.a.onDidOpenWindow,q=>q.id),this.onDidTriggerSystemContextMenu=P.Event.filter(P.Event.map(this.a.onDidTriggerSystemContextMenu,({window:q,x:W,y:G})=>({windowId:q.id,x:W,y:G})),({windowId:q})=>!!this.a.getWindowById(q)),this.onDidMaximizeWindow=P.Event.filter(P.Event.fromNodeEventEmitter(A.app,"browser-window-maximize",(q,W)=>W.id),q=>!!this.a.getWindowById(q)),this.onDidUnmaximizeWindow=P.Event.filter(P.Event.fromNodeEventEmitter(A.app,"browser-window-unmaximize",(q,W)=>W.id),q=>!!this.a.getWindowById(q)),this.onDidBlurWindow=P.Event.filter(P.Event.fromNodeEventEmitter(A.app,"browser-window-blur",(q,W)=>W.id),q=>!!this.a.getWindowById(q)),this.onDidFocusWindow=P.Event.any(P.Event.map(P.Event.filter(P.Event.map(this.a.onDidChangeWindowsCount,()=>this.a.getLastActiveWindow()),q=>!!q),q=>q.id),P.Event.filter(P.Event.fromNodeEventEmitter(A.app,"browser-window-focus",(q,W)=>W.id),q=>!!this.a.getWindowById(q))),this.onDidResumeOS=P.Event.fromNodeEventEmitter(A.powerMonitor,"resume"),this.onDidChangeColorScheme=this.m.onDidChangeColorScheme,this.s=this.B(new P.$Od),this.onDidChangePassword=this.s.event,this.onDidChangeDisplay=P.Event.debounce(P.Event.any(P.Event.filter(P.Event.fromNodeEventEmitter(A.screen,"display-metrics-changed",(q,W,G)=>G),q=>!(Array.isArray(q)&&q.length===1&&q[0]==="workArea")),P.Event.fromNodeEventEmitter(A.screen,"display-added"),P.Event.fromNodeEventEmitter(A.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.a.getWindows().map(z=>({id:z.id,workspace:z.openedWorkspace??(0,n.$5h)(z.backupPath,z.isExtensionDevelopmentHost),title:z.win?.getTitle()??"",filename:z.getRepresentedFilename(),dirty:z.isDocumentEdited()}))}async getWindowCount(U){return this.a.getWindowCount()}async getActiveWindowId(U){const z=A.BrowserWindow.getFocusedWindow()||this.a.getLastActiveWindow();if(z)return z.id}openWindow(U,z,x){return Array.isArray(z)?this.t(U,z,x):this.u(U,z)}async t(U,z,x=Object.create(null)){z.length>0&&await this.a.open({context:5,contextWindowId:U,urisToOpen:z,cli:this.g.args,forceNewWindow:x.forceNewWindow,forceReuseWindow:x.forceReuseWindow,preferNewWindow:x.preferNewWindow,diffMode:x.diffMode,mergeMode:x.mergeMode,addMode:x.addMode,gotoLineMode:x.gotoLineMode,noRecentEntry:x.noRecentEntry,waitMarkerFileURI:x.waitMarkerFileURI,remoteAuthority:x.remoteAuthority||void 0,forceProfile:x.forceProfile,forceTempProfile:x.forceTempProfile})}async u(U,z){await this.a.openEmptyWindow({context:5,contextWindowId:U},z)}async toggleFullScreen(U){this.F(U)?.toggleFullScreen()}async handleTitleDoubleClick(U){this.F(U)?.handleTitleDoubleClick()}async isMaximized(U){const z=this.F(U);return z?.win?z.win.isMaximized():!1}async maximizeWindow(U){const z=this.F(U);z?.win&&z.win.maximize()}async unmaximizeWindow(U){const z=this.F(U);z?.win&&z.win.unmaximize()}async minimizeWindow(U){const z=this.F(U);z?.win&&z.win.minimize()}async moveWindowTop(U,z){const x=this.D(z?.targetWindowId)??this.F(U);x?.win&&x.win.moveTop()}async positionWindow(U,z,x){const Z=this.D(x?.targetWindowId)??this.F(U);if(Z?.win){if(Z.win.isFullScreen()){const ae=P.Event.toPromise(P.Event.once(P.Event.fromNodeEventEmitter(Z.win,"leave-full-screen")));Z.win.setFullScreen(!1),await ae}Z.win.setBounds(z)}}async updateWindowControls(U,z){const x=this.F(U);x&&x.updateWindowControls(z)}async focusWindow(U,z){(this.D(z?.targetWindowId)??this.F(U))?.focus({force:z?.force??!1})}async setMinimumSize(U,z,x){const Z=this.F(U);if(Z?.win){const[ae,se]=Z.win.getSize(),[ce,Y]=Z.win.getMinimumSize(),[K,Q]=[z??ce,x??Y],[q,W]=[Math.max(ae,K),Math.max(se,Q)];(ce!==K||Y!==Q)&&Z.win.setMinimumSize(K,Q),(ae!==q||se!==W)&&Z.win.setSize(q,W)}}async saveWindowSplash(U,z){this.m.saveWindowSplash(U,z)}async installShellCommand(U){const{source:z,target:x}=await this.w();try{const{symbolicLink:Z}=await m.SymlinkSupport.stat(z);if(Z&&!Z.dangling){const ae=await(0,f.$$p)(z);if(x===ae)return}await m.Promises.unlink(z)}catch(Z){if(Z.code!=="ENOENT")throw Z}try{await m.Promises.symlink(x,z)}catch(Z){if(Z.code!=="EACCES"&&Z.code!=="ENOENT")throw Z;const{response:ae}=await this.showMessageBox(U,{type:"info",message:(0,$.localize)(0,null,this.j.nameShort),buttons:[(0,$.localize)(1,null),(0,$.localize)(2,null)]});if(ae===0)try{const se=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${x}' '${z}'\\" with administrator privileges"`;await(0,R.promisify)(S.exec)(se)}catch{throw new Error((0,$.localize)(3,null,z))}}}async uninstallShellCommand(U){const{source:z}=await this.w();try{await m.Promises.unlink(z)}catch(x){switch(x.code){case"EACCES":{const{response:Z}=await this.showMessageBox(U,{type:"info",message:(0,$.localize)(4,null,this.j.nameShort),buttons:[(0,$.localize)(5,null),(0,$.localize)(6,null)]});if(Z===0)try{const ae=`osascript -e "do shell script \\"rm '${z}'\\" with administrator privileges"`;await(0,R.promisify)(S.exec)(ae)}catch{throw new Error((0,$.localize)(7,null,z))}break}case"ENOENT":break;default:throw x}}}async w(){const U=(0,g.$kc)(this.g.appRoot,"bin","code"),z=`/usr/local/bin/${this.j.applicationName}`;if(!await m.Promises.exists(U))throw new Error((0,$.localize)(8,null,U));return{source:z,target:U}}async showMessageBox(U,z){const x=this.H(U);return this.c.showMessageBox(z,x?.win??void 0)}async showSaveDialog(U,z){const x=this.H(U);return this.c.showSaveDialog(z,x?.win??void 0)}async showOpenDialog(U,z){const x=this.H(U);return this.c.showOpenDialog(z,x?.win??void 0)}async pickFileFolderAndOpen(U,z){const x=await this.c.pickFileFolder(z);x&&await this.z(await Promise.all(x.map(async Z=>await m.SymlinkSupport.existsDirectory(Z)?{folderUri:y.URI.file(Z)}:{fileUri:y.URI.file(Z)})),z,U)}async pickFolderAndOpen(U,z){const x=await this.c.pickFolder(z);x&&await this.z(x.map(Z=>({folderUri:y.URI.file(Z)})),z,U)}async pickFileAndOpen(U,z){const x=await this.c.pickFile(z);x&&await this.z(x.map(Z=>({fileUri:y.URI.file(Z)})),z,U)}async pickWorkspaceAndOpen(U,z){const x=await this.c.pickWorkspace(z);x&&await this.z(x.map(Z=>({workspaceUri:y.URI.file(Z)})),z,U)}async z(U,z,x){await this.a.open({context:3,contextWindowId:x,cli:this.g.args,urisToOpen:U,forceNewWindow:z.forceNewWindow})}async showItemInFolder(U,z){A.shell.showItemInFolder(z)}async setRepresentedFilename(U,z){this.F(U)?.setRepresentedFilename(z)}async setDocumentEdited(U,z){this.F(U)?.setDocumentEdited(z)}async openExternal(U,z){return this.g.unsetSnapExportedVariables(),A.shell.openExternal(z),this.g.restoreSnapExportedVariables(),!0}moveItemToTrash(U,z){return A.shell.trashItem(z)}async isAdmin(){let U;return b.$j?U=(await new Promise((z,x)=>{J(["native-is-elevated"],z,x)}))():U=process.getuid?.()===0,U}async writeElevated(U,z,x,Z){const ae=await new Promise((se,ce)=>{J(["@vscode/sudo-prompt"],se,ce)});return new Promise((se,ce)=>{const Y=[`"${this.C}"`];Z?.unlock&&Y.push("--file-chmod"),Y.push("--file-write",`"${z.fsPath}"`,`"${x.fsPath}"`);const K={name:this.j.nameLong.replace("-",""),icns:b.$k&&this.g.isBuilt?(0,g.$jc)((0,g.$mc)(this.g.appRoot),`${this.j.nameShort}.icns`):void 0};ae.exec(Y.join(" "),K,(Q,q,W)=>{q&&this.h.trace(`[sudo-prompt] received stdout: ${q}`),W&&this.h.trace(`[sudo-prompt] received stderr: ${W}`),Q?ce(Q):se(void 0)})})}async isRunningUnderARM64Translation(){return b.$l||b.$j?!1:A.app.runningUnderARM64Translation}get C(){return b.$j?this.g.isBuilt?(0,g.$jc)((0,g.$mc)(process.execPath),"bin",`${this.j.applicationName}.cmd`):(0,g.$jc)(this.g.appRoot,"scripts","code-cli.bat"):b.$l?this.g.isBuilt?(0,g.$jc)((0,g.$mc)(process.execPath),"bin",`${this.j.applicationName}`):(0,g.$jc)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,g.$jc)(this.g.appRoot,"bin","code"):(0,g.$jc)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,s.totalmem)(),freemem:(0,s.freemem)(),loadavg:(0,s.loadavg)()}}async getOSProperties(){return{arch:(0,s.arch)(),platform:(0,s.platform)(),release:(0,s.release)(),type:(0,s.type)(),cpus:(0,s.cpus)()}}async getOSVirtualMachineHint(){return v.$Sm.value()}async getOSColorScheme(){return this.m.getColorScheme()}async hasWSLFeatureInstalled(){return b.$j&&(0,O.$t7b)()}async killProcess(U,z,x){process.kill(z,x)}async readClipboardText(U,z){return A.clipboard.readText(z)}async writeClipboardText(U,z,x){return A.clipboard.writeText(z,x)}async readClipboardFindText(U){return A.clipboard.readFindText()}async writeClipboardFindText(U,z){return A.clipboard.writeFindText(z)}async writeClipboardBuffer(U,z,x,Z){return A.clipboard.writeBuffer(z,Buffer.from(x.buffer),Z)}async readClipboardBuffer(U,z){return p.$ce.wrap(A.clipboard.readBuffer(z))}async hasClipboard(U,z,x){return A.clipboard.has(z,x)}async newWindowTab(){await this.a.open({context:5,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){A.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){A.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){A.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){A.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){A.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(U,z){this.F(U)?.updateTouchBar(z)}async notifyReady(U){this.F(U)?.setReady()}async relaunch(U,z){return this.f.relaunch(z)}async reload(U,z){const x=this.F(U);if(x){if((0,n.$6h)(x.openedWorkspace)){const Z=x.openedWorkspace.configPath;if(Z.scheme===c.Schemas.file&&(await this.n.resolveLocalWorkspace(Z))?.transient)return this.openWindow(x.id,{forceReuseWindow:!0})}return this.f.reload(x,z?.disableExtensions!==void 0?{_:[],"disable-extensions":z.disableExtensions}:void 0)}}async closeWindow(U){this.closeWindowById(U,U)}async closeWindowById(U,z){return(this.D(z)??this.F(z))?.win?.close()}async quit(U){const z=this.a.getLastActiveWindow();z?.isExtensionDevelopmentHost&&this.a.getWindowCount()>1&&z.win?z.win.close():this.f.quit()}async exit(U,z){await this.f.kill(z)}async resolveProxy(U,z){return this.F(U)?.win?.webContents?.session?.resolveProxy(z)}findFreePort(U,z,x,Z,ae=1){return(0,w.$hg)(z,x,Z,ae)}async openDevTools(U,z){this.H(U)?.win?.webContents.openDevTools(z)}async toggleDevTools(U){this.H(U)?.win?.webContents.toggleDevTools()}async sendInputEvent(U,z){const x=this.F(U);x?.win&&(z.type==="mouseDown"||z.type==="mouseUp")&&x.win.webContents.sendInputEvent(z)}async profileRenderer(U,z,x){const Z=this.F(U);if(!Z||!Z.win)throw new Error;return await new D.$u7b(Z.win,z,this.h).inspect(x)}async windowsGetStringRegKey(U,z,x,Z){if(!b.$j)return;const ae=await new Promise((se,ce)=>{J(["@vscode/windows-registry"],se,ce)});try{return ae.GetStringRegKey(z,x,Z)}catch{return}}D(U){return this.F(U)??this.G(U)}F(U){if(typeof U=="number")return this.a.getWindowById(U)}G(U){if(typeof U=="number")return this.b.getWindowById(U)}H(U){let z=this.r.invokeFunction(t.$_6b);return z||(z=this.D(U)),z}};e.$w7b=I,Ee([C.$ih],I.prototype,"C",null),e.$w7b=I=Ee([te(0,t.$06b),te(1,k.$96b),te(2,d.$R6b),te(3,l.$z6b),te(4,u.$x6b),te(5,i.$$i),te(6,a.$qj),te(7,r.$L6b),te(8,o.$26b),te(9,E.$Ph)],I)}),define(ie[299],ne([0,1,15,38,28,2,13,4,107,180,91,132,59,24,6,69,78,25,79,68,33,34,60,22,7,29,8]),function(J,e,S,A,s,R,C,P,h,c,g,b,y,f,v,m,w,$,d,u,E,l,i,a,r,t,n){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$x7b=void 0;const p="issue.processExplorerWindowState";let O=class{static{o=this}static{this.a="#1E1E1E"}constructor(I,j,U,z,x,Z,ae,se,ce,Y,K){this.g=I,this.h=j,this.i=U,this.j=z,this.k=x,this.l=Z,this.m=ae,this.n=se,this.o=ce,this.p=Y,this.q=K,this.b=null,this.c=null,this.d=null,this.f=null,this.r()}r(){A.$uT.on("vscode:listProcesses",async I=>{const j=[];try{j.push({name:(0,c.localize)(0,null),rootProcess:await(0,h.$Gr)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(z=>{(0,g.$sm)(z)?j.push({name:z.hostName,rootProcess:z}):z.processes&&j.push({name:z.hostName,rootProcess:z.processes})})}catch(U){this.i.error(`Listing processes failed: ${U}`)}this.t(I,"vscode:listProcessesResponse",j)}),A.$uT.on("vscode:workbenchCommand",(I,j)=>{const{id:U,from:z,args:x}=j;let Z;switch(z){case"processExplorer":Z=this.f;break;default:throw new Error(`Unexpected command source: ${z}`)}Z?.webContents.send("vscode:runAction",{id:U,from:z,args:x})}),A.$uT.on("vscode:closeProcessExplorer",I=>{this.d?.close()}),A.$uT.on("vscode:pidToNameRequest",async I=>{const j=await this.k.getMainDiagnostics(),U=[];for(const z of j.windows)U.push([z.pid,`window [${z.id}] (${z.title})`]);for(const{pid:z,name:x}of i.$e7b.getAll())U.push([z,x]);this.t(I,"vscode:pidToNameResponse",U)})}async openReporter(I){if(!this.b&&(this.c=S.BrowserWindow.getFocusedWindow(),this.c)){const j=new R.$Rc,U=j.add(this.n.createIPCObjectUrl()),z=this.v(this.c,700,800);this.b=this.u(z,U,{backgroundColor:I.styles.backgroundColor,title:(0,c.localize)(1,null),zoomLevel:I.zoomLevel,alwaysOnTop:!1},"issue-reporter"),U.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:I,disableExtensions:!!this.h.disableExtensions,os:{type:(0,s.type)(),arch:(0,s.arch)(),release:(0,s.release)()},product:w.default}),this.b.loadURL(C.$dg.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,j.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,j.dispose())})}this.b&&this.s(this.b)}async openProcessExplorer(I){if(!this.d&&(this.f=S.BrowserWindow.getFocusedWindow(),this.f)){const j=new R.$Rc,U=j.add(this.n.createIPCObjectUrl()),z=this.p.getItem(p,void 0),x=D(z)?z:this.v(this.f,800,500);this.d=this.u(x,U,{backgroundColor:I.styles.backgroundColor,title:(0,c.localize)(2,null),zoomLevel:I.zoomLevel,alwaysOnTop:!0},"process-explorer"),U.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:I,product:w.default}),this.d.loadURL(C.$dg.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,j.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,j.dispose())});const Z=()=>{if(!this.d)return;const ae=this.d.getSize(),se=this.d.getPosition();if(!ae||!se)return;const ce={width:ae[0],height:ae[1],x:se[0],y:se[1]};this.p.setItem(p,ce)};this.d.on("moved",Z),this.d.on("resized",Z)}this.d&&this.s(this.d)}async stopTracing(){if(!this.h.args.trace)return;const I=await S.contentTracing.stopRecording(`${(0,E.$7f)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({type:"info",message:(0,c.localize)(3,null),detail:(0,c.localize)(4,null,I),buttons:[(0,c.localize)(5,null)]},S.BrowserWindow.getFocusedWindow()??void 0),this.m.showItemInFolder(void 0,I)}async getSystemStatus(){const[I,j]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(I,j)}async $getSystemInfo(){const[I,j]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.j.getSystemInfo(I,j)}async $getPerformanceInfo(){try{const[I,j]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(I,j)}catch(I){throw this.i.warn("issueService#getPerformanceInfo ",I.message),I}}async $reloadWithExtensionsDisabled(){if(this.c)try{await this.m.reload(this.c.id,{disableExtensions:!0})}catch(I){this.i.error(I)}}async $showConfirmCloseDialog(){if(this.b){const{response:I}=await this.l.showMessageBox({type:"warning",message:(0,c.localize)(6,null),buttons:[(0,c.localize)(7,null),(0,c.localize)(8,null)]},this.b);I===0&&this.b&&(this.b.destroy(),this.b=null)}}async $showClipboardDialog(){if(this.b){const{response:I}=await this.l.showMessageBox({type:"warning",message:(0,c.localize)(9,null),buttons:[(0,c.localize)(10,null),(0,c.localize)(11,null)]},this.b);return I===0}return!1}async $getIssueReporterUri(I){if(!this.c)throw new Error("Issue reporter window not available");const j=this.q.getWindowById(this.c.id);if(!j)throw new Error("Window not found");const U=`vscode:triggerIssueUriRequestHandlerResponse${j.id}`;return n.Promises.withAsyncBody(async(z,x)=>{const Z=new a.$Yd;j.sendWhenReady("vscode:triggerIssueUriRequestHandler",Z.token,{replyChannel:U,extensionId:I}),A.$uT.once(U,(ae,se)=>{z(r.URI.parse(se))});try{await(0,n.$Vg)(5e3),Z.cancel(),x(new Error("Timed out waiting for issue reporter URI"))}finally{A.$uT.removeHandler(U)}})}async $closeReporter(){this.b?.close()}async closeProcessExplorer(){this.d?.close()}s(I){I.isMinimized()&&I.restore(),I.focus()}t(I,j,...U){I.sender.isDestroyed()||I.sender.send(j,...U)}u(I,j,U,z){const x=new S.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:I.width,height:I.height,minWidth:300,minHeight:200,x:I.x,y:I.y,title:U.title,backgroundColor:U.backgroundColor||o.a,webPreferences:{preload:C.$dg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${j.resource.toString()}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,u.$qC)(U.zoomLevel),sandbox:!0},alwaysOnTop:U.alwaysOnTop,experimentalDarkMode:!0});return x.setMenuBarVisibility(!1),x}v(I,j,U){let z;const x=S.screen.getAllDisplays();if(x.length===1)z=x[0];else{if(P.$k){const se=S.screen.getCursorScreenPoint();z=S.screen.getDisplayNearestPoint(se)}!z&&I&&(z=S.screen.getDisplayMatching(I.getBounds())),z||(z=S.screen.getPrimaryDisplay()||x[0])}const Z=z.bounds,ae={width:j,height:U,x:Z.x+Z.width/2-j/2,y:Z.y+Z.height/2-U/2};return Z.width>0&&Z.height>0&&(ae.x<Z.x&&(ae.x=Z.x),ae.y<Z.y&&(ae.y=Z.y),ae.x>Z.x+Z.width&&(ae.x=Z.x),ae.y>Z.y+Z.height&&(ae.y=Z.y),ae.width>Z.width&&(ae.width=Z.width),ae.height>Z.height&&(ae.height=Z.height)),ae}};e.$x7b=O,e.$x7b=O=o=Ee([te(1,f.$x6b),te(2,v.$$i),te(3,g.$rm),te(4,b.$h7b),te(5,y.$R6b),te(6,m.$v7b),te(7,d.$T6b),te(8,$.$qj),te(9,l.$FN),te(10,t.$06b)],O);function D(k){return typeof k!="object"||k===null?!1:"x"in k&&"y"in k&&"width"in k&&"height"in k}}),define(ie[300],ne([0,1,22,18,24,20,6,69,25,50,26,48,100]),function(J,e,S,A,s,R,C,P,h,c,g,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y7b=void 0;let f=class extends y.$W7b{constructor(m,w,$,d,u,E,l,i){super(m,w,d,u,E,i),this.e=$,this.u=l}s(m){return(0,y.$V7b)(`linux-${process.arch}`,m,this.k)}t(m){this.a&&(this.d(b.$tU.CheckingForUpdates(m)),this.i.request({url:this.a},S.CancellationToken.None).then(c.$3o).then(w=>{!w||!w.url||!w.version||!w.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!m}),this.d(b.$tU.Idle(1))):this.d(b.$tU.AvailableForDownload(w))}).then(void 0,w=>{this.j.error(w),this.e.publicLog2("update:notAvailable",{explicit:!!m});const $=m?w.message||w:void 0;this.d(b.$tU.Idle(1,$))}))}async o(m){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):m.update.url&&this.u.openExternal(void 0,m.update.url),this.d(b.$tU.Idle(1))}};e.$Y7b=f,e.$Y7b=f=Ee([te(0,R.$z6b),te(1,A.$ki),te(2,g.$dl),te(3,s.$x6b),te(4,c.$Wo),te(5,C.$$i),te(6,P.$v7b),te(7,h.$qj)],f)}),define(ie[301],ne([0,1,47,45,28,8,22,54,9,7,144,21,18,24,16,20,6,69,25,50,26,48,100]),function(J,e,S,A,s,R,C,P,h,c,g,b,y,f,v,m,w,$,d,u,E,l,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$17b=void 0;async function a(o,p=1e3){for(;!o();)await(0,R.$Vg)(p)}let r;function t(){return typeof r>"u"&&(r=A.existsSync(h.$jc(h.$mc(process.execPath),"unins000.exe"))?0:1),r}let n=class extends i.$W7b{get cachePath(){const p=h.$jc((0,s.tmpdir)(),`vscode-${this.k.quality}-${this.k.target}-${process.arch}`);return b.Promises.mkdir(p,{recursive:!0}).then(()=>p)}constructor(p,O,D,k,I,j,U,z,x){super(p,O,k,I,j,x),this.u=D,this.v=U,this.w=z,p.setRelaunchHandler(this)}handleRelaunch(p){return p?.addArgs||p?.removeArgs||this.state.type!=="ready"||!this.e?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.d(l.$tU.Disabled(5)),this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s(p){let O=`win32-${process.arch}`;return t()===1?O+="-archive":this.k.target==="user"&&(O+="-user"),(0,i.$V7b)(O,p,this.k)}t(p){this.a&&(this.d(l.$tU.CheckingForUpdates(p)),this.i.request({url:this.a},C.CancellationToken.None).then(u.$3o).then(O=>{const D=t();return!O||!O.url||!O.version||!O.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!p}),this.d(l.$tU.Idle(D)),Promise.resolve(null)):D===1?(this.d(l.$tU.AvailableForDownload(O)),Promise.resolve(null)):(this.d(l.$tU.Downloading(O)),this.C(O.version).then(()=>this.B(O.version).then(k=>b.Promises.exists(k).then(I=>{if(I)return Promise.resolve(k);const j=O.url,U=O.hash,z=`${k}.tmp`;return this.i.request({url:j},C.CancellationToken.None).then(x=>this.v.writeFile(c.URI.file(z),x.stream)).then(U?()=>(0,g.$pT)(z,O.hash):()=>{}).then(()=>b.Promises.rename(z,k,!1)).then(()=>k)})).then(k=>{const I=this.g.getValue("update.enableWindowsBackgroundUpdates");this.e={packagePath:k},I?this.k.target==="user"?this.p():this.d(l.$tU.Downloaded(O)):this.d(l.$tU.Ready(O))})))}).then(void 0,O=>{this.j.error(O),this.u.publicLog2("update:notAvailable",{explicit:!!p});const D=p?O.message||O:void 0;this.d(l.$tU.Idle(t(),D))}))}async o(p){p.update.url&&this.w.openExternal(void 0,p.update.url),this.d(l.$tU.Idle(t()))}async B(p){const O=await this.cachePath;return h.$jc(O,`CodeSetup-${this.k.quality}-${p}.exe`)}async C(p=null){const O=p?j=>!new RegExp(`${this.k.quality}-${p}\\.exe$`).test(j):()=>!0,D=await this.cachePath,I=(await b.Promises.readdir(D)).filter(O).map(async j=>{try{await b.Promises.unlink(h.$jc(D,j))}catch{}});await Promise.all(I)}async p(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.e)return Promise.resolve(void 0);const p=this.state.update;this.d(l.$tU.Updating(p));const O=await this.cachePath;this.e.updateFilePath=h.$jc(O,`CodeSetup-${this.k.quality}-${p.version}.flag`),await b.Promises.writeFile(this.e.updateFilePath,"flag"),(0,S.spawn)(this.e.packagePath,["/verysilent","/log",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(l.$tU.Idle(t()))});const k=`${this.k.win32MutexName}-ready`,I=await new Promise((j,U)=>{J(["@vscode/windows-mutex"],j,U)});a(()=>I.isActive(k)).then(()=>this.d(l.$tU.Ready(p)))}r(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.e.updateFilePath?A.unlinkSync(this.e.updateFilePath):(0,S.spawn)(this.e.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return t()}async _applySpecificUpdate(p){if(this.state.type!=="idle")return;const O=this.g.getValue("update.enableWindowsBackgroundUpdates"),D={version:"unknown",productVersion:"unknown"};this.d(l.$tU.Downloading(D)),this.e={packagePath:p},O?this.k.target==="user"?this.p():this.d(l.$tU.Downloaded(D)):this.d(l.$tU.Ready(D))}};e.$17b=n,Ee([P.$ih],n.prototype,"cachePath",null),e.$17b=n=Ee([te(0,m.$z6b),te(1,y.$ki),te(2,E.$dl),te(3,f.$x6b),te(4,u.$Wo),te(5,w.$$i),te(6,v.$_j),te(7,$.$v7b),te(8,d.$qj)],n)}),define(ie[133],ne([0,1,15,8,22,49,3,2,13,65,4,7,190,63,18,59,24,62,16,20,6,25,79,252,81,26,102,67,68,29,30,53,128,136,39,34,52,66,23,5]),function(J,e,S,A,s,R,C,P,h,c,g,b,y,f,v,m,w,$,d,u,E,l,i,a,r,t,n,o,p,O,D,k,I,j,U,z,x,Z,ae,se){"use strict";var ce;Object.defineProperty(e,"__esModule",{value:!0}),e.$76b=e.$66b=void 0;var Y;(function(q){q[q.NONE=0]="NONE",q[q.NAVIGATING=1]="NAVIGATING",q[q.READY=2]="READY"})(Y||(Y={}));class K extends P.$Sc{focus(W){g.$k&&W?.force&&S.app.focus({steal:!0});const G=this.a();G&&(G.isMinimized()&&G.restore(),G.focus())}}e.$66b=K;let Q=class extends K{static{ce=this}static{this.b="windowControlHeight"}get id(){return this.m}get win(){return this.n}a(){return this.n}get lastFocusTime(){return this.s}get backupPath(){return this.t?.backupPath}get openedWorkspace(){return this.t?.workspace}get profile(){if(!this.config)return;const W=this.U.profiles.find(G=>G.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&W?W:this.U.getProfileForWorkspace(this.config.workspace??(0,D.$5h)(this.backupPath,this.isExtensionDevelopmentHost))??this.U.defaultProfile}get remoteAuthority(){return this.t?.remoteAuthority}get config(){return this.t}get isExtensionDevelopmentHost(){return!!this.t?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.t?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.t?.debugId}constructor(W,G,H,X,re,L,M,N,T,F,B,V,oe,de,ue,he,ve,be,ye,Ie,Te){super(),this.P=G,this.Q=H,this.R=X,this.S=re,this.U=L,this.W=M,this.X=N,this.Y=T,this.Z=F,this.$=B,this.ab=V,this.bb=oe,this.db=de,this.eb=ue,this.fb=he,this.gb=ve,this.hb=be,this.ib=ye,this.jb=Ie,this.c=this.B(new C.$Od),this.onWillLoad=this.c.event,this.f=this.B(new C.$Od),this.onDidSignalReady=this.f.event,this.g=this.B(new C.$Od),this.onDidTriggerSystemContextMenu=this.g.event,this.h=this.B(new C.$Od),this.onDidClose=this.h.event,this.j=this.B(new C.$Od),this.onDidDestroy=this.j.event,this.s=-1,this.z=void 0,this.C=void 0,this.G=!1,this.H=[],this.I=[],this.J=void 0,this.L=void 0,this.M=this.B(this.hb.createIPCObjectUrl()),this.O=!1,this.lb=0;{const[me,we]=this.vb(W.state);this.u=me,this.P.trace("window#ctor: using window state",me);const _=this.u.mode===0||this.u.mode===3,le=this.Z.getValue("window"),ge=Te.invokeFunction(O.$$6b,this.u,{show:!_,webPreferences:{preload:h.$dg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.M.resource.toString()}`],v8CacheOptions:this.R.useCodeCache?"bypassHeatCheck":"none"}});g.$k&&!this.Cb()&&(ge.fullscreenable=!1);const Oe=g.$k&&le?.nativeTabs===!0;Oe&&(ge.tabbingIdentifier=this.gb.nameShort);const Ce=(0,p.$oC)(this.Z)==="custom";if(Ce&&(ge.titleBarStyle="hidden",g.$k||(ge.frame=!1),(0,p.$pC)(this.Z))){const Le=this.$.getWindowSplash()?.colorInfo.titleBarBackground??this.$.getBackgroundColor(),Re=j.$2s.fromHex(Le).isDarker()?"#FFFFFF":"#000000";ge.titleBarOverlay={height:29,color:Le,symbolColor:Re},this.G=!0}if((0,c.mark)("code/willCreateCodeBrowserWindow"),this.n=new S.BrowserWindow(ge),(0,c.mark)("code/didCreateCodeBrowserWindow"),this.m=this.n.id,g.$k&&Ce&&this.n.setSheetOffset(22),Ce&&(g.$j&&(0,p.$pC)(this.Z)||g.$k)){const Le=this.jb.getItem(ce.b);Le&&this.updateWindowControls({height:Le})}g.$j&&Ce&&this.n.hookWindowMessage(278,()=>{const[Re,He]=this.n.getPosition(),ze=S.screen.getCursorScreenPoint(),ee=ze.x-Re,fe=ze.y-He;return(()=>!(ee>30&&fe>=0&&fe<=Math.max(this.n.getBounds().height*.15,35)))()||(this.n.setEnabled(!1),this.n.setEnabled(!0),this.g.fire({x:ee,y:fe})),0}),(g.$k||g.$j)&&we&&(!Oe||S.BrowserWindow.getAllWindows().length===1)&&[this.u.width,this.u.height,this.u.x,this.u.y].every(Le=>typeof Le=="number")&&this.n.setBounds({width:this.u.width,height:this.u.height,x:this.u.x,y:this.u.y}),_&&((0,c.mark)("code/willMaximizeCodeWindow"),this.n.maximize(),this.u.mode===3?(this.kb("WindowMode.Fullscreen"),this.yb(!0)):this.kb("WindowMode.Maximized"),this.n.show(),(0,c.mark)("code/didMaximizeCodeWindow")),this.s=Date.now()}this.R.args["open-devtools"]===!0&&this.n.webContents.openDevTools(),this.sb(),this.Gb(),this.mb()}kb(W){this.Z.getValue("window.logFullScreenTransitions")&&this.P.info(`window-fullscreen-bug: ${W})`)}setRepresentedFilename(W){g.$k?this.n.setRepresentedFilename(W):this.D=W}getRepresentedFilename(){return g.$k?this.n.getRepresentedFilename():this.D}setDocumentEdited(W){g.$k&&this.n.setDocumentEdited(W),this.F=W}isDocumentEdited(){return g.$k?this.n.isDocumentEdited():!!this.F}setReady(){for(this.P.trace(`window#load: window reported ready (id: ${this.m})`),this.lb=2;this.H.length;)this.H.pop()(this);this.f.fire()}ready(){return new Promise(W=>{if(this.isReady)return W(this);this.H.push(W)})}get isReady(){return this.lb===2}get whenClosedOrLoaded(){return new Promise(W=>{function G(){H.dispose(),X.dispose(),W()}const H=this.onDidClose(()=>G()),X=this.onWillLoad(()=>G())})}mb(){this.n.on("unresponsive",()=>this.pb(1)),this.n.webContents.on("render-process-gone",(G,H)=>this.pb(2,{...H})),this.n.webContents.on("did-fail-load",(G,H,X)=>this.pb(3,{reason:X,exitCode:H})),this.n.webContents.on("will-prevent-unload",G=>{G.preventDefault()}),this.n.on("closed",()=>{this.h.fire(),this.dispose()}),this.n.webContents.on("did-finish-load",()=>{this.N&&(this.t=this.N,this.N=void 0)}),this.n.on("focus",()=>{this.s=Date.now()}),this.n.on("maximize",G=>{this.t&&(this.t.maximized=!0),S.app.emit("browser-window-maximize",G,this.n)}),this.n.on("unmaximize",G=>{this.t&&(this.t.maximized=!1),S.app.emit("browser-window-unmaximize",G,this.n)}),this.n.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",s.CancellationToken.None),this.kb(`enter-full-screen: ${Date.now()}`),this.C?.complete(),this.C=void 0}),this.n.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",s.CancellationToken.None),this.kb(`leave-full-screen: ${Date.now()}`),this.C?.complete(),this.C=void 0}),this.B(this.Z.onDidChangeConfiguration(G=>this.sb(G))),this.B(this.ab.onDidDeleteUntitledWorkspace(G=>this.rb(G)));const W=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.n.webContents.session.webRequest.onBeforeSendHeaders({urls:W},async(G,H)=>{const X=await this.ob();H({cancel:!1,requestHeaders:Object.assign(G.requestHeaders,X)})})}ob(){return this.nb||(this.nb=(0,a.$ep)(this.gb.version,this.gb,this.R,this.Z,this.W,this.X,this.db)),this.nb}async pb(W,G){switch(W){case 2:this.P.error(`CodeWindow: renderer process gone (reason: ${G?.reason||"<unknown>"}, code: ${G?.exitCode||"<unknown>"})`);break;case 1:this.P.error("CodeWindow: detected unresponsive");break;case 3:this.P.error(`CodeWindow: failed to load (reason: ${G?.reason||"<unknown>"}, code: ${G?.exitCode||"<unknown>"})`);break}switch(this.db.publicLog2("windowerror",{type:W,reason:G?.reason,code:G?.exitCode}),W){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.fb.kill(1);return}if(this.R.args["enable-smoke-test-driver"]){await this.qb(!1,!1),this.fb.quit();return}if(W===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.n&&this.n.webContents&&this.n.webContents.isDevToolsOpened())return;const{response:H,checkboxChecked:X}=await this.eb.showMessageBox({type:"warning",buttons:[(0,y.localize)(0,null),(0,y.localize)(1,null),(0,y.localize)(2,null)],message:(0,y.localize)(3,null),detail:(0,y.localize)(4,null),checkboxLabel:this.t?.workspace?(0,y.localize)(5,null):void 0},this.n);if(H!==2){const re=H===0;await this.qb(re,X)}}else if(W===2){let H;G?H=(0,y.localize)(7,null,G.reason,G.exitCode??"<unknown>"):H=(0,y.localize)(6,null);const{response:X,checkboxChecked:re}=await this.eb.showMessageBox({type:"warning",buttons:[this.t?.workspace?(0,y.localize)(8,null):(0,y.localize)(9,null),(0,y.localize)(10,null)],message:H,detail:this.t?.workspace?(0,y.localize)(11,null):(0,y.localize)(12,null),checkboxLabel:this.t?.workspace?(0,y.localize)(13,null):void 0},this.n),L=X===0;await this.qb(L,re)}break}}async qb(W,G){const H=this.t?.workspace;if(G&&H)try{const X=this.Y.workspaceStorage(H);await X.init(),X.delete("memento/workbench.parts.editor"),await X.close()}catch(X){this.P.error(X)}if(this.j.fire(),this.n?.destroy(),W&&this.t){let X,re;(0,D.$1h)(H)?X={folderUri:H.uri}:(0,D.$6h)(H)?X={workspaceUri:H.configPath}:re=!0,(0,ae.$Ob)(await this.ib.open({context:5,userEnv:this.t.userEnv,cli:{...this.R.args,_:[]},urisToOpen:X?[X]:void 0,forceEmpty:re,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}rb(W){this.t?.workspace?.id===W.id&&(this.t.workspace=void 0)}sb(W){if(!W||W.affectsConfiguration("window.menuBarVisibility")){const G=this.Db();G!==this.w&&(this.w=G,this.Eb(G))}if(!W||W.affectsConfiguration("http.proxy")){let G=(this.Z.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;G?.endsWith("/")&&(G=G.substr(0,G.length-1));const H=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((G||"").indexOf("@")===-1&&(G!==this.J||H!==this.L)){this.J=G,this.L=H;const X=G||"",re=H?`${H},<local>`:"<local>";this.P.trace(`Setting proxy to '${X}', bypassing '${re}'`),this.n.webContents.session.setProxy({proxyRules:X,proxyBypassRules:re,pacScript:""})}}}addTabbedWindow(W){g.$k&&W.win&&this.n.addTabbedWindow(W.win)}load(W,G=Object.create(null)){this.P.trace(`window#load: attempt to load window (id: ${this.m})`),this.isDocumentEdited()&&(!G.isReload||!this.bb.isHotExitEnabled())&&this.setDocumentEdited(!1),G.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.n.setTitle(this.gb.nameLong)),this.tb(W,G),this.lb===0?this.t=W:this.N=W,this.lb=1,this.n.loadURL(h.$dg.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.R.isBuilt?"":"-dev"}.html`).toString(!0));const H=this.O;this.O=!0,!this.R.isBuilt&&!this.R.extensionTestsLocationURI&&this.B(new A.$7g(()=>{this.n&&!this.n.isVisible()&&!this.n.isMinimized()&&(this.n.show(),this.focus({force:!0}),this.n.webContents.openDevTools())},1e4)).schedule(),this.c.fire({workspace:W.workspace,reason:G.isReload?3:H?2:1})}tb(W,G){const H=(this.t??this.N)?.userEnv;if(H){const X=(0,$.$Ol)(H)&&!(0,$.$Ol)(W.userEnv),re=this.isExtensionDevelopmentHost;(X||re)&&(W.userEnv={...H,...W.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(W.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),G.disableExtensions!==void 0&&(W["disable-extensions"]=G.disableExtensions),W.fullscreen=this.isFullScreen,W.maximized=this.n.isMaximized(),W.partsSplash=this.$.getWindowSplash(),(0,c.mark)("code/willOpenNewWindow"),W.perfMarks=(0,c.getMarks)(),this.M.update(W)}async reload(W){const G=Object.assign({},this.t);G.workspace=await this.ub(G),delete G.filesToOpenOrCreate,delete G.filesToDiff,delete G.filesToMerge,delete G.filesToWait,this.isExtensionDevelopmentHost&&W&&(G.verbose=W.verbose,G.debugId=W.debugId,G.extensionEnvironment=W.extensionEnvironment,G["inspect-extensions"]=W["inspect-extensions"],G["inspect-brk-extensions"]=W["inspect-brk-extensions"],G["extensions-dir"]=W["extensions-dir"]),G.accessibilitySupport=S.app.isAccessibilitySupportEnabled(),G.isInitialStartup=!1,G.policiesData=this.S.serialize(),G.continueOn=this.R.continueOn,G.profiles={all:this.U.profiles,profile:this.profile||this.U.defaultProfile,home:this.U.profilesHome},G.logLevel=this.Q.getLogLevel(),G.loggers={window:this.Q.getRegisteredLoggers(this.id),global:this.Q.getRegisteredLoggers()},this.load(G,{isReload:!0,disableExtensions:W?.["disable-extensions"]})}async ub(W){if((0,D.$6h)(W.workspace)){const G=W.workspace.configPath;if(G.scheme===h.Schemas.file&&!await this.W.exists(G))return}else if((0,D.$1h)(W.workspace)){const G=W.workspace.uri;if(G.scheme===h.Schemas.file&&!await this.W.exists(G))return}return W.workspace}serializeWindowState(){if(!this.n)return(0,I.$w6b)();if(this.isFullScreen){let H;try{H=S.screen.getDisplayMatching(this.getBounds())}catch{}const X=(0,I.$w6b)();return{mode:3,display:H?H.id:void 0,width:this.u.width||X.width,height:this.u.height||X.height,x:this.u.x||0,y:this.u.y||0}}const W=Object.create(null);let G;if(!g.$k&&this.n.isMaximized()?G=0:G=1,G===0?W.mode=0:W.mode=1,G===1||G===0){let H;G===1?H=this.getBounds():H=this.n.getNormalBounds(),W.x=H.x,W.y=H.y,W.width=H.width,W.height=H.height}return W}updateWindowControls(W){if(W.height&&this.jb.setItem(ce.b,W.height),g.$j&&this.G)this.n.setTitleBarOverlay({color:W.backgroundColor?.trim()===""?void 0:W.backgroundColor,symbolColor:W.foregroundColor?.trim()===""?void 0:W.foregroundColor,height:W.height?W.height-1:void 0});else if(g.$k&&W.height!==void 0){const G=(W.height-15)/2;G?this.n.setWindowButtonPosition({x:G,y:G}):this.n.setWindowButtonPosition(null)}}vb(W){(0,c.mark)("code/willRestoreCodeWindowState");let G=!1;if(W)try{const H=S.screen.getAllDisplays();G=H.length>1,W=this.wb(W,H)}catch(H){this.P.warn(`Unexpected error validating window state: ${H}
${H.stack}`)}return(0,c.mark)("code/didRestoreCodeWindowState"),[W||(0,I.$w6b)(),G]}wb(W,G){if(this.P.trace(`window#validateWindowState: validating window state on ${G.length} display(s)`,W),typeof W.x!="number"||typeof W.y!="number"||typeof W.width!="number"||typeof W.height!="number"){this.P.trace("window#validateWindowState: unexpected type of state values");return}if(W.width<=0||W.height<=0){this.P.trace("window#validateWindowState: unexpected negative values");return}if(G.length===1){const re=this.xb(G[0]);if(re){let L=function(){!W||typeof W.x!="number"||typeof W.y!="number"||!re||(W.x<re.x&&(W.x=re.x),W.y<re.y&&(W.y=re.y))};this.P.trace("window#validateWindowState: 1 monitor working area",re),L(),W.width>re.width&&(W.width=re.width),W.height>re.height&&(W.height=re.height),W.x>re.x+re.width-128&&(W.x=re.x+re.width-W.width),W.y>re.y+re.height-128&&(W.y=re.y+re.height-W.height),L()}return W}if(W.display&&W.mode===3){const re=G.find(L=>L.id===W.display);if(re&&typeof re.bounds?.x=="number"&&typeof re.bounds?.y=="number"){this.P.trace("window#validateWindowState: restoring fullscreen to previous display");const L=(0,I.$w6b)(3);return L.x=re.bounds.x,L.y=re.bounds.y,L}}let H,X;try{H=S.screen.getDisplayMatching({x:W.x,y:W.y,width:W.width,height:W.height}),X=this.xb(H)}catch{}if(H&&X&&W.x+W.width>X.x&&W.y+W.height>X.y&&W.x<X.x+X.width&&W.y<X.y+X.height)return this.P.trace("window#validateWindowState: multi-monitor working area",X),W}xb(W){if(W.workArea.width>0&&W.workArea.height>0)return W.workArea;if(W.bounds.width>0&&W.bounds.height>0)return W.bounds}getBounds(){const[W,G]=this.n.getPosition(),[H,X]=this.n.getSize();return{x:W,y:G,width:H,height:X}}toggleFullScreen(){this.yb(!this.isFullScreen)}yb(W){this.Cb()?this.zb(W):this.Bb(W),this.sendWhenReady(W?"vscode:enterFullScreen":"vscode:leaveFullScreen",s.CancellationToken.None),this.w&&this.Eb(this.w,!1)}get isFullScreen(){if(this.kb(`isFullScreen(): begin at ${Date.now()}`),g.$k&&typeof this.z=="boolean")return this.kb(`isFullScreen(): returning transientIsNativeFullScreen = ${this.z}`),this.z;const W=this.n.isFullScreen(),G=this.n.isSimpleFullScreen();return this.kb(`isFullScreen(): returning natively, isFullScreen = ${W}, isSimpleFullScreen = ${G}`),W||G}zb(W){this.n.isSimpleFullScreen()&&this.n.setSimpleFullScreen(!1),this.Ab(W)}Ab(W){g.$k&&(this.kb(`doSetNativeFullScreen(${W}): begin at ${Date.now()}`),this.z=W,this.C=new A.$dh,Promise.race([this.C.p,(0,A.$Vg)(1e3)]).finally(()=>{this.kb(`doSetNativeFullScreen(${W}): finish at ${Date.now()}`),this.z=void 0})),this.n.setFullScreen(W)}Bb(W){this.n.isFullScreen()&&this.Ab(!1),this.n.setSimpleFullScreen(W),this.n.webContents.focus()}Cb(){const W=this.Z.getValue("window");return!W||typeof W.nativeFullScreen!="boolean"||W.nativeTabs?!0:W.nativeFullScreen!==!1}isMinimized(){return this.n.isMinimized()}Db(){let W=(0,p.$nC)(this.Z);return["visible","toggle","hidden"].indexOf(W)<0&&(W="classic"),W}Eb(W,G=!0){g.$k||(W==="toggle"&&G&&this.send("vscode:showInfoMessage",(0,y.localize)(14,null)),W==="hidden"?setTimeout(()=>{this.Fb(W)}):this.Fb(W))}Fb(W){const G=this.isFullScreen;switch(W){case"classic":this.n.setMenuBarVisibility(!G),this.n.autoHideMenuBar=G;break;case"visible":this.n.setMenuBarVisibility(!0),this.n.autoHideMenuBar=!1;break;case"toggle":this.n.setMenuBarVisibility(!1),this.n.autoHideMenuBar=!0;break;case"hidden":this.n.setMenuBarVisibility(!1),this.n.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(g.$k)switch(S.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this.n.minimize();break;case"None":break;case"Maximize":default:this.n.isMaximized()?this.n.unmaximize():this.n.maximize()}else this.n.isMaximized()?this.n.unmaximize():this.n.maximize()}close(){this.n?.close()}sendWhenReady(W,G,...H){this.isReady?this.send(W,...H):this.ready().then(()=>{G.isCancellationRequested||this.send(W,...H)})}send(W,...G){if(this.n){if(this.n.isDestroyed()||this.n.webContents.isDestroyed()){this.P.warn(`Sending IPC message to channel '${W}' for window that is destroyed`);return}try{this.n.webContents.send(W,...G)}catch(H){this.P.warn(`Error sending IPC message to channel '${W}' of window ${this.m}: ${(0,R.$Bi)(H)}`)}}}updateTouchBar(W){g.$k&&this.I.forEach((G,H)=>{const X=W[H];G.segments=this.Ib(X)})}Gb(){if(g.$k){for(let W=0;W<10;W++){const G=this.Hb();this.I.push(G)}this.n.setTouchBar(new S.TouchBar({items:this.I}))}}Hb(W=[]){const G=this.Ib(W),H=new S.TouchBar.TouchBarSegmentedControl({segments:G,mode:"buttons",segmentStyle:"automatic",change:X=>{this.sendWhenReady("vscode:runAction",s.CancellationToken.None,{id:H.segments[X].id,from:"touchbar"})}});return H}Ib(W=[]){return W.map(H=>{let X;H.icon&&!n.ThemeIcon.isThemeIcon(H.icon)&&H.icon?.dark?.scheme===h.Schemas.file&&(X=S.nativeImage.createFromPath(b.URI.revive(H.icon.dark).fsPath),X.isEmpty()&&(X=void 0));let re;return typeof H.title=="string"?re=H.title:re=H.title.value,{id:H.id,label:X?void 0:re,icon:X}})}dispose(){super.dispose(),this.Q.deregisterLoggers(this.id),this.n=null}};e.$76b=Q,e.$76b=Q=ce=Ee([te(1,E.$$i),te(2,Z.$46b),te(3,w.$x6b),te(4,U.$mn),te(5,x.$F6b),te(6,d.$_j),te(7,r.$J6b),te(8,r.$H6b),te(9,v.$ki),te(10,o.$L6b),te(11,k.$26b),te(12,f.$Q6b),te(13,t.$dl),te(14,m.$R6b),te(15,u.$z6b),te(16,l.$qj),te(17,i.$T6b),te(18,O.$06b),te(19,z.$FN),te(20,se.$Ph)],Q)}),define(ie[302],ne([0,1,15,3,24,133]),function(J,e,S,A,s,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$86b=void 0;let C=class extends R.$66b{get win(){if(!this.c){const h=S.BrowserWindow.fromWebContents(this.h);h&&(this.c=h,this.n(h))}return this.c}a(){return this.win}get lastFocusTime(){return this.g}constructor(h,c){super(),this.h=h,this.j=c,this.id=this.h.id,this.b=this.B(new A.$Od),this.onDidClose=this.b.event,this.c=null,this.g=Date.now(),this.m()}m(){this.j.args["open-devtools"]===!0&&this.h.openDevTools({mode:"bottom"})}n(h){h.on("closed",()=>{this.b.fire(),this.dispose()}),h.on("focus",()=>{this.g=Date.now()})}dispose(){super.dispose(),this.c=null}};e.$86b=C,e.$86b=C=Ee([te(1,s.$x6b)],C)}),define(ie[303],ne([0,1,15,3,13,302,5,29]),function(J,e,S,A,s,R,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t8b=void 0;let h=class{constructor(g){this.b=g,this.a=new Map}createWindow(){return this.b.invokeFunction(P.$$6b,void 0,{webPreferences:{preload:s.$dg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload-slim.js").fsPath}})}registerWindow(g){const b=this.b.createInstance(R.$86b,g);this.a.set(b.id,b),A.Event.once(b.onDidClose)(()=>this.a.delete(b.id))}getWindowById(g){return this.a.get(g)}getFocusedWindow(){const g=S.BrowserWindow.getFocusedWindow();if(g)return this.getWindowById(g.id)}getLastActiveWindow(){return(0,P.$a7b)(Array.from(this.a.values()))}};e.$t8b=h,e.$t8b=h=Ee([te(0,C.$Ph)],h)}),define(ie[82],ne([0,1,15,23,8,3,46,2,13,4,19,7,21,193,5,20,6,81,97,30,53,31]),function(J,e,S,A,s,R,C,P,h,c,g,b,y,f,v,m,w,$,d,u,E,l){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$I7b=e.$H7b=void 0,e.$H7b=(0,v.$Qh)("workspacesHistoryMainService");let a=class extends P.$Sc{static{i=this}static{this.a=500}static{this.b="history.recentlyOpenedPathsList"}constructor(t,n,o,p){super(),this.f=t,this.g=n,this.h=o,this.j=p,this.c=this.B(new R.$Od),this.onDidChangeRecentlyOpened=this.c.event,this.G=this.B(new s.$Sg(800)),this.m()}m(){this.h.when(4).then(()=>this.H()),this.B(this.g.onDidEnterWorkspace(t=>this.addRecentlyOpened([{workspace:t.workspace,remoteAuthority:t.window.remoteAuthority}])))}async addRecentlyOpened(t){let n=[],o=[];for(const O of t)if((0,d.$SU)(O))!this.g.isUntitledWorkspace(O.workspace)&&!this.u(n,O.workspace)&&n.push(O);else if((0,d.$TU)(O))this.w(n,O.folderUri)||n.push(O);else{const D=this.y(o,O.fileUri),k=O.fileUri.scheme===h.Schemas.file&&i.F.indexOf((0,g.$tg)(O.fileUri))>=0;!D&&!k&&(o.push(O),c.$j&&O.fileUri.scheme===h.Schemas.file&&S.app.addRecentDocument(O.fileUri.fsPath))}const p=await this.n({workspaces:n,files:o});n=p.workspaces,o=p.files,n.length>i.a&&(n.length=i.a),o.length>i.a&&(o.length=i.a),await this.s({workspaces:n,files:o}),this.c.fire(),c.$k&&this.G.trigger(()=>this.M())}async removeRecentlyOpened(t){const n=D=>{const k=this.t(D);for(const I of t)if(g.$ng.isEqual(I,k))return!1;return!0},o=await this.getRecentlyOpened(),p=o.workspaces.filter(n),O=o.files.filter(n);(p.length!==o.workspaces.length||O.length!==o.files.length)&&(await this.s({files:O,workspaces:p}),this.c.fire(),c.$k&&this.G.trigger(()=>this.M()))}async clearRecentlyOpened(){await this.s({workspaces:[],files:[]}),S.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.n()}async n(t){const n=new l.$Ac(O=>g.$ng.getComparisonKey(O));if(t?.workspaces)for(const O of t.workspaces)n.set(this.t(O),O);const o=new l.$Ac(O=>g.$ng.getComparisonKey(O));if(t?.files)for(const O of t.files)o.set(this.t(O),O);const p=await this.r();for(const O of p.workspaces){const D=n.get(this.t(O));D?D.label=D.label??O.label:n.set(this.t(O),O)}for(const O of p.files){const D=o.get(this.t(O));D?D.label=D.label??O.label:o.set(this.t(O),O)}return{workspaces:[...n.values()],files:[...o.values()]}}async r(){await this.j.whenReady;let t;const n=this.j.get(i.b,-1);if(typeof n=="string")try{t=JSON.parse(n)}catch(o){this.f.error("Unexpected error parsing opened paths list",o)}return(0,d.$ZU)(t,this.f)}async s(t){await this.j.whenReady,this.j.store(i.b,JSON.stringify((0,d.$1U)(t)),-1,1)}t(t){return(0,d.$TU)(t)?t.folderUri:(0,d.$UU)(t)?t.fileUri:t.workspace.configPath}u(t,n){return!!t.find(o=>(0,d.$SU)(o)&&o.workspace.id===n.id)}w(t,n){return!!t.find(o=>(0,d.$TU)(o)&&g.$ng.isEqual(o.folderUri,n))}y(t,n){return!!t.find(o=>g.$ng.isEqual(o.fileUri,n))}static{this.z=7}static{this.C=10}static{this.D=7}static{this.F=["COMMIT_EDITMSG","MERGE_MSG"]}async H(){c.$j&&(await this.I(),this.B(this.onDidChangeRecentlyOpened(()=>this.I())))}async I(){if(!c.$j)return;const t=[];if(t.push({type:"tasks",items:[{type:"task",title:(0,f.localize)(0,null),description:(0,f.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const n=[];for(const O of S.app.getJumpListSettings().removedItems){const D=O.args;if(D){const k=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(D);k&&n.push(b.URI.parse(k[2]))}}await this.removeRecentlyOpened(n);let o=!1;const p=(0,A.$Hb)((await this.getRecentlyOpened()).workspaces.slice(0,i.D).map(O=>{const D=(0,d.$SU)(O)?O.workspace:O.folderUri,{title:k,description:I}=this.J(D,O.label);let j;return b.URI.isUri(D)?j=`--folder-uri "${D.toString()}"`:(o=!0,j=`--file-uri "${D.configPath.toString()}"`),{type:"task",title:k.substr(0,255),description:I.substr(0,255),program:process.execPath,args:j,iconPath:"explorer.exe",iconIndex:0}}));p.length>0&&t.push({type:"custom",name:o?(0,f.localize)(2,null):(0,f.localize)(3,null),items:p})}t.push({type:"recent"});try{const n=S.app.setJumpList(t);n&&n!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${n}`)}catch(n){this.f.warn("updateWindowsJumpList#setJumpList",n)}}J(t,n){if(n)return{title:(0,C.$Ev)(n).name,description:n};if(b.URI.isUri(t))return{title:(0,g.$tg)(t),description:this.L(t)};if(this.g.isUntitledWorkspace(t))return{title:(0,f.localize)(4,null),description:""};let o=(0,g.$tg)(t.configPath);return o.endsWith(u.$ai)&&(o=o.substr(0,o.length-u.$ai.length-1)),{title:(0,f.localize)(5,null,o),description:this.L(t.configPath)}}L(t){return t.scheme==="file"?(0,C.$wv)(t.fsPath):t.toString()}async M(){if(!c.$k)return;S.app.clearRecentDocuments();const t=await this.getRecentlyOpened(),n=[];let o=0;for(let O=0;O<t.workspaces.length&&o<i.z;O++){const D=this.t(t.workspaces[O]);if(D.scheme===h.Schemas.file){const k=(0,g.$kg)(D);await y.Promises.exists(k)&&(n.push(k),o++)}}const p=[];for(let O=0;O<t.files.length&&o<i.C;O++){const D=this.t(t.files[O]);if(D.scheme===h.Schemas.file){const k=(0,g.$kg)(D);if(i.F.includes((0,g.$tg)(D))||n.includes(k))continue;await y.Promises.exists(k)&&(p.push(k),o++)}}p.reverse().forEach(O=>S.app.addRecentDocument(O)),n.reverse().forEach(O=>S.app.addRecentDocument(O))}};e.$I7b=a,e.$I7b=a=i=Ee([te(0,w.$$i),te(1,E.$26b),te(2,m.$z6b),te(3,$.$J6b)],a)}),define(ie[304],ne([0,1,15,8,22,46,4,7,181,18,24,20,6,231,69,25,34,26,48,68,29,82]),function(J,e,S,A,s,R,C,P,h,c,g,b,y,f,v,m,w,$,d,u,E,l){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$J7b=void 0;const a="menu";let r=class{static{i=this}static{this.a="lastKnownMenubarData"}constructor(o,p,O,D,k,I,j,U,z,x,Z){this.n=o,this.o=p,this.p=O,this.q=D,this.r=k,this.s=I,this.t=j,this.u=U,this.v=z,this.w=x,this.x=Z,this.m=Object.create(null),this.g=new A.$7g(()=>this.E(),0),this.h=new A.$7g(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(C.$k||(0,u.$oC)(this.o)==="native")&&this.y(),this.z(),this.d=!1,this.f=!1,this.j=[],this.H(),this.A()}y(){const o=this.t.getItem(i.a);o&&(o.menus&&(this.k=o.menus),o.keybindings&&(this.l=o.keybindings))}z(){this.m["workbench.action.files.newUntitledFile"]=(I,j,U)=>this.p.openEmptyWindow({context:2,contextWindowId:j?.id}),this.m["workbench.action.newWindow"]=(I,j,U)=>this.p.openEmptyWindow({context:2,contextWindowId:j?.id}),this.m["workbench.action.files.openFileFolder"]=(I,j,U)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.P(U),telemetryExtraData:{from:a}}),this.m["workbench.action.files.openFolder"]=(I,j,U)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.P(U),telemetryExtraData:{from:a}}),this.m["workbench.action.openWorkspace"]=(I,j,U)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.P(U),telemetryExtraData:{from:a}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened();const o=this.x.youTubeUrl;o&&(this.m["workbench.action.openYouTubeUrl"]=()=>this.Z(o,"openYouTubeUrl"));const p=this.x.requestFeatureUrl;p&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.Z(p,"openUserVoiceUrl"));const O=this.x.reportIssueUrl;O&&(this.m["workbench.action.openIssueReporter"]=()=>this.Z(O,"openReportIssues"));const D=this.x.licenseUrl;D&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(C.$w){const I=D.indexOf("?")>0?"&":"?";this.Z(`${D}${I}lang=${C.$w}`,"openLicenseUrl")}else this.Z(D,"openLicenseUrl")});const k=this.x.privacyStatementUrl;k&&D&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.Z(k,"openPrivacyStatement")})}A(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(o=>this.F(o)),this.w.onDidBlurWindow(()=>this.G()),this.w.onDidFocusWindow(()=>this.G())}get B(){const o=this.o.getValue("window.enableMenuBarMnemonics");return typeof o!="boolean"?!0:o}get C(){if(!C.$k)return!1;const o=this.o.getValue("window.nativeTabs");return typeof o!="boolean"?!1:o}updateMenu(o,p){this.k=o.menus,this.l=o.keybindings,this.t.setItem(i.a,o),this.D()}D(){this.g.schedule()}E(){this.b||setTimeout(()=>{this.b||this.H()},10)}F(o){C.$k&&(o.oldCount===0&&o.newCount>0||o.oldCount>0&&o.newCount===0)&&(this.d=o.newCount===0,this.D())}G(){C.$k&&(this.f=!S.BrowserWindow.getFocusedWindow(),this.D())}H(){const o=S.Menu.getApplicationMenu();if(o&&this.j.push(o),Object.keys(this.k).length===0){S.Menu.setApplicationMenu(C.$k?new S.Menu:null);return}const p=new S.Menu;let O;if(C.$k){const k=new S.Menu;O=new S.MenuItem({label:this.x.nameShort,submenu:k}),this.I(k),p.append(O)}if(C.$k&&!this.c){this.c=!0;const k=new S.Menu;k.append(new S.MenuItem({label:this.ab(h.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),S.app.dock.setMenu(k)}if(this.K("File")){const k=new S.Menu,I=new S.MenuItem({label:this.ab(h.localize(1,null)),submenu:k});this.M(k,"File"),p.append(I)}if(this.K("Edit")){const k=new S.Menu,I=new S.MenuItem({label:this.ab(h.localize(2,null)),submenu:k});this.M(k,"Edit"),p.append(I)}if(this.K("Selection")){const k=new S.Menu,I=new S.MenuItem({label:this.ab(h.localize(3,null)),submenu:k});this.M(k,"Selection"),p.append(I)}if(this.K("View")){const k=new S.Menu,I=new S.MenuItem({label:this.ab(h.localize(4,null)),submenu:k});this.M(k,"View"),p.append(I)}if(this.K("Go")){const k=new S.Menu,I=new S.MenuItem({label:this.ab(h.localize(5,null)),submenu:k});this.M(k,"Go"),p.append(I)}if(this.K("Run")){const k=new S.Menu,I=new S.MenuItem({label:this.ab(h.localize(6,null)),submenu:k});this.M(k,"Run"),p.append(I)}if(this.K("Terminal")){const k=new S.Menu,I=new S.MenuItem({label:this.ab(h.localize(7,null)),submenu:k});this.M(k,"Terminal"),p.append(I)}let D;if(this.K("Window")){const k=new S.Menu;D=new S.MenuItem({label:this.ab(h.localize(8,null)),submenu:k,role:"window"}),this.S(k)}if(D&&p.append(D),this.K("Help")){const k=new S.Menu,I=new S.MenuItem({label:this.ab(h.localize(9,null)),submenu:k,role:"help"});this.M(k,"Help"),p.append(I)}p.items&&p.items.length>0?S.Menu.setApplicationMenu(p):S.Menu.setApplicationMenu(null),this.h.schedule()}I(o){const p=this.U(h.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),O=this.T();let D;if(this.K("Preferences")){const ae=new S.Menu;this.M(ae,"Preferences"),D=new S.MenuItem({label:this.ab(h.localize(11,null)),submenu:ae})}const k=new S.Menu,I=new S.MenuItem({label:h.localize(12,null),role:"services",submenu:k}),j=new S.MenuItem({label:h.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),U=new S.MenuItem({label:h.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),z=new S.MenuItem({label:h.localize(15,null),role:"unhide"}),x=new S.MenuItem(this.Y("workbench.action.quit",{label:h.localize(16,null,this.x.nameLong),click:async(ae,se,ce)=>{const Y=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||S.BrowserWindow.getFocusedWindow()||Y?.isMinimized())&&await this.J(ce)&&this.w.quit(void 0)}})),Z=[p];Z.push(...O),D&&Z.push(t(),D),Z.push(t(),I,t(),j,U,z,t(),x),Z.forEach(ae=>o.append(ae))}async J(o){if(this.p.getWindowCount()===0)return!0;const p=this.o.getValue("window.confirmBeforeClose");if(p==="always"||p==="keyboardOnly"&&this.Q(o)){const{response:O}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,{type:"question",buttons:[h.localize(17,null),h.localize(18,null)],message:h.localize(19,null)});return O===0}return!0}K(o){if(!C.$k&&(0,u.$oC)(this.o)==="custom")return!1;switch(o){case"File":case"Help":if(C.$k)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[o];case"Window":if(C.$k)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[o]}}L(o,p){p.forEach(O=>{if((0,f.$E7b)(O))o.append(t());else if((0,f.$D7b)(O)){const D=new S.Menu,k=new S.MenuItem({label:this.ab(O.label),submenu:D});this.L(D,O.submenu.items),o.append(k)}else(0,f.$F7b)(O)?o.append(this.O(O)):(0,f.$G7b)(O)&&(O.id==="workbench.action.showAboutDialog"&&this.N(o),C.$k?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[O.id]?o.append(new S.MenuItem(this.Y(O.id,{label:this.ab(O.label),click:this.m[O.id]}))):o.append(this.U(O.label,O.id,!1,O.checked)):o.append(this.U(O.label,O.id,O.enabled!==!1,!!O.checked)):o.append(this.U(O.label,O.id,O.enabled!==!1,!!O.checked)))})}M(o,p){this.k&&this.k[p]&&this.L(o,this.k[p].items)}N(o){const p=this.T();p.length&&(p.forEach(O=>o.append(O)),o.append(t()))}O(o){const p=P.URI.revive(o.uri),O=o.id,D=O==="openRecentFile"?{fileUri:p}:O==="openRecentWorkspace"?{workspaceUri:p}:{folderUri:p};return new S.MenuItem(this.Y(O,{label:o.label,click:async(k,I,j)=>{const U=this.P(j);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[D],forceNewWindow:U,gotoLineMode:!1,remoteAuthority:o.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([p])}},!1))}P(o){return!!(o&&(!C.$k&&(o.ctrlKey||o.shiftKey)||C.$k&&(o.metaKey||o.altKey)))}Q(o){return!!(o.triggeredByAccelerator||o.altKey||o.ctrlKey||o.metaKey||o.shiftKey)}R(o,p,O){const D={label:this.ab(o),role:O,enabled:!0};return new S.MenuItem(this.X(p,D))}S(o){const p=new S.MenuItem({label:h.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),O=new S.MenuItem({label:h.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),D=new S.MenuItem({label:h.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),k=this.U(h.localize(23,null),"workbench.action.switchWindow"),I=[];this.C&&(I.push(t()),I.push(this.U(h.localize(24,null),"workbench.action.newWindowTab")),I.push(this.R(h.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),I.push(this.R(h.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),I.push(this.R(h.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),I.push(this.R(h.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[p,O,t(),k,...I,t(),D].forEach(j=>o.append(j))}T(){switch(this.n.state.type){case"idle":return[new S.MenuItem({label:this.ab(h.localize(29,null)),click:()=>setTimeout(()=>{this.$("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new S.MenuItem({label:h.localize(30,null),enabled:!1})];case"available for download":return[new S.MenuItem({label:this.ab(h.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new S.MenuItem({label:h.localize(32,null),enabled:!1})];case"downloaded":return[new S.MenuItem({label:this.ab(h.localize(33,null)),click:()=>{this.$("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new S.MenuItem({label:h.localize(34,null),enabled:!1})];case"ready":return[new S.MenuItem({label:this.ab(h.localize(35,null)),click:()=>{this.$("RestartToUpdate"),this.n.quitAndInstall()}})];default:return[]}}U(o,p,O,D){const k=this.ab(o),I=typeof p=="function"?p:(Z,ae,se)=>{const ce=Z?Z.userSettingsLabel:null;let Y=p;Array.isArray(p)&&(Y=this.P(se)?p[1]:p[0]),ce&&se.triggeredByAccelerator?this.W({type:"keybinding",userSettingsLabel:ce}):this.W({type:"commandId",commandId:Y})},j=typeof O=="boolean"?O:this.p.getWindowCount()>0,U=typeof D=="boolean"?D:!1,z={label:k,click:I,enabled:j};U&&(z.type="checkbox",z.checked=U);let x;return typeof p=="string"?x=p:Array.isArray(p)&&(x=p[0]),C.$k&&(x==="editor.action.clipboardCutAction"?z.role="cut":x==="editor.action.clipboardCopyAction"?z.role="copy":x==="editor.action.clipboardPasteAction"&&(z.role="paste"),x==="undo"?z.click=this.V(I,{inDevTools:Z=>Z.undo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("undo:")}):x==="redo"?z.click=this.V(I,{inDevTools:Z=>Z.redo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("redo:")}):x==="editor.action.selectAll"&&(z.click=this.V(I,{inDevTools:Z=>Z.selectAll(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("selectAll:")}))),new S.MenuItem(this.X(x,z))}V(o,p){return(O,D,k)=>{const I=S.BrowserWindow.getFocusedWindow();if(!I)return p.inNoWindow();if(I.webContents.isDevToolsFocused()&&I.webContents.devToolsWebContents)return p.inDevTools(I.webContents.devToolsWebContents);o(O,D||I,k)}}W(o){let p=S.BrowserWindow.getFocusedWindow();if(!p){const D=this.p.getLastActiveWindow();D?.isMinimized()&&(p=D.win)}const O=p?this.p.getWindowById(p.id):void 0;if(O){if(this.v.trace("menubar#runActionInRenderer",o),C.$k&&!this.q.isBuilt&&!O.isReady&&(o.type==="commandId"&&o.commandId==="workbench.action.toggleDevTools"||o.type!=="commandId"&&o.userSettingsLabel==="alt+cmd+i"))return;if(o.type==="commandId"){const D={id:o.commandId,from:"menu"};O.sendWhenReady("vscode:runAction",s.CancellationToken.None,D)}else{const D={userSettingsLabel:o.userSettingsLabel};O.sendWhenReady("vscode:runKeybinding",s.CancellationToken.None,D)}}else this.v.trace("menubar#runActionInRenderer: no active window found",o)}X(o,p){const O=typeof o=="string"?this.l[o]:void 0;if(O?.label){if(O.isNative!==!1)p.accelerator=O.label,p.userSettingsLabel=O.userSettingsLabel;else if(typeof p.label=="string"){const D=p.label.indexOf("[");D>=0?p.label=`${p.label.substr(0,D)} [${O.label}]`:p.label=`${p.label} [${O.label}]`}}else p.accelerator=void 0;return p}Y(o,p,O=!p.accelerator){O&&(p=this.X(o,p));const D=p.click;return p.click=(k,I,j)=>{this.$(o),D?.(k,I,j)},p}Z(o,p){this.w.openExternal(void 0,o),this.$(p)}$(o){this.r.publicLog2("workbenchActionExecuted",{id:o,from:a})}ab(o){return(0,R.$Bv)(o,!this.B)}};e.$J7b=r,e.$J7b=r=i=Ee([te(0,d.$uU),te(1,c.$ki),te(2,E.$06b),te(3,g.$x6b),te(4,$.$dl),te(5,l.$H7b),te(6,w.$FN),te(7,b.$z6b),te(8,y.$$i),te(9,v.$v7b),te(10,m.$qj)],r);function t(){return new S.MenuItem({type:"separator"})}}),define(ie[305],ne([0,1,5,20,6,304]),function(J,e,S,A,s,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L7b=e.$K7b=void 0,e.$K7b=(0,S.$Qh)("menubarMainService");let C=class{constructor(h,c,g){this.b=h,this.c=c,this.d=g,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(R.$J7b)}async updateMenubar(h,c){this.d.trace("menubarService#updateMenubar",h),(await this.a).updateMenu(c,h)}};e.$L7b=C,e.$L7b=C=Ee([te(0,S.$Ph),te(1,A.$z6b),te(2,s.$$i)],C)}),define(ie[306],ne([0,1,15,21,131,28,23,22,3,33,46,2,13,9,65,4,35,19,12,7,191,63,18,59,24,16,5,20,6,78,79,58,34,68,133,29,130,298,30,98,82,53,67,39,52,66]),function(J,e,S,A,s,R,C,P,h,c,g,b,y,f,v,m,w,$,d,u,E,l,i,a,r,t,n,o,p,O,D,k,I,j,U,z,x,Z,ae,se,ce,Y,K,Q,q,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_7b=void 0;function G(re){return(0,ae.$6h)(re?.workspace)}function H(re){return(0,ae.$1h)(re?.workspace)}let X=class extends b.$Sc{constructor(L,M,N,T,F,B,V,oe,de,ue,he,ve,be,ye,Ie,Te,me,we,_){super(),this.m=L,this.n=M,this.r=N,this.s=T,this.t=F,this.u=B,this.w=V,this.z=oe,this.C=de,this.D=ue,this.F=he,this.G=ve,this.H=be,this.I=ye,this.J=Ie,this.L=Te,this.M=me,this.N=we,this.O=_,this.a=this.B(new h.$Od),this.onDidOpenWindow=this.a.event,this.b=this.B(new h.$Od),this.onDidSignalReadyWindow=this.b.event,this.c=this.B(new h.$Od),this.onDidDestroyWindow=this.c.event,this.f=this.B(new h.$Od),this.onDidChangeWindowsCount=this.f.event,this.g=this.B(new h.$Od),this.onDidTriggerSystemContextMenu=this.g.event,this.h=new Map,this.j=this.B(new Z.$97b(this,this.u,this.D,this.s,this.G)),this.P()}P(){this.B(this.I.onDidEnterWorkspace(L=>this.b.fire(L.window))),this.B(this.onDidSignalReadyWindow(L=>{if(L.config?.extensionDevelopmentPath||L.config?.extensionTestsPath){const M=new b.$Rc;if(M.add(h.Event.any(L.onDidClose,L.onDidDestroy)(()=>M.dispose())),L.config.extensionDevelopmentPath)for(const N of L.config.extensionDevelopmentPath)M.add(this.N.addValidFileRoot(N));L.config.extensionTestsPath&&M.add(this.N.addValidFileRoot(L.config.extensionTestsPath))}}))}openEmptyWindow(L,M){const N=this.z.args,T=M?.remoteAuthority||void 0,F=!0,B=M?.forceReuseWindow,V=!B;return this.open({...L,cli:N,forceEmpty:F,forceNewWindow:V,forceReuseWindow:B,remoteAuthority:T})}openExistingWindow(L,M){L.focus(),this.Q(M,[L])}async open(L){this.s.trace("windowsManager#open"),L.addMode&&(L.initialStartup||!this.getLastActiveWindow())&&(L.addMode=!1);const M=[],N=[],T=[],F=[],B=[];let V,oe=0;const de=await this.Y(L);this.s.trace("windowsManager#open pathsToOpen",de);for(const ye of de)H(ye)?L.addMode?M.push(ye):N.push(ye):G(ye)?T.push(ye):ye.fileUri?(V||(V={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:ye.remoteAuthority}),V.filesToOpenOrCreate.push(ye)):ye.backupPath?B.push({backupFolder:(0,f.$nc)(ye.backupPath),remoteAuthority:ye.remoteAuthority}):oe++;L.diffMode&&V&&V.filesToOpenOrCreate.length>=2&&(V.filesToDiff=V.filesToOpenOrCreate.slice(0,2),V.filesToOpenOrCreate=[]),L.mergeMode&&V&&V.filesToOpenOrCreate.length===4&&(V.filesToMerge=V.filesToOpenOrCreate.slice(0,4),V.filesToOpenOrCreate=[],V.filesToDiff=[]),V&&L.waitMarkerFileURI&&(V.filesToWait={paths:(0,C.$Hb)([...V.filesToDiff,V.filesToMerge[3],...V.filesToOpenOrCreate]),waitMarkerFileUri:L.waitMarkerFileURI}),L.initialStartup?(F.push(...this.I.getUntitledWorkspaces()),T.push(...F),B.push(...this.F.getEmptyWindowBackups())):B.length=0;const{windows:ue,filesOpenedInWindow:he}=await this.R(L,T,N,B,oe,V,M);if(this.s.trace(`windowsManager#open used window count ${ue.length} (workspacesToOpen: ${T.length}, foldersToOpen: ${N.length}, emptyToRestore: ${B.length}, emptyToOpen: ${oe})`),ue.length>1)if(he)he.focus();else{const ye=this.j.state.lastActiveWindow&&!L.forceEmpty&&!L.cli._.length&&!L.cli["file-uri"]&&!L.cli["folder-uri"]&&!(L.urisToOpen&&L.urisToOpen.length);let Ie=!0,Te=!0;if(ye){const me=ue.filter(we=>this.j.state.lastActiveWindow&&we.backupPath===this.j.state.lastActiveWindow.backupPath);me.length&&(me[0].focus(),Ie=!1,Te=!1)}if(Ie)for(let me=ue.length-1;me>=0;me--){const we=ue[me];if(!(we.openedWorkspace&&F.some(_=>we.openedWorkspace&&_.workspace.id===we.openedWorkspace.id)||we.backupPath&&B.some(_=>we.backupPath&&_.backupFolder===(0,f.$nc)(we.backupPath)))){we.focus(),Te=!1;break}}Te&&ue[ue.length-1].focus()}const ve=V&&V.filesToDiff.length>0,be=V&&V.filesToMerge.length>0;if(!ue.some(ye=>ye.isExtensionDevelopmentHost)&&!ve&&!be&&!L.noRecentEntry){const ye=[];for(const Ie of de)G(Ie)&&!Ie.transient?ye.push({label:Ie.label,workspace:Ie.workspace,remoteAuthority:Ie.remoteAuthority}):H(Ie)?ye.push({label:Ie.label,folderUri:Ie.workspace.uri,remoteAuthority:Ie.remoteAuthority}):Ie.fileUri&&ye.push({label:Ie.label,fileUri:Ie.fileUri,remoteAuthority:Ie.remoteAuthority});this.H.addRecentlyOpened(ye)}return this.Q(L,ue),ue}Q(L,M){const N=L.waitMarkerFileURI;L.context===0&&N&&M.length===1&&M[0]&&(async()=>{await M[0].whenClosedOrLoaded;try{await this.M.del(N)}catch{}})()}async R(L,M,N,T,F,B,V){const oe=[];let de;function ue(me,we){oe.push(me),we&&(de=me,B=void 0)}let{openFolderInNewWindow:he,openFilesInNewWindow:ve}=this.jb(L);if(!L.initialStartup&&V.length>0){const me=V[0].remoteAuthority,we=this.ob(me);we&&ue(this.U(we,V.map(_=>_.workspace.uri)))}const be=N.length+M.length+T.length;if(B&&be===0){const me=B.filesToOpenOrCreate[0]||B.filesToDiff[0]||B.filesToMerge[3],we=this.getWindows().filter(le=>B&&(0,$.$Bg)(le.remoteAuthority,B.remoteAuthority));let _;me?.fileUri&&!ve&&((L.context===4||L.context===0||L.context===1)&&(_=await(0,x.$U6b)(we,me.fileUri,async le=>le.configPath.scheme===y.Schemas.file?this.I.resolveLocalWorkspace(le.configPath):void 0)),_||(_=this.pb(we))),_?(0,ae.$6h)(_.openedWorkspace)?M.push({workspace:_.openedWorkspace,remoteAuthority:_.remoteAuthority}):(0,ae.$1h)(_.openedWorkspace)?N.push({workspace:_.openedWorkspace,remoteAuthority:_.remoteAuthority}):ue(this.S(L,_,B),!0):ue(await this.kb({userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,filesToOpen:B,forceNewWindow:!0,remoteAuthority:B.remoteAuthority,forceNewTabbedWindow:L.forceNewTabbedWindow,forceProfile:L.forceProfile,forceTempProfile:L.forceTempProfile}),!0)}const ye=(0,C.$Mb)(M,me=>me.workspace.id);if(ye.length>0){const me=(0,C.$Hb)(ye.map(we=>(0,x.$V6b)(this.getWindows(),we.workspace.configPath)));if(me.length>0){const we=me[0],_=(0,$.$Bg)(B?.remoteAuthority,we.remoteAuthority)?B:void 0;ue(this.S(L,we,_),!!_),he=!0}for(const we of ye){if(me.some(ge=>ge.openedWorkspace&&ge.openedWorkspace.id===we.workspace.id))continue;const _=we.remoteAuthority,le=(0,$.$Bg)(B?.remoteAuthority,_)?B:void 0;ue(await this.X(L,we,he,le),!!le),he=!0}}const Ie=(0,C.$Mb)(N,me=>$.$ng.getComparisonKey(me.workspace.uri));if(Ie.length>0){const me=(0,C.$Hb)(Ie.map(we=>(0,x.$V6b)(this.getWindows(),we.workspace.uri)));if(me.length>0){const we=me[0],_=(0,$.$Bg)(B?.remoteAuthority,we.remoteAuthority)?B:void 0;ue(this.S(L,we,_),!!_),he=!0}for(const we of Ie){if(me.some(ge=>(0,ae.$1h)(ge.openedWorkspace)&&$.$ng.isEqual(ge.openedWorkspace.uri,we.workspace.uri)))continue;const _=we.remoteAuthority,le=(0,$.$Bg)(B?.remoteAuthority,_)?B:void 0;ue(await this.X(L,we,he,le),!!le),he=!0}}const Te=(0,C.$Mb)(T,me=>me.backupFolder);if(Te.length>0)for(const me of Te){const we=me.remoteAuthority,_=(0,$.$Bg)(B?.remoteAuthority,we)?B:void 0;ue(await this.W(L,!0,we,_,me),!!_),he=!0}if(oe.length===0||B){B&&!F&&F++;const me=B?B.remoteAuthority:L.remoteAuthority;for(let we=0;we<F;we++)ue(await this.W(L,he,me,B),!!B),he=!0}return{windows:(0,C.$Mb)(oe),filesOpenedInWindow:de}}S(L,M,N){this.s.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:N}),M.focus();const T={filesToOpenOrCreate:N?.filesToOpenOrCreate,filesToDiff:N?.filesToDiff,filesToMerge:N?.filesToMerge,filesToWait:N?.filesToWait,termProgram:L?.userEnv?.TERM_PROGRAM};return M.sendWhenReady("vscode:openFiles",P.CancellationToken.None,T),M}U(L,M){this.s.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:M}),L.focus();const N={foldersToAdd:M};return L.sendWhenReady("vscode:addFolders",P.CancellationToken.None,N),L}W(L,M,N,T,F){this.s.trace("windowsManager#doOpenEmpty",{restore:!!F,remoteAuthority:N,filesToOpen:T,forceNewWindow:M});let B;return!M&&typeof L.contextWindowId=="number"&&(B=this.getWindowById(L.contextWindowId)),this.kb({userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,remoteAuthority:N,forceNewWindow:M,forceNewTabbedWindow:L.forceNewTabbedWindow,filesToOpen:T,windowToUse:B,emptyWindowBackupInfo:F,forceProfile:L.forceProfile,forceTempProfile:L.forceTempProfile})}X(L,M,N,T,F){return this.s.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:M,filesToOpen:T}),!N&&!F&&typeof L.contextWindowId=="number"&&(F=this.getWindowById(L.contextWindowId)),this.kb({workspace:M.workspace,userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,remoteAuthority:M.remoteAuthority,forceNewWindow:N,forceNewTabbedWindow:L.forceNewTabbedWindow,filesToOpen:T,windowToUse:F,forceProfile:L.forceProfile,forceTempProfile:L.forceTempProfile})}async Y(L){let M,N=!1,T=!1;if(L.urisToOpen&&L.urisToOpen.length>0?(M=await this.Z(L),N=!0):L.forceEmpty?M=[Object.create(null)]:L.cli._.length||L.cli["folder-uri"]||L.cli["file-uri"]?(M=await this.$(L.cli),M.length===0&&M.push(Object.create(null)),N=!0):(M=await this.bb(),M.length===0&&M.push(Object.create(null)),T=!0),!L.addMode&&N){const F=M.filter(B=>H(B));if(F.length>1){const B=F[0].remoteAuthority;if(F.every(V=>(0,$.$Bg)(V.remoteAuthority,B))){const V=await this.I.createUntitledWorkspace(F.map(oe=>({uri:oe.workspace.uri})));M.push({workspace:V,remoteAuthority:B}),M=M.filter(oe=>!H(oe))}}}if(L.initialStartup&&!T&&this.G.getValue("window")?.restoreWindows==="preserve"){const F=await this.bb();M.unshift(...F.filter(B=>G(B)||H(B)||B.backupPath))}return M}async Z(L){const M={gotoLineMode:L.gotoLineMode,remoteAuthority:L.remoteAuthority},N=await Promise.all((0,C.$Hb)(L.urisToOpen||[]).map(async T=>{const F=await this.db(T,M);if(F)return F.label=T.label,F;const B=this.fb(T);this.L.showMessageBox({type:"info",buttons:[(0,E.localize)(0,null)],message:B.scheme===y.Schemas.file?(0,E.localize)(1,null):(0,E.localize)(2,null),detail:B.scheme===y.Schemas.file?(0,E.localize)(3,null,(0,g.$vv)(B,{os:m.OS,tildify:this.z})):(0,E.localize)(4,null,B.toString(!0))},S.BrowserWindow.getFocusedWindow()??void 0)}));return(0,C.$Hb)(N)}async $(L){const M=[],N={ignoreFileNotFound:!0,gotoLineMode:L.goto,remoteAuthority:L.remote||void 0,forceOpenWorkspaceAsFile:L.diff&&L._.length===2||L.merge&&L._.length===4},T=L["folder-uri"];if(T){const V=await Promise.all(T.map(oe=>{const de=this.ab(oe);if(de)return this.db({folderUri:de},N)}));M.push(...(0,C.$Hb)(V))}const F=L["file-uri"];if(F){const V=await Promise.all(F.map(oe=>{const de=this.ab(oe);if(de)return this.db((0,ae.$ji)(oe)?{workspaceUri:de}:{fileUri:de},N)}));M.push(...(0,C.$Hb)(V))}const B=await Promise.all(L._.map(V=>N.remoteAuthority?this.ib(V,N):this.gb(V,N)));return M.push(...(0,C.$Hb)(B)),M}ab(L){try{const M=u.URI.parse(L);if(!M.scheme){this.s.error(`Invalid URI input string, scheme missing: ${L}`);return}return M.path?M:M.with({path:"/"})}catch(M){this.s.error(`Invalid URI input string: ${L}, ${M.message}`)}}async bb(){const L=this.cb();switch(L){case"none":return[];case"one":case"all":case"preserve":case"folders":{const M=[];L!=="one"&&M.push(...this.j.state.openedWindows),this.j.state.lastActiveWindow&&M.push(this.j.state.lastActiveWindow);const N=await Promise.all(M.map(async T=>{if(T.workspace){const F=await this.db({workspaceUri:T.workspace.configPath},{remoteAuthority:T.remoteAuthority,rejectTransientWorkspaces:!0});if(G(F))return F}else if(T.folderUri){const F=await this.db({folderUri:T.folderUri},{remoteAuthority:T.remoteAuthority});if(H(F))return F}else if(L!=="folders"&&T.backupPath)return{backupPath:T.backupPath,remoteAuthority:T.remoteAuthority}}));return(0,C.$Hb)(N)}}}cb(){let L;return this.D.wasRestarted?L="all":(L=this.G.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(L)||(L="all")),L}async db(L,M=Object.create(null)){const N=this.fb(L);return N.scheme===y.Schemas.file?((0,j.$mC)(L)&&(M={...M,forceOpenWorkspaceAsFile:!0}),this.gb(N.fsPath,M)):this.eb(L,M)}eb(L,M){let N=this.fb(L);const T=(0,k.$Vk)(N)||M.remoteAuthority;if(N=(0,$.$Dg)((0,$.$xg)(N)),(0,j.$mC)(L)){if(M.gotoLineMode){const{path:F,line:B,column:V}=(0,c.$6f)(N.path);return{fileUri:N.with({path:F}),options:{selection:B?{startLineNumber:B,startColumn:V||1}:void 0},remoteAuthority:T}}return{fileUri:N,remoteAuthority:T}}else if((0,j.$kC)(L))return{workspace:(0,se.$Y6b)(N),remoteAuthority:T};return{workspace:(0,se.$Z6b)(N),remoteAuthority:T}}fb(L){return(0,j.$kC)(L)?L.workspaceUri:(0,j.$lC)(L)?L.folderUri:L.fileUri}async gb(L,M,N){let T,F;M.gotoLineMode&&({path:L,line:T,column:F}=(0,c.$6f)(L)),L=(0,c.$1f)((0,f.$hc)(L),(0,w.cwd)());try{const B=await A.Promises.stat(L);if(B.isFile()){if(!M.forceOpenWorkspaceAsFile){const V=await this.I.resolveLocalWorkspace(u.URI.file(L));if(V)return V.transient&&M.rejectTransientWorkspaces?void 0:{workspace:{id:V.id,configPath:V.configPath},type:t.FileType.File,exists:!0,remoteAuthority:V.remoteAuthority,transient:V.transient}}return{fileUri:u.URI.file(L),type:t.FileType.File,exists:!0,options:{selection:T?{startLineNumber:T,startColumn:F||1}:void 0}}}else{if(B.isDirectory())return{workspace:(0,se.$Z6b)(u.URI.file(L),B),type:t.FileType.Directory,exists:!0};if(!m.$j&&L==="/dev/null")return{fileUri:u.URI.file(L),type:t.FileType.File,exists:!0}}}catch(B){if(B.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!N)return this.hb(L,M);const V=u.URI.file(L);if(this.H.removeRecentlyOpened([V]),M.ignoreFileNotFound)return{fileUri:V,type:t.FileType.File,exists:!1}}}async hb(L,M){const N=u.URI.file(L),{response:T,checkboxChecked:F}=await this.L.showMessageBox({type:"warning",buttons:[(0,E.localize)(5,null),(0,E.localize)(6,null),(0,E.localize)(7,null)],message:(0,E.localize)(8,null,N.authority),detail:(0,E.localize)(9,null,(0,g.$vv)(N,{os:m.OS,tildify:this.z})),checkboxLabel:(0,E.localize)(10,null,N.authority),cancelId:1});if(T===0){if((0,s.addUNCHostToAllowlist)(N.authority),F){const B={channel:"vscode:configureAllowedUNCHost",args:N.authority};this.sendToFocused(B.channel,B.args),this.sendToOpeningWindow(B.channel,B.args)}return this.gb(L,M,!0)}if(T===2)return S.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.hb(L,M)}ib(L,M){const N=L.charCodeAt(0),T=M.remoteAuthority;let F,B;M.gotoLineMode&&({path:L,line:F,column:B}=(0,c.$6f)(L)),N!==47&&((0,c.$Zf)(N)&&L.charCodeAt(L.charCodeAt(1))===58&&(L=(0,c.$Sf)(L)),L=`/${L}`);const V=u.URI.from({scheme:y.Schemas.vscodeRemote,authority:T,path:L});if(L.charCodeAt(L.length-1)!==47){if((0,ae.$ji)(L))return M.forceOpenWorkspaceAsFile?{fileUri:V,options:{selection:F?{startLineNumber:F,startColumn:B||1}:void 0},remoteAuthority:M.remoteAuthority}:{workspace:(0,se.$Y6b)(V),remoteAuthority:T};if(M.gotoLineMode||f.$gc.basename(L).indexOf(".")!==-1)return{fileUri:V,options:{selection:F?{startLineNumber:F,startColumn:B||1}:void 0},remoteAuthority:T}}return{workspace:(0,se.$Z6b)(V),remoteAuthority:T}}jb(L){const M=this.G.getValue("window"),N=M?.openFoldersInNewWindow||"default",T=M?.openFilesInNewWindow||"off";let F=(L.preferNewWindow||L.forceNewWindow)&&!L.forceReuseWindow;!L.forceNewWindow&&!L.forceReuseWindow&&(N==="on"||N==="off")&&(F=N==="on");let B=!1;return L.forceNewWindow||L.forceReuseWindow?B=!!L.forceNewWindow&&!L.forceReuseWindow:(m.$k?L.context===1&&(B=!0):L.context!==3&&L.context!==2&&!(L.userEnv&&L.userEnv.TERM_PROGRAM==="vscode")&&(B=!0),!L.cli.extensionDevelopmentPath&&(T==="on"||T==="off")&&(B=T==="on")),{openFolderInNewWindow:!!F,openFilesInNewWindow:B}}async openExtensionDevelopmentHostWindow(L,M){const N=(0,x.$W6b)(this.getWindows(),L);if(N)return this.D.reload(N,M.cli),N.focus(),[N];let T=M.cli["folder-uri"]||[],F=M.cli["file-uri"]||[],B=M.cli._;if(!B.length&&!T.length&&!F.length&&!M.cli.extensionTestsPath){const de=this.j.state.lastPluginDevelopmentHostWindow,ue=de?.workspace??de?.folderUri;ue&&(u.URI.isUri(ue)?ue.scheme===y.Schemas.file?B=[ue.fsPath]:T=[ue.toString()]:ue.configPath.scheme===y.Schemas.file?B=[(0,$.$kg)(ue.configPath)]:F=[ue.configPath.toString()])}let V=M.remoteAuthority;for(const de of L)if(de.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ue=u.URI.parse(de),he=(0,k.$Vk)(ue);he&&(V?(0,$.$Bg)(he,V)||this.s.error("more than one extension development path authority"):V=he)}B=B.filter(de=>{const ue=u.URI.file(de);return(0,x.$V6b)(this.getWindows(),ue)?!1:(0,$.$Bg)((0,k.$Vk)(ue),V)}),T=T.filter(de=>{const ue=this.ab(de);return ue&&(0,x.$V6b)(this.getWindows(),ue)?!1:ue?(0,$.$Bg)((0,k.$Vk)(ue),V):!1}),F=F.filter(de=>{const ue=this.ab(de);return ue&&(0,x.$V6b)(this.getWindows(),ue)?!1:ue?(0,$.$Bg)((0,k.$Vk)(ue),V):!1}),M.cli._=B,M.cli["folder-uri"]=T,M.cli["file-uri"]=F;const oe={context:M.context,cli:M.cli,forceNewWindow:!0,forceEmpty:!B.length&&!T.length&&!F.length,userEnv:M.userEnv,noRecentEntry:!0,waitMarkerFileURI:M.waitMarkerFileURI,remoteAuthority:V,forceProfile:M.forceProfile,forceTempProfile:M.forceTempProfile};return this.open(oe)}async kb(L){const M=this.G.getValue("window"),N=this.getLastActiveWindow(),T=N?.profile??this.C.defaultProfile;let F;!L.forceNewWindow&&!L.forceNewTabbedWindow&&(F=L.windowToUse||N,F&&F.focus());const B={...this.z.args,...L.cli,machineId:this.m,sqmId:this.n,windowId:-1,mainPid:process.pid,appRoot:this.z.appRoot,execPath:process.execPath,codeCachePath:this.z.codeCachePath,backupPath:L.emptyWindowBackupInfo?(0,f.$jc)(this.z.backupHome,L.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.C.profilesHome,all:this.C.profiles,profile:T},homeDir:this.z.userHome.with({scheme:y.Schemas.file}).fsPath,tmpDir:this.z.tmpDir.with({scheme:y.Schemas.file}).fsPath,userDataDir:this.z.userDataPath,remoteAuthority:L.remoteAuthority,workspace:L.workspace,userEnv:{...this.r,...L.userEnv},filesToOpenOrCreate:L.filesToOpen?.filesToOpenOrCreate,filesToDiff:L.filesToOpen?.filesToDiff,filesToMerge:L.filesToOpen?.filesToMerge,filesToWait:L.filesToOpen?.filesToWait,logLevel:this.t.getLogLevel(),loggers:{window:[],global:this.t.getRegisteredLoggers()},logsPath:this.z.logsHome.with({scheme:y.Schemas.file}).fsPath,product:O.default,isInitialStartup:L.initialStartup,perfMarks:(0,v.getMarks)(),os:{release:(0,R.release)(),hostname:(0,R.hostname)(),arch:(0,R.arch)()},zoomLevel:typeof M?.zoomLevel=="number"?M.zoomLevel:void 0,autoDetectHighContrast:M?.autoDetectHighContrast??!0,autoDetectColorScheme:M?.autoDetectColorScheme??!1,accessibilitySupport:S.app.accessibilitySupportEnabled,colorScheme:this.O.getColorScheme(),policiesData:this.w.serialize(),continueOn:this.z.continueOn};if(F){const V=F.config;!B.extensionDevelopmentPath&&V?.extensionDevelopmentPath&&(B.extensionDevelopmentPath=V.extensionDevelopmentPath,B.extensionDevelopmentKind=V.extensionDevelopmentKind,B["enable-proposed-api"]=V["enable-proposed-api"],B.verbose=V.verbose,B["inspect-extensions"]=V["inspect-extensions"],B["inspect-brk-extensions"]=V["inspect-brk-extensions"],B.debugId=V.debugId,B.extensionEnvironment=V.extensionEnvironment,B["extensions-dir"]=V["extensions-dir"],B["disable-extensions"]=V["disable-extensions"]),B.loggers={global:B.loggers.global,window:V?.loggers.window??B.loggers.window}}else{const V=this.j.getNewWindowState(B);(0,v.mark)("code/willCreateCodeWindow");const oe=F=this.J.createInstance(U.$76b,{state:V,extensionDevelopmentPath:B.extensionDevelopmentPath,isExtensionTestHost:!!B.extensionTestsPath});(0,v.mark)("code/didCreateCodeWindow"),L.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(oe),this.h.set(oe.id,oe),this.a.fire(oe),this.f.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()});const de=new b.$Rc;de.add(oe.onDidSignalReady(()=>this.b.fire(oe))),de.add(h.Event.once(oe.onDidClose)(()=>this.nb(oe,de))),de.add(h.Event.once(oe.onDidDestroy)(()=>this.c.fire(oe))),de.add(oe.onDidTriggerSystemContextMenu(({x:he,y:ve})=>this.g.fire({window:oe,x:he,y:ve})));const ue=(0,d.$Kf)(oe.win?.webContents);ue.removeAllListeners("devtools-reload-page"),ue.on("devtools-reload-page",()=>this.D.reload(oe)),this.D.registerWindow(oe)}return B.windowId=F.id,F.isReady?this.D.unload(F,4).then(async V=>{V||await this.lb(F,B,L,T)}):await this.lb(F,B,L,T),F}async lb(L,M,N,T){if(M.extensionDevelopmentPath||((0,ae.$6h)(M.workspace)?M.backupPath=this.F.registerWorkspaceBackup({workspace:M.workspace,remoteAuthority:M.remoteAuthority}):(0,ae.$1h)(M.workspace)?M.backupPath=this.F.registerFolderBackup({folderUri:M.workspace.uri,remoteAuthority:M.remoteAuthority}):M.backupPath=this.F.registerEmptyWindowBackup({backupFolder:N.emptyWindowBackupInfo?.backupFolder??(0,se.$16b)().id,remoteAuthority:M.remoteAuthority})),this.C.isEnabled()){const F=M.workspace??(0,ae.$5h)(M.backupPath,!1),B=this.mb(N,F,T),V=B instanceof Promise?await B:B;M.profiles.profile=V,M.extensionDevelopmentPath||await this.C.setProfileForWorkspace(F,V)}L.load(M)}mb(L,M,N){return L.forceProfile?this.C.profiles.find(T=>T.name===L.forceProfile)??this.C.createNamedProfile(L.forceProfile):L.forceTempProfile?this.C.createTransientProfile():this.C.getProfileForWorkspace(M)??N}nb(L,M){this.h.delete(L.id),this.f.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()}),M.dispose()}getFocusedWindow(){const L=S.BrowserWindow.getFocusedWindow();if(L)return this.getWindowById(L.id)}getLastActiveWindow(){return this.pb(this.getWindows())}ob(L){return this.pb(this.getWindows().filter(M=>(0,$.$Bg)(M.remoteAuthority,L)))}pb(L){return(0,z.$a7b)(L)}sendToFocused(L,...M){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(L,P.CancellationToken.None,...M)}sendToOpeningWindow(L,...M){this.B(h.Event.once(this.onDidSignalReadyWindow)(N=>{N.sendWhenReady(L,P.CancellationToken.None,...M)}))}sendToAll(L,M,N){for(const T of this.getWindows())N&&N.indexOf(T.id)>=0||T.sendWhenReady(L,P.CancellationToken.None,M)}getWindows(){return Array.from(this.h.values())}getWindowCount(){return this.h.size}getWindowById(L){return this.h.get(L)}getWindowByWebContents(L){const M=S.BrowserWindow.fromWebContents(L);if(M)return this.getWindowById(M.id)}};e.$_7b=X,e.$_7b=X=Ee([te(3,p.$$i),te(4,W.$46b),te(5,I.$FN),te(6,Q.$mn),te(7,r.$x6b),te(8,q.$F6b),te(9,o.$z6b),te(10,l.$Q6b),te(11,i.$ki),te(12,ce.$H7b),te(13,Y.$26b),te(14,n.$Ph),te(15,a.$R6b),te(16,t.$_j),te(17,D.$T6b),te(18,K.$L6b)],X)}),define(ie[307],ne([0,1,63,29,82,53]),function(J,e,S,A,s,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b8b=void 0;let C=class{constructor(h,c,g,b){this.a=h,this.b=c,this.c=g,this.d=b,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(h,c){const g=this.b.getWindowById(h);if(g)return this.a.enterWorkspace(g,this.b.getWindows(),c)}createUntitledWorkspace(h,c,g){return this.a.createUntitledWorkspace(c,g)}deleteUntitledWorkspace(h,c){return this.a.deleteUntitledWorkspace(c)}getWorkspaceIdentifier(h,c){return this.a.getWorkspaceIdentifier(c)}getRecentlyOpened(h){return this.c.getRecentlyOpened()}addRecentlyOpened(h,c){return this.c.addRecentlyOpened(c)}removeRecentlyOpened(h,c){return this.c.removeRecentlyOpened(c)}clearRecentlyOpened(h){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};e.$b8b=C,e.$b8b=C=Ee([te(0,R.$26b),te(1,A.$06b),te(2,s.$H7b),te(3,S.$Q6b)],C)}),define(ie[308],ne([0,1,15,131,38,28,17,49,14,33,3,44,46,2,13,9,4,12,7,32,158,42,159,110,290,162,63,283,18,200,91,132,59,116,220,24,62,94,209,293,211,212,213,16,224,93,77,5,92,219,299,284,291,20,6,305,69,25,58,294,95,34,275,81,122,26,251,253,51,48,265,288,300,289,301,127,267,268,269,272,297,29,306,274,30,97,82,307,53,39,233,52,244,50,80,129,277,292,280,8,255,276,228,66,296,271,23,125,295,263,239,71,90,303]),function(J,e,S,A,s,R,C,P,h,c,g,b,y,f,v,m,w,$,d,u,E,l,i,a,r,t,n,o,p,O,D,k,I,j,U,z,x,Z,ae,se,ce,Y,K,Q,q,W,G,H,X,re,L,M,N,T,F,B,V,oe,de,ue,he,ve,be,ye,Ie,Te,me,we,_,le,ge,Oe,Ce,Le,Re,He,ze,ee,fe,$e,ke,De,Ne,je,Fe,Ve,Ge,Qe,Ze,Xe,it,nt,wt,bt,pt,yt,vt,kt,Et,rt,ht,St,Pt,It,ot,Ot,ft,at,Dt,Ct,ct,At,dt,Rt){"use strict";var lt;Object.defineProperty(e,"__esModule",{value:!0}),e.$u8b=void 0;let ut=class extends f.$Sc{static{lt=this}static{this.a={[v.Schemas.file]:"security.promptForLocalFileProtocolHandling",[v.Schemas.vscodeRemote]:"security.promptForRemoteFileProtocolHandling"}}constructor(Se,Pe,Ae,pe,Me,Ue,Be,Je,qe,We,Ke,Ye){super(),this.g=Se,this.h=Pe,this.j=Ae,this.m=pe,this.n=Me,this.s=Ue,this.t=Be,this.u=Je,this.w=qe,this.y=We,this.z=Ke,this.C=Ye,this.D(),this.F()}D(){const Se=qe=>qe?.startsWith(`${v.Schemas.vscodeWebview}://`),Pe=new Set(["clipboard-read","clipboard-sanitized-write"]);S.session.defaultSession.setPermissionRequestHandler((qe,We,Ke,Ye)=>Se(Ye.requestingUrl)?Ke(Pe.has(We)):Ke(!1)),S.session.defaultSession.setPermissionCheckHandler((qe,We,Ke,Ye)=>Se(Ye.requestingUrl)?Pe.has(We):!1);const Ae=new Set([v.Schemas.file,v.Schemas.vscodeFileResource,v.Schemas.vscodeRemoteResource,v.Schemas.vscodeManagedRemoteResource,"devtools"]),pe=qe=>{for(let We=qe;We;We=We.parent)if(We.url.startsWith(`${v.Schemas.vscodeWebview}://`))return!0;return!1},Me=qe=>qe.resourceType==="xhr"||pe(qe.frame),Ue=qe=>{const We=qe.frame;if(!We||!this.b)return!1;const Ke=S.BrowserWindow.getAllWindows();for(const Ye of Ke)if(We.processId===Ye.webContents.mainFrame.processId)return!0;return!1},Be=(qe,We)=>{if(qe.path!=="/index.html")return!0;const Ke=We.frame;if(!Ke||!this.b)return!1;for(const Ye of this.b.getWindows())if(Ye.win&&Ke.processId===Ye.win.webContents.mainFrame.processId)return!0;return!1};S.session.defaultSession.webRequest.onBeforeRequest((qe,We)=>{const Ke=d.URI.parse(qe.url);return Ke.scheme===v.Schemas.vscodeWebview&&!Be(Ke,qe)?(this.m.error("Blocked vscode-webview request",qe.url),We({cancel:!0})):Ke.scheme===v.Schemas.vscodeFileResource&&!Ue(qe)?(this.m.error("Blocked vscode-file request",qe.url),We({cancel:!0})):Ke.path.endsWith(".svg")&&!Ae.has(Ke.scheme)?We({cancel:!Me(qe)}):We({cancel:!1})}),S.session.defaultSession.webRequest.onHeadersReceived((qe,We)=>{const Ke=qe.responseHeaders,Ye=Ke["content-type"]||Ke["Content-Type"];if(Ye&&Array.isArray(Ye)){const xe=d.URI.parse(qe.url);if(xe.path.endsWith(".svg")&&Ae.has(xe.scheme))return Ke["Content-Type"]=["image/svg+xml"],We({cancel:!1,responseHeaders:Ke});if(!xe.path.endsWith(v.Schemas.vscodeRemoteResource)&&Ye.some(et=>et.toLowerCase().includes("image/svg")))return We({cancel:!Me(qe)})}return We({cancel:!1})});const Je=S.session.defaultSession;typeof Je.setCodeCachePath=="function"&&this.s.codeCachePath&&Je.setCodeCachePath((0,m.$jc)(this.s.codeCachePath,"chrome")),w.$j&&(this.u.getValue("security.restrictUNCAccess")===!1?(0,A.disableUNCAccessRestrictions)():(0,A.addUNCHostToAllowlist)(this.u.getValue("security.allowedUNCHosts")))}F(){(0,h.setUnexpectedErrorHandler)(Ae=>this.H(Ae)),process.on("uncaughtException",Ae=>{(0,h.$Z)(Ae)||(0,h.$1)(Ae)}),process.on("unhandledRejection",Ae=>(0,h.$1)(Ae)),this.t.onWillShutdown(()=>this.dispose()),(0,E.$vT)(),S.app.on("accessibility-support-changed",(Ae,pe)=>{this.b?.sendToAll("vscode:accessibilitySupportChanged",pe)}),S.app.on("activate",async(Ae,pe)=>{this.m.trace("app#activate"),pe||await this.b?.openEmptyWindow({context:1})}),S.app.on("web-contents-created",(Ae,pe)=>{pe?.opener?.url.startsWith(`${v.Schemas.vscodeFileResource}://${v.$cg}/`)&&this.c?.registerWindow(pe),pe.on("will-navigate",Ue=>{this.m.error("webContents#will-navigate: Prevented webcontent navigation"),Ue.preventDefault()}),pe.setWindowOpenHandler(Ue=>Ue.url==="about:blank"?(this.m.trace("webContents#setWindowOpenHandler: Allowing about:blank window to open"),{action:"allow",overrideBrowserWindowOptions:this.c?.createWindow()}):(this.m.trace(`webContents#setWindowOpenHandler: Prevented opening window with URL ${Ue.url}}`),this.f?.openExternal(void 0,Ue.url),{action:"deny"}))});let Se=[],Pe;S.app.on("open-file",(Ae,pe)=>{this.m.trace("app#open-file: ",pe),Ae.preventDefault(),Se.push((0,Fe.$ji)(pe)?{workspaceUri:d.URI.file(pe)}:{fileUri:d.URI.file(pe)}),Pe!==void 0&&(clearTimeout(Pe),Pe=void 0),Pe=setTimeout(async()=>{await this.b?.open({context:1,cli:this.s.args,urisToOpen:Se,gotoLineMode:!1,preferNewWindow:!0}),Se=[],Pe=void 0},100)}),S.app.on("new-window-for-tab",async()=>{await this.b?.openEmptyWindow({context:4})}),s.$uT.handle("vscode:getWindowId",Ae=>Promise.resolve(Ae.sender.id)),s.$uT.handle("vscode:fetchShellEnv",Ae=>{const pe=this.b?.getWindowByWebContents(Ae.sender);let Me,Ue;return pe?.config?(Me=pe.config,Ue={...process.env,...pe.config.userEnv}):(Me=this.s.args,Ue=process.env),this.X(Me,Ue,!1)}),s.$uT.handle("vscode:writeNlsFile",(Ae,pe,Me)=>{const Ue=this.G([pe]);if(!Ue||typeof Me!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.y.writeFile(Ue,C.$ce.fromString(Me))}),s.$uT.handle("vscode:readNlsFile",async(Ae,...pe)=>{const Me=this.G(pe);if(!Me)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.y.readFile(Me)).value.toString()}),s.$uT.on("vscode:toggleDevTools",Ae=>Ae.sender.toggleDevTools()),s.$uT.on("vscode:openDevTools",Ae=>Ae.sender.openDevTools()),s.$uT.on("vscode:reloadWindow",Ae=>Ae.sender.reload())}G(Se){let Pe;for(const Ae of Se)typeof Ae=="string"&&(typeof Pe!="string"?Pe=Ae:Pe=(0,m.$jc)(Pe,Ae));if(!(typeof Pe!="string"||!(0,m.$ic)(Pe)||!(0,c.$Yf)(Pe,this.s.cachedLanguagesPath,!w.$l)))return d.URI.file(Pe)}H(Se){if(Se){const Pe={message:`[uncaught exception in main]: ${Se.message}`,stack:Se.stack};this.b?.sendToFocused("vscode:reportError",JSON.stringify(Pe))}this.m.error(`[uncaught exception in main]: ${Se}`),Se.stack&&this.m.error(Se.stack)}async startup(){this.m.debug("Starting VS Code"),this.m.debug(`from: ${this.s.appRoot}`),this.m.debug("args:",this.s.args);const Se=this.z.win32AppUserModelId;w.$j&&Se&&S.app.setAppUserModelId(Se);try{w.$k&&this.u.getValue("window.nativeTabs")===!0&&!S.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&S.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(We){this.m.error(We)}const Pe=new i.$BT;this.t.onWillShutdown(We=>{We.reason===2&&Pe.dispose()}),this.m.trace("Resolving machine identifier...");const[Ae,pe]=await Promise.all([(0,ht.$j8b)(this.w,this.m),(0,ht.$k8b)(this.w,this.m)]);this.m.trace(`Resolved machine identifier: ${Ae}`);const{sharedProcessReady:Me,sharedProcessClient:Ue}=this.P(Ae,pe),Be=await this.Q(Ae,pe,Me);this.B(Be.createInstance(r.$b7b)),this.B(Be.createInstance(kt.$f8b)),Be.invokeFunction(We=>this.R(We,Pe,Ue));const Je=await Be.invokeFunction(We=>this.I(We,Pe));this.J(Pe),this.t.phase=2,await Be.invokeFunction(We=>this.S(We,Je)),this.t.phase=3,this.U(),this.B(new rt.$7g(()=>{this.B((0,rt.$$g)(()=>this.t.phase=4,2500))},2500)).schedule()}async I(Se,Pe){const Ae=this.b=Se.get(De.$06b),pe=Se.get(He.$iU),Me=this.f=Se.get(V.$v7b),Ue=Se.get(I.$R6b),Be=this;pe.registerHandler({async handleURL(xe,et){return Be.O(Ae,Ue,pe,xe,et)}});const Je=this.B(new je.$a8b({onDidOpenWindow:Me.onDidOpenWindow,onDidFocusWindow:Me.onDidFocusWindow,getActiveWindowId:()=>Me.getActiveWindowId(-1)})),qe=new l.$yh(xe=>Je.getActiveClientId().then(et=>xe===et)),We=new ze.$47b(qe,this.m),Ke=Pe.getChannel("urlHandler",We);pe.registerHandler(new ze.$37b(Ke));const Ye=await this.L(Ae,Ue);return this.B(new fe.$57b(Ye?.urls,pe,Ae,this.s,this.z,this.m)),Ye}J(Se){const Pe=()=>({statusCode:404,data:"Not found"}),Ae=new At.$V(()=>Se.getChannel(ct.$r8b,new ct.$s8b));S.protocol.registerBufferProtocol(v.Schemas.vscodeManagedRemoteResource,(pe,Me)=>{const Ue=d.URI.parse(pe.url);if(!Ue.authority.startsWith("window:"))return Me(Pe());Ae.value.call(ct.$q8b,[Ue]).then(Be=>Me({...Be,data:Buffer.from(Be.body,"base64")}),Be=>{this.m.warn("error dispatching remote resource call",Be),Me({statusCode:500,data:String(Be)})})})}async L(Se,Pe){const Ae=this.s.args["open-url"]?this.s.args._urls||[]:[];Ae.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Ae);const pe=global.getOpenUrls()||[];if(pe.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",pe),Ae.length+pe.length===0)return;const Me=[...Ae,...pe].map(Je=>{try{return{uri:d.URI.parse(Je),originalUrl:Je}}catch{this.m.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Je);return}}),Ue=[],Be=[];for(const Je of Me){if(!Je)continue;if(await this.M(Je.uri,Se,Pe)){this.m.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Je.uri.toString(!0));continue}const qe=this.N(Je.uri);qe?(this.m.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Je.uri.toString(!0),qe),Ue.push(qe)):(this.m.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Je.uri.toString(!0)),Be.push(Je))}return{urls:Be,openables:Ue}}async M(Se,Pe,Ae){if(Se.authority!==v.Schemas.file&&Se.authority!==v.Schemas.vscodeRemote||this.u.getValue(lt.a[Se.authority])===!1)return!1;const{response:Me,checkboxChecked:Ue}=await Ae.showMessageBox({type:"warning",buttons:[(0,t.localize)(0,null),(0,t.localize)(1,null)],message:(0,t.localize)(2,null,Se.authority===v.Schemas.file?(0,y.$vv)(Se,{os:w.OS,tildify:this.s}):Se.toString(!0),this.z.nameShort),detail:(0,t.localize)(3,null),checkboxLabel:Se.authority===v.Schemas.file?(0,t.localize)(4,null):(0,t.localize)(5,null),cancelId:1});if(Me!==0)return!0;if(Ue){const Be={channel:"vscode:disablePromptForProtocolHandling",args:Se.authority===v.Schemas.file?"local":"remote"};Pe.sendToFocused(Be.channel,Be.args),Pe.sendToOpeningWindow(Be.channel,Be.args)}return!1}N(Se){if(Se.path){if(Se.authority===v.Schemas.file){const Pe=d.URI.file(Se.fsPath);return(0,Fe.$ji)(Pe)?{workspaceUri:Pe}:{fileUri:Pe}}else if(Se.authority===v.Schemas.vscodeRemote){const Pe=Se.path.indexOf(m.$gc.sep,1);if(Pe!==-1){const Ae=Se.path.substring(1,Pe),pe=Se.path.substring(Pe);let Me=Se.query;const Ue=new URLSearchParams(Se.query);Ue.get("windowId")==="_blank"&&(Ue.delete("windowId"),Me=Ue.toString());const Be=d.URI.from({scheme:v.Schemas.vscodeRemote,authority:Ae,path:pe,query:Me,fragment:Se.fragment});return(0,Fe.$ji)(pe)?{workspaceUri:Be}:/:[\d]+$/.test(pe)?{fileUri:Be}:{folderUri:Be}}}}}async O(Se,Pe,Ae,pe,Me){if(this.m.trace("app#handleProtocolUrl():",pe.toString(!0),Me),pe.scheme===this.z.urlProtocol&&pe.path==="workspace"&&(pe=pe.with({authority:"file",path:d.URI.parse(pe.query).path,query:""})),await this.M(pe,Se,Pe))return this.m.trace("app#handleProtocolUrl() protocol url was blocked:",pe.toString(!0)),!0;let Ue=!1;const Be=new URLSearchParams(pe.query);Be.get("windowId")==="_blank"?(this.m.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",pe.toString(!0)),Be.delete("windowId"),pe=pe.with({query:Be.toString()}),Ue=!0):w.$k&&Se.getWindowCount()===0&&(this.m.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",pe.toString(!0)),Ue=!0);const Je=Be.get("continueOn");Je!==null&&(this.m.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",pe.toString(!0)),Be.delete("continueOn"),pe=pe.with({query:Be.toString()}),this.s.continueOn=Je??void 0);const qe=this.N(pe);return qe?(this.m.trace("app#handleProtocolUrl() opening protocol url as window:",qe,pe.toString(!0)),(0,ft.$Ob)(await Se.open({context:5,cli:{...this.s.args},urisToOpen:[qe],forceNewWindow:Ue,gotoLineMode:!0}))?.focus(),!0):Ue?(this.m.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",pe.toString(!0)),await(0,ft.$Ob)(await Se.open({context:5,cli:{...this.s.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,de.$Vk)(pe)}))?.ready(),Ae.open(pe,Me)):(this.m.trace("app#handleProtocolUrl(): not handled",pe.toString(!0),Me),!1)}P(Se,Pe){const Ae=this.B(this.j.createInstance(ue.$P7b,Se,Pe)),pe=(async()=>{this.m.trace("Main->SharedProcess#connect");const Ue=await Ae.connect();return this.m.trace("Main->SharedProcess#connect: connection established"),new a.$CT(Ue,"main")})();return{sharedProcessReady:(async()=>(await Ae.whenReady(),pe))(),sharedProcessClient:pe}}async Q(Se,Pe,Ae){const pe=new X.$Oh;switch(process.platform){case"win32":pe.set(le.$uU,new G.$Nh(Re.$17b));break;case"linux":w.$m?pe.set(le.$uU,new G.$Nh(Le.$Z7b,[process.env.SNAP,process.env.SNAP_REVISION])):pe.set(le.$uU,new G.$Nh(Ce.$Y7b));break;case"darwin":pe.set(le.$uU,new G.$Nh(Oe.$X7b));break}pe.set(De.$06b,new G.$Nh(Ne.$_7b,[Se,Pe,this.h],!1)),pe.set(dt.$96b,new G.$Nh(Rt.$t8b,void 0,!1));const Me=new I.$S6b(this.m,this.z);pe.set(I.$R6b,Me),pe.set(N.$B7b,new G.$Nh(N.$C7b,void 0,!1)),pe.set(k.$h7b,new G.$Nh(k.$i7b,void 0,!1)),pe.set(D.$rm,l.ProxyChannel.toService((0,l.$wh)(Ae.then(We=>We.getChannel("diagnostics"))))),pe.set(re.$kxb,new G.$Nh(L.$x7b,[this.h])),pe.set(j.$cU,new G.$Nh(U.$j7b)),pe.set(M.$y7b,new G.$Nh(M.$z7b)),pe.set(V.$v7b,new G.$Nh(V.$w7b,void 0,!1)),pe.set($e.$67b,new G.$Nh(ke.$87b)),pe.set(B.$K7b,new G.$Nh(B.$L7b)),pe.set(ae.$k7b,new G.$Nh(se.$m7b)),pe.set(ye.$H6b,new G.$Nh(ye.$I6b)),pe.set(ye.$J6b,new G.$Nh(ye.$K6b));const Ue=new Dt.$p8b({graceTime:6e4,shortGraceTime:6e3,scrollback:this.u.getValue("terminal.integrated.persistentSessionScrollback")??100},this.u,this.s,this.t,this.m),Be=new Ct.$zr(Ue,this.u,this.m,this.n);pe.set(at.$ar,Be),w.$j?pe.set(ce.$n7b,new G.$Nh(Y.$o7b)):w.$k?pe.set(ce.$n7b,new G.$Nh(Y.$p7b)):w.$l&&pe.set(ce.$n7b,new G.$Nh(Y.$q7b));const Je=new o.$c7b(this.s,this.u,this.m,this.w);pe.set(n.$Q6b,Je);const qe=new Ze.$36b(this.s,this.m,this.C,Je,Me);if(pe.set(Ze.$26b,qe),pe.set(Ve.$RU,new G.$Nh(Qe.$b8b,void 0,!1)),pe.set(Ge.$H7b,new G.$Nh(Ge.$I7b,void 0,!1)),pe.set(He.$iU,new G.$Nh(ee.$kU,void 0,!1)),(0,_.$vo)(this.z,this.s)){const We=(0,_.$Ao)(this.z,this.u),Ke=(0,l.$wh)(Ae.then(st=>st.getChannel("telemetryAppender"))),Ye=new me.$S7b(Ke),xe=(0,Ie.$lo)((0,R.release)(),(0,R.hostname)(),process.arch,this.z.commit,this.z.version,Se,Pe,We),et=(0,_.$Bo)(this.s),tt={appenders:[Ye],commonProperties:xe,piiPaths:et,sendErrorTelemetry:!0};pe.set(Te.$dl,new G.$Nh(we.$5q,[tt],!1))}else pe.set(Te.$dl,_.$po);return pe.set(pt.$yp,new G.$Nh(St.$MN,void 0,!0)),pe.set(yt.$Cp,new G.$Nh(vt.$e8b,void 0,!0)),pe.set(ot.$n8b,new G.$Nh(ot.$o8b,void 0,!0)),await rt.Promises.settled([Je.initialize(),qe.initialize()]),this.j.createChild(pe)}R(Se,Pe,Ae){const pe=this.B(new f.$Rc),Me=l.ProxyChannel.fromService(Se.get(N.$B7b),pe,{disableMarshalling:!0});this.g.registerChannel("launch",Me);const Ue=l.ProxyChannel.fromService(Se.get(k.$h7b),pe,{disableMarshalling:!0});this.g.registerChannel("diagnostics",Ue);const Be=new it.$c8b(Se.get(Xe.$mn));Pe.registerChannel("policy",Be),Ae.then(_e=>_e.registerChannel("policy",Be));const Je=this.y.getProvider(v.Schemas.file);(0,$.$Jf)(Je instanceof W.$eq);const qe=new q.$r7b(Je,this.m,this.s);Pe.registerChannel(K.$vN,qe),Ae.then(_e=>_e.registerChannel(K.$vN,qe));const We=l.ProxyChannel.fromService(Se.get(nt.$F6b),pe);Pe.registerChannel("userDataProfiles",We),Ae.then(_e=>_e.registerChannel("userDataProfiles",We));const Ke=new wt.$Zq(Se.get(bt.$Wo));Ae.then(_e=>_e.registerChannel("request",Ke));const Ye=new ge.$T7b(Se.get(le.$uU));Pe.registerChannel("update",Ye);const xe=l.ProxyChannel.fromService(Se.get(re.$kxb),pe);Pe.registerChannel("issue",xe);const et=l.ProxyChannel.fromService(Se.get(j.$cU),pe);Pe.registerChannel("encryption",et);const tt=l.ProxyChannel.fromService(Se.get(he.$4k),pe);Pe.registerChannel("sign",tt);const st=l.ProxyChannel.fromService(Se.get(M.$y7b),pe);Pe.registerChannel("keyboardLayout",st),this.f=Se.get(V.$v7b);const gt=l.ProxyChannel.fromService(this.f,pe);Pe.registerChannel("nativeHost",gt),Ae.then(_e=>_e.registerChannel("nativeHost",gt));const Mt=l.ProxyChannel.fromService(Se.get(Ve.$RU),pe);Pe.registerChannel("workspaces",Mt);const jt=l.ProxyChannel.fromService(Se.get(B.$K7b),pe);Pe.registerChannel("menubar",jt);const Lt=l.ProxyChannel.fromService(Se.get(He.$iU),pe);Pe.registerChannel("url",Lt);const Ft=l.ProxyChannel.fromService(Se.get($e.$67b),pe);Pe.registerChannel("webview",Ft);const $t=this.B(new be.$Q7b(this.m,Se.get(ye.$H6b)));Pe.registerChannel("storage",$t),Ae.then(_e=>_e.registerChannel("storage",$t));const Ut=this.B(new Et.$g8b(Se.get(ye.$H6b),Se.get(nt.$F6b),this.m));Ae.then(_e=>_e.registerChannel("profileStorageListener",Ut));const Nt=l.ProxyChannel.fromService(Se.get(at.$ar),pe);Pe.registerChannel(at.TerminalIpcChannels.LocalPty,Nt);const Wt=l.ProxyChannel.fromService(Se.get(ce.$n7b),pe);Pe.registerChannel("externalTerminal",Wt);const mt=new Pt.$l8b(Se.get(It.$46b));Pe.registerChannel("logger",mt),Ae.then(_e=>_e.registerChannel("logger",mt));const Tt=new O.$d7b(Se.get(De.$06b));Pe.registerChannel("extensionhostdebugservice",Tt);const zt=l.ProxyChannel.fromService(Se.get(ae.$k7b),pe);Pe.registerChannel(ae.$l7b,zt);const Bt=l.ProxyChannel.fromService(Se.get(ot.$n8b),pe);Pe.registerChannel(Ot.$m8b,Bt)}async S(Se,Pe){const Ae=this.b=Se.get(De.$06b);this.c=Se.get(dt.$96b);const pe=(0,x.$Ol)(process.env)?0:4,Me=this.s.args;if(Pe){if(Pe.openables.length>0)return Ae.open({context:pe,cli:Me,urisToOpen:Pe.openables,gotoLineMode:!0,initialStartup:!0});if(Pe.urls.length>0)for(const tt of Pe.urls){const st=new URLSearchParams(tt.uri.query);if(st.get("windowId")==="_blank")return st.delete("windowId"),tt.originalUrl=tt.uri.toString(!0),tt.uri=tt.uri.with({query:st.toString()}),Ae.open({context:pe,cli:Me,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const Ue=global.macOpenFiles,Be=Me._.length,Je=!!Me["folder-uri"],qe=!!Me["file-uri"],We=Me["skip-add-to-recently-opened"]===!0,Ke=Me.wait&&Me.waitMarkerFilePath?d.URI.file(Me.waitMarkerFilePath):void 0,Ye=Me.remote||void 0,xe=Me.profile,et=Me["profile-temp"];if(!Be&&!Je&&!qe){if(Me["new-window"]||xe||et)return Ae.open({context:pe,cli:Me,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:We,waitMarkerFileURI:Ke,initialStartup:!0,remoteAuthority:Ye,forceProfile:xe,forceTempProfile:et});if(Ue.length)return Ae.open({context:1,cli:Me,urisToOpen:Ue.map(tt=>(0,Fe.$ji)(tt)?{workspaceUri:d.URI.file(tt)}:{fileUri:d.URI.file(tt)}),noRecentEntry:We,waitMarkerFileURI:Ke,initialStartup:!0})}return Ae.open({context:pe,cli:Me,forceNewWindow:Me["new-window"]||!Be&&Me["unity-launch"],diffMode:Me.diff,mergeMode:Me.merge,noRecentEntry:We,waitMarkerFileURI:Ke,gotoLineMode:Me.goto,initialStartup:!0,remoteAuthority:Ye,forceProfile:xe,forceTempProfile:et})}U(){this.W(),S.protocol.registerHttpProtocol(v.Schemas.vscodeRemoteResource,(Se,Pe)=>{Pe({url:Se.url.replace(/^vscode-remote-resource:/,"http:"),method:Se.method})}),this.X(this.s.args,process.env,!0),this.Y(),w.$k&&S.app.runningUnderARM64Translation&&this.b?.sendToFocused("vscode:showTranslatedBuildWarning")}async W(){const Se=this.z.win32MutexName;if(w.$j&&Se)try{const Pe=await new Promise((pe,Me)=>{J(["@vscode/windows-mutex"],pe,Me)}),Ae=new Pe.Mutex(Se);g.Event.once(this.t.onWillShutdown)(()=>Ae.release())}catch(Pe){this.m.error(Pe)}}async X(Se,Pe,Ae){try{return await(0,Z.$Ul)(this.u,this.m,Se,Pe)}catch(pe){const Me=(0,P.$Bi)(pe);Ae?this.b?.sendToFocused("vscode:showResolveShellEnvError",Me):this.m.error(Me)}return{}}async Y(){try{const Pe=(await this.y.readFile(this.s.argvResource)).value.toString(),Ae=JSON.parse((0,b.$6m)(Pe)),Me=(0,_.$xo)(this.u)>=1;if(Ae["enable-crash-reporter"]===void 0){const Ue=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Me},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,u.$fg)()}"`,"}"],Be=Pe.substring(0,Pe.length-2).concat(`,
`,Ue.join(`
`));await this.y.writeFile(this.s.argvResource,C.$ce.fromString(Be))}else{const Ue=Pe.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Me},`);Ue!==Pe&&await this.y.writeFile(this.s.argvResource,C.$ce.fromString(Ue))}}catch(Se){this.m.error(Se)}}};e.$u8b=ut,e.$u8b=ut=lt=Ee([te(2,H.$Ph),te(3,F.$$i),te(4,F.$_i),te(5,z.$x6b),te(6,T.$z6b),te(7,p.$ki),te(8,ve.$FN),te(9,Q.$_j),te(10,oe.$qj),te(11,nt.$F6b)],ut)}),define(ie[314],ne([0,1,15,45,7,23,8,49,14,33,3,46,13,9,65,4,35,27,21,42,99,308,10,18,238,250,24,62,202,16,222,93,77,218,92,20,225,6,78,25,79,278,126,287,50,286,95,249,34,51,67,52,39,234,232,2,40,266,66,227,115,121,270,264]),function(J,e,S,A,s,R,C,P,h,c,g,b,y,f,v,m,w,$,d,u,E,l,i,a,r,t,n,o,p,O,D,k,I,j,U,z,x,Z,ae,se,ce,Y,K,Q,q,W,G,H,X,re,L,M,N,T,F,B,V,oe,de,ue,he,ve,be){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class ye{main(){try{this.a()}catch(me){console.error(me.message),S.app.exit(1)}}async a(){(0,h.setUnexpectedErrorHandler)(Re=>console.error(Re));const[me,we,_,le,ge,Oe,Ce,Le]=this.b();try{try{await this.d(_,Le,le,ge,Ce)}catch(Re){throw this.f(_,Ce,Re),Re}await me.invokeFunction(async Re=>{const He=Re.get(Z.$$i),ze=Re.get(z.$z6b),ee=Re.get(O.$_j),fe=Re.get(Z.$_i),$e=await this.e(He,_,ze,me,Ce,!0);return d.Promises.writeFile(_.mainLockfile,String(process.pid)).catch(ke=>{He.warn(`app#startup(): Error writing main lockfile: ${ke.stack}`)}),Oe.logger=fe.createLogger("main",{name:(0,i.localize)(0,null)}),g.Event.once(ze.onWillShutdown)(ke=>{ee.dispose(),le.dispose(),ke.join("instanceLockfile",d.Promises.unlink(_.mainLockfile).catch(()=>{}))}),me.createInstance(l.$u8b,$e,we).startup()})}catch(Re){me.invokeFunction(this.i,Re)}}b(){const me=new U.$Oh,we=new B.$Rc;process.once("exit",()=>we.dispose());const _={_serviceBrand:void 0,...ae.default};me.set(se.$qj,_);const le=new n.$y6b(this.j(),_),ge=this.c(le);me.set(n.$x6b,le);const Oe=new de.$56b((0,Z.$mj)(le),le.logsHome);me.set(de.$46b,Oe);const Ce=new x.$h4b(Oe.getLogLevel()),Le=we.add(new ue.$NN(Ce,[new Z.$fj(Oe.getLogLevel())]));me.set(Z.$$i,Le);const Re=new D.$Rp(Le);me.set(O.$_j,Re);const He=new k.$eq(Le);Re.registerProvider(y.Schemas.file,He);const ze=new oe.$Dr(Re);me.set(V.$Jk,ze);const ee=new ve.$IN(1,le,Le,Re);me.set(X.$EN,ee),me.set(X.$FN,ee);const fe=new M.$G6b(ee,ze,le,Re,Le);me.set(M.$F6b,fe),Re.registerProvider(y.Schemas.vscodeUserData,new be.$F8b(y.Schemas.file,He,y.Schemas.vscodeUserData,fe,ze,Le));const $e=m.$j&&_.win32RegValueName?we.add(new T.$D8b(Le,_.win32RegValueName)):le.policyFile?we.add(new F.$E8b(le.policyFile,Re,Le)):new N.$on;me.set(N.$mn,$e);const ke=new r.$On(fe.defaultProfile.settingsResource,Re,$e,Le);return me.set(a.$ki,ke),me.set(z.$z6b,new I.$Nh(z.$A6b,void 0,!1)),me.set(q.$Wo,new I.$Nh(W.$B8b,void 0,!0)),me.set(L.$L6b,new I.$Nh(L.$M6b)),me.set(G.$4k,new I.$Nh(H.$C8b,void 0,!1)),me.set(K.$bv,new I.$Nh(Q.$z8b)),me.set(ce.$T6b,new Y.$w8b(le,fe,Le)),[new j.$hq(me,!0),ge,le,ke,ee,Ce,_,fe]}c(me){const we={VSCODE_IPC_HOOK:me.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(_=>{const le=process.env[_];typeof le=="string"&&(we[_]=le)}),Object.assign(process.env,we),we}async d(me,we,_,le,ge){await C.Promises.settled([Promise.all([me.extensionsPath,me.codeCachePath,me.logsHome.with({scheme:y.Schemas.file}).fsPath,we.defaultProfile.globalStorageHome.with({scheme:y.Schemas.file}).fsPath,me.workspaceStorageHome.with({scheme:y.Schemas.file}).fsPath,me.localHistoryHome.with({scheme:y.Schemas.file}).fsPath,me.backupHome].map(Oe=>Oe?d.Promises.mkdir(Oe,{recursive:!0}):void 0)),le.init(),_.initialize()]),we.init()}async e(me,we,_,le,ge,Oe){let Ce;try{(0,v.mark)("code/willStartMainServer"),Ce=await(0,E.$Lh)(we.mainIPCHandle),(0,v.mark)("code/didStartMainServer"),g.Event.once(_.onWillShutdown)(()=>Ce.dispose())}catch(Le){if(Le.code!=="EADDRINUSE")throw this.f(we,ge,Le),Le;let Re;try{Re=await(0,E.$Mh)(we.mainIPCHandle,"main")}catch(fe){if(!Oe||m.$j||fe.code!=="ECONNREFUSED")throw fe.code==="EPERM"&&this.g((0,i.localize)(1,null,ge.nameShort),(0,i.localize)(2,null),ge),fe;try{(0,A.unlinkSync)(we.mainIPCHandle)}catch($e){throw me.warn("Could not delete obsolete instance handle",$e),$e}return this.e(me,we,_,le,ge,!1)}if(we.extensionTestsLocationURI&&!we.debugExtensionHost.break){const fe=`Running extension tests from the command line is currently only supported if no other instance of ${ge.nameShort} is running.`;throw me.error(fe),Re.dispose(),new Error(fe)}let He;!we.args.wait&&!we.args.status&&(He=setTimeout(()=>{this.g((0,i.localize)(3,null,ge.nameShort),(0,i.localize)(4,null),ge)},1e4));const ze=u.ProxyChannel.toService(Re.getChannel("launch"),{disableMarshalling:!0}),ee=u.ProxyChannel.toService(Re.getChannel("diagnostics"),{disableMarshalling:!0});if(we.args.status)return le.invokeFunction(async()=>{const fe=new t.$Kr(re.$po,ge),$e=await ee.getMainDiagnostics(),ke=await ee.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),De=await fe.getDiagnostics($e,ke);throw console.log(De),new h.$ab});throw m.$j&&await this.h(ze,me),me.trace("Sending env to running instance..."),await ze.start(we.args,process.env),Re.dispose(),He&&clearTimeout(He),new h.$ab("Sent env to running instance. Terminating...")}if(we.args.status)throw console.log((0,i.localize)(5,null,ge.nameShort)),new h.$ab("Terminating...");return process.env.VSCODE_PID=String(process.pid),Ce}f(me,we,_){if(_.code==="EACCES"||_.code==="EPERM"){const le=(0,R.$Hb)([me.userDataPath,me.extensionsPath,E.$Hh]).map(ge=>(0,b.$vv)(s.URI.file(ge),{os:m.OS,tildify:me}));this.g((0,i.localize)(6,null),(0,i.localize)(7,null,(0,P.$Bi)(_),le.join(`
`)),we)}}g(me,we,_){S.dialog.showMessageBoxSync((0,he.$Jv)({type:"warning",buttons:[(0,i.localize)(8,null)],message:me,detail:we},_).options)}async h(me,we){if(m.$j){const _=await me.getMainProcessId();we.trace("Sending some foreground love to the running instance:",_);try{(await new Promise((le,ge)=>{J(["windows-foreground-love"],le,ge)})).allowSetForegroundWindow(_)}catch(le){we.error(le)}}}i(me,we){const _=me.get(Z.$$i),le=me.get(z.$z6b);let ge=0;we&&(we.isExpected?we.message&&_.trace(we.message):(ge=1,we.stack?_.error(we.stack):_.error(`Startup error: ${we.toString()}`))),le.kill(ge)}j(){const me=this.k((0,o.$Ll)(process.argv));if(me.wait&&!me.waitMarkerFilePath){const we=(0,p.$v8b)(me.verbose);we&&((0,o.$Nl)(process.argv,"--waitMarkerFilePath",we),me.waitMarkerFilePath=we)}return me}k(me){if(me["open-url"]&&(me._urls=me._,me._=[]),!me.remote){const we=this.l(me._,me.goto);me._=we}return me}l(me,we){const _=(0,w.cwd)(),le=me.map(Ce=>{let Le=String(Ce),Re;we&&(Re=(0,c.$6f)(Le),Le=Re.path),Le&&(Le=this.m(_,Le));const He=(0,c.$1f)(Le,_),ze=(0,f.$nc)(He);return ze&&!(0,c.$Wf)(ze)?null:we&&Re?(Re.path=He,this.n(Re)):He}),ge=m.$j||m.$k,Oe=(0,R.$Mb)(le,Ce=>Ce&&ge?Ce.toLowerCase():Ce||"");return(0,R.$Hb)(Oe)}m(me,we){return m.$j&&(we=(0,$.$Le)(we,'"')),we=(0,$.$Je)((0,$.$Je)(we," "),"	"),m.$j&&(we=(0,f.$kc)(me,we),we=(0,$.$Le)(we,".")),we}n(me){const we=[me.path];return typeof me.line=="number"&&we.push(String(me.line)),typeof me.column=="number"&&we.push(String(me.column)),we.join(":")}}new ye().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/2f32f0edae007ddd03699c325a451184c4c5e89b/core/vs/code/electron-main/main.js.map
